from pyspark.sql.types import *
from optimus import Optimus
from optimus.helpers.json import json_enconding
from optimus.helpers.functions import deep_sort
import unittest
from pyspark.ml.linalg import Vectors, VectorUDT, DenseVector
import numpy as np
nan = np.nan
import datetime
from pyspark.sql import functions as F
from optimus.ml import distancecluster as dc
op = Optimus(master='local')
source_df=op.create.df([('LOCNCODE', StringType(), True),('LOCNDSCR', StringType(), True),('ADDRESS1', StringType(), True),('ADDRESS2', StringType(), True),('ADDRESS3', StringType(), True),('CITY', StringType(), True),('STATE', StringType(), True),('ZIPCODE', StringType(), True),('COUNTRY', StringType(), True),('Location_Segment', StringType(), True),('PAQ', StringType(), True),('TIPUNI', StringType(), True),('Tipo_unidad', StringType(), True),('ITEMNMBR', StringType(), True),('ITMSHNAM', StringType(), True),('MZ', StringType(), True),('LT', StringType(), True),('EDIF', StringType(), True),('NIVEL', StringType(), True),('NOUNI', StringType(), True),('CONDO', StringType(), True),('REGIMEN', StringType(), True),('ETAPA', StringType(), True),('PROTO', StringType(), True),('ITEMDESC', StringType(), True),('NIVELES', StringType(), True),('COCHERA', StringType(), True),('RECAM', StringType(), True),('ALCOB', StringType(), True),('BANOS', StringType(), True),('Num_Balcon', StringType(), True),('SALA', StringType(), True),('COMEDOR', StringType(), True),('COCINA', StringType(), True),('Cuarto_Lavado', StringType(), True),('Cuarto_Servicio', StringType(), True),('OTROX', StringType(), True),('OTROX1', StringType(), True),('SupCons', StringType(), True),('PATIOSERV', StringType(), True),('TERRAZA', StringType(), True),('BALCON', StringType(), True),('AZOTEA', StringType(), True),('Otros', StringType(), True),('AREATOT', StringType(), True),('FRENTE', StringType(), True),('Sup_Terreno', StringType(), True),('EXCEDENTE', StringType(), True),('OTRO1', StringType(), True),('OTRO2', StringType(), True),('TAMANO', StringType(), True),('UBICAVER', StringType(), True),('UBICAHORI', StringType(), True),('QTYONHND_', StringType(), True),('QTYSOLD', StringType(), True),('INACTIVE', StringType(), True),('UOMPRICE', StringType(), True),('MONTOAPA', StringType(), True),('PAGINI', StringType(), True),('ENGANCHE', StringType(), True),('FECHESCRIPRO', StringType(), True),('FECHAENTREGA', StringType(), True),('FECHASALIDAVENTAS', StringType(), True),('LIBERADO_NOLIBERADO', StringType(), True),('ACTIVO_INACTIVO', StringType(), True),('Estatus1Vivienda', StringType(), True),('Estatus2Vivienda', StringType(), True),('CUSTNMBR', StringType(), True),('Nombre_Completo', StringType(), True),('cNombre', StringType(), True),('cApellidoPaterno', StringType(), True),('cApellidoMaterno', StringType(), True),('cRfc', StringType(), True),('cCurp', StringType(), True),('fkIdGradoInteres', StringType(), True),('cSexo', StringType(), True),('cEmail', StringType(), True),('cTelefonoCasa', StringType(), True),('cTelefonoCelular', StringType(), True),('cTelefonoTrabajo', StringType(), True),('cNumeroSeguroSocial', StringType(), True),('dFechaNacimiento', StringType(), True),('cEstadoCivil', StringType(), True),('cRegimenConyugal', StringType(), True),('cNacionalidad', StringType(), True),('cLugarNacimiento', StringType(), True),('cRecomendadoPor', StringType(), True),('fkIdMedio', StringType(), True),('cMedioContacto', StringType(), True),('cCalle', StringType(), True),('cNumeroExterior', StringType(), True),('cNumeroInterior', StringType(), True),('cColonia', StringType(), True),('cMunicipio', StringType(), True),('cEstado', StringType(), True),('cPais', StringType(), True),('cCodigoPostal', StringType(), True),('nTiempoResidencia', StringType(), True),('cComentario', StringType(), True),('cNumeroIdentificacion', StringType(), True),('cTipoIdentificación', StringType(), True),('REFERENCIA', StringType(), True),('FACTURA', StringType(), True),('NOTACR', StringType(), True),('Precio_cierre', StringType(), True),('Precio_cierre_Tot', StringType(), True),('Aumento_al_Contrato', StringType(), True),('Condonacón', StringType(), True),('Precio_Escritura_Total', StringType(), True),('Precio_Dev', StringType(), True),('Precio_Dev_Total', StringType(), True),('Notarios_Proyectados', StringType(), True),('Gatos_A_terceros', StringType(), True),('Depositos', StringType(), True),('Saldo', StringType(), True),('dFechaCreacion', StringType(), True),('dFechaModificacion', StringType(), True),('FECHA_Cotizado', StringType(), True),('FECHA_SolApartado', StringType(), True),('FECHA_AutApartado', StringType(), True),('Vigencia_Apartado', StringType(), True),('FechaVencimientoApartado', StringType(), True),('FECHA_SolDictamen', StringType(), True),('FECHA_ProcDictamen', StringType(), True),('FECHA_DictaminadoLlamada', StringType(), True),('FECHA_DictaminadoFirma', StringType(), True),('FECHA_Dictaminado', StringType(), True),('FECHA_Rechazado', StringType(), True),('FECHA_EscrituraAvaluo', StringType(), True),('FECHA_EscrituraFolio', StringType(), True),('FolioEscsritura', StringType(), True),('FECHA_EscrituraReal', StringType(), True),('FECHA_Cancelado', StringType(), True),('FECHA_Liberado', StringType(), True),('FECHA_Entregado', StringType(), True),('MotivoCancelacion', StringType(), True)], [('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV008', 'ALVCDEY0080', None, None, None, None, '008', None, '0', '0', 'EST CDEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV021', 'ALVCDEY0690', None, None, None, None, '069', None, '0', '0', 'EST CDEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV022', 'ALVCDEY0710', None, None, None, None, '071', None, '0', '0', 'EST CDEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV027', 'ALVCDEY0810', None, None, None, None, '081', None, '0', '0', 'EST CDEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV032', 'ALVCEEY0090', None, None, None, None, '009', None, '0', '0', 'EST CEEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV035', 'ALVCEEY0150', None, None, None, None, '015', None, '0', '0', 'EST CEEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV009', 'ALVCDEY0100', None, None, None, None, '010', None, '0', '0', 'EST CDEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV012', 'ALVCDEY0160', None, None, None, None, '016', None, '0', '0', 'EST CDEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV019', 'ALVCDEY0650', None, None, None, None, '065', None, '0', '0', 'EST CDEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV044', 'ALVCUEY0340', None, None, None, None, '034', None, '0', '0', 'EST CUEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV049', 'ALVCUEY0470', None, None, None, None, '047', None, '0', '0', 'EST CUEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV001', 'ALVCAEY0490', None, None, None, None, '049', None, '0', '0', 'EST CAEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV004', 'ALVCBEY0530', None, None, None, None, '053', None, '0', '0', 'EST CBEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV010', 'ALVCDEY0120', None, None, None, None, '012', None, '0', '0', 'EST CDEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV011', 'ALVCDEY0140', None, None, None, None, '014', None, '0', '0', 'EST CDEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV016', 'ALVCDEY0240', None, None, None, None, '024', None, '0', '0', 'EST CDEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV039', 'ALVCEEY0230', None, None, None, None, '023', None, '0', '0', 'EST CEEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV045', 'ALVCUEY0350', None, None, None, None, '035', None, '0', '0', 'EST CUEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV057', 'ALVEEEY0840', None, None, None, None, '084', None, '0', '0', 'EST EEEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV023', 'ALVCDEY0730', None, None, None, None, '073', None, '0', '0', 'EST CDEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV031', 'ALVCEEY0070', None, None, None, None, '007', None, '0', '0', 'EST CEEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV007', 'ALVCDEY0060', None, None, None, None, '006', None, '0', '0', 'EST CDEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV017', 'ALVCDEY0260', None, None, None, None, '026', None, '0', '0', 'EST CDEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV025', 'ALVCDEY0770', None, None, None, None, '077', None, '0', '0', 'EST CDEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV026', 'ALVCDEY0790', None, None, None, None, '079', None, '0', '0', 'EST CDEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV033', 'ALVCEEY0110', None, None, None, None, '011', None, '0', '0', 'EST CEEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV036', 'ALVCEEY0170', None, None, None, None, '017', None, '0', '0', 'EST CEEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV040', 'ALVCEEY0250', None, None, None, None, '025', None, '0', '0', 'EST CEEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV043', 'ALVCEEY0740', None, None, None, None, '074', None, '0', '0', 'EST CEEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV050', 'ALVCUEY0480', None, None, None, None, '048', None, '0', '0', 'EST CUEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV054', 'ALVEDEY0590', None, None, None, None, '059', None, '0', '0', 'EST EDEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '19', None, None, None, None, None, None, '3.8', None, '0', None, None, 'Discapacitado Compart', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV003', 'ALVCBEY0500', None, None, None, None, '050', None, '0', '0', 'EST CBEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV006', 'ALVCDEY0040', None, None, None, None, '004', None, '0', '0', 'EST CDEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV013', 'ALVCDEY0180', None, None, None, None, '018', None, '0', '0', 'EST CDEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV018', 'ALVCDEY0280', None, None, None, None, '028', None, '0', '0', 'EST CDEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV024', 'ALVCDEY0750', None, None, None, None, '075', None, '0', '0', 'EST CDEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV029', 'ALVCEEY0030', None, None, None, None, '003', None, '0', '0', 'EST CEEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV034', 'ALVCEEY0130', None, None, None, None, '013', None, '0', '0', 'EST CEEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV037', 'ALVCEEY0190', None, None, None, None, '019', None, '0', '0', 'EST CEEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV042', 'ALVCEEY0290', None, None, None, None, '029', None, '0', '0', 'EST CEEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV047', 'ALVCUEY0450', None, None, None, None, '045', None, '0', '0', 'EST CUEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV051', 'ALVCUEY0550', None, None, None, None, '055', None, '0', '0', 'EST CUEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV052', 'ALVDDEY0830', None, None, None, None, '083', None, '0', '0', 'EST DDEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '19', None, None, None, None, None, None, '3.8', None, '0', None, None, 'Discapacitado', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV020', 'ALVCDEY0670', None, None, None, None, '067', None, '0', '0', 'EST CDEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV030', 'ALVCEEY0050', None, None, None, None, '005', None, '0', '0', 'EST CEEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV048', 'ALVCUEY0460', None, None, None, None, '046', None, '0', '0', 'EST CUEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV058', 'ALVEEEY0860', None, None, None, None, '086', None, '0', '0', 'EST EEEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV002', 'ALVCAEY0520', None, None, None, None, '052', None, '0', '0', 'EST CAEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV005', 'ALVCDEY0020', None, None, None, None, '002', None, '0', '0', 'EST CDEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV014', 'ALVCDEY0200', None, None, None, None, '020', None, '0', '0', 'EST CDEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV015', 'ALVCDEY0220', None, None, None, None, '022', None, '0', '0', 'EST CDEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV028', 'ALVCDEY0850', None, None, None, None, '085', None, '0', '0', 'EST CDEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV038', 'ALVCEEY0210', None, None, None, None, '021', None, '0', '0', 'EST CEEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV041', 'ALVCEEY0270', None, None, None, None, '027', None, '0', '0', 'EST CEEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV046', 'ALVCUEY0360', None, None, None, None, '036', None, '0', '0', 'EST CUEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV053', 'ALVEDEY0570', None, None, None, None, '057', None, '0', '0', 'EST EDEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '19', None, None, None, None, None, None, '3.8', None, '0', None, None, 'Discapacitado Compart', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV055', 'ALVEEEY0580', None, None, None, None, '058', None, '0', '0', 'EST EEEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', None, '2', 'ESTACIONAMIENTO', 'ALVV056', 'ALVEEEY0600', None, None, None, None, '060', None, '0', '0', 'EST EEEY', 'Cajon virtual', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.2', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Chico', 'Cajon virtual', 'Cajon virtual', '0', '0', '1', '0', None, None, None, None, None, None, 'NO LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP001', '1', 'DEPARTAMENTO', 'ALVD001', 'ALV0AD11010', None, None, '0A', '1', '101', None, '1', '0', 'ALV 2.1-C', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado, Balcón.', None, None, '2', None, '1', '1', '15.6', None, None, '2.28', None, None, None, '46.36', '0', '0', '2.57', None, '0', '48.93', None, None, '0', None, None, None, None, None, '1', '0', '1', '1331690', '10000', '0', '0', '20-Jan-17', '20-Jan-17', '23-Apr-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP001', '2', 'ESTACIONAMIENTO', 'ALVE024', 'ALVCDEX0710', None, None, None, None, '071', None, '1', '0', 'EST CDEX', 'Cajón chico, adelante doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '1', '0', '1', '1', '0', '0', '0', '20-Jan-17', '20-Jan-17', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP002', '1', 'DEPARTAMENTO', 'ALVD002', 'ALV0AD11020', None, None, '0A', '1', '102', None, '1', '0', 'ALV 2.2-C', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado, Balcón.', None, None, '2', None, '1', '1', '15.39', None, None, '2.28', None, None, None, '47.97', '0', '0', '2.52', None, '0', '50.49', None, None, '0', None, None, None, None, None, '1', '0', '1', '1370862', '10000', '0', '0', '20-Jan-17', '20-Jan-17', '23-Apr-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP002', '2', 'ESTACIONAMIENTO', 'ALVE021', 'ALVCDEX0650', None, None, None, None, '065', None, '1', '0', 'EST CDEX', 'Cajón chico, adelante doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '1', '0', '1', '1', '0', '0', '0', '20-Jan-17', '20-Jan-17', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP003', '1', 'DEPARTAMENTO', 'ALVD003', 'ALV0AD11030', None, None, '0A', '1', '103', None, '1', '0', 'ALV 2.3', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '15.16', None, None, '2.28', None, None, None, '44.29', '0', '0', '0', None, '0', '44.29', None, None, '0', None, None, None, None, None, '1', '0', '1', '1172626', '10000', '0', '0', '20-Jan-17', '20-Jan-17', '23-Apr-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP003', '2', 'ESTACIONAMIENTO', 'ALVE111', 'ALVGEEB0700', None, None, None, None, '070', None, '1', '0', 'EST GEEB', 'Cajón grande, atras doble, arriba con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Atrás doble', '1', '0', '1', '1', '0', '0', '0', '20-Jan-17', '20-Jan-17', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP004', '1', 'DEPARTAMENTO', 'ALVD004', 'ALV0AD11040', None, None, '0A', '1', '104', None, '1', '0', 'ALV 2.4', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '15.69', None, None, '2.28', None, None, None, '44.91', '0', '0', '0', None, '0', '44.91', None, None, '0', None, None, None, None, None, '1', '0', '1', '1187420', '10000', '0', '0', '20-Jan-17', '20-Jan-17', '23-Apr-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP004', '2', 'ESTACIONAMIENTO', 'ALVE109', 'ALVGEEB0660', None, None, None, None, '066', None, '1', '0', 'EST GEEB', 'Cajón grande, atras doble, arriba con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Atrás doble', '1', '0', '1', '1', '0', '0', '0', '20-Jan-17', '20-Jan-17', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP005', '1', 'DEPARTAMENTO', 'ALVD005', 'ALV0AD22010', None, None, '0A', '2', '201', None, '1', '0', 'ALV 2.1-C', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado, Balcón.', None, None, '2', None, '1', '1', '15.6', None, None, '2.28', None, None, None, '46.36', '0', '0', '2.57', None, '0', '48.93', None, None, '0', None, None, None, None, None, '1', '0', '1', '1295509', '10000', '0', '0', '20-Jan-17', '20-Jan-17', '23-Apr-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP005', '2', 'ESTACIONAMIENTO', 'ALVE045', 'ALVCEEX0740', None, None, None, None, '074', None, '1', '0', 'EST CEEX', 'Cajón chico, atrás doble., abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '1', '0', '1', '1', '0', '0', '0', '20-Jan-17', '20-Jan-17', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP006', '1', 'DEPARTAMENTO', 'ALVD006', 'ALV0AD22020', None, None, '0A', '2', '202', None, '1', '0', 'ALV 2.2-C', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado, Balcón.', None, None, '2', None, '1', '1', '15.39', None, None, '2.28', None, None, None, '47.97', '0', '0', '2.52', None, '0', '50.49', None, None, '0', None, None, None, None, None, '1', '0', '1', '1357648', '10000', '0', '0', '20-Jan-17', '20-Jan-17', '23-Apr-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP006', '2', 'ESTACIONAMIENTO', 'ALVE022', 'ALVCDEX0670', None, None, None, None, '067', None, '1', '0', 'EST CDEX', 'Cajón chico, adelante doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '1', '0', '1', '1', '0', '0', '0', '20-Jan-17', '20-Jan-17', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP007', '1', 'DEPARTAMENTO', 'ALVD007', 'ALV0AD22030', None, None, '0A', '2', '203', None, '1', '0', 'ALV 2.3', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '15.16', None, None, '2.28', None, None, None, '44.29', '0', '0', '0', None, '0', '44.29', None, None, '0', None, None, None, None, None, '1', '0', '1', '1160429', '10000', '0', '0', '20-Jan-17', '20-Jan-17', '23-Apr-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP007', '2', 'ESTACIONAMIENTO', 'ALVE112', 'ALVGEEB0720', None, None, None, None, '072', None, '1', '0', 'EST GEEB', 'Cajón grande, atras doble, arriba con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Atrás doble', '1', '0', '1', '1', '0', '0', '0', '20-Jan-17', '20-Jan-17', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP008', '1', 'DEPARTAMENTO', 'ALVD008', 'ALV0AD22040', None, None, '0A', '2', '204', None, '1', '0', 'ALV 2.4', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '15.69', None, None, '2.28', None, None, None, '44.91', '0', '0', '0', None, '0', '44.91', None, None, '0', None, None, None, None, None, '1', '0', '1', '1175049', '10000', '0', '0', '20-Jan-17', '20-Jan-17', '23-Apr-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP008', '2', 'ESTACIONAMIENTO', 'ALVE110', 'ALVGEEB0680', None, None, None, None, '068', None, '1', '0', 'EST GEEB', 'Cajón grande, atras doble, arriba con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Atrás doble', '1', '0', '1', '1', '0', '0', '0', '20-Jan-17', '20-Jan-17', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP009', '1', 'DEPARTAMENTO', 'ALVD009', 'ALV0AD33010', None, None, '0A', '3', '301', None, '1', '0', 'ALV 2.1-C', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado, Balcón.', None, None, '2', None, '1', '1', '15.6', None, None, '2.28', None, None, None, '46.36', '0', '0', '2.57', None, '0', '48.93', None, None, '0', None, None, None, None, None, '1', '0', '1', '1269012', '10000', '0', '0', '20-Jan-17', '20-Jan-17', '23-Apr-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP009', '2', 'ESTACIONAMIENTO', 'ALVE093', 'ALVGEEA0680', None, None, None, None, '068', None, '1', '0', 'EST GEEA', 'Cajón grande, atras doble, abajo con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Atrás doble', '1', '0', '1', '1', '0', '0', '0', '20-Jan-17', '20-Jan-17', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP010', '1', 'DEPARTAMENTO', 'ALVD010', 'ALV0AD33020', None, None, '0A', '3', '302', None, '1', '0', 'ALV 2.2-C', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado, Balcón.', None, None, '2', None, '1', '1', '15.39', None, None, '2.28', None, None, None, '47.97', '0', '0', '2.52', None, '0', '50.49', None, None, '0', None, None, None, None, None, '1', '0', '1', '1341134', '10000', '0', '0', '20-Jan-17', '20-Jan-17', '23-Apr-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP010', '2', 'ESTACIONAMIENTO', 'ALVE023', 'ALVCDEX0690', None, None, None, None, '069', None, '1', '0', 'EST CDEX', 'Cajón chico, adelante doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '1', '0', '1', '1', '0', '0', '0', '20-Jan-17', '20-Jan-17', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP011', '1', 'DEPARTAMENTO', 'ALVD011', 'ALV0AD33030', None, None, '0A', '3', '303', None, '1', '0', 'ALV 2.3', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '15.16', None, None, '2.28', None, None, None, '44.29', '0', '0', '0', None, '0', '44.29', None, None, '0', None, None, None, None, None, '1', '0', '1', '1029291', '10000', '0', '0', '20-Jan-17', '20-Jan-17', '23-Apr-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP012', '1', 'DEPARTAMENTO', 'ALVD012', 'ALV0AD33040', None, None, '0A', '3', '304', None, '1', '0', 'ALV 2.4', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '15.69', None, None, '2.28', None, None, None, '44.91', '0', '0', '0', None, '0', '44.91', None, None, '0', None, None, None, None, None, '1', '0', '1', '1043699', '10000', '0', '0', '20-Jan-17', '20-Jan-17', '23-Apr-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP013', '1', 'DEPARTAMENTO', 'ALVD013', 'ALV0AD44010', None, None, '0A', '4', '401', None, '1', '0', 'ALV 2.1-C', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado, Balcón.', None, None, '2', None, '1', '1', '15.6', None, None, '2.28', None, None, None, '46.36', '0', '0', '2.57', None, '0', '48.93', None, None, '0', None, None, None, None, None, '1', '0', '1', '1208385', '10000', '0', '0', '20-Jan-17', '20-Jan-17', '23-Apr-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP013', '2', 'ESTACIONAMIENTO', 'ALVE094', 'ALVGEEA0700', None, None, None, None, '070', None, '1', '0', 'EST GEEA', 'Cajón grande, atras doble, abajo con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Atrás doble', '1', '0', '1', '1', '0', '0', '0', '20-Jan-17', '20-Jan-17', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP014', '1', 'DEPARTAMENTO', 'ALVD014', 'ALV0AD44020', None, None, '0A', '4', '402', None, '1', '0', 'ALV 2.2-C', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado, Balcón.', None, None, '2', None, '1', '1', '15.39', None, None, '2.28', None, None, None, '47.97', '0', '0', '2.52', None, '0', '50.49', None, None, '0', None, None, None, None, None, '1', '0', '1', '1277333', '10000', '0', '0', '20-Jan-17', '20-Jan-17', '23-Apr-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP014', '2', 'ESTACIONAMIENTO', 'ALVE025', 'ALVCDEX0730', None, None, None, None, '073', None, '1', '0', 'EST CDEX', 'Cajón chico, adelante doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '1', '0', '1', '1', '0', '0', '0', '20-Jan-17', '20-Jan-17', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP015', '1', 'DEPARTAMENTO', 'ALVD015', 'ALV0AD44030', None, None, '0A', '4', '403', None, '1', '0', 'ALV 2.3', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '15.16', None, None, '2.28', None, None, None, '44.29', '0', '0', '0', None, '0', '44.29', None, None, '0', None, None, None, None, None, '1', '0', '1', '978345', '10000', '0', '0', '20-Jan-17', '20-Jan-17', '23-Apr-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP016', '1', 'DEPARTAMENTO', 'ALVD016', 'ALV0AD44040', None, None, '0A', '4', '404', None, '1', '0', 'ALV 2.4', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '15.69', None, None, '2.28', None, None, None, '44.91', '0', '0', '0', None, '0', '44.91', None, None, '0', None, None, None, None, None, '1', '0', '1', '992042', '10000', '0', '0', '20-Jan-17', '20-Jan-17', '23-Apr-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP017', '1', 'DEPARTAMENTO', 'ALVD017', 'ALV0AD55010', None, None, '0A', '5', '501', None, '1', '0', 'ALV 2.1-C', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado, Balcón.', None, None, '2', None, '1', '1', '15.6', None, None, '2.28', None, None, None, '46.36', '0', '0', '2.57', None, '0', '48.93', None, None, '0', None, None, None, None, None, '1', '0', '1', '1196105', '10000', '0', '0', '20-Jan-17', '20-Jan-17', '23-Apr-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP017', '2', 'ESTACIONAMIENTO', 'ALVE095', 'ALVGEEA0720', None, None, None, None, '072', None, '1', '0', 'EST GEEA', 'Cajón grande, atras doble, abajo con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Atrás doble', '1', '0', '1', '1', '0', '0', '0', '20-Jan-17', '20-Jan-17', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP018', '1', 'DEPARTAMENTO', 'ALVD018', 'ALV0AD55020', None, None, '0A', '5', '502', None, '1', '0', 'ALV 2.2-C', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado, Balcón.', None, None, '2', None, '1', '1', '15.39', None, None, '2.28', None, None, None, '47.97', '0', '0', '2.52', None, '0', '50.49', None, None, '0', None, None, None, None, None, '1', '0', '1', '1231969', '10000', '0', '0', '20-Jan-17', '20-Jan-17', '23-Apr-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP018', '2', 'ESTACIONAMIENTO', 'ALVE092', 'ALVGEEA0660', None, None, None, None, '066', None, '1', '0', 'EST GEEA', 'Cajón grande, atras doble, abajo con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Atrás doble', '1', '0', '1', '1', '0', '0', '0', '20-Jan-17', '20-Jan-17', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP019', '1', 'DEPARTAMENTO', 'ALVD019', 'ALV0AD55030', None, None, '0A', '5', '503', None, '1', '0', 'ALV 2.3', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '15.16', None, None, '2.28', None, None, None, '44.29', '0', '0', '0', None, '0', '44.29', None, None, '0', None, None, None, None, None, '1', '0', '1', '966612', '10000', '0', '0', '20-Jan-17', '20-Jan-17', '23-Apr-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP020', '1', 'DEPARTAMENTO', 'ALVD020', 'ALV0AD55040', None, None, '0A', '5', '504', None, '1', '0', 'ALV 2.4', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '15.69', None, None, '2.28', None, None, None, '44.91', '0', '0', '0', None, '0', '44.91', None, None, '0', None, None, None, None, None, '1', '0', '1', '980142', '10000', '0', '0', '20-Jan-17', '20-Jan-17', '23-Apr-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP023', '1', 'DEPARTAMENTO', 'ALVD023', 'ALV0BD11030', None, None, '0B', '1', '103', None, '1', '0', 'ALV 3.3', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '13.4', None, '3.8', '2.15', None, None, None, '45.16', '0', '0', '0', None, '0', '45.16', None, None, '0', None, None, None, None, None, '1', '0', '0', '1182850', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP023', '2', 'ESTACIONAMIENTO', 'ALVE062', 'ALVGAEB0890', None, None, None, None, '089', None, '1', '0', 'EST GAEB', 'Cajon grande, adelante triple, arriba con eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Adelante triple', '1', '0', '0', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP027', '1', 'DEPARTAMENTO', 'ALVD027', 'ALV0BD22030', None, None, '0B', '2', '203', None, '1', '0', 'ALV 3.3', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '13.4', None, '3.8', '2.15', None, None, None, '45.16', '0', '0', '0', None, '0', '45.16', None, None, '0', None, None, None, None, None, '1', '0', '0', '1170410', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP027', '2', 'ESTACIONAMIENTO', 'ALVE065', 'ALVGCEX0910', None, None, None, None, '091', None, '1', '0', 'EST GCEX', 'Cajón grande, atrás triple, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Atrás triple', '1', '0', '0', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP033', '1', 'DEPARTAMENTO', 'ALVD033', 'ALV0BD44010', None, None, '0B', '4', '401', None, '1', '0', 'ALV 3.1-C', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado, Balcón.', None, None, '2', None, '1', '1', '13.32', None, '3.8', '2.45', None, None, None, '49.47', '0', '0', '2.55', None, '0', '52.02', None, None, '0', None, None, None, None, None, '1', '0', '0', '1254237', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP033', '2', 'ESTACIONAMIENTO', 'ALVE063', 'ALVGBEA0900', None, None, None, None, '090', None, '1', '0', 'EST GBEA', 'Cajón grande, en medio triple, abajo con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'En medio triple', '1', '0', '0', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP037', '1', 'DEPARTAMENTO', 'ALVD037', 'ALV0BD55010', None, None, '0B', '5', '501', None, '1', '0', 'ALV 3.1-C', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado, Balcón.', None, None, '2', None, '1', '1', '13.32', None, '3.8', '2.45', None, None, None, '49.47', '0', '0', '2.55', None, '0', '52.02', None, None, '0', None, None, None, None, None, '1', '0', '0', '1241130', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP037', '2', 'ESTACIONAMIENTO', 'ALVE117', 'ALVGEEB0880', None, None, None, None, '088', None, '1', '0', 'EST GEEB', 'Cajón grande, atras doble, arriba con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Atrás doble', '1', '0', '0', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP038', '1', 'DEPARTAMENTO', 'ALVD038', 'ALV0BD55020', None, None, '0B', '5', '502', None, '1', '0', 'ALV 3.2-C', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado, Balcón.', None, None, '2', None, '1', '1', '13.4', None, '3.8', '2.15', None, None, None, '50.88', '0', '0', '2.61', None, '0', '53.49', None, None, '0', None, None, None, None, None, '1', '0', '1', '1285628', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP038', '2', 'ESTACIONAMIENTO', 'ALVE061', 'ALVGAEA0890', None, None, None, None, '089', None, '1', '0', 'EST GAEA', 'Cajon grande,adelante triple, abajo con eleva auto', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Adelante triple', '1', '0', '1', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP043', '1', 'DEPARTAMENTO', 'ALVD043', 'ALV0CD00030', None, None, '0C', '0', '003', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '0', '1187098', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP043', '2', 'ESTACIONAMIENTO', 'ALVE099', 'ALVGEEA0820', None, None, None, None, '082', None, '1', '0', 'EST GEEA', 'Cajón grande, atras doble, abajo con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Atrás doble', '1', '0', '0', '1', '0', '0', '0', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP048', '1', 'DEPARTAMENTO', 'ALVD048', 'ALV0CD11020', None, None, '0C', '1', '102', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '0', '1160698', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP048', '2', 'ESTACIONAMIENTO', 'ALVE107', 'ALVGEEB0620', None, None, None, None, '062', None, '1', '0', 'EST GEEB', 'Cajón grande, atras doble, arriba con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Atrás doble', '1', '0', '0', '1', '0', '0', '0', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP050', '1', 'DEPARTAMENTO', 'ALVD050', 'ALV0CD11040', None, None, '0C', '1', '104', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '0', '1160698', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP050', '2', 'ESTACIONAMIENTO', 'ALVE113', 'ALVGEEB0760', None, None, None, None, '076', None, '1', '0', 'EST GEEB', 'Cajón grande, atras doble, arriba con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Atrás doble', '1', '0', '0', '1', '0', '0', '0', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP053', '1', 'DEPARTAMENTO', 'ALVD053', 'ALV0CD11070', None, None, '0C', '1', '107', None, '1', '0', 'ALV 5-C', 'Estancia, Comedor, 1 Recámara, Alcoba, Baño, Cocina, Cuarto de lavado, Balcón.', None, None, '1', '1', '1', '1', '15.01', None, '3.67', '2.16', None, None, None, '59.11', '0', '0', '1.77', None, '0', '60.88', None, None, '0', None, None, None, None, None, '1', '0', '0', '1710351', '10000', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP053', '2', 'ESTACIONAMIENTO', 'ALVE055', 'ALVEDEX0570', None, None, None, None, '057', None, '1', '0', 'EST EDEX', 'Discapacitados compartido, adelante doble', None, None, None, None, None, None, None, None, None, None, None, None, None, '15.5', None, None, None, None, None, None, '3.1', None, '0', None, None, 'Discapacitado Compart', 'Abajo sin eleva autos', 'Adelante doble', '1', '0', '0', '1', '0', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP053', '3', 'BODEGA', 'ALVB004', 'ALV00BD0040', None, None, None, None, '004', None, '1', '0', 'ALV B 4.51', 'bodega de 4.51 m2', None, None, None, None, None, None, None, None, None, None, None, None, None, '4.51', None, None, None, None, None, None, None, None, '0', None, None, None, None, None, '1', '0', '0', '1', '0', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP054', '1', 'DEPARTAMENTO', 'ALVD054', 'ALV0CD22010', None, None, '0C', '2', '201', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '0', '1148636', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP054', '2', 'ESTACIONAMIENTO', 'ALVE114', 'ALVGEEB0780', None, None, None, None, '078', None, '1', '0', 'EST GEEB', 'Cajón grande, atras doble, arriba con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Atrás doble', '1', '0', '0', '1', '0', '0', '0', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP057', '1', 'DEPARTAMENTO', 'ALVD057', 'ALV0CD22040', None, None, '0C', '2', '204', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1032746', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP060', '1', 'DEPARTAMENTO', 'ALVD060', 'ALV0CD22070', None, None, '0C', '2', '207', None, '1', '0', 'ALV 5-C', 'Estancia, Comedor, 1 Recámara, Alcoba, Baño, Cocina, Cuarto de lavado, Balcón.', None, None, '1', '1', '1', '1', '15.01', None, '3.67', '2.16', None, None, None, '59.11', '0', '0', '1.77', None, '0', '60.88', None, None, '0', None, None, None, None, None, '1', '0', '1', '1669418', '10000', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP060', '2', 'ESTACIONAMIENTO', 'ALVE056', 'ALVEDEX0590', None, None, None, None, '059', None, '1', '0', 'EST EDEX', 'Discapacitados compartido, adelante doble', None, None, None, None, None, None, None, None, None, None, None, None, None, '15.5', None, None, None, None, None, None, '3.1', None, '0', None, None, 'Discapacitado Compart', 'Abajo sin eleva autos', 'Adelante doble', '1', '0', '1', '1', '0', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP060', '3', 'BODEGA', 'ALVB001', 'ALV00BD0010', None, None, None, None, '001', None, '1', '0', 'ALV B 2.72', 'bodega de 2.72 m2', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.72', None, None, None, None, None, None, None, None, '0', None, None, None, None, None, '1', '0', '0', '1', '0', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP061', '1', 'DEPARTAMENTO', 'ALVD061', 'ALV0CD33010', None, None, '0C', '3', '301', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1017672', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP062', '1', 'DEPARTAMENTO', 'ALVD062', 'ALV0CD33020', None, None, '0C', '3', '302', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1017672', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP063', '1', 'DEPARTAMENTO', 'ALVD063', 'ALV0CD33030', None, None, '0C', '3', '303', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1017672', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP065', '1', 'DEPARTAMENTO', 'ALVD065', 'ALV0CD33050', None, None, '0C', '3', '305', None, '1', '0', 'ALV 1.1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '13.9', None, '4.11', '2.16', None, None, None, '47.05', '0', '0', '0', None, '0', '47.05', None, None, '0', None, None, None, None, None, '1', '0', '0', '1247951', '10000', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP065', '2', 'ESTACIONAMIENTO', 'ALVE073', 'ALVGDEA0630', None, None, None, None, '063', None, '1', '0', 'EST GDEA', 'Cajón grande, adelante doble, abajo con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Adelante doble', '1', '0', '0', '1', '0', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP068', '1', 'DEPARTAMENTO', 'ALVD068', 'ALV0CD44010', None, None, '0C', '4', '401', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '967301', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP069', '1', 'DEPARTAMENTO', 'ALVD069', 'ALV0CD44020', None, None, '0C', '4', '402', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '967301', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP070', '1', 'DEPARTAMENTO', 'ALVD070', 'ALV0CD44030', None, None, '0C', '4', '403', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '967301', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP075', '1', 'DEPARTAMENTO', 'ALVD075', 'ALV0CD55010', None, None, '0C', '5', '501', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '955699', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP076', '1', 'DEPARTAMENTO', 'ALVD076', 'ALV0CD55020', None, None, '0C', '5', '502', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '955699', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP077', '1', 'DEPARTAMENTO', 'ALVD077', 'ALV0CD55030', None, None, '0C', '5', '503', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '955699', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP078', '1', 'DEPARTAMENTO', 'ALVD078', 'ALV0CD55040', None, None, '0C', '5', '504', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '955699', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP080', '1', 'DEPARTAMENTO', 'ALVD080', 'ALV0CD55060', None, None, '0C', '5', '506', None, '1', '0', 'ALV 1.1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '13.9', None, '4.11', '2.16', None, None, None, '47.05', '0', '0', '0', None, '0', '47.05', None, None, '0', None, None, None, None, None, '1', '0', '1', '1163092', '10000', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP080', '2', 'ESTACIONAMIENTO', 'ALVE096', 'ALVGEEA0760', None, None, None, None, '076', None, '1', '0', 'EST GEEA', 'Cajón grande, atras doble, abajo con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Atrás doble', '1', '0', '1', '1', '0', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP082', '1', 'DEPARTAMENTO', 'ALVD082', 'ALV0DD00010', None, None, '0D', '0', '001', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1278693', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP082', '2', 'ESTACIONAMIENTO', 'ALVE049', 'ALVCUEX0450', None, None, None, None, '045', None, '1', '0', 'EST CUEX', 'Cajón chico, único, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Único', '1', '0', '1', '1', '0', '0', '0', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP083', '1', 'DEPARTAMENTO', 'ALVD083', 'ALV0DD00020', None, None, '0D', '0', '002', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1278693', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP083', '2', 'ESTACIONAMIENTO', 'ALVE050', 'ALVCUEX0460', None, None, None, None, '046', None, '1', '0', 'EST CUEX', 'Cajón chico, único, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Único', '1', '0', '1', '1', '0', '0', '0', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP084', '1', 'DEPARTAMENTO', 'ALVD084', 'ALV0DD00030', None, None, '0D', '0', '003', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1278693', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP084', '2', 'ESTACIONAMIENTO', 'ALVE051', 'ALVCUEX0470', None, None, None, None, '047', None, '1', '0', 'EST CUEX', 'Cajón chico, único, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Único', '1', '0', '1', '1', '0', '0', '0', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP085', '1', 'DEPARTAMENTO', 'ALVD085', 'ALV0DD00040', None, None, '0D', '0', '004', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1278693', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP085', '2', 'ESTACIONAMIENTO', 'ALVE052', 'ALVCUEX0480', None, None, None, None, '048', None, '1', '0', 'EST CUEX', 'Cajón chico, único, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Único', '1', '0', '1', '1', '0', '0', '0', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP086', '1', 'DEPARTAMENTO', 'ALVD086', 'ALV0DD00050', None, None, '0D', '0', '005', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1278693', '10000', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP086', '2', 'ESTACIONAMIENTO', 'ALVE053', 'ALVCUEX0550', None, None, None, None, '055', None, '1', '0', 'EST CUEX', 'Cajón chico, único, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Único', '1', '0', '1', '1', '0', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP087', '1', 'DEPARTAMENTO', 'ALVD087', 'ALV0DD00060', None, None, '0D', '0', '006', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1220720', '10000', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP087', '2', 'ESTACIONAMIENTO', 'ALVE007', 'ALVCDEX0020', None, None, None, None, '002', None, '1', '0', 'EST CDEX', 'Cajón chico, adelante doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '1', '0', '1', '1', '0', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP088', '1', 'DEPARTAMENTO', 'ALVD088', 'ALV0DD00070', None, None, '0D', '0', '007', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1220720', '10000', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP088', '2', 'ESTACIONAMIENTO', 'ALVE008', 'ALVCDEX0040', None, None, None, None, '004', None, '1', '0', 'EST CDEX', 'Cajón chico, adelante doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '1', '0', '1', '1', '0', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP089', '1', 'DEPARTAMENTO', 'ALVD089', 'ALV0DD00080', None, None, '0D', '0', '008', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1220720', '10000', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP089', '2', 'ESTACIONAMIENTO', 'ALVE009', 'ALVCDEX0060', None, None, None, None, '006', None, '1', '0', 'EST CDEX', 'Cajón chico, adelante doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '1', '0', '1', '1', '0', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP090', '1', 'DEPARTAMENTO', 'ALVD090', 'ALV0DD11010', None, None, '0D', '1', '101', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1220397', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP090', '2', 'ESTACIONAMIENTO', 'ALVE010', 'ALVCDEX0080', None, None, None, None, '008', None, '1', '0', 'EST CDEX', 'Cajón chico, adelante doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '1', '0', '1', '1', '0', '0', '0', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP091', '1', 'DEPARTAMENTO', 'ALVD091', 'ALV0DD11020', None, None, '0D', '1', '102', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1220397', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP091', '2', 'ESTACIONAMIENTO', 'ALVE011', 'ALVCDEX0100', None, None, None, None, '010', None, '1', '0', 'EST CDEX', 'Cajón chico, adelante doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '1', '0', '1', '1', '0', '0', '0', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP092', '1', 'DEPARTAMENTO', 'ALVD092', 'ALV0DD11030', None, None, '0D', '1', '103', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1220397', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP092', '2', 'ESTACIONAMIENTO', 'ALVE012', 'ALVCDEX0120', None, None, None, None, '012', None, '1', '0', 'EST CDEX', 'Cajón chico, adelante doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '1', '0', '1', '1', '0', '0', '0', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP093', '1', 'DEPARTAMENTO', 'ALVD093', 'ALV0DD11040', None, None, '0D', '1', '104', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1220397', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP093', '2', 'ESTACIONAMIENTO', 'ALVE013', 'ALVCDEX0140', None, None, None, None, '014', None, '1', '0', 'EST CDEX', 'Cajón chico, adelante doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '1', '0', '1', '1', '0', '0', '0', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP094', '1', 'DEPARTAMENTO', 'ALVD094', 'ALV0DD11050', None, None, '0D', '1', '105', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1199327', '10000', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP094', '2', 'ESTACIONAMIENTO', 'ALVE070', 'ALVGDEA0410', None, None, None, None, '041', None, '1', '0', 'EST GDEA', 'Cajón grande, adelante doble, abajo con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Adelante doble', '1', '0', '1', '1', '0', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP095', '1', 'DEPARTAMENTO', 'ALVD095', 'ALV0DD11060', None, None, '0D', '1', '106', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1199327', '10000', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP095', '2', 'ESTACIONAMIENTO', 'ALVE071', 'ALVGDEA0430', None, None, None, None, '043', None, '1', '0', 'EST GDEA', 'Cajón grande, adelante doble, abajo con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Adelante doble', '1', '0', '1', '1', '0', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP096', '1', 'DEPARTAMENTO', 'ALVD096', 'ALV0DD11070', None, None, '0D', '1', '107', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1196985', '10000', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP096', '2', 'ESTACIONAMIENTO', 'ALVE031', 'ALVCEEX0030', None, None, None, None, '003', None, '1', '0', 'EST CEEX', 'Cajón chico, atrás doble., abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '1', '0', '1', '1', '0', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP097', '1', 'DEPARTAMENTO', 'ALVD097', 'ALV0DD11080', None, None, '0D', '1', '108', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1196985', '10000', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP097', '2', 'ESTACIONAMIENTO', 'ALVE032', 'ALVCEEX0050', None, None, None, None, '005', None, '1', '0', 'EST CEEX', 'Cajón chico, atrás doble., abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '1', '0', '1', '1', '0', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP098', '1', 'DEPARTAMENTO', 'ALVD098', 'ALV0DD22010', None, None, '0D', '2', '201', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1184923', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP098', '2', 'ESTACIONAMIENTO', 'ALVE033', 'ALVCEEX0070', None, None, None, None, '007', None, '1', '0', 'EST CEEX', 'Cajón chico, atrás doble., abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '1', '0', '1', '1', '0', '0', '0', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP099', '1', 'DEPARTAMENTO', 'ALVD099', 'ALV0DD22020', None, None, '0D', '2', '202', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1184923', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP099', '2', 'ESTACIONAMIENTO', 'ALVE034', 'ALVCEEX0090', None, None, None, None, '009', None, '1', '0', 'EST CEEX', 'Cajón chico, atrás doble., abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '1', '0', '1', '1', '0', '0', '0', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP100', '1', 'DEPARTAMENTO', 'ALVD100', 'ALV0DD22030', None, None, '0D', '2', '203', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1184923', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP100', '2', 'ESTACIONAMIENTO', 'ALVE035', 'ALVCEEX0110', None, None, None, None, '011', None, '1', '0', 'EST CEEX', 'Cajón chico, atrás doble., abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '1', '0', '1', '1', '0', '0', '0', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP101', '1', 'DEPARTAMENTO', 'ALVD101', 'ALV0DD22040', None, None, '0D', '2', '204', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1184923', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP101', '2', 'ESTACIONAMIENTO', 'ALVE036', 'ALVCEEX0130', None, None, None, None, '013', None, '1', '0', 'EST CEEX', 'Cajón chico, atrás doble., abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '1', '0', '1', '1', '0', '0', '0', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP102', '1', 'DEPARTAMENTO', 'ALVD102', 'ALV0DD22050', None, None, '0D', '2', '205', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1184923', '10000', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP102', '2', 'ESTACIONAMIENTO', 'ALVE037', 'ALVCEEX0150', None, None, None, None, '015', None, '1', '0', 'EST CEEX', 'Cajón chico, atrás doble., abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '1', '0', '1', '1', '0', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP103', '1', 'DEPARTAMENTO', 'ALVD103', 'ALV0DD22060', None, None, '0D', '2', '206', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1174390', '10000', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP103', '2', 'ESTACIONAMIENTO', 'ALVE088', 'ALVGEEA0420', None, None, None, None, '042', None, '1', '0', 'EST GEEA', 'Cajón grande, atras doble, abajo con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Atrás doble', '1', '0', '1', '1', '0', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP104', '1', 'DEPARTAMENTO', 'ALVD104', 'ALV0DD22070', None, None, '0D', '2', '207', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1174390', '10000', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP104', '2', 'ESTACIONAMIENTO', 'ALVE089', 'ALVGEEA0440', None, None, None, None, '044', None, '1', '0', 'EST GEEA', 'Cajón grande, atras doble, abajo con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Atrás doble', '1', '0', '1', '1', '0', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP105', '1', 'DEPARTAMENTO', 'ALVD105', 'ALV0DD22080', None, None, '0D', '2', '208', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1161512', '10000', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP105', '2', 'ESTACIONAMIENTO', 'ALVE001', 'ALVCAEX0490', None, None, None, None, '049', None, '1', '0', 'EST CAEX', 'Cajon chico, adelante triple, abajo sin eleva auto.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', '121', None, 'Chico', 'Abajo sin eleva autos', 'Adelante triple', '1', '0', '1', '1', '0', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP106', '1', 'DEPARTAMENTO', 'ALVD106', 'ALV0DD33010', None, None, '0D', '3', '301', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1146437', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP106', '2', 'ESTACIONAMIENTO', 'ALVE002', 'ALVCAEX0520', None, None, None, None, '052', None, '1', '0', 'EST CAEX', 'Cajon chico, adelante triple, abajo sin eleva auto.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante triple', '1', '0', '1', '1', '0', '0', '0', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP107', '1', 'DEPARTAMENTO', 'ALVD107', 'ALV0DD33020', None, None, '0D', '3', '302', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1144095', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP107', '2', 'ESTACIONAMIENTO', 'ALVE079', 'ALVGDEB0410', None, None, None, None, '041', None, '1', '0', 'EST GDEB', 'Cajón grande, adelante doble, arriba con eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Adelante doble', '1', '0', '1', '1', '0', '0', '0', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP108', '1', 'DEPARTAMENTO', 'ALVD108', 'ALV0DD33030', None, None, '0D', '3', '303', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1144095', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP108', '2', 'ESTACIONAMIENTO', 'ALVE080', 'ALVGDEB0430', None, None, None, None, '043', None, '1', '0', 'EST GDEB', 'Cajón grande, adelante doble, arriba con eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Adelante doble', '1', '0', '1', '1', '0', '0', '0', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP109', '1', 'DEPARTAMENTO', 'ALVD109', 'ALV0DD33040', None, None, '0D', '3', '304', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1133559', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP109', '2', 'ESTACIONAMIENTO', 'ALVE105', 'ALVGEEB0420', None, None, None, None, '042', None, '1', '0', 'EST GEEB', 'Cajón grande, atras doble, arriba con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Atrás doble', '1', '0', '1', '1', '0', '0', '0', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP110', '1', 'DEPARTAMENTO', 'ALVD110', 'ALV0DD33050', None, None, '0D', '3', '305', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1133559', '10000', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP110', '2', 'ESTACIONAMIENTO', 'ALVE106', 'ALVGEEB0440', None, None, None, None, '044', None, '1', '0', 'EST GEEB', 'Cajón grande, atras doble, arriba con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Atrás doble', '1', '0', '1', '1', '0', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP111', '1', 'DEPARTAMENTO', 'ALVD111', 'ALV0DD33060', None, None, '0D', '3', '306', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1123025', '10000', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP111', '2', 'ESTACIONAMIENTO', 'ALVE003', 'ALVCBEX0500', None, None, None, None, '050', None, '1', '0', 'EST CBEX', 'Cajón chico, en medio triple, abajo sin eleva auto.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'En medio triple', '1', '0', '1', '1', '0', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP112', '1', 'DEPARTAMENTO', 'ALVD112', 'ALV0DD33070', None, None, '0D', '3', '307', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1123025', '10000', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP112', '2', 'ESTACIONAMIENTO', 'ALVE004', 'ALVCBEX0530', None, None, None, None, '053', None, '1', '0', 'EST CBEX', 'Cajón chico, en medio triple, abajo sin eleva auto.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'En medio triple', '1', '0', '1', '1', '0', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP113', '1', 'DEPARTAMENTO', 'ALVD113', 'ALV0DD33080', None, None, '0D', '3', '308', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1099612', '10000', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP113', '2', 'ESTACIONAMIENTO', 'ALVE005', 'ALVCCEX0510', None, None, None, None, '051', None, '1', '0', 'EST CCEX', 'Cajón chico, atras triple, abajo sin eleva auto.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás triple', '1', '0', '1', '1', '0', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP114', '1', 'DEPARTAMENTO', 'ALVD114', 'ALV0DD44010', None, None, '0D', '4', '401', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1046120', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP114', '2', 'ESTACIONAMIENTO', 'ALVE006', 'ALVCCEX0540', None, None, None, None, '054', None, '1', '0', 'EST CCEX', 'Cajón chico, atras triple, abajo sin eleva auto.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás triple', '1', '0', '1', '1', '0', '0', '0', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP115', '1', 'DEPARTAMENTO', 'ALVD115', 'ALV0DD44020', None, None, '0D', '4', '402', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '967301', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP116', '1', 'DEPARTAMENTO', 'ALVD116', 'ALV0DD44030', None, None, '0D', '4', '403', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '967301', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP117', '1', 'DEPARTAMENTO', 'ALVD117', 'ALV0DD44040', None, None, '0D', '4', '404', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '967301', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP118', '1', 'DEPARTAMENTO', 'ALVD118', 'ALV0DD44050', None, None, '0D', '4', '405', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '967301', '10000', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP119', '1', 'DEPARTAMENTO', 'ALVD119', 'ALV0DD44060', None, None, '0D', '4', '406', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '967301', '10000', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP120', '1', 'DEPARTAMENTO', 'ALVD120', 'ALV0DD44070', None, None, '0D', '4', '407', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '967301', '10000', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP121', '1', 'DEPARTAMENTO', 'ALVD121', 'ALV0DD44080', None, None, '0D', '4', '408', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '967301', '10000', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP122', '1', 'DEPARTAMENTO', 'ALVD122', 'ALV0DD55010', None, None, '0D', '5', '501', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '955699', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP123', '1', 'DEPARTAMENTO', 'ALVD123', 'ALV0DD55020', None, None, '0D', '5', '502', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '955699', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP124', '1', 'DEPARTAMENTO', 'ALVD124', 'ALV0DD55030', None, None, '0D', '5', '503', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '955699', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP125', '1', 'DEPARTAMENTO', 'ALVD125', 'ALV0DD55040', None, None, '0D', '5', '504', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '955699', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP126', '1', 'DEPARTAMENTO', 'ALVD126', 'ALV0DD55050', None, None, '0D', '5', '505', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '955699', '10000', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP127', '1', 'DEPARTAMENTO', 'ALVD127', 'ALV0DD55060', None, None, '0D', '5', '506', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '955699', '10000', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP128', '1', 'DEPARTAMENTO', 'ALVD128', 'ALV0DD55070', None, None, '0D', '5', '507', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '955699', '10000', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP129', '1', 'DEPARTAMENTO', 'ALVD129', 'ALV0DD55080', None, None, '0D', '5', '508', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '955699', '10000', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP130', '1', 'DEPARTAMENTO', 'ALVD130', 'ALV0ED00010', None, None, '0E', '0', '001', None, '1', '0', 'ALV 1.2', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '16.63', None, None, '2.28', None, None, None, '49.09', '0', '0', '0', None, '0', '49.09', None, None, '0', None, None, None, None, None, '1', '0', '0', '1405390', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP130', '2', 'ESTACIONAMIENTO', 'ALVE048', 'ALVCUEX0360', None, None, None, None, '036', None, '1', '0', 'EST CUEX', 'Cajón chico, único, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Único', '1', '0', '0', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP131', '1', 'DEPARTAMENTO', 'ALVD131', 'ALV0ED00020', None, None, '0E', '0', '002', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '0', '1220720', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP131', '2', 'ESTACIONAMIENTO', 'ALVE014', 'ALVCDEX0160', None, None, None, None, '016', None, '1', '0', 'EST CDEX', 'Cajón chico, adelante doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '1', '0', '0', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP135', '1', 'DEPARTAMENTO', 'ALVD135', 'ALV0ED00060', None, None, '0E', '0', '006', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '0', '1220720', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP135', '2', 'ESTACIONAMIENTO', 'ALVE016', 'ALVCDEX0200', None, None, None, None, '020', None, '1', '0', 'EST CDEX', 'Cajón chico, adelante doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '1', '0', '0', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP136', '1', 'DEPARTAMENTO', 'ALVD136', 'ALV0ED00070', None, None, '0E', '0', '007', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '0', '1220720', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP136', '2', 'ESTACIONAMIENTO', 'ALVE017', 'ALVCDEX0220', None, None, None, None, '022', None, '1', '0', 'EST CDEX', 'Cajón chico, adelante doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '1', '0', '0', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP137', '1', 'DEPARTAMENTO', 'ALVD137', 'ALV0ED00080', None, None, '0E', '0', '008', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '0', '1220720', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP137', '2', 'ESTACIONAMIENTO', 'ALVE018', 'ALVCDEX0240', None, None, None, None, '024', None, '1', '0', 'EST CDEX', 'Cajón chico, adelante doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '1', '0', '0', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP138', '1', 'DEPARTAMENTO', 'ALVD138', 'ALV0ED11010', None, None, '0E', '1', '101', None, '1', '0', 'ALV 1.2', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '16.63', None, None, '2.28', None, None, None, '49.09', '0', '0', '0', None, '0', '49.09', None, None, '0', None, None, None, None, None, '1', '0', '0', '1346853', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP138', '2', 'ESTACIONAMIENTO', 'ALVE019', 'ALVCDEX0260', None, None, None, None, '026', None, '1', '0', 'EST CDEX', 'Cajón chico, adelante doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '1', '0', '0', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP139', '1', 'DEPARTAMENTO', 'ALVD139', 'ALV0ED11020', None, None, '0E', '1', '102', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '0', '1220397', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP139', '2', 'ESTACIONAMIENTO', 'ALVE020', 'ALVCDEX0280', None, None, None, None, '028', None, '1', '0', 'EST CDEX', 'Cajón chico, adelante doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '1', '0', '0', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP140', '1', 'DEPARTAMENTO', 'ALVD140', 'ALV0ED11030', None, None, '0E', '1', '103', None, '1', '0', 'ALV 1.3', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '17.82', None, None, '2.28', None, None, None, '46.03', '0', '0', '0', None, '0', '46.03', None, None, '0', None, None, None, None, None, '1', '0', '0', '1252771', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP140', '2', 'ESTACIONAMIENTO', 'ALVE066', 'ALVGDEA0300', None, None, None, None, '030', None, '1', '0', 'EST GDEA', 'Cajón grande, adelante doble, abajo con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Adelante doble', '1', '0', '0', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP147', '1', 'DEPARTAMENTO', 'ALVD147', 'ALV0ED22020', None, None, '0E', '2', '202', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '0', '1184923', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP147', '2', 'ESTACIONAMIENTO', 'ALVE041', 'ALVCEEX0230', None, None, None, None, '023', None, '1', '0', 'EST CEEX', 'Cajón chico, atrás doble., abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '1', '0', '0', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP150', '1', 'DEPARTAMENTO', 'ALVD150', 'ALV0ED22050', None, None, '0E', '2', '205', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '0', '1184923', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP150', '2', 'ESTACIONAMIENTO', 'ALVE044', 'ALVCEEX0290', None, None, None, None, '029', None, '1', '0', 'EST CEEX', 'Cajón chico, atrás doble., abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '1', '0', '0', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP156', '1', 'DEPARTAMENTO', 'ALVD156', 'ALV0ED33030', None, None, '0E', '3', '303', None, '1', '0', 'ALV 1.3', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '17.82', None, None, '2.28', None, None, None, '46.03', '0', '0', '0', None, '0', '46.03', None, None, '0', None, None, None, None, None, '1', '0', '0', '1196153', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP156', '2', 'ESTACIONAMIENTO', 'ALVE076', 'ALVGDEB0320', None, None, None, None, '032', None, '1', '0', 'EST GDEB', 'Cajón grande, adelante doble, arriba con eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Adelante doble', '1', '0', '0', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP159', '1', 'DEPARTAMENTO', 'ALVD159', 'ALV0ED33060', None, None, '0E', '3', '306', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1133559', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP159', '2', 'ESTACIONAMIENTO', 'ALVE101', 'ALVGEEB0310', None, None, None, None, '031', None, '1', '0', 'EST GEEB', 'Cajón grande, atras doble, arriba con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Atrás doble', '1', '0', '1', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP162', '1', 'DEPARTAMENTO', 'ALVD162', 'ALV0ED44010', None, None, '0E', '4', '401', None, '1', '0', 'ALV 1.2', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '16.63', None, None, '2.28', None, None, None, '49.09', '0', '0', '0', None, '0', '49.09', None, None, '0', None, None, None, None, None, '1', '0', '0', '1195849', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP162', '2', 'ESTACIONAMIENTO', 'ALVE104', 'ALVGEEB0400', None, None, None, None, '040', None, '1', '0', 'EST GEEB', 'Cajón grande, atras doble, arriba con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Atrás doble', '1', '0', '0', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP163', '1', 'DEPARTAMENTO', 'ALVD163', 'ALV0ED44020', None, None, '0E', '4', '402', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '0', '967301', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP165', '1', 'DEPARTAMENTO', 'ALVD165', 'ALV0ED44040', None, None, '0E', '4', '404', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '0', '967301', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP172', '1', 'DEPARTAMENTO', 'ALVD172', 'ALV0ED55030', None, None, '0E', '5', '503', None, '1', '0', 'ALV 1.3', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '17.82', None, None, '2.28', None, None, None, '46.03', '0', '0', '0', None, '0', '46.03', None, None, '0', None, None, None, None, None, '1', '0', '1', '1004586', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP173', '1', 'DEPARTAMENTO', 'ALVD173', 'ALV0ED55040', None, None, '0E', '5', '504', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '955699', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP175', '1', 'DEPARTAMENTO', 'ALVD175', 'ALV0ED55060', None, None, '0E', '5', '506', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '955699', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP058', '1', 'DEPARTAMENTO', 'ALVD058', 'ALV0CD22050', None, None, '0C', '2', '205', None, '1', '0', 'ALV 1.1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '13.9', None, '4.11', '2.16', None, None, None, '47.05', '0', '0', '0', None, '0', '47.05', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,285,220.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00053420', 'FELIX MANUEL HERNANDEZ ORTEGA', 'FELIX MANUEL', 'HERNANDEZ', 'ORTEGA', 'HEOF7008017T2', 'HEOF700801HHGRRL00', '0', 'H', 'CARMONA_LOZADA@YAHOO.COM.MX', '26089071', '5543690318', '16487190', '39917020263', '1-Aug-70', 'CASADO', 'SOCIEDAD CONYUGAL', 'MEXICANA', 'HIDALGO', None, '3', 'Gallardete', 'JOSE NAVA', 'MZ 13', 'LT 30', 'CONGRESO AGRARISTA MEXICANO', 'IZTAPALAPA', 'DISTRITO FEDERAL', 'MEXICO', '09760', '10', 'EMPLEADO', '2764006745612', 'IFE', '30020102155', '0002371', None, '1028886.99000', '1028887.99000', '.00000', '.00000', '1028887.99000', '.00000', '.00000', '90542.14000', '.00000', '.00000', '1119430.13000', '1-Jan-00', '19-Jun-15', '13-Mar-15', '13-Mar-15', '17-Mar-15', '12', None, '18-Mar-15', '18-Mar-15', '18-Mar-15', '30-Mar-15', '30-Mar-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP058', '2', 'ESTACIONAMIENTO', 'ALVE029', 'ALVCDEX0810', None, None, None, None, '081', None, '1', '0', 'EST CDEX', 'Cajón chico, adelante doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00053420', 'FELIX MANUEL HERNANDEZ ORTEGA', 'FELIX MANUEL', 'HERNANDEZ', 'ORTEGA', 'HEOF7008017T2', 'HEOF700801HHGRRL00', '0', 'H', 'CARMONA_LOZADA@YAHOO.COM.MX', '26089071', '5543690318', '16487190', '39917020263', '1-Aug-70', 'CASADO', 'SOCIEDAD CONYUGAL', 'MEXICANA', 'HIDALGO', None, '3', 'Gallardete', 'JOSE NAVA', 'MZ 13', 'LT 30', 'CONGRESO AGRARISTA MEXICANO', 'IZTAPALAPA', 'DISTRITO FEDERAL', 'MEXICO', '09760', '10', 'EMPLEADO', '2764006745612', 'IFE', '30020102155', '0002371', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '13-Mar-15', '13-Mar-15', '17-Mar-15', '12', None, '18-Mar-15', '18-Mar-15', '18-Mar-15', '30-Mar-15', '30-Mar-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP161', '1', 'DEPARTAMENTO', 'ALVD161', 'ALV0ED33080', None, None, '0E', '3', '308', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,133,559.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00061055', 'RAYMUNDO CONTRERAS RUIZ', 'RAYMUNDO', 'CONTRERAS', 'RUIZ', 'CORR810603560', 'CORR810603HDFNZY02', '1', None, 'raycontrerasr@hotmail.com', '40803909', None, '5540803909', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, None, None, 'Mexico', None, '0', None, None, None, '30010177704', 'SI000010610', None, '823106.22000', '823107.22000', '.00000', '.00000', '823107.22000', '.00000', '.00000', '67165.48000', '.00000', '-58485.14000', '831787.56000', '15-Jan-15', '15-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', '0', None, '5-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP161', '2', 'ESTACIONAMIENTO', 'ALVE103', 'ALVGEEB0380', None, None, None, None, '038', None, '1', '0', 'EST GEEB', 'Cajón grande, atras doble, arriba con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Atrás doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00061055', 'RAYMUNDO CONTRERAS RUIZ', 'RAYMUNDO', 'CONTRERAS', 'RUIZ', 'CORR810603560', 'CORR810603HDFNZY02', '1', None, 'raycontrerasr@hotmail.com', '40803909', None, '5540803909', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, None, None, 'Mexico', None, '0', None, None, None, '30010177704', 'SI000010617', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', '0', None, '5-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP148', '1', 'DEPARTAMENTO', 'ALVD148', 'ALV0ED22030', None, None, '0E', '2', '203', None, '1', '0', 'ALV 1.3', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '17.82', None, None, '2.28', None, None, None, '46.03', '0', '0', '0', None, '0', '46.03', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,237,753.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00065869', 'DAVID BATALLA DOMINGUEZ', 'DAVID', 'BATALLA', 'DOMINGUEZ', 'BADD891219CD1', 'BADD891219HMCTMV09', '1', None, 'dbdnike@hotmail.com', '58681222', None, '5543418307', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, None, None, 'Mexico', None, '0', None, None, None, '30010178900', 'SI000010907', None, '898763.75000', '898764.75000', '.00000', '.00000', '898764.75000', '.00000', '.00000', '76934.18000', '.00000', '-10000.00000', '965698.93000', '15-Jan-15', '15-Jan-15', '19-Jan-15', '19-Jan-15', '19-Jan-15', '0', None, '19-Jan-15', '19-Jan-15', '19-Jan-15', '19-Jan-15', '19-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP148', '2', 'ESTACIONAMIENTO', 'ALVE042', 'ALVCEEX0250', None, None, None, None, '025', None, '1', '0', 'EST CEEX', 'Cajón chico, atrás doble., abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00065869', 'DAVID BATALLA DOMINGUEZ', 'DAVID', 'BATALLA', 'DOMINGUEZ', 'BADD891219CD1', 'BADD891219HMCTMV09', '1', None, 'dbdnike@hotmail.com', '58681222', None, '5543418307', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, None, None, 'Mexico', None, '0', None, None, None, '30010178900', 'SI000011013', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '19-Jan-15', '19-Jan-15', '19-Jan-15', '0', None, '19-Jan-15', '19-Jan-15', '19-Jan-15', '19-Jan-15', '19-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP149', '1', 'DEPARTAMENTO', 'ALVD149', 'ALV0ED22040', None, None, '0E', '2', '204', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,184,923.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00066459', 'ANGEL ANTONIO PACHECO PINEDA', 'ANGEL ANTONIO', 'PACHECO', 'PINEDA', 'PAPA8303253TA', 'PAPA830325HGRCNN00', '1', None, 'angel.pacheco28@yahoo.com.mx', '34164525', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, None, None, 'Mexico', None, '0', None, None, None, '30010178694', 'SI000010908', None, '860403.00000', '860404.00000', '.00000', '.00000', '860404.00000', '.00000', '.00000', '75715.46000', '.00000', '-2992.00000', '933127.46000', '15-Jan-15', '15-Jan-15', '29-Jan-15', '29-Jan-15', '29-Jan-15', '0', None, '29-Jan-15', '29-Jan-15', '29-Jan-15', '29-Jan-15', '29-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP149', '2', 'ESTACIONAMIENTO', 'ALVE043', 'ALVCEEX0270', None, None, None, None, '027', None, '1', '0', 'EST CEEX', 'Cajón chico, atrás doble., abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00066459', 'ANGEL ANTONIO PACHECO PINEDA', 'ANGEL ANTONIO', 'PACHECO', 'PINEDA', 'PAPA8303253TA', 'PAPA830325HGRCNN00', '1', None, 'angel.pacheco28@yahoo.com.mx', '34164525', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, None, None, 'Mexico', None, '0', None, None, None, '30010178694', 'SI000011014', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '29-Jan-15', '29-Jan-15', '29-Jan-15', '0', None, '29-Jan-15', '29-Jan-15', '29-Jan-15', '29-Jan-15', '29-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP164', '1', 'DEPARTAMENTO', 'ALVD164', 'ALV0ED44030', None, None, '0E', '4', '403', None, '1', '0', 'ALV 1.3', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '17.82', None, None, '2.28', None, None, None, '46.03', '0', '0', '0', None, '0', '46.03', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,016,781.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00067785', 'JUAN VELAZQUEZ MELO', 'JUAN', 'VELAZQUEZ', 'MELO', 'VEMJ670527B56', 'VEMJ670527HDFLLN01', '1', None, 'juan.velazquez@grupodeco.com', '50052300', '46232496', '5539993258', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'ESCUADRON 201', 'IZTAPALAPA DF', 'DF', 'Mexico', '09060', '0', None, None, None, '30010183777', '0002283', None, '808988.00000', '808988.00000', '.00000', '.00000', '808988.00000', '.00000', '.00000', '71190.94000', '.00000', '-5000.00000', '875178.94000', '15-Jan-15', '15-Jan-15', '24-Feb-15', '24-Feb-15', '24-Feb-15', '12', None, '24-Feb-15', '24-Feb-15', '24-Feb-15', '24-Feb-15', '24-Feb-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP170', '1', 'DEPARTAMENTO', 'ALVD170', 'ALV0ED55010', None, None, '0E', '5', '501', None, '1', '0', 'ALV 1.2', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '16.63', None, None, '2.28', None, None, None, '49.09', '0', '0', '0', None, '0', '49.09', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,071,369.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00068598', 'ALEJANDRO RODRIGUEZ HERNANDEZ', 'ALEJANDRO', 'RODRIGUEZ', 'HERNANDEZ', 'ROHA730928MQ0', 'ROHA730928HDFDRL04', '1', None, 'alexrodher@yahoo.com', '5528275523', None, '5528275523', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, None, None, 'Mexico', None, '0', None, None, None, '30010178223', 'SI000010757', None, '808757.75000', '808757.75000', '.00000', '.00000', '808757.75000', '.00000', '.00000', '64700.62000', '.00000', '-46000.00000', '827458.37000', '15-Jan-15', '15-Jan-15', '12-Jan-15', '12-Jan-15', '12-Jan-15', '0', None, '12-Jan-15', '12-Jan-15', '12-Jan-15', '12-Jan-15', '12-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP039', '1', 'DEPARTAMENTO', 'ALVD039', 'ALV0BD55030', None, None, '0B', '5', '503', None, '1', '0', 'ALV 3.3', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '13.4', None, '3.8', '2.15', None, None, None, '45.16', '0', '0', '0', None, '0', '45.16', None, None, '0', None, None, None, None, None, '0', '1', '1', '985,599.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00070473', 'MARIA DEL CARMEN DOMINGUEZ RETEGUIN', 'MARIA DEL CARMEN', 'DOMINGUEZ', 'RETEGUIN', 'DORC8609215Z5', 'DORC860921MDFMTR04', '1', None, 'kejh_21@hotmail.com', '53910593', None, '5535226703', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, None, None, 'Mexico', None, '0', None, None, None, '30010175864', 'SI000010904', None, '744011.00000', '744011.00000', '.00000', '.00000', '744011.00000', '.00000', '.00000', '73657.09000', '.00000', '-20000.00000', '797668.09000', '15-Jan-15', '15-Jan-15', '16-Jan-15', '16-Jan-15', '16-Jan-15', '0', None, '16-Jan-15', '16-Jan-15', '16-Jan-15', '16-Jan-15', '16-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP025', '1', 'DEPARTAMENTO', 'ALVD025', 'ALV0BD22010', None, None, '0B', '2', '201', None, '1', '0', 'ALV 3.1-C', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado, Balcón.', None, None, '2', None, '1', '1', '13.32', None, '3.8', '2.45', None, None, None, '49.47', '0', '0', '2.55', None, '0', '52.02', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,360,321.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00071214', 'LYDIA GABRIELA CASTILLO MORENO', 'LYDIA GABRIELA', 'CASTILLO', 'MORENO', 'CAML850418K82', 'CAML850418MDFSRY05', '1', None, 'lydiagabrielacm@hotmail.com', '5550752748', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, None, None, 'Mexico', None, '0', None, None, None, '30010174917', 'SI000010605', None, '987763.75000', '987764.75000', '.00000', '.00000', '987764.75000', '.00000', '.00000', '85342.80000', '.00000', '-14992.00000', '1058115.55000', '15-Jan-15', '15-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', '0', None, '5-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP025', '2', 'ESTACIONAMIENTO', 'ALVE100', 'ALVGEEA0880', None, None, None, None, '088', None, '1', '0', 'EST GEEA', 'Cajón grande, atras doble, abajo con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Atrás doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00071214', 'LYDIA GABRIELA CASTILLO MORENO', 'LYDIA GABRIELA', 'CASTILLO', 'MORENO', 'CAML850418K82', 'CAML850418MDFSRY05', '1', None, 'lydiagabrielacm@hotmail.com', '5550752748', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, None, None, 'Mexico', None, '0', None, None, None, '30010174917', 'SI000010616', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', '0', None, '5-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP072', '1', 'DEPARTAMENTO', 'ALVD072', 'ALV0CD44050', None, None, '0C', '4', '405', None, '1', '0', 'ALV 1.1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '13.9', None, '4.11', '2.16', None, None, None, '47.05', '0', '0', '0', None, '0', '47.05', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,186,255.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00076120', 'ATENEA LIMA SANTOS', 'ATENEA', 'LIMA', 'SANTOS', 'LISA7910208T0', 'LISA791020MMCMNT19', '0', 'M', 'atenea.lima@gmail.com', '52196019', '5539394658', '55874304', None, '20-Oct-79', 'SOLTERO', None, 'MEXICA', 'ESTADO DE MEXICO', None, '3', 'Gallardete', 'EDIF 21', 'ENTRADA B', '401', 'U.HAB LINDAVISTA VALLEJO', 'GUSTAVO  A MADERO', 'DISTRITO FEDERAL', 'MEXICO', '07720', '3', 'DOCENTE', '14530505385067910203M2412311MEX', 'IFE', '30020105471', '0002514', None, '1096859.50000', '1096860.50000', '.00000', '.00000', '1096860.50000', '.00000', '.00000', '98717.44000', '.00000', '-47900.22000', '1147677.72000', '1-Jan-00', '24-Mar-15', '24-Mar-15', '12-Mar-15', '17-Mar-15', '12', None, '30-Mar-15', '30-Mar-15', '30-Mar-15', '1-Apr-15', '1-Apr-15', '5-Mar-15', None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP072', '2', 'ESTACIONAMIENTO', 'ALVE121', 'ALVGUEB0560', None, None, None, None, '056', None, '1', '0', 'EST GUEB', 'Cajón grande, único, arriba con eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Único', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00076120', 'ATENEA LIMA SANTOS', 'ATENEA', 'LIMA', 'SANTOS', 'LISA7910208T0', 'LISA791020MMCMNT19', '0', 'M', 'atenea.lima@gmail.com', '52196019', '5539394658', '55874304', None, '20-Oct-79', 'SOLTERO', None, 'MEXICA', 'ESTADO DE MEXICO', None, '3', 'Gallardete', 'EDIF 21', 'ENTRADA B', '401', 'U.HAB LINDAVISTA VALLEJO', 'GUSTAVO  A MADERO', 'DISTRITO FEDERAL', 'MEXICO', '07720', '3', 'DOCENTE', '14530505385067910203M2412311MEX', 'IFE', '30020105471', '0002514', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '24-Mar-15', '24-Mar-15', '12-Mar-15', '17-Mar-15', '12', None, '30-Mar-15', '30-Mar-15', '30-Mar-15', '1-Apr-15', '1-Apr-15', '5-Mar-15', None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP166', '1', 'DEPARTAMENTO', 'ALVD166', 'ALV0ED44050', None, None, '0E', '4', '405', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '0', '1', '1', '967,301.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00078512', 'SANDRA LUZ MORALES GUITRON', 'SANDRA LUZ', 'MORALES', 'GUITRON', 'MOGS750522Q97', 'MOGS750522MDFRTN06', '0', 'H', 'sguitron@hotmail.com', '57296000EXT5663', '57296000EXT5663', '552091536', None, '22-May-75', 'SOLTERO', None, 'MEXICANA', 'DF', None, '1', 'Impresos', 'CERRO COLORADO', '49', '17', 'SAN JOSE RESIDENCIAL ECUESTRE', 'TLALNEPANTLA MEX', 'MEX', 'MEXICO', '54187', '0', 'EMPLEADA', '4760084080281', 'IFE', '30020103120', '0002316', None, '737501.01000', '737501.01000', '.00000', '.00000', '737501.01000', '.00000', '.00000', '66375.09000', '.00000', '-10000.00000', '793876.10000', '1-Jan-00', '3-Mar-15', '3-Mar-15', '3-Mar-15', '31-Mar-15', '12', None, '31-Mar-15', '31-Mar-15', '31-Mar-15', '31-Mar-15', '31-Mar-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP022', '1', 'DEPARTAMENTO', 'ALVD022', 'ALV0BD11020', None, None, '0B', '1', '102', None, '1', '0', 'ALV 3.2-C', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado, Balcón.', None, None, '2', None, '1', '1', '13.4', None, '3.8', '2.15', None, None, None, '50.88', '0', '0', '2.61', None, '0', '53.49', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,536,575.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00078557', 'GABRIEL REYES CRUZ', 'GABRIEL', 'REYES', 'CRUZ', 'RECG830601KW3', 'RECG830601HDFYRB03', '1', None, 'gabriel.reyes.1@bbva.com', '56996307', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'ECATEPEC MORELOS MEX', 'MEX', 'Mexico', '55139', '0', None, None, None, '30010175955', 'SI000010532', None, '1115747.00000', '1115748.00000', '.00000', '.00000', '1115748.00000', '.00000', '.00000', '96400.55000', '.00000', '-9992.00000', '1202156.55000', '1-Jan-00', '30-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '0', None, '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP022', '2', 'ESTACIONAMIENTO', 'ALVE054', 'ALVDDEX0830', None, None, None, None, '083', None, '1', '0', 'EST DDEX', 'Discapacitados, adelante doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '19', None, None, None, None, None, None, '3.8', None, '0', None, None, 'DISCAPACITADO', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00078557', 'GABRIEL REYES CRUZ', 'GABRIEL', 'REYES', 'CRUZ', 'RECG830601KW3', 'RECG830601HDFYRB03', '1', None, 'gabriel.reyes.1@bbva.com', '56996307', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'ECATEPEC MORELOS MEX', 'MEX', 'Mexico', '55139', '0', None, None, None, '30010175955', 'SI000010547', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '30-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '0', None, '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP026', '1', 'DEPARTAMENTO', 'ALVD026', 'ALV0BD22020', None, None, '0B', '2', '202', None, '1', '0', 'ALV 3.2-C', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado, Balcón.', None, None, '2', None, '1', '1', '13.4', None, '3.8', '2.15', None, None, None, '50.88', '0', '0', '2.61', None, '0', '53.49', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,475,737.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00078789', 'ANDRES ERNESTO ALVAREZ ELGUERO', 'ANDRES ERNESTO', 'ALVAREZ', 'ELGUERO', 'AAEA870828EQ7', 'AAEA870828HDFLLN08', '1', None, 'andres_eae@yahoo.com.mx', '53559473', '91719600 ext 25', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02500', '0', None, None, None, '30010177027', 'SI000010533', None, '1071571.00000', '1071572.00000', '.00000', '.00000', '1071572.00000', '.00000', '.00000', '85725.69000', '.00000', '-121420.00000', '1035877.69000', '1-Jan-00', '30-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '0', None, '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP026', '2', 'ESTACIONAMIENTO', 'ALVE059', 'ALVEEEX0840', None, None, None, None, '084', None, '1', '0', 'EST EEEX', 'Discapacitados compartido, atrás doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '15.5', None, None, None, None, None, None, '3.1', None, '0', None, None, 'Discapacitado Compart', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00078789', 'ANDRES ERNESTO ALVAREZ ELGUERO', 'ANDRES ERNESTO', 'ALVAREZ', 'ELGUERO', 'AAEA870828EQ7', 'AAEA870828HDFLLN08', '1', None, 'andres_eae@yahoo.com.mx', '53559473', '91719600 ext 25', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02500', '0', None, None, None, '30010177027', 'SI000010548', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '30-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '0', None, '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP134', '1', 'DEPARTAMENTO', 'ALVD134', 'ALV0ED00050', None, None, '0E', '0', '005', None, '1', '0', 'ALV 1I-B', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado, Terraza.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '10.81', '0', None, '0', '54.6', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,353,894.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00078853', 'MAYRA ZAGAL CAMPUZANO', 'MAYRA', 'ZAGAL', 'CAMPUZANO', 'ZACM870525IY2', 'ZACM870525MMCGMY02', '1', None, 'mayra.zagal@stryker.com', '5518490406', '5591830960', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'TEOTIHUACÁN MEX', 'MEX', 'Mexico', '55816', '0', None, None, None, '30010176029', 'SI000010608', None, '992559.75000', '992560.75000', '.00000', '.00000', '992560.75000', '.00000', '.00000', '87345.27000', '.00000', '-10000.00000', '1069906.02000', '1-Jan-00', '30-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', '0', None, '5-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP134', '2', 'ESTACIONAMIENTO', 'ALVE047', 'ALVCUEX0350', None, None, None, None, '035', None, '1', '0', 'EST CUEX', 'Cajón chico, único, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Único', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00078853', 'MAYRA ZAGAL CAMPUZANO', 'MAYRA', 'ZAGAL', 'CAMPUZANO', 'ZACM870525IY2', 'ZACM870525MMCGMY02', '1', None, 'mayra.zagal@stryker.com', '5518490406', '5591830960', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'TEOTIHUACÁN MEX', 'MEX', 'Mexico', '55816', '0', None, None, None, '30010176029', 'SI000010611', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '30-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', '0', None, '5-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP030', '1', 'DEPARTAMENTO', 'ALVD030', 'ALV0BD33020', None, None, '0B', '3', '302', None, '1', '0', 'ALV 3.2-C', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado, Balcón.', None, None, '2', None, '1', '1', '13.4', None, '3.8', '2.15', None, None, None, '50.88', '0', '0', '2.61', None, '0', '53.49', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,458,219.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00078881', 'OSCAR MEJIA MENDOZA', 'OSCAR', 'MEJIA', 'MENDOZA', 'MEMO810906RA2', 'MEMO810906HMCJNS05', '1', None, 'memocomm@hotmail.com', '53673942', '57473500', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07720', '0', None, None, None, '30010176300', 'SI000010535', None, '1058851.00000', '1058852.00000', '.00000', '.00000', '1058852.00000', '.00000', '.00000', '84708.09000', '.00000', '-160000.00000', '983560.09000', '1-Jan-00', '30-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '0', None, '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP030', '2', 'ESTACIONAMIENTO', 'ALVE060', 'ALVEEEX0860', None, None, None, None, '086', None, '1', '0', 'EST EEEX', 'Discapacitados compartido, atrás doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '15.5', None, None, None, None, None, None, '3.1', None, '0', None, None, 'Discapacitado Compart', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00078881', 'OSCAR MEJIA MENDOZA', 'OSCAR', 'MEJIA', 'MENDOZA', 'MEMO810906RA2', 'MEMO810906HMCJNS05', '1', None, 'memocomm@hotmail.com', '53673942', '57473500', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07720', '0', None, None, None, '30010176300', 'SI000010549', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '30-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '0', None, '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP152', '1', 'DEPARTAMENTO', 'ALVD152', 'ALV0ED22070', None, None, '0E', '2', '207', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,174,390.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00078887', 'ESPERANZA QUILATZI DELGADO  PORTILLA', 'ESPERANZA QUILATZI', 'DELGADO', 'PORTILLA', 'DEPE820506K2A', 'DEPE820506MDFLRS04', '1', None, 'westgogh@hotmail.com', '55773484', '50972149', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07810', '0', None, None, None, '30010178637', 'SI000010910', None, '852753.75000', '852754.75000', '.00000', '.00000', '852754.75000', '.00000', '.00000', '76747.84000', '.00000', '-82459.13000', '847043.46000', '1-Jan-00', '30-Jan-15', '23-Jan-15', '23-Jan-15', '23-Jan-15', '0', None, '23-Jan-15', '23-Jan-15', '23-Jan-15', '23-Jan-15', '23-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP152', '2', 'ESTACIONAMIENTO', 'ALVE085', 'ALVGEEA0330', None, None, None, None, '033', None, '1', '0', 'EST GEEA', 'Cajón grande, atras doble, abajo con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Atrás doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00078887', 'ESPERANZA QUILATZI DELGADO  PORTILLA', 'ESPERANZA QUILATZI', 'DELGADO', 'PORTILLA', 'DEPE820506K2A', 'DEPE820506MDFLRS04', '1', None, 'westgogh@hotmail.com', '55773484', '50972149', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07810', '0', None, None, None, '30010178637', 'SI000011018', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '30-Jan-15', '23-Jan-15', '23-Jan-15', '23-Jan-15', '0', None, '23-Jan-15', '23-Jan-15', '23-Jan-15', '23-Jan-15', '23-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP160', '1', 'DEPARTAMENTO', 'ALVD160', 'ALV0ED33070', None, None, '0E', '3', '307', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,133,559.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00079076', 'CARINA MUÑOZ ESTRADA', 'CARINA', 'MUÑOZ', 'ESTRADA', 'MUEC7812088H9', 'MUEC781208MDFXSR08', '1', None, 'caris_78@hotmail.com', '44204049', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'CUAUHTÉMOC DF', 'DF', 'Mexico', '06800', '0', None, None, None, '30010178595', 'SI000010914', None, '854262.00000', '854263.00000', '.00000', '.00000', '854263.00000', '.00000', '.00000', '77783.58000', '.00000', '-88158.48000', '843888.10000', '1-Jan-00', '30-Jan-15', '23-Jan-15', '23-Jan-15', '23-Jan-15', '0', None, '23-Jan-15', '23-Jan-15', '23-Jan-15', '23-Jan-15', '23-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP160', '2', 'ESTACIONAMIENTO', 'ALVE102', 'ALVGEEB0330', None, None, None, None, '033', None, '1', '0', 'EST GEEB', 'Cajón grande, atras doble, arriba con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Atrás doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00079076', 'CARINA MUÑOZ ESTRADA', 'CARINA', 'MUÑOZ', 'ESTRADA', 'MUEC7812088H9', 'MUEC781208MDFXSR08', '1', None, 'caris_78@hotmail.com', '44204049', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'CUAUHTÉMOC DF', 'DF', 'Mexico', '06800', '0', None, None, None, '30010178595', 'SI000011019', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '30-Jan-15', '23-Jan-15', '23-Jan-15', '23-Jan-15', '0', None, '23-Jan-15', '23-Jan-15', '23-Jan-15', '23-Jan-15', '23-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP029', '1', 'DEPARTAMENTO', 'ALVD029', 'ALV0BD33010', None, None, '0B', '3', '301', None, '1', '0', 'ALV 3.1-C', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado, Balcón.', None, None, '2', None, '1', '1', '13.32', None, '3.8', '2.45', None, None, None, '49.47', '0', '0', '2.55', None, '0', '52.02', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,328,071.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00079091', 'CLARA ELIZABETH AGUILAR PEREZ', 'CLARA ELIZABETH', 'AGUILAR', 'PEREZ', 'AUPC8401161J1', 'AUPC840116MDFLRL', '1', None, 'basebal22@yahoo.com.mx', '67897025', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '54194', '0', None, None, None, '30010177407', 'SI000010749', None, '945059.33000', '945060.33000', '.00000', '.00000', '945060.33000', '.00000', '.00000', '79384.99000', '.00000', '-10000.00000', '1014445.32000', '1-Jan-00', '30-Jan-15', '8-Jan-15', '8-Jan-15', '8-Jan-15', '0', None, '8-Jan-15', '8-Jan-15', '8-Jan-15', '8-Jan-15', '8-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP029', '2', 'ESTACIONAMIENTO', 'ALVE083', 'ALVGDEB0870', None, None, None, None, '087', None, '1', '0', 'EST GDEB', 'Cajón grande, adelante doble, arriba con eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Adelante doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00079091', 'CLARA ELIZABETH AGUILAR PEREZ', 'CLARA ELIZABETH', 'AGUILAR', 'PEREZ', 'AUPC8401161J1', 'AUPC840116MDFLRL', '1', None, 'basebal22@yahoo.com.mx', '67897025', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '54194', '0', None, None, None, '30010177407', 'SI000010750', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '30-Jan-15', '8-Jan-15', '8-Jan-15', '8-Jan-15', '0', None, '8-Jan-15', '8-Jan-15', '8-Jan-15', '8-Jan-15', '8-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP034', '1', 'DEPARTAMENTO', 'ALVD034', 'ALV0BD44020', None, None, '0B', '4', '402', None, '1', '0', 'ALV 3.2-C', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado, Balcón.', None, None, '2', None, '1', '1', '13.4', None, '3.8', '2.15', None, None, None, '50.88', '0', '0', '2.61', None, '0', '53.49', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,323,879.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00079094', 'FRANCISCO CARLOS REYNA  MARTINEZ', 'FRANCISCO CARLOS', 'REYNA', 'MARTINEZ', 'REMF781203TW5', 'REMF781203HDFYRR00', '1', None, 'carlosreyna15@hotmail.com', '56998239', '10848161', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'ECATEPEC MORELOS MEX', 'MEX', 'Mexico', '55310', '0', None, None, None, '30010177035', 'SI000010607', None, '999375.00000', '999376.00000', '.00000', '.00000', '999376.00000', '.00000', '.00000', '86346.01000', '.00000', '-10000.00000', '1075722.01000', '1-Jan-00', '30-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', '0', None, '5-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP034', '2', 'ESTACIONAMIENTO', 'ALVE074', 'ALVGDEA0870', None, None, None, None, '087', None, '1', '0', 'EST GDEA', 'Cajón grande, adelante doble, abajo con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Adelante doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00079094', 'FRANCISCO CARLOS REYNA  MARTINEZ', 'FRANCISCO CARLOS', 'REYNA', 'MARTINEZ', 'REMF781203TW5', 'REMF781203HDFYRR00', '1', None, 'carlosreyna15@hotmail.com', '56998239', '10848161', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'ECATEPEC MORELOS MEX', 'MEX', 'Mexico', '55310', '0', None, None, None, '30010177035', 'SI000010615', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '30-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', '0', None, '5-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP155', '1', 'DEPARTAMENTO', 'ALVD155', 'ALV0ED33020', None, None, '0E', '3', '302', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,144,095.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00079160', 'SONIA BELTRAN SANCHEZ', 'SONIA', 'BELTRAN', 'SANCHEZ', 'BESS6203193X7', 'BESS620319MDFLNN08', '1', None, 'sooniabeltrans@hotmail.com', '29004115', '58042800', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02950', '0', None, None, None, '30010177688', 'SI000010541', None, '825756.29000', '825757.29000', '.00000', '.00000', '825757.29000', '.00000', '.00000', '66060.51000', '.00000', '-240992.00000', '650825.80000', '1-Jan-00', '30-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '0', None, '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP155', '2', 'ESTACIONAMIENTO', 'ALVE075', 'ALVGDEB0300', None, None, None, None, '030', None, '1', '0', 'EST GDEB', 'Cajón grande, adelante doble, arriba con eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Adelante doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00079160', 'SONIA BELTRAN SANCHEZ', 'SONIA', 'BELTRAN', 'SANCHEZ', 'BESS6203193X7', 'BESS620319MDFLNN08', '1', None, 'sooniabeltrans@hotmail.com', '29004115', '58042800', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02950', '0', None, None, None, '30010177688', 'SI000010551', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '30-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '0', None, '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP154', '1', 'DEPARTAMENTO', 'ALVD154', 'ALV0ED33010', None, None, '0E', '3', '301', None, '1', '0', 'ALV 1.2', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '16.63', None, None, '2.28', None, None, None, '49.09', '0', '0', '0', None, '0', '49.09', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,282,483.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00079220', 'FERNANDO AUGUSTO MAGAÑA CASTILLO', 'FERNANDO AUGUSTO', 'MAGAÑA', 'CASTILLO', 'MACF7804279QA', 'MACF780427HDFGSR01', '1', None, 'fernando@shadow.mx', '5515215417', '5528898137', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07840', '0', None, None, None, '30010178009', 'SI000010665', None, '931243.75000', '931244.75000', '.00000', '.00000', '931244.75000', '.00000', '.00000', '77479.49000', '.00000', '-10000.00000', '998724.24000', '1-Jan-00', '30-Jan-15', '6-Jan-15', '6-Jan-15', '6-Jan-15', '0', None, '6-Jan-15', '6-Jan-15', '6-Jan-15', '6-Jan-15', '6-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP154', '2', 'ESTACIONAMIENTO', 'ALVE087', 'ALVGEEA0400', None, None, None, None, '040', None, '1', '0', 'EST GEEA', 'Cajón grande, atras doble, abajo con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Atrás doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00079220', 'FERNANDO AUGUSTO MAGAÑA CASTILLO', 'FERNANDO AUGUSTO', 'MAGAÑA', 'CASTILLO', 'MACF7804279QA', 'MACF780427HDFGSR01', '1', None, 'fernando@shadow.mx', '5515215417', '5528898137', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07840', '0', None, None, None, '30010178009', 'SI000010667', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '30-Jan-15', '6-Jan-15', '6-Jan-15', '6-Jan-15', '0', None, '6-Jan-15', '6-Jan-15', '6-Jan-15', '6-Jan-15', '6-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP035', '1', 'DEPARTAMENTO', 'ALVD035', 'ALV0BD44030', None, None, '0B', '4', '403', None, '1', '0', 'ALV 3.3', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '13.4', None, '3.8', '2.15', None, None, None, '45.16', '0', '0', '0', None, '0', '45.16', None, None, '0', None, None, None, None, None, '0', '1', '1', '997,563.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00079261', 'EDGAR ANDREY PEÑAFLOR MARTINEZ', 'EDGAR ANDREY', 'PEÑAFLOR', 'MARTINEZ', 'PEME780814CD9', 'PEME780814HDFXRD08', '1', None, 'andrey120@aol.com', '17932016', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07730', '0', None, None, None, '30010177514', 'SI000010902', None, '753042.95000', '753042.95000', '.00000', '.00000', '753042.95000', '.00000', '.00000', '52713.00000', '.00000', '-125091.00000', '680664.95000', '1-Jan-00', '30-Jan-15', '21-Jan-15', '21-Jan-15', '21-Jan-15', '0', None, '21-Jan-15', '21-Jan-15', '21-Jan-15', '21-Jan-15', '21-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP036', '1', 'DEPARTAMENTO', 'ALVD036', 'ALV0BD44040', None, None, '0B', '4', '404', None, '1', '0', 'ALV 4', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '13.52', None, '3.72', '2.02', None, None, None, '44.27', '0', '0', '0', None, '0', '44.27', None, None, '0', None, None, None, None, None, '0', '1', '1', '977,904.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00079289', 'ALAN PLANELLS GOMEZ', 'ALAN', 'PLANELLS', 'GOMEZ', 'PAGA700219N72', 'PAGA700219HDFLML02', '0', 'H', 'j.n.316@hotmail.com', '57393391', '56668580', None, '11907053927', '19-Feb-70', 'CASADO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '1', 'Impresos', 'ACUEDUCTO DE GUADALUPE', '211', '46', 'ZONA RES ACUEDUCTO DE GUADALUPE', 'GUSTAVO A. MADERO DF', 'DF', 'MEXICO', '07279', '0', 'EMPLEADO', '1277115178', 'IFE', '30010177878', '0002300', None, '782865.00000', '782865.00000', '.00000', '.00000', '782865.00000', '.00000', '.00000', '68892.08000', '.00000', '-10000.00000', '841757.08000', '1-Jan-00', '5-Mar-15', '25-Feb-15', '25-Feb-15', '25-Feb-15', '12', None, '27-Feb-15', '27-Feb-15', '27-Feb-15', '13-Mar-15', '13-Mar-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP157', '1', 'DEPARTAMENTO', 'ALVD157', 'ALV0ED33040', None, None, '0E', '3', '304', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,144,095.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00079383', 'CRISTIAN ALDANA ZARATE', 'CRISTIAN', 'ALDANA', 'ZARATE', 'AAZC820217542', 'AAZC820217HDFLRR03', '1', None, 'cristianaldana@hotmail.com', '5539778639', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07840', '0', None, None, None, '30010178348', 'SI000010756', None, '830756.26000', '830757.26000', '.00000', '.00000', '830757.26000', '.00000', '.00000', '66460.51000', '.00000', '-38304.30000', '858913.47000', '1-Jan-00', '30-Jan-15', '12-Jan-15', '12-Jan-15', '12-Jan-15', '0', None, '12-Jan-15', '12-Jan-15', '12-Jan-15', '12-Jan-15', '12-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP157', '2', 'ESTACIONAMIENTO', 'ALVE077', 'ALVGDEB0370', None, None, None, None, '037', None, '1', '0', 'EST GDEB', 'Cajón grande, adelante doble, arriba con eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Adelante doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00079383', 'CRISTIAN ALDANA ZARATE', 'CRISTIAN', 'ALDANA', 'ZARATE', 'AAZC820217542', 'AAZC820217HDFLRR03', '1', None, 'cristianaldana@hotmail.com', '5539778639', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07840', '0', None, None, None, '30010178348', 'SI000010758', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '30-Jan-15', '12-Jan-15', '12-Jan-15', '12-Jan-15', '0', None, '12-Jan-15', '12-Jan-15', '12-Jan-15', '12-Jan-15', '12-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP021', '1', 'DEPARTAMENTO', 'ALVD021', 'ALV0BD11010', None, None, '0B', '1', '101', None, '1', '0', 'ALV 3.1-C', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado, Balcón.', None, None, '2', None, '1', '1', '13.32', None, '3.8', '2.45', None, None, None, '49.47', '0', '0', '2.55', None, '0', '52.02', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,407,894.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00079386', 'IRMA BEATRIZ ALFARO ORTEGA', 'IRMA BEATRIZ', 'ALFARO', 'ORTEGA', 'AAOI710113LI4', 'AAOI710113MDFLRR03', '1', None, 'betoven_md@hotmail.com', '57578747', '57473500', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07530', '0', None, None, None, '30010178975', 'SI000010772', None, '1022307.75000', '1022308.75000', '.00000', '.00000', '1022308.75000', '.00000', '.00000', '88328.39000', '.00000', '-10000.00000', '1100637.14000', '1-Jan-00', '30-Jan-15', '13-Jan-15', '13-Jan-15', '13-Jan-15', '0', None, '13-Jan-15', '13-Jan-15', '13-Jan-15', '13-Jan-15', '13-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP021', '2', 'ESTACIONAMIENTO', 'ALVE030', 'ALVCDEX0850', None, None, None, None, '085', None, '1', '0', 'EST CDEX', 'Cajón chico, adelante doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00079386', 'IRMA BEATRIZ ALFARO ORTEGA', 'IRMA BEATRIZ', 'ALFARO', 'ORTEGA', 'AAOI710113LI4', 'AAOI710113MDFLRR03', '1', None, 'betoven_md@hotmail.com', '57578747', '57473500', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07530', '0', None, None, None, '30010178975', 'SI000010773', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '30-Jan-15', '13-Jan-15', '13-Jan-15', '13-Jan-15', '0', None, '13-Jan-15', '13-Jan-15', '13-Jan-15', '13-Jan-15', '13-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP142', '1', 'DEPARTAMENTO', 'ALVD142', 'ALV0ED11050', None, None, '0E', '1', '105', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,199,327.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00079559', 'ANGEL EMMANUEL OLIVARES ANDRADE', 'ANGEL EMMANUEL', 'OLIVARES', 'ANDRADE', 'OIAA831215GQ8', 'OIAA831215HDFLNN19', '1', None, 'dremmanuel08@hotmail.com', '53685231', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '02300', '0', None, None, None, '30010178504', 'SI000010906', None, '870861.75000', '870862.75000', '.00000', '.00000', '870862.75000', '.00000', '.00000', '86215.23000', '.00000', '-74302.00000', '882775.98000', '1-Jan-00', '30-Jan-15', '20-Jan-15', '20-Jan-15', '20-Jan-15', '0', None, '20-Jan-15', '20-Jan-15', '20-Jan-15', '20-Jan-15', '20-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP142', '2', 'ESTACIONAMIENTO', 'ALVE068', 'ALVGDEA0370', None, None, None, None, '037', None, '1', '0', 'EST GDEA', 'Cajón grande, adelante doble, abajo con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Adelante doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00079559', 'ANGEL EMMANUEL OLIVARES ANDRADE', 'ANGEL EMMANUEL', 'OLIVARES', 'ANDRADE', 'OIAA831215GQ8', 'OIAA831215HDFLNN19', '1', None, 'dremmanuel08@hotmail.com', '53685231', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '02300', '0', None, None, None, '30010178504', 'SI000011020', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '30-Jan-15', '20-Jan-15', '20-Jan-15', '20-Jan-15', '0', None, '20-Jan-15', '20-Jan-15', '20-Jan-15', '20-Jan-15', '20-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP141', '1', 'DEPARTAMENTO', 'ALVD141', 'ALV0ED11040', None, None, '0E', '1', '104', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,199,327.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00079564', 'CHRISTOPHER VARGAS QUEZADAS', 'CHRISTOPHER', 'VARGAS', 'QUEZADAS', 'VAQC800310628', 'VAQC800310HDFRZH05', '1', None, 'quezadas69@hotmail.com', '53481051', '57546627', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'NAUCALPAN JUÁREZ MEX', 'MEX', 'Mexico', '53228', '0', None, None, None, '30010179601', 'SI000010905', None, '914405.00000', '914406.00000', '.00000', '.00000', '914406.00000', '.00000', '.00000', '73152.40000', '.00000', '-58000.00000', '929558.40000', '1-Jan-00', '30-Jan-15', '22-Jan-15', '22-Jan-15', '22-Jan-15', '0', None, '22-Jan-15', '22-Jan-15', '22-Jan-15', '22-Jan-15', '22-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP141', '2', 'ESTACIONAMIENTO', 'ALVE067', 'ALVGDEA0320', None, None, None, None, '032', None, '1', '0', 'EST GDEA', 'Cajón grande, adelante doble, abajo con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Adelante doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00079564', 'CHRISTOPHER VARGAS QUEZADAS', 'CHRISTOPHER', 'VARGAS', 'QUEZADAS', 'VAQC800310628', 'VAQC800310HDFRZH05', '1', None, 'quezadas69@hotmail.com', '53481051', '57546627', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'NAUCALPAN JUÁREZ MEX', 'MEX', 'Mexico', '53228', '0', None, None, None, '30010179601', 'SI000011017', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '30-Jan-15', '22-Jan-15', '22-Jan-15', '22-Jan-15', '0', None, '22-Jan-15', '22-Jan-15', '22-Jan-15', '22-Jan-15', '22-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP040', '1', 'DEPARTAMENTO', 'ALVD040', 'ALV0BD55040', None, None, '0B', '5', '504', None, '1', '0', 'ALV 4', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '13.52', None, '3.72', '2.02', None, None, None, '44.27', '0', '0', '0', None, '0', '44.27', None, None, '0', None, None, None, None, None, '0', '1', '1', '966,174.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00079567', 'ALETHIA BERENICE PEÑAFLOR MARTINEZ', 'ALETHIA BERENICE', 'PEÑAFLOR', 'MARTINEZ', 'PEMA861014NP5', 'PEMA861014MMCXRL07', '1', None, 'ale_bpm@hotmail.com', '4158164857', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, None, None, 'Mexico', None, '0', None, None, None, '30010178546', 'SI000011152', None, '729348.21000', '729348.21000', '.00000', '.00000', '729348.21000', '.00000', '.00000', '65641.34000', '.00000', '-133002.68000', '661986.87000', '1-Jan-00', '30-Jan-15', '3-Feb-15', '3-Feb-15', '3-Feb-15', '0', None, '3-Feb-15', '3-Feb-15', '3-Feb-15', '3-Feb-15', '3-Feb-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP158', '1', 'DEPARTAMENTO', 'ALVD158', 'ALV0ED33050', None, None, '0E', '3', '305', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,144,095.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00079760', 'ISAAC OCAMPO MENA', 'ISAAC', 'OCAMPO', 'MENA', 'OAMI8303034X5', 'OAMI830303HDFCNS01', '1', None, 'zack8303@gmail.com', '27512070', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'AZCAPOTZALCO DF', 'DF', 'Mexico', '54090', '0', None, None, None, '30010179221', 'SI000010912', None, '830239.69000', '830240.69000', '.00000', '.00000', '830240.69000', '.00000', '.00000', '73106.55000', '.00000', '-46975.50000', '856371.74000', '1-Jan-00', '30-Jan-15', '20-Jan-15', '20-Jan-15', '20-Jan-15', '0', None, '20-Jan-15', '20-Jan-15', '20-Jan-15', '20-Jan-15', '20-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP158', '2', 'ESTACIONAMIENTO', 'ALVE078', 'ALVGDEB0390', None, None, None, None, '039', None, '1', '0', 'EST GDEB', 'Cajón grande, adelante doble, arriba con eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Adelante doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00079760', 'ISAAC OCAMPO MENA', 'ISAAC', 'OCAMPO', 'MENA', 'OAMI8303034X5', 'OAMI830303HDFCNS01', '1', None, 'zack8303@gmail.com', '27512070', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'AZCAPOTZALCO DF', 'DF', 'Mexico', '54090', '0', None, None, None, '30010179221', 'SI000011022', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '30-Jan-15', '20-Jan-15', '20-Jan-15', '20-Jan-15', '0', None, '20-Jan-15', '20-Jan-15', '20-Jan-15', '20-Jan-15', '20-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP146', '1', 'DEPARTAMENTO', 'ALVD146', 'ALV0ED22010', None, None, '0E', '2', '201', None, '1', '0', 'ALV 1.2', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '16.63', None, None, '2.28', None, None, None, '49.09', '0', '0', '0', None, '0', '49.09', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,309,921.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00079879', 'IGNACIO ELIZALDE MARTINEZ', 'IGNACIO', 'ELIZALDE', 'MARTINEZ', 'EIMI770731MY8', 'EIMI770731HHGLRG09', '1', None, 'ielizalde@gmail.com', '63058457', '57296000 ext526', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PEDREGAL DE STO DOMINGO', 'DF', 'DF', 'Mexico', '04369', '0', None, None, None, '30010182191', 'SI000011159', None, '998725.04000', '998726.04000', '.00000', '.00000', '998726.04000', '.00000', '.00000', '89885.25000', '.00000', '-200995.92000', '887615.37000', '1-Jan-00', '22-Feb-15', '10-Feb-15', '10-Feb-15', '10-Feb-15', '0', None, '10-Feb-15', '10-Feb-15', '10-Feb-15', '10-Feb-15', '10-Feb-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP146', '2', 'ESTACIONAMIENTO', 'ALVE040', 'ALVCEEX0210', None, None, None, None, '021', None, '1', '0', 'EST CEEX', 'Cajón chico, atrás doble., abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00079879', 'IGNACIO ELIZALDE MARTINEZ', 'IGNACIO', 'ELIZALDE', 'MARTINEZ', 'EIMI770731MY8', 'EIMI770731HHGLRG09', '1', None, 'ielizalde@gmail.com', '63058457', '57296000 ext526', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PEDREGAL DE STO DOMINGO', 'DF', 'DF', 'Mexico', '04369', '0', None, None, None, '30010182191', 'SI000011266', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '22-Feb-15', '10-Feb-15', '10-Feb-15', '10-Feb-15', '0', None, '10-Feb-15', '10-Feb-15', '10-Feb-15', '10-Feb-15', '10-Feb-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP168', '1', 'DEPARTAMENTO', 'ALVD168', 'ALV0ED44070', None, None, '0E', '4', '407', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '0', '1', '1', '967,301.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00079953', 'MARIA ZAUCENA SOTO GOMEZ', 'MARIA ZAUCENA', 'SOTO', 'GOMEZ', 'SOGZ7503105R9', None, '1', None, None, None, None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'GUSTAVO A MADERO', None, 'Mexico', None, '0', None, None, None, '30010180641', 'SI000011161', None, '737501.00000', '737501.00000', '.00000', '.00000', '737501.00000', '.00000', '.00000', '59000.08000', '.00000', '-16309.98000', '780191.10000', '1-Jan-00', '12-Mar-15', '3-Feb-15', '3-Feb-15', '3-Feb-15', '0', None, '3-Feb-15', '3-Feb-15', '3-Feb-15', '3-Feb-15', '3-Feb-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP041', '1', 'DEPARTAMENTO', 'ALVD041', 'ALV0CD00010', None, None, '0C', '0', '001', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,187,098.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00080021', 'HEIDI NOPAL GUERRERO', 'HEIDI', 'NOPAL', 'GUERRERO', 'NOGH7409171X1', 'NOGH740917MOCPRD04', '0', 'M', 'alonsitodepollo@yahoo.com.mx', '53030267', '55384056', '53030392', None, '12-Sep-74', 'CASADO', 'BIENES SEPARADOS', 'MEXICANA', 'OAXACA', None, '15', 'Tu casa total.com', 'AVE LAZARO CARDENAS', 'N 10', '0', 'DEL BOSQUE', 'DF', 'DF', 'MEXICO', '07200', '12', 'PROFESORA', '0916095240964', 'IFE', '30020103724', '0002580', None, '1097638.30000', '1097639.30000', '.00000', '.00000', '1097639.30000', '.00000', '.00000', '98787.54000', '.00000', '-22992.00000', '1173434.84000', '1-Jan-00', '28-Mar-15', '30-Mar-15', '28-Mar-15', '30-Mar-15', '12', None, '1-Apr-15', '1-Apr-15', '1-Apr-15', '9-Apr-15', '9-Apr-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP041', '2', 'ESTACIONAMIENTO', 'ALVE097', 'ALVGEEA0780', None, None, None, None, '078', None, '1', '0', 'EST GEEA', 'Cajón grande, atras doble, abajo con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Atrás doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00080021', 'HEIDI NOPAL GUERRERO', 'HEIDI', 'NOPAL', 'GUERRERO', 'NOGH7409171X1', 'NOGH740917MOCPRD04', '0', 'M', 'alonsitodepollo@yahoo.com.mx', '53030267', '55384056', '53030392', None, '12-Sep-74', 'CASADO', 'BIENES SEPARADOS', 'MEXICANA', 'OAXACA', None, '15', 'Tu casa total.com', 'AVE LAZARO CARDENAS', 'N 10', '0', 'DEL BOSQUE', 'DF', 'DF', 'MEXICO', '07200', '12', 'PROFESORA', '0916095240964', 'IFE', '30020103724', '0002580', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '28-Mar-15', '30-Mar-15', '28-Mar-15', '30-Mar-15', '12', None, '1-Apr-15', '1-Apr-15', '1-Apr-15', '9-Apr-15', '9-Apr-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP151', '1', 'DEPARTAMENTO', 'ALVD151', 'ALV0ED22060', None, None, '0E', '2', '206', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,174,390.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00080053', 'AARÓN SALAZAR PÉREZ', 'AARÓN', 'SALAZAR', 'PÉREZ', 'SAPA8710179Z5', 'SAPA871017HMCLRR01', '1', None, 'ingaaron.ri0610@gmail.com', None, None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'COL BENITO JUAREZ SECCION 2', None, 'Mexico', None, '0', None, None, None, '30010180427', 'SI000010909', None, '895392.00000', '895393.00000', '.00000', '.00000', '895393.00000', '.00000', '.00000', '78794.50000', '.00000', '-10000.00000', '964187.50000', '1-Jan-00', '12-Mar-15', '28-Jan-15', '28-Jan-15', '28-Jan-15', '0', None, '28-Jan-15', '28-Jan-15', '28-Jan-15', '28-Jan-15', '28-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP151', '2', 'ESTACIONAMIENTO', 'ALVE084', 'ALVGEEA0310', None, None, None, None, '031', None, '1', '0', 'EST GEEA', 'Cajón grande, atras doble, abajo con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Atrás doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00080053', 'AARÓN SALAZAR PÉREZ', 'AARÓN', 'SALAZAR', 'PÉREZ', 'SAPA8710179Z5', 'SAPA871017HMCLRR01', '1', None, 'ingaaron.ri0610@gmail.com', None, None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'COL BENITO JUAREZ SECCION 2', None, 'Mexico', None, '0', None, None, None, '30010180427', 'SI000011015', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '12-Mar-15', '28-Jan-15', '28-Jan-15', '28-Jan-15', '0', None, '28-Jan-15', '28-Jan-15', '28-Jan-15', '28-Jan-15', '28-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP031', '1', 'DEPARTAMENTO', 'ALVD031', 'ALV0BD33030', None, None, '0B', '3', '303', None, '1', '0', 'ALV 3.3', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '13.4', None, '3.8', '2.15', None, None, None, '45.16', '0', '0', '0', None, '0', '45.16', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,049,508.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00080425', 'FLORENTINO HERNÁNDEZ HERNÁNDEZ', 'FLORENTINO', 'HERNÁNDEZ', 'HERNÁNDEZ', 'HEHF8010055M7', 'HEHF801005HDFRRL16', '1', None, 'tinoh67@hotmail.com', None, None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'ECATEPEC DE MORELOS', None, 'Mexico', None, '0', None, None, None, '30010181748', 'SI000011151', None, '800178.97000', '800178.97000', '.00000', '.00000', '800178.97000', '.00000', '.00000', '67215.04000', '.00000', '-26320.72000', '841073.29000', '1-Jan-00', '12-Mar-15', '4-Feb-15', '4-Feb-15', '4-Feb-15', '0', None, '4-Feb-15', '4-Feb-15', '4-Feb-15', '4-Feb-15', '4-Feb-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP169', '1', 'DEPARTAMENTO', 'ALVD169', 'ALV0ED44080', None, None, '0E', '4', '408', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '0', '1', '1', '967,301.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00080439', 'ARMANDO JUAREZ SANCHEZ', 'ARMANDO', 'JUAREZ', 'SANCHEZ', 'JUSA651209GE2', 'JUSA651209HDFRNR00', '1', None, 'arjusa@yahoo.com.mx', '7101239', '52246382', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'RESIDENCIAL SAN ANTONIO', 'HGO', 'HGO', 'Mexico', '42111', '0', None, None, None, '30010182571', 'SI000011162', None, '737501.00000', '737501.00000', '.00000', '.00000', '737501.00000', '.00000', '.00000', '63720.09000', '.00000', '-10000.00000', '791221.09000', '1-Jan-00', '22-Feb-15', '9-Feb-15', '9-Feb-15', '9-Feb-15', '0', None, '9-Feb-15', '9-Feb-15', '9-Feb-15', '9-Feb-15', '9-Feb-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP143', '1', 'DEPARTAMENTO', 'ALVD143', 'ALV0ED11060', None, None, '0E', '1', '106', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,199,327.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00080476', 'ALEJO BARRON MARTINEZ', 'ALEJO', 'BARRON', 'MARTINEZ', 'BAMA590701R57', 'BAMA590701HDFRRL05', '1', None, 'alejobarron@outlook.es', None, None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'GUSTAVO A MADERO', None, 'Mexico', None, '0', None, None, None, '30010181961', 'SI000011158', None, '914405.00000', '914406.00000', '.00000', '.00000', '914406.00000', '.00000', '.00000', '85589.31000', '.00000', '-32410.80000', '967584.51000', '1-Jan-00', '12-Mar-15', '4-Feb-15', '4-Feb-15', '4-Feb-15', '0', None, '4-Feb-15', '4-Feb-15', '4-Feb-15', '4-Feb-15', '4-Feb-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP143', '2', 'ESTACIONAMIENTO', 'ALVE069', 'ALVGDEA0390', None, None, None, None, '039', None, '1', '0', 'EST GDEA', 'Cajón grande, adelante doble, abajo con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Adelante doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00080476', 'ALEJO BARRON MARTINEZ', 'ALEJO', 'BARRON', 'MARTINEZ', 'BAMA590701R57', 'BAMA590701HDFRRL05', '1', None, 'alejobarron@outlook.es', None, None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'GUSTAVO A MADERO', None, 'Mexico', None, '0', None, None, None, '30010181961', 'SI000011270', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '12-Mar-15', '4-Feb-15', '4-Feb-15', '4-Feb-15', '0', None, '4-Feb-15', '4-Feb-15', '4-Feb-15', '4-Feb-15', '4-Feb-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP171', '1', 'DEPARTAMENTO', 'ALVD171', 'ALV0ED55020', None, None, '0E', '5', '502', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '0', '1', '1', '955,699.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00080540', 'GABRIELA VERONICA SOTO RUIZ', 'GABRIELA VERONICA', 'SOTO', 'RUIZ', 'SORG7702085B8', 'SORG770208MDFTZB08', '1', None, 'liguitos26@hotmail.com', None, None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'AZCAPOTZALCO', None, 'Mexico', None, '0', None, None, None, '30010182118', 'SI000011163', None, '728655.00000', '728655.00000', '.00000', '.00000', '728655.00000', '.00000', '.00000', '58292.40000', '.00000', '-90000.00000', '696947.40000', '1-Jan-00', '12-Mar-15', '4-Feb-15', '4-Feb-15', '4-Feb-15', '0', None, '4-Feb-15', '4-Feb-15', '4-Feb-15', '4-Feb-15', '4-Feb-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP133', '1', 'DEPARTAMENTO', 'ALVD133', 'ALV0ED00040', None, None, '0E', '0', '004', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,220,720.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00080673', 'SERGIO OSVALDO LOPEZ DIAZ', 'SERGIO OSVALDO', 'LOPEZ', 'DIAZ', 'LODS860608FD0', 'LODS860608HDFPZR01', '1', None, 'sold666@hotmail.com', '57533736', '52825554', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'CAMPESTRE ARAGON AT', 'DF', 'DF', 'Mexico', '07530', '0', None, None, None, '30010182506', 'SI000011156', None, '930717.00000', '930718.00000', '.00000', '.00000', '930718.00000', '.00000', '.00000', '74457.36000', '.00000', '-39000.00000', '966175.36000', '1-Jan-00', '22-Feb-15', '9-Feb-15', '9-Feb-15', '9-Feb-15', '0', None, '9-Feb-15', '9-Feb-15', '9-Feb-15', '9-Feb-15', '9-Feb-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP133', '2', 'ESTACIONAMIENTO', 'ALVE015', 'ALVCDEX0180', None, None, None, None, '018', None, '1', '0', 'EST CDEX', 'Cajón chico, adelante doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00080673', 'SERGIO OSVALDO LOPEZ DIAZ', 'SERGIO OSVALDO', 'LOPEZ', 'DIAZ', 'LODS860608FD0', 'LODS860608HDFPZR01', '1', None, 'sold666@hotmail.com', '57533736', '52825554', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'CAMPESTRE ARAGON AT', 'DF', 'DF', 'Mexico', '07530', '0', None, None, None, '30010182506', 'SI000011265', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '22-Feb-15', '9-Feb-15', '9-Feb-15', '9-Feb-15', '0', None, '9-Feb-15', '9-Feb-15', '9-Feb-15', '9-Feb-15', '9-Feb-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP067', '1', 'DEPARTAMENTO', 'ALVD067', 'ALV0CD33070', None, None, '0C', '3', '307', None, '1', '0', 'ALV 5-C', 'Estancia, Comedor, 1 Recámara, Alcoba, Baño, Cocina, Cuarto de lavado, Balcón.', None, None, '1', '1', '1', '1', '15.01', None, '3.67', '2.16', None, None, None, '59.11', '0', '0', '1.77', None, '0', '60.88', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,620,422.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00080955', 'VERA CRUZ MANZANO', 'VERA', 'CRUZ', 'MANZANO', 'CUMV771117BK3', None, '1', None, None, '53674799', '30677519', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'U HAB S C T', 'DF', 'DF', 'Mexico', '07700', '0', None, None, None, '30010183546', 'SI000011153', None, '1297237.02000', '1297239.02000', '.00000', '.00000', '1297239.02000', '.00000', '.00000', '103780.96000', '.00000', '-128536.32000', '1272483.66000', '1-Jan-00', '22-Feb-15', '16-Feb-15', '16-Feb-15', '16-Feb-15', '0', None, '16-Feb-15', '16-Feb-15', '16-Feb-15', '16-Feb-15', '16-Feb-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP067', '2', 'ESTACIONAMIENTO', 'ALVE057', 'ALVEEEX0580', None, None, None, None, '058', None, '1', '0', 'EST EEEX', 'Discapacitados compartido, atrás doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '15.5', None, None, None, None, None, None, '3.1', None, '0', None, None, 'Discapacitado Compart', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00080955', 'VERA CRUZ MANZANO', 'VERA', 'CRUZ', 'MANZANO', 'CUMV771117BK3', None, '1', None, None, '53674799', '30677519', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'U HAB S C T', 'DF', 'DF', 'Mexico', '07700', '0', None, None, None, '30010183546', 'SI000011271', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '22-Feb-15', '16-Feb-15', '16-Feb-15', '16-Feb-15', '0', None, '16-Feb-15', '16-Feb-15', '16-Feb-15', '16-Feb-15', '16-Feb-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP067', '3', 'BODEGA', 'ALVB003', 'ALV00BD0030', None, None, None, None, '003', None, '1', '0', 'ALV B 2.34', 'bodega de 2.34 m2', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.34', None, None, None, None, None, None, None, None, '0', None, None, None, None, None, '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00080955', 'VERA CRUZ MANZANO', 'VERA', 'CRUZ', 'MANZANO', 'CUMV771117BK3', None, '1', None, None, '53674799', '30677519', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'U HAB S C T', 'DF', 'DF', 'Mexico', '07700', '0', None, None, None, '30010183546', 'SI000011291', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '22-Feb-15', '16-Feb-15', '16-Feb-15', '16-Feb-15', '0', None, '16-Feb-15', '16-Feb-15', '16-Feb-15', '16-Feb-15', '16-Feb-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP081', '1', 'DEPARTAMENTO', 'ALVD081', 'ALV0CD55070', None, None, '0C', '5', '507', None, '1', '0', 'ALV 5-C', 'Estancia, Comedor, 1 Recámara, Alcoba, Baño, Cocina, Cuarto de lavado, Balcón.', None, None, '1', '1', '1', '1', '15.01', None, '3.67', '2.16', None, None, None, '59.11', '0', '0', '1.77', None, '0', '60.88', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,462,029.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00081124', 'CARLOS EDUARDO PEREZ ROJAS', 'CARLOS EDUARDO', 'PEREZ', 'ROJAS', 'PERC861228GB3', 'PERC861228HDFRJR03', '0', 'H', None, '55857466', None, None, '39108604743', '28-Dec-86', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '4', 'Espectacular', 'CDA AMAPOLA', '16', None, 'EL TANQUE', 'MAGDALENA CONTRERAS', 'DISTRITO FEDERAL', 'MEXICO', '10320', '0', 'EMPLEADO', 'G13907659', 'PASAPORTE', '30010184155', '0002286', None, '1170434.00000', '1170435.00000', '.00000', '.00000', '1170435.00000', '.00000', '.00000', '93634.80000', '.00000', '-52052.50000', '1212017.30000', '23-Feb-15', '23-Feb-15', '24-Feb-15', '24-Feb-15', '24-Feb-15', '12', None, '24-Feb-15', '24-Feb-15', '24-Feb-15', '24-Feb-15', '24-Feb-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP081', '2', 'ESTACIONAMIENTO', 'ALVE118', 'ALVGUEA0010', None, None, None, None, '001', None, '1', '0', 'EST GUEA', 'Cajón grande, único, abajo con eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Único', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00081124', 'CARLOS EDUARDO PEREZ ROJAS', 'CARLOS EDUARDO', 'PEREZ', 'ROJAS', 'PERC861228GB3', 'PERC861228HDFRJR03', '0', 'H', None, '55857466', None, None, '39108604743', '28-Dec-86', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '4', 'Espectacular', 'CDA AMAPOLA', '16', None, 'EL TANQUE', 'MAGDALENA CONTRERAS', 'DISTRITO FEDERAL', 'MEXICO', '10320', '0', 'EMPLEADO', 'G13907659', 'PASAPORTE', '30010184155', '0002286', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '23-Feb-15', '23-Feb-15', '24-Feb-15', '24-Feb-15', '24-Feb-15', '12', None, '24-Feb-15', '24-Feb-15', '24-Feb-15', '24-Feb-15', '24-Feb-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP046', '1', 'DEPARTAMENTO', 'ALVD046', 'ALV0CD00060', None, None, '0C', '0', '006', None, '1', '0', 'ALV 1.1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '13.9', None, '4.11', '2.16', None, None, None, '47.05', '0', '0', '0', None, '0', '47.05', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,298,652.00 ', '10,000.00 ', '0.00 ', '0.00 ', '2-Jun-16', '2-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00081130', 'JORGE LUIS RODRIGUEZ ROJAS', 'JORGE LUIS', 'RODRIGUEZ', 'ROJAS', 'RORJ85121571A', 'RORJ851215HDFDJROO', '0', 'H', None, '5541592135', '5527809856', None, None, '15-Dec-85', 'CASADO', None, 'MEXICANA', 'MEXICO D.F.', None, '11', 'Anuncio en Google', 'AV ART 27 CONSTITUCIONAL', '106', None, 'SAN BARTOLO ATEPEHUACAN', 'GUSTAVO A MADERO', 'MEXICO D.F.', 'MEXICO', '07730', '5', 'LICENCIADO', 'IDMEX1265118576', 'IFE', '30010183371', '0002287', None, '1039640.00000', '1039641.00000', '.00000', '.00000', '1039641.00000', '.00000', '.00000', '72774.87000', '.00000', '-44992.00000', '1067423.87000', '23-Feb-15', '23-Feb-15', '24-Feb-15', '24-Feb-15', '24-Feb-15', '12', None, '24-Feb-15', '24-Feb-15', '24-Feb-15', '24-Feb-15', '24-Feb-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP046', '2', 'ESTACIONAMIENTO', 'ALVE026', 'ALVCDEX0750', None, None, None, None, '075', None, '1', '0', 'EST CDEX', 'Cajón chico, adelante doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00081130', 'JORGE LUIS RODRIGUEZ ROJAS', 'JORGE LUIS', 'RODRIGUEZ', 'ROJAS', 'RORJ85121571A', 'RORJ851215HDFDJROO', '0', 'H', None, '5541592135', '5527809856', None, None, '15-Dec-85', 'CASADO', None, 'MEXICANA', 'MEXICO D.F.', None, '11', 'Anuncio en Google', 'AV ART 27 CONSTITUCIONAL', '106', None, 'SAN BARTOLO ATEPEHUACAN', 'GUSTAVO A MADERO', 'MEXICO D.F.', 'MEXICO', '07730', '5', 'LICENCIADO', 'IDMEX1265118576', 'IFE', '30010183371', '0002287', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '23-Feb-15', '23-Feb-15', '24-Feb-15', '24-Feb-15', '24-Feb-15', '12', None, '24-Feb-15', '24-Feb-15', '24-Feb-15', '24-Feb-15', '24-Feb-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP174', '1', 'DEPARTAMENTO', 'ALVD174', 'ALV0ED55050', None, None, '0E', '5', '505', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '0', '1', '1', '955,699.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00081148', 'TANIA ROSALES ORTEGA', 'TANIA', 'ROSALES', 'ORTEGA', 'ROOT8608277D4', 'ROOT860827MDFSRN07', '0', 'M', None, '63056007', '5540810038', None, None, '27-Aug-86', 'UNION LIBRE', None, 'MEXICANA', 'MEXICO DF', None, '3', 'Gallardete', 'ANDADOR 46', '33', 'C 305', 'ACUEDUCTO DE GUADALUPE', 'GUSTAVO A. MADERO', 'DISTRITO FEDERAL', 'MEXICO', '07279', '0', 'TRADUCTORA', '0959099787459', 'IFE', '30010184668', '0002031', None, '760088.00000', '760088.00000', '.00000', '.00000', '760088.00000', '.00000', '.00000', '75248.71000', '.00000', '-29771.20000', '805565.51000', '26-Feb-15', '26-Feb-15', '3-Mar-15', '3-Mar-15', '3-Mar-15', '12', None, '3-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP079', '1', 'DEPARTAMENTO', 'ALVD079', 'ALV0CD55050', None, None, '0C', '5', '505', None, '1', '0', 'ALV 1.1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '13.9', None, '4.11', '2.16', None, None, None, '47.05', '0', '0', '0', None, '0', '47.05', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,163,092.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00081167', 'MARA PERLA PEREZ RIVERA', 'MARA PERLA', 'PEREZ', 'RIVERA', 'PERM770226FH9', 'PERM770226MDFRVR02', '0', 'M', None, '5522070017', '5513737817', '5541151642', '39967752211', '26-Feb-77', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '4', 'Espectacular', 'CDA 2DA DE ANGEL BRIOSO VASC', '6', None, 'PALMATITLA', 'GUSTAVO A MADERO', 'DISTRITO FEDERAL', 'MEXICO', '07170', '5', 'EMPLEADO', 'X', 'IFE', '30010183835', '0002334', None, '977674.00000', '977675.00000', '.00000', '.00000', '977675.00000', '.00000', '.00000', '78214.00000', '.00000', '-10000.00000', '1045889.00000', '27-Feb-15', '27-Feb-15', '6-Mar-15', '6-Mar-15', '4-Mar-15', '12', None, '9-Mar-15', '9-Mar-15', '9-Mar-15', '13-Mar-15', '13-Mar-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP079', '2', 'ESTACIONAMIENTO', 'ALVE091', 'ALVGEEA0640', None, None, None, None, '064', None, '1', '0', 'EST GEEA', 'Cajón grande, atras doble, abajo con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Atrás doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00081167', 'MARA PERLA PEREZ RIVERA', 'MARA PERLA', 'PEREZ', 'RIVERA', 'PERM770226FH9', 'PERM770226MDFRVR02', '0', 'M', None, '5522070017', '5513737817', '5541151642', '39967752211', '26-Feb-77', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '4', 'Espectacular', 'CDA 2DA DE ANGEL BRIOSO VASC', '6', None, 'PALMATITLA', 'GUSTAVO A MADERO', 'DISTRITO FEDERAL', 'MEXICO', '07170', '5', 'EMPLEADO', 'X', 'IFE', '30010183835', '0002334', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '27-Feb-15', '27-Feb-15', '6-Mar-15', '6-Mar-15', '4-Mar-15', '12', None, '9-Mar-15', '9-Mar-15', '9-Mar-15', '13-Mar-15', '13-Mar-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP167', '1', 'DEPARTAMENTO', 'ALVD167', 'ALV0ED44060', None, None, '0E', '4', '406', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '0', '1', '1', '967,301.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00081230', 'ALDO ALBERTO MORENO SUAZO', 'ALDO ALBERTO', 'MORENO', 'SUAZO', 'MOSA8503053P5', 'MOSA850305HDFRZL06', '0', 'H', 'aams050385@hotmail.com', '22276482', '5536605776', '57296000', None, '5-Mar-85', 'SOLTERO', None, 'MEXICANA', 'MEXICO DF', None, '3', 'Gallardete', 'CLL RIO SAN JAVIER', 'MZ 6', 'LT 8', 'LUIS DONALDO COLOSIO', 'GUSTAVO A MADERO', 'MEXICO DF', 'MEXICO', '07164', '10', 'EMPLEADO', '0853074929631', 'IFE', '30020102676', '0002412', None, '798096.00000', '798096.00000', '.00000', '.00000', '798096.00000', '.00000', '.00000', '71828.64000', '.00000', '-93741.85000', '776182.79000', '1-Mar-15', '30-Mar-15', '20-Mar-15', '20-Mar-15', '24-Mar-15', '12', None, '24-Mar-15', '24-Mar-15', '24-Mar-15', '30-Mar-15', '30-Mar-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP028', '1', 'DEPARTAMENTO', 'ALVD028', 'ALV0BD22040', None, None, '0B', '2', '204', None, '1', '0', 'ALV 4', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '13.52', None, '3.72', '2.02', None, None, None, '44.27', '0', '0', '0', None, '0', '44.27', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,044,067.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00081234', 'ANGEL CRUCES ALARCON', 'ANGEL', 'CRUCES', 'ALARCON', 'CUAA590111RL5', 'CUAA590111HDFRLN00', '0', 'H', None, '57666076', '5519309424', '5544645247', None, '11-Jan-59', 'CASADO', None, 'MEXICANA', 'MEXICO DF', None, '9', 'Web', 'CALLE 1515', 'N/A', 'N/A', 'SAN JUAN DE ARAGON', 'GUSTAVO A. MADERO DF', 'MEXICO DF', 'MEXICO', '07548', '10', 'EMPLEADO', '1591111787183', 'IFE', '30010185285', '0002477', None, '796030.00000', '796030.00000', '.00000', '.00000', '796030.00000', '.00000', '.00000', '71642.70000', '.00000', '-9992.00000', '857680.70000', '1-Mar-15', '4-Mar-15', '3-Mar-15', '3-Mar-15', '4-Mar-15', '12', None, '4-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP176', '1', 'DEPARTAMENTO', 'ALVD176', 'ALV0ED55070', None, None, '0E', '5', '507', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '0', '1', '1', '955,699.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00081249', 'MARIA DE LOS ANGELES FERNANDEZ RODRIGUEZ', 'MARIA DE LOS ANGELES', 'FERNANDEZ', 'RODRIGUEZ', 'FERA780409RL5', 'FERA780409MDFRDN09', '0', 'H', None, '53910598', '5513958966', '91324000', '11007805507', '9-Apr-78', 'CASADO', 'BIENES SEPARADOS', 'MEXICANA', 'DISTRITO FEDERAL', None, '3', 'Gallardete', 'DE LA RIA', '55', None, 'FRAC RESIDENCIAL ACDTO GPE', 'FRAC RESIDENCIAL ACDTO GPE', 'DF', 'MEXICO', '7220', '1', 'AUXILARA DE BASE', '1566049819812', 'IFE', '30010183892', '0002319', None, '765088.00000', '765088.00000', '.00000', '.00000', '765088.00000', '.00000', '.00000', '61207.04000', '.00000', '-56633.68000', '769661.36000', '2-Mar-15', '13-Mar-15', '2-Mar-15', '2-Mar-15', '2-Mar-15', '12', None, '13-Mar-15', '13-Mar-15', '13-Mar-15', '13-Mar-15', '13-Mar-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP051', '1', 'DEPARTAMENTO', 'ALVD051', 'ALV0CD11050', None, None, '0C', '1', '105', None, '1', '0', 'ALV 1.1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '13.9', None, '4.11', '2.16', None, None, None, '47.05', '0', '0', '0', None, '0', '47.05', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,298,180.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00081258', 'MYRIAM ESPERANZA GARCIA LOPEZ', 'MYRIAM ESPERANZA', 'GARCIA', 'LOPEZ', 'GALM870911GM5', 'GALM870911MGTRPY08', '0', 'M', 'hopemau@hotmail.com', '55775777', '5532069577', None, '20118703337', '11-Sep-87', 'SOLTERO', None, 'MEXICANA', 'GUANAJUATO', None, '20', 'Zona Prop', 'GAVIOTAS', '57', None, 'GRANJAS MODERNAS', 'GUSTAVO A. MADERO', 'DISTRITO FEDERAL', 'MEXICO', '07460', '28', 'LIDER DISCOVERY', '1560105216271', 'IFE', '30010184916', '0002484', None, '1039262.00000', '1039263.00000', '.00000', '.00000', '1039263.00000', '.00000', '.00000', '86466.68000', '.00000', '-18940.06000', '1106789.62000', '2-Mar-15', '2-Mar-15', '2-Mar-15', '2-Mar-15', '3-Mar-15', '12', None, '4-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP051', '2', 'ESTACIONAMIENTO', 'ALVE027', 'ALVCDEX0770', None, None, None, None, '077', None, '1', '0', 'EST CDEX', 'Cajón chico, adelante doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00081258', 'MYRIAM ESPERANZA GARCIA LOPEZ', 'MYRIAM ESPERANZA', 'GARCIA', 'LOPEZ', 'GALM870911GM5', 'GALM870911MGTRPY08', '0', 'M', 'hopemau@hotmail.com', '55775777', '5532069577', None, '20118703337', '11-Sep-87', 'SOLTERO', None, 'MEXICANA', 'GUANAJUATO', None, '20', 'Zona Prop', 'GAVIOTAS', '57', None, 'GRANJAS MODERNAS', 'GUSTAVO A. MADERO', 'DISTRITO FEDERAL', 'MEXICO', '07460', '28', 'LIDER DISCOVERY', '1560105216271', 'IFE', '30010184916', '0002484', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '2-Mar-15', '2-Mar-15', '2-Mar-15', '2-Mar-15', '3-Mar-15', '12', None, '4-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP132', '1', 'DEPARTAMENTO', 'ALVD132', 'ALV0ED00030', None, None, '0E', '0', '003', None, '1', '0', 'ALV 1.3-B', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado, Terraza.', None, None, '2', None, '1', '0', '17.82', None, None, '2.28', None, None, None, '46.03', '0', '11.61', '0', None, '0', '57.64', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,413,008.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00081261', 'CLAUDIA CASIMIRO CORREA', 'CLAUDIA', 'CASIMIRO', 'CORREA', 'CACC860323NR1', 'CACC860323MDFSRL05', '0', 'M', None, '55303537', '5539062129', '52781300', '80138668670', '23-Mar-86', 'SOLTERO', None, 'MEXICANA', 'MEXICO D.F.', None, '3', 'Gallardete', 'DR JIMENEZ', '260', '2', 'DE LOS DOCTORES', 'CUAUHTEMOC', 'DISTRITO FEDERAL', 'MEXICO', '06720', '7', 'ANALISTA', '4787097900992', 'IFE', '30010184874', '0002483', None, '1187750.00000', '1187751.00000', '.00000', '.00000', '1187751.00000', '.00000', '.00000', '106897.59000', '.00000', '-109199.40000', '1185449.19000', '2-Mar-15', '2-Mar-15', '2-Mar-15', '2-Mar-15', '3-Mar-15', '12', None, '4-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP132', '2', 'ESTACIONAMIENTO', 'ALVE046', 'ALVCUEX0340', None, None, None, None, '034', None, '1', '0', 'EST CUEX', 'Cajón chico, único, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Único', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00081261', 'CLAUDIA CASIMIRO CORREA', 'CLAUDIA', 'CASIMIRO', 'CORREA', 'CACC860323NR1', 'CACC860323MDFSRL05', '0', 'M', None, '55303537', '5539062129', '52781300', '80138668670', '23-Mar-86', 'SOLTERO', None, 'MEXICANA', 'MEXICO D.F.', None, '3', 'Gallardete', 'DR JIMENEZ', '260', '2', 'DE LOS DOCTORES', 'CUAUHTEMOC', 'DISTRITO FEDERAL', 'MEXICO', '06720', '7', 'ANALISTA', '4787097900992', 'IFE', '30010184874', '0002483', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '2-Mar-15', '2-Mar-15', '2-Mar-15', '2-Mar-15', '3-Mar-15', '12', None, '4-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP177', '1', 'DEPARTAMENTO', 'ALVD177', 'ALV0ED55080', None, None, '0E', '5', '508', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '0', '1', '1', '955,699.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00081262', 'JORGE ALFONSO CARRILLO DIAZ', 'JORGE ALFONSO', 'CARRILLO', 'DIAZ', 'CADJ691228HT6', 'CADJ691228HTLRZR04', '0', 'H', 'alcarrillodiaz@yahoo.com', '51195399', '5523060273', '5523060273', None, '28-Dec-69', 'SOLTERO', None, 'MEXICANA', 'TLAXCALA', None, '10', 'Buscando en Google', 'AV.ESCUADRON 201', '63 ED 16 PISO 3', '402', 'LA PURISIMA TICOMAN', 'GUSTAVO A. MADERO', 'DISTRITO FEDERAL', 'MEXICO', '07330', '16', 'LICENCIADO', '1039006702863', 'IFE', '30010185715', '0002341', None, '779242.71000', '779242.71000', '.00000', '.00000', '779242.71000', '.00000', '.00000', '54546.99000', '.00000', '-779242.71000', '54546.99000', '2-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', '2-Mar-15', '12', None, '10-Mar-15', '10-Mar-15', '10-Mar-15', '13-Mar-15', '13-Mar-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP052', '1', 'DEPARTAMENTO', 'ALVD052', 'ALV0CD11060', None, None, '0C', '1', '106', None, '1', '0', 'ALV 1.1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '13.9', None, '4.11', '2.16', None, None, None, '47.05', '0', '0', '0', None, '0', '47.05', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,298,180.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00081287', 'TANIA MARIA MURGA ORTEGA', 'TANIA MARIA', 'MURGA', 'ORTEGA', 'MUOT840509LT3', 'MUOT840509MDFRRN09', '0', 'M', 'tania.murga@sherwin.com.mx', '53332933', '5522649674', None, '20078409008', '9-May-84', 'SOLTERO', None, 'MEXICANA', 'MEXICO DF', None, '3', 'Gallardete', 'AV PLAZAS DE ARAGON N 85', 'MZ 12 LT 80 85', 'C1', 'PLAZAS DE ARAGON', 'NEZAHUALCOYOTL', 'MEXICO DF', 'MEXICO', '57139', '20', 'EMPLEADA', '3145096362010', 'IFE', '30010185327', '0002491', None, '1091226.00000', '1091227.00000', '.00000', '.00000', '1091227.00000', '.00000', '.00000', '96027.98000', '.00000', '-10000.00000', '1177254.98000', '2-Mar-15', '2-Mar-15', '3-Mar-15', '2-Mar-15', '3-Mar-15', '12', None, '4-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP052', '2', 'ESTACIONAMIENTO', 'ALVE028', 'ALVCDEX0790', None, None, None, None, '079', None, '1', '0', 'EST CDEX', 'Cajón chico, adelante doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00081287', 'TANIA MARIA MURGA ORTEGA', 'TANIA MARIA', 'MURGA', 'ORTEGA', 'MUOT840509LT3', 'MUOT840509MDFRRN09', '0', 'M', 'tania.murga@sherwin.com.mx', '53332933', '5522649674', None, '20078409008', '9-May-84', 'SOLTERO', None, 'MEXICANA', 'MEXICO DF', None, '3', 'Gallardete', 'AV PLAZAS DE ARAGON N 85', 'MZ 12 LT 80 85', 'C1', 'PLAZAS DE ARAGON', 'NEZAHUALCOYOTL', 'MEXICO DF', 'MEXICO', '57139', '20', 'EMPLEADA', '3145096362010', 'IFE', '30010185327', '0002491', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '2-Mar-15', '2-Mar-15', '3-Mar-15', '2-Mar-15', '3-Mar-15', '12', None, '4-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP032', '1', 'DEPARTAMENTO', 'ALVD032', 'ALV0BD33040', None, None, '0B', '3', '304', None, '1', '0', 'ALV 4', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '13.52', None, '3.72', '2.02', None, None, None, '44.27', '0', '0', '0', None, '0', '44.27', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,028,826.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00081425', 'JORGE HERNANDEZ BUENROSTRO', 'JORGE', 'HERNANDEZ', 'BUENROSTRO', 'HEBJ5608187T9', 'HEBJ560818HDFRNR04', '0', 'H', 'j.hdez.b@gmail.com', '55375998', '5510224983', '5510224983', None, '18-Aug-56', 'CASADO', 'BIENES SEPARADOS', 'MEXICANA', 'DISTRITO FEDERAL', None, '3', 'Gallardete', 'LIDIA', '91', '3', 'GUADALUPE TEPEYAC', 'GUSTAVO A. MADERO', 'DISTRITO FEDERAL', 'MEXICO', '07840', '22', 'EMPLEADO', '1119003150855', 'IFE', '30020103765', '0002381', None, '951294.30000', '951294.30000', '.00000', '.00000', '951294.30000', '.00000', '.00000', '66590.60000', '.00000', '-312822.78000', '705062.12000', '7-Mar-15', '12-Mar-15', '12-Mar-15', '7-Mar-15', '9-Mar-15', '12', None, '18-Mar-15', '20-Mar-15', '20-Mar-15', '30-Mar-15', '30-Mar-15', '5-Mar-15', None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP042', '1', 'DEPARTAMENTO', 'ALVD042', 'ALV0CD00020', None, None, '0C', '0', '002', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,187,098.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00081426', 'MARIA AZUCENA SOTO GOMEZ', 'MARIA AZUCENA', 'SOTO', 'GOMEZ', 'SOGA750310573', 'SOGA750310MMNTMZ07', '0', 'M', 'MASOTOGOMEZ@YAHOO.COM.MX', '5555783787', '0445543636917', '0445531455949', '16127500706', '10-Mar-75', 'SOLTERO', None, 'MEXICANA', 'MICHOACAN', None, '3', 'Gallardete', 'NORTE 20', '5007', '2', 'CAPULTITLAN', 'GUSTAVO A. MADERO', 'DISTRITO FEDERAL', 'MEXICO', '07370', '5', 'MEDICO', '445553593011', 'IFE', '30020103930', '0002712', None, '1097637.30000', '1097638.30000', '.00000', '.00000', '1097638.30000', '.00000', '.00000', '87811.06000', '.00000', '-165570.00000', '1019879.36000', '7-Mar-15', '30-May-15', '25-Apr-15', '7-Mar-15', '18-Mar-15', '12', None, '16-Apr-15', '27-Apr-15', '27-Apr-15', '29-Apr-15', '29-Apr-15', '5-Mar-15', None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP042', '2', 'ESTACIONAMIENTO', 'ALVE098', 'ALVGEEA0800', None, None, None, None, '080', None, '1', '0', 'EST GEEA', 'Cajón grande, atras doble, abajo con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Atrás doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00081426', 'MARIA AZUCENA SOTO GOMEZ', 'MARIA AZUCENA', 'SOTO', 'GOMEZ', 'SOGA750310573', 'SOGA750310MMNTMZ07', '0', 'M', 'MASOTOGOMEZ@YAHOO.COM.MX', '5555783787', '0445543636917', '0445531455949', '16127500706', '10-Mar-75', 'SOLTERO', None, 'MEXICANA', 'MICHOACAN', None, '3', 'Gallardete', 'NORTE 20', '5007', '2', 'CAPULTITLAN', 'GUSTAVO A. MADERO', 'DISTRITO FEDERAL', 'MEXICO', '07370', '5', 'MEDICO', '445553593011', 'IFE', '30020103930', '0002712', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '7-Mar-15', '30-May-15', '25-Apr-15', '7-Mar-15', '18-Mar-15', '12', None, '16-Apr-15', '27-Apr-15', '27-Apr-15', '29-Apr-15', '29-Apr-15', '5-Mar-15', None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP055', '1', 'DEPARTAMENTO', 'ALVD055', 'ALV0CD22020', None, None, '0C', '2', '202', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,148,636.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00081455', 'ESTELA MARGARITA FLORES DE LEON', 'ESTELA MARGARITA', 'FLORES', 'DE LEON', 'FOLE720301JI7', 'FOLE720301MDFLNS02', '0', 'H', 'margarita.flores@ercamate.com.mx', '5557810111', '5522657921', '5515483526', '94947205517', '1-Mar-72', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '3', 'Gallardete', 'CUITLAHUAC', '54', '02', 'STA.  ISABEL TOLA', 'GUSTAVO A MADERO', 'DISTRITO FEDERAL', 'MEXICO', '07010', '14', 'RESPONSABLE LOGISTICA', '1288003772701', 'IFE', '30020107279', '0002530', None, '1062075.30000', '1062076.30000', '.00000', '.00000', '1062076.30000', '.00000', '.00000', '84966.10000', '.00000', '-16790.90000', '1130251.50000', '7-Mar-15', '23-Mar-15', '23-Mar-15', '22-Mar-15', '23-Mar-15', '12', None, '23-Mar-15', '27-Mar-15', '30-Mar-15', '1-Apr-15', '1-Apr-15', '5-Mar-15', None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP055', '2', 'ESTACIONAMIENTO', 'ALVE115', 'ALVGEEB0800', None, None, None, None, '080', None, '1', '0', 'EST GEEB', 'Cajón grande, atras doble, arriba con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Atrás doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00081455', 'ESTELA MARGARITA FLORES DE LEON', 'ESTELA MARGARITA', 'FLORES', 'DE LEON', 'FOLE720301JI7', 'FOLE720301MDFLNS02', '0', 'H', 'margarita.flores@ercamate.com.mx', '5557810111', '5522657921', '5515483526', '94947205517', '1-Mar-72', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '3', 'Gallardete', 'CUITLAHUAC', '54', '02', 'STA.  ISABEL TOLA', 'GUSTAVO A MADERO', 'DISTRITO FEDERAL', 'MEXICO', '07010', '14', 'RESPONSABLE LOGISTICA', '1288003772701', 'IFE', '30020107279', '0002530', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '7-Mar-15', '23-Mar-15', '23-Mar-15', '22-Mar-15', '23-Mar-15', '12', None, '23-Mar-15', '27-Mar-15', '30-Mar-15', '1-Apr-15', '1-Apr-15', '5-Mar-15', None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP059', '1', 'DEPARTAMENTO', 'ALVD059', 'ALV0CD22060', None, None, '0C', '2', '206', None, '1', '0', 'ALV 1.1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '13.9', None, '4.11', '2.16', None, None, None, '47.05', '0', '0', '0', None, '0', '47.05', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,264,149.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00081580', 'VERONICA MADAI RESENDIZ MONTIEL', 'VERONICA MADAI', 'RESENDIZ', 'MONTIEL', 'REMV790624DK5', 'REMV790624MDFSNR01', '0', 'M', 'veronica_resendiz@yahoo.com', None, '5527470866', None, '30017915635', '24-Jun-79', 'SOLTERO', None, 'MEXICANA', 'MEXICO', None, '1', 'Impresos', 'CALZ CHALMA LA VILLA', '50 E 31', '404', 'U HAB ARBOLILLO', 'GOSTAVO A. MADERO', 'DISTRITO FEDERAL', 'MEXICO', '07140', '20', None, '0934049983589', 'IFE', '30020109564', '0002641', None, '1168884.00000', '1168885.00000', '.00000', '.00000', '1168885.00000', '.00000', '.00000', '94738.39000', '.00000', '-27348.13000', '1236275.26000', '13-Mar-15', '7-Apr-15', '7-Apr-15', '30-Mar-15', '30-Mar-15', '12', None, '9-Apr-15', '10-Apr-15', '10-Apr-15', '13-Apr-15', '13-Apr-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP059', '2', 'ESTACIONAMIENTO', 'ALVE072', 'ALVGDEA0610', None, None, None, None, '061', None, '1', '0', 'EST GDEA', 'Cajón grande, adelante doble, abajo con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Adelante doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00081580', 'VERONICA MADAI RESENDIZ MONTIEL', 'VERONICA MADAI', 'RESENDIZ', 'MONTIEL', 'REMV790624DK5', 'REMV790624MDFSNR01', '0', 'M', 'veronica_resendiz@yahoo.com', None, '5527470866', None, '30017915635', '24-Jun-79', 'SOLTERO', None, 'MEXICANA', 'MEXICO', None, '1', 'Impresos', 'CALZ CHALMA LA VILLA', '50 E 31', '404', 'U HAB ARBOLILLO', 'GOSTAVO A. MADERO', 'DISTRITO FEDERAL', 'MEXICO', '07140', '20', None, '0934049983589', 'IFE', '30020109564', '0002641', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '13-Mar-15', '7-Apr-15', '7-Apr-15', '30-Mar-15', '30-Mar-15', '12', None, '9-Apr-15', '10-Apr-15', '10-Apr-15', '13-Apr-15', '13-Apr-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP066', '1', 'DEPARTAMENTO', 'ALVD066', 'ALV0CD33060', None, None, '0C', '3', '306', None, '1', '0', 'ALV 1.1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '13.9', None, '4.11', '2.16', None, None, None, '47.05', '0', '0', '0', None, '0', '47.05', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,246,194.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00081612', 'NORMA ANGELICA VAZQUEZ ROSAS', 'NORMA ANGELICA', 'VAZQUEZ', 'ROSAS', 'VARN730618696', 'VARN730618MDFZSR09', '0', 'H', 'angyvazquez@hotmail.com', '5553528478', '5513997942', '50043434 100', None, '18-Jun-73', 'CASADO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '10', 'Buscando en Google', 'CAMPO IXTOC', '19', None, 'SAN ANTONIO', 'AZCAPOTZALCO', 'DISTRITO FEDERAL', 'MEXICO', '02720', '1', 'DIRECTORA OPERATIVA', '0029137437128', 'IFE', '30020106388', '0002522', None, '1152281.90000', '1152282.90000', '.00000', '.00000', '1152282.90000', '.00000', '.00000', '103705.46000', '.00000', '-80000.00000', '1175988.36000', '14-Mar-15', '14-Mar-15', '27-Mar-15', '27-Mar-15', '30-Mar-15', '12', None, '30-Mar-15', '30-Mar-15', '30-Mar-15', '6-Apr-15', '6-Apr-15', '5-Mar-15', None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP066', '2', 'ESTACIONAMIENTO', 'ALVE120', 'ALVGUEB0010', None, None, None, None, '001', None, '1', '0', 'EST GUEB', 'Cajón grande, único, arriba con eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Único', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00081612', 'NORMA ANGELICA VAZQUEZ ROSAS', 'NORMA ANGELICA', 'VAZQUEZ', 'ROSAS', 'VARN730618696', 'VARN730618MDFZSR09', '0', 'H', 'angyvazquez@hotmail.com', '5553528478', '5513997942', '50043434 100', None, '18-Jun-73', 'CASADO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '10', 'Buscando en Google', 'CAMPO IXTOC', '19', None, 'SAN ANTONIO', 'AZCAPOTZALCO', 'DISTRITO FEDERAL', 'MEXICO', '02720', '1', 'DIRECTORA OPERATIVA', '0029137437128', 'IFE', '30020106388', '0002522', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '14-Mar-15', '14-Mar-15', '27-Mar-15', '27-Mar-15', '30-Mar-15', '12', None, '30-Mar-15', '30-Mar-15', '30-Mar-15', '6-Apr-15', '6-Apr-15', '5-Mar-15', None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP045', '1', 'DEPARTAMENTO', 'ALVD045', 'ALV0CD00050', None, None, '0C', '0', '005', None, '1', '0', 'ALV 1.1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '13.9', None, '4.11', '2.16', None, None, None, '47.05', '0', '0', '0', None, '0', '47.05', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,309,667.00 ', '10,000.00 ', '0.00 ', '0.00 ', '2-Jun-16', '2-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00081614', 'HECTOR MOCTEZUMA BUSTOS', 'HECTOR', 'MOCTEZUMA', 'BUSTOS', 'MOBH6705225P9', 'MOBH670522HDFCSC01', '0', 'H', 'moctezuma67@hotmail.com', '59581370', '5552141803', '57477289', None, '22-May-67', 'CASADO', 'SOCIEDAD CONYUGAL', 'MEXICANA', 'MEXICO DISTRITO FEDERAL', None, '3', 'Gallardete', 'NARCISO MENDOZA', '81', '16 A', 'FRACC LAS AMERICAS', 'ECATEPEC DE MORELOS', 'MEXICO', 'MEXICO', '55070', '10', 'CONTADOR PUBLICO', '1822011026568', 'IFE', '30020113103', '0002708', None, '1232301.00000', '1232302.00000', '.00000', '.00000', '1232302.00000', '.00000', '.00000', '110907.18000', '.00000', '-26187.80000', '1317021.38000', '14-Mar-15', '15-Apr-15', '17-Apr-15', '17-Apr-15', '21-Apr-15', '12', None, '21-Apr-15', '22-Apr-15', '24-Apr-15', '28-Apr-15', '28-Apr-15', '21-Apr-15', None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP045', '2', 'ESTACIONAMIENTO', 'ALVE119', 'ALVGUEA0560', None, None, None, None, '056', None, '1', '0', 'EST GUEA', 'Cajón grande, único, abajo con eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Único', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00081614', 'HECTOR MOCTEZUMA BUSTOS', 'HECTOR', 'MOCTEZUMA', 'BUSTOS', 'MOBH6705225P9', 'MOBH670522HDFCSC01', '0', 'H', 'moctezuma67@hotmail.com', '59581370', '5552141803', '57477289', None, '22-May-67', 'CASADO', 'SOCIEDAD CONYUGAL', 'MEXICANA', 'MEXICO DISTRITO FEDERAL', None, '3', 'Gallardete', 'NARCISO MENDOZA', '81', '16 A', 'FRACC LAS AMERICAS', 'ECATEPEC DE MORELOS', 'MEXICO', 'MEXICO', '55070', '10', 'CONTADOR PUBLICO', '1822011026568', 'IFE', '30020113103', '0002708', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '14-Mar-15', '15-Apr-15', '17-Apr-15', '17-Apr-15', '21-Apr-15', '12', None, '21-Apr-15', '22-Apr-15', '24-Apr-15', '28-Apr-15', '28-Apr-15', '21-Apr-15', None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP144', '1', 'DEPARTAMENTO', 'ALVD144', 'ALV0ED11070', None, None, '0E', '1', '107', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,196,985.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00081685', 'NAVID MONCERRAT NIETO MACIAS', 'NAVID MONCERRAT', 'NIETO', 'MACIAS', 'NIMN8808177A9', 'NIMN880817MDFTCV05', '0', 'H', 'iq.navidnieto@hotmail.com', '22272436', '5543533817', None, '01048803009', '17-Aug-88', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '66', 'Recomedación', 'RAMON NOVARO', '207', '16', 'JORGE NEGRETE', 'GUSTAVO A. MADERO', 'DISTRITO FEDERAL', 'MEXICO', '07280', '25', 'ING. DE PROYECTO', '0953106828085', 'IFE', '30020106339', '0002453', None, '1106780.40000', '1106781.40000', '.00000', '.00000', '1106781.40000', '.00000', '.00000', '97396.73000', '.00000', '-88000.00000', '1116178.13000', '16-Mar-15', '21-Mar-15', '21-Mar-15', '16-Mar-15', '18-Mar-15', '12', None, '25-Mar-15', '27-Mar-15', '27-Mar-15', '31-Mar-15', '31-Mar-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP144', '2', 'ESTACIONAMIENTO', 'ALVE038', 'ALVCEEX0170', None, None, None, None, '017', None, '1', '0', 'EST CEEX', 'Cajón chico, atrás doble., abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00081685', 'NAVID MONCERRAT NIETO MACIAS', 'NAVID MONCERRAT', 'NIETO', 'MACIAS', 'NIMN8808177A9', 'NIMN880817MDFTCV05', '0', 'H', 'iq.navidnieto@hotmail.com', '22272436', '5543533817', None, '01048803009', '17-Aug-88', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '66', 'Recomedación', 'RAMON NOVARO', '207', '16', 'JORGE NEGRETE', 'GUSTAVO A. MADERO', 'DISTRITO FEDERAL', 'MEXICO', '07280', '25', 'ING. DE PROYECTO', '0953106828085', 'IFE', '30020106339', '0002453', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '16-Mar-15', '21-Mar-15', '21-Mar-15', '16-Mar-15', '18-Mar-15', '12', None, '25-Mar-15', '27-Mar-15', '27-Mar-15', '31-Mar-15', '31-Mar-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP056', '1', 'DEPARTAMENTO', 'ALVD056', 'ALV0CD22030', None, None, '0C', '2', '203', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,148,636.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00081797', 'YOHANNA FLORES ARAMBURO', 'YOHANNA', 'FLORES', 'ARAMBURO', 'FOAY8509034S7', 'FOAY850903MCLLRH03', '0', 'H', 'yohis.flores@gmail.com', '63617590', '5564142160', '11034444', '32108502728', '3-Sep-85', 'SOLTERO', None, 'MEXICANA', 'SALTILLO COAHUILA', None, '3', 'Gallardete', 'AHUEHUETES', '60', '403', 'SAN BARTOLO ATEPEHUACAN', 'GUSTAVO A MADERO', 'DISTRITO FEDERAL', 'MEXICO', '07300', '3', 'INGENIERO EN SISTEMAS', '1064079421336', 'IFE', '30020107089', '0002551', None, '1062075.30000', '1062076.30000', '.00000', '.00000', '1062076.30000', '.00000', '.00000', '95586.87000', '.00000', '-74984.00000', '1082679.17000', '21-Mar-15', '21-Mar-15', '31-Mar-15', '21-Mar-15', '23-Mar-15', '12', None, '31-Mar-15', '31-Mar-15', '31-Mar-15', '7-Apr-15', '7-Apr-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP056', '2', 'ESTACIONAMIENTO', 'ALVE116', 'ALVGEEB0820', None, None, None, None, '082', None, '1', '0', 'EST GEEB', 'Cajón grande, atras doble, arriba con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Atrás doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00081797', 'YOHANNA FLORES ARAMBURO', 'YOHANNA', 'FLORES', 'ARAMBURO', 'FOAY8509034S7', 'FOAY850903MCLLRH03', '0', 'H', 'yohis.flores@gmail.com', '63617590', '5564142160', '11034444', '32108502728', '3-Sep-85', 'SOLTERO', None, 'MEXICANA', 'SALTILLO COAHUILA', None, '3', 'Gallardete', 'AHUEHUETES', '60', '403', 'SAN BARTOLO ATEPEHUACAN', 'GUSTAVO A MADERO', 'DISTRITO FEDERAL', 'MEXICO', '07300', '3', 'INGENIERO EN SISTEMAS', '1064079421336', 'IFE', '30020107089', '0002551', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '21-Mar-15', '21-Mar-15', '31-Mar-15', '21-Mar-15', '23-Mar-15', '12', None, '31-Mar-15', '31-Mar-15', '31-Mar-15', '7-Apr-15', '7-Apr-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP044', '1', 'DEPARTAMENTO', 'ALVD044', 'ALV0CD00040', None, None, '0C', '0', '004', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,172,025.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00082108', 'JOSEFINA GONZALEZ DIAZ', 'JOSEFINA', 'GONZALEZ', 'DIAZ', 'GODJ5901232M9', 'GODJ590123MGRNZS07', '0', 'H', 'jet.tapia@hotmail.com', '015949573555', '5540742051', None, None, '23-Jan-59', 'SOLTERO', None, 'MEXICANA', 'ESTADO DE GUERRERO', None, '8', 'Publicidad en Pto de Vta', 'AV. 16 DE SEPTIEMBRE', '7', None, 'CUANALAN', 'ACOLMAN', 'ESTADO DE MEXICO', 'MEXICO', '55885', '35', 'NEGOCIO PROPIO', '0050010627415', 'IFE', '30020110299', '0002627', None, '1068702.00000', '1068703.00000', '.00000', '.00000', '1068703.00000', '.00000', '.00000', '74809.21000', '.00000', '-419984.00000', '723528.21000', '3-Apr-15', '9-Apr-15', '9-Apr-15', '3-Apr-15', '6-Apr-15', '12', None, '9-Apr-15', '9-Apr-15', '9-Apr-15', '10-Apr-15', '10-Apr-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP044', '2', 'ESTACIONAMIENTO', 'ALVE081', 'ALVGDEB0610', None, None, None, None, '061', None, '1', '0', 'EST GDEB', 'Cajón grande, adelante doble, arriba con eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Adelante doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00082108', 'JOSEFINA GONZALEZ DIAZ', 'JOSEFINA', 'GONZALEZ', 'DIAZ', 'GODJ5901232M9', 'GODJ590123MGRNZS07', '0', 'H', 'jet.tapia@hotmail.com', '015949573555', '5540742051', None, None, '23-Jan-59', 'SOLTERO', None, 'MEXICANA', 'ESTADO DE GUERRERO', None, '8', 'Publicidad en Pto de Vta', 'AV. 16 DE SEPTIEMBRE', '7', None, 'CUANALAN', 'ACOLMAN', 'ESTADO DE MEXICO', 'MEXICO', '55885', '35', 'NEGOCIO PROPIO', '0050010627415', 'IFE', '30020110299', '0002627', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '3-Apr-15', '9-Apr-15', '9-Apr-15', '3-Apr-15', '6-Apr-15', '12', None, '9-Apr-15', '9-Apr-15', '9-Apr-15', '10-Apr-15', '10-Apr-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP073', '1', 'DEPARTAMENTO', 'ALVD073', 'ALV0CD44060', None, None, '0C', '4', '406', None, '1', '0', 'ALV 1.1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '13.9', None, '4.11', '2.16', None, None, None, '47.05', '0', '0', '0', None, '0', '47.05', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,175,558.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00082306', 'LAURA GRICELDA RAMOS LOPEZ', 'LAURA GRICELDA', 'RAMOS', 'LOPEZ', 'RALL840803A97', 'RALL840803MDFMPR01', '0', 'M', 'im.madferit@gmail.com', '57371525', '5523874204', '5561114823', None, '3-Aug-84', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '11', 'Anuncio en Google', 'PROSPERIDAD A', '111 A', None, 'CAMPESTRE ARAGON', 'GUSTAVO A MADERO', 'DISTRITO FEDERAL', 'MEXICO', '07530', '2', 'EMPLEADA', 'G7355150', 'PASAPORTE', '30020112071', '0002703', None, '1119579.00000', '1119580.00000', '.00000', '.00000', '1119580.00000', '.00000', '.00000', '100762.20000', '.00000', '-83798.50000', '1136543.70000', '11-Apr-15', '19-Apr-15', '19-Apr-15', '11-Apr-15', '13-Apr-15', '12', None, '22-Apr-15', '23-Apr-15', '24-Apr-15', '28-Apr-15', '28-Apr-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP073', '2', 'ESTACIONAMIENTO', 'ALVE090', 'ALVGEEA0620', None, None, None, None, '062', None, '1', '0', 'EST GEEA', 'Cajón grande, atras doble, abajo con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Atrás doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00082306', 'LAURA GRICELDA RAMOS LOPEZ', 'LAURA GRICELDA', 'RAMOS', 'LOPEZ', 'RALL840803A97', 'RALL840803MDFMPR01', '0', 'M', 'im.madferit@gmail.com', '57371525', '5523874204', '5561114823', None, '3-Aug-84', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '11', 'Anuncio en Google', 'PROSPERIDAD A', '111 A', None, 'CAMPESTRE ARAGON', 'GUSTAVO A MADERO', 'DISTRITO FEDERAL', 'MEXICO', '07530', '2', 'EMPLEADA', 'G7355150', 'PASAPORTE', '30020112071', '0002703', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '11-Apr-15', '19-Apr-15', '19-Apr-15', '11-Apr-15', '13-Apr-15', '12', None, '22-Apr-15', '23-Apr-15', '24-Apr-15', '28-Apr-15', '28-Apr-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP049', '1', 'DEPARTAMENTO', 'ALVD049', 'ALV0CD11030', None, None, '0C', '1', '103', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,160,698.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00082457', 'DEMETRIO MALDONADO RESENDIZ', 'DEMETRIO', 'MALDONADO', 'RESENDIZ', 'MARD701230PBA', 'MARD701230HDFLSM05', '0', 'H', 'dem70_maldonado@yahoo.com.mx', '58225439', '5552484924', None, '39897046858', '30-Dec-70', 'CASADO', 'SOCIEDAD CONYUGAL', 'MEXICANO', 'MEXICO D,F.', None, '8', 'Publicidad en Pto de Vta', 'RIO BRAVO', '19', None, 'MEXICO NUEVO', 'ATIZAPAN DE ZARAGOZA', 'ESTADO DE MEXICO', 'MEXICO', '52966', '7', 'EMPLEADO', '0330008997685', 'IFE', '30020113392', '0002743', None, '1090426.00000', '1090427.00000', '.00000', '.00000', '1090427.00000', '.00000', '.00000', '87234.16000', '.00000', '-10000.00000', '1167661.16000', '18-Apr-15', '25-Apr-15', '19-Apr-15', '18-Apr-15', '20-Apr-15', '12', None, '26-Apr-15', '29-Apr-15', '30-Apr-15', '5-May-15', '5-May-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP049', '2', 'ESTACIONAMIENTO', 'ALVE108', 'ALVGEEB0640', None, None, None, None, '064', None, '1', '0', 'EST GEEB', 'Cajón grande, atras doble, arriba con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Atrás doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00082457', 'DEMETRIO MALDONADO RESENDIZ', 'DEMETRIO', 'MALDONADO', 'RESENDIZ', 'MARD701230PBA', 'MARD701230HDFLSM05', '0', 'H', 'dem70_maldonado@yahoo.com.mx', '58225439', '5552484924', None, '39897046858', '30-Dec-70', 'CASADO', 'SOCIEDAD CONYUGAL', 'MEXICANO', 'MEXICO D,F.', None, '8', 'Publicidad en Pto de Vta', 'RIO BRAVO', '19', None, 'MEXICO NUEVO', 'ATIZAPAN DE ZARAGOZA', 'ESTADO DE MEXICO', 'MEXICO', '52966', '7', 'EMPLEADO', '0330008997685', 'IFE', '30020113392', '0002743', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '18-Apr-15', '25-Apr-15', '19-Apr-15', '18-Apr-15', '20-Apr-15', '12', None, '26-Apr-15', '29-Apr-15', '30-Apr-15', '5-May-15', '5-May-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP074', '1', 'DEPARTAMENTO', 'ALVD074', 'ALV0CD44070', None, None, '0C', '4', '407', None, '1', '0', 'ALV 5-C', 'Estancia, Comedor, 1 Recámara, Alcoba, Baño, Cocina, Cuarto de lavado, Balcón.', None, None, '1', '1', '1', '1', '15.01', None, '3.67', '2.16', None, None, None, '59.11', '0', '0', '1.77', None, '0', '60.88', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,537,202.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00082573', 'LETICIA ANDREA MORALES SANCHEZ', 'LETICIA ANDREA', 'MORALES', 'SANCHEZ', 'MOSL601110B95', 'MOSL601110MDFRNT04', '0', 'M', 'andreams@telmexmail.com', '58418023', '5559405417', '57296000 55067', None, '10-Nov-60', 'SOLTERO', None, 'MEXICANA', 'MEXICO D.F.', None, '3', 'Gallardete', 'JUAN DE DIOS PEZA', '61', '1-A-203', 'SANTIAGO ZAPOTITLAN', 'TLAHUAC', 'DISTRITO FEDERAL', 'MEXICO', '13300', '23', 'EMPLEADA', '3637011374838', 'IFE', '30020114374', '0002798', None, '1464001.00000', '1464003.00000', '.00000', '.00000', '1464003.00000', '.00000', '.00000', '131760.27000', '.00000', '-205754.48000', '1390008.79000', '24-Apr-15', '5-May-15', '5-May-15', '11-May-15', '11-May-15', '0', None, '11-May-15', '11-May-15', '11-May-15', '12-May-15', '12-May-15', '7-May-15', None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP074', '2', 'ESTACIONAMIENTO', 'ALVE058', 'ALVEEEX0600', None, None, None, None, '060', None, '1', '0', 'EST EEEX', 'Discapacitados compartido, atrás doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '15.5', None, None, None, None, None, None, '3.1', None, '0', None, None, 'Discapacitado Compart', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00082573', 'LETICIA ANDREA MORALES SANCHEZ', 'LETICIA ANDREA', 'MORALES', 'SANCHEZ', 'MOSL601110B95', 'MOSL601110MDFRNT04', '0', 'M', 'andreams@telmexmail.com', '58418023', '5559405417', '57296000 55067', None, '10-Nov-60', 'SOLTERO', None, 'MEXICANA', 'MEXICO D.F.', None, '3', 'Gallardete', 'JUAN DE DIOS PEZA', '61', '1-A-203', 'SANTIAGO ZAPOTITLAN', 'TLAHUAC', 'DISTRITO FEDERAL', 'MEXICO', '13300', '23', 'EMPLEADA', '3637011374838', 'IFE', '30020114374', '0002798', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '24-Apr-15', '5-May-15', '5-May-15', '11-May-15', '11-May-15', '0', None, '11-May-15', '11-May-15', '11-May-15', '12-May-15', '12-May-15', '7-May-15', None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP074', '3', 'BODEGA', 'ALVB002', 'ALV00BD0020', None, None, None, None, '002', None, '1', '0', 'ALV B 1.90', 'bodega de 1.90 m2', None, None, None, None, None, None, None, None, None, None, None, None, None, '1.9', None, None, None, None, None, None, None, None, '0', None, None, None, None, None, '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00082573', 'LETICIA ANDREA MORALES SANCHEZ', 'LETICIA ANDREA', 'MORALES', 'SANCHEZ', 'MOSL601110B95', 'MOSL601110MDFRNT04', '0', 'M', 'andreams@telmexmail.com', '58418023', '5559405417', '57296000 55067', None, '10-Nov-60', 'SOLTERO', None, 'MEXICANA', 'MEXICO D.F.', None, '3', 'Gallardete', 'JUAN DE DIOS PEZA', '61', '1-A-203', 'SANTIAGO ZAPOTITLAN', 'TLAHUAC', 'DISTRITO FEDERAL', 'MEXICO', '13300', '23', 'EMPLEADA', '3637011374838', 'IFE', '30020114374', '0002798', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '24-Apr-15', '5-May-15', '5-May-15', '11-May-15', '11-May-15', '0', None, '11-May-15', '11-May-15', '11-May-15', '12-May-15', '12-May-15', '7-May-15', None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP071', '1', 'DEPARTAMENTO', 'ALVD071', 'ALV0CD44040', None, None, '0C', '4', '404', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '0', '1', '1', '967,301.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00082579', 'DAVID ALBERTO MONTERROSAS SANTOS', 'DAVID ALBERTO', 'MONTERROSAS', 'SANTOS', 'MOSD871229CE6', 'MOSD871229HDFNNV02', '0', 'H', 'im_skazy182@hotmail.com', '5557918957', '5527183227', '5555575370', '11058711729', '29-Dec-87', 'SOLTERO', None, 'MEXICANA', 'MEXICO DF', None, '66', 'Recomedación', 'AVE SECCION A', 'A', 'LT 22', 'TOLOTZIN V', 'ECATEPEC', 'ESTADO DE MEXICO', 'MEXICO', '55330', '27', 'EMPLEADO', '1408106592402', 'IFE', '30020116197', '0002826', None, '906239.00000', '906239.00000', '.00000', '.00000', '906239.00000', '.00000', '.00000', '81561.51000', '.00000', '-73615.18000', '914185.33000', '25-Apr-15', '3-May-15', '21-May-15', '20-May-15', '21-May-15', '12', None, '21-May-15', '21-May-15', '22-May-15', '25-May-15', '25-May-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP047', '1', 'DEPARTAMENTO', 'ALVD047', 'ALV0CD11010', None, None, '0C', '1', '101', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,171,232.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00082948', 'JUANA CRUZ BLANCO', 'JUANA', 'CRUZ', 'BLANCO', 'CUBJ560919BN5', 'CUBJ560919MMNRLN07', '0', 'H', 'JUANA.CRUZ@GMAIL.COM', '51263334', '5522710011', None, '90885601659', '19-Sep-56', 'SOLTERO', None, 'MEXICANA', 'MEXICO D.F', None, '8', 'Publicidad en Pto de Vta', 'COLIMA', '289', None, 'SANTA MARÍA TULPETLAC', 'ECATEPEC DE MORELOS', 'ESTADO DE MEXICO', 'MEXICO', '55400', '20', 'DOCTORA', '1334083847377', 'IFE', '30020117690', '0002843', None, '1115459.00000', '1115460.00000', '.00000', '.00000', '1115460.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1115460.00000', '13-May-15', '27-May-15', '15-May-15', '15-May-15', '15-May-15', '12', None, '18-May-15', '19-May-15', '26-May-15', '28-May-15', '28-May-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP047', '2', 'ESTACIONAMIENTO', 'ALVE082', 'ALVGDEB0630', None, None, None, None, '063', None, '1', '0', 'EST GDEB', 'Cajón grande, adelante doble, arriba con eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Adelante doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00082948', 'JUANA CRUZ BLANCO', 'JUANA', 'CRUZ', 'BLANCO', 'CUBJ560919BN5', 'CUBJ560919MMNRLN07', '0', 'H', 'JUANA.CRUZ@GMAIL.COM', '51263334', '5522710011', None, '90885601659', '19-Sep-56', 'SOLTERO', None, 'MEXICANA', 'MEXICO D.F', None, '8', 'Publicidad en Pto de Vta', 'COLIMA', '289', None, 'SANTA MARÍA TULPETLAC', 'ECATEPEC DE MORELOS', 'ESTADO DE MEXICO', 'MEXICO', '55400', '20', 'DOCTORA', '1334083847377', 'IFE', '30020117690', '0002843', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '13-May-15', '27-May-15', '15-May-15', '15-May-15', '15-May-15', '12', None, '18-May-15', '19-May-15', '26-May-15', '28-May-15', '28-May-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP024', '1', 'DEPARTAMENTO', 'ALVD024', 'ALV0BD11040', None, None, '0B', '1', '104', None, '1', '0', 'ALV 4', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '13.52', None, '3.72', '2.02', None, None, None, '44.27', '0', '0', '0', None, '0', '44.27', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,151,080.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00083767', 'MARIA GUADALUPE RIOS SANDOVAL', 'MARIA GUADALUPE', 'RIOS', 'SANDOVAL', 'RISG321205DS5', 'RISG321205MMNSND05', '0', 'M', 'RIOS.SANDOVAL@YAHOO.COM.MX', '5526511215', '5539726483', '5554433500', None, '5-Dec-32', 'SOLTERO', None, 'MEXICANA', 'PARACHO MICHOACAN', None, '9', 'Web', 'C 11', 'EDF  7 B', 'DEP 402', 'EDF  7 B DEP 402', 'GUSTAVO A MADERO', 'DF', 'MEXICO', '07249', '20', 'EMPLEADA', '0928005349930', 'IFE', '30020124746', '0002994', None, '1151080.00000', '1151081.00000', '.00000', '.00000', '1151081.00000', '.00000', '.00000', '80575.67000', '.00000', '-1009982.00000', '221674.67000', '17-Jun-15', '30-Jun-15', '24-Jun-15', '20-Jun-15', '22-Jun-15', '12', None, '30-Jun-15', '30-Jun-15', '30-Jun-15', '1-Jul-15', '1-Jul-15', '29-Jun-15', None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP024', '2', 'ESTACIONAMIENTO', 'ALVE064', 'ALVGBEB0900', None, None, None, None, '090', None, '1', '0', 'EST GBEB', 'Cajón grande, en medio triple, arriba con eleva auto.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'En medio triple', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00083767', 'MARIA GUADALUPE RIOS SANDOVAL', 'MARIA GUADALUPE', 'RIOS', 'SANDOVAL', 'RISG321205DS5', 'RISG321205MMNSND05', '0', 'M', 'RIOS.SANDOVAL@YAHOO.COM.MX', '5526511215', '5539726483', '5554433500', None, '5-Dec-32', 'SOLTERO', None, 'MEXICANA', 'PARACHO MICHOACAN', None, '9', 'Web', 'C 11', 'EDF  7 B', 'DEP 402', 'EDF  7 B DEP 402', 'GUSTAVO A MADERO', 'DF', 'MEXICO', '07249', '20', 'EMPLEADA', '0928005349930', 'IFE', '30020124746', '0002994', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '17-Jun-15', '30-Jun-15', '24-Jun-15', '20-Jun-15', '22-Jun-15', '12', None, '30-Jun-15', '30-Jun-15', '30-Jun-15', '1-Jul-15', '1-Jul-15', '29-Jun-15', None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP153', '1', 'DEPARTAMENTO', 'ALVD153', 'ALV0ED22080', None, None, '0E', '2', '208', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,174,390.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00083852', 'GUSTAVO DURAN SAN LAZARO', 'GUSTAVO', 'DURAN', 'SAN LAZARO', 'DUSG850913N98', 'DUSG850913HDFRNS06', '0', 'H', 'GUSTAVO_REX@HOTMAIL.COM', '26462431', '5585336197', '53879330', '94078512053', '13-Sep-85', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '66', 'Recomedación', 'TLAXCALTECAS', '223', '43', 'CD AZTECA 2A SECC', 'ECATEPEC', 'ESTADO DE MEXICO', 'MEXICO', '55120', '25', 'REPRESENTANTE MEDICO', '07380039655', 'PASAPORTE', '30020126287', '0003000', None, '1174390.00000', '1174391.00000', '.00000', '.00000', '1174391.00000', '.00000', '.00000', '93951.28000', '.00000', '-35000.00000', '1233342.28000', '20-Jun-15', '28-Jun-15', '28-Jun-15', '27-Jun-15', '29-Jun-15', '12', None, '29-Jun-15', '29-Jun-15', '29-Jun-15', '1-Jul-15', '1-Jul-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP153', '2', 'ESTACIONAMIENTO', 'ALVE086', 'ALVGEEA0380', None, None, None, None, '038', None, '1', '0', 'EST GEEA', 'Cajón grande, atras doble, abajo con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Atrás doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00083852', 'GUSTAVO DURAN SAN LAZARO', 'GUSTAVO', 'DURAN', 'SAN LAZARO', 'DUSG850913N98', 'DUSG850913HDFRNS06', '0', 'H', 'GUSTAVO_REX@HOTMAIL.COM', '26462431', '5585336197', '53879330', '94078512053', '13-Sep-85', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '66', 'Recomedación', 'TLAXCALTECAS', '223', '43', 'CD AZTECA 2A SECC', 'ECATEPEC', 'ESTADO DE MEXICO', 'MEXICO', '55120', '25', 'REPRESENTANTE MEDICO', '07380039655', 'PASAPORTE', '30020126287', '0003000', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '20-Jun-15', '28-Jun-15', '28-Jun-15', '27-Jun-15', '29-Jun-15', '12', None, '29-Jun-15', '29-Jun-15', '29-Jun-15', '1-Jul-15', '1-Jul-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP064', '1', 'DEPARTAMENTO', 'ALVD064', 'ALV0CD33040', None, None, '0C', '3', '304', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,017,672.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PV00083974', 'YESSICA SANCHEZ CHAVARRIA', 'YESSICA', 'SANCHEZ', 'CHAVARRIA', 'SACY8408202I5', 'SACY840820MDFNHS02', '0', 'H', 'YESSIK_01@HOTMAIL.COM', '57180502', '5543428755', '53959077', '01108402247', '20-Aug-84', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '66', 'Recomedación', 'ALPINO', '299', '2882', 'LAZARO CARDENAS', 'TLALNEPANTLA', 'ESTADO DE MEXICO', 'MEXICO', '54189', '30', 'CONSULTOR', '4770085383541', 'IFE', '30020126139', '0003045', None, '1017672.00000', '1017672.00000', '.00000', '.00000', '1017672.00000', '.00000', '.00000', '81413.76000', '.00000', '-20000.00000', '1079085.76000', '27-Jun-15', '4-Jul-15', '6-Jul-15', '27-Jun-15', '30-Jun-15', '12', None, '7-Jul-15', '7-Jul-15', '8-Jul-15', '9-Jul-15', '9-Jul-15', '4-May-15', None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP145', '1', 'DEPARTAMENTO', 'ALVD145', 'ALV0ED11080', None, None, '0E', '1', '108', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,196,985.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PVI0000142', 'MARIA LUISA ESCAMILLA', 'MARIA LUISA', 'ESCAMILLA', None, 'EALU500415R88', 'EAXL500415MDFSXS05', '1', None, 'construccionb1@hotmail.com', None, None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, None, None, 'Mexico', None, '0', None, None, None, '30010178140', 'SI000010664', None, '869161.75000', '869162.75000', '.00000', '.00000', '869162.75000', '.00000', '.00000', '60841.33000', '.00000', '-510000.00000', '420004.08000', '15-Jan-15', '15-Jan-15', '6-Jan-15', '6-Jan-15', '6-Jan-15', '0', None, '6-Jan-15', '6-Jan-15', '6-Jan-15', '6-Jan-15', '6-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP145', '2', 'ESTACIONAMIENTO', 'ALVE039', 'ALVCEEX0190', None, None, None, None, '019', None, '1', '0', 'EST CEEX', 'Cajón chico, atrás doble., abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'VENTA', '007-DICTAMINADA', 'PVI0000142', 'MARIA LUISA ESCAMILLA', 'MARIA LUISA', 'ESCAMILLA', None, 'EALU500415R88', 'EAXL500415MDFSXS05', '1', None, 'construccionb1@hotmail.com', None, None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, None, None, 'Mexico', None, '0', None, None, None, '30010178140', 'SI000010666', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '6-Jan-15', '6-Jan-15', '6-Jan-15', '0', None, '6-Jan-15', '6-Jan-15', '6-Jan-15', '6-Jan-15', '6-Jan-15', None, None, None, None, None, None, None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP053', '1', 'DEPARTAMENTO', 'ALVD053', 'ALV0CD11070', None, None, '0C', '1', '107', None, '1', '0', 'ALV 5-C', 'Estancia, Comedor, 1 Recámara, Alcoba, Baño, Cocina, Cuarto de lavado, Balcón.', None, None, '1', '1', '1', '1', '15.01', None, '3.67', '2.16', None, None, None, '59.11', '0', '0', '1.77', None, '0', '60.88', None, None, '0', None, None, None, None, None, '1', '0', '0', '1710351', '10000', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '014-REUBICACION', 'PV00081578', 'MARIA DE LA PAZ TIMOTEA GUZMAN PLATA', 'MARIA DE LA PAZ TIMOTEA', 'GUZMAN', 'PLATA', 'GUPP620124438', 'GUPP620121MDFZLZ03', '0', 'M', 'mguz@correo.azc.uam.mx', '55777419', '5545721404', '53189130', None, '24-Jan-62', 'CASADO', 'SOCIEDAD CONYUGAL', 'MEXICANA', 'MEXICO DISTRITO FEDERAL', None, '10', 'Buscando en Google', 'CALI', '686', None, 'LINDAVISTA', 'GUSTAVO A MADERO', 'DISTRITO FEDERAL', 'MEXICO', '07300', '15', 'PROFESORA', '1295005613267', 'IFE', '30020105463', '0002418', '0000054', '1581460.10000', '1581462.10000', '.00000', '.00000', '1581462.10000', '-1581460.10000', '-1581462.10000', '.00000', '.00000', '-1310000.00000', '-1310000.00000', '12-Mar-15', '17-Mar-15', '19-Mar-15', '14-Mar-15', '17-Mar-15', '12', None, '24-Mar-15', '24-Mar-15', '24-Mar-15', '31-Mar-15', '31-Mar-15', None, None, None, None, None, '4-Aug-15', None, None, 'REUBICACION'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP053', '2', 'ESTACIONAMIENTO', 'ALVE055', 'ALVEDEX0570', None, None, None, None, '057', None, '1', '0', 'EST EDEX', 'Discapacitados compartido, adelante doble', None, None, None, None, None, None, None, None, None, None, None, None, None, '15.5', None, None, None, None, None, None, '3.1', None, '0', None, None, 'Discapacitado Compart', 'Abajo sin eleva autos', 'Adelante doble', '1', '0', '0', '1', '0', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '014-REUBICACION', 'PV00081578', 'MARIA DE LA PAZ TIMOTEA GUZMAN PLATA', 'MARIA DE LA PAZ TIMOTEA', 'GUZMAN', 'PLATA', 'GUPP620124438', 'GUPP620121MDFZLZ03', '0', 'M', 'mguz@correo.azc.uam.mx', '55777419', '5545721404', '53189130', None, '24-Jan-62', 'CASADO', 'SOCIEDAD CONYUGAL', 'MEXICANA', 'MEXICO DISTRITO FEDERAL', None, '10', 'Buscando en Google', 'CALI', '686', None, 'LINDAVISTA', 'GUSTAVO A MADERO', 'DISTRITO FEDERAL', 'MEXICO', '07300', '15', 'PROFESORA', '1295005613267', 'IFE', '30020105463', '0002418', '0000054', '1.00000', '.00000', '.00000', '.00000', '.00000', '-1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '12-Mar-15', '17-Mar-15', '19-Mar-15', '14-Mar-15', '17-Mar-15', '12', None, '24-Mar-15', '24-Mar-15', '24-Mar-15', '31-Mar-15', '31-Mar-15', None, None, None, None, None, '4-Aug-15', None, None, 'REUBICACION'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP053', '3', 'BODEGA', 'ALVB004', 'ALV00BD0040', None, None, None, None, '004', None, '1', '0', 'ALV B 4.51', 'bodega de 4.51 m2', None, None, None, None, None, None, None, None, None, None, None, None, None, '4.51', None, None, None, None, None, None, None, None, '0', None, None, None, None, None, '1', '0', '0', '1', '0', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '014-REUBICACION', 'PV00081578', 'MARIA DE LA PAZ TIMOTEA GUZMAN PLATA', 'MARIA DE LA PAZ TIMOTEA', 'GUZMAN', 'PLATA', 'GUPP620124438', 'GUPP620121MDFZLZ03', '0', 'M', 'mguz@correo.azc.uam.mx', '55777419', '5545721404', '53189130', None, '24-Jan-62', 'CASADO', 'SOCIEDAD CONYUGAL', 'MEXICANA', 'MEXICO DISTRITO FEDERAL', None, '10', 'Buscando en Google', 'CALI', '686', None, 'LINDAVISTA', 'GUSTAVO A MADERO', 'DISTRITO FEDERAL', 'MEXICO', '07300', '15', 'PROFESORA', '1295005613267', 'IFE', '30020105463', '0002418', '0000054', '1.00000', '.00000', '.00000', '.00000', '.00000', '-1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '12-Mar-15', '17-Mar-15', '19-Mar-15', '14-Mar-15', '17-Mar-15', '12', None, '24-Mar-15', '24-Mar-15', '24-Mar-15', '31-Mar-15', '31-Mar-15', None, None, None, None, None, '4-Aug-15', None, None, 'REUBICACION'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP165', '1', 'DEPARTAMENTO', 'ALVD165', 'ALV0ED44040', None, None, '0E', '4', '404', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '0', '967301', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00055960', 'CANDY GUZMAN GOMEZ', 'CANDY', 'GUZMAN', 'GOMEZ', 'GUGC750403EX8', 'GUGC861106MDFZMN08', '0', 'H', None, '5528591356', None, None, '01088609787', '3-Apr-75', 'SOLTERO', None, 'MEXICANA', 'DF', None, '1', 'Impresos', 'EDIT', '48', 'A 102', 'LINDAVISTA', 'GUSTAVO A MADERO', 'DF', 'MEXICO', '07720', '2', 'CONSULTOR SAP', '1457108384430', 'IFE', '30010184650', '0002035', '0000087', '808096.02000', '808096.02000', '.00000', '.00000', '808096.02000', '-808096.02000', '-808096.02000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '26-Feb-15', '26-Feb-15', '24-Feb-15', '12', None, '27-Feb-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', None, None, None, None, None, '21-Aug-15', None, None, 'CANCELADO'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP150', '1', 'DEPARTAMENTO', 'ALVD150', 'ALV0ED22050', None, None, '0E', '2', '205', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '0', '1184923', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00070537', 'MARIA DEL CORAL ITZEL CASTAÑEDA MORENO', 'MARIA DEL CORAL ITZEL', 'CASTAÑEDA', 'MORENO', 'CAMC830901CJ3', 'CAMC830901MDFSRR05', '1', None, 'it.castaneda@gmail.com', '26740151', None, '5520897024', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, None, None, 'Mexico', None, '0', None, None, None, '30010177084', 'SI000010540', '00000061', '860403.75000', '860404.75000', '.00000', '.00000', '860404.75000', '-860403.75000', '-860404.75000', '.00000', '.00000', '-59960.00000', '-59960.00000', '15-Jan-15', '15-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '0', None, '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', None, None, None, None, None, '30-Nov-15', None, None, 'CANCELACION'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP150', '2', 'ESTACIONAMIENTO', 'ALVE044', 'ALVCEEX0290', None, None, None, None, '029', None, '1', '0', 'EST CEEX', 'Cajón chico, atrás doble., abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '1', '0', '0', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00070537', 'MARIA DEL CORAL ITZEL CASTAÑEDA MORENO', 'MARIA DEL CORAL ITZEL', 'CASTAÑEDA', 'MORENO', 'CAMC830901CJ3', 'CAMC830901MDFSRR05', '1', None, 'it.castaneda@gmail.com', '26740151', None, '5520897024', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, None, None, 'Mexico', None, '0', None, None, None, '30010177084', 'SI000010546', '00000061', '1.00000', '.00000', '.00000', '.00000', '.00000', '-1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '0', None, '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', None, None, None, None, None, '30-Nov-15', None, None, 'CANCELACION'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP038', '1', 'DEPARTAMENTO', 'ALVD038', 'ALV0BD55020', None, None, '0B', '5', '502', None, '1', '0', 'ALV 3.2-C', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado, Balcón.', None, None, '2', None, '1', '1', '13.4', None, '3.8', '2.15', None, None, None, '50.88', '0', '0', '2.61', None, '0', '53.49', None, None, '0', None, None, None, None, None, '1', '0', '1', '1285628', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00078671', 'ELENA ZUÑIGA ESQUIVEL', 'ELENA', 'ZUÑIGA', 'ESQUIVEL', 'ZUEE820807US3', 'ZUEE820807MDFXSL06', '1', None, 'elenazunigae@imss.gob.mx', '52949463', '53265446', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'NAUCALPAN JUÁREZ MEX', 'MEX', 'Mexico', '53830', '0', None, None, None, '30010178579', 'SI000010903', 'DEV000001256', '970499.00000', '970500.00000', '.00000', '.00000', '970500.00000', '-970499.00000', '-970500.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '30-Jan-15', '16-Jan-15', '16-Jan-15', '16-Jan-15', '0', None, '16-Jan-15', '16-Jan-15', '16-Jan-15', '16-Jan-15', '16-Jan-15', None, None, None, None, None, '29-May-15', None, None, 'CANCELADO'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP038', '2', 'ESTACIONAMIENTO', 'ALVE061', 'ALVGAEA0890', None, None, None, None, '089', None, '1', '0', 'EST GAEA', 'Cajon grande,adelante triple, abajo con eleva auto', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Adelante triple', '1', '0', '1', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00078671', 'ELENA ZUÑIGA ESQUIVEL', 'ELENA', 'ZUÑIGA', 'ESQUIVEL', 'ZUEE820807US3', 'ZUEE820807MDFXSL06', '1', None, 'elenazunigae@imss.gob.mx', '52949463', '53265446', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'NAUCALPAN JUÁREZ MEX', 'MEX', 'Mexico', '53830', '0', None, None, None, '30010178579', 'SI000011023', 'DEV000001256', '1.00000', '.00000', '.00000', '.00000', '.00000', '-1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '30-Jan-15', '16-Jan-15', '16-Jan-15', '16-Jan-15', '0', None, '16-Jan-15', '16-Jan-15', '16-Jan-15', '16-Jan-15', '16-Jan-15', None, None, None, None, None, '29-May-15', None, None, 'CANCELADO'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP024', '1', 'DEPARTAMENTO', 'ALVD024', 'ALV0BD11040', None, None, '0B', '1', '104', None, '1', '0', 'ALV 4', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '13.52', None, '3.72', '2.02', None, None, None, '44.27', '0', '0', '0', None, '0', '44.27', None, None, '0', None, None, None, None, None, '0', '1', '1', '1151080', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00078755', 'CLAUDIA IVETT MONTOYA ENDOQUI', 'CLAUDIA IVETT', 'MONTOYA', 'ENDOQUI', 'MOEC7907018L4', 'MOEC790701MDFNNL07', '1', None, 'cmontoya@deloittemx.com', '50806910', '50806910', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'CUAUHTÉMOC DF', 'DF', 'Mexico', '06400', '0', None, None, None, '30010175658', 'SI000010604', 'DEV000001224', '830827.77000', '830828.77000', '.00000', '.00000', '830828.77000', '-830827.77000', '-830828.77000', '74774.51000', '.00000', '.00000', '74774.51000', '1-Jan-00', '30-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', '0', None, '5-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', None, None, None, None, None, '28-Apr-15', None, None, 'CANCELADO POR FALTA DE RECURSOS'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP024', '2', 'ESTACIONAMIENTO', 'ALVE064', 'ALVGBEB0900', None, None, None, None, '090', None, '1', '0', 'EST GBEB', 'Cajón grande, en medio triple, arriba con eleva auto.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'En medio triple', '0', '1', '1', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00078755', 'CLAUDIA IVETT MONTOYA ENDOQUI', 'CLAUDIA IVETT', 'MONTOYA', 'ENDOQUI', 'MOEC7907018L4', 'MOEC790701MDFNNL07', '1', None, 'cmontoya@deloittemx.com', '50806910', '50806910', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'CUAUHTÉMOC DF', 'DF', 'Mexico', '06400', '0', None, None, None, '30010175658', 'SI000010613', 'DEV000001244', '1.00000', '.00000', '.00000', '.00000', '.00000', '-1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '30-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', '0', None, '5-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', None, None, None, None, None, '18-May-15', None, None, 'CANCELADO POR FALTA DE RECURSOS'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP153', '1', 'DEPARTAMENTO', 'ALVD153', 'ALV0ED22080', None, None, '0E', '2', '208', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '0', '1', '1', '1174390', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00078819', 'RODOLFO MARTINEZ CENDEJAS', 'RODOLFO', 'MARTINEZ', 'CENDEJAS', 'MACR750511BY4', 'MACR750511HDFRND07', '1', None, 'rodolfomc75@gmail.com', '21666025', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, None, None, 'Mexico', None, '0', None, None, None, '30010180245', 'SI000010911', '0000004', '895392.00000', '895393.00000', '.00000', '.00000', '895393.00000', '-895392.00000', '-895393.00000', '.00000', '.00000', '12433.20000', '12433.20000', '1-Jan-00', '30-Jan-15', '23-Jan-15', '23-Jan-15', '23-Jan-15', '0', None, '23-Jan-15', '23-Jan-15', '23-Jan-15', '23-Jan-15', '23-Jan-15', None, None, None, None, None, '19-Jun-15', None, None, 'CANCELACION'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP153', '2', 'ESTACIONAMIENTO', 'ALVE086', 'ALVGEEA0380', None, None, None, None, '038', None, '1', '0', 'EST GEEA', 'Cajón grande, atras doble, abajo con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Atrás doble', '0', '1', '1', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00078819', 'RODOLFO MARTINEZ CENDEJAS', 'RODOLFO', 'MARTINEZ', 'CENDEJAS', 'MACR750511BY4', 'MACR750511HDFRND07', '1', None, 'rodolfomc75@gmail.com', '21666025', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, None, None, 'Mexico', None, '0', None, None, None, '30010180245', 'SI000011021', '0000004', '1.00000', '.00000', '.00000', '.00000', '.00000', '-1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '30-Jan-15', '23-Jan-15', '23-Jan-15', '23-Jan-15', '0', None, '23-Jan-15', '23-Jan-15', '23-Jan-15', '23-Jan-15', '23-Jan-15', None, None, None, None, None, '19-Jun-15', None, None, 'CANCELACION'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP027', '1', 'DEPARTAMENTO', 'ALVD027', 'ALV0BD22030', None, None, '0B', '2', '203', None, '1', '0', 'ALV 3.3', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '13.4', None, '3.8', '2.15', None, None, None, '45.16', '0', '0', '0', None, '0', '45.16', None, None, '0', None, None, None, None, None, '1', '0', '0', '1170410', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00078931', 'DANIEL ANTONIO VAZQUEZ COVARRUBIAS', 'DANIEL ANTONIO', 'VAZQUEZ', 'COVARRUBIAS', 'VACD860923J64', 'VACD860923HDFZVN07', '0', 'H', 'DAV.COVARRUBIAS@YAHOO.COM', '57954498', '5527446103', '53879330  2339', '07058605739', '23-Sep-86', 'CASADO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '1', 'Impresos', 'PLAN DE TUXTEPEC 42 EDIF 10', '42 EDIF 10', '201', 'PLAN DE TUXTEPEC', 'GUSTAVO A. MADERO DF', 'DISTRITO FEDERAL', 'MEXICO', '07320', '4', 'MONITOR CLINICO', '1038099802105', 'IFE', '30010176664', 'SI000010534', '0000044', '849865.00000', '849866.00000', '.00000', '.00000', '849866.00000', '-849865.00000', '-849866.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '8-Oct-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '12', None, '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', None, '1-Sep-15', '14-Sep-15', None, '14-Sep-15', '28-Jul-15', None, None, 'CANCELADO'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP027', '2', 'ESTACIONAMIENTO', 'ALVE065', 'ALVGCEX0910', None, None, None, None, '091', None, '1', '0', 'EST GCEX', 'Cajón grande, atrás triple, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Atrás triple', '1', '0', '0', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00078931', 'DANIEL ANTONIO VAZQUEZ COVARRUBIAS', 'DANIEL ANTONIO', 'VAZQUEZ', 'COVARRUBIAS', 'VACD860923J64', 'VACD860923HDFZVN07', '0', 'H', 'DAV.COVARRUBIAS@YAHOO.COM', '57954498', '5527446103', '53879330  2339', '07058605739', '23-Sep-86', 'CASADO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '1', 'Impresos', 'PLAN DE TUXTEPEC 42 EDIF 10', '42 EDIF 10', '201', 'PLAN DE TUXTEPEC', 'GUSTAVO A. MADERO DF', 'DISTRITO FEDERAL', 'MEXICO', '07320', '4', 'MONITOR CLINICO', '1038099802105', 'IFE', '30010176664', 'SI000010550', '0000044', '1.00000', '.00000', '.00000', '.00000', '.00000', '-1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '8-Oct-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '12', None, '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', None, '1-Sep-15', '14-Sep-15', None, '14-Sep-15', '28-Jul-15', None, None, 'CANCELADO'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP136', '1', 'DEPARTAMENTO', 'ALVD136', 'ALV0ED00070', None, None, '0E', '0', '007', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '0', '1220720', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00079011', 'RUTH JULITA MARQUEZ ROJAS', 'RUTH JULITA', 'MARQUEZ', 'ROJAS', 'MARR780508P8A', 'MARR780508MDFRJT04', '0', 'M', 'RUTH.MARQUEZ.R@ITELCEL.COM', '66522259', '5539333227', '25813700 EXT 35', '94927445950', '8-May-78', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '109', 'GALLARDETES', '15', '278 T9', 'D 204', 'PROGRESO NACIONAL', 'GUSTAVO A. MADERO DF', 'DF', 'MEXICO', '07600', '5', 'SUPERVISOR DE EVAL DE PRODUCT.', '0998057572137', 'IFE', '30010176524', 'SI000010537', '0000043', '894919.75000', '894920.75000', '.00000', '.00000', '894920.75000', '-894919.75000', '-894920.75000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '9-Aug-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '0', None, '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', None, None, None, None, None, '24-Jul-15', None, None, 'CANCELADO'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP136', '2', 'ESTACIONAMIENTO', 'ALVE017', 'ALVCDEX0220', None, None, None, None, '022', None, '1', '0', 'EST CDEX', 'Cajón chico, adelante doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '1', '0', '0', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00079011', 'RUTH JULITA MARQUEZ ROJAS', 'RUTH JULITA', 'MARQUEZ', 'ROJAS', 'MARR780508P8A', 'MARR780508MDFRJT04', '0', 'M', 'RUTH.MARQUEZ.R@ITELCEL.COM', '66522259', '5539333227', '25813700 EXT 35', '94927445950', '8-May-78', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '109', 'GALLARDETES', '15', '278 T9', 'D 204', 'PROGRESO NACIONAL', 'GUSTAVO A. MADERO DF', 'DF', 'MEXICO', '07600', '5', 'SUPERVISOR DE EVAL DE PRODUCT.', '0998057572137', 'IFE', '30010176524', 'SI000010543', '0000043', '1.00000', '.00000', '.00000', '.00000', '.00000', '-1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '9-Aug-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '0', None, '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', None, None, None, None, None, '24-Jul-15', None, None, 'CANCELADO'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP140', '1', 'DEPARTAMENTO', 'ALVD140', 'ALV0ED11030', None, None, '0E', '1', '103', None, '1', '0', 'ALV 1.3', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '17.82', None, None, '2.28', None, None, None, '46.03', '0', '0', '0', None, '0', '46.03', None, None, '0', None, None, None, None, None, '1', '0', '0', '1252771', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00079026', 'ANGEL IVAN ROSAS FRIAS', 'ANGEL IVAN', 'ROSAS', 'FRIAS', 'ROFA870407DM7', 'ROFA840407HDFSRN08', '1', None, 'habacuc351@hotmail.com', '5557528783', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07600', '0', None, None, None, '30010176573', 'SI000010609', '00000060', '904669.78000', '904670.78000', '.00000', '.00000', '904670.78000', '-904669.78000', '-904670.78000', '.00000', '.00000', '-34260.00000', '-34260.00000', '1-Jan-00', '30-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', '0', None, '5-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', None, None, None, None, None, '30-Nov-15', None, None, 'CANCELACION'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP140', '2', 'ESTACIONAMIENTO', 'ALVE066', 'ALVGDEA0300', None, None, None, None, '030', None, '1', '0', 'EST GDEA', 'Cajón grande, adelante doble, abajo con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Adelante doble', '1', '0', '0', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00079026', 'ANGEL IVAN ROSAS FRIAS', 'ANGEL IVAN', 'ROSAS', 'FRIAS', 'ROFA870407DM7', 'ROFA840407HDFSRN08', '1', None, 'habacuc351@hotmail.com', '5557528783', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07600', '0', None, None, None, '30010176573', 'SI000010614', '00000060', '1.00000', '.00000', '.00000', '.00000', '.00000', '-1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '30-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', '0', None, '5-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', None, None, None, None, None, '30-Nov-15', None, None, 'CANCELACION'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP033', '1', 'DEPARTAMENTO', 'ALVD033', 'ALV0BD44010', None, None, '0B', '4', '401', None, '1', '0', 'ALV 3.1-C', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado, Balcón.', None, None, '2', None, '1', '1', '13.32', None, '3.8', '2.45', None, None, None, '49.47', '0', '0', '2.55', None, '0', '52.02', None, None, '0', None, None, None, None, None, '1', '0', '0', '1254237', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00079031', 'ROSA IRAZU CALLEJAS HERNANDEZ', 'ROSA IRAZU', 'CALLEJAS', 'HERNANDEZ', 'CAHR860306VC9', 'CAHR860306MDFLRS04', '1', None, 'irazucallejas@hotmail.com', '57521300', '52831300', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07320', '0', None, None, None, '30010176599', 'SI000010606', '0000094', '946802.25000', '946803.25000', '.00000', '.00000', '946803.25000', '-946802.25000', '-946803.25000', '.00000', '.00000', '-83475.00000', '-83475.00000', '1-Jan-00', '30-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', '0', None, '5-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', None, None, None, None, None, '28-Aug-15', None, None, 'CANCELADO'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP033', '2', 'ESTACIONAMIENTO', 'ALVE063', 'ALVGBEA0900', None, None, None, None, '090', None, '1', '0', 'EST GBEA', 'Cajón grande, en medio triple, abajo con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'En medio triple', '1', '0', '0', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00079031', 'ROSA IRAZU CALLEJAS HERNANDEZ', 'ROSA IRAZU', 'CALLEJAS', 'HERNANDEZ', 'CAHR860306VC9', 'CAHR860306MDFLRS04', '1', None, 'irazucallejas@hotmail.com', '57521300', '52831300', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07320', '0', None, None, None, '30010176599', 'SI000010612', '0000094', '1.00000', '.00000', '.00000', '.00000', '.00000', '-1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '30-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', '0', None, '5-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', '5-Jan-15', None, None, None, None, None, '28-Aug-15', None, None, 'CANCELADO'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP139', '1', 'DEPARTAMENTO', 'ALVD139', 'ALV0ED11020', None, None, '0E', '1', '102', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '0', '1220397', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00079104', 'MARCELINO DE LA PAZ SANCHEZ', 'MARCELINO', 'DE LA PAZ', 'SANCHEZ', 'PASM620116N81', 'PASM620116HMCZNR05', '1', None, 'ivangdelapaz@gmail.com', '22274491', '57475100', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07240', '0', None, None, None, '30010176987', 'SI000010539', '00000049', '886161.78000', '886162.78000', '.00000', '.00000', '886162.78000', '-886161.78000', '-886162.78000', '.00000', '.00000', '-79929.20000', '-79929.20000', '1-Jan-00', '30-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '0', None, '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', None, None, None, None, None, '19-Nov-15', None, None, 'CANCELACION'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP139', '2', 'ESTACIONAMIENTO', 'ALVE020', 'ALVCDEX0280', None, None, None, None, '028', None, '1', '0', 'EST CDEX', 'Cajón chico, adelante doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '1', '0', '0', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00079104', 'MARCELINO DE LA PAZ SANCHEZ', 'MARCELINO', 'DE LA PAZ', 'SANCHEZ', 'PASM620116N81', 'PASM620116HMCZNR05', '1', None, 'ivangdelapaz@gmail.com', '22274491', '57475100', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07240', '0', None, None, None, '30010176987', 'SI000010545', '00000049', '1.00000', '.00000', '.00000', '.00000', '.00000', '-1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '30-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '0', None, '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', None, None, None, None, None, '19-Nov-15', None, None, 'CANCELACION'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP131', '1', 'DEPARTAMENTO', 'ALVD131', 'ALV0ED00020', None, None, '0E', '0', '002', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '0', '1220720', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00079125', 'ALEXIS ROSAS  CORDOVA', 'ALEXIS', 'ROSAS', 'CORDOVA', 'ROCA860307KK4', 'ROCA860307HDFSRL06', '1', None, 'alexnick122@gmail.com', '51207357', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'ECATEPEC MORELOS MEX', 'MEX', 'Mexico', '55280', '0', None, None, None, '30010177050', 'SI000010536', '00000008', '894919.76000', '894920.76000', '.00000', '.00000', '894920.76000', '-894919.76000', '-894920.76000', '.00000', '.00000', '-48928.56000', '-48928.56000', '1-Jan-00', '30-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '0', None, '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', None, None, None, None, None, '22-Oct-15', None, None, 'CANCELACION'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP131', '2', 'ESTACIONAMIENTO', 'ALVE014', 'ALVCDEX0160', None, None, None, None, '016', None, '1', '0', 'EST CDEX', 'Cajón chico, adelante doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '1', '0', '0', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00079125', 'ALEXIS ROSAS  CORDOVA', 'ALEXIS', 'ROSAS', 'CORDOVA', 'ROCA860307KK4', 'ROCA860307HDFSRL06', '1', None, 'alexnick122@gmail.com', '51207357', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'ECATEPEC MORELOS MEX', 'MEX', 'Mexico', '55280', '0', None, None, None, '30010177050', 'SI000010542', '00000008', '1.00000', '.00000', '.00000', '.00000', '.00000', '-1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '30-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '0', None, '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', None, None, None, None, None, '22-Oct-15', None, None, 'CANCELACION'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP138', '1', 'DEPARTAMENTO', 'ALVD138', 'ALV0ED11010', None, None, '0E', '1', '101', None, '1', '0', 'ALV 1.2', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '16.63', None, None, '2.28', None, None, None, '49.09', '0', '0', '0', None, '0', '49.09', None, None, '0', None, None, None, None, None, '1', '0', '0', '1346853', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00079250', 'FABIAN RAMOS JUAREZ', 'FABIAN', 'RAMOS', 'JUAREZ', 'RAJF790512QQA', 'RAJF790512HDFMRB07', '1', None, 'ramos_fabian@hotmail.com', '57523803', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07300', '0', None, None, None, '30010177522', 'SI000010538', '00000003', '977984.22000', '977985.22000', '.00000', '.00000', '977985.22000', '-977984.22000', '-977985.22000', '.00000', '.00000', '-499110.78000', '-499110.78000', '1-Jan-00', '30-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '0', None, '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', None, None, None, None, None, '21-Oct-15', None, None, 'CANCELACION'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP138', '2', 'ESTACIONAMIENTO', 'ALVE019', 'ALVCDEX0260', None, None, None, None, '026', None, '1', '0', 'EST CDEX', 'Cajón chico, adelante doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '1', '0', '0', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00079250', 'FABIAN RAMOS JUAREZ', 'FABIAN', 'RAMOS', 'JUAREZ', 'RAJF790512QQA', 'RAJF790512HDFMRB07', '1', None, 'ramos_fabian@hotmail.com', '57523803', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07300', '0', None, None, None, '30010177522', 'SI000010544', '00000003', '1.00000', '.00000', '.00000', '.00000', '.00000', '-1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '30-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '0', None, '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', None, None, None, None, None, '21-Oct-15', None, None, 'CANCELACION'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP156', '1', 'DEPARTAMENTO', 'ALVD156', 'ALV0ED33030', None, None, '0E', '3', '303', None, '1', '0', 'ALV 1.3', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '17.82', None, None, '2.28', None, None, None, '46.03', '0', '0', '0', None, '0', '46.03', None, None, '0', None, None, None, None, None, '1', '0', '0', '1196153', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00079554', 'FRANCISCO JAVIER TORRES BRISEÑO', 'FRANCISCO JAVIER', 'TORRES', 'BRISEÑO', 'TOBF721209EA9', 'TOBF721209HDFRRR02', '1', None, 'fjtb2005@yahoo.com', '29240757', '55679092  ext 5', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'ZACATECAS ZAC', 'ZAC', 'Mexico', '98098', '0', None, None, None, '30010178496', 'SI000010789', '0000101', '868556.30000', '868557.30000', '.00000', '.00000', '868557.30000', '-868556.30000', '-868557.30000', '.00000', '.00000', '-10000.00000', '-10000.00000', '1-Jan-00', '30-Jan-15', '14-Jan-15', '14-Jan-15', '14-Jan-15', '0', None, '14-Jan-15', '14-Jan-15', '14-Jan-15', '14-Jan-15', '14-Jan-15', None, None, None, None, None, '11-Sep-15', None, None, 'CANCELADO'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP156', '2', 'ESTACIONAMIENTO', 'ALVE076', 'ALVGDEB0320', None, None, None, None, '032', None, '1', '0', 'EST GDEB', 'Cajón grande, adelante doble, arriba con eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Adelante doble', '1', '0', '0', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00079554', 'FRANCISCO JAVIER TORRES BRISEÑO', 'FRANCISCO JAVIER', 'TORRES', 'BRISEÑO', 'TOBF721209EA9', 'TOBF721209HDFRRR02', '1', None, 'fjtb2005@yahoo.com', '29240757', '55679092  ext 5', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'ZACATECAS ZAC', 'ZAC', 'Mexico', '98098', '0', None, None, None, '30010178496', 'SI000010790', '0000101', '1.00000', '.00000', '.00000', '.00000', '.00000', '-1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '30-Jan-15', '14-Jan-15', '14-Jan-15', '14-Jan-15', '0', None, '14-Jan-15', '14-Jan-15', '14-Jan-15', '14-Jan-15', '14-Jan-15', None, None, None, None, None, '11-Sep-15', None, None, 'CANCELADO'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP137', '1', 'DEPARTAMENTO', 'ALVD137', 'ALV0ED00080', None, None, '0E', '0', '008', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '0', '1220720', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00079731', 'MARIA DEL CARMEN MENESES TAPIA', 'MARIA DEL CARMEN', 'MENESES', 'TAPIA', 'METC511118UD7', 'METC511118MDFNPR08', '1', None, 'k.arminmeneses@live.com.mx', '18580683', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54140', '0', None, None, None, '30010181425', 'SI000011157', '00000047', '930717.00000', '930718.00000', '.00000', '.00000', '930718.00000', '-930717.00000', '-930718.00000', '.00000', '.00000', '-95000.00000', '-95000.00000', '1-Jan-00', '30-Jan-15', '4-Feb-15', '4-Feb-15', '4-Feb-15', '0', None, '4-Feb-15', '4-Feb-15', '4-Feb-15', '4-Feb-15', '4-Feb-15', None, None, None, None, None, '18-Nov-15', None, None, 'CANCELACION'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP137', '2', 'ESTACIONAMIENTO', 'ALVE018', 'ALVCDEX0240', None, None, None, None, '024', None, '1', '0', 'EST CDEX', 'Cajón chico, adelante doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '1', '0', '0', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00079731', 'MARIA DEL CARMEN MENESES TAPIA', 'MARIA DEL CARMEN', 'MENESES', 'TAPIA', 'METC511118UD7', 'METC511118MDFNPR08', '1', None, 'k.arminmeneses@live.com.mx', '18580683', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54140', '0', None, None, None, '30010181425', 'SI000011267', '00000047', '1.00000', '.00000', '.00000', '.00000', '.00000', '-1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '30-Jan-15', '4-Feb-15', '4-Feb-15', '4-Feb-15', '0', None, '4-Feb-15', '4-Feb-15', '4-Feb-15', '4-Feb-15', '4-Feb-15', None, None, None, None, None, '18-Nov-15', None, None, 'CANCELACION'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP023', '1', 'DEPARTAMENTO', 'ALVD023', 'ALV0BD11030', None, None, '0B', '1', '103', None, '1', '0', 'ALV 3.3', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '13.4', None, '3.8', '2.15', None, None, None, '45.16', '0', '0', '0', None, '0', '45.16', None, None, '0', None, None, None, None, None, '1', '0', '0', '1182850', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00079790', 'FERNANDO RODRIGUEZ DE LA CRUZ', 'FERNANDO', 'RODRIGUEZ', 'DE LA CRUZ', 'ROCF811129GP3', 'ROCF811129HVZDRR08', '1', None, 'brek29@gmail.com', '5525089087', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, None, None, 'Mexico', None, '0', None, None, None, '30010179841', 'SI000010901', '00000050', '901842.00000', '901843.00000', '.00000', '.00000', '901843.00000', '-901842.00000', '-901843.00000', '.00000', '.00000', '-70000.00000', '-70000.00000', '1-Jan-00', '30-Jan-15', '19-Jan-15', '19-Jan-15', '19-Jan-15', '0', None, '19-Jan-15', '19-Jan-15', '19-Jan-15', '19-Jan-15', '19-Jan-15', None, None, None, None, None, '19-Nov-15', None, None, 'CANCELADO'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP023', '2', 'ESTACIONAMIENTO', 'ALVE062', 'ALVGAEB0890', None, None, None, None, '089', None, '1', '0', 'EST GAEB', 'Cajon grande, adelante triple, arriba con eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Adelante triple', '1', '0', '0', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00079790', 'FERNANDO RODRIGUEZ DE LA CRUZ', 'FERNANDO', 'RODRIGUEZ', 'DE LA CRUZ', 'ROCF811129GP3', 'ROCF811129HVZDRR08', '1', None, 'brek29@gmail.com', '5525089087', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, None, None, 'Mexico', None, '0', None, None, None, '30010179841', 'SI000011024', '00000050', '1.00000', '.00000', '.00000', '.00000', '.00000', '-1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '30-Jan-15', '19-Jan-15', '19-Jan-15', '19-Jan-15', '0', None, '19-Jan-15', '19-Jan-15', '19-Jan-15', '19-Jan-15', '19-Jan-15', None, None, None, None, None, '19-Nov-15', None, None, 'CANCELADO'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP135', '1', 'DEPARTAMENTO', 'ALVD135', 'ALV0ED00060', None, None, '0E', '0', '006', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '0', '1220720', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00079864', 'TANIA RUIZ ZAMORA', 'TANIA', 'RUIZ', 'ZAMORA', 'RUZT770918ED6', 'RUZT770809MDFZMN01', '0', 'H', 'fridda77@yahoo.com.mx', '5548336869', None, None, '39937752317', '18-Sep-77', 'SOLTERO', None, 'MEXICANA', 'DF', None, '1', 'Impresos', 'CULTURA ROMANA', '1000', '19 402', 'HIPODROMO TEXTIL', 'TLALNEPANTLA MEX', 'MEXICO', 'MEXICO', '54094', '1', 'EMPLEADA', '5088047017773', 'IFE', '30010182225', '0002277', '0000060', '926116.00000', '926117.00000', '.00000', '.00000', '926117.00000', '-926116.00000', '-926117.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '23-Feb-15', '23-Feb-15', '24-Feb-15', '24-Feb-15', '12', None, '24-Feb-15', '24-Feb-15', '24-Feb-15', '24-Feb-15', '24-Feb-15', '24-Feb-15', None, None, None, None, '5-Aug-15', None, None, 'CANCELADO'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP135', '2', 'ESTACIONAMIENTO', 'ALVE016', 'ALVCDEX0200', None, None, None, None, '020', None, '1', '0', 'EST CDEX', 'Cajón chico, adelante doble, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '1', '0', '0', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00079864', 'TANIA RUIZ ZAMORA', 'TANIA', 'RUIZ', 'ZAMORA', 'RUZT770918ED6', 'RUZT770809MDFZMN01', '0', 'H', 'fridda77@yahoo.com.mx', '5548336869', None, None, '39937752317', '18-Sep-77', 'SOLTERO', None, 'MEXICANA', 'DF', None, '1', 'Impresos', 'CULTURA ROMANA', '1000', '19 402', 'HIPODROMO TEXTIL', 'TLALNEPANTLA MEX', 'MEXICO', 'MEXICO', '54094', '1', 'EMPLEADA', '5088047017773', 'IFE', '30010182225', '0002277', '0000060', '1.00000', '.00000', '.00000', '.00000', '.00000', '-1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '23-Feb-15', '23-Feb-15', '24-Feb-15', '24-Feb-15', '12', None, '24-Feb-15', '24-Feb-15', '24-Feb-15', '24-Feb-15', '24-Feb-15', '24-Feb-15', None, None, None, None, '5-Aug-15', None, None, 'CANCELADO'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP159', '1', 'DEPARTAMENTO', 'ALVD159', 'ALV0ED33060', None, None, '0E', '3', '306', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '1', '1133559', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00079870', 'ALEJANDRA MAGALI GOMEZ MENDOZA', 'ALEJANDRA MAGALI', 'GOMEZ', 'MENDOZA', 'GOMA841203DD6', 'GOMA841203MDFMNL08', '1', None, 'alejandra.gomez.1.@bbva.com', '55888834', '55144500', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'ECATEPEC MORELOS MEX', 'MEX', 'Mexico', '55340', '0', None, None, None, '30010181235', 'SI000010913', 'DEV000001258', '864262.00000', '864263.00000', '.00000', '.00000', '864263.00000', '-864262.00000', '-864263.00000', '.00000', '.00000', '10000.00000', '10000.00000', '1-Jan-00', '30-Jan-15', '29-Jan-15', '29-Jan-15', '29-Jan-15', '0', None, '29-Jan-15', '29-Jan-15', '29-Jan-15', '29-Jan-15', '29-Jan-15', None, None, None, None, None, '9-Jun-15', None, None, 'CANCELACION'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP159', '2', 'ESTACIONAMIENTO', 'ALVE101', 'ALVGEEB0310', None, None, None, None, '031', None, '1', '0', 'EST GEEB', 'Cajón grande, atras doble, arriba con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Atrás doble', '1', '0', '1', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00079870', 'ALEJANDRA MAGALI GOMEZ MENDOZA', 'ALEJANDRA MAGALI', 'GOMEZ', 'MENDOZA', 'GOMA841203DD6', 'GOMA841203MDFMNL08', '1', None, 'alejandra.gomez.1.@bbva.com', '55888834', '55144500', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'ECATEPEC MORELOS MEX', 'MEX', 'Mexico', '55340', '0', None, None, None, '30010181235', 'SI000011016', 'DEV000001258', '1.00000', '.00000', '.00000', '.00000', '.00000', '-1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '30-Jan-15', '29-Jan-15', '29-Jan-15', '29-Jan-15', '0', None, '29-Jan-15', '29-Jan-15', '29-Jan-15', '29-Jan-15', '29-Jan-15', None, None, None, None, None, '9-Jun-15', None, None, 'CANCELACION'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP130', '1', 'DEPARTAMENTO', 'ALVD130', 'ALV0ED00010', None, None, '0E', '0', '001', None, '1', '0', 'ALV 1.2', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '16.63', None, None, '2.28', None, None, None, '49.09', '0', '0', '0', None, '0', '49.09', None, None, '0', None, None, None, None, None, '1', '0', '0', '1405390', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00080289', 'ANUAR JOSUE TOLEDO CABALLERO', 'ANUAR JOSUE', 'TOLEDO', 'CABALLERO', 'TOCA831213MJ8', 'TOCA831213HDFLBN06', '1', None, 'anuarmet@yahoo.com.mx', '57664525', '53335000 ext 51', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BOSQUES DE ARAGON', 'MEX', 'MEX', 'Mexico', '57170', '0', None, None, None, '30010182779', 'SI000011154', '0000096', '1071515.03000', '1071516.03000', '.00000', '.00000', '1071516.03000', '-1071515.03000', '-1071516.03000', '.00000', '.00000', '-52067.50000', '-52067.50000', '1-Jan-00', '22-Feb-15', '12-Feb-15', '12-Feb-15', '12-Feb-15', '0', None, '12-Feb-15', '12-Feb-15', '12-Feb-15', '12-Feb-15', '12-Feb-15', None, None, None, None, None, '1-Sep-15', None, None, 'CANCELAOD'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP130', '2', 'ESTACIONAMIENTO', 'ALVE048', 'ALVCUEX0360', None, None, None, None, '036', None, '1', '0', 'EST CUEX', 'Cajón chico, único, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Único', '1', '0', '0', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00080289', 'ANUAR JOSUE TOLEDO CABALLERO', 'ANUAR JOSUE', 'TOLEDO', 'CABALLERO', 'TOCA831213MJ8', 'TOCA831213HDFLBN06', '1', None, 'anuarmet@yahoo.com.mx', '57664525', '53335000 ext 51', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BOSQUES DE ARAGON', 'MEX', 'MEX', 'Mexico', '57170', '0', None, None, None, '30010182779', 'SI000011269', '0000096', '1.00000', '.00000', '.00000', '.00000', '.00000', '-1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '22-Feb-15', '12-Feb-15', '12-Feb-15', '12-Feb-15', '0', None, '12-Feb-15', '12-Feb-15', '12-Feb-15', '12-Feb-15', '12-Feb-15', None, None, None, None, None, '1-Sep-15', None, None, 'CANCELADO'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP132', '1', 'DEPARTAMENTO', 'ALVD132', 'ALV0ED00030', None, None, '0E', '0', '003', None, '1', '0', 'ALV 1.3-B', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado, Terraza.', None, None, '2', None, '1', '0', '17.82', None, None, '2.28', None, None, None, '46.03', '0', '11.61', '0', None, '0', '57.64', None, None, '0', None, None, None, None, None, '0', '1', '1', '1413008', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00080451', 'HEVER HONORATO CERVANTES', 'HEVER', 'HONORATO', 'CERVANTES', 'HOCH801104LU7', 'HOCH801104HGRNRV02', '1', None, 'heverhc@hotmail.com', None, None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'GUSTAVO A MADERO', None, 'Mexico', None, '0', None, None, None, '30010182258', 'SI000011155', 'DEV000001159', '1077233.03000', '1077234.03000', '.00000', '.00000', '1077234.03000', '-1077233.03000', '-1077234.03000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '12-Mar-15', '6-Feb-15', '6-Feb-15', '6-Feb-15', '0', None, '6-Feb-15', '6-Feb-15', '6-Feb-15', '6-Feb-15', '6-Feb-15', None, None, None, None, None, '23-Feb-15', None, None, 'falta de solvencia'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP132', '2', 'ESTACIONAMIENTO', 'ALVE046', 'ALVCUEX0340', None, None, None, None, '034', None, '1', '0', 'EST CUEX', 'Cajón chico, único, abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Único', '0', '1', '1', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00080451', 'HEVER HONORATO CERVANTES', 'HEVER', 'HONORATO', 'CERVANTES', 'HOCH801104LU7', 'HOCH801104HGRNRV02', '1', None, 'heverhc@hotmail.com', None, None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'GUSTAVO A MADERO', None, 'Mexico', None, '0', None, None, None, '30010182258', 'SI000011268', 'DEV000001160', '1.00000', '.00000', '.00000', '.00000', '.00000', '-1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '12-Mar-15', '6-Feb-15', '6-Feb-15', '6-Feb-15', '0', None, '6-Feb-15', '6-Feb-15', '6-Feb-15', '6-Feb-15', '6-Feb-15', None, None, None, None, None, '23-Feb-15', None, None, 'falta de solvencia'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP163', '1', 'DEPARTAMENTO', 'ALVD163', 'ALV0ED44020', None, None, '0E', '4', '402', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '0', '967301', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00080849', 'FABIOLA  ANGELICA CONTRERAS CASTAÑEDA', 'FABIOLA  ANGELICA', 'CONTRERAS', 'CASTAÑEDA', 'COCF810609FZ5', None, '1', None, None, '67944534', '5528965722', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'TEPEYAC INSURGENTES', 'DF', 'DF', 'Mexico', '07020', '0', None, None, None, '30010183306', 'SI000011160', '0000120', '727501.00000', '727501.00000', '.00000', '.00000', '727501.00000', '-727501.00000', '-727501.00000', '.00000', '.00000', '-50000.00000', '-50000.00000', '1-Jan-00', '22-Feb-15', '18-Feb-15', '18-Feb-15', '18-Feb-15', '0', None, '18-Feb-15', '18-Feb-15', '18-Feb-15', '18-Feb-15', '18-Feb-15', None, None, None, None, None, '8-Oct-15', None, None, 'CANCELACION'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP147', '1', 'DEPARTAMENTO', 'ALVD147', 'ALV0ED22020', None, None, '0E', '2', '202', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '0', '1184923', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00081143', 'CARLOS ALBERTO BLANCO GARCIA', 'CARLOS ALBERTO', 'BLANCO', 'GARCIA', 'BAGC890405RN3', 'BAGC890405HDFLRR00', '0', 'H', 'CABG.10@HOTMAIL.COM', '51090249', '5551090249', '26269100', '01068909918', '5-Apr-89', 'SOLTERO', None, 'MEXICANA', 'MÉXICO D.F.', None, '8', 'Publicidad en Pto de Vta', 'AGUILUCHOS LOTE 18', '43', None, 'BOULEVARES DEL LAGO', 'NICOLAS DE ROMERO', 'ESTADO DE MÉXICO', 'MÉXICO', '54473', '0', 'GERENTE DE INTELIGENCIA DE MERADO', '3782109980678', 'IFE', '30010182845', '0003202', '0000092', '903424.00000', '903425.00000', '.00000', '.00000', '903425.00000', '-903424.00000', '-903425.00000', '.00000', '.00000', '-10000.00000', '-10000.00000', '26-Feb-15', '27-Aug-15', '27-Aug-15', '27-Aug-15', '27-Aug-15', '12', None, '27-Aug-15', '27-Aug-15', '27-Aug-15', '27-Aug-15', '27-Aug-15', None, None, None, None, None, '27-Aug-15', None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP147', '2', 'ESTACIONAMIENTO', 'ALVE041', 'ALVCEEX0230', None, None, None, None, '023', None, '1', '0', 'EST CEEX', 'Cajón chico, atrás doble., abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '1', '0', '0', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00081143', 'CARLOS ALBERTO BLANCO GARCIA', 'CARLOS ALBERTO', 'BLANCO', 'GARCIA', 'BAGC890405RN3', 'BAGC890405HDFLRR00', '0', 'H', 'CABG.10@HOTMAIL.COM', '51090249', '5551090249', '26269100', '01068909918', '5-Apr-89', 'SOLTERO', None, 'MEXICANA', 'MÉXICO D.F.', None, '8', 'Publicidad en Pto de Vta', 'AGUILUCHOS LOTE 18', '43', None, 'BOULEVARES DEL LAGO', 'NICOLAS DE ROMERO', 'ESTADO DE MÉXICO', 'MÉXICO', '54473', '0', 'GERENTE DE INTELIGENCIA DE MERADO', '3782109980678', 'IFE', '30010182845', '0003202', '0000092', '1.00000', '.00000', '.00000', '.00000', '.00000', '-1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '26-Feb-15', '27-Aug-15', '27-Aug-15', '27-Aug-15', '27-Aug-15', '12', None, '27-Aug-15', '27-Aug-15', '27-Aug-15', '27-Aug-15', '27-Aug-15', None, None, None, None, None, '27-Aug-15', None, None, None), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP147', '1', 'DEPARTAMENTO', 'ALVD147', 'ALV0ED22020', None, None, '0E', '2', '202', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '0', '1184923', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00081143', 'CARLOS ALBERTO BLANCO GARCIA', 'CARLOS ALBERTO', 'BLANCO', 'GARCIA', 'BAGC890405RN3', 'BAGC890405HDFLRR00', '0', 'H', 'CABG.10@HOTMAIL.COM', '51090249', '5551090249', '26269100', '01068909918', '5-Apr-89', 'SOLTERO', None, 'MEXICANA', 'MÉXICO D.F.', None, '8', 'Publicidad en Pto de Vta', 'AGUILUCHOS LOTE 18', '43', None, 'BOULEVARES DEL LAGO', 'NICOLAS DE ROMERO', 'ESTADO DE MÉXICO', 'MÉXICO', '54473', '0', 'GERENTE DE INTELIGENCIA DE MERADO', '3782109980678', 'IFE', '70010182845', '0002266', '0000086', '996026.00000', '996027.00000', '.00000', '.00000', '996027.00000', '-996026.00000', '-996027.00000', '.00000', '.00000', '10000.00000', '10000.00000', '26-Feb-15', '27-Aug-15', '26-Feb-15', '26-Feb-15', '24-Feb-15', '12', None, '27-Feb-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', None, None, None, None, None, '21-Aug-15', None, None, 'CANCELADO POR ERROR EN PRECIO DE FACTURA'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP147', '2', 'ESTACIONAMIENTO', 'ALVE041', 'ALVCEEX0230', None, None, None, None, '023', None, '1', '0', 'EST CEEX', 'Cajón chico, atrás doble., abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '1', '0', '0', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00081143', 'CARLOS ALBERTO BLANCO GARCIA', 'CARLOS ALBERTO', 'BLANCO', 'GARCIA', 'BAGC890405RN3', 'BAGC890405HDFLRR00', '0', 'H', 'CABG.10@HOTMAIL.COM', '51090249', '5551090249', '26269100', '01068909918', '5-Apr-89', 'SOLTERO', None, 'MEXICANA', 'MÉXICO D.F.', None, '8', 'Publicidad en Pto de Vta', 'AGUILUCHOS LOTE 18', '43', None, 'BOULEVARES DEL LAGO', 'NICOLAS DE ROMERO', 'ESTADO DE MÉXICO', 'MÉXICO', '54473', '0', 'GERENTE DE INTELIGENCIA DE MERADO', '3782109980678', 'IFE', '70010182845', '0002266', '0000086', '1.00000', '.00000', '.00000', '.00000', '.00000', '-1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '26-Feb-15', '27-Aug-15', '26-Feb-15', '26-Feb-15', '24-Feb-15', '12', None, '27-Feb-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', None, None, None, None, None, '21-Aug-15', None, None, 'CANCELADO POR ERROR EN PRECIO DE FACTURA'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP065', '1', 'DEPARTAMENTO', 'ALVD065', 'ALV0CD33050', None, None, '0C', '3', '305', None, '1', '0', 'ALV 1.1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '13.9', None, '4.11', '2.16', None, None, None, '47.05', '0', '0', '0', None, '0', '47.05', None, None, '0', None, None, None, None, None, '1', '0', '0', '1247951', '10000', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00081144', 'JESICA SUHEIL MERCADO ALARCON', 'JESICA SUHEIL', 'MERCADO', 'ALARCON', 'MEAJ790108RZ6', 'MEAJ790108MDFRLS05', '0', 'M', None, '5553887849', '5512954129', '5557221000', '68977922720', '1-Feb-79', 'CASADO', None, 'MEXICANA', 'MEXICO DF', None, '10', 'Buscando en Google', 'ADN DEL  TEMOLUCO  31', 'EDIF 33', 'DEP 102', 'ACUEDUCTO DE GUADALUPE', 'GUSTAVO A MADERO', 'DISTRITO FEDERAL', 'MEXICO', '07279', '10', 'EMPLEADO', '0961011969696', 'IFE', '30010183660', '0002267', '00000033', '999052.00000', '999053.00000', '.00000', '.00000', '999053.00000', '-999052.00000', '-999053.00000', '.00000', '.00000', '-27473.80000', '-27473.80000', '26-Feb-15', '26-Feb-15', '26-Feb-15', '26-Feb-15', '24-Feb-15', '12', None, '27-Feb-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', None, None, None, None, None, '10-Nov-15', None, None, 'CANCELACION'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP065', '2', 'ESTACIONAMIENTO', 'ALVE073', 'ALVGDEA0630', None, None, None, None, '063', None, '1', '0', 'EST GDEA', 'Cajón grande, adelante doble, abajo con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Adelante doble', '1', '0', '0', '1', '0', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00081144', 'JESICA SUHEIL MERCADO ALARCON', 'JESICA SUHEIL', 'MERCADO', 'ALARCON', 'MEAJ790108RZ6', 'MEAJ790108MDFRLS05', '0', 'M', None, '5553887849', '5512954129', '5557221000', '68977922720', '1-Feb-79', 'CASADO', None, 'MEXICANA', 'MEXICO DF', None, '10', 'Buscando en Google', 'ADN DEL  TEMOLUCO  31', 'EDIF 33', 'DEP 102', 'ACUEDUCTO DE GUADALUPE', 'GUSTAVO A MADERO', 'DISTRITO FEDERAL', 'MEXICO', '07279', '10', 'EMPLEADO', '0961011969696', 'IFE', '30010183660', '0002267', '00000033', '1.00000', '.00000', '.00000', '.00000', '.00000', '-1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '26-Feb-15', '26-Feb-15', '26-Feb-15', '26-Feb-15', '24-Feb-15', '12', None, '27-Feb-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', None, None, None, None, None, '10-Nov-15', None, None, 'CANCELACION'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP060', '1', 'DEPARTAMENTO', 'ALVD060', 'ALV0CD22070', None, None, '0C', '2', '207', None, '1', '0', 'ALV 5-C', 'Estancia, Comedor, 1 Recámara, Alcoba, Baño, Cocina, Cuarto de lavado, Balcón.', None, None, '1', '1', '1', '1', '15.01', None, '3.67', '2.16', None, None, None, '59.11', '0', '0', '1.77', None, '0', '60.88', None, None, '0', None, None, None, None, None, '1', '0', '1', '1669418', '10000', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00081153', 'LUIS RICARDO RAMIREZ SAAVEDRA', 'LUIS RICARDO', 'RAMIREZ', 'SAAVEDRA', 'RASL750403380', 'RASL750403HDFMVS01', '0', 'H', 'MCHJM2012@HOTMAIL.COM', '1111111111', '5539401148', '1111111111', None, '3-Apr-75', 'SOLTERO', None, 'MEXICANA', 'DF', None, '3', 'Gallardete', 'MAPIMI', '65', 'NA', 'VALLE GOMEZ', 'CUAUHTEMOC', 'DF', 'MEXICO', '00000', '2', 'CONTADOR', '0554123693735', 'IFE', '30010184072', '0002033', 'DEV000001208', '1336458.00000', '1336460.00000', '.00000', '.00000', '1336460.00000', '-1336458.00000', '-1336460.00000', '.00000', '-228801.96000', '.00000', '-228801.96000', '26-Feb-15', '20-Jun-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', '0', None, '5-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', None, None, None, None, None, '8-Apr-15', None, None, 'CANCELADO POR FALTA DE RECURSOS'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP060', '2', 'ESTACIONAMIENTO', 'ALVE056', 'ALVEDEX0590', None, None, None, None, '059', None, '1', '0', 'EST EDEX', 'Discapacitados compartido, adelante doble', None, None, None, None, None, None, None, None, None, None, None, None, None, '15.5', None, None, None, None, None, None, '3.1', None, '0', None, None, 'Discapacitado Compart', 'Abajo sin eleva autos', 'Adelante doble', '1', '0', '1', '1', '0', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00081153', 'LUIS RICARDO RAMIREZ SAAVEDRA', 'LUIS RICARDO', 'RAMIREZ', 'SAAVEDRA', 'RASL750403380', 'RASL750403HDFMVS01', '0', 'H', 'MCHJM2012@HOTMAIL.COM', '1111111111', '5539401148', '1111111111', None, '3-Apr-75', 'SOLTERO', None, 'MEXICANA', 'DF', None, '3', 'Gallardete', 'MAPIMI', '65', 'NA', 'VALLE GOMEZ', 'CUAUHTEMOC', 'DF', 'MEXICO', '00000', '2', 'CONTADOR', '0554123693735', 'IFE', '30010184072', '0002033', 'DEV000001208', '1.00000', '.00000', '.00000', '.00000', '.00000', '-1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '26-Feb-15', '20-Jun-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', '0', None, '5-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', None, None, None, None, None, '8-Apr-15', None, None, 'CANCELADO POR FALTA DE RECURSOS'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP060', '3', 'BODEGA', 'ALVB001', 'ALV00BD0010', None, None, None, None, '001', None, '1', '0', 'ALV B 2.72', 'bodega de 2.72 m2', None, None, None, None, None, None, None, None, None, None, None, None, None, '2.72', None, None, None, None, None, None, None, None, '0', None, None, None, None, None, '1', '0', '0', '1', '0', '0', '0', '20-Jun-16', '20-Jun-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00081153', 'LUIS RICARDO RAMIREZ SAAVEDRA', 'LUIS RICARDO', 'RAMIREZ', 'SAAVEDRA', 'RASL750403380', 'RASL750403HDFMVS01', '0', 'H', 'MCHJM2012@HOTMAIL.COM', '1111111111', '5539401148', '1111111111', None, '3-Apr-75', 'SOLTERO', None, 'MEXICANA', 'DF', None, '3', 'Gallardete', 'MAPIMI', '65', 'NA', 'VALLE GOMEZ', 'CUAUHTEMOC', 'DF', 'MEXICO', '00000', '2', 'CONTADOR', '0554123693735', 'IFE', '30010184072', '0002033', 'DEV000001208', '1.00000', '.00000', '.00000', '.00000', '.00000', '-1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '26-Feb-15', '20-Jun-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', '0', None, '5-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', None, None, None, None, None, '8-Apr-15', None, None, 'CANCELADO POR FALTA DE RECURSOS'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP162', '1', 'DEPARTAMENTO', 'ALVD162', 'ALV0ED44010', None, None, '0E', '4', '401', None, '1', '0', 'ALV 1.2', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '16.63', None, None, '2.28', None, None, None, '49.09', '0', '0', '0', None, '0', '49.09', None, None, '0', None, None, None, None, None, '1', '0', '0', '1195849', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00081366', 'BERENICE VERUETE JIMENEZ', 'BERENICE', 'VERUETE', 'JIMENEZ', 'VEJB740529C44', 'VEJB740529MDFRMR02', '0', 'M', 'bereveruete@gmail.com', '57544525', '5522559552', '57296000', None, '29-May-74', 'SOLTERO', None, 'MEXICANA', 'MEXICO D.F.', None, '2', 'Volante', 'COQUIMBO', '639 A', None, 'LINDAVISTA', 'GUSTAVO A MADERO', 'DISTRITO FEDERAL', 'MEXICO', '07300', '8', 'MEDICO', '1295045296146', 'IFE', '30020108962', '0002652', '0000102', '1105731.00000', '1105732.00000', '.00000', '.00000', '1105732.00000', '-1105731.00000', '-1105732.00000', '.00000', '.00000', '-137044.54000', '-137044.54000', '4-Mar-15', '8-Apr-15', '8-Apr-15', '30-Mar-15', '30-Mar-15', '12', None, '14-Apr-15', '14-Apr-15', '14-Apr-15', '17-Apr-15', '17-Apr-15', '13-Apr-15', None, None, None, None, '15-Sep-15', None, None, 'CANCELADO'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP162', '2', 'ESTACIONAMIENTO', 'ALVE104', 'ALVGEEB0400', None, None, None, None, '040', None, '1', '0', 'EST GEEB', 'Cajón grande, atras doble, arriba con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Atrás doble', '1', '0', '0', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00081366', 'BERENICE VERUETE JIMENEZ', 'BERENICE', 'VERUETE', 'JIMENEZ', 'VEJB740529C44', 'VEJB740529MDFRMR02', '0', 'M', 'bereveruete@gmail.com', '57544525', '5522559552', '57296000', None, '29-May-74', 'SOLTERO', None, 'MEXICANA', 'MEXICO D.F.', None, '2', 'Volante', 'COQUIMBO', '639 A', None, 'LINDAVISTA', 'GUSTAVO A MADERO', 'DISTRITO FEDERAL', 'MEXICO', '07300', '8', 'MEDICO', '1295045296146', 'IFE', '30020108962', '0002652', '0000102', '1.00000', '.00000', '.00000', '.00000', '.00000', '-1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '4-Mar-15', '8-Apr-15', '8-Apr-15', '30-Mar-15', '30-Mar-15', '12', None, '14-Apr-15', '14-Apr-15', '14-Apr-15', '17-Apr-15', '17-Apr-15', '13-Apr-15', None, None, None, None, '15-Sep-15', None, None, 'CANCELADO'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP037', '1', 'DEPARTAMENTO', 'ALVD037', 'ALV0BD55010', None, None, '0B', '5', '501', None, '1', '0', 'ALV 3.1-C', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado, Balcón.', None, None, '2', None, '1', '1', '13.32', None, '3.8', '2.45', None, None, None, '49.47', '0', '0', '2.55', None, '0', '52.02', None, None, '0', None, None, None, None, None, '1', '0', '0', '1241130', '10000', '0', '0', '20-Feb-16', '20-Feb-16', '24-May-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00081524', 'SUSANA GONZALEZ GUERRERO', 'SUSANA', 'GONZALEZ', 'GUERRERO', 'GOGS820601UQ5', 'GOGS820601MDFRS02', '0', 'H', 'susana_politicas@hotmail.com', '55471467', '0445536467443', None, None, '1-Jun-82', 'SOLTERO', None, 'MEXICANO', 'MEXICO  D,F.', None, '8', 'Publicidad en Pto de Vta', 'STA MA LA RIBERA', '148', '12', 'SANTA MARIA LA RIBERA', 'CUAHUTEMOC', 'D,F', 'MEXICO', '06400', '32', 'EMPLEADA', '4648014548831', 'IFE', '30020106909', '0002525', '00000083', '1132599.20000', '1132600.20000', '.00000', '.00000', '1132600.20000', '-1132599.20000', '-1132600.20000', '.00000', '.00000', '-12000.00000', '-12000.00000', '10-Mar-15', '12-Mar-15', '22-Mar-15', '20-Mar-15', '23-Mar-15', '12', None, '30-Mar-15', '30-Mar-15', '1-Apr-15', '6-Apr-15', '6-Apr-15', None, None, None, None, None, '9-Dec-15', None, None, 'CANCELACION'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP037', '2', 'ESTACIONAMIENTO', 'ALVE117', 'ALVGEEB0880', None, None, None, None, '088', None, '1', '0', 'EST GEEB', 'Cajón grande, atras doble, arriba con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Atrás doble', '1', '0', '0', '1', '0', '0', '0', '20-Feb-16', '20-Feb-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00081524', 'SUSANA GONZALEZ GUERRERO', 'SUSANA', 'GONZALEZ', 'GUERRERO', 'GOGS820601UQ5', 'GOGS820601MDFRS02', '0', 'H', 'susana_politicas@hotmail.com', '55471467', '0445536467443', None, None, '1-Jun-82', 'SOLTERO', None, 'MEXICANO', 'MEXICO  D,F.', None, '8', 'Publicidad en Pto de Vta', 'STA MA LA RIBERA', '148', '12', 'SANTA MARIA LA RIBERA', 'CUAHUTEMOC', 'D,F', 'MEXICO', '06400', '32', 'EMPLEADA', '4648014548831', 'IFE', '30020106909', '0002525', '00000083', '1.00000', '.00000', '.00000', '.00000', '.00000', '-1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '10-Mar-15', '12-Mar-15', '22-Mar-15', '20-Mar-15', '23-Mar-15', '12', None, '30-Mar-15', '30-Mar-15', '1-Apr-15', '6-Apr-15', '6-Apr-15', None, None, None, None, None, '9-Dec-15', None, None, 'CANCELACION'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP043', '1', 'DEPARTAMENTO', 'ALVD043', 'ALV0CD00030', None, None, '0C', '0', '003', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '0', '1187098', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00081556', 'FRANCISCO TELLEZ MORENO', 'FRANCISCO', 'TELLEZ', 'MORENO', 'TEMF6308205U3', 'TEMF630820HDFLRR06', '0', 'H', 'ftellezmor@gmail.com', '5553922677', '4441309560', '52805262', None, '20-Aug-63', 'CASADO', None, 'MEXICANO', 'DISTRITO FEDERAL', None, '3', 'Gallardete', 'CALLE 314', '114', '114', 'NUEVA AZCAPOTZALCO', 'GUSTAVO A MADERO', 'MEXICO DF', 'MEXICO', '07420', '20', 'EMPLEADO', '0444116040577', 'IFE', '30020105406', '0002429', '00000076', '1097638.30000', '1097639.30000', '.00000', '.00000', '1097639.30000', '-1097638.30000', '-1097639.30000', '.00000', '.00000', '-56751.36000', '-56751.36000', '11-Mar-15', '25-Mar-15', '19-Mar-15', '12-Mar-15', '12-Mar-15', '12', None, '25-Mar-15', '25-Mar-15', '25-Mar-15', '30-Mar-15', '30-Mar-15', '5-Mar-15', None, None, None, None, '8-Dec-15', None, None, 'CANCELADO'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP043', '2', 'ESTACIONAMIENTO', 'ALVE099', 'ALVGEEA0820', None, None, None, None, '082', None, '1', '0', 'EST GEEA', 'Cajón grande, atras doble, abajo con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Atrás doble', '1', '0', '0', '1', '0', '0', '0', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00081556', 'FRANCISCO TELLEZ MORENO', 'FRANCISCO', 'TELLEZ', 'MORENO', 'TEMF6308205U3', 'TEMF630820HDFLRR06', '0', 'H', 'ftellezmor@gmail.com', '5553922677', '4441309560', '52805262', None, '20-Aug-63', 'CASADO', None, 'MEXICANO', 'DISTRITO FEDERAL', None, '3', 'Gallardete', 'CALLE 314', '114', '114', 'NUEVA AZCAPOTZALCO', 'GUSTAVO A MADERO', 'MEXICO DF', 'MEXICO', '07420', '20', 'EMPLEADO', '0444116040577', 'IFE', '30020105406', '0002429', '00000076', '1.00000', '.00000', '.00000', '.00000', '.00000', '-1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '11-Mar-15', '25-Mar-15', '19-Mar-15', '12-Mar-15', '12-Mar-15', '12', None, '25-Mar-15', '25-Mar-15', '25-Mar-15', '30-Mar-15', '30-Mar-15', '5-Mar-15', None, None, None, None, '8-Dec-15', None, None, 'CANCELADO'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP050', '1', 'DEPARTAMENTO', 'ALVD050', 'ALV0CD11040', None, None, '0C', '1', '104', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '0', '1160698', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00081626', 'RAFAEL TROVAMALA LANDA', 'RAFAEL', 'TROVAMALA', 'LANDA', 'TOLR550913ML9', 'TOLR550913HDFRNF04', '0', 'H', 'loretamala@hotmail.com', '5557949916', '5531179205', None, None, '13-Sep-55', 'SOLTERO', None, 'MEXICANA', 'MEXICO DF', None, '17', 'Guía D Inmuebles', 'INSURGENTES NORTE 148B', '148 B', None, 'SANTA MARIA LA RIVERA', 'CUAUHTEMOC', 'DF', 'MEXICO', '06400', '15', 'PROFESOR', '4614008662508', 'PASAPORTE', '30020105893', '0002519', '00000048', '1073228.20000', '1073229.20000', '.00000', '.00000', '1073229.20000', '-1073228.20000', '-1073229.20000', '.00000', '.00000', '-10000.00000', '-10000.00000', '14-Mar-15', '27-Mar-15', '27-Mar-15', '14-Mar-15', '18-Mar-15', '12', None, '30-Mar-15', '30-Mar-15', '1-Apr-15', '6-Apr-15', '6-Apr-15', '5-Mar-15', None, None, None, None, '18-Nov-15', None, None, 'CANCELADO'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP050', '2', 'ESTACIONAMIENTO', 'ALVE113', 'ALVGEEB0760', None, None, None, None, '076', None, '1', '0', 'EST GEEB', 'Cajón grande, atras doble, arriba con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Atrás doble', '1', '0', '0', '1', '0', '0', '0', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00081626', 'RAFAEL TROVAMALA LANDA', 'RAFAEL', 'TROVAMALA', 'LANDA', 'TOLR550913ML9', 'TOLR550913HDFRNF04', '0', 'H', 'loretamala@hotmail.com', '5557949916', '5531179205', None, None, '13-Sep-55', 'SOLTERO', None, 'MEXICANA', 'MEXICO DF', None, '17', 'Guía D Inmuebles', 'INSURGENTES NORTE 148B', '148 B', None, 'SANTA MARIA LA RIVERA', 'CUAUHTEMOC', 'DF', 'MEXICO', '06400', '15', 'PROFESOR', '4614008662508', 'PASAPORTE', '30020105893', '0002519', '00000048', '1.00000', '.00000', '.00000', '.00000', '.00000', '-1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '14-Mar-15', '27-Mar-15', '27-Mar-15', '14-Mar-15', '18-Mar-15', '12', None, '30-Mar-15', '30-Mar-15', '1-Apr-15', '6-Apr-15', '6-Apr-15', '5-Mar-15', None, None, None, None, '18-Nov-15', None, None, 'CANCELADO'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP054', '1', 'DEPARTAMENTO', 'ALVD054', 'ALV0CD22010', None, None, '0C', '2', '201', None, '1', '0', 'ALV 1I', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '0', '1148636', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00081826', 'LEOPOLDO OCHOA RICO', 'LEOPOLDO', 'OCHOA', 'RICO', 'OORL60092395A', 'OORL600923HDFCCP09', '0', 'H', 'leopoldo2309@hotmail.com', '57738685', '5535221637', '57212222', '06856006504', '23-Sep-60', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '8', 'Publicidad en Pto de Vta', 'FELIPE DE LA GARZA', '369', None, 'JUAN ESCUTIA', 'IZTAPALAPA', 'MEXICO', 'MEXICO', '09100', '21', 'LIDER DE PROYECTO', '2065004841004', 'IFE', '30020107246', '0002529', '00000085', '1062075.30000', '1062076.30000', '.00000', '.00000', '1062076.30000', '-1062075.30000', '-1062076.30000', '.00000', '.00000', '-33748.36000', '-33748.36000', '22-Mar-15', '27-Mar-15', '30-Mar-15', '30-Mar-15', '30-Mar-15', '12', None, '30-Mar-15', '30-Mar-15', '30-Mar-15', '1-Apr-15', '1-Apr-15', None, None, None, None, None, '11-Dec-15', None, None, 'CANCELADO'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP054', '2', 'ESTACIONAMIENTO', 'ALVE114', 'ALVGEEB0780', None, None, None, None, '078', None, '1', '0', 'EST GEEB', 'Cajón grande, atras doble, arriba con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Atrás doble', '1', '0', '0', '1', '0', '0', '0', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00081826', 'LEOPOLDO OCHOA RICO', 'LEOPOLDO', 'OCHOA', 'RICO', 'OORL60092395A', 'OORL600923HDFCCP09', '0', 'H', 'leopoldo2309@hotmail.com', '57738685', '5535221637', '57212222', '06856006504', '23-Sep-60', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '8', 'Publicidad en Pto de Vta', 'FELIPE DE LA GARZA', '369', None, 'JUAN ESCUTIA', 'IZTAPALAPA', 'MEXICO', 'MEXICO', '09100', '21', 'LIDER DE PROYECTO', '2065004841004', 'IFE', '30020107246', '0002529', '00000085', '1.00000', '.00000', '.00000', '.00000', '.00000', '-1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '22-Mar-15', '27-Mar-15', '30-Mar-15', '30-Mar-15', '30-Mar-15', '12', None, '30-Mar-15', '30-Mar-15', '30-Mar-15', '1-Apr-15', '1-Apr-15', None, None, None, None, None, '11-Dec-15', None, None, 'CANCELADO'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP048', '1', 'DEPARTAMENTO', 'ALVD048', 'ALV0CD11020', None, None, '0C', '1', '102', None, '1', '0', 'ALV 1D', 'Estancia, Comedor, 2 Recámaras, Baño, Cocina, Cuarto de lavado.', None, None, '2', None, '1', '0', '14.49', None, None, '2.16', None, None, None, '43.79', '0', '0', '0', None, '0', '43.79', None, None, '0', None, None, None, None, None, '1', '0', '0', '1160698', '10000', '0', '0', '20-Oct-16', '20-Oct-16', '22-Jan-16', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00081960', 'MARIA ALICIA GASCA MARTINEZ', 'MARIA ALICIA', 'GASCA', 'MARTINEZ', 'GAMA531205ST9', 'GAMA531205MBCSRL07', '0', 'H', 'agasca@mnyl.com.mx', '55673970', '5532742100', '53269147', None, '5-Dec-53', 'SOLTERO', None, 'MEXICANA', 'MIXICALI BAJA CALIFORNIA', None, '3', 'Gallardete', 'MANZANA 2 EDIF 35', 'ENTRADA E', '304', 'UNIDAD LINDAVISTA', 'GUSTAVO A MADERO', 'DISTRITO FEDERAL', 'MEXICO', '07720', '30', 'EMPLEADA', '1455005552728', 'IFE', '30020111446', '0002654', '0000039', '1073229.00000', '1073230.00000', '.00000', '.00000', '1073230.00000', '-1073229.00000', '-1073230.00000', '.00000', '.00000', '.00000', '.00000', '27-Mar-15', '27-Mar-15', '8-Apr-15', '9-Apr-15', '10-Apr-15', '12', None, '11-Apr-15', '13-Apr-15', '14-Apr-15', '17-Apr-15', '17-Apr-15', None, None, None, None, None, '24-Jul-15', None, None, 'CANCELADO'), ('ALV', 'Altos Lindavista', 'Guanajuato # 85', None, 'San Bartolo Atepehuacan', 'Gustavo A. Madero', 'Distrito Federal', '07730', 'Mexico', '0531', 'ALVP048', '2', 'ESTACIONAMIENTO', 'ALVE107', 'ALVGEEB0620', None, None, None, None, '062', None, '1', '0', 'EST GEEB', 'Cajón grande, atras doble, arriba con eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Atrás doble', '1', '0', '0', '1', '0', '0', '0', '20-Oct-16', '20-Oct-16', '22-Sep-15', 'LIBERADO', 'ACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00081960', 'MARIA ALICIA GASCA MARTINEZ', 'MARIA ALICIA', 'GASCA', 'MARTINEZ', 'GAMA531205ST9', 'GAMA531205MBCSRL07', '0', 'H', 'agasca@mnyl.com.mx', '55673970', '5532742100', '53269147', None, '5-Dec-53', 'SOLTERO', None, 'MEXICANA', 'MIXICALI BAJA CALIFORNIA', None, '3', 'Gallardete', 'MANZANA 2 EDIF 35', 'ENTRADA E', '304', 'UNIDAD LINDAVISTA', 'GUSTAVO A MADERO', 'DISTRITO FEDERAL', 'MEXICO', '07720', '30', 'EMPLEADA', '1455005552728', 'IFE', '30020111446', '0002654', '0000039', '1.00000', '.00000', '.00000', '.00000', '.00000', '-1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '27-Mar-15', '27-Mar-15', '8-Apr-15', '9-Apr-15', '10-Apr-15', '12', None, '11-Apr-15', '13-Apr-15', '14-Apr-15', '17-Apr-15', '17-Apr-15', None, None, None, None, None, '24-Jul-15', None, None, 'CANCELADO'), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP001', '1', 'DEPARTAMENTO', 'AMOD001', 'AMO0UD00020', None, None, '0U', '0', '002', None, '1', '0', 'AMO A', 'sala/comedor,cocina, dos recámaras, 2 baños, vestidor, patio de lavado y jardín privado', None, None, '2', 'n/a', '2', '1', '22.45', None, '5.97', '2.46', 'n/a', None, None, '74.74', None, '0', '0', '8.47', '0', '83.21', None, None, '0', None, None, None, None, None, '0', '1', '1', '2,665,816.00 ', '25,000.00 ', '175,000.00 ', '399,872.00 ', '20-Jan-15', '20-Jan-15', '24-Jul-14', 'LIBERADO', 'INACTIVO', 'VENTA', '011-LIBERADA', 'PV00068834', 'OSCAR RUBIO RIOS', 'OSCAR', 'RUBIO', 'RIOS', 'RURO5411076T6', 'RURO541107HDFBSS03', '1', None, 'oscar.rubio@habitavi.com', '5544844738', '52035700 ext 25', '5544844738', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'U CTM CULHUACAN SECC 6', 'COYOACÁN DF', 'DF', 'Mexico', '04480', '0', None, None, None, '30000029063', 'SI000004602', None, '2621011.57000', '2844111.58000', '.00000', '.00000', '2844111.58000', '.00000', '.00000', '184867.52000', '.00000', '-2844111.57000', '184867.53000', '15-Jan-15', '15-Jan-15', '9-May-14', '9-May-14', '9-May-14', '12', None, '9-May-14', '9-May-14', '9-May-14', '9-May-14', '9-May-14', None, '1-Oct-15', '1-Oct-15', None, '30-Sep-15', None, '1-Dec-15', None, None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP001', '2', 'ESTACIONAMIENTO', 'AMOE020', 'AMOCDEX0120', None, None, '0U', None, '012', None, '1', '0', 'EST CDEX', 'Cajón Chico, Adelante Triple, Abajo sin eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante Triple', '0', '1', '1', '230,000.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Mar-15', '20-Mar-15', '21-Sep-14', 'LIBERADO', 'INACTIVO', 'VENTA', '011-LIBERADA', 'PV00068834', 'OSCAR RUBIO RIOS', 'OSCAR', 'RUBIO', 'RIOS', 'RURO5411076T6', 'RURO541107HDFBSS03', '1', None, 'oscar.rubio@habitavi.com', '5544844738', '52035700 ext 25', '5544844738', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'U CTM CULHUACAN SECC 6', 'COYOACÁN DF', 'DF', 'Mexico', '04480', '0', None, None, None, '30000029063', 'SI000004913', None, '223100.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '20-Jun-14', '20-Jun-14', '20-Jun-14', '12', None, '20-Jun-14', '20-Jun-14', '20-Jun-14', '20-Jun-14', '20-Jun-14', None, '1-Oct-15', '1-Oct-15', None, '30-Sep-15', None, '1-Dec-15', None, None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP001', '2', 'ESTACIONAMIENTO', 'AMOE021', 'AMOCEEX0130', None, None, '0U', None, '013', None, '1', '0', 'EST CEEX', 'Cajón Chico, Atrás doble, Abajo sin eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Mar-15', '20-Mar-15', '21-Sep-14', 'LIBERADO', 'INACTIVO', 'VENTA', '011-LIBERADA', 'PV00068834', 'OSCAR RUBIO RIOS', 'OSCAR', 'RUBIO', 'RIOS', 'RURO5411076T6', 'RURO541107HDFBSS03', '1', None, 'oscar.rubio@habitavi.com', '5544844738', '52035700 ext 25', '5544844738', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'U CTM CULHUACAN SECC 6', 'COYOACÁN DF', 'DF', 'Mexico', '04480', '0', None, None, None, '30000029063', 'SI000004914', None, '.01000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '20-Jun-14', '20-Jun-14', '20-Jun-14', '12', None, '20-Jun-14', '20-Jun-14', '20-Jun-14', '20-Jun-14', '20-Jun-14', None, '1-Oct-15', '1-Oct-15', None, '30-Sep-15', None, '1-Dec-15', None, None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP014', '1', 'DEPARTAMENTO', 'AMOD014', 'AMO0UD33030', None, None, '0U', '3', '303', None, '1', '0', 'AMO D2', 'sala/comedor,cocina, dos recámaras, 2 baños, vestidor, patio de lavado y esc. int. a roof garden', None, None, '2', 'n/a', '2', '0', '25.13', None, '5.95', '2.43', 'n/a', None, None, '78.49', None, '0', '0', None, '78.49', '156.98', None, None, '0', None, None, None, None, None, '0', '1', '1', '3,230,841.00 ', '25,000.00 ', '175,000.00 ', '484,626.00 ', '20-Jan-15', '20-Jan-15', '24-Jul-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00062618', 'DONACIANO VERA LOPEZ', 'DONACIANO', 'VERA', 'LOPEZ', 'VELD540706D30', 'VELD540706HDFRPN02', '0', 'H', 'DONACIANO.VERA@DRAGADOSMX.COM', '57990684', '36403166', '5514733297', None, '6-Jul-54', 'CASADO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '1', 'Impresos', 'BOSQUES DE CAMERUN', '29', None, 'BOSQUES DE ARAGON', 'NEZAHUALCÓYOTL MEX', 'MEX', 'MEXICO', '57170', '5', 'EMPLEADO', '1538010637164', 'IFE', '30020106677', '0002407', None, '3161109.90000', '3391110.00000', '.00000', '.00000', '3391110.00000', '.00000', '.00000', '237377.70000', '.00000', '.00000', '3628487.70000', '1-Jan-00', '20-Jun-15', '18-Mar-15', '18-Mar-15', '20-Mar-15', '12', None, '1-Apr-15', '1-Apr-15', '1-Apr-15', '1-Apr-15', '1-Apr-15', None, '10-Apr-15', '10-Apr-15', None, '14-May-15', None, '6-May-15', '19-May-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP014', '2', 'ESTACIONAMIENTO', 'AMOE009', 'AMOCDEX0050', None, None, '0U', None, '005', None, '1', '0', 'EST CDEX', 'Cajón Chico, Adelante Triple, Abajo sin eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante Triple', '0', '1', '1', '230,000.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-15', '20-Feb-15', '24-Aug-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00062618', 'DONACIANO VERA LOPEZ', 'DONACIANO', 'VERA', 'LOPEZ', 'VELD540706D30', 'VELD540706HDFRPN02', '0', 'H', 'DONACIANO.VERA@DRAGADOSMX.COM', '57990684', '36403166', '5514733297', None, '6-Jul-54', 'CASADO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '1', 'Impresos', 'BOSQUES DE CAMERUN', '29', None, 'BOSQUES DE ARAGON', 'NEZAHUALCÓYOTL MEX', 'MEX', 'MEXICO', '57170', '5', 'EMPLEADO', '1538010637164', 'IFE', '30020106677', '0002407', None, '230000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '20-Jun-15', '18-Mar-15', '18-Mar-15', '20-Mar-15', '12', None, '1-Apr-15', '1-Apr-15', '1-Apr-15', '1-Apr-15', '1-Apr-15', None, '10-Apr-15', '10-Apr-15', None, '14-May-15', None, '6-May-15', '19-May-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP014', '2', 'ESTACIONAMIENTO', 'AMOE010', 'AMOCEEX0060', None, None, '0U', None, '006', None, '1', '0', 'EST CEEX', 'Cajón Chico, Atrás doble, Abajo sin eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-15', '20-Feb-15', '24-Aug-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00062618', 'DONACIANO VERA LOPEZ', 'DONACIANO', 'VERA', 'LOPEZ', 'VELD540706D30', 'VELD540706HDFRPN02', '0', 'H', 'DONACIANO.VERA@DRAGADOSMX.COM', '57990684', '36403166', '5514733297', None, '6-Jul-54', 'CASADO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '1', 'Impresos', 'BOSQUES DE CAMERUN', '29', None, 'BOSQUES DE ARAGON', 'NEZAHUALCÓYOTL MEX', 'MEX', 'MEXICO', '57170', '5', 'EMPLEADO', '1538010637164', 'IFE', '30020106677', '0002407', None, '.10000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '20-Jun-15', '18-Mar-15', '18-Mar-15', '20-Mar-15', '12', None, '1-Apr-15', '1-Apr-15', '1-Apr-15', '1-Apr-15', '1-Apr-15', None, '10-Apr-15', '10-Apr-15', None, '14-May-15', None, '6-May-15', '19-May-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP009', '1', 'DEPARTAMENTO', 'AMOD009', 'AMO0UD22020', None, None, '0U', '2', '202', None, '1', '0', 'AMO B1', 'sala/comedor,cocina, dos recámaras, 2 baños, vestidor y patio de lavado', None, None, '2', 'n/a', '2', '0', '25.13', None, '5.95', '2.43', 'n/a', None, None, '78.49', None, '0', '0', None, '0', '78.49', None, None, '0', None, None, None, None, None, '0', '1', '1', '2,257,422.00 ', '25,000.00 ', '175,000.00 ', '338,613.00 ', '20-Jan-15', '20-Jan-15', '24-Jul-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00070231', 'DALIA GORODZINSKY SALSBERG', 'DALIA', 'GORODZINSKY', 'SALSBERG', 'GOSD821124I30', 'GOSD821124', '1', None, 'd.dalia@hotmail.com', '0000000', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LOMAS DE LAS PALMAS', 'HUIXQUILUCAN MEX', 'MEX', 'Mexico', '52788', '0', None, None, None, '30000030111', 'SI000003639', None, '2288125.40000', '2378125.41000', '.00000', '.00000', '2378125.41000', '.00000', '.00000', '9014.12000', '.00000', '-2379625.40000', '7514.13000', '15-Jan-15', '15-Jan-15', '30-Jan-14', '30-Jan-14', '30-Jan-14', '0', None, '30-Jan-14', '30-Jan-14', '30-Jan-14', '30-Jan-14', '30-Jan-14', None, '5-Mar-15', '5-Mar-15', None, '19-Mar-15', None, '23-Mar-15', '27-Mar-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP009', '2', 'ESTACIONAMIENTO', 'AMOE011', 'AMOGDEB0070', None, None, '0U', None, '007', None, '1', '0', 'EST GDEB', 'Cajón Grande, Adelante doble, Arriba con eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Adelante doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-15', '20-Feb-15', '24-Aug-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00070231', 'DALIA GORODZINSKY SALSBERG', 'DALIA', 'GORODZINSKY', 'SALSBERG', 'GOSD821124I30', 'GOSD821124', '1', None, 'd.dalia@hotmail.com', '0000000', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LOMAS DE LAS PALMAS', 'HUIXQUILUCAN MEX', 'MEX', 'Mexico', '52788', '0', None, None, None, '30000030111', 'SI000003645', None, '.01000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '30-Jan-14', '30-Jan-14', '30-Jan-14', '0', None, '30-Jan-14', '30-Jan-14', '30-Jan-14', '30-Jan-14', '30-Jan-14', None, '5-Mar-15', '5-Mar-15', None, '19-Mar-15', None, '23-Mar-15', '27-Mar-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP009', '2', 'ESTACIONAMIENTO', 'AMOE012', 'AMOGDEA0070', None, None, '0U', None, '007', None, '1', '0', 'EST GDEA', 'Cajón Grande, Adelante doble, Abajo con eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Adelante doble', '0', '1', '1', '120,000.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-15', '20-Feb-15', '24-Aug-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00070231', 'DALIA GORODZINSKY SALSBERG', 'DALIA', 'GORODZINSKY', 'SALSBERG', 'GOSD821124I30', 'GOSD821124', '1', None, 'd.dalia@hotmail.com', '0000000', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LOMAS DE LAS PALMAS', 'HUIXQUILUCAN MEX', 'MEX', 'Mexico', '52788', '0', None, None, None, '30000030111', 'SI000003642', None, '90000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '30-Jan-14', '30-Jan-14', '30-Jan-14', '0', None, '30-Jan-14', '30-Jan-14', '30-Jan-14', '30-Jan-14', '30-Jan-14', None, '5-Mar-15', '5-Mar-15', None, '19-Mar-15', None, '23-Mar-15', '27-Mar-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP004', '1', 'DEPARTAMENTO', 'AMOD004', 'AMO0UD11010', None, None, '0U', '1', '101', None, '1', '0', 'AMO C', 'sala/comedor,cocina, dos recámaras, 2 baños, vestidor, patio de lavado y balcón', None, None, '2', 'n/a', '2', '1', '25', None, '5.95', '2.48', 'n/a', None, None, '75.25', None, '0', '2.33', None, '0', '77.58', None, None, '0', None, None, None, None, None, '0', '1', '1', '2,266,315.00 ', '25,000.00 ', '175,000.00 ', '339,947.00 ', '20-Jan-15', '20-Jan-15', '24-Jul-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00070268', 'VERONICA MAITE SANTOS JACOB', 'VERONICA MAITE', 'SANTOS', 'JACOB', 'SAJV600606RE2', 'SAJV600606', '1', None, 'veronica.santos@gmail.com', '00000000', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BOSQUES DE LOS ENCINOS 194', 'MIGUEL HIDALGO DF', 'DF', 'Mexico', '03100', '0', None, None, None, '30000030129', 'SI000003637', None, '2297139.52000', '2387139.53000', '.00000', '.00000', '2387139.53000', '.00000', '.00000', '.00000', '.00000', '-2382439.52000', '4700.01000', '15-Jan-15', '15-Jan-15', '30-Jan-14', '30-Jan-14', '30-Jan-14', '0', None, '30-Jan-14', '30-Jan-14', '30-Jan-14', '30-Jan-14', '30-Jan-14', None, '5-Mar-15', '5-Mar-15', None, '19-Mar-15', None, '23-Mar-15', '27-Mar-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP004', '2', 'ESTACIONAMIENTO', 'AMOE005', 'AMOGDEA0030', None, None, '0U', None, '003', None, '1', '0', 'EST GDEA', 'Cajón Grande, Adelante doble, Abajo con eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Adelante doble', '0', '1', '1', '120,000.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-15', '20-Feb-15', '24-Aug-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00070268', 'VERONICA MAITE SANTOS JACOB', 'VERONICA MAITE', 'SANTOS', 'JACOB', 'SAJV600606RE2', 'SAJV600606', '1', None, 'veronica.santos@gmail.com', '00000000', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BOSQUES DE LOS ENCINOS 194', 'MIGUEL HIDALGO DF', 'DF', 'Mexico', '03100', '0', None, None, None, '30000030129', 'SI000003641', None, '90000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '30-Jan-14', '30-Jan-14', '30-Jan-14', '0', None, '30-Jan-14', '30-Jan-14', '30-Jan-14', '30-Jan-14', '30-Jan-14', None, '5-Mar-15', '5-Mar-15', None, '19-Mar-15', None, '23-Mar-15', '27-Mar-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP004', '2', 'ESTACIONAMIENTO', 'AMOE006', 'AMOGDEB0030', None, None, '0U', None, '003', None, '1', '0', 'EST GDEB', 'Cajón Grande, Adelante doble, Arriba con eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Adelante doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-15', '20-Feb-15', '24-Aug-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00070268', 'VERONICA MAITE SANTOS JACOB', 'VERONICA MAITE', 'SANTOS', 'JACOB', 'SAJV600606RE2', 'SAJV600606', '1', None, 'veronica.santos@gmail.com', '00000000', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BOSQUES DE LOS ENCINOS 194', 'MIGUEL HIDALGO DF', 'DF', 'Mexico', '03100', '0', None, None, None, '30000030129', 'SI000003644', None, '.01000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '30-Jan-14', '30-Jan-14', '30-Jan-14', '0', None, '30-Jan-14', '30-Jan-14', '30-Jan-14', '30-Jan-14', '30-Jan-14', None, '5-Mar-15', '5-Mar-15', None, '19-Mar-15', None, '23-Mar-15', '27-Mar-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP008', '1', 'DEPARTAMENTO', 'AMOD008', 'AMO0UD22010', None, None, '0U', '2', '201', None, '1', '0', 'AMO C', 'sala/comedor,cocina, dos recámaras, 2 baños, vestidor, patio de lavado y balcón', None, None, '2', 'n/a', '2', '1', '25', None, '5.95', '2.48', 'n/a', None, None, '75.25', None, '0', '2.33', None, '0', '77.58', None, None, '0', None, None, None, None, None, '0', '1', '1', '2,229,674.00 ', '25,000.00 ', '175,000.00 ', '334,451.00 ', '20-Jan-15', '20-Jan-15', '24-Jul-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00070271', 'GISELLE LEVY BENSIMON', 'GISELLE', 'LEVY', 'BENSIMON', 'MORC541031DU3', 'LEBG890701MDFVNS07', '1', None, 'giselle.levy@quierocasa.com.mx', '52035700', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BOSQUES DE LAS LOMAS', 'CUAJIMALPA MORELOS DF', 'DF', 'Mexico', '05120', '0', None, None, None, '30000030137', 'SI000003638', None, '2260000.00000', '2350000.01000', '.00000', '.00000', '2350000.01000', '.00000', '.00000', '.00000', '.00000', '-2351500.00000', '-1499.99000', '15-Jan-15', '15-Jan-15', '30-Jan-14', '30-Jan-14', '30-Jan-14', '0', None, '30-Jan-14', '30-Jan-14', '30-Jan-14', '30-Jan-14', '30-Jan-14', None, '5-Mar-15', '5-Mar-15', None, '19-Mar-15', None, '23-Mar-15', '27-Mar-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP008', '2', 'ESTACIONAMIENTO', 'AMOE001', 'AMOGDEB0010', None, None, '0U', None, '001', None, '1', '0', 'EST GDEB', 'Cajón Grande, Adelante doble, Arriba con eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Adelante doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-15', '20-Feb-15', '24-Aug-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00070271', 'GISELLE LEVY BENSIMON', 'GISELLE', 'LEVY', 'BENSIMON', 'MORC541031DU3', 'LEBG890701MDFVNS07', '1', None, 'giselle.levy@quierocasa.com.mx', '52035700', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BOSQUES DE LAS LOMAS', 'CUAJIMALPA MORELOS DF', 'DF', 'Mexico', '05120', '0', None, None, None, '30000030137', 'SI000003643', None, '.01000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '30-Jan-14', '30-Jan-14', '30-Jan-14', '0', None, '30-Jan-14', '30-Jan-14', '30-Jan-14', '30-Jan-14', '30-Jan-14', None, '5-Mar-15', '5-Mar-15', None, '19-Mar-15', None, '23-Mar-15', '27-Mar-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP008', '2', 'ESTACIONAMIENTO', 'AMOE002', 'AMOGDEA0010', None, None, '0U', None, '001', None, '1', '0', 'EST GDEA', 'Cajón Grande, Adelante doble, Abajo con eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Adelante doble', '0', '1', '1', '120,000.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-15', '20-Feb-15', '24-Aug-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00070271', 'GISELLE LEVY BENSIMON', 'GISELLE', 'LEVY', 'BENSIMON', 'MORC541031DU3', 'LEBG890701MDFVNS07', '1', None, 'giselle.levy@quierocasa.com.mx', '52035700', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BOSQUES DE LAS LOMAS', 'CUAJIMALPA MORELOS DF', 'DF', 'Mexico', '05120', '0', None, None, None, '30000030137', 'SI000003640', None, '90000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '30-Jan-14', '30-Jan-14', '30-Jan-14', '0', None, '30-Jan-14', '30-Jan-14', '30-Jan-14', '30-Jan-14', '30-Jan-14', None, '5-Mar-15', '5-Mar-15', None, '19-Mar-15', None, '23-Mar-15', '27-Mar-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP015', '1', 'DEPARTAMENTO', 'AMOD015', 'AMO0UD33040', None, None, '0U', '3', '304', None, '1', '0', 'AMO D3', 'sala/comedor,cocina, dos recámaras, 2 baños, vestidor, patio de lavado y esc. int. a roof garden', None, None, '2', 'n/a', '2', '0', '25.13', None, '5.95', '2.43', 'n/a', None, None, '78.49', None, '0', '0', None, '78.49', '156.98', None, None, '0', None, None, None, None, None, '0', '1', '1', '3,211,110.00 ', '25,000.00 ', '175,000.00 ', '481,667.00 ', '20-Jan-15', '20-Jan-15', '24-Jul-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00071084', 'YOLANDA MOGUEL GARRIDO', 'YOLANDA', 'MOGUEL', 'GARRIDO', 'MOGY830322T40', 'MOGY830322MCSGRL07', '0', 'H', 'YMOGUEL@GMAIL.COM', '5543602141', '52818632', '5555017356', None, '22-Mar-83', 'CASADO', None, 'MEXICANA', 'CHIAPAS', None, '57', 'Activación', 'ANDREA DEL SARTO 15', '15', '205', 'MIXCOAC', 'BENITO JUÁREZ DF', 'DF', 'MEXICO', '03910', '5', 'EMPLEADA', '4454089965991', 'IFE', '30020104243', '0002370', None, '3113100.02000', '3113102.02000', '.00000', '-89.82000', '3113012.20000', '.00000', '.00000', '280179.18000', '.00000', '232820.00000', '3626011.38000', '1-Jan-00', '20-Jun-15', '6-Apr-15', '6-Apr-15', '6-Apr-15', '12', None, '6-Apr-15', '6-Apr-15', '6-Apr-15', '6-Apr-15', '6-Apr-15', None, '18-May-15', '18-May-15', None, '18-May-15', None, '19-May-15', '8-Sep-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP015', '2', 'ESTACIONAMIENTO', 'AMOE027', 'AMOCCEX0190', None, None, '0U', None, '019', None, '1', '0', 'EST CCEX', 'Cajón Chico, Atrás triple, Abajo sin eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás triple', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-15', '20-Feb-15', '24-Aug-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00071084', 'YOLANDA MOGUEL GARRIDO', 'YOLANDA', 'MOGUEL', 'GARRIDO', 'MOGY830322T40', 'MOGY830322MCSGRL07', '0', 'H', 'YMOGUEL@GMAIL.COM', '5543602141', '52818632', '5555017356', None, '22-Mar-83', 'CASADO', None, 'MEXICANA', 'CHIAPAS', None, '57', 'Activación', 'ANDREA DEL SARTO 15', '15', '205', 'MIXCOAC', 'BENITO JUÁREZ DF', 'DF', 'MEXICO', '03910', '5', 'EMPLEADA', '4454089965991', 'IFE', '30020104243', '0002370', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '20-Jun-15', '6-Apr-15', '6-Apr-15', '6-Apr-15', '12', None, '6-Apr-15', '6-Apr-15', '6-Apr-15', '6-Apr-15', '6-Apr-15', None, '18-May-15', '18-May-15', None, '18-May-15', None, '19-May-15', '8-Sep-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP015', '2', 'ESTACIONAMIENTO', 'AMOE026', 'AMOCBEX0180', None, None, '0U', None, '018', None, '1', '0', 'EST CBEX', 'Cajón Chico, En medio Triple, Abajo sin eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'En medio Triple', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-15', '20-Feb-15', '24-Aug-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00071084', 'YOLANDA MOGUEL GARRIDO', 'YOLANDA', 'MOGUEL', 'GARRIDO', 'MOGY830322T40', 'MOGY830322MCSGRL07', '0', 'H', 'YMOGUEL@GMAIL.COM', '5543602141', '52818632', '5555017356', None, '22-Mar-83', 'CASADO', None, 'MEXICANA', 'CHIAPAS', None, '57', 'Activación', 'ANDREA DEL SARTO 15', '15', '205', 'MIXCOAC', 'BENITO JUÁREZ DF', 'DF', 'MEXICO', '03910', '5', 'EMPLEADA', '4454089965991', 'IFE', '30020104243', '0002370', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '20-Jun-15', '6-Apr-15', '6-Apr-15', '6-Apr-15', '12', None, '6-Apr-15', '6-Apr-15', '6-Apr-15', '6-Apr-15', '6-Apr-15', None, '18-May-15', '18-May-15', None, '18-May-15', None, '19-May-15', '8-Sep-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP011', '1', 'DEPARTAMENTO', 'AMOD011', 'AMO0UD22040', None, None, '0U', '2', '204', None, '1', '0', 'AMO B3', 'sala/comedor,cocina, dos recámaras, 2 baños, vestidor y patio de lavado', None, None, '2', 'n/a', '2', '0', '25.13', None, '5.95', '2.43', 'n/a', None, None, '78.49', None, '0', '0', None, '0', '78.49', None, None, '0', None, None, None, None, None, '0', '1', '1', '2,446,437.00 ', '25,000.00 ', '175,000.00 ', '366,966.00 ', '20-Jan-15', '20-Jan-15', '24-Jul-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00071636', 'VICTORIA  ALICIA PAZ MARTIN DEL CAMPO', 'VICTORIA  ALICIA', 'PAZ', 'MARTIN DEL CAMPO', 'PAMV691030HD9', 'PAMV691030MDFZRC02', '1', None, 'malinalli03@yahoo.com.mx', '53031129', None, '5525742016', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'CUAUTEPEC DE MADERO', 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07210', '0', None, None, None, '30000030954', 'SI000005511', None, '2405320.38000', '2405320.39000', '.00000', '.00000', '2405320.39000', '.00000', '.00000', '168372.42000', '.00000', '-2405320.38000', '168372.43000', '15-Jan-15', '15-Jan-15', '14-Aug-14', '14-Aug-14', '14-Aug-14', '0', None, '14-Aug-14', '14-Aug-14', '14-Aug-14', '14-Aug-14', '14-Aug-14', None, '4-Mar-15', '4-Mar-15', None, '19-Mar-15', None, '20-Mar-15', '24-Mar-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP011', '2', 'ESTACIONAMIENTO', 'AMOE025', 'AMOCAEX0170', None, None, '0U', None, '017', None, '1', '0', 'EST CAEX', 'Cajón Chico, Adelante Triple, Abajo sin eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante Triple', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-15', '20-Feb-15', '24-Aug-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00071636', 'VICTORIA  ALICIA PAZ MARTIN DEL CAMPO', 'VICTORIA  ALICIA', 'PAZ', 'MARTIN DEL CAMPO', 'PAMV691030HD9', 'PAMV691030MDFZRC02', '1', None, 'malinalli03@yahoo.com.mx', '53031129', None, '5525742016', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'CUAUTEPEC DE MADERO', 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07210', '0', None, None, None, '30000030954', 'SI000005512', None, '.01000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '14-Aug-14', '14-Aug-14', '14-Aug-14', '0', None, '14-Aug-14', '14-Aug-14', '14-Aug-14', '14-Aug-14', '14-Aug-14', None, '4-Mar-15', '4-Mar-15', None, '19-Mar-15', None, '20-Mar-15', '24-Mar-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP007', '1', 'DEPARTAMENTO', 'AMOD007', 'AMO0UD11040', None, None, '0U', '1', '104', None, '1', '0', 'AMO B3', 'sala/comedor,cocina, dos recámaras, 2 baños, vestidor y patio de lavado', None, None, '2', 'n/a', '2', '0', '25.13', None, '5.95', '2.43', 'n/a', None, None, '78.49', None, '0', '0', None, '0', '78.49', None, None, '0', None, None, None, None, None, '0', '1', '1', '2,529,330.00 ', '25,000.00 ', '175,000.00 ', '379,400.00 ', '20-Jan-15', '20-Jan-15', '24-Jul-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00071989', 'VERONICA GABRIELA RAMOS BARONA', 'VERONICA GABRIELA', 'RAMOS', 'BARONA', 'RABV720706Q12', 'RABV720706MDFMRR02', '1', None, 'veritobarona@hotmail.com', '54897027', None, '5585060167', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'AMPL TEPEPAN', 'XOCHIMILCO DF', 'DF', 'Mexico', '16020', '0', None, None, None, '30000031101', 'SI000005551', None, '2486556.03000', '2486556.05000', '.00000', '.00000', '2486556.05000', '.00000', '.00000', '174058.92000', '.00000', '-2486558.03000', '174056.94000', '15-Jan-15', '15-Jan-15', '20-Aug-14', '20-Aug-14', '20-Aug-14', '0', None, '20-Aug-14', '20-Aug-14', '20-Aug-14', '20-Aug-14', '20-Aug-14', None, '6-Apr-15', '6-Apr-15', None, '7-Apr-15', None, '9-Apr-15', '19-May-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP007', '2', 'ESTACIONAMIENTO', 'AMOE018', 'AMOGEEA0100', None, None, '0U', None, '010', None, '1', '0', 'EST GEEA', 'Cajón Grande, Atrás doble, Abajo con eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Atrás doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-15', '20-Feb-15', '24-Aug-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00071989', 'VERONICA GABRIELA RAMOS BARONA', 'VERONICA GABRIELA', 'RAMOS', 'BARONA', 'RABV720706Q12', 'RABV720706MDFMRR02', '1', None, 'veritobarona@hotmail.com', '54897027', None, '5585060167', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'AMPL TEPEPAN', 'XOCHIMILCO DF', 'DF', 'Mexico', '16020', '0', None, None, None, '30000031101', 'SI000005552', None, '.01000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '20-Aug-14', '20-Aug-14', '20-Aug-14', '0', None, '20-Aug-14', '20-Aug-14', '20-Aug-14', '20-Aug-14', '20-Aug-14', None, '6-Apr-15', '6-Apr-15', None, '7-Apr-15', None, '9-Apr-15', '19-May-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP007', '2', 'ESTACIONAMIENTO', 'AMOE017', 'AMOGEEB0100', None, None, '0U', None, '010', None, '1', '0', 'EST GEEB', 'Cajón Grande, Atrás doble, Arriba con eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Atrás doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-15', '20-Feb-15', '24-Aug-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00071989', 'VERONICA GABRIELA RAMOS BARONA', 'VERONICA GABRIELA', 'RAMOS', 'BARONA', 'RABV720706Q12', 'RABV720706MDFMRR02', '1', None, 'veritobarona@hotmail.com', '54897027', None, '5585060167', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'AMPL TEPEPAN', 'XOCHIMILCO DF', 'DF', 'Mexico', '16020', '0', None, None, None, '30000031101', 'SI000005553', None, '.01000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '20-Aug-14', '20-Aug-14', '20-Aug-14', '0', None, '20-Aug-14', '20-Aug-14', '20-Aug-14', '20-Aug-14', '20-Aug-14', None, '6-Apr-15', '6-Apr-15', None, '7-Apr-15', None, '9-Apr-15', '19-May-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP003', '1', 'DEPARTAMENTO', 'AMOD003', 'AMO0UD00040', None, None, '0U', '0', '004', None, '1', '0', 'AMO B4', 'sala/comedor,cocina, dos recámaras, 2 baños, vestidor, patio de lavado, terraza y jardín privado', None, None, '2', 'n/a', '2', '1', '25.13', None, '5.95', '2.43', 'n/a', None, None, '78.49', None, '9.5', '0', '8.52', '0', '96.51', None, None, '0', None, None, None, None, None, '0', '1', '1', '2,738,156.00 ', '25,000.00 ', '175,000.00 ', '410,723.00 ', '20-Jan-15', '20-Jan-15', '24-Jul-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00071991', 'EDNA ROBLES CALVILLO', 'EDNA', 'ROBLES', 'CALVILLO', 'ROCE651026RE5', 'ROCE651026MTSBLD06', '1', None, 'edenea10@hotmail.com', '8115999156', '5554783248', '8116601971', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'COLINAS DE SAN JERONIMO', 'MONTERREY NL', 'NL', 'Mexico', '64630', '0', None, None, None, '30000031119', 'SI000005639', None, '2563202.01000', '2563202.03000', '.00000', '.00000', '2563202.03000', '.00000', '.00000', '179424.14000', '.00000', '-2564902.01000', '177724.16000', '15-Jan-15', '15-Jan-15', '2-Sep-14', '2-Sep-14', '2-Sep-14', '0', None, '2-Sep-14', '2-Sep-14', '2-Sep-14', '2-Sep-14', '2-Sep-14', None, '12-Mar-15', '12-Mar-15', None, '19-Mar-15', None, '19-Mar-15', '19-Mar-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP003', '2', 'ESTACIONAMIENTO', 'AMOE007', 'AMOGEEB0040', None, None, '0U', None, '004', None, '1', '0', 'EST GEEB', 'Cajón Grande, Atrás doble, Arriba con eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Atrás doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-15', '20-Feb-15', '24-Aug-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00071991', 'EDNA ROBLES CALVILLO', 'EDNA', 'ROBLES', 'CALVILLO', 'ROCE651026RE5', 'ROCE651026MTSBLD06', '1', None, 'edenea10@hotmail.com', '8115999156', '5554783248', '8116601971', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'COLINAS DE SAN JERONIMO', 'MONTERREY NL', 'NL', 'Mexico', '64630', '0', None, None, None, '30000031119', 'SI000005643', None, '.01000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '2-Sep-14', '2-Sep-14', '2-Sep-14', '0', None, '2-Sep-14', '2-Sep-14', '2-Sep-14', '2-Sep-14', '2-Sep-14', None, '12-Mar-15', '12-Mar-15', None, '19-Mar-15', None, '19-Mar-15', '19-Mar-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP003', '2', 'ESTACIONAMIENTO', 'AMOE008', 'AMOGEEA0040', None, None, '0U', None, '004', None, '1', '0', 'EST GEEA', 'Cajón Grande, Atrás doble, Abajo con eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Atrás doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-15', '20-Feb-15', '24-Aug-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00071991', 'EDNA ROBLES CALVILLO', 'EDNA', 'ROBLES', 'CALVILLO', 'ROCE651026RE5', 'ROCE651026MTSBLD06', '1', None, 'edenea10@hotmail.com', '8115999156', '5554783248', '8116601971', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'COLINAS DE SAN JERONIMO', 'MONTERREY NL', 'NL', 'Mexico', '64630', '0', None, None, None, '30000031119', 'SI000005641', None, '.01000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '2-Sep-14', '2-Sep-14', '2-Sep-14', '0', None, '2-Sep-14', '2-Sep-14', '2-Sep-14', '2-Sep-14', '2-Sep-14', None, '12-Mar-15', '12-Mar-15', None, '19-Mar-15', None, '19-Mar-15', '19-Mar-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP005', '1', 'DEPARTAMENTO', 'AMOD005', 'AMO0UD11020', None, None, '0U', '1', '102', None, '1', '0', 'AMO B1', 'sala/comedor,cocina, dos recámaras, 2 baños, vestidor y patio de lavado', None, None, '2', 'n/a', '2', '0', '25.13', None, '5.95', '2.43', 'n/a', None, None, '78.49', None, '0', '0', None, '0', '78.49', None, None, '0', None, None, None, None, None, '0', '1', '1', '2,559,890.00 ', '25,000.00 ', '175,000.00 ', '383,984.00 ', '20-Jan-15', '20-Jan-15', '24-Jul-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00072224', 'SALVADOR HERNANDEZ RODRIGUEZ', 'SALVADOR', 'HERNANDEZ', 'RODRIGUEZ', 'HERS520909KK5', 'HERS520909HHGRDL01', '1', None, 'susaro56@hotmail.com', '55346788', '53460000 ext 30', '5532114007', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'DEL VALLE', 'BENITO JUÁREZ DF', 'DF', 'Mexico', '03100', '0', None, None, None, '30000031184', 'SI000005599', None, '2567203.19000', '2567203.20000', '.00000', '.00000', '2567203.20000', '.00000', '.00000', '179704.22000', '.00000', '-2567204.19000', '179703.23000', '15-Jan-15', '15-Jan-15', '26-Aug-14', '26-Aug-14', '26-Aug-14', '0', None, '26-Aug-14', '26-Aug-14', '26-Aug-14', '26-Aug-14', '26-Aug-14', None, '28-Jul-15', '28-Jul-15', None, '3-Aug-15', None, '4-Aug-15', '14-Aug-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP005', '2', 'ESTACIONAMIENTO', 'AMOE019', 'AMOCUEX0110', None, None, '0U', None, '011', None, '1', '0', 'EST CUEX', 'Cajón Chico, Único, Abajo sin eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Único', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-May-15', '20-May-15', '21-Nov-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00072224', 'SALVADOR HERNANDEZ RODRIGUEZ', 'SALVADOR', 'HERNANDEZ', 'RODRIGUEZ', 'HERS520909KK5', 'HERS520909HHGRDL01', '1', None, 'susaro56@hotmail.com', '55346788', '53460000 ext 30', '5532114007', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'DEL VALLE', 'BENITO JUÁREZ DF', 'DF', 'Mexico', '03100', '0', None, None, None, '30000031184', 'SI000005600', None, '.01000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '26-Aug-14', '26-Aug-14', '26-Aug-14', '0', None, '26-Aug-14', '26-Aug-14', '26-Aug-14', '26-Aug-14', '26-Aug-14', None, '28-Jul-15', '28-Jul-15', None, '3-Aug-15', None, '4-Aug-15', '14-Aug-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP002', '1', 'DEPARTAMENTO', 'AMOD002', 'AMO0UD00030', None, None, '0U', '0', '003', None, '1', '0', 'AMO B5', 'sala/comedor,cocina, dos recámaras, 2 baños, vestidor y patio de lavado y terraza', None, None, '2', 'n/a', '2', '0', '25.13', None, '5.95', '2.43', 'n/a', None, None, '78.49', None, '9.27', '0', None, '0', '87.76', None, None, '0', None, None, None, None, None, '0', '2', '1', '2,657,873.00 ', '25,000.00 ', '175,000.00 ', '398,681.00 ', '20-Jan-15', '20-Jan-15', '24-Jul-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00072296', 'MARTHA LETICIA GARCIA RODRIGUEZ', 'MARTHA LETICIA', 'GARCIA', 'RODRIGUEZ', 'GARM620706IJ5', 'GARM620706MDFRDR00', '1', None, 'martha.garcia@hotmail.com', '56735523', '57296000', '5514733104', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'EJIDOS DE HUIPULCO', 'TLALPAN DF', 'DF', 'Mexico', '14380', '0', None, None, None, '30000031218', 'SI000005638', None, '2615466.05000', '2615466.07000', '.00000', '.00000', '2615466.07000', '.00000', '.00000', '186582.62000', '.00000', '-2616966.05000', '185082.64000', '15-Jan-15', '15-Jan-15', '2-Sep-14', '2-Sep-14', '2-Sep-14', '0', None, '2-Sep-14', '2-Sep-14', '2-Sep-14', '2-Sep-14', '2-Sep-14', None, '17-Aug-15', '17-Aug-15', None, '24-Aug-15', None, '22-Sep-15', '30-Sep-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP002', '2', 'ESTACIONAMIENTO', 'AMOE004', 'AMOGEEB0020', None, None, '0U', None, '002', None, '1', '0', 'EST GEEB', 'Cajón Grande, Atrás doble, Arriba con eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Atrás doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '22-Aug-14', '22-Aug-14', '23-Feb-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00072296', 'MARTHA LETICIA GARCIA RODRIGUEZ', 'MARTHA LETICIA', 'GARCIA', 'RODRIGUEZ', 'GARM620706IJ5', 'GARM620706MDFRDR00', '1', None, 'martha.garcia@hotmail.com', '56735523', '57296000', '5514733104', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'EJIDOS DE HUIPULCO', 'TLALPAN DF', 'DF', 'Mexico', '14380', '0', None, None, None, '30000031218', 'SI000005642', None, '.01000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '2-Sep-14', '2-Sep-14', '2-Sep-14', '0', None, '2-Sep-14', '2-Sep-14', '2-Sep-14', '2-Sep-14', '2-Sep-14', None, '17-Aug-15', '17-Aug-15', None, '24-Aug-15', None, '22-Sep-15', '30-Sep-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP002', '2', 'ESTACIONAMIENTO', 'AMOE003', 'AMOGEEA0020', None, None, '0U', None, '002', None, '1', '0', 'EST GEEA', 'Cajón Grande, Atrás doble, Abajo con eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Atrás doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '22-Aug-14', '22-Aug-14', '23-Feb-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00072296', 'MARTHA LETICIA GARCIA RODRIGUEZ', 'MARTHA LETICIA', 'GARCIA', 'RODRIGUEZ', 'GARM620706IJ5', 'GARM620706MDFRDR00', '1', None, 'martha.garcia@hotmail.com', '56735523', '57296000', '5514733104', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'EJIDOS DE HUIPULCO', 'TLALPAN DF', 'DF', 'Mexico', '14380', '0', None, None, None, '30000031218', 'SI000005640', None, '.01000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '2-Sep-14', '2-Sep-14', '2-Sep-14', '0', None, '2-Sep-14', '2-Sep-14', '2-Sep-14', '2-Sep-14', '2-Sep-14', None, '17-Aug-15', '17-Aug-15', None, '24-Aug-15', None, '22-Sep-15', '30-Sep-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP006', '1', 'DEPARTAMENTO', 'AMOD006', 'AMO0UD11030', None, None, '0U', '1', '103', None, '1', '0', 'AMO B2', 'sala/comedor,cocina, dos recámaras, 2 baños, vestidor y patio de lavado', None, None, '2', 'n/a', '2', '0', '25.13', None, '5.95', '2.43', 'n/a', None, None, '78.49', None, '0', '0', None, '0', '78.49', None, None, '0', None, None, None, None, None, '0', '1', '1', '2,529,330.00 ', '25,000.00 ', '175,000.00 ', '379,400.00 ', '20-Jan-15', '20-Jan-15', '24-Jul-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00075083', 'LUIS RODOLFO GARCIA TREJO', 'LUIS RODOLFO', 'GARCIA', 'TREJO', 'GATL7506208D0', 'GATL750620HBCRRS04', '1', None, 'lc_lili_alvarez@hotmail.com', '62689207', '46127095', '5532277627', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'NAPOLES', 'BENITO JUÁREZ DF', 'DF', 'Mexico', '03810', '0', None, None, None, '30010165824', 'SI000006134', None, '2613383.83000', '2613383.85000', '.00000', '.00000', '2613383.85000', '.00000', '.00000', '182936.86000', '.00000', '-2613384.41000', '182936.30000', '15-Jan-15', '15-Jan-15', '1-Oct-14', '1-Oct-14', '1-Oct-14', '0', None, '1-Oct-14', '1-Oct-14', '1-Oct-14', '1-Oct-14', '1-Oct-14', None, '7-Jul-15', '7-Jul-15', None, '14-Jul-15', None, '9-Jul-15', '11-Jul-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP006', '2', 'ESTACIONAMIENTO', 'AMOE014', 'AMOGEEA0080', None, None, '0U', None, '008', None, '1', '0', 'EST GEEA', 'Cajón Grande, Atrás doble, Abajo con eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Atrás doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-May-15', '20-May-15', '21-Nov-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00075083', 'LUIS RODOLFO GARCIA TREJO', 'LUIS RODOLFO', 'GARCIA', 'TREJO', 'GATL7506208D0', 'GATL750620HBCRRS04', '1', None, 'lc_lili_alvarez@hotmail.com', '62689207', '46127095', '5532277627', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'NAPOLES', 'BENITO JUÁREZ DF', 'DF', 'Mexico', '03810', '0', None, None, None, '30010165824', 'SI000006135', None, '.01000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '1-Oct-14', '1-Oct-14', '1-Oct-14', '0', None, '1-Oct-14', '1-Oct-14', '1-Oct-14', '1-Oct-14', '1-Oct-14', None, '7-Jul-15', '7-Jul-15', None, '14-Jul-15', None, '9-Jul-15', '11-Jul-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP006', '2', 'ESTACIONAMIENTO', 'AMOE013', 'AMOGEEB0080', None, None, '0U', None, '008', None, '1', '0', 'EST GEEB', 'Cajón Grande, Atrás doble, Arriba con eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Atrás doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-May-15', '20-May-15', '21-Nov-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00075083', 'LUIS RODOLFO GARCIA TREJO', 'LUIS RODOLFO', 'GARCIA', 'TREJO', 'GATL7506208D0', 'GATL750620HBCRRS04', '1', None, 'lc_lili_alvarez@hotmail.com', '62689207', '46127095', '5532277627', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'NAPOLES', 'BENITO JUÁREZ DF', 'DF', 'Mexico', '03810', '0', None, None, None, '30010165824', 'SI000006136', None, '.01000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '1-Oct-14', '1-Oct-14', '1-Oct-14', '0', None, '1-Oct-14', '1-Oct-14', '1-Oct-14', '1-Oct-14', '1-Oct-14', None, '7-Jul-15', '7-Jul-15', None, '14-Jul-15', None, '9-Jul-15', '11-Jul-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP013', '1', 'DEPARTAMENTO', 'AMOD013', 'AMO0UD33020', None, None, '0U', '3', '302', None, '1', '0', 'AMO D1', 'sala/comedor,cocina, dos recámaras, 2 baños, vestidor, patio de lavado y esc. int. a roof garden', None, None, '2', 'n/a', '2', '0', '25.13', None, '5.95', '2.43', 'n/a', None, None, '78.49', None, '0', '0', None, '78.49', '156.98', None, None, '0', None, None, None, None, None, '0', '1', '1', '3,361,104.00 ', '25,000.00 ', '175,000.00 ', '504,166.00 ', '20-Jan-15', '20-Jan-15', '24-Jul-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00076199', 'MARIA FERNANDA CASTAÑO BRUNET', 'MARIA FERNANDA', 'CASTAÑO', 'BRUNET', 'CABF8512151T4', 'CABF851215MNESRR05', '1', None, 'fernanda@brunet.com.mx', '56302148', '5519513831', '55555555555', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'JARDINES DEL PEDREGAL', 'ALVARO OBREGÓN DF', 'DF', 'Mexico', '01900', '0', None, None, None, '30010168596', 'SI000006383', None, '3433064.95000', '3433064.97000', '.00000', '.00000', '3433064.97000', '.00000', '.00000', '240314.54000', '.00000', '-3433064.95000', '240314.56000', '15-Jan-15', '15-Jan-15', '17-Oct-14', '17-Oct-14', '17-Oct-14', '0', None, '17-Oct-14', '17-Oct-14', '17-Oct-14', '17-Oct-14', '17-Oct-14', None, '14-May-15', '14-May-15', None, '21-May-15', None, '21-May-15', '2-Jun-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP013', '2', 'ESTACIONAMIENTO', 'AMOE024', 'AMODCEX0160', None, None, '0U', None, '016', None, '1', '0', 'EST DCEX', 'Cajón Discapacitados, Atrás triple, Abajo sin eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '19', None, None, None, None, None, None, '3.8', None, '0', None, None, 'Discapacitados', 'Abajo sin eleva autos', 'Atrás triple', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Jan-15', '20-Jan-15', '24-Jul-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00076199', 'MARIA FERNANDA CASTAÑO BRUNET', 'MARIA FERNANDA', 'CASTAÑO', 'BRUNET', 'CABF8512151T4', 'CABF851215MNESRR05', '1', None, 'fernanda@brunet.com.mx', '56302148', '5519513831', '55555555555', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'JARDINES DEL PEDREGAL', 'ALVARO OBREGÓN DF', 'DF', 'Mexico', '01900', '0', None, None, None, '30010168596', 'SI000006385', None, '.01000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '17-Oct-14', '17-Oct-14', '17-Oct-14', '0', None, '17-Oct-14', '17-Oct-14', '17-Oct-14', '17-Oct-14', '17-Oct-14', None, '14-May-15', '14-May-15', None, '21-May-15', None, '21-May-15', '2-Jun-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP013', '2', 'ESTACIONAMIENTO', 'AMOE023', 'AMOCBEX0150', None, None, '0U', None, '015', None, '1', '0', 'EST CBEX', 'Cajón Chico, En medio Triple, Abajo sin eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'En medio Triple', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Jan-15', '20-Jan-15', '24-Jul-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00076199', 'MARIA FERNANDA CASTAÑO BRUNET', 'MARIA FERNANDA', 'CASTAÑO', 'BRUNET', 'CABF8512151T4', 'CABF851215MNESRR05', '1', None, 'fernanda@brunet.com.mx', '56302148', '5519513831', '55555555555', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'JARDINES DEL PEDREGAL', 'ALVARO OBREGÓN DF', 'DF', 'Mexico', '01900', '0', None, None, None, '30010168596', 'SI000006384', None, '.01000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '17-Oct-14', '17-Oct-14', '17-Oct-14', '0', None, '17-Oct-14', '17-Oct-14', '17-Oct-14', '17-Oct-14', '17-Oct-14', None, '14-May-15', '14-May-15', None, '21-May-15', None, '21-May-15', '2-Jun-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP012', '1', 'DEPARTAMENTO', 'AMOD012', 'AMO0UD33010', None, None, '0U', '3', '301', None, '1', '0', 'AMO E', 'sala/comedor,cocina, 2 recámaras, 2 baños, vestidor, p. de lavado, balcón y esc. int. roof garden', None, None, '2', 'n/a', '2', '1', '25', None, '5.95', '2.48', 'n/a', None, None, '75.25', None, '0', '2.33', None, '75.25', '152.83', None, None, '0', None, None, None, None, None, '0', '1', '1', '3,210,953.00 ', '25,000.00 ', '175,000.00 ', '481,643.00 ', '20-Jan-15', '20-Jan-15', '24-Jul-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00082316', 'YAZMIN LUCIA HEREDIA MEJIA', 'YAZMIN LUCIA', 'HEREDIA', 'MEJIA', 'HEMY7809295W9', 'HEMY780929MDFRJZ06', '0', 'H', 'YAZMINCREATICA@GMAIL.COM', '5540866641', '5540866641', None, None, '29-Sep-78', 'SOLTERO', None, 'MEXICANA', 'MEXICO D.F', None, '1', 'Impresos', 'REYNA', '230', 'CASA 2', 'TLACOPAC SAN ANGEL', 'ALVARO OBREGON', 'D.F', 'MEXICO', '01040', '11', 'EMPRESARIAL', '3465047575184', 'IFE', '30020115066', '0002775', None, '3110951.00000', '3110953.00000', '.00000', '.00000', '3110953.00000', '.00000', '.00000', '279985.77000', '.00000', '-3116454.00000', '274484.77000', '12-Apr-15', '25-May-15', '4-May-15', '26-Apr-15', '28-Apr-15', '12', None, '5-May-15', '5-May-15', '6-May-15', '6-May-15', '6-May-15', None, '24-Aug-15', '24-Aug-15', None, '27-Aug-15', None, '1-Sep-15', '2-Oct-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP012', '2', 'ESTACIONAMIENTO', 'AMOE015', 'AMOGDEA0090', None, None, '0U', None, '009', None, '1', '0', 'EST GDEA', 'Cajón Grande, Adelante doble, Abajo con eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo con eleva autos', 'Adelante doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Jan-15', '20-Jan-15', '24-Jul-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00082316', 'YAZMIN LUCIA HEREDIA MEJIA', 'YAZMIN LUCIA', 'HEREDIA', 'MEJIA', 'HEMY7809295W9', 'HEMY780929MDFRJZ06', '0', 'H', 'YAZMINCREATICA@GMAIL.COM', '5540866641', '5540866641', None, None, '29-Sep-78', 'SOLTERO', None, 'MEXICANA', 'MEXICO D.F', None, '1', 'Impresos', 'REYNA', '230', 'CASA 2', 'TLACOPAC SAN ANGEL', 'ALVARO OBREGON', 'D.F', 'MEXICO', '01040', '11', 'EMPRESARIAL', '3465047575184', 'IFE', '30020115066', '0002775', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '12-Apr-15', '25-May-15', '4-May-15', '26-Apr-15', '28-Apr-15', '12', None, '5-May-15', '5-May-15', '6-May-15', '6-May-15', '6-May-15', None, '24-Aug-15', '24-Aug-15', None, '27-Aug-15', None, '1-Sep-15', '2-Oct-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP012', '2', 'ESTACIONAMIENTO', 'AMOE016', 'AMOGDEB0090', None, None, '0U', None, '009', None, '1', '0', 'EST GDEB', 'Cajón Grande, Adelante doble, Arriba con eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Arriba con eleva autos', 'Adelante doble', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Jan-15', '20-Jan-15', '24-Jul-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00082316', 'YAZMIN LUCIA HEREDIA MEJIA', 'YAZMIN LUCIA', 'HEREDIA', 'MEJIA', 'HEMY7809295W9', 'HEMY780929MDFRJZ06', '0', 'H', 'YAZMINCREATICA@GMAIL.COM', '5540866641', '5540866641', None, None, '29-Sep-78', 'SOLTERO', None, 'MEXICANA', 'MEXICO D.F', None, '1', 'Impresos', 'REYNA', '230', 'CASA 2', 'TLACOPAC SAN ANGEL', 'ALVARO OBREGON', 'D.F', 'MEXICO', '01040', '11', 'EMPRESARIAL', '3465047575184', 'IFE', '30020115066', '0002775', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '12-Apr-15', '25-May-15', '4-May-15', '26-Apr-15', '28-Apr-15', '12', None, '5-May-15', '5-May-15', '6-May-15', '6-May-15', '6-May-15', None, '24-Aug-15', '24-Aug-15', None, '27-Aug-15', None, '1-Sep-15', '2-Oct-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP010', '1', 'DEPARTAMENTO', 'AMOD010', 'AMO0UD22030', None, None, '0U', '2', '203', None, '1', '0', 'AMO B2', 'sala/comedor,cocina, dos recámaras, 2 baños, vestidor y patio de lavado', None, None, '2', 'n/a', '2', '0', '25.13', None, '5.95', '2.43', 'n/a', None, None, '78.49', None, '0', '0', None, '0', '78.49', None, None, '0', None, None, None, None, None, '0', '1', '1', '2,446,437.00 ', '25,000.00 ', '175,000.00 ', '366,966.00 ', '20-Jan-15', '20-Jan-15', '24-Jul-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00082633', 'LORENA MONICA ZEPEDA IBARRA', 'LORENA MONICA', 'ZEPEDA', 'IBARRA', 'ZEIL621231D83', 'ZEIL621231MDFPBR03', '0', 'M', 'lorenazepedaibarra@yahoo.com.mx', '5510556263', '5527294263', None, None, '31-Dec-62', 'SOLTERO', None, 'MEXICANA', 'MEXICO, D.F.', None, '10', 'Buscando en Google', 'DR ATL', '229', '13', 'SANTA MARIA LA RIBERA', 'CUAUHTEMOC', 'DISTRITO FEDERAL', 'MEXICO', '6400', '0', 'EMPLEADA', '4613002446636', 'IFE', '30020114978', '0002772', None, '2446437.00000', '2446438.00000', '.00000', '.00000', '2446438.00000', '.00000', '.00000', '171250.66000', '.00000', '-2446438.00000', '171250.66000', '26-Apr-15', '4-May-15', '30-Apr-15', '26-Apr-15', '27-Apr-15', '12', None, '4-May-15', '4-May-15', '4-May-15', '6-May-15', '6-May-15', None, '10-Jun-15', '10-Jun-15', None, '18-Jun-15', None, '23-Jun-15', '24-Jun-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP010', '2', 'ESTACIONAMIENTO', 'AMOE022', 'AMOCAEX0140', None, None, '0U', None, '014', None, '1', '0', 'EST CAEX', 'Cajón Chico, Adelante Triple, Abajo sin eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante Triple', '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Apr-15', '20-Apr-15', '22-Oct-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00082633', 'LORENA MONICA ZEPEDA IBARRA', 'LORENA MONICA', 'ZEPEDA', 'IBARRA', 'ZEIL621231D83', 'ZEIL621231MDFPBR03', '0', 'M', 'lorenazepedaibarra@yahoo.com.mx', '5510556263', '5527294263', None, None, '31-Dec-62', 'SOLTERO', None, 'MEXICANA', 'MEXICO, D.F.', None, '10', 'Buscando en Google', 'DR ATL', '229', '13', 'SANTA MARIA LA RIBERA', 'CUAUHTEMOC', 'DISTRITO FEDERAL', 'MEXICO', '6400', '0', 'EMPLEADA', '4613002446636', 'IFE', '30020114978', '0002772', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '26-Apr-15', '4-May-15', '30-Apr-15', '26-Apr-15', '27-Apr-15', '12', None, '4-May-15', '4-May-15', '4-May-15', '6-May-15', '6-May-15', None, '10-Jun-15', '10-Jun-15', None, '18-Jun-15', None, '23-Jun-15', '24-Jun-15', None), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP012', '1', 'DEPARTAMENTO', 'AMOD012', 'AMO0UD33010', None, None, '0U', '3', '301', None, '1', '0', 'AMO E', 'sala/comedor,cocina, 2 recámaras, 2 baños, vestidor, p. de lavado, balcón y esc. int. roof garden', None, None, '2', 'n/a', '2', '1', '25', None, '5.95', '2.48', 'n/a', None, None, '75.25', None, '0', '2.33', None, '75.25', '152.83', None, None, '0', None, None, None, None, None, '0', '1', '1', '3210953', '25000', '175000', '481643', '20-Jan-15', '20-Jan-15', '24-Jul-14', 'LIBERADO', 'INACTIVO', 'CANCELADO', '014-REUBICACION', 'PV00062618', 'DONACIANO VERA LOPEZ', 'DONACIANO', 'VERA', 'LOPEZ', 'VELD540706D30', 'VELD540706HDFRPN02', '0', 'H', 'DONACIANO.VERA@DRAGADOSMX.COM', '57990684', '36403166', '5514733297', None, '6-Jul-54', 'CASADO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '1', 'Impresos', 'BOSQUES DE CAMERUN', '29', None, 'BOSQUES DE ARAGON', 'NEZAHUALCÓYOTL MEX', 'MEX', 'MEXICO', '57170', '5', 'EMPLEADO', '1538010637164', 'IFE', '30000024650', 'SI000004163', 'DEV000001183', '3254625.33000', '3434625.34000', '.00000', '.00000', '3434625.34000', '-3254625.33000', '-3434625.34000', '.00000', '-598998.68000', '-3391110.00000', '-3990108.68000', '1-Jan-00', '20-Jun-15', '18-Mar-15', '18-Mar-15', '18-Mar-15', '0', None, '18-Mar-15', '18-Mar-15', '18-Mar-15', '18-Mar-15', '18-Mar-15', None, None, None, None, None, '18-Mar-15', None, None, 'REUBICACION'), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP014', '2', 'ESTACIONAMIENTO', 'AMOE009', 'AMOCDEX0050', None, None, '0U', None, '005', None, '1', '0', 'EST CDEX', 'Cajón Chico, Adelante Triple, Abajo sin eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante Triple', '0', '1', '1', '230000', '0', '0', '0', '20-Feb-15', '20-Feb-15', '24-Aug-14', 'LIBERADO', 'INACTIVO', 'CANCELADO', '014-REUBICACION', 'PV00062618', 'DONACIANO VERA LOPEZ', 'DONACIANO', 'VERA', 'LOPEZ', 'VELD540706D30', 'VELD540706HDFRPN02', '0', 'H', 'DONACIANO.VERA@DRAGADOSMX.COM', '57990684', '36403166', '5514733297', None, '6-Jul-54', 'CASADO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '1', 'Impresos', 'BOSQUES DE CAMERUN', '29', None, 'BOSQUES DE ARAGON', 'NEZAHUALCÓYOTL MEX', 'MEX', 'MEXICO', '57170', '5', 'EMPLEADO', '1538010637164', 'IFE', '30000024650', 'SI000004164', 'DEV000001183', '180000.00000', '.00000', '.00000', '.00000', '.00000', '-180000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '20-Jun-15', '18-Mar-15', '18-Mar-15', '18-Mar-15', '0', None, '18-Mar-15', '18-Mar-15', '18-Mar-15', '18-Mar-15', '18-Mar-15', None, None, None, None, None, '18-Mar-15', None, None, 'REUBICACION'), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP014', '2', 'ESTACIONAMIENTO', 'AMOE010', 'AMOCEEX0060', None, None, '0U', None, '006', None, '1', '0', 'EST CEEX', 'Cajón Chico, Atrás doble, Abajo sin eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '1', '0', '0', '0', '20-Feb-15', '20-Feb-15', '24-Aug-14', 'LIBERADO', 'INACTIVO', 'CANCELADO', '014-REUBICACION', 'PV00062618', 'DONACIANO VERA LOPEZ', 'DONACIANO', 'VERA', 'LOPEZ', 'VELD540706D30', 'VELD540706HDFRPN02', '0', 'H', 'DONACIANO.VERA@DRAGADOSMX.COM', '57990684', '36403166', '5514733297', None, '6-Jul-54', 'CASADO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '1', 'Impresos', 'BOSQUES DE CAMERUN', '29', None, 'BOSQUES DE ARAGON', 'NEZAHUALCÓYOTL MEX', 'MEX', 'MEXICO', '57170', '5', 'EMPLEADO', '1538010637164', 'IFE', '30000024650', 'SI000004165', 'DEV000001183', '.01000', '.00000', '.00000', '.00000', '.00000', '-.01000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '20-Jun-15', '18-Mar-15', '18-Mar-15', '18-Mar-15', '0', None, '18-Mar-15', '18-Mar-15', '18-Mar-15', '18-Mar-15', '18-Mar-15', None, None, None, None, None, '18-Mar-15', None, None, 'REUBICACION'), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP014', '1', 'DEPARTAMENTO', 'AMOD014', 'AMO0UD33030', None, None, '0U', '3', '303', None, '1', '0', 'AMO D2', 'sala/comedor,cocina, dos recámaras, 2 baños, vestidor, patio de lavado y esc. int. a roof garden', None, None, '2', 'n/a', '2', '0', '25.13', None, '5.95', '2.43', 'n/a', None, None, '78.49', None, '0', '0', None, '78.49', '156.98', None, None, '0', None, None, None, None, None, '0', '1', '1', '3230841', '25000', '175000', '484626', '20-Jan-15', '20-Jan-15', '24-Jul-14', 'LIBERADO', 'INACTIVO', 'CANCELADO', '014-REUBICACION', 'PV00071084', 'YOLANDA MOGUEL GARRIDO', 'YOLANDA', 'MOGUEL', 'GARRIDO', 'MOGY830322T40', 'MOGY830322MCSGRL07', '0', 'H', 'YMOGUEL@GMAIL.COM', '5543602141', '52818632', '5555017356', None, '22-Mar-83', 'CASADO', None, 'MEXICANA', 'CHIAPAS', None, '57', 'Activación', 'ANDREA DEL SARTO 15', '15', '205', 'MIXCOAC', 'BENITO JUÁREZ DF', 'DF', 'MEXICO', '03910', '5', 'EMPLEADA', '4454089965991', 'IFE', '30010152624', 'SI000005418', 'DEV000001176', '3113010.20000', '3113010.22000', '.00000', '.00000', '3113010.22000', '-3113010.20000', '-3113010.22000', '.00000', '-532947.38000', '-3345830.20000', '-3878777.58000', '1-Jan-00', '20-Jun-15', '31-Jul-14', '31-Jul-14', '31-Jul-14', '0', None, '31-Jul-14', '31-Jul-14', '31-Jul-14', '31-Jul-14', '31-Jul-14', None, None, None, None, None, '13-Mar-15', None, None, 'REUBICACION POR COMODIDAD'), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP015', '2', 'ESTACIONAMIENTO', 'AMOE027', 'AMOCCEX0190', None, None, '0U', None, '019', None, '1', '0', 'EST CCEX', 'Cajón Chico, Atrás triple, Abajo sin eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás triple', '0', '1', '1', '1', '0', '0', '0', '20-Feb-15', '20-Feb-15', '24-Aug-14', 'LIBERADO', 'INACTIVO', 'CANCELADO', '014-REUBICACION', 'PV00071084', 'YOLANDA MOGUEL GARRIDO', 'YOLANDA', 'MOGUEL', 'GARRIDO', 'MOGY830322T40', 'MOGY830322MCSGRL07', '0', 'H', 'YMOGUEL@GMAIL.COM', '5543602141', '52818632', '5555017356', None, '22-Mar-83', 'CASADO', None, 'MEXICANA', 'CHIAPAS', None, '57', 'Activación', 'ANDREA DEL SARTO 15', '15', '205', 'MIXCOAC', 'BENITO JUÁREZ DF', 'DF', 'MEXICO', '03910', '5', 'EMPLEADA', '4454089965991', 'IFE', '30010152624', 'SI000005420', 'DEV000001176', '.01000', '.00000', '.00000', '.00000', '.00000', '-.01000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '20-Jun-15', '31-Jul-14', '31-Jul-14', '31-Jul-14', '0', None, '31-Jul-14', '31-Jul-14', '31-Jul-14', '31-Jul-14', '31-Jul-14', None, None, None, None, None, '13-Mar-15', None, None, 'REUBICACION'), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP015', '2', 'ESTACIONAMIENTO', 'AMOE026', 'AMOCBEX0180', None, None, '0U', None, '018', None, '1', '0', 'EST CBEX', 'Cajón Chico, En medio Triple, Abajo sin eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'En medio Triple', '0', '1', '1', '1', '0', '0', '0', '20-Feb-15', '20-Feb-15', '24-Aug-14', 'LIBERADO', 'INACTIVO', 'CANCELADO', '014-REUBICACION', 'PV00071084', 'YOLANDA MOGUEL GARRIDO', 'YOLANDA', 'MOGUEL', 'GARRIDO', 'MOGY830322T40', 'MOGY830322MCSGRL07', '0', 'H', 'YMOGUEL@GMAIL.COM', '5543602141', '52818632', '5555017356', None, '22-Mar-83', 'CASADO', None, 'MEXICANA', 'CHIAPAS', None, '57', 'Activación', 'ANDREA DEL SARTO 15', '15', '205', 'MIXCOAC', 'BENITO JUÁREZ DF', 'DF', 'MEXICO', '03910', '5', 'EMPLEADA', '4454089965991', 'IFE', '30010152624', 'SI000005419', 'DEV000001176', '.01000', '.00000', '.00000', '.00000', '.00000', '-.01000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '20-Jun-15', '31-Jul-14', '31-Jul-14', '31-Jul-14', '0', None, '31-Jul-14', '31-Jul-14', '31-Jul-14', '31-Jul-14', '31-Jul-14', None, None, None, None, None, '13-Mar-15', None, None, 'REUBICACION'), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP010', '1', 'DEPARTAMENTO', 'AMOD010', 'AMO0UD22030', None, None, '0U', '2', '203', None, '1', '0', 'AMO B2', 'sala/comedor,cocina, dos recámaras, 2 baños, vestidor y patio de lavado', None, None, '2', 'n/a', '2', '0', '25.13', None, '5.95', '2.43', 'n/a', None, None, '78.49', None, '0', '0', None, '0', '78.49', None, None, '0', None, None, None, None, None, '0', '1', '1', '2446437', '25000', '175000', '366966', '20-Jan-15', '20-Jan-15', '24-Jul-14', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00063898', 'SILVIA MARIBEL ESPINO PELAEZ', 'SILVIA MARIBEL', 'ESPINO', 'PELAEZ', 'EIPS640421LD1', 'EIPS640421MOCSLL07', '1', None, 'spelaez13@gmail.com', '5554370481', '49890750', '5549881359', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'NAPOLES', 'BENITO JUÁREZ DF', 'DF', 'Mexico', '03810', '0', None, None, None, '30000025632', 'SI000004707', 'DEV000001220', '2479711.73000', '2479711.74000', '.00000', '.00000', '2479711.74000', '-2479711.73000', '-2479711.74000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '28-May-14', '28-May-14', '28-May-14', '0', None, '28-May-14', '28-May-14', '28-May-14', '28-May-14', '28-May-14', None, None, None, None, None, '17-Apr-15', None, None, 'CANCELADO POR FALTA DE RECURSOS'), ('AMO', 'Maia', 'Amores # 206', None, 'Del Valle Norte', 'Benito Juárez', 'Distrito Federal', '03100', 'Mexico', '0561', 'AMOP010', '2', 'ESTACIONAMIENTO', 'AMOE022', 'AMOCAEX0140', None, None, '0U', None, '014', None, '1', '0', 'EST CAEX', 'Cajón Chico, Adelante Triple, Abajo sin eleva autos', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante Triple', '0', '1', '1', '1', '0', '0', '0', '20-Apr-15', '20-Apr-15', '22-Oct-14', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00063898', 'SILVIA MARIBEL ESPINO PELAEZ', 'SILVIA MARIBEL', 'ESPINO', 'PELAEZ', 'EIPS640421LD1', 'EIPS640421MOCSLL07', '1', None, 'spelaez13@gmail.com', '5554370481', '49890750', '5549881359', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'NAPOLES', 'BENITO JUÁREZ DF', 'DF', 'Mexico', '03810', '0', None, None, None, '30000025632', 'SI000004708', 'DEV000001220', '.01000', '.00000', '.00000', '.00000', '.00000', '-.01000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '28-May-14', '28-May-14', '28-May-14', '0', None, '28-May-14', '28-May-14', '28-May-14', '28-May-14', '28-May-14', None, None, None, None, None, '17-Apr-15', None, None, 'CANCELADO POR FALTA DE RECURSOS'), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBPLOCAL001', '4', 'LOCAL', 'ARBL001', 'ARB01LC0010', None, 'ss', None, None, '001', '38.29', '1', '0', 'LOCAL COMERCIAL DE 38.29 M2', 'LOCAL COMERCIAL DE 38.29 M2', None, None, None, None, None, None, None, None, None, None, None, None, None, '38.29', None, None, None, None, None, None, None, None, '0', None, None, None, None, None, '1', '0', '0', '421650.72', '0', '0', '0', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBPLOCAL002', '4', 'LOCAL', 'ARBL002', 'ARB01LC0020', None, '01', None, None, '002', '28.39', '1', '0', 'LOCAL COMERCIAL  DE 28.39 M2', 'LOCAL COMERCIAL  DE 28.39 M2', None, None, None, None, None, None, None, None, None, None, None, None, None, '28.39', None, None, None, None, None, None, None, None, '0', None, None, None, None, None, '1', '0', '0', '395286.24', '0', '0', '0', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBPLOCAL003', '4', 'LOCAL', 'ARBL003', 'ARB01LC0030', None, '01', None, None, '003', '31.85', '1', '0', 'LOCAL COMERCIAL DE 31.85 M2', 'LOCAL COMERCIAL DE 31.85 M2', None, None, None, None, None, None, None, None, None, None, None, None, None, '31.85', None, None, None, None, None, None, None, None, '0', None, None, None, None, None, '1', '0', '0', '443379.84', '0', '0', '0', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBPLOCAL004', '4', 'LOCAL', 'ARBL004', 'ARB01LC0040', None, '01', None, None, '004', '35.3', '1', '0', 'LOCAL COMERCIAL DE 35.3 M2', 'LOCAL COMERCIAL DE 35.3 M2', None, None, None, None, None, None, None, None, None, None, None, None, None, '35.3', None, None, None, None, None, None, None, None, '0', None, None, None, None, None, '1', '0', '0', '491459.52', '0', '0', '0', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBPLOCAL005', '4', 'LOCAL', 'ARBL005', 'ARB01LC0050', None, '01', None, None, '005', '38.76', '1', '0', 'LOCAL COMERCIAL DE 38.76 M2', 'LOCAL COMERCIAL DE 38.76 M2', None, None, None, None, None, None, None, None, None, None, None, None, None, '38.76', None, None, None, None, None, None, None, None, '0', None, None, None, None, None, '1', '0', '0', '539553.12', '0', '0', '0', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBPLOCAL006', '4', 'LOCAL', 'ARBL006', 'ARB01LC0060', None, '01', None, None, '006', '42.18', '1', '0', 'LOCAL COMERCIAL DE 42.18 M2', 'LOCAL COMERCIAL DE 42.18 M2', None, None, None, None, None, None, None, None, None, None, None, None, None, '42.18', None, None, None, None, None, None, None, None, '0', None, None, None, None, None, '1', '0', '0', '586421.76', '0', '0', '0', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBPLOCAL007', '4', 'LOCAL', 'ARBL007', 'ARB01LC0070', None, '01', None, None, '007', '94.6', '1', '0', 'LOCAL COMERCIAL DE 94.60 M2', 'LOCAL COMERCIAL DE 94.60 M2', None, None, None, None, None, None, None, None, None, None, None, None, None, '94.6', None, None, None, None, None, None, None, None, '0', None, None, None, None, None, '1', '0', '0', '1316929.44', '0', '0', '0', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBPLOCAL008', '4', 'LOCAL', 'ARBL008', 'ARB01LC0080', None, '01', None, None, '008', '53.13', '1', '0', 'LOCAL COMERCIAL DE 53.13 M2', 'LOCAL COMERCIAL DE 53.13 M2', None, None, None, None, None, None, None, None, None, None, None, None, None, '53.13', None, None, None, None, None, None, None, None, '0', None, None, None, None, None, '1', '0', '0', '739583.52', '0', '0', '0', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBPLOCAL009', '4', 'LOCAL', 'ARBL009', 'ARB04LC0090', None, '04', None, None, '009', '60 (terreno)', '1', '0', 'LOCAL COMERCIAL DE 60 M2', 'LOCAL COMERCIAL DE 60 M2', None, None, None, None, None, None, None, None, None, None, None, None, None, '60', None, None, None, None, None, None, None, None, '0', None, None, None, None, None, '1', '0', '1', '258100', '0', '0', '0', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBPLOCAL010', '4', 'LOCAL', 'ARBL010', 'ARB07LC0100', None, '07', None, None, '010', '60 (terreno)', '1', '0', 'LOCAL COMERCIAL DE 60 M2', 'LOCAL COMERCIAL DE 60 M2', None, None, None, None, None, None, None, None, None, None, None, None, None, '60', None, None, None, None, None, None, None, None, '0', None, None, None, None, None, '1', '0', '1', '0', '0', '0', '0', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC146', '0', 'CASA', 'ARBC146', 'ARB02CA0040', None, '02', None, None, '004', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '010-ESCRITURADA', 'PV00077539', 'ANGEL JOEL TELLEZ ELIZALDE', 'ANGEL JOEL', 'TELLEZ', 'ELIZALDE', 'TEEA890520NX0', 'TEEA890520HMCLLN04', '0', 'H', 'jtellez208@gmail.com', '16760055', '5544923217', None, '20098924242', '20-May-89', 'SOLTERO', None, 'MEXICANA', 'ESTADO DE MEXICO', None, '2', 'Volante', 'CLL CAOBA NUM 157', '29', '9A', 'EX HACIENDA SN MIGUEL FRACCIONAMIENTO', 'CUAUTITLÁN IZCALLI MEX', 'MEXICO', 'MEXICO', '54715', '9', 'EMPLEADO', '1416118397149', 'IFE', '30020113962', '0002808', None, '549678.00000', '549678.00000', '.00000', '.00000', '549678.00000', '.00000', '.00000', '48600.00000', '6500.00000', '-551199.03000', '53578.97000', '1-Jan-00', '21-Apr-15', '12-May-15', '4-May-15', '4-May-15', '12', None, '12-May-15', '14-May-15', '15-May-15', '18-May-15', '18-May-15', None, '3-Sep-15', '3-Sep-15', None, '9-Sep-15', None, None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC217', '0', 'CASA', 'ARBC217', 'ARB07CA0230', None, '07', None, None, '023', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '24-Jan-14', '24-Jan-14', '28-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '011-LIBERADA', 'PV00083333', 'MARTHA PATRICIA HERNANDEZ GOMEZ', 'MARTHA PATRICIA', 'HERNANDEZ', 'GOMEZ', 'HEGM860409LM6', 'HEGM860409MMCRMR01', '0', 'H', 'PATRICA8624@OUTLOOK.COM', None, '5518298696', '91724990', '92088621500', '9-Apr-86', 'CASADO', 'BIENES MANCOMUNADOS', 'MEXICANA', 'ESTADO DE MEXICO', None, '35', 'Suburbano', 'CERRADA TEXCOCO', '83', None, 'ISIDRO FABELA', 'TLALNEPANTLA', 'MEXICO', 'MEXICO', '54110', '5', 'EMPLEADO', '5096103453020', 'IFE', '30020121007', '0002890', None, '515330.50000', '515330.50000', '.00000', '.00000', '515330.50000', '.00000', '.00000', '51637.50000', '.00000', '-524621.30000', '42346.70000', '31-May-15', '31-May-15', '31-May-15', '31-May-15', '1-Jun-15', '12', None, '1-Jun-15', '1-Jun-15', '2-Jun-15', '3-Jun-15', '3-Jun-15', None, '1-Sep-15', '15-Sep-15', None, '15-Sep-15', None, '1-Dec-15', None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC082', '0', 'CASA', 'ARBC082', 'ARB06CA0290', None, '06', None, None, '029', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '011-LIBERADA', 'PV00083519', 'LIAM MORENO MARIN', 'LIAM', 'MORENO', 'MARIN', 'MOML770919S2A', 'MOML770919HDFRRM08', '0', 'H', 'LIAM.MORENO@HOTMAIL.COM', '5558710711', '5516970048', None, '11977716254', '19-Sep-77', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '2', 'Volante', 'NOVEDADES', '196', None, 'ATLANTA', 'CUAUTITLAN IZCALLI', 'MEXICO', 'MEXICO', '54740', '10', 'EMPLEADO', '0807046949965', 'IFE', '30020122427', '0002953', None, '555862.50000', '555862.50000', '.00000', '.00000', '555862.50000', '.00000', '.00000', '.00000', '.00000', '-589481.66000', '-33619.16000', '7-Jun-15', '7-Jun-15', '13-Jun-15', '8-Jun-15', '8-Jun-15', '12', None, '18-Jun-15', '18-Jun-15', '18-Jun-15', '19-Jun-15', '19-Jun-15', '17-Jun-15', '14-Jul-15', '14-Jul-15', None, '1-Sep-15', None, '25-Sep-15', None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC042', '0', 'CASA', 'ARBC042', 'ARB08CA0050', None, '08', None, None, '005', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '31-Jan-14', '31-Jan-14', '4-Aug-13', 'LIBERADO', 'INACTIVO', 'VENTA', '011-LIBERADA', 'PV00084875', 'VERONICA VAZQUEZ PEREZ', 'VERONICA', 'VAZQUEZ', 'PEREZ', 'VAPV7206183R5', 'VAPV720618MDFZRR03', '0', 'M', 'VEROPEREZ.1@HOTMAIL.COM', '53824190', '5515120099', '5548964085', '07967205050', '18-Jun-72', 'CASADO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '2', 'Volante', 'AV PASEO DEL FERROCARRIL 95 95', '95', 'N 101', 'LOS REYES IZTACALA', 'TLALNEPANTLA', 'MEXICO', 'MEXICO', '54000', '8', 'EMPLEADO', '5048003240971', 'IFE', '30020133010', '0003184', None, '472004.50000', '472004.50000', '.00000', '.00000', '472004.50000', '.00000', '.00000', '.00000', '32493.44000', '-504497.94000', '.00000', '11-Aug-15', '13-Aug-15', '11-Aug-15', '13-Aug-15', '13-Aug-15', '12', None, '14-Aug-15', '14-Aug-15', '17-Aug-15', '19-Aug-15', '19-Aug-15', None, '1-Sep-15', '9-Sep-15', None, '14-Sep-15', None, '1-Oct-15', None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC216', '0', 'CASA', 'ARBC216', 'ARB07CA0240', None, '07', None, None, '024', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '24-Jan-14', '24-Jan-14', '28-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '011-LIBERADA', 'PV00085344', 'JUANA FABIOLA CRUZ ORTEGA', 'JUANA FABIOLA', 'CRUZ', 'ORTEGA', 'CUOJ820120UP1', 'CUOJ820120MDFRRN05', '0', 'M', 'FABIOLA.CRUZ@DILETTO.COM', '51136903', '5514705253', '5552161994', '42978207233', '20-Jan-82', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '2', 'Volante', 'NARANJOS', 'MZA 18', 'LT 2 EDIF 3-C 301', 'ALAMOS III', 'CUAUTITLAN', 'MEXICO', 'MEXICO', '54830', '8', 'EMPLEADO', '1169084877557', 'IFE', '30020134182', '0003237', None, '443341.50000', '443341.50000', '.00000', '.00000', '443341.50000', '.00000', '.00000', '.00000', '26280.57000', '-468131.17000', '1490.90000', '15-Aug-15', '22-Aug-15', '22-Aug-15', '9-Sep-15', '10-Sep-15', '12', None, '10-Sep-15', '10-Sep-15', '10-Sep-15', '11-Sep-15', '11-Sep-15', '29-Aug-15', '11-Sep-15', '11-Sep-15', None, '15-Sep-15', None, '9-Oct-15', None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC212', '0', 'CASA', 'ARBC212', 'ARB07CA0200', None, '07', None, None, '020', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '24-Jan-14', '24-Jan-14', '28-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00016261', 'ISMAEL MEDINA OROZCO', 'ISMAEL', 'MEDINA', 'OROZCO', 'MEOI760925K29', 'MEOI760925HCHDRS00', '1', None, None, '58720264', None, '5546096974', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LOS MORALES', 'CUAUTITLÁN', 'MEX', 'Mexico', None, '0', None, None, None, '30010174115', 'SI000010246', None, '584818.33000', '584818.33000', '.00000', '.00000', '584818.33000', '.00000', '.00000', '54680.51000', '.00000', '-584818.33000', '54680.51000', '1-Jan-00', '19-Jun-15', '2-Dec-14', '2-Dec-14', '2-Dec-14', '0', None, '2-Dec-14', '2-Dec-14', '2-Dec-14', '2-Dec-14', '2-Dec-14', None, '27-Jan-15', '27-Jan-15', None, '30-Jan-15', None, '2-Mar-15', '11-Mar-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC167', '0', 'CASA', 'ARBC167', 'ARB01CA0080', None, '01', None, None, '008', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00016369', 'ULISES GABRIEL PANTOJA RAMIREZ', 'ULISES GABRIEL', 'PANTOJA', 'RAMIREZ', 'PARU8210206Q1', None, '1', None, None, '26181474', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'AMPLIACION OLIMPICA PONIENTE', 'NAUCALPAN JUÁREZ MEX', 'MEX', 'Mexico', '53690', '0', None, None, None, '30000000627', 'SI000001172', None, '442000.00000', '442000.00000', '.00000', '.00000', '442000.00000', '.00000', '.00000', '42607.95000', '.00000', '-442000.00000', '42607.95000', '15-Jan-15', '15-Jan-15', '31-Oct-12', '31-Oct-12', '31-Oct-12', '0', None, '31-Oct-12', '31-Oct-12', '31-Oct-12', '31-Oct-12', '31-Oct-12', None, '28-Feb-13', '28-Feb-13', None, '28-Feb-13', None, '12-Apr-13', '12-Apr-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC166', '0', 'CASA', 'ARBC166', 'ARB01CA0070', None, '01', None, None, '007', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00017011', 'LOURDES TORREZ ROMERO', 'LOURDES', 'TORREZ', 'ROMERO', 'TORL700124TC2', None, '1', None, None, '13128285', None, '5528649328', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LA CONCHITA ZAPOTITLAN', 'MILPA ALTA DF', 'DF', 'Mexico', '13360', '0', None, None, None, '30000001419', 'SI000001323', None, '452000.00000', '452000.00000', '.00000', '.00000', '452000.00000', '.00000', '.00000', '42641.10000', '.00000', '-452000.00000', '42641.10000', '1-Jan-00', '19-Jun-15', '27-Dec-12', '27-Dec-12', '27-Dec-12', '0', None, '27-Dec-12', '27-Dec-12', '27-Dec-12', '27-Dec-12', '27-Dec-12', None, '30-Mar-13', '30-Mar-13', None, '30-Mar-13', None, '16-Jul-13', '22-Jul-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC203', '0', 'CASA', 'ARBC203', 'ARB07CA0280', None, '07', None, None, '028', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '24-Jan-14', '24-Jan-14', '28-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00020555', 'VICTOR ANGEL AGUILAR VEGA', 'VICTOR ANGEL', 'AGUILAR', 'VEGA', 'AUVV750314QQ1', 'AUVV750314HDFGGC02', '0', 'H', 'victorangel.aguilar@gmail.com', '5517285956', '5558811048', None, None, '14-Mar-75', 'CASADO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '35', 'Suburbano', 'ICEBERG', '3', None, 'ATLANTA 1A SECCION', 'CUAUTITLAN IZCALLI', 'MEXICO', 'MEXICO', '54740', '13', 'EMPLEADO', '0806046110912', 'IFE', '30010182829', '0002347', None, '564819.00000', '564819.00000', '.00000', '.00000', '564819.00000', '.00000', '.00000', '55917.08000', '.00000', '-564819.00000', '55917.08000', '1-Jan-00', '11-Mar-15', '2-Mar-15', '2-Mar-15', '2-Mar-15', '0', None, '11-Mar-15', '12-Mar-15', '12-Mar-15', '13-Mar-15', '13-Mar-15', None, '10-Jul-15', '10-Jul-15', None, '28-Jul-15', None, '2-Sep-15', '9-Sep-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC143', '0', 'CASA', 'ARBC143', 'ARB02CA0160', None, '02', None, None, '016', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00023447', 'DAVID CERRILLO SAUCEDO', 'DAVID', 'CERRILLO', 'SAUCEDO', 'CESD800116AP6', None, '1', None, 'david.cerrillo@hotmail.com', '5513586213', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'COL. SAN MIGUEL OTLICA', 'TULTEPEC MEX', 'MEX', 'Mexico', '54960', '0', None, None, None, '30000008265', 'SI000001662', None, '464000.00000', '464000.00000', '.00000', '.00000', '464000.00000', '.00000', '.00000', '42607.95000', '.00000', '-464000.00000', '42607.95000', '15-Jan-15', '15-Jan-15', '18-Feb-13', '18-Feb-13', '18-Feb-13', '0', None, '18-Feb-13', '18-Feb-13', '18-Feb-13', '18-Feb-13', '18-Feb-13', None, '30-Jun-13', '30-Jun-13', None, '30-Jun-13', None, '26-Jul-13', '1-Aug-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC173', '0', 'CASA', 'ARBC173', 'ARB01CA0030', None, '01', None, None, '003', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00024027', 'SARA MEDINA LOPEZ', 'SARA', 'MEDINA', 'LOPEZ', 'MELS670409KF8', None, '1', None, None, '5532774905', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SANTA INES', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02140', '0', None, None, None, '30000008554', 'SI000001045', None, '432000.00000', '432000.00000', '.00000', '.00000', '432000.00000', '.00000', '.00000', '.00000', '.00000', '-432000.00000', '.00000', '1-Jan-00', '19-Jun-15', '30-Sep-12', '30-Sep-12', '30-Sep-12', '0', None, '30-Sep-12', '30-Sep-12', '30-Sep-12', '30-Sep-12', '30-Sep-12', None, '28-Feb-13', '28-Feb-13', None, '28-Feb-13', None, '6-Apr-13', '6-Apr-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC137', '0', 'CASA', 'ARBC137', 'ARB02CA0100', None, '02', None, None, '010', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00025213', 'ALEJANDRO JAVIER TOVAR MELENDEZ', 'ALEJANDRO JAVIER', 'TOVAR', 'MELENDEZ', 'TOMA8701123JA', None, '1', None, None, '49919566', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN SEBASTIAN XHALA', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54714', '0', None, None, None, '30000009214', 'SI000001719', None, '464000.00000', '464000.00000', '.00000', '.00000', '464000.00000', '.00000', '.00000', '41225.00000', '.00000', '-464286.23000', '40938.77000', '1-Jan-00', '19-Jun-15', '21-Feb-13', '21-Feb-13', '21-Feb-13', '0', None, '21-Feb-13', '21-Feb-13', '21-Feb-13', '21-Feb-13', '21-Feb-13', None, '30-Apr-13', '30-Apr-13', None, '30-Apr-13', None, '1-Jul-13', '5-Jul-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC163', '0', 'CASA', 'ARBC163', 'ARB01CA0040', None, '01', None, None, '004', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00026228', 'MARCO ANTONIO CORTES MANDUJANO', 'MARCO ANTONIO', 'CORTES', 'MANDUJANO', 'COMM740926PH8', None, '1', None, None, '5520861307', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PUEBLO SNA JUAN ATLAMICA', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54729', '0', None, None, None, '30000009578', 'SI000001171', None, '431161.59000', '431161.59000', '.00000', '.00000', '431161.59000', '.00000', '.00000', '42607.95000', '.00000', '-431161.59000', '42607.95000', '1-Jan-00', '19-Jun-15', '31-Oct-12', '31-Oct-12', '31-Oct-12', '0', None, '31-Oct-12', '31-Oct-12', '31-Oct-12', '31-Oct-12', '31-Oct-12', None, '31-Mar-13', '31-Mar-13', None, '31-Mar-13', None, '9-May-13', '9-May-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC003', '0', 'CASA', 'ARBC003', 'ARB04CA0260', None, '04', None, None, '026', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00026620', 'GABRIELA MARTINEZ CASTILLO', 'GABRIELA', 'MARTINEZ', 'CASTILLO', 'MACG841015A3A', 'MACG841015MMCRSB00', '1', None, 'peque_gmc@hotmail.com', '58774869', '43307833', '5524942590', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PLAN DE GUADALUPE VICTORIA', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54760', '0', None, None, None, '30000009701', 'SI000002934', None, '465677.67000', '465677.67000', '.00000', '.00000', '465677.67000', '.00000', '.00000', '.00000', '.00000', '-465677.67000', '.00000', '15-Jan-15', '15-Jan-15', '25-Oct-13', '25-Oct-13', '25-Oct-13', '0', None, '25-Oct-13', '25-Oct-13', '25-Oct-13', '25-Oct-13', '25-Oct-13', None, '29-Nov-13', '29-Nov-13', None, '9-Dec-13', None, '14-Mar-14', '21-Mar-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC142', '0', 'CASA', 'ARBC142', 'ARB02CA0150', None, '02', None, None, '015', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00026689', 'JESUS ARCIGA PEREZ', 'JESUS', 'ARCIGA', 'PEREZ', 'AIPJ7509181Z9', None, '1', None, None, '5379 2991', None, '5522674207', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN MIGUEL XOCHIMANGA', 'ATIZAPÁN MEX', 'MEX', 'Mexico', '54600', '0', None, None, None, '30000009735', 'SI000001832', None, '464000.00000', '464000.00000', '.00000', '.00000', '464000.00000', '.00000', '.00000', '48000.00000', '.00000', '-464000.00000', '48000.00000', '1-Jan-00', '19-Jun-15', '28-Feb-13', '28-Feb-13', '28-Feb-13', '0', None, '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', None, '31-May-13', '31-May-13', None, '31-May-13', None, '25-Jun-13', '1-Jul-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC102', '0', 'CASA', 'ARBC102', 'ARB05CA0220', None, '05', None, None, '022', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '29-Nov-13', '29-Nov-13', '2-Jun-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00026817', 'CAROLINA RAMIREZ MENDOZA', 'CAROLINA', 'RAMIREZ', 'MENDOZA', 'RAMC830126ME2', 'RAMC830126MDFMNR05', '1', None, None, '11132977', None, '5510076621', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'CUAUTITLÁN IZCALLI MEX', None, 'Mexico', None, '0', None, None, None, '30010161708', 'SI000005695', None, '559818.33000', '559818.33000', '.00000', '.00000', '559818.33000', '.00000', '.00000', '55422.01000', '.00000', '-561318.33000', '53922.01000', '1-Jan-00', '19-Jun-15', '5-Sep-14', '5-Sep-14', '5-Sep-14', '0', None, '5-Sep-14', '5-Sep-14', '5-Sep-14', '5-Sep-14', '5-Sep-14', None, '22-Oct-14', '22-Oct-14', None, '11-Nov-14', None, '27-Feb-15', '4-Mar-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC153', '0', 'CASA', 'ARBC153', 'ARB03CA0070', None, '03', None, None, '007', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '30-Mar-13', '30-Mar-13', '1-Oct-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00027972', 'MARCOS EDUARDO PARACHE REYES', 'MARCOS EDUARDO', 'PARACHE', 'REYES', 'PARM670906GJ5', 'PARM670906HDFRYR05', '1', None, None, '54289786', '58739335', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'JARDINES DE LA HACIENDA', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54720', '0', None, None, None, '30000010063', 'SI000003225', None, '499484.12000', '499484.12000', '.00000', '.00000', '499484.12000', '.00000', '.00000', '54000.00000', '.00000', '-499484.12000', '54000.00000', '1-Jan-00', '19-Jun-15', '4-Dec-13', '4-Dec-13', '4-Dec-13', '0', None, '4-Dec-13', '4-Dec-13', '4-Dec-13', '4-Dec-13', '4-Dec-13', None, '6-Feb-14', '6-Feb-14', None, '11-Feb-14', None, '2-Apr-14', '4-Apr-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC228', '0', 'CASA', 'ARBC228', 'ARB03CA0190', None, '03', None, None, '019', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '30-Mar-13', '30-Mar-13', '1-Oct-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00028440', 'HECTOR HUGO SOSA GODINEZ', 'HECTOR HUGO', 'SOSA', 'GODINEZ', 'SOGH750809DU9', 'SOGH750809HDFSDC00', '1', None, None, '49912288', '53916898', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BARRIO SANTIAGO', 'TEOLOYUCÁN MEX', 'MEX', 'Mexico', '54784', '0', None, None, None, '30000010238', 'SI000001758', None, '474000.00000', '474000.00000', '.00000', '.00000', '474000.00000', '.00000', '.00000', '51000.00000', '.00000', '-474000.00000', '51000.00000', '1-Jan-00', '19-Jun-15', '26-Feb-13', '26-Feb-13', '26-Feb-13', '0', None, '26-Feb-13', '26-Feb-13', '26-Feb-13', '26-Feb-13', '26-Feb-13', None, '30-Apr-13', '30-Apr-13', None, '30-Apr-13', None, '11-Jul-13', '22-Jul-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC040', '0', 'CASA', 'ARBC040', 'ARB08CA0070', None, '08', None, None, '007', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '31-Jan-14', '31-Jan-14', '4-Aug-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00028504', 'SERGIO MARTIN RANGEL AGUILAR', 'SERGIO MARTIN', 'RANGEL', 'AGUILAR', 'RAAS830512TU2', 'RAAS830512HDFNGR07', '0', 'H', 'CHECOS06@HOTMAIL.COM', '20646987', '5523908205', None, None, '12-May-83', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '35', 'Suburbano', 'JUAN FERNANDEZ ALBARRAN', 'MANZANA IX', 'LOTE 7 CASA 2', 'FRACCIONAMIENTO LA GUADALUPANA', 'CUAUTITLAN', 'MÉXICO', 'MEXICO', '54840', '8', 'EMPLEADO', '0691084640976', 'IFE', '30020118961', '0002851', None, '468750.00000', '468750.00000', '.00000', '.00000', '468750.00000', '.00000', '.00000', '61750.00000', '.00000', '-468750.00000', '61750.00000', '1-Jan-00', '19-Jun-15', '21-May-15', '21-May-15', '27-May-15', '12', None, '27-May-15', '28-May-15', '28-May-15', '29-May-15', '29-May-15', '4-May-15', '1-Jul-15', '1-Jul-15', None, '8-Jul-15', None, '6-Aug-15', '14-Aug-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC176', '0', 'CASA', 'ARBC176', 'ARB01CA0170', None, '01', None, None, '017', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00028555', 'BLANCA ROSA JUAREZ BUENDIA', 'BLANCA ROSA', 'JUAREZ', 'BUENDIA', 'JUBB521115TI3', None, '1', None, None, '57637268', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'TEPALCATES', 'IZTAPALAPA DF', 'DF', 'Mexico', '09210', '0', None, None, None, '30000010303', 'SI000001324', None, '461662.05000', '461662.05000', '.00000', '.00000', '461662.05000', '.00000', '.00000', '.00000', '.00000', '-461662.05000', '.00000', '1-Jan-00', '19-Jun-15', '27-Dec-12', '27-Dec-12', '27-Dec-12', '0', None, '27-Dec-12', '27-Dec-12', '27-Dec-12', '27-Dec-12', '27-Dec-12', None, '20-Mar-13', '20-Mar-13', None, '20-Mar-13', None, '18-Jun-13', '24-Jun-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC144', '0', 'CASA', 'ARBC144', 'ARB02CA0050', None, '02', None, None, '005', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00028749', 'SILVIA RAMIREZ DIAZ', 'SILVIA', 'RAMIREZ', 'DIAZ', 'RADS710119LIA', 'RADS710119MDFMZL06', '1', None, None, '55872129', None, '5541902449', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PRENSA NACIONAL', 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54170', '0', None, None, None, '30000010378', 'SI000001372', None, '432000.00000', '432000.00000', '.00000', '.00000', '432000.00000', '.00000', '.00000', '42607.95000', '.00000', '-432000.00000', '42607.95000', '1-Jan-00', '19-Jun-15', '31-Dec-12', '31-Dec-12', '31-Dec-12', '0', None, '31-Dec-12', '31-Dec-12', '31-Dec-12', '31-Dec-12', '31-Dec-12', None, '21-Apr-13', '21-Apr-13', None, '21-Apr-13', None, '12-Jun-13', '17-Jun-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC170', '0', 'CASA', 'ARBC170', 'ARB01CA0110', None, '01', None, None, '011', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00028794', 'CESAR ALEJANDRO ZAMORA GARCIA', 'CESAR ALEJANDRO', 'ZAMORA', 'GARCIA', 'ZAGC8106067C9', 'ZAGC810606HMCMRS00', '1', None, None, '26410063', None, '5554545123', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'AMPL. BENITO JUAREZ', 'NAUCALPAN JUÁREZ MEX', 'MEX', 'Mexico', '53790', '0', None, None, None, '30000010410', 'SI000001291', None, '412000.00000', '412000.00000', '.00000', '.00000', '412000.00000', '.00000', '.00000', '.00000', '.00000', '-412000.00000', '.00000', '1-Jan-00', '19-Jun-15', '17-Dec-12', '17-Dec-12', '17-Dec-12', '0', None, '17-Dec-12', '17-Dec-12', '17-Dec-12', '17-Dec-12', '17-Dec-12', None, '12-Mar-13', '12-Mar-13', None, '12-Mar-13', None, '12-Apr-13', '12-Apr-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC177', '0', 'CASA', 'ARBC177', 'ARB01CA0180', None, '01', None, None, '018', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00029187', 'MONTZERRAT EVANGELINA SANCHEZ LOYOLA', 'MONTZERRAT EVANGELINA', 'SANCHEZ', 'LOYOLA', 'SALM861222BR5', None, '1', None, None, '5527474280', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'COYOACAN', 'COYOACÁN DF', 'DF', 'Mexico', '09810', '0', None, None, None, '30000010626', 'SI000001442', None, '442000.00000', '442000.00000', '.00000', '.00000', '442000.00000', '.00000', '.00000', '42607.95000', '.00000', '-444320.00000', '40287.95000', '1-Jan-00', '12-Mar-15', '14-Jan-13', '14-Jan-13', '14-Jan-13', '0', None, '14-Jan-13', '14-Jan-13', '14-Jan-13', '14-Jan-13', '14-Jan-13', None, '28-Feb-13', '28-Feb-13', None, '28-Feb-13', None, '23-Jul-13', '1-Aug-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC178', '0', 'CASA', 'ARBC178', 'ARB01CA0190', None, '01', None, None, '019', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00029262', 'MARIA GUADALUPE LEDEZMA AVILA', 'MARIA GUADALUPE', 'LEDEZMA', 'AVILA', 'LEAG7009106C5', None, '1', None, 'exxlibris@hotmail.com', '16681469', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'AMPL JORGE JIMENEZ CANTU', None, 'MEX', 'Mexico', '56513', '0', None, None, None, '30000010667', 'SI000001319', None, '452000.00000', '452000.00000', '.00000', '.00000', '452000.00000', '.00000', '.00000', '.00000', '.00000', '-487376.05000', '-35376.05000', '15-Jan-15', '15-Jan-15', '26-Dec-12', '26-Dec-12', '26-Dec-12', '0', None, '26-Dec-12', '26-Dec-12', '26-Dec-12', '26-Dec-12', '26-Dec-12', None, '28-Feb-13', '28-Feb-13', None, '28-Feb-13', None, '31-May-13', '31-May-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC165', '0', 'CASA', 'ARBC165', 'ARB01CA0060', None, '01', None, None, '006', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00029419', 'DANIEL ANTONIO TORRES ORTIZ', 'DANIEL ANTONIO', 'TORRES', 'ORTIZ', 'TOOD751211HT5', None, '1', None, None, '60947842', '5550903700', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN JOSE EL JARAL', 'ATIZAPÁN MEX', 'MEX', 'Mexico', '52924', '0', None, None, None, '30000010766', 'SI000001288', None, '442000.00000', '442000.00000', '.00000', '.00000', '442000.00000', '.00000', '.00000', '42585.00000', '.00000', '-442000.00000', '42585.00000', '15-Jan-15', '15-Jan-15', '14-Dec-12', '14-Dec-12', '14-Dec-12', '0', None, '14-Dec-12', '14-Dec-12', '14-Dec-12', '14-Dec-12', '14-Dec-12', None, '31-Mar-13', '31-Mar-13', None, '31-Mar-13', None, '9-May-13', '9-May-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC169', '0', 'CASA', 'ARBC169', 'ARB01CA0100', None, '01', None, None, '010', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00029560', 'JONATHAN SALAS OLIVARES', 'JONATHAN', 'SALAS', 'OLIVARES', 'SAOJ8301095N5', None, '1', None, None, '52086260', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LOMAS DE SOTELO', 'MIGUEL HIDALGO DF', 'DF', 'Mexico', '11200', '0', None, None, None, '30000010865', 'SI000001338', None, '440413.05000', '440413.05000', '.00000', '.00000', '440413.05000', '.00000', '.00000', '.00000', '.00000', '-440413.05000', '.00000', '1-Jan-00', '19-Jun-15', '28-Dec-12', '28-Dec-12', '28-Dec-12', '0', None, '28-Dec-12', '28-Dec-12', '28-Dec-12', '28-Dec-12', '28-Dec-12', None, '28-Feb-13', '28-Feb-13', None, '28-Feb-13', None, '18-Oct-13', '23-Oct-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC168', '0', 'CASA', 'ARBC168', 'ARB01CA0090', None, '01', None, None, '009', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00029561', 'RODRIGO MIRANDA VARGAS', 'RODRIGO', 'MIRANDA', 'VARGAS', 'MIVR820421TF6', 'MIVR820421HMCRRD02', '1', None, 'rmiranda@grupodiamond.com', '58729778', '26201316', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'UNIDAD HABITACIONAL CEBADALES', 'CUAUTITLÁN MEX', 'MEX', 'Mexico', '55858', '0', None, None, None, '30000010873', 'SI000001482', None, '442000.00000', '442000.00000', '.00000', '.00000', '442000.00000', '.00000', '.00000', '.00000', '.00000', '-442000.00000', '.00000', '15-Jan-15', '15-Jan-15', '22-Jan-13', '22-Jan-13', '22-Jan-13', '0', None, '22-Jan-13', '22-Jan-13', '22-Jan-13', '22-Jan-13', '22-Jan-13', None, '21-Mar-13', '21-Mar-13', None, '21-Mar-13', None, '26-Apr-13', '26-Apr-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC204', '0', 'CASA', 'ARBC204', 'ARB01CA0010', None, '01', None, None, '001', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00029862', 'CELSO CIRO MENDEZ MENDOZA', 'CELSO CIRO', 'MENDEZ', 'MENDOZA', 'MEMC610806AG0', None, '1', None, None, '5516175816', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BARRIO SAN ROQUE', 'CUAUTITLÁN MEX', 'MEX', 'Mexico', '54840', '0', None, None, None, '30000011020', 'SI000001290', None, '412000.00000', '412000.00000', '.00000', '.00000', '412000.00000', '.00000', '.00000', '42607.95000', '.00000', '-412000.00000', '42607.95000', '1-Jan-00', '19-Jun-15', '17-Dec-12', '17-Dec-12', '17-Dec-12', '0', None, '17-Dec-12', '17-Dec-12', '17-Dec-12', '17-Dec-12', '17-Dec-12', None, '28-Feb-13', '28-Feb-13', None, '28-Feb-13', None, '22-Mar-13', '22-Mar-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC150', '0', 'CASA', 'ARBC150', 'ARB03CA0040', None, '03', None, None, '004', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '30-Apr-13', '30-Apr-13', '1-Nov-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00030109', 'ERICK ISRAEL PEREZ ORTIZ', 'ERICK ISRAEL', 'PEREZ', 'ORTIZ', 'PEOE8202138K9', 'PEOE820213HDFRRR04', '1', None, None, '5559446586', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'NUEVA ESPAÑA', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02129', '0', None, None, None, '30000011129', 'SI000001765', None, '474000.00000', '474000.00000', '.00000', '.00000', '474000.00000', '.00000', '.00000', '42641.10000', '.00000', '-474000.00000', '42641.10000', '1-Jan-00', '19-Jun-15', '27-Feb-13', '27-Feb-13', '27-Feb-13', '0', None, '27-Feb-13', '27-Feb-13', '27-Feb-13', '27-Feb-13', '27-Feb-13', None, '24-Apr-13', '24-Apr-13', None, '24-Apr-13', None, '18-Jun-13', '24-Jun-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC185', '0', 'CASA', 'ARBC185', 'ARB01CA0120', None, '01', None, None, '012', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00030158', 'ALAN RODRIGUEZ SANCHEZ', 'ALAN', 'RODRIGUEZ', 'SANCHEZ', 'ROSA811112123', None, '1', None, None, '5547867770', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'TLALNEPANTLA MEX', None, 'Mexico', None, '0', None, None, None, '30000011160', 'SI000001317', None, '436605.76000', '436605.76000', '.00000', '.00000', '436605.76000', '.00000', '.00000', '.00000', '.00000', '-436605.76000', '.00000', '1-Jan-00', '19-Jun-15', '21-Dec-12', '21-Dec-12', '21-Dec-12', '0', None, '21-Dec-12', '21-Dec-12', '21-Dec-12', '21-Dec-12', '21-Dec-12', None, '28-Feb-13', '28-Feb-13', None, '28-Feb-13', None, '4-Apr-13', '4-Apr-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC136', '0', 'CASA', 'ARBC136', 'ARB02CA0090', None, '02', None, None, '009', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00030338', 'JORGE ENRIQUE DOMINGUEZ LOPEZ', 'JORGE ENRIQUE', 'DOMINGUEZ', 'LOPEZ', 'DOLJ85120681A', None, '1', None, None, '53925435', None, '5523356891', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'AHUEHUETES', 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54150', '0', None, None, None, '30000011335', 'SI000001483', None, '412000.00000', '412000.00000', '.00000', '.00000', '412000.00000', '.00000', '.00000', '42607.95000', '.00000', '-412410.38000', '42197.57000', '1-Jan-00', '19-Jun-15', '22-Jan-13', '22-Jan-13', '22-Jan-13', '0', None, '22-Jan-13', '22-Jan-13', '22-Jan-13', '22-Jan-13', '22-Jan-13', None, '31-Mar-13', '31-Mar-13', None, '31-Mar-13', None, '3-May-13', '3-May-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC062', '0', 'CASA', 'ARBC062', 'ARB08CA0180', None, '08', None, None, '018', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '31-Jan-14', '31-Jan-14', '4-Aug-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00030494', 'ROCIO PASCUAL CARBALLIDO', 'ROCIO', 'PASCUAL', 'CARBALLIDO', 'PACR790117EQ4', 'PACR790117MDFSRC01', '0', 'H', 'ROCIO_PASCUAL@HOTMAIL.COM', '53103652', '5514977224', None, None, '17-Jan-79', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '35', 'Suburbano', 'INDEPENDENCIA', '25', None, 'SANTA MARIA TLAYACAMPA', 'TLALNEPANTLA', 'MEXICO', 'MEXICO', '54110', '5', 'EMPLEADO', '5113113236473', 'IFE', '30020102619', '0002492', None, '555862.50000', '555862.50000', '.00000', '.00000', '555862.50000', '.00000', '.00000', '51637.50000', '.00000', '51137.29000', '658637.29000', '1-Jan-00', '20-Jun-15', '2-Mar-15', '2-Mar-15', '2-Mar-15', '12', None, '4-Mar-15', '4-Mar-15', '4-Mar-15', '13-Mar-15', '13-Mar-15', None, '17-Mar-15', '17-Mar-15', None, '19-Mar-15', None, '28-Apr-15', '20-May-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC159', '0', 'CASA', 'ARBC159', 'ARB01CA0140', None, '01', None, None, '014', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00030558', 'GABINO CAMACHO MENA', 'GABINO', 'CAMACHO', 'MENA', 'CAMG7610259Y1', None, '1', None, 'lizmena11@hotmail.com', '58700118', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'AMADO NERVO', 'TULTEPEC MEX', 'MEX', 'Mexico', '54960', '0', None, None, None, '30000011491', 'SI000001370', None, '402000.00000', '402000.00000', '.00000', '.00000', '402000.00000', '.00000', '.00000', '.00000', '.00000', '-434436.26000', '-32436.26000', '15-Jan-15', '15-Jan-15', '31-Dec-12', '31-Dec-12', '31-Dec-12', '0', None, '31-Dec-12', '31-Dec-12', '31-Dec-12', '31-Dec-12', '31-Dec-12', None, '12-Mar-13', '12-Mar-13', None, '12-Mar-13', None, '12-Apr-13', '12-Apr-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC174', '0', 'CASA', 'ARBC174', 'ARB01CA0150', None, '01', None, None, '015', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00030679', 'ELIZABETH CRUZ GARCIA', 'ELIZABETH', 'CRUZ', 'GARCIA', 'CUGE780806TB0', None, '1', None, None, '58930422', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'U HAB NIÑOS HEROES INFONAVIT', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', None, '0', None, None, None, '30000011566', 'SI000001371', None, '432000.00000', '432000.00000', '.00000', '.00000', '432000.00000', '.00000', '.00000', '.00000', '.00000', '-440875.00000', '-8875.00000', '1-Jan-00', '19-Jun-15', '31-Dec-12', '31-Dec-12', '31-Dec-12', '0', None, '31-Dec-12', '31-Dec-12', '31-Dec-12', '31-Dec-12', '31-Dec-12', None, '28-Feb-13', '28-Feb-13', None, '28-Feb-13', None, '7-Jun-13', '7-Jun-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC182', '0', 'CASA', 'ARBC182', 'ARB02CA0020', None, '02', None, None, '002', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00031189', 'FRANCISCO TLECUILE MIXTECO', 'FRANCISCO', 'TLECUILE', 'MIXTECO', 'TEMF730702ZZ9', None, '1', None, 'lizmena11@hotmail.com', '36366791', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN MARTIN TEPETLIXPAN', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54763', '0', None, None, None, '30000011962', 'SI000001470', None, '412000.00000', '412000.00000', '.00000', '.00000', '412000.00000', '.00000', '.00000', '.00000', '.00000', '-412000.00000', '.00000', '15-Jan-15', '15-Jan-15', '18-Jan-13', '18-Jan-13', '18-Jan-13', '0', None, '18-Jan-13', '18-Jan-13', '18-Jan-13', '18-Jan-13', '18-Jan-13', None, '21-Mar-13', '21-Mar-13', None, '21-Mar-13', None, '3-May-13', '3-May-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC135', '0', 'CASA', 'ARBC135', 'ARB02CA0080', None, '02', None, None, '008', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00031649', 'GUADALUPE MENDOZA AVALOS', 'GUADALUPE', 'MENDOZA', 'AVALOS', 'MEAG670801L24', None, '1', None, 'ines.torres@quirocasaya.com.mx', '44347274', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN MIGUEL CHAPULTEPEC', 'MIGUEL HIDALGO DF', 'DF', 'Mexico', '11850', '0', None, None, None, '30000012077', 'SI000001473', None, '458511.05000', '458511.05000', '.00000', '.00000', '458511.05000', '.00000', '.00000', '42607.95000', '.00000', '-458511.05000', '42607.95000', '15-Jan-15', '15-Jan-15', '21-Jan-13', '21-Jan-13', '21-Jan-13', '0', None, '21-Jan-13', '21-Jan-13', '21-Jan-13', '21-Jan-13', '21-Jan-13', None, '30-Apr-13', '30-Apr-13', None, '30-Apr-13', None, '2-Sep-13', '21-Sep-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC138', '0', 'CASA', 'ARBC138', 'ARB02CA0110', None, '02', None, None, '011', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00032030', 'ANA LILIA RODRIGUEZ FLORES', 'ANA LILIA', 'RODRIGUEZ', 'FLORES', 'ROFA800926RA6', None, '1', None, None, '55938407', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'MIGUEL HIDALGO DF', None, 'Mexico', None, '0', None, None, None, '30000012200', 'SI000001831', None, '487490.00000', '487490.00000', '.00000', '.00000', '487490.00000', '.00000', '.00000', '.00000', '.00000', '-487490.00000', '.00000', '1-Jan-00', '19-Jun-15', '28-Feb-13', '28-Feb-13', '28-Feb-13', '0', None, '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', None, '31-May-13', '31-May-13', None, '31-May-13', None, '25-Jun-13', '1-Aug-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC132', '0', 'CASA', 'ARBC132', 'ARB02CA0190', None, '02', None, None, '019', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00032212', 'ALMA DELIA HERRERA LEON', 'ALMA DELIA', 'HERRERA', 'LEON', 'HELA651011CR2', None, '1', None, None, '57304995', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BENITO JUAREZ', 'NEZAHUALCÓYOTL MEX', 'MEX', 'Mexico', '57000', '0', None, None, None, '30000012309', 'SI000001637', None, '482000.00000', '482000.00000', '.00000', '.00000', '482000.00000', '.00000', '.00000', '42607.95000', '.00000', '-482000.00000', '42607.95000', '1-Jan-00', '19-Jun-15', '7-Feb-13', '7-Feb-13', '7-Feb-13', '0', None, '7-Feb-13', '7-Feb-13', '7-Feb-13', '7-Feb-13', '7-Feb-13', None, '31-Mar-13', '31-Mar-13', None, '31-Mar-13', None, '16-Jul-13', '1-Aug-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC158', '0', 'CASA', 'ARBC158', 'ARB02CA0170', None, '02', None, None, '017', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00032538', 'ELISEO SANTIAGO HERNANDEZ', 'ELISEO', 'SANTIAGO', 'HERNANDEZ', 'SAHE6406144B0', None, '1', None, 'nayesan_48@hotmail.com', '53239625', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'CHALMA DE GUADALUPE', 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '7210', '0', None, None, None, '30000012465', 'SI000001571', None, '462000.00000', '462000.00000', '.00000', '-10000.00000', '452000.00000', '.00000', '.00000', '42641.10000', '.00000', '-452001.00000', '42640.10000', '15-Jan-15', '15-Jan-15', '31-Jan-13', '31-Jan-13', '31-Jan-13', '0', None, '31-Jan-13', '31-Jan-13', '31-Jan-13', '31-Jan-13', '31-Jan-13', None, '30-Apr-13', '30-Apr-13', None, '30-Apr-13', None, '15-Nov-13', '22-Nov-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC134', '0', 'CASA', 'ARBC134', 'ARB02CA0070', None, '02', None, None, '007', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00033548', 'JOSE ANTONIO DOMINGUEZ HERNANDEZ', 'JOSE ANTONIO', 'DOMINGUEZ', 'HERNANDEZ', 'DOHA6401184B5', None, '1', None, None, '26345235', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'MEX', 'ACACOYAGUA CHIS', 'CHIS', 'Mexico', None, '0', None, None, None, '30000012945', 'SI000001569', None, '442000.00000', '442000.00000', '.00000', '.00000', '442000.00000', '.00000', '.00000', '.00000', '.00000', '-442000.00000', '.00000', '1-Jan-00', '19-Jun-15', '31-Jan-13', '31-Jan-13', '31-Jan-13', '0', None, '31-Jan-13', '31-Jan-13', '31-Jan-13', '31-Jan-13', '31-Jan-13', None, '12-Mar-13', '12-Mar-13', None, '12-Mar-13', None, '26-Apr-13', '26-Apr-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC051', '0', 'CASA', 'ARBC051', 'ARB04CA0100', None, '04', None, None, '010', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00033997', 'HUGO RODOLFO MONTOYA LOPEZ', 'HUGO RODOLFO', 'MONTOYA', 'LOPEZ', 'MOLH780601EQ4', None, '1', None, None, '59125749', None, '5514962188', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'NARVARTE PONIENTE', 'BENITO JUÁREZ DF', 'DF', 'Mexico', '03020', '0', None, None, None, '30000013117', 'SI000002455', None, '476317.21000', '476317.21000', '.00000', '.00000', '476317.21000', '.00000', '.00000', '49810.00000', '.00000', '-476317.21000', '49810.00000', '1-Jan-00', '19-Jun-15', '30-Jun-13', '30-Jun-13', '30-Jun-13', '0', None, '30-Jun-13', '30-Jun-13', '30-Jun-13', '30-Jun-13', '30-Jun-13', None, '31-Jul-13', '31-Jul-13', None, '31-Jul-13', None, '19-Aug-13', '11-Oct-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC157', '0', 'CASA', 'ARBC157', 'ARB03CA0110', None, '03', None, None, '011', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '30-Mar-13', '30-Mar-13', '1-Oct-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00035028', 'ARACELI GONZALEZ HERNANDEZ', 'ARACELI', 'GONZALEZ', 'HERNANDEZ', 'GOHA661201QP3', 'GOHA661201MDFNRR02', '1', None, None, '53174394', None, '5522209334', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'UNIDAD BARRIENTOS', 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54110', '0', None, None, None, '30000013430', 'SI000001835', None, '474000.00000', '474000.00000', '.00000', '.00000', '474000.00000', '.00000', '.00000', '51000.00000', '.00000', '-481182.25000', '43817.75000', '1-Jan-00', '19-Jun-15', '28-Feb-13', '28-Feb-13', '28-Feb-13', '0', None, '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', None, '22-May-13', '22-May-13', None, '22-May-13', None, '5-Nov-13', '8-Nov-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC156', '0', 'CASA', 'ARBC156', 'ARB03CA0100', None, '03', None, None, '010', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '30-Mar-13', '30-Mar-13', '1-Oct-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00035078', 'JORGE RETANA SIMON', 'JORGE', 'RETANA', 'SIMON', 'RESJ791120T5A', 'RESJ791120HDFTMR02', '1', None, 'pamela.diaz@quierocasaya.com.mx', '44445149', '58120678', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PEDREGAL DE CARRASCO', 'COYOACÁN DF', 'DF', 'Mexico', '04700', '0', None, None, None, '30000013463', 'SI000001834', None, '484000.00000', '484000.00000', '.00000', '.00000', '484000.00000', '.00000', '.00000', '51000.00000', '.00000', '-484000.00000', '51000.00000', '15-Jan-15', '15-Jan-15', '28-Feb-13', '28-Feb-13', '28-Feb-13', '0', None, '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', None, '24-Apr-13', '24-Apr-13', None, '24-Apr-13', None, '4-Nov-13', '29-Sep-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC147', '0', 'CASA', 'ARBC147', 'ARB03CA0010', None, '03', None, None, '001', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '29-Mar-13', '29-Mar-13', '30-Sep-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00035282', 'PABLO SANTIBAÑEZ LOPEZ', 'PABLO', 'SANTIBAÑEZ', 'LOPEZ', 'SALP610428BD2', None, '1', None, None, '5536449018', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'AJUCHITLÁN PROGRESO GRO', None, 'Mexico', None, '0', None, None, None, '30000013554', 'SI000001737', None, '484000.00000', '484000.00000', '.00000', '.00000', '484000.00000', '.00000', '.00000', '51000.00000', '.00000', '-484000.00000', '51000.00000', '1-Jan-00', '19-Jun-15', '25-Feb-13', '25-Feb-13', '25-Feb-13', '0', None, '25-Feb-13', '25-Feb-13', '25-Feb-13', '25-Feb-13', '25-Feb-13', None, '30-Apr-13', '30-Apr-13', None, '30-Apr-13', None, '18-Dec-13', '23-Jan-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC155', '0', 'CASA', 'ARBC155', 'ARB03CA0090', None, '03', None, None, '009', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '24-May-13', '24-May-13', '25-Nov-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00036100', 'LIZBETH CRUZ MORALES', 'LIZBETH', 'CRUZ', 'MORALES', 'CUML8301242Q9', 'CUML830124MDFRRZ05', '1', None, 'lizbeth.morales@codere.com', '53620209', '52017800', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'AMPL. LOMAS DE SAN ANDRES', 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54040', '0', None, None, None, '30000013927', 'SI000001766', None, '464000.00000', '464000.00000', '.00000', '.00000', '464000.00000', '.00000', '.00000', '.00000', '.00000', '-463999.53000', '.47000', '15-Jan-15', '15-Jan-15', '27-Feb-13', '27-Feb-13', '27-Feb-13', '0', None, '27-Feb-13', '27-Feb-13', '27-Feb-13', '27-Feb-13', '27-Feb-13', None, '30-Jun-13', '30-Jun-13', None, '30-Jun-13', None, '18-Dec-13', '23-Dec-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC145', '0', 'CASA', 'ARBC145', 'ARB02CA0180', None, '02', None, None, '018', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00036411', 'PAULINA IXCHEL ARELLANO ORTEGA', 'PAULINA IXCHEL', 'ARELLANO', 'ORTEGA', 'AEOP860605127', None, '1', None, None, '62743933', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'ARENAL 1ERA SECC', 'VENUSTIANO CARRANZA DF', 'DF', 'Mexico', '15600', '0', None, None, None, '30000014040', 'SI000001833', None, '464000.00000', '464000.00000', '.00000', '.00000', '464000.00000', '.00000', '.00000', '39000.00000', '.00000', '-464000.00000', '39000.00000', '1-Jan-00', '19-Jun-15', '28-Feb-13', '28-Feb-13', '28-Feb-13', '0', None, '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', None, '31-May-13', '31-May-13', None, '31-May-13', None, '27-Jun-13', '15-Jul-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC171', '0', 'CASA', 'ARBC171', 'ARB02CA0060', None, '02', None, None, '006', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00036552', 'ALBERTO ISAAC RENDON PEDRAZA', 'ALBERTO ISAAC', 'RENDON', 'PEDRAZA', 'REPA601010F48', None, '1', None, None, '5557541029', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN JOSE TICOMAN', 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '06340', '0', None, None, None, '30000014131', 'SI000001980', None, '455600.00000', '455600.00000', '.00000', '.00000', '455600.00000', '.00000', '.00000', '41225.00000', '.00000', '-463620.00000', '33205.00000', '1-Jan-00', '19-Jun-15', '25-Mar-13', '25-Mar-13', '25-Mar-13', '0', None, '25-Mar-13', '25-Mar-13', '25-Mar-13', '25-Mar-13', '25-Mar-13', None, '27-Aug-13', '27-Aug-13', None, '27-Aug-13', None, '5-Sep-13', '10-Sep-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC183', '0', 'CASA', 'ARBC183', 'ARB02CA0030', None, '02', None, None, '003', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00036808', 'JOSE ALEJANDRO ALVARADO MARTINEZ', 'JOSE ALEJANDRO', 'ALVARADO', 'MARTINEZ', 'AAMA860419TY9', None, '1', None, None, '23021606', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BOSQUES DE MORELOS', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54760', '0', None, None, None, '30000014248', 'SI000001979', None, '495600.00000', '495600.00000', '.00000', '.00000', '495600.00000', '.00000', '.00000', '51000.00000', '.00000', '-495600.00000', '51000.00000', '1-Jan-00', '19-Jun-15', '25-Mar-13', '25-Mar-13', '25-Mar-13', '0', None, '25-Mar-13', '25-Mar-13', '25-Mar-13', '25-Mar-13', '25-Mar-13', None, '30-Jun-13', '30-Jun-13', None, '30-Jun-13', None, '8-Oct-13', '11-Oct-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC064', '0', 'CASA', 'ARBC064', 'ARB04CA0120', None, '04', None, None, '012', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00037977', 'OLGA MERCEDES ROJAS JIMENEZ', 'OLGA MERCEDES', 'ROJAS', 'JIMENEZ', 'ROJO6409246M2', 'ROJO640924MDFJML08', '1', None, None, '53 84 59 04', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'MAGDALENA MIXHUCA', 'VENUSTIANO CARRANZA DF', 'DF', 'Mexico', '15850', '0', None, None, None, '30000014578', 'SI000002234', None, '493831.88000', '493831.88000', '.00000', '.00000', '493831.88000', '.00000', '.00000', '51000.00000', '.00000', '-496151.88000', '48680.00000', '1-Jan-00', '19-Jun-15', '30-Apr-13', '30-Apr-13', '30-Apr-13', '0', None, '30-Apr-13', '30-Apr-13', '30-Apr-13', '30-Apr-13', '30-Apr-13', None, '31-Jul-13', '31-Jul-13', None, '31-Jul-13', None, '15-Jan-14', '22-Feb-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC221', '0', 'CASA', 'ARBC221', 'ARB03CA0130', None, '03', None, None, '013', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '30-Mar-13', '30-Mar-13', '1-Oct-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00039088', 'GUADALUPE MORENO NAVA', 'GUADALUPE', 'MORENO', 'NAVA', 'MONG630521834', None, '1', None, 'gmoreno@gmi.com.mx', '55555555', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PLAZAS DE ARAGON', 'NEZAHUALCÓYOTL MEX', 'MEX', 'Mexico', '57139', '0', None, None, None, '30000015146', 'SI000002035', None, '475600.00000', '475600.00000', '.00000', '.00000', '475600.00000', '.00000', '.00000', '41225.00000', '.00000', '-475600.00000', '41225.00000', '15-Jan-15', '15-Jan-15', '28-Mar-13', '28-Mar-13', '28-Mar-13', '0', None, '28-Mar-13', '28-Mar-13', '28-Mar-13', '28-Mar-13', '28-Mar-13', None, '30-Apr-13', '30-Apr-13', None, '30-Apr-13', None, '11-Jun-13', '17-Jun-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC181', '0', 'CASA', 'ARBC181', 'ARB02CA0010', None, '02', None, None, '001', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00039598', 'MARLENE MUÑOZ FRANCO', 'MARLENE', 'MUÑOZ', 'FRANCO', 'MUFM7704169U5', 'MUFM770416MDFXRR07', '1', None, None, '53556492', None, '5529518122', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'U. HAB. HOGARES FERROCARRILERO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02540', '0', None, None, None, '30000015401', 'SI000002162', None, '487490.00000', '487490.00000', '.00000', '.00000', '487490.00000', '.00000', '.00000', '51000.00000', '.00000', '-488146.27000', '50343.73000', '1-Jan-00', '19-Jun-15', '22-Apr-13', '22-Apr-13', '22-Apr-13', '0', None, '22-Apr-13', '22-Apr-13', '22-Apr-13', '22-Apr-13', '22-Apr-13', None, '31-May-13', '31-May-13', None, '31-May-13', None, '1-Jul-13', '16-Jul-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC205', '0', 'CASA', 'ARBC205', 'ARB03CA0120', None, '03', None, None, '012', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '30-Mar-13', '30-Mar-13', '1-Oct-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00039744', 'LILIAN MARTINEZ ACOSTA', 'LILIAN', 'MARTINEZ', 'ACOSTA', 'MAAL750508L97', None, '1', None, None, '5539908128', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'JORGE NEGRETE', 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07280', '0', None, None, None, '30000015450', 'SI000002170', None, '507490.00000', '507490.00000', '.00000', '.00000', '507490.00000', '.00000', '.00000', '.00000', '.00000', '-507490.00000', '.00000', '1-Jan-00', '19-Jun-15', '23-Apr-13', '23-Apr-13', '23-Apr-13', '0', None, '23-Apr-13', '23-Apr-13', '23-Apr-13', '23-Apr-13', '23-Apr-13', None, '30-Jun-13', '30-Jun-13', None, '30-Jun-13', None, '3-Dec-13', '22-Feb-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC149', '0', 'CASA', 'ARBC149', 'ARB03CA0030', None, '03', None, None, '003', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '30-Mar-13', '30-Mar-13', '1-Oct-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00039872', 'MARIA DEL CARMEN CERVANTES ORTIZ', 'MARIA DEL CARMEN', 'CERVANTES', 'ORTIZ', 'CEOC621116KC9', 'CEOC621116MDFRRR06', '1', None, None, '5541362871', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PRESIDENTE FRANCISCO I. MADERO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02430', '0', None, None, None, '30000015484', 'SI000002196', None, '497490.00000', '497490.00000', '.00000', '.00000', '497490.00000', '.00000', '.00000', '48000.00000', '.00000', '-500490.00000', '45000.00000', '1-Jan-00', '19-Jun-15', '24-Apr-13', '24-Apr-13', '24-Apr-13', '0', None, '24-Apr-13', '24-Apr-13', '24-Apr-13', '24-Apr-13', '24-Apr-13', None, '29-Aug-13', '29-Aug-13', None, '29-Aug-13', None, '20-Feb-14', '22-Feb-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC223', '0', 'CASA', 'ARBC223', 'ARB03CA0140', None, '03', None, None, '014', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '30-Mar-13', '30-Mar-13', '1-Oct-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00039936', 'REY DAVID VALENCIA SANCHEZ', 'REY DAVID', 'VALENCIA', 'SANCHEZ', 'VASR851017QPA', None, '1', None, 'rey.david.valencia@ericsson.com', '5554198455', '11030000', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'FRACC.LA TRINIDAD', 'ZUMPANGO MEX', 'MEX', 'Mexico', '56614', '0', None, None, None, '30000015500', 'SI000002171', None, '487490.00000', '487490.00000', '.00000', '.00000', '487490.00000', '.00000', '.00000', '51000.00000', '.00000', '-487490.00000', '51000.00000', '15-Jan-15', '15-Jan-15', '23-Apr-13', '23-Apr-13', '23-Apr-13', '0', None, '23-Apr-13', '23-Apr-13', '23-Apr-13', '23-Apr-13', '23-Apr-13', None, '31-May-13', '31-May-13', None, '31-May-13', None, '8-Jul-13', '17-Jul-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC225', '0', 'CASA', 'ARBC225', 'ARB03CA0160', None, '03', None, None, '016', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '30-Mar-13', '30-Mar-13', '1-Oct-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00040333', 'SALOMON MORALES TORRES', 'SALOMON', 'MORALES', 'TORRES', 'MOTS810828T67', None, '1', None, None, '59018697', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'AMPLIACION DE LOS REMEDIOS.', 'NAUCALPAN JUÁREZ MEX', 'MEX', 'Mexico', '53400', '0', None, None, None, '30000015674', 'SI000002273', None, '487490.00000', '487490.00000', '.00000', '.00000', '487490.00000', '.00000', '.00000', '24250.00000', '.00000', '-490090.00000', '21650.00000', '1-Jan-00', '19-Jun-15', '10-May-13', '10-May-13', '10-May-13', '0', None, '10-May-13', '10-May-13', '10-May-13', '10-May-13', '10-May-13', None, '30-Jun-13', '30-Jun-13', None, '30-Jun-13', None, '5-Aug-13', '13-Aug-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC024', '0', 'CASA', 'ARBC024', 'ARB04CA0370', None, '04', None, None, '037', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00041551', 'ISAAC ROSAS ZAMORA', 'ISAAC', 'ROSAS', 'ZAMORA', 'ROZI660903T41', 'ROZI660903HDFSMS00', '1', None, None, '28555148', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BARRIO SAN BARTOLO', 'TEOLOYUCÁN MEX', 'MEX', 'Mexico', '54770', '0', None, None, None, '30000016094', 'SI000002328', None, '485677.67000', '485677.67000', '.00000', '-15000.00000', '470677.67000', '.00000', '.00000', '41225.00000', '.00000', '-491677.67000', '20225.00000', '1-Jan-00', '19-Jun-15', '31-May-13', '31-May-13', '31-May-13', '0', None, '31-May-13', '31-May-13', '31-May-13', '31-May-13', '31-May-13', None, '31-Jul-13', '31-Jul-13', None, '31-Jul-13', None, '21-Aug-13', '4-Oct-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC179', '0', 'CASA', 'ARBC179', 'ARB01CA0200', None, '01', None, None, '020', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00041957', 'MARIA AZUCENA RUIZ SORIANO', 'MARIA AZUCENA', 'RUIZ', 'SORIANO', 'RUSA8010062F4', None, '1', None, 'aymara@hotmail.com', '52796819', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'IZTACALCO DF', None, 'Mexico', None, '0', None, None, None, '30000016201', 'SI000002270', None, '499677.25000', '499677.25000', '.00000', '.00000', '499677.25000', '.00000', '.00000', '41225.00000', '.00000', '-501881.25000', '39021.00000', '1-Jan-00', '12-Mar-15', '9-May-13', '9-May-13', '9-May-13', '0', None, '9-May-13', '9-May-13', '9-May-13', '9-May-13', '9-May-13', None, '31-May-13', '31-May-13', None, '31-May-13', None, '8-Jul-13', '17-Jul-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC226', '0', 'CASA', 'ARBC226', 'ARB03CA0170', None, '03', None, None, '017', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '30-Mar-13', '30-Mar-13', '1-Oct-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00042675', 'JOSUE ANTHONY CAMACHO MARBAN', 'JOSUE ANTHONY', 'CAMACHO', 'MARBAN', 'CAMJ860728TK3', 'CAMJ860728HDFMRS02', '1', None, None, '36874293', '53460000', '5521750938', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'MAVILLAS', 'NEZAHUALCÓYOTL MEX', 'MEX', 'Mexico', '57410', '0', None, None, None, '30000016367', 'SI000002327', None, '499677.25000', '499677.25000', '.00000', '.00000', '499677.25000', '.00000', '.00000', '.00000', '.00000', '-501677.25000', '-2000.00000', '1-Jan-00', '19-Jun-15', '31-May-13', '31-May-13', '31-May-13', '0', None, '31-May-13', '31-May-13', '31-May-13', '31-May-13', '31-May-13', None, '21-Nov-12', '21-Nov-12', None, '21-Nov-13', None, '19-Dec-13', '20-Dec-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC154', '0', 'CASA', 'ARBC154', 'ARB03CA0080', None, '03', None, None, '008', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '30-Mar-13', '30-Mar-13', '1-Oct-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00042912', 'LUIS ANGEL SANCHEZ DE LA CRUZ', 'LUIS ANGEL', 'SANCHEZ', 'DE LA CRUZ', 'SACL840617892', 'SACL840617HDFNRS07', '1', None, None, '58176647', None, '5544755351', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'JARDINES DE LA HACIENDA SUR', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54720', '0', None, None, None, '30000016474', 'SI000002454', None, '499677.25000', '499677.25000', '.00000', '.00000', '499677.25000', '.00000', '.00000', '54000.00000', '.00000', '-499677.37000', '53999.88000', '1-Jan-00', '19-Jun-15', '30-Jun-13', '30-Jun-13', '30-Jun-13', '0', None, '30-Jun-13', '30-Jun-13', '30-Jun-13', '30-Jun-13', '30-Jun-13', None, '31-Aug-13', '31-Aug-13', None, '31-Aug-13', None, '16-Dec-13', '20-Dec-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC060', '0', 'CASA', 'ARBC060', 'ARB04CA0010', None, '04', None, None, '001', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00044993', 'MARIA NUÑEZ MONTAÑO', 'MARIA', 'NUÑEZ', 'MONTAÑO', 'NUMM690119SU8', None, '1', None, None, '9121768', None, '5514875718', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BARRIO DEL REFUGIO', 'TEQUIXQUIAC MEX', 'MEX', 'Mexico', '55650', '0', None, None, None, '30000017068', 'SI000002488', None, '485677.67000', '485677.67000', '.00000', '.00000', '485677.67000', '.00000', '.00000', '49725.00000', '.00000', '-485677.67000', '49725.00000', '1-Jan-00', '19-Jun-15', '15-Jul-13', '15-Jul-13', '15-Jul-13', '0', None, '15-Jul-13', '15-Jul-13', '15-Jul-13', '15-Jul-13', '15-Jul-13', None, '31-Jul-13', '31-Jul-13', None, '31-Jul-13', None, '3-Sep-13', '11-Oct-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC035', '0', 'CASA', 'ARBC035', 'ARB08CA0120', None, '08', None, None, '012', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '31-Jan-14', '31-Jan-14', '4-Aug-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00046184', 'MARIO ALBERTO ESQUIVEL DE LA CRUZ', 'MARIO ALBERTO', 'ESQUIVEL', 'DE LA CRUZ', 'EUCM761217MA0', 'EUCM761217HDFSRR08', '0', 'H', 'MARIO.AE@HOTMAIL.COM', '58932334', '5515228396', None, '92937708904', '17-Dec-76', 'CASADO', 'BIENES MANCOMUNADOS', 'MEXICANA', 'DISTRITO FEDERAL', None, '2', 'Volante', 'AV DEL CANAL', 'MZA 330', 'LT 16', 'LA PRESITA', 'CUAUTITLAN IZCALLI', 'MEXICO', 'MEXICO', '54763', '6', 'EMPLEADO', '0885047361165', 'IFE', '30020104045', '0002437', None, '564819.00000', '564819.00000', '.00000', '.00000', '564819.00000', '.00000', '.00000', '52810.58000', '.00000', '-564819.00000', '52810.58000', '1-Jan-00', '20-Jun-15', '24-Mar-15', '26-Mar-15', '26-Mar-15', '12', None, '26-Mar-15', '26-Mar-15', '26-Mar-15', '30-Mar-15', '30-Mar-15', '5-Mar-15', '31-Mar-15', '31-Mar-15', None, '13-Apr-15', None, '6-May-15', '13-May-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC224', '0', 'CASA', 'ARBC224', 'ARB03CA0150', None, '03', None, None, '015', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '30-Mar-13', '30-Mar-13', '1-Oct-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00046403', 'LILIANA DURAN BAUTISTA', 'LILIANA', 'DURAN', 'BAUTISTA', 'DUBL730628679', None, '1', None, None, '53415290', None, '5540987493', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'ALVARO OBREGON', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02090', '0', None, None, None, '30000017399', 'SI000002505', None, '499677.25000', '499677.25000', '.00000', '.00000', '499677.25000', '.00000', '.00000', '51000.00000', '.00000', '-505677.25000', '45000.00000', '1-Jan-00', '19-Jun-15', '24-Jul-13', '24-Jul-13', '24-Jul-13', '0', None, '24-Jul-13', '24-Jul-13', '24-Jul-13', '24-Jul-13', '24-Jul-13', None, '31-Aug-13', '31-Aug-13', None, '31-Aug-13', None, '27-Sep-13', '4-Oct-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC001', '0', 'CASA', 'ARBC001', 'ARB04CA0190', None, '04', None, None, '019', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00046804', 'PEDRO ABRAHAM MARTINEZ ROSALES', 'PEDRO ABRAHAM', 'MARTINEZ', 'ROSALES', 'MARP6803167N4', None, '1', None, None, '48002568', None, '5563474192', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'CENTRO', 'CUAUTITLÁN MEX', 'MEX', 'Mexico', '54800', '0', None, None, None, '30000017506', 'SI000002529', None, '485677.67000', '485677.67000', '.00000', '.00000', '485677.67000', '.00000', '.00000', '42000.00000', '.00000', '-485681.67000', '41996.00000', '1-Jan-00', '19-Jun-15', '31-Jul-13', '31-Jul-13', '31-Jul-13', '0', None, '31-Jul-13', '31-Jul-13', '31-Jul-13', '31-Jul-13', '31-Jul-13', None, '5-May-14', '5-May-14', None, '12-May-14', None, '19-May-14', '28-May-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC023', '0', 'CASA', 'ARBC023', 'ARB04CA0280', None, '04', None, None, '028', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00047440', 'MIRNA YAZMIN HERNANDEZ BRAVO', 'MIRNA YAZMIN', 'HERNANDEZ', 'BRAVO', 'HEBM760906H68', 'HEBM760906MMCRRR03', '1', None, 'jonathan_omar_h@hotmail.com', '58727768', '26328382', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'EL PARAISO', 'ATIZAPÁN ZARAGOZA MEX', 'MEX', 'Mexico', '54800', '0', None, None, None, '30000017753', 'SI000002639', None, '495677.67000', '495677.67000', '.00000', '.00000', '495677.67000', '.00000', '.00000', '.00000', '.00000', '-497997.67000', '-2320.00000', '15-Jan-15', '15-Jan-15', '23-Aug-13', '23-Aug-13', '23-Aug-13', '0', None, '23-Aug-13', '23-Aug-13', '23-Aug-13', '23-Aug-13', '23-Aug-13', None, '24-Oct-13', '24-Oct-13', None, '24-Oct-13', None, '31-Jan-14', '7-Feb-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC151', '0', 'CASA', 'ARBC151', 'ARB03CA0050', None, '03', None, None, '005', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '30-Mar-13', '30-Mar-13', '1-Oct-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00047664', 'DAVID GONZALEZ GONZALEZ', 'DAVID', 'GONZALEZ', 'GONZALEZ', 'GOGD861029KS6', 'GOGD861029HDFNNV03', '1', None, None, '19145894', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LA GUADALUPANA', 'CUAUTITLÁN MEX', 'MEX', 'Mexico', '54840', '0', None, None, None, '30000017803', 'SI000002638', None, '509677.25000', '509677.25000', '.00000', '.00000', '509677.25000', '.00000', '.00000', '.00000', '.00000', '-515241.22000', '-5563.97000', '1-Jan-00', '19-Jun-15', '23-Aug-13', '23-Aug-13', '23-Aug-13', '0', None, '23-Aug-13', '23-Aug-13', '23-Aug-13', '23-Aug-13', '23-Aug-13', None, '16-Oct-13', '16-Oct-13', None, '16-Oct-13', None, '20-Dec-13', '20-Dec-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC148', '0', 'CASA', 'ARBC148', 'ARB03CA0020', None, '03', None, None, '002', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '30-Mar-13', '30-Mar-13', '1-Oct-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00048144', 'VERONICA ESTRADA MENDOZA', 'VERONICA', 'ESTRADA', 'MENDOZA', 'EAMV850911448', 'EAMV850911MDFSNR03', '1', None, 'veritos35@hotmail.com', '21256806', '5553176108', '5545781496', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'UH MAGISTERIAL', 'ALVARO OBREGÓN DF', 'DF', 'Mexico', '54010', '0', None, None, None, '30000017977', 'SI000002641', None, '499677.25000', '499677.25000', '.00000', '.00000', '499677.25000', '.00000', '.00000', '.00000', '.00000', '-505677.25000', '-6000.00000', '15-Jan-15', '15-Jan-15', '26-Aug-13', '26-Aug-13', '26-Aug-13', '0', None, '26-Aug-13', '26-Aug-13', '26-Aug-13', '26-Aug-13', '26-Aug-13', None, '30-Sep-13', '30-Sep-13', None, '30-Sep-13', None, '16-Oct-13', '23-Oct-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC009', '0', 'CASA', 'ARBC009', 'ARB04CA0200', None, '04', None, None, '020', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00049104', 'ROBERTO HERMOSILLO VEGA', 'ROBERTO', 'HERMOSILLO', 'VEGA', 'HEVR681111H5A', 'HEVR681111HMCRGB05', '1', None, 'mari.ermosillo@gmail.com', '58833558', None, '52914331', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'UNIDAD MORELOS 3A SECCION', 'TULTITLÁN MEX', 'MEX', 'Mexico', '54930', '0', None, None, None, '30000018264', 'SI000002679', None, '485677.67000', '485677.67000', '.00000', '.00000', '485677.67000', '.00000', '.00000', '.00000', '.00000', '-485677.67000', '.00000', '15-Jan-15', '15-Jan-15', '2-Sep-13', '2-Sep-13', '2-Sep-13', '0', None, '2-Sep-13', '2-Sep-13', '2-Sep-13', '2-Sep-13', '2-Sep-13', None, '10-Oct-13', '10-Oct-13', None, '10-Oct-13', None, '28-Oct-13', '31-Oct-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC054', '0', 'CASA', 'ARBC054', 'ARB04CA0070', None, '04', None, None, '007', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00049299', 'ANA ERIKA FLORES ORTIZ', 'ANA ERIKA', 'FLORES', 'ORTIZ', 'FOOA8202077M4', None, '1', None, None, '58706574', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'EL PARTIDOR', 'CUAUTITLÁN MEX', 'MEX', 'Mexico', '54800', '0', None, None, None, '30000018389', 'SI000002781', None, '465677.67000', '465677.67000', '.00000', '.00000', '465677.67000', '.00000', '.00000', '.00000', '.00000', '-468129.16000', '-2451.49000', '1-Jan-00', '19-Jun-15', '24-Sep-13', '24-Sep-13', '24-Sep-13', '0', None, '24-Sep-13', '24-Sep-13', '24-Sep-13', '24-Sep-13', '24-Sep-13', None, '11-Oct-13', '11-Oct-13', None, '11-Oct-13', None, '28-Oct-13', '31-Oct-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC025', '0', 'CASA', 'ARBC025', 'ARB04CA0290', None, '04', None, None, '029', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00049459', 'JOSE LUIS OAXACA ROSAS', 'JOSE LUIS', 'OAXACA', 'ROSAS', 'OARL7309184D9', None, '1', None, 'joaxaca@live.com.mx', '911001096', None, '5532878205', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BARRIO DE SANTIAGO 2A SECC', 'ZUMPANGO MEX', 'MEX', 'Mexico', '55600', '0', None, None, None, '30000018504', 'SI000002769', None, '475677.67000', '475677.67000', '.00000', '.00000', '475677.67000', '.00000', '.00000', '.00000', '.00000', '-475677.67000', '.00000', '15-Jan-15', '15-Jan-15', '20-Sep-13', '20-Sep-13', '20-Sep-13', '0', None, '20-Sep-13', '20-Sep-13', '20-Sep-13', '20-Sep-13', '20-Sep-13', None, '14-Oct-13', '14-Oct-13', None, '14-Oct-13', None, '12-Nov-13', '14-Nov-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC059', '0', 'CASA', 'ARBC059', 'ARB04CA0020', None, '04', None, None, '002', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00049582', 'SANDRA GARCIA BALTAZAR', 'SANDRA', 'GARCIA', 'BALTAZAR', 'GABS800810SD2', 'GABS800810MPLRLN04', '1', None, None, '65483770', '54456546', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN JUAN  IXTACALA', 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54160', '0', None, None, None, '30000018546', 'SI000002789', None, '475677.67000', '475677.67000', '.00000', '.00000', '475677.67000', '.00000', '.00000', '.00000', '.00000', '-475677.67000', '.00000', '1-Jan-00', '19-Jun-15', '26-Sep-13', '26-Sep-13', '26-Sep-13', '0', None, '26-Sep-13', '26-Sep-13', '26-Sep-13', '26-Sep-13', '26-Sep-13', None, '31-Oct-13', '31-Oct-13', None, '31-Oct-13', None, '8-Nov-13', '14-Nov-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC011', '0', 'CASA', 'ARBC011', 'ARB04CA0180', None, '04', None, None, '018', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00050134', 'ULISES PECH RIVERA', 'ULISES', 'PECH', 'RIVERA', 'PERU661128B14', None, '1', None, None, '17414447', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PUEBLO SANTIAGO TEPATLAXCO', 'NAUCALPAN JUÁREZ MEX', 'MEX', 'Mexico', '53216', '0', None, None, None, '30000018637', 'SI000002785', None, '485677.67000', '485677.67000', '.00000', '.00000', '485677.67000', '.00000', '.00000', '.00000', '.00000', '-485677.67000', '.00000', '1-Jan-00', '19-Jun-15', '25-Sep-13', '25-Sep-13', '25-Sep-13', '0', None, '25-Sep-13', '25-Sep-13', '25-Sep-13', '25-Sep-13', '25-Sep-13', None, '11-Nov-13', '11-Nov-13', None, '11-Nov-13', None, '9-Dec-13', '20-Dec-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC193', '0', 'CASA', 'ARBC193', 'ARB07CA0010', None, '07', None, None, '001', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '17-Jan-14', '17-Jan-14', '21-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00050404', 'CESAR HERNANDEZ AMEZCUA', 'CESAR', 'HERNANDEZ', 'AMEZCUA', 'MACE600818EN8', 'HEAC760610HDFRMS02', '1', None, 'chernandeza1@hotmail.com', '5585795488', None, '5585795488', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PBLO SAN JOSE HUILANGO', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54710', '0', None, None, None, '30010163803', 'SI000005944', None, '549818.33000', '549818.33000', '.00000', '.00000', '549818.33000', '.00000', '.00000', '54432.01000', '.00000', '-503575.98000', '100674.36000', '15-Jan-15', '15-Jan-15', '24-Sep-14', '24-Sep-14', '24-Sep-14', '0', None, '24-Sep-14', '24-Sep-14', '24-Sep-14', '24-Sep-14', '24-Sep-14', None, '26-Oct-14', '26-Oct-14', None, '9-Dec-14', None, '10-Mar-15', '18-Mar-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC030', '0', 'CASA', 'ARBC030', 'ARB04CA0310', None, '04', None, None, '031', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00050762', 'ANA MARIA RODRIGUEZ ESPINOSA', 'ANA MARIA', 'RODRIGUEZ', 'ESPINOSA', 'ROEA630326636', 'ROEA630326MDFDSN00', '1', None, 'a.benetton@hotmail.es', '57909019', '56230834', '26928592', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'EMILIANO ZAPATA', 'ECATEPEC MORELOS MEX', 'MEX', 'Mexico', '55200', '0', None, None, None, '30000018884', 'SI000002822', None, '485964.11000', '485964.11000', '.00000', '.00000', '485964.11000', '.00000', '.00000', '.00000', '.00000', '-485964.11000', '.00000', '15-Jan-15', '15-Jan-15', '2-Oct-13', '2-Oct-13', '2-Oct-13', '0', None, '2-Oct-13', '2-Oct-13', '2-Oct-13', '2-Oct-13', '2-Oct-13', None, '4-Nov-13', '4-Nov-13', None, '4-Nov-13', None, '29-Aug-14', '15-Oct-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC010', '0', 'CASA', 'ARBC010', 'ARB04CA0300', None, '04', None, None, '030', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00050774', 'JAIR LOPEZ GUTIERREZ', 'JAIR', 'LOPEZ', 'GUTIERREZ', 'LOGJ690912FI8', None, '1', None, 'jair.lopezg@hotmail.com', '58314674', None, '5535241701', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'VILLAS DE CUAUTITLAN', 'CUAUTITLÁN MEX', 'MEX', 'Mexico', '54800', '0', None, None, None, '30000018900', 'SI000002795', None, '485677.67000', '485677.67000', '.00000', '.00000', '485677.67000', '.00000', '.00000', '.00000', '.00000', '-485677.67000', '.00000', '15-Jan-15', '15-Jan-15', '1-Oct-13', '1-Oct-13', '1-Oct-13', '0', None, '1-Oct-13', '1-Oct-13', '1-Oct-13', '1-Oct-13', '1-Oct-13', None, '4-Nov-13', '4-Nov-13', None, '4-Nov-13', None, '12-Nov-13', '14-Nov-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC175', '0', 'CASA', 'ARBC175', 'ARB01CA0160', None, '01', None, None, '016', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00050940', 'GABRIELA GOMEZ ZAMORA', 'GABRIELA', 'GOMEZ', 'ZAMORA', 'GOZG760818ND9', None, '1', None, None, '56461900', '52643372', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'UNIDAD MODELO', 'IZTAPALAPA DF', 'DF', 'Mexico', '09089', '0', None, None, None, '30000019007', 'SI000002818', None, '461321.55000', '461321.55000', '.00000', '.00000', '461321.55000', '.00000', '.00000', '.00000', '.00000', '-462321.55000', '-1000.00000', '1-Jan-00', '19-Jun-15', '2-Oct-13', '2-Oct-13', '2-Oct-13', '0', None, '2-Oct-13', '2-Oct-13', '2-Oct-13', '2-Oct-13', '2-Oct-13', None, '31-Oct-13', '31-Oct-13', None, '31-Oct-13', None, '7-Nov-13', '14-Nov-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC012', '0', 'CASA', 'ARBC012', 'ARB04CA0170', None, '04', None, None, '017', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00051237', 'ANA LILIA SANDOVAL PINEDA', 'ANA LILIA', 'SANDOVAL', 'PINEDA', 'SAPA790313712', None, '1', None, None, '5524904967', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'REFORMA', 'NEZAHUALCÓYOTL MEX', 'MEX', 'Mexico', '57840', '0', None, None, None, '30000019080', 'SI000003136', None, '469492.52000', '469492.52000', '.00000', '.00000', '469492.52000', '.00000', '.00000', '51000.00000', '.00000', '-469492.52000', '51000.00000', '1-Jan-00', '19-Jun-15', '2-Dec-13', '2-Dec-13', '2-Dec-13', '0', None, '2-Dec-13', '2-Dec-13', '2-Dec-13', '2-Dec-13', '2-Dec-13', None, '23-Jan-14', '23-Jan-14', None, '29-Jan-14', None, '5-Mar-14', '14-Mar-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC131', '0', 'CASA', 'ARBC131', 'ARB05CA0350', None, '05', None, None, '035', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '29-Nov-13', '29-Nov-13', '2-Jun-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00051269', 'TERESA HUERTA FERNANDEZ', 'TERESA', 'HUERTA', 'FERNANDEZ', 'BASR760809RF6', 'HUFT730828MHGRRR11', '1', None, 'tere_fesc@hotmail.com', '56231917', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, None, None, 'Mexico', None, '0', None, None, None, '30010173588', 'SI000010242', None, '525000.00000', '525000.00000', '.00000', '.00000', '525000.00000', '.00000', '.00000', '54862.50000', '.00000', '-465882.79000', '113979.71000', '15-Jan-15', '15-Jan-15', '2-Dec-14', '2-Dec-14', '2-Dec-14', '0', None, '2-Dec-14', '2-Dec-14', '2-Dec-14', '2-Dec-14', '2-Dec-14', None, '5-Jan-15', '5-Jan-15', None, '19-Jan-15', None, '9-Mar-15', '11-Mar-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC055', '0', 'CASA', 'ARBC055', 'ARB04CA0060', None, '04', None, None, '006', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00051664', 'JUDITH GALINDO SOSA', 'JUDITH', 'GALINDO', 'SOSA', 'GASJ780718NR9', 'GASJ780718MDFLSD05', '1', None, 'boraborabig@gmail.com', '5551579363', None, '0445551579363', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'COVE', 'ALVARO OBREGÓN DF', 'DF', 'Mexico', '01120', '0', None, None, None, '30000019205', 'SI000002950', None, '485677.67000', '485677.67000', '.00000', '.00000', '485677.67000', '.00000', '.00000', '21989.00000', '.00000', '-516271.46000', '-8604.79000', '15-Jan-15', '15-Jan-15', '4-Nov-13', '4-Nov-13', '4-Nov-13', '0', None, '4-Nov-13', '4-Nov-13', '4-Nov-13', '4-Nov-13', '4-Nov-13', None, '2-Dec-13', '2-Dec-13', None, '9-Dec-13', None, '23-Dec-13', '27-Dec-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC049', '0', 'CASA', 'ARBC049', 'ARB04CA0030', None, '04', None, None, '003', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00051667', 'CLAUDIA DIAZ RUIZ', 'CLAUDIA', 'DIAZ', 'RUIZ', 'DIRC7108283H6', 'DIRC710828MTLZZL02', '1', None, None, '33306738', None, '0445522853821', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'XOCHIMILCO DF', None, 'Mexico', None, '0', None, None, None, '30000019213', 'SI000001999', None, '464564.31000', '464564.31000', '.00000', '.00000', '464564.31000', '.00000', '.00000', '.00000', '.00000', '-468064.31000', '-3500.00000', '1-Jan-00', '19-Jun-15', '27-Mar-13', '27-Mar-13', '27-Mar-13', '0', None, '27-Mar-13', '27-Mar-13', '27-Mar-13', '27-Mar-13', '27-Mar-13', None, '30-Oct-13', '30-Oct-13', None, '30-Oct-13', None, '4-Dec-13', '20-Dec-13', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC026', '0', 'CASA', 'ARBC026', 'ARB04CA0350', None, '04', None, None, '035', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00052620', 'JOSE DE JESUS LOPEZ HERNANDEZ', 'JOSE DE JESUS', 'LOPEZ', 'HERNANDEZ', 'LOHJ600612JU5', 'LOHJ600612HDFPRS06', '1', None, None, '62789102', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'MIXCOAC', 'BENITO JUÁREZ DF', 'DF', 'Mexico', '03910', '0', None, None, None, '30000019494', 'SI000003227', None, '485964.12000', '485964.12000', '.00000', '.00000', '485964.12000', '.00000', '.00000', '54000.00000', '.00000', '-485964.12000', '54000.00000', '1-Jan-00', '19-Jun-15', '4-Dec-13', '4-Dec-13', '4-Dec-13', '0', None, '4-Dec-13', '4-Dec-13', '4-Dec-13', '4-Dec-13', '4-Dec-13', None, '4-Dec-13', '4-Dec-13', None, '11-Feb-14', None, '9-Jul-14', '15-Jul-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC057', '0', 'CASA', 'ARBC057', 'ARB04CA0040', None, '04', None, None, '004', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00052857', 'OLIVIA MONTOR VARGAS', 'OLIVIA', 'MONTOR', 'VARGAS', 'MOVO790413LX1', 'MOVO790413MGRNRL00', '1', None, None, '9168958', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PORTAL DEL SOL', 'HUEHUETOCA MEX', 'MEX', 'Mexico', '54685', '0', None, None, None, '30000019544', 'SI000003135', None, '495677.67000', '495677.67000', '.00000', '.00000', '495677.67000', '.00000', '.00000', '54000.00000', '.00000', '-497997.67000', '51680.00000', '1-Jan-00', '19-Jun-15', '2-Dec-13', '2-Dec-13', '2-Dec-13', '0', None, '2-Dec-13', '2-Dec-13', '2-Dec-13', '2-Dec-13', '2-Dec-13', None, '16-Jan-14', '16-Jan-14', None, '20-Jan-14', None, '3-Apr-14', '4-Apr-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC006', '0', 'CASA', 'ARBC006', 'ARB04CA0230', None, '04', None, None, '023', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00052898', 'JOCABED ALVAREZ MENDOZA', 'JOCABED', 'ALVAREZ', 'MENDOZA', 'AAMJ740321DE4', 'AAMJ740321MMNLNC00', '1', None, 'jocabed_1974@hotmail.com', '65486101', None, '5540026260', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'EL OLIVO II', 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54110', '0', None, None, None, '30000019569', 'SI000003293', None, '495677.67000', '495677.67000', '.00000', '.00000', '495677.67000', '.00000', '.00000', '54000.00000', '.00000', '-495677.67000', '54000.00000', '15-Jan-15', '15-Jan-15', '16-Dec-13', '16-Dec-13', '16-Dec-13', '0', None, '16-Dec-13', '16-Dec-13', '16-Dec-13', '16-Dec-13', '16-Dec-13', None, '25-Feb-14', '25-Feb-14', None, '6-Mar-14', None, '10-Jun-14', '12-Jun-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC014', '0', 'CASA', 'ARBC014', 'ARB04CA0150', None, '04', None, None, '015', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00053260', 'MARIO RAUL VENEGAS DE LEON', 'MARIO RAUL', 'VENEGAS', 'DE LEON', 'VELM810605J47', 'VELM810605HDFNNR06', '1', None, None, '29795968', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'VENUSTIANO CARRANZA DF', None, 'Mexico', None, '0', None, None, None, '30000019684', 'SI000003044', None, '465677.67000', '465677.67000', '.00000', '.00000', '465677.67000', '.00000', '.00000', '.00000', '.00000', '-465677.67000', '.00000', '1-Jan-00', '19-Jun-15', '14-Nov-13', '14-Nov-13', '14-Nov-13', '0', None, '14-Nov-13', '14-Nov-13', '14-Nov-13', '14-Nov-13', '14-Nov-13', None, '6-Dec-13', '6-Dec-13', None, '9-Dec-13', None, '31-Mar-14', '1-Apr-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC016', '0', 'CASA', 'ARBC016', 'ARB04CA0210', None, '04', None, None, '021', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00053358', 'PATRICIA DE LA LUZ GARZA', 'PATRICIA', 'DE LA LUZ', 'GARZA', 'LUGP600521MGA', 'LUGP600521MDFZRT02', '1', None, 'patricialuzgarza@hotmail.com', '5516516844', None, '5539830422', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BARRIO DE SAN ANDRES', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02240', '0', None, None, None, '30000019734', 'SI000003137', None, '485964.12000', '485964.12000', '.00000', '.00000', '485964.12000', '.00000', '.00000', '.00000', '.00000', '-485964.12000', '.00000', '15-Jan-15', '15-Jan-15', '2-Dec-13', '2-Dec-13', '2-Dec-13', '0', None, '2-Dec-13', '2-Dec-13', '2-Dec-13', '2-Dec-13', '2-Dec-13', None, '6-Dec-13', '6-Dec-13', None, '9-Dec-13', None, '23-Apr-14', '5-May-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC140', '0', 'CASA', 'ARBC140', 'ARB02CA0130', None, '02', None, None, '013', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00053982', 'JUANA GODINEZ RIOJA', 'JUANA', 'GODINEZ', 'RIOJA', 'GORJ6402086M1', 'GORJ640208MDFDJN07', '1', None, None, '58418003', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LA CONCHITA ZAPOTITLAN', 'TLÁHUAC DF', 'DF', 'Mexico', '13360', '0', None, None, None, '30000019965', 'SI000003179', None, '499677.25000', '499677.25000', '.00000', '.00000', '499677.25000', '.00000', '.00000', '51000.00000', '.00000', '-499677.25000', '51000.00000', '1-Jan-00', '19-Jun-15', '3-Dec-13', '3-Dec-13', '3-Dec-13', '0', None, '3-Dec-13', '3-Dec-13', '3-Dec-13', '3-Dec-13', '3-Dec-13', None, '17-Jan-14', '17-Jan-14', None, '29-Jan-14', None, '14-Feb-14', '21-Feb-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC002', '0', 'CASA', 'ARBC002', 'ARB04CA0270', None, '04', None, None, '027', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00054464', 'FERNANDO ALMAZAN DIAZ', 'FERNANDO', 'ALMAZAN', 'DIAZ', 'AADF7606276F5', 'AADF760627HDFLZR02', '1', None, 'a_d_fher@hotmail.com', '58256690', '52098800 EXT 13', '5531040413', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'ATIZAPAN CENTRO', 'ATIZAPÁN ZARAGOZA MEX', 'MEX', 'Mexico', '52900', '0', None, None, None, '30000020120', 'SI000003108', None, '485764.12000', '485764.12000', '.00000', '.00000', '485764.12000', '.00000', '.00000', '54000.00000', '.00000', '-486419.25000', '53344.87000', '15-Jan-15', '15-Jan-15', '29-Nov-13', '29-Nov-13', '29-Nov-13', '0', None, '29-Nov-13', '29-Nov-13', '29-Nov-13', '29-Nov-13', '29-Nov-13', None, '3-Mar-14', '3-Mar-14', None, '10-Mar-14', None, '21-May-14', '19-Jun-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC161', '0', 'CASA', 'ARBC161', 'ARB01CA0020', None, '01', None, None, '002', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00054571', 'ERWIN HUGO CRUZ HERNANDEZ', 'ERWIN HUGO', 'CRUZ', 'HERNANDEZ', 'CUHE8308Q1K12', 'CUHE830801', '1', None, None, '58816132', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'CUMBRIA', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54740', '0', None, None, None, '30000020161', 'SI000003073', None, '484677.25000', '484677.25000', '.00000', '.00000', '484677.25000', '.00000', '.00000', '.00000', '.00000', '-495650.26000', '-10973.01000', '1-Jan-00', '19-Jun-15', '21-Nov-13', '21-Nov-13', '21-Nov-13', '0', None, '21-Nov-13', '21-Nov-13', '21-Nov-13', '21-Nov-13', '21-Nov-13', None, '13-Jan-14', '13-Jan-14', None, '13-Feb-14', None, '9-Apr-14', '25-Apr-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC180', '0', 'CASA', 'ARBC180', 'ARB01CA0210', None, '01', None, None, '021', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00054710', 'OSCAR RICARDO LOPEZ CAMACHO', 'OSCAR RICARDO', 'LOPEZ', 'CAMACHO', 'LOCO6511117U1', 'LXCO651111HDFPMS04', '1', None, None, '5547842702', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'TLALNEPANTLA MEX', None, 'Mexico', None, '0', None, None, None, '30000020252', 'SI000003224', None, '479677.25000', '479677.25000', '.00000', '.00000', '479677.25000', '.00000', '.00000', '54000.00000', '.00000', '-479677.25000', '54000.00000', '1-Jan-00', '19-Jun-15', '4-Dec-13', '4-Dec-13', '4-Dec-13', '0', None, '4-Dec-13', '4-Dec-13', '4-Dec-13', '4-Dec-13', '4-Dec-13', None, '30-Jan-14', '30-Jan-14', None, '10-Feb-14', None, '9-Jul-14', '15-Jul-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC172', '0', 'CASA', 'ARBC172', 'ARB01CA0130', None, '01', None, None, '013', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00055025', 'LAURA PAOLA RENAU CAJAS', 'LAURA PAOLA', 'RENAU', 'CAJAS', 'RECL800917HY1', 'RECL800917MDFNJR05', '1', None, None, '2225402937', '65976177', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LA GUADALUPANA CUAUTITL', 'CUAUTITLÁN MEX', 'MEX', 'Mexico', '54840', '0', None, None, None, '30000020336', 'SI000003134', None, '490135.04000', '490135.04000', '.00000', '.00000', '490135.04000', '.00000', '.00000', '54000.00000', '.00000', '-490135.04000', '54000.00000', '1-Jan-00', '19-Jun-15', '2-Dec-13', '2-Dec-13', '2-Dec-13', '0', None, '2-Dec-13', '2-Dec-13', '2-Dec-13', '2-Dec-13', '2-Dec-13', None, '2-Apr-14', '2-Apr-14', None, '14-Apr-14', None, '6-Jun-14', '12-Apr-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC119', '0', 'CASA', 'ARBC119', 'ARB05CA0380', None, '05', None, None, '038', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '29-Nov-13', '29-Nov-13', '2-Jun-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00055084', 'MARIA ISABEL GUTIERREZ KRIEGER', 'MARIA ISABEL', 'GUTIERREZ', 'KRIEGER', 'GUKI510312KR8', 'GUKI510312MDFTRS05', '1', None, None, '59159083', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'CONDESA', 'CUAUHTÉMOC DF', 'DF', 'Mexico', '06140', '0', None, None, None, '30000020443', 'SI000003408', None, '483818.33000', '483818.33000', '.00000', '.00000', '483818.33000', '.00000', '.00000', '54000.00000', '.00000', '-483818.33000', '54000.00000', '1-Jan-00', '19-Jun-15', '3-Jan-14', '3-Jan-14', '3-Jan-14', '0', None, '3-Jan-14', '3-Jan-14', '3-Jan-14', '3-Jan-14', '3-Jan-14', None, '8-Apr-14', '8-Apr-14', None, '14-Apr-14', None, '6-Jun-14', '12-Jun-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC005', '0', 'CASA', 'ARBC005', 'ARB04CA0240', None, '04', None, None, '024', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00055413', 'RICARDO ANTONIO GARCIA DE LA ROSA', 'RICARDO ANTONIO', 'GARCIA', 'DE LA ROSA', 'GARR840701T34', 'GARR840701HDFRSC13', '1', None, None, '0000000000', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'AZCAPOTZALCO DF', None, 'Mexico', None, '0', None, None, None, '30000020591', 'SI000003286', None, '465677.67000', '465677.67000', '.00000', '.00000', '465677.67000', '.00000', '.00000', '51000.00000', '.00000', '-465677.67000', '51000.00000', '1-Jan-00', '19-Jun-15', '13-Dec-13', '13-Dec-13', '13-Dec-13', '0', None, '13-Dec-13', '13-Dec-13', '13-Dec-13', '13-Dec-13', '13-Dec-13', None, '23-Jan-14', '23-Jan-14', None, '29-Jan-14', None, '17-Feb-14', '1-Mar-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC112', '0', 'CASA', 'ARBC112', 'ARB05CA0100', None, '05', None, None, '010', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00055504', 'TANIA LILIA HERNANDEZ MORENO', 'TANIA LILIA', 'HERNANDEZ', 'MORENO', 'HEMT880422N77', 'HEMT880422MDFRRN08', '1', None, 'tania_2204@outlook.com', '26165805', None, '5529508034', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'MORELOS', 'VENUSTIANO CARRANZA DF', 'DF', 'Mexico', '15270', '0', None, None, None, '30000020633', 'SI000003229', None, '499818.33000', '499818.33000', '.00000', '.00000', '499818.33000', '.00000', '.00000', '54000.00000', '.00000', '-499818.33000', '54000.00000', '15-Jan-15', '15-Jan-15', '4-Dec-13', '4-Dec-13', '4-Dec-13', '0', None, '4-Dec-13', '4-Dec-13', '4-Dec-13', '4-Dec-13', '4-Dec-13', None, '5-May-14', '5-May-14', None, '12-May-14', None, '5-Jun-14', '20-Jun-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC007', '0', 'CASA', 'ARBC007', 'ARB04CA0220', None, '04', None, None, '022', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00056107', 'EVA PEREZ GARCIA', 'EVA', 'PEREZ', 'GARCIA', 'PEGE681026NR5', 'PEGE681026MDFRRV09', '1', None, 'eva.perez@sepdf.gob.mx', '53065940', None, '5521897455', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'COCOYOTES', 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07180', '0', None, None, None, '30000020815', 'SI000003138', None, '485677.67000', '485677.67000', '.00000', '.00000', '485677.67000', '.00000', '.00000', '54000.00000', '.00000', '-485677.67000', '54000.00000', '15-Jan-15', '15-Jan-15', '2-Dec-13', '2-Dec-13', '2-Dec-13', '0', None, '2-Dec-13', '2-Dec-13', '2-Dec-13', '2-Dec-13', '2-Dec-13', None, '6-Feb-14', '6-Feb-14', None, '10-Mar-14', None, '11-Jun-14', '19-Jun-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC029', '0', 'CASA', 'ARBC029', 'ARB04CA0320', None, '04', None, None, '032', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00056557', 'CARLOS LÓPEZ RUÍZ', 'CARLOS', 'LÓPEZ', 'RUÍZ', 'LORC731019RT7', 'LORC731019HDFPZR04', '1', None, 'textes_17@hotmail.com', '53836468', None, '5526759074', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'EL ROSARIO', 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54090', '0', None, None, None, '30000020997', 'SI000003344', None, '468459.61000', '468459.61000', '.00000', '.00000', '468459.61000', '.00000', '.00000', '51000.00000', '.00000', '-468459.61000', '51000.00000', '15-Jan-15', '15-Jan-15', '23-Dec-13', '23-Dec-13', '23-Dec-13', '0', None, '23-Dec-13', '23-Dec-13', '23-Dec-13', '23-Dec-13', '23-Dec-13', None, '14-Jan-14', '14-Jan-14', None, '16-Jan-14', None, '10-Feb-14', '15-Feb-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC127', '0', 'CASA', 'ARBC127', 'ARB05CA0300', None, '05', None, None, '030', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '29-Nov-13', '29-Nov-13', '2-Jun-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00057080', 'MARTIN NIEVES OMAÑA', 'MARTIN', 'NIEVES', 'OMAÑA', 'NIOM630122UV7', 'NIOM630122HMCVMR04', '1', None, None, '58770083', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BOSQUES DE MORELOS', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54760', '0', None, None, None, '30000021235', 'SI000003364', None, '499818.33000', '499818.33000', '.00000', '.00000', '499818.33000', '.00000', '.00000', '51000.00000', '.00000', '-499818.33000', '51000.00000', '1-Jan-00', '19-Jun-15', '26-Dec-13', '26-Dec-13', '26-Dec-13', '0', None, '26-Dec-13', '26-Dec-13', '26-Dec-13', '26-Dec-13', '26-Dec-13', None, '6-Feb-14', '6-Feb-14', None, '13-Feb-14', None, '28-Feb-14', '16-Apr-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC111', '0', 'CASA', 'ARBC111', 'ARB05CA0110', None, '05', None, None, '011', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00057182', 'PAULINA TORRES RIVERO', 'PAULINA', 'TORRES', 'RIVERO', 'TORP831224GR4', 'TORP831224MMCRVL03', '1', None, None, '58781796', '58992425', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BARRIO SAN ANTONIO', 'MELCHOR OCAMPO MEX', 'MEX', 'Mexico', '54880', '0', None, None, None, '30000021318', 'SI000003345', None, '469818.33000', '469818.33000', '.00000', '.00000', '469818.33000', '.00000', '.00000', '51000.00000', '.00000', '-469818.33000', '51000.00000', '1-Jan-00', '19-Jun-15', '23-Dec-13', '23-Dec-13', '23-Dec-13', '0', None, '23-Dec-13', '23-Dec-13', '23-Dec-13', '23-Dec-13', '23-Dec-13', None, '9-Apr-14', '9-Apr-14', None, '14-Apr-14', None, '22-May-14', '28-May-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC013', '0', 'CASA', 'ARBC013', 'ARB04CA0160', None, '04', None, None, '016', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00057233', 'HECTOR NOLASCO LOPEZ', 'HECTOR', 'NOLASCO', 'LOPEZ', 'NOLH781127EM1', 'NOLH781127HMNLPC04', '1', None, 'hector.nolasco@hotmail.com', '58818143', None, '5549019320', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'U H FIDEL VELAZQUEZ', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54700', '0', None, None, None, '30000021342', 'SI000003314', None, '469677.68000', '469677.68000', '.00000', '.00000', '469677.68000', '.00000', '.00000', '51000.00000', '.00000', '-463677.68000', '57000.00000', '15-Jan-15', '15-Jan-15', '19-Dec-13', '19-Dec-13', '19-Dec-13', '0', None, '19-Dec-13', '19-Dec-13', '19-Dec-13', '19-Dec-13', '19-Dec-13', None, '21-Jan-14', '21-Jan-14', None, '13-Feb-14', None, '26-Feb-14', '14-Mar-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC031', '0', 'CASA', 'ARBC031', 'ARB04CA0110', None, '04', None, None, '011', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00057322', 'JOEL NIEVES GARCIA', 'JOEL', 'NIEVES', 'GARCIA', 'NIGJ770524KX4', 'NIGJ770524HDFVRL07', '1', None, None, '53625600', '51407000 EXT 22', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'VISTA HERMOSA', 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54080', '0', None, None, None, '30000021409', 'SI000003407', None, '480677.67000', '480677.67000', '.00000', '.00000', '480677.67000', '.00000', '.00000', '54000.00000', '.00000', '-480677.67000', '54000.00000', '1-Jan-00', '19-Jun-15', '3-Jan-14', '3-Jan-14', '3-Jan-14', '0', None, '3-Jan-14', '3-Jan-14', '3-Jan-14', '3-Jan-14', '3-Jan-14', None, '6-Mar-14', '6-Mar-14', None, '10-Mar-14', None, '8-Jul-14', '15-Jul-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC227', '0', 'CASA', 'ARBC227', 'ARB03CA0180', None, '03', None, None, '018', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '30-Mar-13', '30-Mar-13', '1-Oct-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00057670', 'JOSE LUIS PADRON LUGO', 'JOSE LUIS', 'PADRON', 'LUGO', 'PALL590823EK9', 'PALL590823HDFDGS06', '1', None, 'pollita_i@hotmail.com', '53574367', None, '5541886707', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'AMPL SAN PEDRO XALPA', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02719', '0', None, None, None, '30000021557', 'SI000003432', None, '469677.25000', '469677.25000', '.00000', '.00000', '469677.25000', '.00000', '.00000', '41225.00000', '.00000', '-473179.90000', '37722.35000', '15-Jan-15', '15-Jan-15', '6-Jan-14', '6-Jan-14', '6-Jan-14', '0', None, '6-Jan-14', '6-Jan-14', '6-Jan-14', '6-Jan-14', '6-Jan-14', None, '6-Feb-14', '6-Feb-14', None, '13-Feb-14', None, '5-Mar-14', '1-Apr-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC164', '0', 'CASA', 'ARBC164', 'ARB01CA0050', None, '01', None, None, '005', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00057686', 'EDUARDO TORRES GARCIA', 'EDUARDO', 'TORRES', 'GARCIA', 'TOGE800513JUA', 'TOGE800513HDFRRD07', '1', None, None, '58727183', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'CUAUTITLÁN MEX', None, 'Mexico', None, '0', None, None, None, '30000021599', 'SI000003386', None, '499677.25000', '499677.25000', '.00000', '.00000', '499677.25000', '.00000', '.00000', '51000.00000', '.00000', '-499677.25000', '51000.00000', '1-Jan-00', '19-Jun-15', '30-Dec-13', '30-Dec-13', '30-Dec-13', '0', None, '30-Dec-13', '30-Dec-13', '30-Dec-13', '30-Dec-13', '30-Dec-13', None, '17-Jan-14', '17-Jan-14', None, '10-Feb-14', None, '26-Feb-14', '14-Mar-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC104', '0', 'CASA', 'ARBC104', 'ARB05CA0200', None, '05', None, None, '020', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '29-Nov-13', '29-Nov-13', '2-Jun-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00057776', 'LEOPOLDO CARRANZA ROJAS', 'LEOPOLDO', 'CARRANZA', 'ROJAS', 'CARL6505024LA', 'CARL650502HMCRJP03', '1', None, None, '26206802', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'EL PARTIDOR', 'CUAUTITLÁN MEX', 'MEX', 'Mexico', '54879', '0', None, None, None, '30000021672', 'SI000003397', None, '497117.98000', '497117.98000', '.00000', '.00000', '497117.98000', '.00000', '.00000', '51000.00000', '.00000', '-497117.98000', '51000.00000', '1-Jan-00', '19-Jun-15', '2-Jan-14', '2-Jan-14', '2-Jan-14', '0', None, '2-Jan-14', '2-Jan-14', '2-Jan-14', '2-Jan-14', '2-Jan-14', None, '6-Feb-14', '6-Feb-14', None, '13-Feb-14', None, '28-Feb-14', '14-Mar-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC028', '0', 'CASA', 'ARBC028', 'ARB04CA0330', None, '04', None, None, '033', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00057876', 'OSCAR DANIEL LUGO CRUZ', 'OSCAR DANIEL', 'LUGO', 'CRUZ', 'LUCO910914K2A', 'LUCO910914HMCGRS03', '1', None, None, '62969166', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'UNIDAD NIÑOS HEROES', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54870', '0', None, None, None, '30000021680', 'SI000003433', None, '465677.67000', '465677.67000', '.00000', '.00000', '465677.67000', '.00000', '.00000', '51000.00000', '.00000', '-465677.67000', '51000.00000', '1-Jan-00', '19-Jun-15', '6-Jan-14', '6-Jan-14', '6-Jan-14', '0', None, '6-Jan-14', '6-Jan-14', '6-Jan-14', '6-Jan-14', '6-Jan-14', None, '23-Jan-14', '23-Jan-14', None, '13-Feb-14', None, '17-Feb-14', '22-Feb-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC152', '0', 'CASA', 'ARBC152', 'ARB03CA0060', None, '03', None, None, '006', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '30-Mar-13', '30-Mar-13', '1-Oct-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00058053', 'NOE MADRIGAL SANCHEZ', 'NOE', 'MADRIGAL', 'SANCHEZ', 'MASN810424T45', 'MASN810424HDFDNX04', '1', None, None, '53938846', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'TLALNEPANTLA MEX', None, 'Mexico', None, '0', None, None, None, '30000021789', 'SI000003646', None, '499677.25000', '499677.25000', '.00000', '.00000', '499677.25000', '.00000', '.00000', '45000.00000', '.00000', '-499677.25000', '45000.00000', '1-Jan-00', '19-Jun-15', '30-Jan-14', '30-Jan-14', '30-Jan-14', '0', None, '30-Jan-14', '30-Jan-14', '30-Jan-14', '30-Jan-14', '30-Jan-14', None, '7-May-14', '7-May-14', None, '12-May-14', None, '21-May-14', '28-May-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC114', '0', 'CASA', 'ARBC114', 'ARB05CA0190', None, '05', None, None, '019', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00058086', 'MONICA BERENICE SERRANO CHACON', 'MONICA BERENICE', 'SERRANO', 'CHACON', 'SECM761018CU5', 'SECM761018MDFRHN04', '1', None, None, '53902801', '535588184', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PRESIDENTE MADERO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02430', '0', None, None, None, '30000021797', 'SI000003434', None, '487390.57000', '487390.57000', '.00000', '.00000', '487390.57000', '.00000', '.00000', '54000.00000', '.00000', '-487629.58000', '53760.99000', '1-Jan-00', '19-Jun-15', '6-Jan-14', '6-Jan-14', '6-Jan-14', '0', None, '6-Jan-14', '6-Jan-14', '6-Jan-14', '6-Jan-14', '6-Jan-14', None, '6-Mar-14', '6-Mar-14', None, '10-Mar-14', None, '2-Jun-14', '12-Jun-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC027', '0', 'CASA', 'ARBC027', 'ARB04CA0340', None, '04', None, None, '034', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00058313', 'JOSUE ALVA URIBE', 'JOSUE', 'ALVA', 'URIBE', 'AAUJ8509276E3', 'AAUJ850927HDFLRS09', '1', None, None, '25989732', '53432000 EXT. 2', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'JARDIN BALBUENA', 'VENUSTIANO CARRANZA DF', 'DF', 'Mexico', '15900', '0', None, None, None, '30000021904', 'SI000003536', None, '470677.67000', '470677.67000', '.00000', '.00000', '470677.67000', '.00000', '.00000', '51000.00000', '.00000', '-470677.67000', '51000.00000', '1-Jan-00', '19-Jun-15', '20-Jan-14', '20-Jan-14', '20-Jan-14', '0', None, '20-Jan-14', '20-Jan-14', '20-Jan-14', '20-Jan-14', '20-Jan-14', None, '28-Mar-14', '28-Mar-14', None, '2-Apr-14', None, '30-Apr-14', '9-May-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC080', '0', 'CASA', 'ARBC080', 'ARB05CA0070', None, '05', None, None, '007', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00059613', 'EDUARDO RUIZ MURILLO', 'EDUARDO', 'RUIZ', 'MURILLO', 'MAGC750629I21', 'RUME670107HDFZRD00', '1', None, None, '53970611', '5208 4649 EXT 1', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'FRACC. RESIDENCIAL CALACOAYA', 'ATIZAPÁN ZARAGOZA MEX', 'MEX', 'Mexico', '52996', '0', None, None, None, '30000022670', 'SI000003931', None, '477818.67000', '477818.67000', '.00000', '.00000', '477818.67000', '.00000', '.00000', '.00000', '.00000', '-477818.67000', '.00000', '1-Jan-00', '19-Jun-15', '24-Feb-14', '24-Feb-14', '24-Feb-14', '0', None, '24-Feb-14', '24-Feb-14', '24-Feb-14', '24-Feb-14', '24-Feb-14', None, '28-Mar-14', '28-Mar-14', None, '2-Apr-14', None, '29-Apr-14', '5-May-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC022', '0', 'CASA', 'ARBC022', 'ARB05CA0020', None, '05', None, None, '002', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00060292', 'MARIA EUGENIA JUAREZ MONJARAS', 'MARIA EUGENIA', 'JUAREZ', 'MONJARAS', 'JUME760826EU0', 'JUME760826MDFRNG04', '1', None, None, '56085825', '24523355', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'UNIDAD INFONAVIT CULHUACAN CTM', 'COYOACÁN DF', 'DF', 'Mexico', '04480', '0', None, None, None, '30000023066', 'SI000003999', None, '499818.34000', '499818.34000', '.00000', '.00000', '499818.34000', '.00000', '.00000', '57000.00000', '.00000', '-501729.04000', '55089.30000', '1-Jan-00', '19-Jun-15', '3-Mar-14', '3-Mar-14', '3-Mar-14', '0', None, '3-Mar-14', '3-Mar-14', '3-Mar-14', '3-Mar-14', '3-Mar-14', None, '18-Aug-14', '18-Aug-14', None, '20-Aug-14', None, '13-Oct-14', '21-Oct-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC053', '0', 'CASA', 'ARBC053', 'ARB04CA0080', None, '04', None, None, '008', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00060549', 'OLIMPIA SELENE GONZALEZ PEREZ', 'OLIMPIA SELENE', 'GONZALEZ', 'PEREZ', 'GOPO700327JE6', 'GOPO700327MDFNRL05', '1', None, None, None, None, '55-3131-0530', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'AZCAPOTZALCO DF', None, 'Mexico', None, '0', None, None, None, '30000023298', 'SI000003647', None, '485677.67000', '485677.67000', '.00000', '.00000', '485677.67000', '.00000', '.00000', '51000.00000', '.00000', '-485677.67000', '51000.00000', '1-Jan-00', '19-Jun-15', '30-Jan-14', '30-Jan-14', '30-Jan-14', '0', None, '30-Jan-14', '30-Jan-14', '30-Jan-14', '30-Jan-14', '30-Jan-14', None, '28-Mar-14', '28-Mar-14', None, '2-Apr-14', None, '7-May-14', '28-May-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC017', '0', 'CASA', 'ARBC017', 'ARB04CA0360', None, '04', None, None, '036', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00061139', 'JOSE OMAR CRUCES TORRES', 'JOSE OMAR', 'CRUCES', 'TORRES', 'ROLD830424IPA', 'CUTO750817HDFRRM03', '1', None, 'jcrucest@sre.gob.mx', '58850630', '5536866006', '5536730017', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'DIEZ DE JUNIO', 'TULTEPEC MEX', 'MEX', 'Mexico', '54980', '0', None, None, None, '30000023629', 'SI000003844', None, '495677.67000', '495677.67000', '.00000', '.00000', '495677.67000', '.00000', '.00000', '57000.00000', '.00000', '-495677.67000', '57000.00000', '15-Jan-15', '15-Jan-15', '14-Feb-14', '14-Feb-14', '14-Feb-14', '0', None, '14-Feb-14', '14-Feb-14', '14-Feb-14', '14-Feb-14', '14-Feb-14', None, '8-May-14', '8-May-14', None, '12-May-14', None, '9-Jun-14', '12-Jun-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC128', '0', 'CASA', 'ARBC128', 'ARB05CA0290', None, '05', None, None, '029', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '29-Nov-13', '29-Nov-13', '2-Jun-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00062530', 'VICTOR JOEL RAMIREZ DUARTE', 'VICTOR JOEL', 'RAMIREZ', 'DUARTE', 'RADV691219Q15', 'RADV691219HDFMRCO7', '1', None, None, '58762648', '58993626', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BARR DE CAPULA', 'TEPOTZOTLÁN MEX', 'MEX', 'Mexico', '54600', '0', None, None, None, '30000024601', 'SI000004031', None, '542733.16000', '542733.16000', '.00000', '.00000', '542733.16000', '.00000', '.00000', '51000.00000', '.00000', '-542733.16000', '51000.00000', '1-Jan-00', '19-Jun-15', '4-Mar-14', '4-Mar-14', '4-Mar-14', '0', None, '4-Mar-14', '4-Mar-14', '4-Mar-14', '4-Mar-14', '4-Mar-14', None, '7-Apr-14', '7-Apr-14', None, '14-Apr-14', None, '21-Jul-14', '25-Jul-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC113', '0', 'CASA', 'ARBC113', 'ARB05CA0120', None, '05', None, None, '012', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00063119', 'DAYSE MAGALI MEJIA VAZQUEZ', 'DAYSE MAGALI', 'MEJIA', 'VAZQUEZ', 'MEVD8705066W8', 'MEVD870506MMCJZY01', '1', None, 'magali.vazquez87@gmail.com', '58673250', None, '5548884227', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN MATEO CUAUTEPEC', 'TULTITLÁN MEX', 'MEX', 'Mexico', '54948', '0', None, None, None, '30000025020', 'SI000004217', None, '484818.33000', '484818.33000', '.00000', '.00000', '484818.33000', '.00000', '.00000', '51000.00000', '.00000', '-484818.33000', '51000.00000', '15-Jan-15', '15-Jan-15', '26-Mar-14', '26-Mar-14', '26-Mar-14', '0', None, '26-Mar-14', '26-Mar-14', '26-Mar-14', '26-Mar-14', '26-Mar-14', None, '28-Mar-14', '28-Mar-14', None, '14-Apr-14', None, '2-May-14', '21-May-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC099', '0', 'CASA', 'ARBC099', 'ARB05CA0170', None, '05', None, None, '017', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00063242', 'ERIKA CARMEN VAZQUEZ TORRES', 'ERIKA CARMEN', 'VAZQUEZ', 'TORRES', 'VATE821104HE8', 'VATE821104MDFZRR04', '1', None, None, '26570788', '25823733', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'AZCAPOTZALCO DF', None, 'Mexico', None, '0', None, None, None, '30000025111', 'SI000004167', None, '487625.42000', '487625.42000', '.00000', '.00000', '487625.42000', '.00000', '.00000', '54000.00000', '.00000', '-487625.42000', '54000.00000', '1-Jan-00', '19-Jun-15', '20-Mar-14', '20-Mar-14', '20-Mar-14', '0', None, '20-Mar-14', '20-Mar-14', '20-Mar-14', '20-Mar-14', '20-Mar-14', None, '28-Mar-14', '28-Mar-14', None, '14-Apr-14', None, '29-Apr-14', '9-May-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC139', '0', 'CASA', 'ARBC139', 'ARB02CA0120', None, '02', None, None, '012', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00063250', 'JUAN ARTURO CORTES AGUIRRE', 'JUAN ARTURO', 'CORTES', 'AGUIRRE', 'COAJ7609204C1', 'COAJ760920HDFRGN09', '1', None, 'cortesja@hotmail.com', '58803641', None, '0', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BOSQUES DE LA HACIENDA 1A', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54715', '0', None, None, None, '30000025137', 'SI000004166', None, '549677.25000', '549677.25000', '.00000', '.00000', '549677.25000', '.00000', '.00000', '51000.00000', '.00000', '-549677.25000', '51000.00000', '15-Jan-15', '15-Jan-15', '20-Mar-14', '20-Mar-14', '20-Mar-14', '0', None, '20-Mar-14', '20-Mar-14', '20-Mar-14', '20-Mar-14', '20-Mar-14', None, '8-Apr-14', '8-Apr-14', None, '14-Apr-14', None, '7-May-14', '15-May-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC106', '0', 'CASA', 'ARBC106', 'ARB05CA0180', None, '05', None, None, '018', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00063369', 'JAQUELINE GONZALEZ BLANCARTE', 'JAQUELINE', 'GONZALEZ', 'BLANCARTE', 'GOBJ750611QB8', 'GOBJ750611MDFNLQ01', '1', None, 'natalycc310782@hotmail.com', '5591506767', '55127181', '5539654655', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'FUENTES DE ARAGON', 'ECATEPEC MORELOS MEX', 'MEX', 'Mexico', '55210', '0', None, None, None, '30000025210', 'SI000005073', None, '552927.10000', '552927.10000', '.00000', '.00000', '552927.10000', '.00000', '.00000', '48264.00000', '.00000', '-553099.44000', '48091.66000', '15-Jan-15', '15-Jan-15', '7-Jul-14', '7-Jul-14', '7-Jul-14', '0', None, '7-Jul-14', '7-Jul-14', '7-Jul-14', '7-Jul-14', '7-Jul-14', None, '4-Sep-14', '4-Sep-14', None, '5-Sep-14', None, '22-Oct-14', '28-Oct-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC039', '0', 'CASA', 'ARBC039', 'ARB04CA0130', None, '04', None, None, '013', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00063688', 'LUIS GERMAN VELES GARCIA', 'LUIS GERMAN', 'VELES', 'GARCIA', 'VEGL870528LU3', 'VEGL870528HMCLRS09', '1', None, None, '5541129509', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LOMA BONITA CUAUTITLAN', 'CUAUTITLÁN MEX', 'MEX', 'Mexico', '54800', '0', None, None, None, '30000025392', 'SI000004603', None, '470677.77000', '470677.77000', '.00000', '.00000', '470677.77000', '.00000', '.00000', '51280.50000', '.00000', '-470677.77000', '51280.50000', '1-Jan-00', '19-Jun-15', '9-May-14', '9-May-14', '9-May-14', '0', None, '9-May-14', '9-May-14', '9-May-14', '9-May-14', '9-May-14', None, '2-Jun-14', '2-Jun-14', None, '5-Jun-14', None, '30-Jun-14', '8-Jul-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC160', '0', 'CASA', 'ARBC160', 'ARB05CA0140', None, '05', None, None, '014', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00063689', 'FRANCISCO GARCIA OLVERA', 'FRANCISCO', 'GARCIA', 'OLVERA', 'GAOF831221P83', 'GAOF831221HDFRLR08', '1', None, None, '5515106854', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'CUAUTITLÁN MEX', None, 'Mexico', None, '0', None, None, None, '30000025400', 'SI000004189', None, '484818.33000', '484818.33000', '.00000', '.00000', '484818.33000', '.00000', '.00000', '51000.00000', '.00000', '-484818.33000', '51000.00000', '1-Jan-00', '19-Jun-15', '24-Mar-14', '24-Mar-14', '24-Mar-14', '0', None, '24-Mar-14', '24-Mar-14', '24-Mar-14', '24-Mar-14', '24-Mar-14', None, '28-Mar-14', '28-Mar-14', None, '14-Apr-14', None, '30-Apr-14', '6-May-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC068', '0', 'CASA', 'ARBC068', 'ARB06CA0190', None, '06', None, None, '019', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00063794', 'CUAUHTEMOC GARCIA VALENCIA', 'CUAUHTEMOC', 'GARCIA', 'VALENCIA', 'GAVC640721KQ0', 'GAVC640721HDFRLH14', '1', None, 'cuauh_temocgv@hotmail.com', '5511305450', None, '5511305450', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SANTA MARIA CALIACAC', 'TEOLOYUCÁN MEX', 'MEX', 'Mexico', '54770', '0', None, None, None, '30000025517', 'SI000004601', None, '549818.33000', '549818.33000', '.00000', '.00000', '549818.33000', '.00000', '.00000', '49483.64000', '.00000', '-550318.33000', '48983.64000', '15-Jan-15', '15-Jan-15', '8-May-14', '8-May-14', '8-May-14', '0', None, '8-May-14', '8-May-14', '8-May-14', '8-May-14', '8-May-14', None, '4-Jul-14', '4-Jul-14', None, '7-Jul-14', None, '8-Aug-14', '12-Aug-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC069', '0', 'CASA', 'ARBC069', 'ARB06CA0180', None, '06', None, None, '018', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00063920', 'GABINA CRUZ CRUZ', 'GABINA', 'CRUZ', 'CRUZ', 'CUCG640219AF4', 'CUCG640219MHGRRB00', '1', None, 'cuauh_temocgv@hotmail.com', '5511305450', None, '5511305450', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BARR SANTA MARIA CALIACAC', 'TEOLOYUCÁN MEX', 'MEX', 'Mexico', '54770', '0', None, None, None, '30000025657', 'SI000004600', None, '549818.33000', '549818.33000', '.00000', '.00000', '549818.33000', '.00000', '.00000', '49483.64000', '.00000', '-549818.33000', '49483.64000', '15-Jan-15', '15-Jan-15', '8-May-14', '8-May-14', '8-May-14', '0', None, '8-May-14', '8-May-14', '8-May-14', '8-May-14', '8-May-14', None, '11-Jul-14', '11-Jul-14', None, '14-Jul-14', None, '8-Aug-14', '12-Aug-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC184', '0', 'CASA', 'ARBC184', 'ARB06CA0010', None, '06', None, None, '001', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00063968', 'ANAHI SORIANO RAMIREZ', 'ANAHI', 'SORIANO', 'RAMIREZ', 'SORA841122RX3', 'SORA841122MMSRMN09', '1', None, None, '53682840', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'INDUSTRIAL', 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07810', '0', None, None, None, '30000025715', 'SI000004306', None, '543000.00000', '543000.00000', '.00000', '.00000', '543000.00000', '.00000', '.00000', '57000.00000', '.00000', '-543000.00000', '57000.00000', '1-Jan-00', '19-Jun-15', '1-Apr-14', '1-Apr-14', '1-Apr-14', '0', None, '1-Apr-14', '1-Apr-14', '1-Apr-14', '1-Apr-14', '1-Apr-14', None, '5-Jun-14', '5-Jun-14', None, '9-Jun-14', None, '30-Jul-14', '7-Aug-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC032', '0', 'CASA', 'ARBC032', 'ARB05CA0010', None, '05', None, None, '001', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00065056', 'JOSE ANTONIO CAMACHO ESCAMILLA', 'JOSE ANTONIO', 'CAMACHO', 'ESCAMILLA', 'HEJL690221JI3', 'CAEA831027HDFMSN02', '1', None, 'antonio_271028@hotmail.com', '5554038136', '55475720 ext 14', '5554038136', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LOMAS DE ATZOLCO', 'ECATEPEC MORELOS MEX', 'MEX', 'Mexico', '55080', '0', None, None, None, '30000026358', 'SI000004654', None, '544500.00000', '544500.00000', '.00000', '.00000', '544500.00000', '.00000', '.00000', '57000.00000', '.00000', '-544501.00000', '56999.00000', '15-Jan-15', '15-Jan-15', '20-May-14', '20-May-14', '20-May-14', '0', None, '20-May-14', '20-May-14', '20-May-14', '20-May-14', '20-May-14', None, '6-Jun-14', '6-Jun-14', None, '9-Jun-14', None, '8-Aug-14', '12-Aug-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC004', '0', 'CASA', 'ARBC004', 'ARB04CA0250', None, '04', None, None, '025', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00065256', 'MARIA MAGDALENA ALARCON RODRIGUEZ', 'MARIA MAGDALENA', 'ALARCON', 'RODRIGUEZ', 'COSL750328DNA', 'AARM540902MGRLDG02', '1', None, 'mariamagdalena@hotmail.com', '58932665', None, '5535016593', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN MARTIN TEPETLIXPAN', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54763', '0', None, None, None, '30000026424', 'SI000004593', None, '480677.65000', '480677.65000', '.00000', '.00000', '480677.65000', '.00000', '.00000', '57000.00000', '.00000', '-480677.65000', '57000.00000', '15-Jan-15', '15-Jan-15', '7-May-14', '7-May-14', '7-May-14', '0', None, '7-May-14', '7-May-14', '7-May-14', '7-May-14', '7-May-14', None, '9-Jul-14', '9-Jul-14', None, '14-Jul-14', None, '2-Oct-14', '7-Oct-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC090', '0', 'CASA', 'ARBC090', 'ARB06CA0300', None, '06', None, None, '030', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00066269', 'JUAN ARISTEO RODRIGUEZ GARCIA', 'JUAN ARISTEO', 'RODRIGUEZ', 'GARCIA', 'ROGJ630903976', 'ROGJ630903', '1', None, 'juan.rod@hotmail.com', '58783680', '5919171331', '5528978416', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SEÑOR DE LOS MILAGROS', 'MELCHOR OCAMPO MEX', 'MEX', 'Mexico', '54880', '0', None, None, None, '30000027307', 'SI000004536', None, '507019.50000', '507019.50000', '.00000', '.00000', '507019.50000', '.00000', '.00000', '51280.50000', '.00000', '-516466.60000', '41833.40000', '15-Jan-15', '15-Jan-15', '2-May-14', '2-May-14', '2-May-14', '0', None, '2-May-14', '2-May-14', '2-May-14', '2-May-14', '2-May-14', None, '24-Oct-14', '24-Oct-14', None, '12-Nov-14', None, '1-Dec-14', '10-Dec-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC098', '0', 'CASA', 'ARBC098', 'ARB06CA0310', None, '06', None, None, '031', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00066428', 'STEPHANIE ROJAS OSNAYA', 'STEPHANIE', 'ROJAS', 'OSNAYA', 'ROOS900429DW0', 'ROOS900429MDFJST07', '1', None, 'fannyosnaya@hotmail.com', '5550195140', '5546067797', '5564030621', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PUEBLO DE SAN ANDRES', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02240', '0', None, None, None, '30010165063', 'SI000005903', None, '564818.33000', '564818.33000', '.00000', '.00000', '564818.33000', '.00000', '.00000', '59023.52000', '.00000', '-564818.33000', '59023.52000', '15-Jan-15', '15-Jan-15', '23-Sep-14', '23-Sep-14', '23-Sep-14', '0', None, '23-Sep-14', '23-Sep-14', '23-Sep-14', '23-Sep-14', '23-Sep-14', None, '12-Mar-15', '12-Mar-15', None, '18-Mar-15', None, '14-May-15', '20-May-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC076', '0', 'CASA', 'ARBC076', 'ARB06CA0110', None, '06', None, None, '011', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00067301', 'MARIA BELEN LOPEZ RAMOS', 'MARIA BELEN', 'LOPEZ', 'RAMOS', 'MAMM640504K58', 'LORB930505MDFPML01', '1', None, 'gbam2911@hotmail.com', '5517644960', None, '5517644960', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PRADO CHURUBUSCO', 'COYOACÁN DF', 'DF', 'Mexico', '4230', '0', None, None, None, '30000027968', 'SI000004709', None, '559500.00000', '559500.00000', '.00000', '.00000', '559500.00000', '.00000', '.00000', '42000.00000', '.00000', '-560526.00000', '40974.00000', '15-Jan-15', '15-Jan-15', '28-May-14', '28-May-14', '28-May-14', '0', None, '28-May-14', '28-May-14', '28-May-14', '28-May-14', '28-May-14', None, '30-May-14', '30-May-14', None, '18-Jun-14', None, '18-Jun-14', '20-Jun-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC126', '0', 'CASA', 'ARBC126', 'ARB05CA0310', None, '05', None, None, '031', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '29-Nov-13', '29-Nov-13', '2-Jun-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00067389', 'JUAN FERNANDO GARCIA HUERTA', 'JUAN FERNANDO', 'GARCIA', 'HUERTA', 'MODL840715R64', 'GAHJ770709HDFRRN00', '1', None, 'jfgarcia@quaitia.com', '5526930019', '50020000 ext 23', '5526930019', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LAURELES', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54840', '0', None, None, None, '30000028032', 'SI000004703', None, '515839.43000', '515839.43000', '.00000', '.00000', '515839.43000', '.00000', '.00000', '51280.50000', '.00000', '-515839.43000', '51280.50000', '15-Jan-15', '15-Jan-15', '27-May-14', '27-May-14', '27-May-14', '0', None, '27-May-14', '27-May-14', '27-May-14', '27-May-14', '27-May-14', None, '5-Jun-14', '5-Jun-14', None, '9-Jun-14', None, '3-Jul-14', '8-Jul-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC015', '0', 'CASA', 'ARBC015', 'ARB04CA0140', None, '04', None, None, '014', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00068047', 'LUIS NUÑEZ MIRANDA', 'LUIS', 'NUÑEZ', 'MIRANDA', 'NUML6707259T5', 'NUML670725HDFXRS09', '1', None, 'lununez@piscimex.com.mx', '19910824', '21223750', '5543624136', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'EL TREBOL', 'TEPOTZOTLÁN MEX', 'MEX', 'Mexico', '54614', '0', None, None, None, '30000028511', 'SI000004886', None, '439140.34000', '439140.34000', '.00000', '.00000', '439140.34000', '.00000', '.00000', '51280.50000', '.00000', '-439140.34000', '51280.50000', '15-Jan-15', '15-Jan-15', '17-Jun-14', '17-Jun-14', '17-Jun-14', '0', None, '17-Jun-14', '17-Jun-14', '17-Jun-14', '17-Jun-14', '17-Jun-14', None, '7-Jul-14', '7-Jul-14', None, '14-Jul-14', None, '31-Jul-14', '5-Aug-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC130', '0', 'CASA', 'ARBC130', 'ARB05CA0080', None, '05', None, None, '008', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00068408', 'JESUS JUAREZ JUAREZ', 'JESUS', 'JUAREZ', 'JUAREZ', 'JUJJ7211045N1', 'JUJJ721104HDFRRS03', '1', None, 'recibofm@vallenproveedora.com.mx', '5564831365', '24519351 y 2451', '5551855388', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LOMAS DE CUAUTEPEC', 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07110', '0', None, None, None, '30000028727', 'SI000004858', None, '497652.25000', '497652.25000', '.00000', '.00000', '497652.25000', '.00000', '.00000', '51280.50000', '.00000', '-497652.25000', '51280.50000', '15-Jan-15', '15-Jan-15', '12-Jun-14', '12-Jun-14', '12-Jun-14', '0', None, '12-Jun-14', '12-Jun-14', '12-Jun-14', '12-Jun-14', '12-Jun-14', None, '24-Jun-14', '24-Jun-14', None, '9-Jul-14', None, '25-Jul-14', '29-Jul-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC067', '0', 'CASA', 'ARBC067', 'ARB06CA0200', None, '06', None, None, '020', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00068497', 'NANCY ALICIA MORELOS CRUZ', 'NANCY ALICIA', 'MORELOS', 'CRUZ', 'MAAJ881229DP3', 'MOCN830321MMCRRN06', '1', None, 'ali_2106@live.com.mx', '58784296', None, '5529053766', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'EDUCACION', 'MELCHOR OCAMPO MEX', 'MEX', 'Mexico', '54880', '0', None, None, None, '30000028792', 'SI000004887', None, '552019.50000', '552019.50000', '.00000', '.00000', '552019.50000', '.00000', '.00000', '51280.50000', '.00000', '-552019.50000', '51280.50000', '15-Jan-15', '15-Jan-15', '17-Jun-14', '17-Jun-14', '17-Jun-14', '0', None, '17-Jun-14', '17-Jun-14', '17-Jun-14', '17-Jun-14', '17-Jun-14', None, '23-Jul-14', '23-Jul-14', None, '12-Aug-14', None, '15-Aug-14', '21-Aug-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC129', '0', 'CASA', 'ARBC129', 'ARB05CA0280', None, '05', None, None, '028', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '29-Nov-13', '29-Nov-13', '2-Jun-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00068760', 'ANABEL GALVEZ NOGUEZ', 'ANABEL', 'GALVEZ', 'NOGUEZ', 'GANA7310279B7', 'GANA731027MDFLGN07', '1', None, 'anabel.galvez@ga3.com.mx', '5513973402', '52339797', '5513973402', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'OLIVAR DEL CONDE', 'ALVARO OBREGÓN DF', 'DF', 'Mexico', '01400', '0', None, None, None, '30000029006', 'SI000004903', None, '504818.33000', '504818.33000', '.00000', '.00000', '504818.33000', '.00000', '.00000', '48264.00000', '.00000', '-504818.33000', '48264.00000', '15-Jan-15', '15-Jan-15', '19-Jun-14', '19-Jun-14', '19-Jun-14', '0', None, '19-Jun-14', '19-Jun-14', '19-Jun-14', '19-Jun-14', '19-Jun-14', None, '28-Aug-14', '28-Aug-14', None, '29-Aug-14', None, '6-Oct-14', '15-Oct-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC077', '0', 'CASA', 'ARBC077', 'ARB06CA0100', None, '06', None, None, '010', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00069394', 'LUIS CONTRERAS DE LA CRUZ', 'LUIS', 'CONTRERAS', 'DE LA CRUZ', 'VILJ6904127Q7', 'COCL810811HVZNRS00', '1', None, 'cruz.816@hotmail.com', '26202645', None, '5516821183', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN BLAS I', 'CUAUTITLÁN MEX', 'MEX', 'Mexico', '54870', '0', None, None, None, '30000029568', 'SI000005014', None, '575036.00000', '575036.00000', '.00000', '.00000', '575036.00000', '.00000', '.00000', '48264.00000', '.00000', '-575036.00000', '48264.00000', '15-Jan-15', '15-Jan-15', '1-Jul-14', '1-Jul-14', '1-Jul-14', '0', None, '1-Jul-14', '1-Jul-14', '1-Jul-14', '1-Jul-14', '1-Jul-14', None, '22-Aug-14', '22-Aug-14', None, '29-Aug-14', None, '23-Sep-14', '25-Sep-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC050', '0', 'CASA', 'ARBC050', 'ARB05CA0090', None, '05', None, None, '009', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00069414', 'SUJEY GONZALEZ CASIANO', 'SUJEY', 'GONZALEZ', 'CASIANO', 'AURK821112LCA', 'GOCS770618MDFNSJ08', '1', None, 'sgonzalez@notaria134.com.mx', '55618766', '53407770', '5528007913', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LA PRECIOSA', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '2460', '0', None, None, None, '30000029600', 'SI000005072', None, '447758.45000', '447758.45000', '.00000', '.00000', '447758.45000', '.00000', '.00000', '51280.50000', '.00000', '-447758.45000', '51280.50000', '15-Jan-15', '15-Jan-15', '7-Jul-14', '7-Jul-14', '7-Jul-14', '0', None, '7-Jul-14', '7-Jul-14', '7-Jul-14', '7-Jul-14', '7-Jul-14', None, '25-Jul-14', '25-Jul-14', None, '12-Aug-14', None, '1-Sep-14', '2-Sep-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC020', '0', 'CASA', 'ARBC020', 'ARB05CA0040', None, '05', None, None, '004', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00069447', 'OLIVIA GUERRERO CRUZ', 'OLIVIA', 'GUERRERO', 'CRUZ', 'OIOJ6903319U7', 'GUCO830106MMCRRL05', '1', None, 'oly-guecruz@live.com', '26111616', None, '5522713617', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'U HAB INFONAVIT NORTE', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54720', '0', None, None, None, '30000029667', 'SI000005012', None, '444898.32000', '444898.32000', '.00000', '.00000', '444898.32000', '.00000', '.00000', '51280.50000', '.00000', '-444898.36000', '51280.46000', '15-Jan-15', '15-Jan-15', '1-Jul-14', '1-Jul-14', '1-Jul-14', '0', None, '1-Jul-14', '1-Jul-14', '1-Jul-14', '1-Jul-14', '1-Jul-14', None, '22-Jul-14', '22-Jul-14', None, '12-Aug-14', None, '22-Aug-14', '2-Sep-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC120', '0', 'CASA', 'ARBC120', 'ARB05CA0370', None, '05', None, None, '037', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '29-Nov-13', '29-Nov-13', '2-Jun-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00069477', 'MARINA PEREZ PARRA', 'MARINA', 'PEREZ', 'PARRA', 'TAHJ831001MZ1', 'PEPM831226MDFRRR06', '1', None, 'marpparra@hotmail.com', '53014480', '35381198', '5532088290', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'ALTAMIRA', 'NAUCALPAN JUÁREZ MEX', 'MEX', 'Mexico', '53700', '0', None, None, None, '30000029717', 'SI000005013', None, '496344.44000', '496344.44000', '.00000', '.00000', '496344.44000', '.00000', '.00000', '51280.50000', '.00000', '-496344.44000', '51280.50000', '15-Jan-15', '15-Jan-15', '1-Jul-14', '1-Jul-14', '1-Jul-14', '0', None, '1-Jul-14', '1-Jul-14', '1-Jul-14', '1-Jul-14', '1-Jul-14', None, '23-Jul-14', '23-Jul-14', None, '12-Aug-14', None, '27-Aug-14', '29-Aug-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC110', '0', 'CASA', 'ARBC110', 'ARB05CA0130', None, '05', None, None, '013', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00069482', 'LUZ MARIA LUNA MARTINEZ', 'LUZ MARIA', 'LUNA', 'MARTINEZ', 'PODK7812054C5', 'LUML691106MDFNRZ08', '1', None, 'luzlunamtz@yahoo.com.mx', '54264154', None, '5', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'CERRO DE LA ESTRELLA', 'IZTAPALAPA DF', 'DF', 'Mexico', '09860', '0', None, None, None, '30000029725', 'SI000005086', None, '544500.00000', '544500.00000', '.00000', '.00000', '544500.00000', '.00000', '.00000', '57000.00000', '.00000', '-546000.00000', '55500.00000', '15-Jan-15', '15-Jan-15', '8-Jul-14', '8-Jul-14', '8-Jul-14', '0', None, '8-Jul-14', '8-Jul-14', '8-Jul-14', '8-Jul-14', '8-Jul-14', None, '29-Jul-14', '29-Jul-14', None, '12-Aug-14', None, '2-Oct-14', '18-Nov-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC103', '0', 'CASA', 'ARBC103', 'ARB05CA0210', None, '05', None, None, '021', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '29-Nov-13', '29-Nov-13', '2-Jun-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00070613', 'MARIO ALBERTO MATA VELAZQUEZ', 'MARIO ALBERTO', 'MATA', 'VELAZQUEZ', 'MAVM831221T7A', 'MAVM831221HMCTLR08', '1', None, 'conciencia.combativa@gmail.com', '58908883', None, '5551826028', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SOLIDARIDAD', 'TULTITLÁN MEX', 'MEX', 'Mexico', '54948', '0', None, None, None, '30000030392', 'SI000005304', None, '488519.50000', '488519.50000', '.00000', '.00000', '488519.50000', '.00000', '.00000', '51280.50000', '.00000', '-488519.50000', '51280.50000', '15-Jan-15', '15-Jan-15', '21-Jul-14', '21-Jul-14', '21-Jul-14', '0', None, '21-Jul-14', '21-Jul-14', '21-Jul-14', '21-Jul-14', '21-Jul-14', None, '8-Aug-14', '8-Aug-14', None, '12-Aug-14', None, '12-Sep-14', '25-Sep-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC074', '0', 'CASA', 'ARBC074', 'ARB06CA0230', None, '06', None, None, '023', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00071477', 'YANAI TAPIA SOLIS', 'YANAI', 'TAPIA', 'SOLIS', 'TASY860212G70', 'TASY860212MMCPLN06', '1', None, 'yanai.tapia@tvh.com', '44750327', '5544750327', '5544750327', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, None, None, 'Mexico', None, '0', None, None, None, '30010178827', 'SI000010774', None, '465000.00000', '465000.00000', '.00000', '.00000', '465000.00000', '.00000', '.00000', '43477.50000', '.00000', '-465000.00000', '43477.50000', '15-Jan-15', '15-Jan-15', '13-Jan-15', '13-Jan-15', '13-Jan-15', '0', None, '13-Jan-15', '13-Jan-15', '13-Jan-15', '13-Jan-15', '13-Jan-15', None, '12-Mar-15', '12-Mar-15', None, '18-Mar-15', None, '22-Apr-15', '29-Apr-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC078', '0', 'CASA', 'ARBC078', 'ARB06CA0090', None, '06', None, None, '009', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00072230', 'LAURA ESTHER CISNEROS ARAUJO', 'LAURA ESTHER', 'CISNEROS', 'ARAUJO', 'PEOL740414UG9', 'CIAL781223MDFSRR02', '1', None, 'lcisnerosa@yahoo.com.mx', '17583505', None, '5517583505', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'VILLA DE ARAGON', 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07570', '0', None, None, None, '30010161120', 'SI000005562', None, '588250.00000', '588250.00000', '.00000', '.00000', '588250.00000', '.00000', '.00000', '61750.00000', '.00000', '-588250.00000', '61750.00000', '15-Jan-15', '15-Jan-15', '21-Aug-14', '21-Aug-14', '21-Aug-14', '0', None, '21-Aug-14', '21-Aug-14', '21-Aug-14', '21-Aug-14', '21-Aug-14', None, '5-Sep-14', '5-Sep-14', None, '9-Sep-14', None, '10-Oct-14', '21-Oct-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC202', '0', 'CASA', 'ARBC202', 'ARB07CA0100', None, '07', None, None, '010', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '17-Jan-14', '17-Jan-14', '21-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00072473', 'JOSE SAMUEL PEÑA LOPEZ', 'JOSE SAMUEL', 'PEÑA', 'LOPEZ', 'GUML820220HHS', 'PELS840718HDFXPM03', '1', None, 'samuel.pena@grupocaisa.com', '44355578', '56622423', '5554075813', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LOMAS DE SAN FRANCISCO TEPOJAC', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54745', '0', None, None, None, '30000031242', 'SI000005615', None, '537613.09000', '537613.09000', '.00000', '.00000', '537613.09000', '.00000', '.00000', '51280.50000', '.00000', '-537613.09000', '51280.50000', '15-Jan-15', '15-Jan-15', '28-Aug-14', '28-Aug-14', '28-Aug-14', '0', None, '28-Aug-14', '28-Aug-14', '28-Aug-14', '28-Aug-14', '28-Aug-14', None, '24-Sep-14', '24-Sep-14', None, '13-Oct-14', None, '22-Oct-14', '23-Oct-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC124', '0', 'CASA', 'ARBC124', 'ARB05CA0260', None, '05', None, None, '026', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '29-Nov-13', '29-Nov-13', '2-Jun-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00072693', 'ELIZABETH BALLESTEROS MONTERO', 'ELIZABETH', 'BALLESTEROS', 'MONTERO', 'BAME8706078C6', 'BAME870607MDFLNL01', '1', None, 'ebm_7@hotmail.com', '10395681', '21595020 EXT 5', '5539129036', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'U. HAB. PENSAMIENTOS', 'TULTITLÁN MEX', 'MEX', 'Mexico', '54930', '0', None, None, None, '30000031283', 'SI000005700', None, '549818.33000', '549818.33000', '.00000', '.00000', '549818.33000', '.00000', '.00000', '51280.50000', '.00000', '-551318.33000', '49780.50000', '15-Jan-15', '15-Jan-15', '8-Sep-14', '8-Sep-14', '8-Sep-14', '0', None, '8-Sep-14', '8-Sep-14', '8-Sep-14', '8-Sep-14', '8-Sep-14', None, '13-Oct-14', '13-Oct-14', None, '15-Oct-14', None, '28-Oct-14', '11-Nov-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC072', '0', 'CASA', 'ARBC072', 'ARB06CA0060', None, '06', None, None, '006', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00072875', 'MIGUEL ANGEL GONZALEZ LUCIO', 'MIGUEL ANGEL', 'GONZALEZ', 'LUCIO', 'NETP770608379', 'GOLM760325HDFNCG09', '1', None, 'mglez.lucio@gmail.com', '21478253', '63601179', '5522675464', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'UHAB  VALLEJO SCT', 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07700', '0', None, None, None, '30010170931', 'SI000009973', None, '440000.00000', '440000.00000', '.00000', '.00000', '440000.00000', '.00000', '.00000', '41140.00000', '.00000', '-440000.00000', '41140.00000', '15-Jan-15', '15-Jan-15', '3-Nov-14', '3-Nov-14', '3-Nov-14', '0', None, '3-Nov-14', '3-Nov-14', '3-Nov-14', '3-Nov-14', '3-Nov-14', None, '2-Dec-14', '2-Dec-14', None, '9-Dec-14', None, '25-Feb-15', '4-Mar-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC109', '0', 'CASA', 'ARBC109', 'ARB05CA0150', None, '05', None, None, '015', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00072880', 'FERNANDO FUENTES MARTINEZ', 'FERNANDO', 'FUENTES', 'MARTINEZ', 'FUMF791022NZ5', 'FUMF791022HDFNRR03', '1', None, 'ferkham@hotmail.com', '5553010683', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN RAFAEL CHAMAPA', 'NAUCALPAN JUÁREZ MEX', 'MEX', 'Mexico', '53660', '0', None, None, None, '30000031317', 'SI000005644', None, '532334.57000', '532334.57000', '.00000', '.00000', '532334.57000', '.00000', '.00000', '51280.50000', '.00000', '-532334.57000', '51280.50000', '1-Jan-00', '12-Mar-15', '2-Sep-14', '2-Sep-14', '2-Sep-14', '0', None, '2-Sep-14', '2-Sep-14', '2-Sep-14', '2-Sep-14', '2-Sep-14', None, '23-Sep-14', '23-Sep-14', None, '14-Oct-14', None, '27-Oct-14', '11-Nov-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC065', '0', 'CASA', 'ARBC065', 'ARB04CA0050', None, '04', None, None, '005', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00072883', 'PONCIANO HERNANDEZ TREJO', 'PONCIANO', 'HERNANDEZ', 'TREJO', 'AUVM761007FC9', 'HETP750527HSPRRN09', '1', None, 'poncho_sanluis@yahoo.com.mx', '5535137878', None, '5535137878', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LAZARO CARDENAS', 'CUAUTITLÁN MEX', 'MEX', 'Mexico', '54870', '0', None, None, None, '30010162052', 'SI000005786', None, '515000.00000', '515000.00000', '.00000', '.00000', '515000.00000', '.00000', '.00000', '50985.00000', '.00000', '-515000.00000', '50985.00000', '15-Jan-15', '15-Jan-15', '18-Sep-14', '18-Sep-14', '18-Sep-14', '0', None, '18-Sep-14', '18-Sep-14', '18-Sep-14', '18-Sep-14', '18-Sep-14', None, '31-Oct-14', '31-Oct-14', None, '12-Nov-14', None, '19-Mar-15', '28-Mar-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC192', '0', 'CASA', 'ARBC192', 'ARB07CA0110', None, '07', None, None, '011', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '17-Jan-14', '17-Jan-14', '21-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00073054', 'ELEANIT DEL CARMEN OCAÑA CHAPARRO', 'ELEANIT DEL CARMEN', 'OCAÑA', 'CHAPARRO', 'HEPD750912993', 'OACE810715MDFCHL03', '1', None, 'ely_ocaa@hotmail.com', '58882152', '26230852', '5533602335', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BO SANTIAGUITO', 'TULTITLÁN MEX', 'MEX', 'Mexico', '54900', '0', None, None, None, '30010163589', 'SI000005904', None, '500000.00000', '500000.00000', '.00000', '-35000.00000', '465000.00000', '.00000', '.00000', '44000.00000', '.00000', '-457182.20000', '51817.80000', '15-Jan-15', '15-Jan-15', '23-Sep-14', '23-Sep-14', '23-Sep-14', '0', None, '23-Sep-14', '23-Sep-14', '23-Sep-14', '23-Sep-14', '23-Sep-14', None, '5-Jan-15', '5-Jan-15', None, '28-Jan-15', None, '24-Mar-15', '30-Mar-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC123', '0', 'CASA', 'ARBC123', 'ARB05CA0340', None, '05', None, None, '034', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '29-Nov-13', '29-Nov-13', '2-Jun-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00073575', 'JOSE ALAN MORA LOPEZ', 'JOSE ALAN', 'MORA', 'LOPEZ', 'NIHM6304135G1', 'MOLA860411HDFRPL06', '1', None, 'alan19_ml@hotmail.com', '58173834', None, '5519229437', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'VALLE DE LA HACIENDA', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54710', '0', None, None, None, '30010162409', 'SI000005788', None, '475000.00000', '475000.00000', '.00000', '.00000', '475000.00000', '.00000', '.00000', '47025.00000', '.00000', '-475000.00000', '47025.00000', '15-Jan-15', '15-Jan-15', '18-Sep-14', '18-Sep-14', '18-Sep-14', '0', None, '18-Sep-14', '18-Sep-14', '18-Sep-14', '18-Sep-14', '18-Sep-14', None, '31-Dec-14', '31-Dec-14', None, '15-Jan-15', None, '19-Mar-15', '28-Mar-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC018', '0', 'CASA', 'ARBC018', 'ARB05CA0060', None, '05', None, None, '006', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00074220', 'OSVALDO CARRILLO PADILLA', 'OSVALDO', 'CARRILLO', 'PADILLA', 'GARM850905G57', 'CAPO820520HDFRDS04', '1', None, 'oscarrillop@hotmail.com', '5516867098', None, '5516867098', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'VALLE DE TULES', 'TULTITLÁN MEX', 'MEX', 'Mexico', '54945', '0', None, None, None, '30010163563', 'SI000005787', None, '549818.33000', '549818.33000', '.00000', '-49818.33000', '500000.00000', '.00000', '.00000', '48384.01000', '.00000', '-500000.00000', '48384.01000', '15-Jan-15', '15-Jan-15', '18-Sep-14', '18-Sep-14', '18-Sep-14', '12', None, '18-Sep-14', '18-Sep-14', '18-Sep-14', '18-Sep-14', '18-Sep-14', None, '5-Jan-15', '5-Jan-15', None, '4-Feb-15', None, '20-Feb-15', '4-Mar-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC210', '0', 'CASA', 'ARBC210', 'ARB07CA0190', None, '07', None, None, '019', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '17-Jan-14', '17-Jan-14', '21-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00074246', 'ANDRES NAVARRETE MURGA', 'ANDRES', 'NAVARRETE', 'MURGA', 'EOCM791028SKA', 'NAMA581130HGRVRN00', '1', None, 'zeus582002@yahoo.com.mx', '5939141541', None, '5511465717', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SANTO TOMAS', 'TEOLOYUCÁN MEX', 'MEX', 'Mexico', '54770', '0', None, None, None, '30010163621', 'SI000006140', None, '550000.00000', '550000.00000', '.00000', '.00000', '550000.00000', '.00000', '.00000', '54450.00000', '.00000', '-549999.99000', '54450.01000', '15-Jan-15', '15-Jan-15', '1-Oct-14', '1-Oct-14', '1-Oct-14', '0', None, '1-Oct-14', '1-Oct-14', '1-Oct-14', '1-Oct-14', '1-Oct-14', None, '27-Mar-15', '27-Mar-15', None, '7-Apr-15', None, '4-May-15', '13-May-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC220', '0', 'CASA', 'ARBC220', 'ARB07CA0300', None, '07', None, None, '030', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '24-Jan-14', '24-Jan-14', '28-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00075147', 'ALEJANDRO MANDUJANO FLORES', 'ALEJANDRO', 'MANDUJANO', 'FLORES', 'MAFA770213PB5', 'MAFA770213HDFNLL07', '1', None, 'alejandro.mandujano@live.com', '58611917', None, '58611917', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LA JOYITA', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54767', '0', None, None, None, '30010165931', 'SI000006033', None, '500000.00000', '500000.00000', '.00000', '.00000', '500000.00000', '.00000', '.00000', '46750.00000', '.00000', '-500000.00000', '46750.00000', '15-Jan-15', '15-Jan-15', '29-Sep-14', '29-Sep-14', '29-Sep-14', '0', None, '29-Sep-14', '29-Sep-14', '29-Sep-14', '29-Sep-14', '29-Sep-14', None, '19-Nov-14', '19-Nov-14', None, '9-Dec-14', None, '29-Dec-14', '9-Jan-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC211', '0', 'CASA', 'ARBC211', 'ARB07CA0290', None, '07', None, None, '029', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '24-Jan-14', '24-Jan-14', '28-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00075152', 'ARTURO MANDUJANO FLORES', 'ARTURO', 'MANDUJANO', 'FLORES', 'MAFA7506153L5', 'MAFA750615HDFNLR00', '1', None, 'arman85@hotmail.com', '58611917', '5512531940', '5533338838', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LA JOYITA', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54767', '0', None, None, None, '30010165972', 'SI000006032', None, '500000.00000', '500000.00000', '.00000', '.00000', '500000.00000', '.00000', '.00000', '46750.00000', '.00000', '-500000.00000', '46750.00000', '15-Jan-15', '15-Jan-15', '29-Sep-14', '29-Sep-14', '29-Sep-14', '0', None, '29-Sep-14', '29-Sep-14', '29-Sep-14', '29-Sep-14', '29-Sep-14', None, '18-Nov-14', '18-Nov-14', None, '9-Dec-14', None, '29-Dec-14', '9-Jan-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC118', '0', 'CASA', 'ARBC118', 'ARB06CA0020', None, '06', None, None, '002', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00075234', 'JUAN IGNACIO RIVERA MENDOZA', 'JUAN IGNACIO', 'RIVERA', 'MENDOZA', 'RIMJ830210M16', 'RIMJ830210HDFVNN02', '1', None, 'riveramendoza52@gmail.com', '46320106', '51407000 ext 45', '5560783977', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'FRACCIONAMIENTO SAN ANTONIO', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54725', '0', None, None, None, '30010166137', 'SI000006139', None, '475000.00000', '475000.00000', '.00000', '.00000', '475000.00000', '.00000', '.00000', '47025.00000', '.00000', '-476492.00000', '45533.00000', '15-Jan-15', '15-Jan-15', '1-Oct-14', '1-Oct-14', '1-Oct-14', '0', None, '1-Oct-14', '1-Oct-14', '1-Oct-14', '1-Oct-14', '1-Oct-14', None, '26-Nov-14', '26-Nov-14', None, '9-Dec-14', None, '25-Feb-15', '4-Mar-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC108', '0', 'CASA', 'ARBC108', 'ARB05CA0160', None, '05', None, None, '016', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00075325', 'JOSE TRINIDAD CRUZ SALINAS', 'JOSE TRINIDAD', 'CRUZ', 'SALINAS', 'REPM860125G44', 'CUST780302HMCRLR00', '1', None, 'josecruzs79@hotmail.com', '8671639178', None, '8992420077', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'MANCHA I', 'NAUCALPAN JUÁREZ MEX', 'MEX', 'Mexico', '53717', '0', None, None, None, '30010166335', 'SI000006137', None, '570000.00000', '570000.00000', '.00000', '.00000', '570000.00000', '.00000', '.00000', '53295.00000', '.00000', '-570000.00000', '53295.00000', '15-Jan-15', '15-Jan-15', '1-Oct-14', '1-Oct-14', '1-Oct-14', '0', None, '1-Oct-14', '1-Oct-14', '1-Oct-14', '1-Oct-14', '1-Oct-14', None, '8-Oct-14', '8-Oct-14', None, '14-Oct-14', None, '7-Nov-14', '4-Feb-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC121', '0', 'CASA', 'ARBC121', 'ARB05CA0360', None, '05', None, None, '036', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '29-Nov-13', '29-Nov-13', '2-Jun-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00075410', 'JOSE MIGUEL GARZA RETANA', 'JOSE MIGUEL', 'GARZA', 'RETANA', 'JILM840904HW5', 'GARM841011HMNRTG03', '1', None, 'bombochota59@gmail.com', '53176981', None, '5531573879', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'NUEVA FERROCARRILERA EL HOYO', 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54120', '0', None, None, None, '30010166632', 'SI000006138', None, '445000.00000', '445000.00000', '.00000', '.00000', '445000.00000', '.00000', '.00000', '41607.50000', '.00000', '-445000.14000', '41607.36000', '15-Jan-15', '15-Jan-15', '1-Oct-14', '1-Oct-14', '1-Oct-14', '0', None, '1-Oct-14', '1-Oct-14', '1-Oct-14', '1-Oct-14', '1-Oct-14', None, '8-Oct-14', '8-Oct-14', None, '14-Oct-14', None, '20-Nov-14', '28-Nov-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC125', '0', 'CASA', 'ARBC125', 'ARB05CA0320', None, '05', None, None, '032', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '29-Nov-13', '29-Nov-13', '2-Jun-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00075819', 'JEANNETH DIAZ RODRIGUEZ', 'JEANNETH', 'DIAZ', 'RODRIGUEZ', 'DIRJ790720CI2', 'DIRJ790720MOCZDN01', '1', None, 'jeannethdr@hotmail.com', '53162246', '5555206575', '5510724737', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LAS HUERTAS 3RA SECC', 'NAUCALPAN JUAREZ MEX', 'MEX', 'Mexico', '53427', '0', None, None, None, '30010167689', 'SI000006477', None, '447000.00000', '447000.00000', '.00000', '.00000', '447000.00000', '.00000', '.00000', '41794.50000', '.00000', '-443480.06000', '45314.44000', '15-Jan-15', '15-Jan-15', '27-Oct-14', '27-Oct-14', '27-Oct-14', '0', None, '27-Oct-14', '27-Oct-14', '27-Oct-14', '27-Oct-14', '27-Oct-14', None, '6-Nov-14', '6-Nov-14', None, '12-Nov-14', None, '17-Dec-14', '25-Feb-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC115', '0', 'CASA', 'ARBC115', 'ARB05CA0330', None, '05', None, None, '033', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '29-Nov-13', '29-Nov-13', '2-Jun-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00076032', 'ISRAEL IBARRA DELGADO', 'ISRAEL', 'IBARRA', 'DELGADO', 'BARO780610FA2', 'IADI740517HDFBLS07', '1', None, 'isrraeboy@hotmail.com', '56274873', '56274873', '5523163108', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'VALLE DE MADERO', 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07190', '0', None, None, None, '30010169081', 'SI000006508', None, '549818.33000', '549818.33000', '.00000', '.00000', '549818.33000', '.00000', '.00000', '54432.01000', '.00000', '-549809.33000', '54441.01000', '15-Jan-15', '15-Jan-15', '29-Oct-14', '29-Oct-14', '29-Oct-14', '0', None, '29-Oct-14', '29-Oct-14', '29-Oct-14', '29-Oct-14', '29-Oct-14', None, '26-Nov-14', '26-Nov-14', None, '9-Dec-14', None, '13-Mar-15', '28-Mar-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC097', '0', 'CASA', 'ARBC097', 'ARB06CA0050', None, '06', None, None, '005', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00076069', 'JULIETA ASCENCIO LUCIO', 'JULIETA', 'ASCENCIO', 'LUCIO', 'AELJ8307303R9', 'AELJ830730MDFSCL00', '1', None, 'julieta.ascencio.2@bbva.com', '53074273', '5512033850', '5544570075', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'MINAS COYOTE', 'NAUCALPAN JUÁREZ MEX', 'MEX', 'Mexico', '53694', '0', None, None, None, '30010168620', 'SI000006509', None, '564818.33000', '564818.33000', '.00000', '.00000', '564818.33000', '.00000', '.00000', '52810.51000', '.00000', '-566318.33000', '51310.51000', '15-Jan-15', '15-Jan-15', '29-Oct-14', '29-Oct-14', '29-Oct-14', '0', None, '29-Oct-14', '29-Oct-14', '29-Oct-14', '29-Oct-14', '29-Oct-14', None, '6-Nov-14', '6-Nov-14', None, '12-Nov-14', None, '11-Dec-14', '17-Dec-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC047', '0', 'CASA', 'ARBC047', 'ARB07CA0370', None, '07', None, None, '037', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '24-Jan-14', '24-Jan-14', '28-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00076188', 'CRYSTAL AYARI LOPEZ RAMOS', 'CRYSTAL AYARI', 'LOPEZ', 'RAMOS', 'SOSN841012IB4', 'LORC880125MMCPMR03', '1', None, 'cold_girl23@hotmail.com', '58917322', '11036000', '5534330270', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'U HAB SAN RAFAEL', 'COACALCO MEX', 'MEX', 'Mexico', '55719', '0', None, None, None, '30010168927', 'SI000006386', None, '594818.33000', '594818.33000', '.00000', '.00000', '594818.33000', '.00000', '.00000', '58887.01000', '.00000', '-594818.33000', '58887.01000', '15-Jan-15', '15-Jan-15', '17-Oct-14', '17-Oct-14', '17-Oct-14', '0', None, '17-Oct-14', '17-Oct-14', '17-Oct-14', '17-Oct-14', '17-Oct-14', None, '26-Nov-14', '26-Nov-14', None, '9-Dec-14', None, '8-Jan-15', '4-Feb-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC196', '0', 'CASA', 'ARBC196', 'ARB07CA0070', None, '07', None, None, '007', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '17-Jan-14', '17-Jan-14', '21-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00076285', 'GILBERTO BAUTISTA UICAB ROJAS', 'GILBERTO BAUTISTA', 'UICAB', 'ROJAS', 'UIRG850204CA4', 'UIRG850204HDFCJL07', '1', None, 'gilberto_571@hotmail.com', '26430091', None, '5550765082', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PEÑON DE LOS BAÑOS', 'VENUSTIANO CARRANZA DF', 'DF', 'Mexico', '15520', '0', None, None, None, '30010169222', 'SI000006479', None, '543300.00000', '543300.00000', '.00000', '.00000', '543300.00000', '.00000', '.00000', '50798.55000', '.00000', '-543292.00000', '50806.55000', '15-Jan-15', '15-Jan-15', '27-Oct-14', '27-Oct-14', '27-Oct-14', '0', None, '27-Oct-14', '27-Oct-14', '27-Oct-14', '27-Oct-14', '27-Oct-14', None, '6-Nov-14', '6-Nov-14', None, '12-Nov-14', None, '11-Dec-14', '22-Dec-14', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC021', '0', 'CASA', 'ARBC021', 'ARB05CA0030', None, '05', None, None, '003', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00076614', 'PERLA OLVERA AGUILAR', 'PERLA', 'OLVERA', 'AGUILAR', 'RIRO7105074VA', 'OEAP800502MDFLGR07', '1', None, 'perla_ol@yahoo.com.mx', '58780483', None, '5549506593', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'EL PARTIDOR', 'CUAUTITLÁN MEX', 'MEX', 'Mexico', '54879', '0', None, None, None, '30010170030', 'SI000006506', None, '468400.00000', '468400.00000', '.00000', '.00000', '468400.00000', '.00000', '.00000', '48432.56000', '.00000', '-454855.50000', '61977.06000', '15-Jan-15', '15-Jan-15', '29-Oct-14', '29-Oct-14', '29-Oct-14', '0', None, '29-Oct-14', '29-Oct-14', '29-Oct-14', '29-Oct-14', '29-Oct-14', None, '5-Jan-15', '5-Jan-15', None, '26-Jan-15', None, '13-Mar-15', '28-Mar-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC105', '0', 'CASA', 'ARBC105', 'ARB06CA0070', None, '06', None, None, '007', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00076916', 'IGNACIO BERNARDINO ALVAREZ GARCIA', 'IGNACIO BERNARDINO', 'ALVAREZ', 'GARCIA', 'AAGI701204LJ9', 'AAGI701204HDFLRG04', '1', None, 'i_alvarez1270@hotmail.com', '65773745', '58806427', '5514178036', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'NUEVA EL ROSARIO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02128', '0', None, None, None, '30010171152', 'SI000009996', None, '484818.33000', '484818.33000', '.00000', '.00000', '484818.33000', '.00000', '.00000', '.00000', '.00000', '-503544.53000', '-18726.20000', '15-Jan-15', '15-Jan-15', '10-Nov-14', '10-Nov-14', '10-Nov-14', '0', None, '10-Nov-14', '10-Nov-14', '10-Nov-14', '10-Nov-14', '10-Nov-14', None, '2-Dec-14', '2-Dec-14', None, '9-Dec-14', None, '12-Feb-15', '18-Feb-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC133', '0', 'CASA', 'ARBC133', 'ARB06CA0380', None, '06', None, None, '038', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00077522', 'HILARIO GARCIA  VAZQUEZ', 'HILARIO', 'GARCIA', 'VAZQUEZ', 'GAVH550114HC8', None, '1', None, None, '43700943', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'TEOLOYUCÁN MEX', 'MEX', 'Mexico', '54770', '0', None, None, None, '30010172135', 'SI000010149', None, '583000.00000', '583000.00000', '.00000', '.00000', '583000.00000', '.00000', '.00000', '54510.50000', '.00000', '-584492.00000', '53018.50000', '1-Jan-00', '30-Jan-15', '27-Nov-14', '27-Nov-14', '27-Nov-14', '0', None, '27-Nov-14', '27-Nov-14', '27-Nov-14', '27-Nov-14', '27-Nov-14', None, '2-Mar-15', '2-Mar-15', None, '5-Mar-15', None, '18-Mar-15', '28-Mar-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC116', '0', 'CASA', 'ARBC116', 'ARB06CA0040', None, '06', None, None, '004', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00077526', 'LUIS MORALES RUIZ', 'LUIS', 'MORALES', 'RUIZ', 'ROSR770406930', 'MORL770621HPLRZS07', '1', None, 'luismorales_ruiz@yahoo.com.mx', '55228805', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'ATIZAPÁN ZARAGOZA MEX', 'MEX', 'Mexico', '52900', '0', None, None, None, '30010172176', 'SI000010113', None, '482000.00000', '482000.00000', '.00000', '.00000', '482000.00000', '.00000', '.00000', '50369.00000', '.00000', '-482000.00000', '50369.00000', '1-Jan-00', '30-Jan-15', '25-Nov-14', '25-Nov-14', '25-Nov-14', '0', None, '25-Nov-14', '25-Nov-14', '25-Nov-14', '25-Nov-14', '25-Nov-14', None, '5-Jan-15', '5-Jan-15', None, '26-Jan-15', None, '12-Feb-15', '18-Feb-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC101', '0', 'CASA', 'ARBC101', 'ARB05CA0230', None, '05', None, None, '023', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '29-Nov-13', '29-Nov-13', '2-Jun-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00077793', 'FRANCISCO JULIAN MORENO MORENO', 'FRANCISCO JULIAN', 'MORENO', 'MORENO', 'GAMR700919CE6', 'MOMF560403HDFRRR00', '1', None, 'francisco56@hotmail.com', '58728228', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'ALVARO OBREGÓN DF', 'DF', 'Mexico', '01270', '0', None, None, None, '30010172739', 'SI000010148', None, '544200.00000', '544200.00000', '.00000', '.00000', '544200.00000', '.00000', '.00000', '53875.80000', '.00000', '-544200.00000', '53875.80000', '1-Jan-00', '30-Jan-15', '27-Nov-14', '27-Nov-14', '27-Nov-14', '0', None, '27-Nov-14', '27-Nov-14', '27-Nov-14', '27-Nov-14', '27-Nov-14', None, '31-Dec-14', '31-Dec-14', None, '14-Jan-15', None, '17-Feb-15', '25-Feb-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC081', '0', 'CASA', 'ARBC081', 'ARB06CA0150', None, '06', None, None, '015', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00077808', 'ANGELICA ESCOBAR AGUILAR', 'ANGELICA', 'ESCOBAR', 'AGUILAR', 'BAGR5606151Y0', 'EOAA650403MMNSGN07', '1', None, 'yanni_wy@hotmail.com', '5551156400', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54710', '0', None, None, None, '30010173687', 'SI000010243', None, '510000.00000', '510000.00000', '.00000', '.00000', '510000.00000', '.00000', '.00000', '50490.00000', '.00000', '-508500.00000', '51990.00000', '1-Jan-00', '30-Jan-15', '2-Dec-14', '2-Dec-14', '2-Dec-14', '0', None, '2-Dec-14', '2-Dec-14', '2-Dec-14', '2-Dec-14', '2-Dec-14', None, '12-Jan-15', '12-Jan-15', None, '13-Jan-15', None, '3-Feb-15', '10-Feb-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC096', '0', 'CASA', 'ARBC096', 'ARB06CA0240', None, '06', None, None, '024', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00077856', 'ADRIANA HUERTA GOMEZ', 'ADRIANA', 'HUERTA', 'GOMEZ', 'EUMR710703FM8', 'HUGA830908MDFRMD05', '1', None, 'ahuertag9800@egresado.ipn.mx', '53031630', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07150', '0', None, None, None, '30010172812', 'SI000010114', None, '464500.00000', '464500.00000', '.00000', '.00000', '464500.00000', '.00000', '.00000', '48540.25000', '.00000', '-464500.00000', '48540.25000', '1-Jan-00', '30-Jan-15', '25-Nov-14', '25-Nov-14', '25-Nov-14', '0', None, '25-Nov-14', '25-Nov-14', '25-Nov-14', '25-Nov-14', '25-Nov-14', None, '12-Jan-15', '12-Jan-15', None, '13-Jan-15', None, '10-Mar-15', '18-Mar-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC019', '0', 'CASA', 'ARBC019', 'ARB05CA0050', None, '05', None, None, '005', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00077916', 'ANA MARIA DEL ROSARIO MORALES UBALDO', 'ANA MARIA DEL ROSARIO', 'MORALES', 'UBALDO', 'MOUA7509052Q1', 'MOUA750905MDFRBN06', '0', 'H', 'rosario1900@yahoo.com.mx', '56638600', '5539193820', None, '39927519213', '5-Sep-75', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '35', 'Suburbano', 'CORREGIDORA', '117', '201 B', 'SANTA ANITA', 'IZTACALCO DF', 'DF', 'MEXICO', '08300', '15', 'EMPLEADA', None, 'IFE', '30010172960', '0002637', None, '446883.74000', '446883.74000', '.00000', '.00000', '446883.74000', '.00000', '.00000', '51637.50000', '.00000', '-446884.70000', '51636.54000', '1-Jan-00', '13-Apr-15', '14-Apr-15', '14-Apr-15', '14-Apr-15', None, None, '14-Apr-15', '14-Apr-15', '14-Apr-15', '14-Apr-15', '14-Apr-15', None, '11-May-15', '11-May-15', None, '19-May-15', None, '4-Jun-15', '10-Jun-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC036', '0', 'CASA', 'ARBC036', 'ARB08CA0110', None, '08', None, None, '011', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '31-Jan-14', '31-Jan-14', '4-Aug-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00078100', 'JOSE DAVID SALAS AGUIRRE', 'JOSE DAVID', 'SALAS', 'AGUIRRE', 'DEAR610922199', 'SAAD810306HDGLGV03', '1', None, 'salas.dave@hotmail.com', '5551064506', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'CUAUHTÉMOC DF', 'DF', 'Mexico', '06400', '0', None, None, None, '30010173646', 'SI000010201', None, '584818.33000', '584818.33000', '.00000', '.00000', '584818.33000', '.00000', '.00000', '54680.51000', '.00000', '-584818.33000', '54680.51000', '1-Jan-00', '30-Jan-15', '1-Dec-14', '1-Dec-14', '1-Dec-14', '12', None, '1-Dec-14', '1-Dec-14', '1-Dec-14', '1-Dec-14', '1-Dec-14', None, '13-Feb-15', '13-Feb-15', None, '19-Feb-15', None, '5-Mar-15', '18-Mar-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC089', '0', 'CASA', 'ARBC089', 'ARB06CA0210', None, '06', None, None, '021', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00078150', 'MARIA VICTORIA ORTEGA ESPINOSA', 'MARIA VICTORIA', 'ORTEGA', 'ESPINOSA', 'OEEV660728D66', 'OEEV660728MDFRSC08', '1', None, 'ernesto.angeles.1962@hotmail.com', '53835142', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02100', '0', None, None, None, '30010177621', 'SI000010668', None, '530000.00000', '530000.00000', '.00000', '.00000', '530000.00000', '.00000', '.00000', '49555.00000', '.00000', '-530000.00000', '49555.00000', '1-Jan-00', '30-Jan-15', '6-Jan-15', '6-Jan-15', '6-Jan-15', '0', None, '6-Jan-15', '6-Jan-15', '6-Jan-15', '6-Jan-15', '6-Jan-15', None, '17-Feb-15', '17-Feb-15', None, '3-Mar-15', None, '6-Mar-15', '28-Mar-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC191', '0', 'CASA', 'ARBC191', 'ARB07CA0120', None, '07', None, None, '012', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '17-Jan-14', '17-Jan-14', '21-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00078205', 'JUANA VERONICA TAPIA HERNANDEZ', 'JUANA VERONICA', 'TAPIA', 'HERNANDEZ', 'LERR8603086V6', 'TAHJ831001MMCPRN08', '1', None, 'lucesitavt@hotmail.com', '26465211', '5527759788', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'ECATEPEC MORELOS MEX', 'MEX', 'Mexico', '55114', '0', None, None, None, '30010173943', 'SI000010245', None, '500000.00000', '500000.00000', '.00000', '.00000', '500000.00000', '.00000', '.00000', '46750.00000', '.00000', '-500000.00000', '46750.00000', '1-Jan-00', '30-Jan-15', '2-Dec-14', '2-Dec-14', '2-Dec-14', '0', None, '2-Dec-14', '2-Dec-14', '2-Dec-14', '2-Dec-14', '2-Dec-14', None, '31-Dec-14', '31-Dec-14', None, '13-Jan-15', None, '17-Feb-15', '25-Feb-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC122', '0', 'CASA', 'ARBC122', 'ARB05CA0250', None, '05', None, None, '025', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '29-Nov-13', '29-Nov-13', '2-Jun-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00078254', 'OLGA LIDIA MUÑOZ JUAREZ', 'OLGA LIDIA', 'MUÑOZ', 'JUAREZ', 'PEVR750519LD7', 'MUJO791218MDFXRL05', '1', None, 'stratofortress_angeldown@hotmail.com', '20645322', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'CUAUTITLÁN MEX', 'MEX', 'Mexico', '54840', '0', None, None, None, '30010174081', 'SI000010317', None, '514000.00000', '514000.00000', '.00000', '.00000', '514000.00000', '.00000', '.00000', '50886.00000', '.00000', '-514000.00000', '50886.00000', '1-Jan-00', '30-Jan-15', '3-Dec-14', '3-Dec-14', '3-Dec-14', '0', None, '3-Dec-14', '3-Dec-14', '3-Dec-14', '3-Dec-14', '3-Dec-14', None, '31-Dec-14', '31-Dec-14', None, '15-Jan-15', None, '5-Feb-15', '18-Feb-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC117', '0', 'CASA', 'ARBC117', 'ARB06CA0030', None, '06', None, None, '003', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00078307', 'ANA ISABEL APARICIO SOLANO', 'ANA ISABEL', 'APARICIO', 'SOLANO', 'LOGY770528U70', 'AASA790522MMCPLN03', '1', None, 'hana_2205@yahoo.com', '53821068', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'TULTEPEC MEX', 'MEX', 'Mexico', '54960', '0', None, None, None, '30010174602', 'SI000010483', None, '584818.33000', '584818.33000', '.00000', '.00000', '584818.33000', '.00000', '.00000', '57897.01000', '.00000', '-584818.33000', '57897.01000', '1-Jan-00', '30-Jan-15', '19-Dec-14', '19-Dec-14', '19-Dec-14', '0', None, '19-Dec-14', '19-Dec-14', '19-Dec-14', '19-Dec-14', '19-Dec-14', None, '5-Jan-15', '5-Jan-15', None, '13-Jan-15', None, '17-Feb-15', '25-Feb-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC037', '0', 'CASA', 'ARBC037', 'ARB08CA0100', None, '08', None, None, '010', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '31-Jan-14', '31-Jan-14', '4-Aug-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00078437', 'MIGUEL ANGEL VAZQUEZ LOPEZ', 'MIGUEL ANGEL', 'VAZQUEZ', 'LOPEZ', 'LERS570909894', 'VALM910406HDFZPG02', '1', None, 'miguel.vazquezl@cns.gob.mx', '53006865', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'NAUCALPAN JUÁREZ MEX', 'MEX', 'Mexico', '53770', '0', None, None, None, '30010174560', 'SI000010400', None, '618800.00000', '618800.00000', '.00000', '.00000', '618800.00000', '.00000', '.00000', '61261.20000', '.00000', '-618800.00000', '61261.20000', '1-Jan-00', '30-Jan-15', '15-Dec-14', '15-Dec-14', '15-Dec-14', '0', None, '15-Dec-14', '15-Dec-14', '15-Dec-14', '15-Dec-14', '15-Dec-14', None, '4-Mar-15', '4-Mar-15', None, '10-Mar-15', None, '6-May-15', '13-May-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC045', '0', 'CASA', 'ARBC045', 'ARB08CA0020', None, '08', None, None, '002', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '31-Jan-14', '31-Jan-14', '4-Aug-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00078479', 'KARLA CRISTINA MORENO ALVAREZ', 'KARLA CRISTINA', 'MORENO', 'ALVAREZ', 'SOBS701111UZ4', 'MOAK760622MMSRLR07', '1', None, 'cafe_moak@hotmail.com', '53833887', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02100', '0', None, None, None, '30010174776', 'SI000010399', None, '564818.33000', '564818.33000', '.00000', '.00000', '564818.33000', '.00000', '.00000', '59023.52000', '.00000', '-564818.33000', '59023.52000', '1-Jan-00', '30-Jan-15', '15-Dec-14', '15-Dec-14', '15-Dec-14', '0', None, '15-Dec-14', '15-Dec-14', '15-Dec-14', '15-Dec-14', '15-Dec-14', None, '19-Feb-15', '19-Feb-15', None, '4-Mar-15', None, '20-Mar-15', '28-Mar-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC071', '0', 'CASA', 'ARBC071', 'ARB06CA0160', None, '06', None, None, '016', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00078496', 'YSELA RENATA RODRIGUEZ LOPEZ', 'YSELA RENATA', 'RODRIGUEZ', 'LOPEZ', 'ROLY840127JA4', 'ROLY840127MGRDPS00', '1', None, 'renis845@hotmail.com', '57592102', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02020', '0', None, None, None, '30010174826', 'SI000010397', None, '610000.00000', '610000.00000', '.00000', '.00000', '610000.00000', '.00000', '.00000', '63745.00000', '.00000', '-611500.00000', '62245.00000', '1-Jan-00', '30-Jan-15', '15-Dec-14', '15-Dec-14', '15-Dec-14', '0', None, '15-Dec-14', '15-Dec-14', '15-Dec-14', '15-Dec-14', '15-Dec-14', None, '25-Mar-15', '25-Mar-15', None, '14-Apr-15', None, '18-Jun-15', '25-Jun-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC084', '0', 'CASA', 'ARBC084', 'ARB06CA0360', None, '06', None, None, '036', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00078611', 'MARGARITA GONZALEZ ALVAREZ', 'MARGARITA', 'GONZALEZ', 'ALVAREZ', 'VAOY630423MR1', 'GOAM840524MGRNLR03', '1', None, 'marglez_@live.com.mx', '42390321', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'TULTITLÁN MEX', 'MEX', 'Mexico', '54900', '0', None, None, None, '30010176094', 'SI000010484', None, '473500.00000', '473500.00000', '.00000', '.00000', '473500.00000', '.00000', '.00000', '49480.75000', '.00000', '-473500.00000', '49480.75000', '1-Jan-00', '30-Jan-15', '19-Dec-14', '19-Dec-14', '19-Dec-14', '0', None, '19-Dec-14', '19-Dec-14', '19-Dec-14', '19-Dec-14', '19-Dec-14', None, '31-Dec-14', '31-Dec-14', None, '28-Jan-15', None, '7-Apr-15', '15-Apr-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC141', '0', 'CASA', 'ARBC141', 'ARB02CA0140', None, '02', None, None, '014', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00078728', 'J. JESÚS PRADO GUILLÉN', 'J. JESÚS', 'PRADO', 'GUILLÉN', 'PAGJ721105638', 'PAGJ721105HMCRLS06', '1', None, 'jprado@finanzas.df.gob.mx', '26410902', '51342637', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'NAUCALPAN JUÁREZ MEX', 'MEX', 'Mexico', '53690', '0', None, None, None, '30010175856', 'SI000010795', None, '484677.26000', '484677.26000', '.00000', '.00000', '484677.26000', '.00000', '.00000', '50648.77000', '.00000', '-484677.26000', '50648.77000', '1-Jan-00', '30-Jan-15', '20-Jan-15', '20-Jan-15', '20-Jan-15', '0', None, '20-Jan-15', '20-Jan-15', '20-Jan-15', '20-Jan-15', '20-Jan-15', None, '11-Feb-15', '11-Feb-15', None, '17-Feb-15', None, '18-Mar-15', '15-Apr-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC046', '0', 'CASA', 'ARBC046', 'ARB08CA0010', None, '08', None, None, '001', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '31-Jan-14', '31-Jan-14', '4-Aug-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00078737', 'MARIA ANGELICA VEGA ENRIQUEZ', 'MARIA ANGELICA', 'VEGA', 'ENRIQUEZ', 'GUTH8701295D8', 'VEEA640616MDFGNN08', '1', None, 'mariaangelica.vega.enriquez@hotmail.com', '15504397', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'CUAUTITLÁN MEX', 'MEX', 'Mexico', '54870', '0', None, None, None, '30010175526', 'SI000010426', None, '588000.00000', '588000.00000', '.00000', '.00000', '588000.00000', '.00000', '.00000', '61446.00000', '.00000', '-589492.00000', '59954.00000', '1-Jan-00', '30-Jan-15', '16-Dec-14', '16-Dec-14', '16-Dec-14', '0', None, '16-Dec-14', '16-Dec-14', '16-Dec-14', '16-Dec-14', '16-Dec-14', None, '31-Dec-14', '31-Dec-14', None, '15-Jan-15', None, '13-Mar-15', '9-Jul-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC070', '0', 'CASA', 'ARBC070', 'ARB06CA0170', None, '06', None, None, '017', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00078764', 'NOE LOPEZ RAMIREZ', 'NOE', 'LOPEZ', 'RAMIREZ', 'PEAV650913JF0', 'LORN591110HDFPMX07', '1', None, 'noe_lopez@hacienda.gob.mx', '91480953', '36881855', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54100', '0', None, None, None, '30010175690', 'SI000010444', None, '500000.00000', '500000.00000', '.00000', '.00000', '500000.00000', '.00000', '.00000', '49500.00000', '.00000', '-500000.00000', '49500.00000', '1-Jan-00', '30-Jan-15', '17-Dec-14', '17-Dec-14', '17-Dec-14', '0', None, '17-Dec-14', '17-Dec-14', '17-Dec-14', '17-Dec-14', '17-Dec-14', None, '3-Mar-15', '3-Mar-15', None, '9-Mar-15', None, '31-Mar-15', '29-Apr-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC187', '0', 'CASA', 'ARBC187', 'ARB07CA0180', None, '07', None, None, '018', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '17-Jan-14', '17-Jan-14', '21-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00078773', 'NORMA ANGELICA MARTINEZ GUERRA', 'NORMA ANGELICA', 'MARTINEZ', 'GUERRA', 'SOLS8311291X6', 'MAGN780811MDFRRR01', '1', None, 'angedperez76@hotmail.com', '53102360', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54010', '0', None, None, None, '30010175732', 'SI000010398', None, '564818.33000', '564818.33000', '.00000', '.00000', '564818.33000', '.00000', '.00000', '59023.51000', '.00000', '-567818.33000', '56023.51000', '1-Jan-00', '30-Jan-15', '15-Dec-14', '15-Dec-14', '15-Dec-14', '0', None, '15-Dec-14', '15-Dec-14', '15-Dec-14', '15-Dec-14', '15-Dec-14', None, '12-Jan-15', '12-Jan-15', None, '13-Jan-15', None, '3-Feb-15', '10-Feb-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC086', '0', 'CASA', 'ARBC086', 'ARB06CA0340', None, '06', None, None, '034', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00078779', 'MARIA GUADALUPE CEDILLO ALVAREZ', 'MARIA GUADALUPE', 'CEDILLO', 'ALVAREZ', 'SATV561101TX4', 'CEAG841211MDFDLD04', '1', None, 'lupita_ceal@hotmail.com', '5519223617', '12536330 ext 22', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54728', '0', None, None, None, '30010175773', 'SI000010445', None, '444000.00000', '444000.00000', '.00000', '.00000', '444000.00000', '.00000', '.00000', '46398.00000', '.00000', '-444067.92000', '46330.08000', '1-Jan-00', '30-Jan-15', '17-Dec-14', '17-Dec-14', '17-Dec-14', '0', None, '17-Dec-14', '17-Dec-14', '17-Dec-14', '17-Dec-14', '17-Dec-14', None, '12-Jan-15', '12-Jan-15', None, '19-Jan-15', None, '15-Apr-15', '4-May-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC188', '0', 'CASA', 'ARBC188', 'ARB07CA0170', None, '07', None, None, '017', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '17-Jan-14', '17-Jan-14', '21-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00078863', 'MARCO ARTURO HERNANDEZ TORRES', 'MARCO ARTURO', 'HERNANDEZ', 'TORRES', 'EEAY720413Q04', 'HETM721202HDFRRR07', '1', None, 'smaguilar64@yahoo.com.mx', '5527451137', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'CUAUHTÉMOC DF', 'DF', 'Mexico', '06450', '0', None, None, None, '30010176086', 'SI000010471', None, '473000.00000', '473000.00000', '.00000', '.00000', '473000.00000', '.00000', '.00000', '49428.50000', '.00000', '-477152.77000', '45275.73000', '1-Jan-00', '30-Jan-15', '18-Dec-14', '18-Dec-14', '18-Dec-14', '0', None, '18-Dec-14', '18-Dec-14', '18-Dec-14', '18-Dec-14', '18-Dec-14', None, '21-Jan-15', '21-Jan-15', None, '28-Jan-15', None, '19-Feb-15', '4-Mar-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC091', '0', 'CASA', 'ARBC091', 'ARB06CA0220', None, '06', None, None, '022', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00079108', 'JOSE LUIS FLORES GARMENDIA', 'JOSE LUIS', 'FLORES', 'GARMENDIA', 'FOGL8611217W7', 'FOGL861121HOCLRS05', '1', None, 'fgarmendiajl@hotmail.com', '41943073', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02630', '0', None, None, None, '30010176995', 'SI000010552', None, '502500.00000', '502500.00000', '.00000', '.00000', '502500.00000', '.00000', '.00000', '46983.75000', '.00000', '-502500.00000', '46983.75000', '1-Jan-00', '30-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '0', None, '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', '1-Jan-15', None, '6-Feb-15', '6-Feb-15', None, '17-Feb-15', None, '5-Mar-15', '18-Mar-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC038', '0', 'CASA', 'ARBC038', 'ARB08CA0090', None, '08', None, None, '009', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '31-Jan-14', '31-Jan-14', '4-Aug-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00079315', 'MANUEL ALEJANDRO HERNANDEZ SEVILLA', 'MANUEL ALEJANDRO', 'HERNANDEZ', 'SEVILLA', 'HESM8011118J5', 'HESM801111HDFRVN04', '1', None, 'alexnandez80@gmail.com', '41681625', '26163604', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'VENUSTIANO CARRANZA DF', 'DF', 'Mexico', '15440', '0', None, None, None, '30010177753', 'SI000010751', None, '566800.00000', '566800.00000', '.00000', '.00000', '566800.00000', '.00000', '.00000', '52995.80000', '.00000', '-566800.00000', '52995.80000', '1-Jan-00', '30-Jan-15', '8-Jan-15', '8-Jan-15', '8-Jan-15', '12', None, '8-Jan-15', '8-Jan-15', '8-Jan-15', '8-Jan-15', '8-Jan-15', None, '9-Feb-15', '9-Feb-15', None, '17-Feb-15', None, '5-Mar-15', '18-Mar-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC008', '0', 'CASA', 'ARBC008', 'ARB07CA0360', None, '07', None, None, '036', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '24-Jan-14', '24-Jan-14', '28-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00079411', 'YOLANDA MORALES TRUJILLO', 'YOLANDA', 'MORALES', 'TRUJILLO', 'MOTY6811165W0', 'MOTY681116MDFRRL07', '1', None, 'ilanda2008@hotmail.com', '5', '5', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, None, None, 'Mexico', None, '0', None, None, None, '30010178330', 'SI000010775', None, '590000.00000', '590000.00000', '.00000', '.00000', '590000.00000', '.00000', '.00000', '61655.00000', '.00000', '-591492.00000', '60163.00000', '1-Jan-00', '30-Jan-15', '13-Jan-15', '13-Jan-15', '13-Jan-15', '0', None, '13-Jan-15', '13-Jan-15', '13-Jan-15', '13-Jan-15', '13-Jan-15', None, '11-Feb-15', '11-Feb-15', None, '17-Feb-15', None, '19-Mar-15', '28-Mar-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC034', '0', 'CASA', 'ARBC034', 'ARB08CA0130', None, '08', None, None, '013', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '31-Jan-14', '31-Jan-14', '4-Aug-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00079672', 'HERON SANTIAGO CRUZ', 'HERON', 'SANTIAGO', 'CRUZ', 'SACH790628NE2', 'SACH790628HDFNRR00', '0', 'H', 'SANTIAGO9812@HOTMAIL.COM', '56825960', '5532660204', '55387276', '92957921858', '28-Jun-79', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '35', 'Suburbano', 'RUMBO', '1336', None, 'PRENSA NACIONAL', 'TLALNEPANTLA MEX', 'MEX', 'MEXICO', '54170', '8', 'EMPLEADO', '5078047468307', 'IFE', '30020105190', '0002441', None, '472821.96000', '472821.96000', '.00000', '.00000', '472821.96000', '.00000', '.00000', '51637.50000', '.00000', '-472821.96000', '51637.50000', '1-Jan-00', '20-Jun-15', '24-Mar-15', '26-Mar-15', '26-Mar-15', '12', None, '26-Mar-15', '26-Mar-15', '26-Mar-15', '31-Mar-15', '31-Mar-15', '5-Mar-15', '31-Mar-15', '31-Mar-15', None, '13-Apr-15', None, '6-May-15', '27-May-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC219', '0', 'CASA', 'ARBC219', 'ARB07CA0140', None, '07', None, None, '014', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '17-Jan-14', '17-Jan-14', '21-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00079904', 'MANUEL MEZA MARTINEZ', 'MANUEL', 'MEZA', 'MARTINEZ', 'MEMM850606KV9', None, '1', None, None, '89944849', '52825478 ext 13', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LOC PUERTO MAGU', 'MEX', 'MEX', 'Mexico', '54440', '0', None, None, None, '30010179692', 'SI000010799', None, '497000.00000', '497000.00000', '.00000', '.00000', '497000.00000', '.00000', '.00000', '46469.50000', '.00000', '-497000.00000', '46469.50000', '1-Jan-00', '22-Feb-15', '20-Jan-15', '20-Jan-15', '20-Jan-15', '0', None, '20-Jan-15', '20-Jan-15', '20-Jan-15', '20-Jan-15', '20-Jan-15', None, '5-Feb-15', '5-Feb-15', None, '12-Feb-15', None, '6-Mar-15', '18-Mar-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC189', '0', 'CASA', 'ARBC189', 'ARB07CA0150', None, '07', None, None, '015', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '17-Jan-14', '17-Jan-14', '21-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00079905', 'JUDITH GOMEZ LUNA', 'JUDITH', 'GOMEZ', 'LUNA', 'GOLJ810411SP7', 'GOLJ810411MDFMND00', '1', None, 'judy_gl@hotmail.com', '68296911', '52825478 ext 13', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'FERNANDO DE ALBA', 'MEX', 'MEX', 'Mexico', '55118', '0', None, None, None, '30010179700', 'SI000010800', None, '500000.00000', '500000.00000', '.00000', '.00000', '500000.00000', '.00000', '.00000', '46750.00000', '.00000', '-500000.00000', '46750.00000', '1-Jan-00', '22-Feb-15', '20-Jan-15', '20-Jan-15', '20-Jan-15', '0', None, '20-Jan-15', '20-Jan-15', '20-Jan-15', '20-Jan-15', '20-Jan-15', None, '5-Feb-15', '5-Feb-15', None, '12-Feb-15', None, '5-Mar-15', '18-Mar-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC194', '0', 'CASA', 'ARBC194', 'ARB07CA0090', None, '07', None, None, '009', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '17-Jan-14', '17-Jan-14', '21-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00080257', 'JOSE AGUSTIN JIMENEZ VALENCIA', 'JOSE AGUSTIN', 'JIMENEZ', 'VALENCIA', 'JIVA870825EI0', 'JIVA870825HDFMLG05', '1', None, 'azetaw@gmail.com', None, None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'CUAUTITLAN IZCALLI MEX', None, 'Mexico', None, '0', None, None, None, '30010181060', 'SI000011048', None, '472928.19000', '472928.19000', '.00000', '.00000', '472928.19000', '.00000', '.00000', '61750.00000', '.00000', '-472928.22000', '61749.97000', '1-Jan-00', '12-Mar-15', '3-Feb-15', '3-Feb-15', '3-Feb-15', '0', None, '3-Feb-15', '3-Feb-15', '3-Feb-15', '3-Feb-15', '3-Feb-15', None, '25-Mar-15', '25-Mar-15', None, '14-Apr-15', None, '6-May-15', '13-May-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC061', '0', 'CASA', 'ARBC061', 'ARB08CA0190', None, '08', None, None, '019', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '31-Jan-14', '31-Jan-14', '4-Aug-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00080442', 'LUIS EDUARDO MORALES CHAVARRIA', 'LUIS EDUARDO', 'MORALES', 'CHAVARRIA', 'MOCL810510UAA', 'MOCL810510HMCRHS05', '1', None, 'luis_eduardo.morales@hotmail.com', '5540647134', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN FRANCISCO TEPOJACO', 'MEX', 'MEX', 'Mexico', '54745', '0', None, None, None, '30010181813', 'SI000011050', None, '564819.00000', '564819.00000', '.00000', '.00000', '564819.00000', '.00000', '.00000', '52810.57000', '.00000', '-566319.00000', '51310.57000', '1-Jan-00', '22-Feb-15', '17-Feb-15', '17-Feb-15', '17-Feb-15', '0', None, '17-Feb-15', '17-Feb-15', '17-Feb-15', '17-Feb-15', '17-Feb-15', None, '5-Mar-15', '5-Mar-15', None, '18-Mar-15', None, '7-Apr-15', '15-Apr-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC186', '0', 'CASA', 'ARBC186', 'ARB07CA0080', None, '07', None, None, '008', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '17-Jan-14', '17-Jan-14', '21-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00080541', 'ANDRES HERNANDEZ LOPEZ', 'ANDRES HERNANDEZ', 'LOPEZ', None, None, None, '0', 'H', None, None, None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, None, None, 'Mexico', None, '0', None, None, '0', '30010182126', 'SI000011047', None, '491000.00000', '491000.00000', '.00000', '.00000', '491000.00000', '.00000', '.00000', '45908.50000', '.00000', '-491000.00000', '45908.50000', '1-Jan-00', '12-Mar-15', '17-Feb-15', '17-Feb-15', '17-Feb-15', '0', None, '17-Feb-15', '17-Feb-15', '17-Feb-15', '17-Feb-15', '17-Feb-15', None, '4-Mar-15', '4-Mar-15', None, '11-Mar-15', None, '7-Apr-15', '15-Apr-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC201', '0', 'CASA', 'ARBC201', 'ARB07CA0020', None, '07', None, None, '002', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '17-Jan-14', '17-Jan-14', '21-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00080624', 'IRENE DIAZ DIAZ', 'IRENE', 'DIAZ', 'DIAZ', 'DIDI720405KF3', 'DIDI720405MTLZZR09', '1', None, 'irene444@live.com.mx', '23187843', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BARRIO EL CARRIL', 'TLX', 'TLX', 'Mexico', '90710', '0', None, None, None, '30010182381', 'SI000011046', None, '588819.00000', '588819.00000', '.00000', '.00000', '588819.00000', '.00000', '.00000', '61750.00000', '.00000', '-590311.00000', '60258.00000', '1-Jan-00', '22-Feb-15', '17-Feb-15', '17-Feb-15', '17-Feb-15', '0', None, '17-Feb-15', '17-Feb-15', '17-Feb-15', '17-Feb-15', '17-Feb-15', None, '3-Mar-15', '3-Mar-15', None, '10-Mar-15', None, '1-Apr-15', '22-Apr-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC190', '0', 'CASA', 'ARBC190', 'ARB07CA0130', None, '07', None, None, '013', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '17-Jan-14', '17-Jan-14', '21-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00080740', 'JONATHAN SOTO LOPEZ', 'JONATHAN', 'SOTO', 'LOPEZ', 'SOLJ9010144C0', 'SOLJ901014HDFTPN08', '1', None, 'loxtprophtz_666@hotmail.com', '28461838', '58993100', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PARQUE SAN MATEO', 'MEX', 'MEX', 'Mexico', '54820', '0', None, None, None, '30010182753', 'SI000011049', None, '464000.00000', '464000.00000', '.00000', '.00000', '464000.00000', '.00000', '.00000', '43384.00000', '.00000', '-464000.00000', '43384.00000', '1-Jan-00', '22-Feb-15', '18-Feb-15', '18-Feb-15', '18-Feb-15', '0', None, '18-Feb-15', '18-Feb-15', '18-Feb-15', '18-Feb-15', '18-Feb-15', None, '4-Mar-15', '4-Mar-15', None, '18-Mar-15', None, '7-Apr-15', '22-Apr-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC088', '0', 'CASA', 'ARBC088', 'ARB06CA0320', None, '06', None, None, '032', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00081126', 'CLAUDIA CAMPOS LOPEZ', 'CLAUDIA', 'CAMPOS', 'LOPEZ', 'CALC7406063P4', 'CALC740606MMCMPL09', '0', 'M', 'CLAUCAMLO@HOTMAIL.COM', '58703568', None, None, '92897405582', '6-Jun-74', 'SOLTERO', None, 'MEXICANA', 'CUAUTITLAN EDO MEX', None, '1', 'Impresos', '21 DE MARZO', '27 MZ 8 LT 1', None, 'LA ESPAÑITA', 'CUAUTITLAN', 'MEX', 'MEXICO', '54800', '0', 'AUXILIAR CONTABLE', '0680045047693', 'IFE', '30010183330', '0002278', None, '535000.00000', '535000.00000', '.00000', '.00000', '535000.00000', '.00000', '.00000', '50022.50000', '.00000', '-535000.00000', '50022.50000', '23-Feb-15', '20-Jun-15', '24-Feb-15', '24-Feb-15', '24-Feb-15', '12', None, '24-Feb-15', '24-Feb-15', '24-Feb-15', '24-Feb-15', '24-Feb-15', None, '6-Mar-15', '6-Mar-15', None, '13-Mar-15', None, '7-Apr-15', '15-Apr-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC052', '0', 'CASA', 'ARBC052', 'ARB04CA0090', None, '04', None, None, '009', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535,678.00 ', '1,500.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00081137', 'CARLOS MARTIN AGUEROS AGUILAR', 'CARLOS MARTIN', 'AGUEROS', 'AGUILAR', 'AUAC830829983', 'AUAC830829HDFGGR08', '0', 'H', 'CARLOS.AGUEROS@AXA.COM.MX', '13334733', '5549678798', '51692500', '07078303323', '29-Aug-83', 'SOLTERO', None, 'MEXICANA', 'MEXICO, D.F.', None, '2', 'Volante', 'AV CULTURA GRIEGA DEPTO 202', '15', '202', 'UNIDAD HAB RIVERA ANAYA', 'AZCAPOTZALCO', 'MEXICO, D.F.', 'MEXICO', '02109', '5', 'EMPLEADO', 'IDMEX1272564461', 'IFE', '30010183389', '0002296', None, '505678.00000', '505678.00000', '.00000', '.00000', '505678.00000', '.00000', '.00000', '42968.00000', '.00000', '-505678.00000', '42968.00000', '25-Feb-15', '20-Jun-15', '25-Feb-15', '25-Feb-15', '25-Feb-15', '12', None, '27-Feb-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', None, '12-Mar-15', '12-Mar-15', None, '19-Mar-15', None, '22-Apr-15', '4-May-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC079', '0', 'CASA', 'ARBC079', 'ARB06CA0080', None, '06', None, None, '008', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00081150', 'ERICK VICENTE CARMONA IERENE', 'ERICK VICENTE', 'CARMONA', 'IERENE', 'CAIE830426IL5', 'CAIE830426HDFRRR04', '0', 'H', 'ECARMONAI@HOTMAIL.COM', '5557983306', '5544604605', '5556256700', None, '26-Apr-83', 'SOLTERO', None, 'MEXICANA', 'MEXICO DISTRITO FEDERAL', None, '35', 'Suburbano', 'TONATIHU', '1', '59', 'CUIDAD AMANECER', 'ECATEPEC', 'ESTADO DE MEXICO', 'MEXICO', '55267', '7', 'EMPLEADO', '0592084706580', 'IFE', '30010183470', '0002032', None, '503250.00000', '503250.00000', '.00000', '.00000', '503250.00000', '.00000', '.00000', '61750.00000', '.00000', '-509132.85000', '55867.15000', '26-Feb-15', '20-Jun-15', '26-Feb-15', '26-Feb-15', '24-Feb-15', '12', None, '27-Feb-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', None, '12-Mar-15', '12-Mar-15', None, '14-Apr-15', None, '4-Jun-15', '18-Jun-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC033', '0', 'CASA', 'ARBC033', 'ARB08CA0060', None, '08', None, None, '006', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '31-Jan-14', '31-Jan-14', '4-Aug-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00081180', 'FELIX ENRIQUE DIAZ LICON', 'FELIX ENRIQUE', 'DIAZ', 'LICON', 'DILF481120JB0', 'DILF481120HDFZCL08', '0', 'H', 'SAMARI_7012@YAHOO.COM.MX', '5515444593', '5539750696', '5557228525', None, '20-Nov-48', 'CASADO', 'SOCIEDAD CONYUGAL', 'MEXICANA', 'MEXICO DF', None, '3', 'Gallardete', 'CALLE 645', '42', None, 'SAN JUAN DE ARAGON 4 Y 5 SECC', 'GUSTAVO A MADERO', 'DISTRITO FEDERAL', 'MEXICO', '07979', '15', 'EMPLEADO', '1632049964260', 'IFE', '30020121478', '0002922', None, '564819.00000', '564819.00000', '.00000', '.00000', '564819.00000', '.00000', '.00000', '50833.71000', '.00000', '-537318.99000', '78333.72000', '28-Feb-15', '2-Jun-15', '10-Jun-15', '3-Jun-15', '9-Jun-15', '12', None, '10-Jun-15', '10-Jun-15', '11-Jun-15', '12-Jun-15', '12-Jun-15', None, '14-Aug-15', '14-Aug-15', None, '21-Aug-15', None, '25-Aug-15', '28-Aug-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC087', '0', 'CASA', 'ARBC087', 'ARB06CA0330', None, '06', None, None, '033', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00081254', 'JOSE RAMON GARCIA ESCALERA', 'JOSE RAMON', 'GARCIA', 'ESCALERA', 'GAER800909G90', 'GAER800909HDFRSM07', '0', 'H', 'RAMONCHO90@HOTMAIL.COM', '5521597152', '0554425051603', '5558858448', '94068008005', '9-Sep-80', 'SOLTERO', None, 'MEXICANA', 'MEXICO', None, '35', 'Suburbano', 'RANCHO LA LAGUNA', '12', '44', 'RANCHO LA PALMA', 'COACALCO', 'MEX', 'MEXICO', '55717', '0', 'INGENIERO EN SISTEMAS', '111111111111111', 'IFE', '30010184460', '0002325', None, '534000.00000', '534000.00000', '.00000', '.00000', '534000.00000', '.00000', '.00000', '51637.50000', '.00000', '-534000.23000', '51637.27000', '2-Mar-15', '20-Jun-15', '2-Mar-15', '2-Mar-15', '2-Mar-15', '12', None, '13-Mar-15', '13-Mar-15', '13-Mar-15', '13-Mar-15', '13-Mar-15', None, '17-Mar-15', '17-Mar-15', None, '19-Mar-15', None, '6-May-15', '13-May-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC075', '0', 'CASA', 'ARBC075', 'ARB06CA0120', None, '06', None, None, '012', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00081282', 'JOSE IGNACIO RIVERA GONZALEZ', 'JOSE IGNACIO', 'RIVERA', 'GONZALEZ', 'RIGI610606DG4', 'RIGI610606HMNVNG09', '0', 'H', 'IRIVERA@OPERADORADETRAJES.COM', '017222781376', '5535066002', '26261608', '11806127152', '6-Jun-61', 'SOLTERO', None, 'MEXICANA', 'MICHOACAN', None, '35', 'Suburbano', 'CARLOS GIRON', '28', None, 'DEPORTIVA 1ERA SECCION', 'TOLUCA', 'MEXICO', 'MEXICO', '71350', '8', 'EMPLEADO', '1250008318149', 'IFE', '30020101322', '0002326', None, '564819.00000', '564819.00000', '.00000', '-8956.50000', '555862.50000', '.00000', '.00000', '51637.50000', '.00000', '-584137.89000', '23362.11000', '2-Mar-15', '20-Jun-15', '2-Mar-15', '2-Mar-15', '2-Mar-15', '12', None, '13-Mar-15', '13-Mar-15', '13-Mar-15', '13-Mar-15', '13-Mar-15', None, '8-Apr-15', '8-Apr-15', None, '14-Apr-15', None, '19-May-15', '27-May-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC199', '0', 'CASA', 'ARBC199', 'ARB07CA0040', None, '07', None, None, '004', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '17-Jan-14', '17-Jan-14', '21-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00081288', 'SERGIO GODINEZ CHAVEZ', 'SERGIO', 'GODINEZ', 'CHAVEZ', 'GOCS710919683', 'GOCS710920HDFDHR06', '0', 'H', 'SGODINEZ@UNITEDFARMS.MX', '4421272536', '4421272536', None, None, '19-Sep-71', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '35', 'Suburbano', 'HACIENDA DE LA GAVIA', '481', None, 'HACIENDA DEL PARQUE', 'CUAUTITLAN IZCALLI', 'MEXICO', 'MEXICO', '54769', '6', 'EMPLEADO', '5526011857317', 'IFE', '30010183579', '0002068', None, '443084.80000', '443084.80000', '.00000', '.00000', '443084.80000', '.00000', '.00000', '51637.50000', '.00000', '-443084.79000', '51637.51000', '2-Mar-15', '20-Jun-15', '2-Mar-15', '5-Mar-15', '5-Mar-15', '12', None, '5-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', None, '17-Mar-15', '17-Mar-15', None, '9-Apr-15', None, '22-Apr-15', '29-Apr-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC198', '0', 'CASA', 'ARBC198', 'ARB07CA0050', None, '07', None, None, '005', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '17-Jan-14', '17-Jan-14', '21-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00081292', 'LIDIA GODINEZ CHAVEZ', 'LIDIA', 'GODINEZ', 'CHAVEZ', 'GOCL700719IA8', 'GOCL700719MMCDHD00', '0', 'H', 'LIDDIACHAVEZ9@GMAIL.COM', '63624236', '5563624236', None, None, '19-Jul-70', 'SOLTERO', None, 'MEXICANA', 'ESTADO DE MEXICO', None, '35', 'Suburbano', 'HACIENDA DE LA GAVIA', 'EDIF 481', '301', 'HACIENDA DEL PARQUE', 'CUAUTITLAN IZCALLI', 'MEXICO', 'MEXICO', '54769', '20', 'EMPLEADO', '1238544515', 'IFE', '30010183561', '0002069', None, '442188.50000', '442188.50000', '.00000', '.00000', '442188.50000', '.00000', '.00000', '30953.20000', '12046.80000', '-442188.50000', '43000.00000', '2-Mar-15', '20-Jun-15', '2-Mar-15', '5-Mar-15', '5-Mar-15', '0', None, '5-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', None, '4-Mar-15', '4-Mar-15', None, '9-Mar-15', None, '12-Mar-15', '18-Mar-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC222', '0', 'CASA', 'ARBC222', 'ARB07CA0160', None, '07', None, None, '016', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '17-Jan-14', '17-Jan-14', '21-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00081294', 'QUINTIN CRUZ MARTINEZ', 'QUINTIN', 'CRUZ', 'MARTINEZ', 'CUMQ8607134P4', 'CUMQ860713HVZRRN09', '0', 'H', 'CHELSEA20101955@HOTMAIL.COM', '20646630', '5513362600', None, None, '13-Jul-86', 'SOLTERO', None, 'MEXICANA', 'VERACRUZ', None, '35', 'Suburbano', 'GUSTAVO BAZ PRADA', 'MZ 10', 'LT 16 CASA 3', 'LA GUADALUPANA', 'CUAUTITLAN', 'MEXICO', 'MEXICO', '54840', '3', 'EMPLEADO', '0691103969872', 'IFE', '30010185541', '0002493', None, '488250.00000', '488250.00000', '.00000', '.00000', '488250.00000', '.00000', '.00000', '61750.00000', '.00000', '-488249.91000', '61750.09000', '2-Mar-15', '20-Jun-15', '2-Mar-15', '2-Mar-15', '2-Mar-15', '12', None, '4-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', None, '18-Mar-15', '18-Mar-15', None, '19-Mar-15', None, '15-Apr-15', '22-Apr-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC083', '0', 'CASA', 'ARBC083', 'ARB06CA0370', None, '06', None, None, '037', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00081297', 'FIDEL CALTENCO CASIQUE', 'FIDEL', 'CALTENCO', 'CASIQUE', 'CACF651213323', 'CACF651213HPLLSD03', '0', 'H', 'FICALTENCO@GMAIL.COM', '42112782', '5530273231', None, None, '13-Dec-65', 'SOLTERO', None, 'MEXICANA', 'PUEBLA', None, '35', 'Suburbano', 'CALLE 17', '51', None, 'EL SOL', 'NEZAHUALCOYOTL', 'MEXICO', 'MEXICO', '57200', '6', 'EMPLEADO', '0684047678932', 'IFE', '30020102643', '0002276', None, '555863.00000', '555863.00000', '.00000', '.00000', '555863.00000', '.00000', '.00000', '51637.50000', '.00000', '-555862.50000', '51638.00000', '2-Mar-15', '20-Jun-15', '10-Mar-15', '10-Mar-15', '12-Mar-15', '12', None, '12-Mar-15', '12-Mar-15', '12-Mar-15', '13-Mar-15', '13-Mar-15', None, '31-Mar-15', '31-Mar-15', None, '13-Apr-15', None, '15-May-15', '20-May-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC093', '0', 'CASA', 'ARBC093', 'ARB06CA0270', None, '06', None, None, '027', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00081350', 'MARIA GUADALUPE ENRIQUEZ SARIÑAN', 'MARIA GUADALUPE', 'ENRIQUEZ', 'SARIÑAN', 'EISG760528ML9', 'EISG760528MDFNRD02', '0', 'M', 'MG_ENRIQUEZSARINAN@TERRA.COM.MX', '58315500', '5558315500', None, '39957628637', '28-May-76', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '35', 'Suburbano', 'PRIV MALINCHE MZ 1 LT 26', 'CONDOMINIO 3', None, 'LOMAS DEL PARQUE', 'TULTITLÁN', 'EM', 'MEXICO', '54958', '0', 'EMPLEADO', '5522083528678', 'IFE', '30010184585', '0002073', None, '555862.50000', '555862.50000', '.00000', '.00000', '555862.50000', '.00000', '.00000', '51637.50000', '.00000', '-582145.95000', '25354.05000', '3-Mar-15', '20-Jun-15', '3-Mar-15', '3-Mar-15', '3-Mar-15', '12', None, '3-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', None, '8-Apr-15', '8-Apr-15', None, '14-Apr-15', None, '14-May-15', '20-May-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC197', '0', 'CASA', 'ARBC197', 'ARB07CA0060', None, '07', None, None, '006', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '17-Jan-14', '17-Jan-14', '21-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00081397', 'CLAUDIA LETICIA PEREZ HERNANDEZ', 'CLAUDIA LETICIA', 'PEREZ', 'HERNANDEZ', 'PEHC691018643', 'PEHC691018MDFRRL05', '0', 'M', 'ALEJANDRO.AMIONE@TUCANTON.COM', '5555320035', '5540181104', '5540407348', '45906908939', '18-Oct-69', 'SOLTERO', None, 'MEXICANA', 'MEXICO DF', None, '9', 'Web', 'CDA 3 RA RETO O', '121', 'EDIF E DEPTO 11', 'EL RETO', 'IZTAPALAPA DF', 'DISTRITO FEDERAL', 'MEXICO', '09440', '10', 'EMPLEADO', '6356006242286', 'IFE', '30020103534', '0002411', None, '499819.00000', '499819.00000', '.00000', '.00000', '499819.00000', '.00000', '.00000', '46733.08000', '.00000', '-474564.28000', '71987.80000', '5-Mar-15', '20-Jun-15', '19-Mar-15', '24-Mar-15', '24-Mar-15', '12', None, '24-Mar-15', '24-Mar-15', '24-Mar-15', '31-Mar-15', '31-Mar-15', '5-Mar-15', '10-Apr-15', '10-Apr-15', None, '11-May-15', None, '19-May-15', '27-May-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC213', '0', 'CASA', 'ARBC213', 'ARB07CA0270', None, '07', None, None, '027', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '24-Jan-14', '24-Jan-14', '28-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00081475', 'AIDE YAZMIN GALENO HERNANDEZ', 'AIDE YAZMIN', 'GALENO', 'HERNANDEZ', 'GAHA850729RDA', 'GAHA850729MDFLRD02', '0', 'M', 'AIDE_GALENO@HOTMAIL.COM', '5518509043', '5539771383', None, '11048524786', '29-Jul-85', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '35', 'Suburbano', 'MONTE ALTO', '41', '49', 'LA ALBORADA', 'CUAUTITLAN', 'ESTADO DE MÉXICO', 'MÉXICO', '54850', '4', 'EMPLEADA', '0160099475847', 'IFE', '30020104128', '0002377', None, '491796.49000', '491796.49000', '.00000', '.00000', '491796.49000', '.00000', '.00000', '51637.50000', '.00000', '-491796.49000', '51637.50000', '8-Mar-15', '20-Jun-15', '8-Mar-15', '8-Mar-15', '10-Mar-15', '12', None, '18-Mar-15', '18-Mar-15', '18-Mar-15', '30-Mar-15', '30-Mar-15', '5-Mar-15', '31-Mar-15', '31-Mar-15', None, '14-Apr-15', None, '6-May-15', '13-May-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC200', '0', 'CASA', 'ARBC200', 'ARB07CA0030', None, '07', None, None, '003', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '2', '1', '572,504.75 ', '1,500.00 ', '0.00 ', '0.00 ', '17-Jan-14', '17-Jan-14', '21-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00081605', 'MARIA ASUNCION AGUILERA DEL TORO', 'MARIA ASUNCION', 'AGUILERA', 'DEL TORO', 'AUTA6601305AA', 'AUTA660130MSLGRS06', '0', 'M', 'MARYCIELO-66@HOTMAIL.COM', '17085274', '5536685700', None, None, '30-Jan-66', 'CASADO', 'SOCIEDAD CONYUGAL', 'MEXICANA', 'SINALOA', None, '35', 'Suburbano', 'QUECHUAS', 'MZA 43', 'LOTE 702', 'AMERICAS II', 'VALLE DE CHALCO', 'MEXICO', 'MEXICO', '56610', '8', 'EMPLEADA', '0974006979355', 'IFE', '30020105786', '0002634', None, '572504.75000', '572504.75000', '.00000', '.00000', '572504.75000', '.00000', '.00000', '61750.00000', '.00000', '-574004.75000', '60250.00000', '14-Mar-15', '20-Jun-15', '15-Apr-15', '15-Apr-15', '15-Apr-15', '12', None, '15-Apr-15', '15-Apr-15', '15-Apr-15', '15-Apr-15', '15-Apr-15', None, '30-Mar-15', '30-Mar-15', None, '14-Apr-15', None, '18-Jun-15', '25-Jun-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC162', '0', 'CASA', 'ARBC162', 'ARB07CA0350', None, '07', None, None, '035', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '24-Jan-14', '24-Jan-14', '28-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00081646', 'MARIA ISABEL LUNA DURAN', 'MARIA ISABEL', 'LUNA', 'DURAN', 'LUDI8112305E8', 'LUDI811230MDFNRS07', '0', 'M', 'CHABELARIS2@HOTMAIL.COM', '57376878', '5539997299', '40400220', '20068101656', '30-Dec-81', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '35', 'Suburbano', 'PUERTO PAPANTLA', '83', None, 'AMPLIACION CASAS ALEMAN', 'GUSTAVO A MADERO', 'DISTRITO FEDERAL', 'MEXICO', '07580', '18', 'EMPLEADA', '1410050937184', 'IFE', '30020105992', '0002444', None, '462268.13000', '462268.13000', '.00000', '.00000', '462268.13000', '.00000', '.00000', '51637.50000', '.00000', '-462268.13000', '51637.50000', '15-Mar-15', '20-Jun-15', '24-Mar-15', '20-Mar-15', '20-Mar-15', '12', None, '26-Mar-15', '26-Mar-15', '26-Mar-15', '31-Mar-15', '31-Mar-15', '5-Mar-15', '31-Mar-15', '31-Mar-15', None, '14-Apr-15', None, '14-May-15', '20-May-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC085', '0', 'CASA', 'ARBC085', 'ARB06CA0350', None, '06', None, None, '035', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00081812', 'RAUL MIRANDA CHAVEZ', 'RAUL', 'MIRANDA', 'CHAVEZ', 'MICR8508091K2', 'MICR850809HMCRHL07', '0', 'H', 'MIRANDA_RAUL1@HOTMAIL.COM', '5558726590', '5540092401', '5553172294', None, '9-Aug-85', 'SOLTERO', None, 'MEXICANA', 'ESTADO DE MEXICO', None, '2', 'Volante', 'CERRADA LOS PINOS', '11', None, 'SAN LORENZO RIO TENCO', 'CUAUTITLAN IZCALLI', 'MEXICO', 'MEXICO', '54713', '8', 'PROFESOR', '0693096306763', 'IFE', '30020107154', '0002450', None, '441603.38000', '441603.38000', '.00000', '.00000', '441603.38000', '.00000', '.00000', '61750.00000', '.00000', '-441603.38000', '61750.00000', '21-Mar-15', '20-Jun-15', '24-Mar-15', '21-Mar-15', '23-Mar-15', '12', None, '26-Mar-15', '26-Mar-15', '26-Mar-15', '31-Mar-15', '31-Mar-15', None, '13-Apr-15', '13-Apr-15', None, '14-Apr-15', None, '18-Jun-15', '25-Jun-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC195', '0', 'CASA', 'ARBC195', 'ARB07CA0210', None, '07', None, None, '021', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '24-Jan-14', '24-Jan-14', '28-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00082007', 'ZAYDA YAEL HERNANDEZ VERA', 'ZAYDA YAEL', 'HERNANDEZ', 'VERA', 'HEVZ880920BF0', 'HEVZ880920MMCRRY00', '0', 'M', None, '5559139926', '5537316305', '57475100', '92078842553', '20-Sep-88', 'SOLTERO', None, 'MEXICANA', 'ESTADO DE MEXICO', None, '53', 'Mini-Ferias', 'AV 1° DE MAYO', 'I 15', '202', 'INFONAVIT CENTRO', 'CUAUTITLAN IZCALLI', 'MEXICO', 'MEXICO', '54760', '2', 'LIC EN SISITEMAS', '0258108328488', 'IFE', '30020109192', '0002587', None, '500000.00000', '500000.00000', '.00000', '.00000', '500000.00000', '.00000', '.00000', '44000.00000', '.00000', '-502500.00000', '41500.00000', '29-Mar-15', '31-Mar-15', '31-Mar-15', '29-Mar-15', '30-Mar-15', '12', None, '31-Mar-15', '4-Apr-15', '9-Apr-15', '9-Apr-15', '9-Apr-15', '5-Mar-15', '14-Aug-15', '14-Aug-15', None, '21-Aug-15', None, '15-Sep-15', '25-Sep-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC207', '0', 'CASA', 'ARBC207', 'ARB07CA0330', None, '07', None, None, '033', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '24-Jan-14', '24-Jan-14', '28-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00082129', 'YLIANA GARCIA VIVEROS', 'YLIANA', 'GARCIA', 'VIVEROS', 'GAVY901104T96', 'GAVY901104MMCRVL07', '0', 'M', 'YLIANA.GARCIA@ELECTROLUX.COM', '58796101', '5523200971', None, '94129006055', '4-Nov-90', 'CASADO', None, 'MEXICANA', 'ESTADO DE MEXICO', None, '35', 'Suburbano', 'MIMOSAS', '141', None, 'VILLA DE LAS FLORES', 'COACALCO', 'MEXICO', 'MEXICO', '55710', '8', 'EMPLEADA', '0050010627417', 'IFE', '30020110406', '0002642', None, '533011.25000', '533011.25000', '.00000', '.00000', '533011.25000', '.00000', '.00000', '51637.50000', '.00000', '-537673.93000', '46974.82000', '3-Apr-15', '20-Jun-15', '3-Apr-15', '6-Apr-15', '8-Apr-15', '12', None, '10-Apr-15', '10-Apr-15', '10-Apr-15', '13-Apr-15', '13-Apr-15', '9-Apr-15', '30-Apr-15', '30-Apr-15', None, '19-May-15', None, '4-Jun-15', '25-Jun-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC048', '0', 'CASA', 'ARBC048', 'ARB08CA0080', None, '08', None, None, '008', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '31-Jan-14', '31-Jan-14', '4-Aug-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00082330', 'JUAN ANTONIO TERAN CRUZ', 'JUAN ANTONIO', 'TERAN', 'CRUZ', 'TECJ781118TP0', 'TECJ781118HMCRRN05', '0', 'H', 'teran.jatc@yahoo.com.mx', '5553170409', '5521523014', None, '92977839403', '18-Nov-78', 'SOLTERO', None, 'MEXICANA', 'ESTADO DE MÉXICO', None, '35', 'Suburbano', 'CALLE ZUMPANGO', '15', 'A', 'ISIDRO FABELA', 'TLALNEPANTLA DE BAZ', 'MÉXICO', 'MÉXICO', '54010', '30', 'EMPLEADO', '5095047952767', 'IFE', '30020112444', '0002683', None, '564819.00000', '564819.00000', '.00000', '.00000', '564819.00000', '.00000', '.00000', '52810.58000', '.00000', '-564819.00000', '52810.58000', '12-Apr-15', '12-Apr-15', '12-Apr-15', '14-Apr-15', '16-Apr-15', '12', None, '20-Apr-15', '21-Apr-15', '21-Apr-15', '22-Apr-15', '22-Apr-15', '5-Mar-15', '25-May-15', '25-May-15', None, '2-Jun-15', None, '18-Jun-15', '25-Jun-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC214', '0', 'CASA', 'ARBC214', 'ARB07CA0260', None, '07', None, None, '026', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '588,250.00 ', '1,500.00 ', '0.00 ', '0.00 ', '24-Jan-14', '24-Jan-14', '28-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00082584', 'LUZ VERONICA PEDRO SANTIAGO', 'LUZ VERONICA', 'PEDRO', 'SANTIAGO', 'PESL740912Q84', 'PESL740912MBCDNZ08', '0', 'M', 'LUZVERONICA4@HOTMAIL.COM', '53043283', '5538766042', '55300967', None, '12-Sep-74', 'SOLTERO', None, 'MEXICANA', 'BAJA CALIFORNIA', None, '35', 'Suburbano', 'SIERRA HERMOSA', '85', None, 'BENITO JUAREZ', 'NAUCALPAN DE JUAREZ', 'MEXICO', 'MEXICO', '53790', '8', 'EMPLEADO', '2670045069626', 'IFE', '30020114465', '0002746', None, '588250.00000', '588250.00000', '.00000', '.00000', '588250.00000', '.00000', '.00000', '61750.00000', '.00000', '-588250.00000', '61750.00000', '25-Apr-15', '20-Jun-15', '5-May-15', '5-May-15', '5-May-15', '12', None, '5-May-15', '5-May-15', '5-May-15', '5-May-15', '5-May-15', None, '14-May-15', '14-May-15', None, '19-May-15', None, '1-Jun-15', '3-Jun-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC056', '0', 'CASA', 'ARBC056', 'ARB08CA0140', None, '08', None, None, '014', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '31-Jan-14', '31-Jan-14', '4-Aug-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00082590', 'GABRIELA CONTRERAS VILLEGAS', 'GABRIELA', 'CONTRERAS', 'VILLEGAS', 'COVG8304278U9', 'COVG830427MMCNLB05', '0', 'M', 'COVIGABY@HOTMAIL.COM', '5939141065', '7221078631', '25813700', '11058314284', '27-Apr-83', 'SOLTERO', None, 'MEXICANA', 'ESTADO DE MEXICO', None, '35', 'Suburbano', 'HIDALGO', '2', None, 'ACOLCO', 'TEOLOYUCAN', 'MEXICO', 'MEXICO', '54770', '20', 'EMPLEADA', '4509084629413', 'IFE', '30020114549', '0002794', None, '449043.50000', '449043.50000', '.00000', '.00000', '449043.50000', '.00000', '.00000', '51637.50000', '.00000', '-449043.50000', '51637.50000', '25-Apr-15', '20-Jun-15', '7-May-15', '26-Apr-15', '28-Apr-15', '12', None, '7-May-15', '7-May-15', '7-May-15', '7-May-15', '7-May-15', '6-May-15', '15-May-15', '15-May-15', None, '19-May-15', None, '14-Jul-15', '31-Jul-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC095', '0', 'CASA', 'ARBC095', 'ARB06CA0250', None, '06', None, None, '025', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00082614', 'JESSICA ANALI ALVAREZ RUIZ', 'JESSICA ANALI', 'ALVAREZ', 'RUIZ', 'AARJ020526929', 'AARJ860217MDFLZS09', '0', 'H', 'j_a_a_r_17@hotmail.com', '53806330', '5522006825', '36881534', None, '26-May-02', 'SOLTERO', None, 'MEXICANA', 'ESTADO DE MEXICO', None, '35', 'Suburbano', 'TECAMAC', '28', '8', 'LA SARDAÑA', 'TULTITLAN', 'MEXICO', 'MEXICO', '54950', '10', 'EMPLEADO', '5544100975430', 'IFE', '30020114770', '0002747', None, '468250.00000', '468250.00000', '.00000', '.00000', '468250.00000', '.00000', '.00000', '61750.00000', '.00000', '-468250.00000', '61750.00000', '26-Apr-15', '26-Apr-15', '26-Apr-15', '26-Apr-15', '28-Apr-15', '12', None, '30-Apr-15', '30-Apr-15', '30-Apr-15', '5-May-15', '5-May-15', '29-Apr-15', '12-Jun-15', '12-Jun-15', None, '18-Jun-15', None, '27-Jul-15', '7-Aug-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC215', '0', 'CASA', 'ARBC215', 'ARB07CA0250', None, '07', None, None, '025', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '24-Jan-14', '24-Jan-14', '28-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00082742', 'GABRIELA ZETINA MARTINEZ', 'GABRIELA', 'ZETINA', 'MARTINEZ', 'ZEMG871206FU4', 'ZEMG871206MDFTRB09', '0', 'M', 'gabriela.zetina@icloud.com', '53993958', '5540332300', '5560854120', '90068719104', '6-Dec-87', 'CASADO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '1', 'Impresos', 'MAR CANTABRICO', '26 B', '4', 'POPOTLA', 'MIGUEL HIDALGO', 'DISTRITO FEDERAL', 'MEXICO', '11400', '10', 'EMPLEADO', '5040105760346', 'IFE', '30020115991', '0002795', None, '505057.50000', '505057.50000', '.00000', '.00000', '505057.50000', '.00000', '.00000', '51637.50000', '.00000', '-505509.24000', '51185.76000', '1-May-15', '5-May-15', '7-May-15', '2-May-15', '4-May-15', '12', None, '7-May-15', '7-May-15', '7-May-15', '11-May-15', '11-May-15', '7-May-15', '27-May-15', '27-May-15', None, '4-Jun-15', None, '30-Jun-15', '24-Jul-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC094', '0', 'CASA', 'ARBC094', 'ARB06CA0260', None, '06', None, None, '026', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '2', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00082751', 'RAFAEL JIMENEZ BECERRA', 'RAFAEL', 'JIMENEZ', 'BECERRA', 'JIBR560213FS0', 'JIBR560213HDFMCF09', '0', 'H', 'rafael.jimenez@congreso.gob.mx', '58829320', '5535281497', '50360000', None, '13-Feb-56', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '35', 'Suburbano', '16 DE SEPTIEMBRE', '55', None, 'SAN LORENZO TETLIXTAC', 'COACALCO DE BERRIOZA', 'MEXICO', 'MEXICO', '55714', '10', 'EMPLEADO', '0601011405357', 'IFE', '30020116080', '0002796', None, '500000.00000', '500000.00000', '.00000', '.00000', '500000.00000', '.00000', '.00000', '49500.00000', '.00000', '-506500.00000', '43000.00000', '2-May-15', '2-May-15', '7-May-15', '2-May-15', '4-May-15', '12', None, '7-May-15', '7-May-15', '7-May-15', '11-May-15', '11-May-15', '6-May-15', '14-Aug-15', '14-Aug-15', None, '27-Aug-15', None, '22-Sep-15', '25-Sep-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC218', '0', 'CASA', 'ARBC218', 'ARB07CA0220', None, '07', None, None, '022', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '24-Jan-14', '24-Jan-14', '28-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00082793', 'MARISOL GARRIDO RAMIREZ', 'MARISOL', 'GARRIDO', 'RAMIREZ', 'GARM840921QL4', 'GARM840921MDFRMR03', '0', 'H', None, '58804162', '5519337759', None, '92028434501', '21-Sep-84', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '35', 'Suburbano', 'EDIFICIO L 4A', None, '404', 'INFONAVIT NORTE', 'CUAUTITLAN IZCALLI', 'MEXICO', 'MEXICO', '54720', '15', 'EMPLEADO', '0743085520516', 'IFE', '30020116619', '0002800', None, '440000.00000', '440000.00000', '.00000', '.00000', '440000.00000', '.00000', '.00000', '51637.50000', '.00000', '-440000.00000', '51637.50000', '3-May-15', '3-May-15', '5-May-15', '6-May-15', '6-May-15', '12', None, '11-May-15', '11-May-15', '11-May-15', '12-May-15', '12-May-15', '7-May-15', '27-May-15', '27-May-15', None, '17-Jun-15', None, '14-Sep-15', '25-Sep-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC041', '0', 'CASA', 'ARBC041', 'ARB08CA0160', None, '08', None, None, '016', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '31-Jan-14', '31-Jan-14', '4-Aug-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00082812', 'KARINA MONSERRAT TORRES RANGEL', 'KARINA MONSERRAT', 'TORRES', 'RANGEL', 'TORK890320FY0', 'TORK890320MDFRNR02', '0', 'H', None, '57348284', '5534229904', None, '96118913092', '20-Mar-89', 'CASADO', None, 'MEXICANA', 'MEXICO DISTRITO FEDERAL', None, '2', 'Volante', 'AV. TEXCOCO', '1268', 'COND. 13 C10201', 'U.H.SOLIDARIDAD', 'IZTAPALAPA', 'DISTRITO FEDERAL', 'MÉXICO', '09140', '14', 'EMPLEADO', '21231111146626', 'IFE', '30020116312', '0002805', None, '485795.00000', '485795.00000', '.00000', '.00000', '485795.00000', '.00000', '.00000', '51637.50000', '.00000', '-485795.00000', '51637.50000', '3-May-15', '3-May-15', '3-May-15', '3-May-15', '4-May-15', '12', None, '6-May-15', '13-May-15', '14-May-15', '15-May-15', '15-May-15', None, '27-May-15', '27-May-15', None, '4-Jun-15', None, '22-Jun-15', '24-Jul-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC206', '0', 'CASA', 'ARBC206', 'ARB07CA0340', None, '07', None, None, '034', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '24-Jan-14', '24-Jan-14', '28-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00082823', 'DIANA RODRIGUEZ ALATRISTE', 'DIANA', 'RODRIGUEZ', 'ALATRISTE', 'ROAD730425IE6', 'ROAD730425MDFDLN05', '0', 'M', 'diana.ralatriste@gmail.com', '5512877876', '5512877876', '57962124', None, '25-Apr-73', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '35', 'Suburbano', 'JULIAN ADAME', '9', None, 'CONSTITUCION DE 1917', 'IZTAPALAPA', 'DISTRITO FEDERAL', 'MEXICO', '09260', '10', 'EMPLEADA', '2305005070914', 'IFE', '30020116429', '0002797', None, '468250.00000', '468250.00000', '.00000', '.00000', '468250.00000', '.00000', '.00000', '61750.00000', '.00000', '-468250.00000', '61750.00000', '4-May-15', '6-May-15', '4-May-15', '4-May-15', '6-May-15', '12', None, '6-May-15', '7-May-15', '8-May-15', '11-May-15', '11-May-15', None, '12-Jun-15', '12-Jun-15', None, '10-Jul-15', None, '17-Aug-15', '22-Aug-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC208', '0', 'CASA', 'ARBC208', 'ARB07CA0320', None, '07', None, None, '032', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '24-Jan-14', '24-Jan-14', '28-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00082915', 'ANTONIO CANO SANCHEZ', 'ANTONIO', 'CANO', 'SANCHEZ', 'CASA8610304QA', 'CASA861030HPLNNN08', '0', 'H', 'kano_1701@yahoo.com.mx', '19417041', '5531260691', None, '65098605374', '30-Oct-86', 'SOLTERO', None, 'MEXICANA', 'PUEBLA', None, '35', 'Suburbano', 'DANIEL DELGADILLO', '105', '6', 'ROMITA', 'CUAUTITLAN', 'MEXICO', 'MEXICO', '54800', '10', 'EMPLEADO', '4632103863372', 'IFE', '30020117153', '0002812', None, '491262.50000', '491262.50000', '.00000', '.00000', '491262.50000', '.00000', '.00000', '51637.50000', '.00000', '-491262.50000', '51637.50000', '10-May-15', '10-May-15', '10-May-15', '10-May-15', '11-May-15', '12', None, '15-May-15', '15-May-15', '18-May-15', '18-May-15', '18-May-15', '14-May-15', '27-May-15', '27-May-15', None, '4-Jun-15', None, '23-Jun-15', '2-Jul-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC044', '0', 'CASA', 'ARBC044', 'ARB08CA0030', None, '08', None, None, '003', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '31-Jan-14', '31-Jan-14', '4-Aug-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00082916', 'MA DE LOS ANGELES DE ALVA FIESCO', 'MA DE LOS ANGELES', 'DE ALVA', 'FIESCO', 'AAFA620825EL1', 'AAFA620825MMCLSN05', '0', 'M', None, '5939141215', '5534614905', None, '11056200956', '25-Aug-62', 'SOLTERO', None, 'MEXICANA', 'ESTADO DE MEXICO', None, '35', 'Suburbano', 'CDA ESPERANZA', '1', None, 'BARR SANTIAGO', 'TEOLOYUCAN', 'MEXICO', 'MEXICO', '54770', '10', 'EMPLEADA', '4507084414878', 'IFE', '30020117179', '0002813', None, '555862.50000', '555862.50000', '.00000', '.00000', '555862.50000', '.00000', '.00000', '51637.50000', '.00000', '-555862.50000', '51637.50000', '10-May-15', '10-May-15', '10-May-15', '10-May-15', '11-May-15', '12', None, '15-May-15', '15-May-15', '15-May-15', '18-May-15', '18-May-15', '4-May-15', '4-Jun-15', '4-Jun-15', None, '15-Jun-15', None, '30-Jun-15', '9-Jul-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC043', '0', 'CASA', 'ARBC043', 'ARB08CA0040', None, '08', None, None, '004', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '31-Jan-14', '31-Jan-14', '4-Aug-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00083166', 'CESAR PEDRAZA MUÑOZ', 'CESAR', 'PEDRAZA', 'MUÑOZ', 'PEMC710219A79', 'PEMC710219HHGDXS09', '0', 'H', 'PEDRAZAMC@HOTMAIL.COM', '57823198', '5516529007', '52784930', '30047100349', '19-Feb-71', 'SOLTERO', None, 'MEXICANA', 'HIDALGO', None, '35', 'Suburbano', 'REEMBOLSOS', '101', None, 'POSTAL', 'BENITO JUAREZ', 'DISTRITO FEDERAL', 'MEXICO', '03410', '8', 'EMPLEADO', '4303071171661', 'IFE', '30020119498', '0002852', None, '500000.00000', '500000.00000', '.00000', '.00000', '500000.00000', '.00000', '.00000', '51637.50000', '.00000', '-500000.00000', '51637.50000', '24-May-15', '24-May-15', '24-May-15', '24-May-15', '25-May-15', '12', None, '27-May-15', '28-May-15', '28-May-15', '29-May-15', '29-May-15', None, '30-Jun-15', '30-Jun-15', None, '8-Jul-15', None, '17-Jul-15', '24-Jul-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC063', '0', 'CASA', 'ARBC063', 'ARB08CA0170', None, '08', None, None, '017', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '31-Jan-14', '31-Jan-14', '4-Aug-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00083330', 'MARCOS GUSTAVO MONTAÑO SOLIS', 'MARCOS GUSTAVO', 'MONTAÑO', 'SOLIS', 'MOSM810802LM7', 'MOSM810802HDFNLR04', '0', 'H', 'MARCOS_MONTANO@DELL.COM', '26705114', '5543520935', '65794885', '92048102385', '2-Aug-81', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '35', 'Suburbano', 'IGNACIO RAMIREZ', '404', None, 'EL HUERTO', 'CUAUTITLAN', 'MEXICO', 'MEXICO', '54807', '8', 'EMPLEADO', '0679136817050', 'IFE', '30020120983', '0002889', None, '564819.00000', '564819.00000', '.00000', '.00000', '564819.00000', '.00000', '.00000', '.00000', '.00000', '-589981.63000', '-25162.63000', '31-May-15', '31-May-15', '31-May-15', '31-May-15', '1-Jun-15', '12', None, '1-Jun-15', '1-Jun-15', '1-Jun-15', '3-Jun-15', '3-Jun-15', None, '10-Jul-15', '10-Jul-15', None, '14-Jul-15', None, '25-Sep-15', '5-Oct-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC107', '0', 'CASA', 'ARBC107', 'ARB05CA0270', None, '05', None, None, '027', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '29-Nov-13', '29-Nov-13', '2-Jun-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00083438', 'JOSE ALEJANDRO GUTIERREZ ORTIZ', 'JOSE ALEJANDRO', 'GUTIERREZ', 'ORTIZ', 'GUOA8702165V7', 'GUOA870216HMCTRL09', '0', 'H', 'ALEX870216@HOTMAIL.COM', '58690206', '5537333527', None, '94088724136', '16-Feb-87', 'SOLTERO', None, 'MEXICANA', 'ESTADO DE MEXICO', None, '0', None, 'IGNACIO LOPEZ RAYON', '26', None, 'UNIDAD MORELOS 2 SECCION', 'TULTITLAN', 'ESTADO DE MEXICO', 'MEXICO', '54930', '5', 'EMPLEADO', '5586103665008', 'IFE', '30020121809', '0003140', None, '450759.49000', '450759.49000', '.00000', '.00000', '450759.49000', '.00000', '.00000', '.00000', '25006.43000', '-475765.92000', '.00000', '4-Jun-15', '31-Jul-15', '1-Aug-15', '31-Jul-15', '3-Aug-15', '12', None, '5-Aug-15', '5-Aug-15', '6-Aug-15', '7-Aug-15', '7-Aug-15', None, '3-Sep-15', '3-Sep-15', None, '9-Sep-15', None, '17-Sep-15', '25-Sep-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC209', '0', 'CASA', 'ARBC209', 'ARB07CA0310', None, '07', None, None, '031', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '24-Jan-14', '24-Jan-14', '28-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00083507', 'MIGUEL ANGEL MORA FLORES', 'MIGUEL ANGEL', 'MORA', 'FLORES', 'MOFM840929TA2', 'MOFM840929HDFRLG06', '0', 'H', 'SANDRA.BRIGIDO.FUENTES@HOTMAIL.COM', '5558160101', '5521971807', '5561160922', '90038431525', '29-Sep-84', 'CASADO', 'SOCIEDAD CONYUGAL', 'MEXICANO', 'DISTRITO FEDERAL', None, '6', 'Lonas', 'TUXPAN', '5', '3', '5 3', 'TLALNEPANTLA DE BAZ', 'MEXICO', 'MEXICO', '52990', '8', 'EMPLEADO', '0250085379823', 'IFE', '30020123714', '0002978', None, '548362.50000', '548362.50000', '.00000', '.00000', '548362.50000', '.00000', '.00000', '51637.50000', '.00000', '-574094.91000', '25905.09000', '7-Jun-15', '22-Jun-15', '22-Jun-15', '14-Jun-15', '15-Jun-15', '12', None, '24-Jun-15', '24-Jun-15', '24-Jun-15', '25-Jun-15', '25-Jun-15', '23-Jun-15', '3-Aug-15', '3-Aug-15', None, '6-Aug-15', None, '13-Aug-15', '22-Aug-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC066', '0', 'CASA', 'ARBC066', 'ARB06CA0130', None, '06', None, None, '013', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00083677', 'ALEJANDRO VELASCO CHAVEZ', 'ALEJANDRO', 'VELASCO', 'CHAVEZ', 'VECA630502BQ4', 'VECA630502HDFLHL05', '0', 'H', 'ALEJANDRO.VELASCOC@IMSSS.GOB.MX', '22393981', '5511960888', '5537196981', '89816340866', '2-May-63', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '2', 'Volante', 'FRANCISCO SARAVIA', '30', None, 'BENITO JUAREZ', 'TULTITLAN', 'ESTADO DE MEXICO', 'MEXICO', '54940', '4', 'EMPLEADO', '0683083197043', 'IFE', '30020123425', '0002961', None, '514463.61000', '514463.61000', '.00000', '.00000', '514463.61000', '.00000', '.00000', '.00000', '.00000', '-535872.57000', '-21408.96000', '13-Jun-15', '13-Jun-15', '16-Jun-15', '13-Jun-15', '16-Jun-15', '12', None, '18-Jun-15', '18-Jun-15', '18-Jun-15', '19-Jun-15', '19-Jun-15', None, '10-Jul-15', '10-Jul-15', None, '1-Sep-15', None, '29-Sep-15', '5-Oct-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC058', '0', 'CASA', 'ARBC058', 'ARB08CA0150', None, '08', None, None, '015', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '31-Jan-14', '31-Jan-14', '4-Aug-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00084268', 'HECTOR ALBERTO MORALES MERCADO', 'HECTOR ALBERTO', 'MORALES', 'MERCADO', 'MOMH800521C01', 'MOMH800521HDFRRC01', '0', 'H', 'HMORALES@SEZIMAG.COM.MX', '63089478', '5521707932', '53173410', '92978014360', '21-May-80', 'CASADO', 'BIENES MANCOMUNADOS', 'MEXICANA', 'DISTRITO FEDERAL', None, '66', 'Recomedación', 'AV 1 DE MAYO', 'EDIF J 10', 'DEPTO 101', 'INFONAVIT CENTRO', 'CUAUTITLAN IZCALLI', 'MEXICO', 'MEXICO', '54763', '30', 'EMPLEADO', '0836083424657', 'IFE', '30020129034', '0003069', None, '544201.40000', '544201.40000', '.00000', '.00000', '544201.40000', '.00000', '.00000', '51637.50000', '.00000', '-550473.30000', '45365.60000', '12-Jul-15', '12-Jul-15', '12-Jul-15', '12-Jul-15', '13-Jul-15', '12', None, '15-Jul-15', '16-Jul-15', '16-Jul-15', '17-Jul-15', '17-Jul-15', None, '3-Aug-15', '3-Aug-15', None, '10-Aug-15', None, '13-Aug-15', '22-Aug-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC092', '0', 'CASA', 'ARBC092', 'ARB06CA0280', None, '06', None, None, '028', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00084319', 'GABRIELA LIZET DE LEON SORIA', 'GABRIELA LIZET', 'DE LEON', 'SORIA', 'LESG800715CP8', 'LESG800715MDFNRB09', '0', 'M', 'H3RMOSHA@GMAIL.COM', '57793989', '5522723719', None, None, '15-Jul-80', 'CASADO', 'SOCIEDAD CONYUGAL', 'MEXICANA', 'DISTRITO FEDERAL', None, '128', 'SUBURBANO', 'ANDADOR 4', 'MANZANA 1', 'LOTE 6 INTERIOR 102', 'PETROQUIMICA FEDERACION', 'ECATEPEC', 'MEXICO', 'MEXICO', '55249', '10', 'EMPLEADO', 'G07278546', 'PASAPORTE', '30020129307', '0003086', None, '481902.00000', '481902.00000', '.00000', '.00000', '481902.00000', '.00000', '.00000', '61750.00000', '.00000', '-481902.29000', '61749.71000', '13-Jul-15', '17-Jul-15', '13-Jul-15', '13-Jul-15', '14-Jul-15', '12', None, '18-Jul-15', '18-Jul-15', '21-Jul-15', '23-Jul-15', '23-Jul-15', '16-Jul-15', '7-Aug-15', '7-Aug-15', None, '10-Aug-15', None, '20-Aug-15', '28-Aug-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC100', '0', 'CASA', 'ARBC100', 'ARB05CA0240', None, '05', None, None, '024', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '2', '1', '552,019.50 ', '1,500.00 ', '0.00 ', '0.00 ', '29-Nov-13', '29-Nov-13', '2-Jun-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00084539', 'JULIO CESAR GARCIA ISLAS', 'JULIO CESAR', 'GARCIA', 'ISLAS', 'GAIJ841023947', 'GAIJ841023HDFRSL00', '0', 'H', 'KARI_LIZ_9@HOTMAIL.COM', '55772750', '5534879723', None, '20038409569', '23-Oct-84', 'CASADO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '123', 'CLIENTES', 'AVE MORELOS', '1', None, 'SANTA ISABEL TOLA', 'GUSTAVO A.MADERO', 'DISTRITO FEDERAL', 'MEXICO', '07010', '10', 'REPARTIDOR', '022', 'IFE', '30020131527', '0003136', None, '502019.50000', '502019.50000', '.00000', '.00000', '502019.50000', '.00000', '.00000', '.00000', '50480.34000', '-553990.74000', '-1490.90000', '25-Jul-15', '3-Aug-15', '31-Jul-15', '31-Jul-15', '3-Aug-15', '12', None, '4-Aug-15', '4-Aug-15', '4-Aug-15', '5-Aug-15', '5-Aug-15', '3-Aug-15', '3-Sep-15', '3-Sep-15', None, '9-Sep-15', None, '17-Sep-15', '25-Sep-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC073', '0', 'CASA', 'ARBC073', 'ARB06CA0140', None, '06', None, None, '014', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564,819.00 ', '1,500.00 ', '0.00 ', '0.00 ', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00084962', 'BEATRIZ JUAREZ ORTEGA', 'BEATRIZ', 'JUAREZ', 'ORTEGA', 'JUOB8110061Y0', 'JUOB811006MDFRRT06', '0', 'H', 'BJUAREZORTEGA@YAHOO.COM.MX', '5557752349', '5533555860', '5551303900', '39998140543', '6-Oct-81', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '55', 'Expo Tu Casa Total (WTC)', 'FLORES MEXICANAS', '132', None, 'BENITO JUAREZ', 'NEZAHUALCOYOTL', 'ESTADO DE MEXICO', 'MEXICO', '57000', '20', 'CORRESPONSAL DE CREDITO Y COBRANZA', '34664115983260', 'IFE', '30020133937', '0003193', None, '450000.00000', '450000.00000', '.00000', '.00000', '450000.00000', '.00000', '.00000', '.00000', '26266.00000', '-476266.00000', '.00000', '13-Aug-15', '20-Aug-15', '19-Aug-15', '20-Aug-15', '20-Aug-15', '12', None, '21-Aug-15', '21-Aug-15', '24-Aug-15', '24-Aug-15', '24-Aug-15', None, '9-Sep-15', '9-Sep-15', None, '15-Sep-15', None, '1-Oct-15', '5-Oct-15', None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC095', '0', 'CASA', 'ARBC095', 'ARB06CA0250', None, '06', None, None, '025', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564819', '1500', '0', '0', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'CANCELADO', '014-REUBICACION', 'PV00079991', 'FIDEL CALTENCO CASIQUE', 'FIDEL', 'CALTENCO', 'CASIQUE', 'CACF651213323', 'CACF651213HPLLSD03', '1', None, 'ficaltenco@gmail.com', None, None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'NEZAHUALCOYOTL', None, 'Mexico', None, '0', None, None, None, '30010179965', 'SI000010797', 'DEV000001175', '622000.00000', '622000.00000', '.00000', '.00000', '622000.00000', '-622000.00000', '-622000.00000', '.00000', '.00000', '-992.00000', '-992.00000', '1-Jan-00', '12-Mar-15', '23-Jan-15', '23-Jan-15', '23-Jan-15', '0', None, '23-Jan-15', '23-Jan-15', '23-Jan-15', '23-Jan-15', '23-Jan-15', None, None, None, None, None, '13-Mar-15', None, None, 'REUBICACION POR COMODIDAD'), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC100', '0', 'CASA', 'ARBC100', 'ARB05CA0240', None, '05', None, None, '024', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '2', '1', '552019.5', '1500', '0', '0', '29-Nov-13', '29-Nov-13', '2-Jun-13', 'LIBERADO', 'INACTIVO', 'CANCELADO', '015-CESION DE DERECHOS', 'PV00068480', 'ALMA PATRICIA SALINAS LOZANO', 'ALMA PATRICIA', 'SALINAS', 'LOZANO', 'SALA870120UIA', 'SALA870120MMCLZL04', '1', None, 'paty_verumu@hotmail.com', '58767091', None, '5542223942', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LAS ANIMAS', 'TEPOTZOTLÁN MEX', 'MEX', 'Mexico', '54616', '0', None, None, None, '30000028776', 'SI000004850', 'DEV000001191', '552019.50000', '552019.50000', '.00000', '.00000', '552019.50000', '-552019.50000', '-552019.50000', '.00000', '.00000', '21248.00000', '21248.00000', '15-Jan-15', '15-Jan-15', '10-Jun-14', '10-Jun-14', '10-Jun-14', '0', None, '10-Jun-14', '10-Jun-14', '10-Jun-14', '10-Jun-14', '10-Jun-14', None, '23-Jun-14', '23-Jun-14', None, '27-Jun-14', '30-Mar-15', None, None, 'CESION DE DERECHOS'), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC180', '0', 'CASA', 'ARBC180', 'ARB01CA0210', None, '01', None, None, '021', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549678', '1500', '0', '0', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00024518', 'MARTHA HERNANDEZ CHAVERO', 'MARTHA', 'HERNANDEZ', 'CHAVERO', 'HECM770729', None, '1', None, None, '5534502531', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'JARDIN AZPEITIA', 'AZCAPOTZALCO DF', 'DF', 'Mexico', None, '0', None, None, None, '30000008885', 'SI000001132', 'DEV000000250', '482000.00000', '482000.00000', '.00000', '.00000', '482000.00000', '-482000.00000', '-482000.00000', '.00000', '.00000', '-3060.00000', '-3060.00000', '1-Jan-00', '19-Jun-15', '17-Oct-12', '17-Oct-12', '17-Oct-12', '0', None, '17-Oct-12', '17-Oct-12', '17-Oct-12', '17-Oct-12', '17-Oct-12', None, None, None, None, None, '10-May-13', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC179', '0', 'CASA', 'ARBC179', 'ARB01CA0200', None, '01', None, None, '020', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549678', '1500', '0', '0', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00025595', 'KATYA ANGELICA PEREZ CANTU', 'KATYA ANGELICA', 'PEREZ', 'CANTU', 'PECK800929QR8', 'PECK800929MDFRNT01', '1', None, None, '55476142', '54887000', '5511477416', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'CAPULTITLAN', 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07370', '0', None, None, None, '30000009313', 'SI000001156', 'DEV000000238', '457778.37000', '457778.37000', '.00000', '.00000', '457778.37000', '-457778.37000', '-457778.37000', '.00000', '.00000', '-3000.00000', '-3000.00000', '1-Jan-00', '19-Jun-15', '24-Oct-12', '24-Oct-12', '24-Oct-12', '0', None, '24-Oct-12', '24-Oct-12', '24-Oct-12', '24-Oct-12', '24-Oct-12', None, None, None, None, None, '24-Apr-13', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC161', '0', 'CASA', 'ARBC161', 'ARB01CA0020', None, '01', None, None, '002', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549678', '1500', '0', '0', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00025603', 'CLAUDIA VELASCO ROSAS', 'CLAUDIA', 'VELASCO', 'ROSAS', 'VERC550215', None, '1', None, None, '5532329303', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PARQUE SAN MATEO', None, 'MEX', 'Mexico', '54820', '0', None, None, None, '30000009339', 'SI000001214', 'DEV000000405', '506660.00000', '506660.00000', '.00000', '.00000', '506660.00000', '-506660.00000', '-506660.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '30-Nov-12', '30-Nov-12', '30-Nov-12', '0', None, '30-Nov-12', '30-Nov-12', '30-Nov-12', '30-Nov-12', '30-Nov-12', None, None, None, None, None, '11-Nov-13', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC164', '0', 'CASA', 'ARBC164', 'ARB01CA0050', None, '01', None, None, '005', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549678', '1500', '0', '0', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00026260', 'ELIEZER SARIÑANA PAREDES', 'ELIEZER', 'SARIÑANA', 'PAREDES', 'SAPE650320', 'SAPE650520HDFRRL06', '1', None, 'esarinana@innovador.com.mx', '91481639', '91717100', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'VILLAS DE LA HACIENDA', 'ATIZAPÁN ZARAGOZA MEX', 'MEX', 'Mexico', '52929', '0', None, None, None, '30000009586', 'SI000001205', 'DEV000000494', '447676.13000', '447676.13000', '.00000', '.00000', '447676.13000', '-447676.13000', '-447676.13000', '.00000', '.00000', '-1500.00000', '-1500.00000', '15-Jan-15', '15-Jan-15', '28-Nov-12', '28-Nov-12', '28-Nov-12', '0', None, '28-Nov-12', '28-Nov-12', '28-Nov-12', '28-Nov-12', '28-Nov-12', None, None, None, None, None, '13-Dec-13', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC172', '0', 'CASA', 'ARBC172', 'ARB01CA0130', None, '01', None, None, '013', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549678', '1500', '0', '0', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00026267', 'IVAN JAVIER PEREZ MONROY', 'IVAN JAVIER', 'PEREZ', 'MONROY', 'PEMI8703181J3', 'PEMI870318HDFRNV09', '1', None, 'ivan.perez@hotmail.com', '20645132', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'GALAXIA CUAUTITLAN', 'CUAUTITLÁN MEX', 'MEX', 'Mexico', '54840', '0', None, None, None, '30000009602', 'SI000001311', 'DEV000000319', '432000.00000', '432000.00000', '.00000', '.00000', '432000.00000', '-432000.00000', '-432000.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '20-Dec-12', '20-Dec-12', '20-Dec-12', '0', None, '20-Dec-12', '20-Dec-12', '20-Dec-12', '20-Dec-12', '20-Dec-12', None, None, None, None, None, '17-Sep-13', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC139', '0', 'CASA', 'ARBC139', 'ARB02CA0120', None, '02', None, None, '012', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549678', '1500', '0', '0', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00026796', 'OLGA MARGARITA VAZQUEZ FIGUEROA', 'OLGA MARGARITA', 'VAZQUEZ', 'FIGUEROA', 'VAFO680209', None, '1', None, None, '49976706', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'KJB', 'MÚZQUIZ COAH', 'COAH', 'Mexico', None, '0', None, None, None, '30000009768', 'SI000001494', 'DEV000000572', '442000.00000', '442000.00000', '.00000', '.00000', '442000.00000', '-442000.00000', '-442000.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '23-Jan-13', '23-Jan-13', '23-Jan-13', '0', None, '23-Jan-13', '23-Jan-13', '23-Jan-13', '23-Jan-13', '23-Jan-13', None, None, None, None, None, '21-Feb-14', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC029', '0', 'CASA', 'ARBC029', 'ARB04CA0320', None, '04', None, None, '032', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535678', '1500', '0', '0', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00027106', 'ADRIAN SANCHEZ MORALES', 'ADRIAN', 'SANCHEZ', 'MORALES', 'SAMA840612', None, '1', None, None, '40777593', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'COYOACÁN DF', None, 'Mexico', None, '0', None, None, None, '30000009859', 'SI000002921', 'DEV000000472', '483667.53000', '483667.53000', '.00000', '.00000', '483667.53000', '-483667.53000', '-483667.53000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '22-Oct-13', '22-Oct-13', '22-Oct-13', '0', None, '22-Oct-13', '22-Oct-13', '22-Oct-13', '22-Oct-13', '22-Oct-13', None, None, None, None, None, '5-Dec-13', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC227', '0', 'CASA', 'ARBC227', 'ARB03CA0180', None, '03', None, None, '018', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549678', '1500', '0', '0', '30-Mar-13', '30-Mar-13', '1-Oct-12', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00028392', 'ALEJANDRO MENDEZ HERNANDEZ', 'ALEJANDRO', 'MENDEZ', 'HERNANDEZ', 'MEHA650328CN2', 'MEHA650328HVZNRL04', '1', None, None, '37291235', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'NAUCALPAN JUÁREZ MEX', None, 'Mexico', None, '0', None, None, None, '30000010220', 'SI000002607', 'DEV000000495', '519677.25000', '519677.25000', '.00000', '.00000', '519677.25000', '-519677.25000', '-519677.25000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '20-Aug-13', '20-Aug-13', '20-Aug-13', '0', None, '20-Aug-13', '20-Aug-13', '20-Aug-13', '20-Aug-13', '20-Aug-13', None, None, None, None, None, '13-Dec-13', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC175', '0', 'CASA', 'ARBC175', 'ARB01CA0160', None, '01', None, None, '016', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549678', '1500', '0', '0', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00028760', 'JULIETA ALONSO VAZQUEZ', 'JULIETA', 'ALONSO', 'VAZQUEZ', 'AOVJ7107', None, '1', None, None, '5534119121', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'JARDIN DE SANTA CLARA , ECATEP', 'ECATEPEC MORELOS MEX', 'MEX', 'Mexico', '55450', '0', None, None, None, '30000010394', 'SI000001568', 'DEV000000284', '433160.00000', '433160.00000', '.00000', '.00000', '433160.00000', '-433160.00000', '-433160.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '31-Jan-13', '31-Jan-13', '31-Jan-13', '0', None, '31-Jan-13', '31-Jan-13', '31-Jan-13', '31-Jan-13', '31-Jan-13', None, None, None, None, None, '21-Aug-13', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC140', '0', 'CASA', 'ARBC140', 'ARB02CA0130', None, '02', None, None, '013', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549678', '1500', '0', '0', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00030754', 'JUANA MARIA PEREZ SIERRA', 'JUANA MARIA', 'PEREZ', 'SIERRA', 'PESJ771222', None, '1', None, None, '59185080', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LUIS ECHEVERRIA', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54760', '0', None, None, None, '30000011624', 'SI000001636', 'DEV000000383', '419500.00000', '419500.00000', '.00000', '.00000', '419500.00000', '-419500.00000', '-419500.00000', '.00000', '.00000', '-6000.00000', '-6000.00000', '1-Jan-00', '19-Jun-15', '7-Feb-13', '7-Feb-13', '7-Feb-13', '0', None, '7-Feb-13', '7-Feb-13', '7-Feb-13', '7-Feb-13', '7-Feb-13', None, None, None, None, None, '28-Oct-13', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC141', '0', 'CASA', 'ARBC141', 'ARB02CA0140', None, '02', None, None, '014', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549678', '1500', '0', '0', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00032422', 'RUTH MIDORY ESCALANTE HURTADO SIERRA', 'RUTH MIDORY', 'ESCALANTE', 'HURTADO SIERRA', 'EAHR701012', None, '1', None, None, '58781977', None, '5531940446', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'MELCHOR OCAMPO', 'MELCHOR OCAMPO MEX', 'MEX', 'Mexico', '54880', '0', None, None, None, '30000012408', 'SI000001570', 'DEV000000215', '442000.00000', '442000.00000', '.00000', '.00000', '442000.00000', '-442000.00000', '-442000.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '31-Jan-13', '31-Jan-13', '31-Jan-13', '0', None, '31-Jan-13', '31-Jan-13', '31-Jan-13', '31-Jan-13', '31-Jan-13', None, None, None, None, None, '14-Mar-13', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC146', '0', 'CASA', 'ARBC146', 'ARB02CA0040', None, '02', None, None, '004', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549678', '1500', '0', '0', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00032664', 'ENRIQUE TOMAS RAFAEL', 'ENRIQUE', 'TOMAS', 'RAFAEL', 'TORE761104', None, '1', None, 'enriquetr@hotmail.com', '20371723', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LOMAS VEREDES SOLIDARIDAD', 'TULTITLÁN MEX', 'MEX', 'Mexico', '54901', '0', None, None, None, '30000012580', 'SI000001537', 'DEV000000878', '442000.00000', '442000.00000', '.00000', '.00000', '442000.00000', '-442000.00000', '-442000.00000', '.00000', '.00000', '-500.00000', '-500.00000', '15-Jan-15', '15-Jan-15', '30-Jan-13', '30-Jan-13', '30-Jan-13', '0', None, '30-Jan-13', '30-Jan-13', '30-Jan-13', '30-Jan-13', '30-Jan-13', None, None, None, None, None, '3-Oct-14', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC180', '0', 'CASA', 'ARBC180', 'ARB01CA0210', None, '01', None, None, '021', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549678', '1500', '0', '0', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00036886', 'JORGE GARITA RUVALCABA', 'JORGE', 'GARITA', 'RUVALCABA', 'GARJ750611', None, '1', None, None, '58782123', '55877966', '5540445543', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LOS ALAMOS', 'BENITO JUÁREZ DF', 'DF', 'Mexico', '03400', '0', None, None, None, '30000014255', 'SI000002272', 'DEV000000428', '487490.00000', '487490.00000', '.00000', '-11890.00000', '475600.00000', '-475600.00000', '-475600.00000', '.00000', '.00000', '-500.00000', '-500.00000', '1-Jan-00', '19-Jun-15', '10-May-13', '10-May-13', '10-May-13', '0', None, '10-May-13', '10-May-13', '10-May-13', '10-May-13', '10-May-13', None, None, None, None, None, '15-Nov-13', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC031', '0', 'CASA', 'ARBC031', 'ARB04CA0110', None, '04', None, None, '011', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535678', '1500', '0', '0', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00040206', 'CAROLINA PEÑA BEZARES', 'CAROLINA', 'PEÑA', 'BEZARES', 'PEBC790207', 'PEBC790207MDFX7R03', '1', None, None, '58801310', '53404600', '58801310', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BOSQUES DE LA HACIENDA', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', None, '0', None, None, None, '30000015609', 'SI000002197', 'DEV000000480', '483831.88000', '483831.88000', '.00000', '.00000', '483831.88000', '-483831.88000', '-483831.88000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '24-Apr-13', '24-Apr-13', '24-Apr-13', '0', None, '24-Apr-13', '24-Apr-13', '24-Apr-13', '24-Apr-13', '24-Apr-13', None, None, None, None, None, '6-Dec-13', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC141', '0', 'CASA', 'ARBC141', 'ARB02CA0140', None, '02', None, None, '014', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549678', '1500', '0', '0', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00044096', 'LUIS OCTAVIO SANCHEZ SANCHEZ', 'LUIS OCTAVIO', 'SANCHEZ', 'SANCHEZ', 'SASL830206FZ1', 'SASL830206HDFNNS01', '1', None, 'luis-meteorix@hotmail.com', '31376115', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN JOSE BUENAVISTA', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54710', '0', None, None, None, '30000016797', 'SI000002439', 'DEV000000739', '509677.25000', '509677.25000', '.00000', '.00000', '509677.25000', '-509677.25000', '-509677.25000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '28-Jun-13', '28-Jun-13', '28-Jun-13', '0', None, '28-Jun-13', '28-Jun-13', '28-Jun-13', '28-Jun-13', '28-Jun-13', None, None, None, None, None, '13-Jun-14', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC015', '0', 'CASA', 'ARBC015', 'ARB04CA0140', None, '04', None, None, '014', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535678', '1500', '0', '0', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00045966', 'ALICIA PADILLA LUNA', 'ALICIA', 'PADILLA', 'LUNA', 'PALA710308', None, '1', None, None, '57187398', '65487576', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'TLALNEPANTLA MEX', None, 'Mexico', None, '0', None, None, None, '30000017308', 'SI000002821', 'DEV000000429', '446393.79000', '446393.79000', '.00000', '.00000', '446393.79000', '-446393.79000', '-446393.79000', '.00000', '.00000', '-250.00000', '-250.00000', '1-Jan-00', '19-Jun-15', '2-Oct-13', '2-Oct-13', '2-Oct-13', '0', None, '2-Oct-13', '2-Oct-13', '2-Oct-13', '2-Oct-13', '2-Oct-13', None, None, None, None, None, '15-Nov-13', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC052', '0', 'CASA', 'ARBC052', 'ARB04CA0090', None, '04', None, None, '009', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535678', '1500', '0', '0', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00047517', 'MIGUEL ANGEL ANCELMO DE JESUS', 'MIGUEL ANGEL', 'ANCELMO', 'DE JESUS', 'AEJM760424', None, '1', None, None, None, None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PETROLERA', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '12000', '0', None, None, None, '30000017779', 'SI000002608', 'DEV000000740', '485677.67000', '485677.67000', '.00000', '.00000', '485677.67000', '-485677.67000', '-485677.67000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '20-Aug-13', '20-Aug-13', '20-Aug-13', '0', None, '20-Aug-13', '20-Aug-13', '20-Aug-13', '20-Aug-13', '20-Aug-13', None, None, None, None, None, '13-Jun-14', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC004', '0', 'CASA', 'ARBC004', 'ARB04CA0250', None, '04', None, None, '025', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535678', '1500', '0', '0', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00048064', 'JOEL VAZQUEZ HERNANDEZ', 'JOEL', 'VAZQUEZ', 'HERNANDEZ', 'VAHJ670523FD9', 'VAHJ670523HDFZRL08', '1', None, None, None, None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'VENUSTIANO CARRANZA DF', None, 'Mexico', None, '0', None, None, None, '30000017928', 'SI000003226', 'DEV000000523', '485964.12000', '485964.12000', '.00000', '.00000', '485964.12000', '-485964.12000', '-485964.12000', '.00000', '.00000', '-3000.00000', '-3000.00000', '1-Jan-00', '19-Jun-15', '4-Dec-13', '4-Dec-13', '4-Dec-13', '0', None, '4-Dec-13', '4-Dec-13', '4-Dec-13', '4-Dec-13', '4-Dec-13', None, None, None, None, None, '20-Jan-14', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC039', '0', 'CASA', 'ARBC039', 'ARB04CA0130', None, '04', None, None, '013', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535678', '1500', '0', '0', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00048122', 'EDGAR MUÑOZ BAEZ', 'EDGAR', 'MUÑOZ', 'BAEZ', 'MUBE860216ET6', 'MUBE860216HDFXZD05', '1', None, None, '5528995955', '58713053', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'ATLANTA 1A SECCION', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54740', '0', None, None, None, '30000017951', 'SI000002757', 'DEV000000481', '495677.67000', '495677.67000', '.00000', '.00000', '495677.67000', '-495677.67000', '-495677.67000', '.00000', '.00000', '-500.00000', '-500.00000', '1-Jan-00', '19-Jun-15', '12-Sep-13', '12-Sep-13', '12-Sep-13', '0', None, '12-Sep-13', '12-Sep-13', '12-Sep-13', '12-Sep-13', '12-Sep-13', None, None, None, None, None, '6-Dec-13', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC128', '0', 'CASA', 'ARBC128', 'ARB05CA0290', None, '05', None, None, '029', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549819', '1500', '0', '0', '29-Nov-13', '29-Nov-13', '2-Jun-13', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00048122', 'EDGAR MUÑOZ BAEZ', 'EDGAR', 'MUÑOZ', 'BAEZ', 'MUBE860216ET6', 'MUBE860216HDFXZD05', '1', None, None, '5528995955', '58713053', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'ATLANTA 1A SECCION', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54740', '0', None, None, None, '30000017969', 'SI000003537', 'DEV000000549', '495313.14000', '495313.14000', '.00000', '.00000', '495313.14000', '-495313.14000', '-495313.14000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '20-Jan-14', '20-Jan-14', '20-Jan-14', '0', None, '20-Jan-14', '20-Jan-14', '20-Jan-14', '20-Jan-14', '20-Jan-14', None, None, None, None, None, '10-Feb-14', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC175', '0', 'CASA', 'ARBC175', 'ARB01CA0160', None, '01', None, None, '016', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549678', '1500', '0', '0', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00049041', 'ARELI HERNANDEZ MEDINA', 'ARELI', 'HERNANDEZ', 'MEDINA', 'HEMA890209', None, '1', None, None, '64241032', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'ALAMOS 1', 'MELCHOR OCAMPO MEX', 'MEX', 'Mexico', '54890', '0', None, None, None, '30000018223', 'SI000002664', 'DEV000000348', '479677.25000', '479677.25000', '.00000', '.00000', '479677.25000', '-479677.25000', '-479677.25000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '31-Aug-13', '31-Aug-13', '31-Aug-13', '0', None, '31-Aug-13', '31-Aug-13', '31-Aug-13', '31-Aug-13', '31-Aug-13', None, None, None, None, None, '2-Oct-13', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC152', '0', 'CASA', 'ARBC152', 'ARB03CA0060', None, '03', None, None, '006', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549678', '1500', '0', '0', '30-Mar-13', '30-Mar-13', '1-Oct-12', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00050390', 'NATALY AGUILAR CRUZ', 'NATALY', 'AGUILAR', 'CRUZ', 'AUCN831013', None, '1', None, 'naguilar_13@hotmail.com', '57922615', '5544862726', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'METROPOLITANA 2A SECC', 'NEZAHUALCÓYOTL MEX', 'MEX', 'Mexico', '57730', '0', None, None, None, '30000018728', 'SI000002819', 'DEV000000479', '469177.25000', '469177.25000', '.00000', '.00000', '469177.25000', '-469177.25000', '-469177.25000', '.00000', '.00000', '-500.00000', '-500.00000', '15-Jan-15', '15-Jan-15', '2-Oct-13', '2-Oct-13', '2-Oct-13', '0', None, '2-Oct-13', '2-Oct-13', '2-Oct-13', '2-Oct-13', '2-Oct-13', None, None, None, None, None, '6-Dec-13', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC053', '0', 'CASA', 'ARBC053', 'ARB04CA0080', None, '04', None, None, '008', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535678', '1500', '0', '0', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00050473', 'OSWALDO SINHUE LEGORRETA BARRON', 'OSWALDO SINHUE', 'LEGORRETA', 'BARRON', 'LEBO760725NZ8', 'LEBO760725HDFGRS09', '1', None, None, '56954535', '5521386621', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'CTM V', 'COYOACÁN DF', 'DF', 'Mexico', '04440', '0', None, None, None, '30000018751', 'SI000002931', 'DEV000000515', '479991.22000', '479991.22000', '.00000', '.00000', '479991.22000', '-479991.22000', '-479991.22000', '.00000', '.00000', '36.28000', '36.28000', '1-Jan-00', '19-Jun-15', '24-Oct-13', '24-Oct-13', '24-Oct-13', '0', None, '24-Oct-13', '24-Oct-13', '24-Oct-13', '24-Oct-13', '24-Oct-13', None, None, None, None, None, '10-Jan-14', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC172', '0', 'CASA', 'ARBC172', 'ARB01CA0130', None, '01', None, None, '013', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549678', '1500', '0', '0', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00050745', 'MARIA MERCEDES DELGADO FLORES', 'MARIA MERCEDES', 'DELGADO', 'FLORES', 'DEFM540615', None, '1', None, None, '49938695', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'VALLEJO', 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07870', '0', None, None, None, '30000018850', 'SI000002794', 'DEV000000382', '459677.25000', '459677.25000', '.00000', '.00000', '459677.25000', '-459677.25000', '-459677.25000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '1-Oct-13', '1-Oct-13', '1-Oct-13', '0', None, '1-Oct-13', '1-Oct-13', '1-Oct-13', '1-Oct-13', '1-Oct-13', None, None, None, None, None, '28-Oct-13', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC153', '0', 'CASA', 'ARBC153', 'ARB03CA0070', None, '03', None, None, '007', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549678', '1500', '0', '0', '30-Mar-13', '30-Mar-13', '1-Oct-12', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00050822', 'ANEL LIZBETH DIAZ PRADO', 'ANEL LIZBETH', 'DIAZ', 'PRADO', 'DIPA810606NV1', 'DIPA810606MDFZRN19', '1', None, None, '46224916', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'COL LIBERACION', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02930', '0', None, None, None, '30000018942', 'SI000002820', 'DEV000000384', '461980.12000', '461980.12000', '.00000', '.00000', '461980.12000', '-461980.12000', '-461980.12000', '.00000', '.00000', '-1500.00000', '-1500.00000', '1-Jan-00', '19-Jun-15', '2-Oct-13', '2-Oct-13', '2-Oct-13', '0', None, '2-Oct-13', '2-Oct-13', '2-Oct-13', '2-Oct-13', '2-Oct-13', None, None, None, None, None, '28-Oct-13', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC065', '0', 'CASA', 'ARBC065', 'ARB04CA0050', None, '04', None, None, '005', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535678', '1500', '0', '0', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00051091', 'HUGO ALBERTO CONTRERA  GUADARRAMA', 'HUGO ALBERTO', 'CONTRERA', 'GUADARRAMA', 'COGH701007', None, '1', None, None, '57565980', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'TEPALCATES', 'IZTAPALAPA DF', 'DF', 'Mexico', '09210', '0', None, None, None, '30000019056', 'SI000002887', 'DEV000000648', '476500.00000', '476500.00000', '.00000', '.00000', '476500.00000', '-476500.00000', '-476500.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '9-Oct-13', '9-Oct-13', '9-Oct-13', '0', None, '9-Oct-13', '9-Oct-13', '9-Oct-13', '9-Oct-13', '9-Oct-13', None, None, None, None, None, '14-Apr-14', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC013', '0', 'CASA', 'ARBC013', 'ARB04CA0160', None, '04', None, None, '016', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535678', '1500', '0', '0', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00051240', 'JOSE CARLOS MORALES INFANTE', 'JOSE CARLOS', 'MORALES', 'INFANTE', 'MOIC761112489', 'MOIC761112HDFRNR01', '1', None, None, '26282194', '5550780400', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'AMPLIACION SAN ANDRES ATENCO', 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54040', '0', None, None, None, '30000019098', 'SI000002894', 'DEV000000439', '485677.67000', '485677.67000', '.00000', '.00000', '485677.67000', '-485677.67000', '-485677.67000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '10-Oct-13', '10-Oct-13', '10-Oct-13', '0', None, '10-Oct-13', '10-Oct-13', '10-Oct-13', '10-Oct-13', '10-Oct-13', None, None, None, None, None, '22-Nov-13', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC152', '0', 'CASA', 'ARBC152', 'ARB03CA0060', None, '03', None, None, '006', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549678', '1500', '0', '0', '30-Mar-13', '30-Mar-13', '1-Oct-12', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00051967', 'EVANGELICA RENATA RICO HERNANDEZ', 'EVANGELICA RENATA', 'RICO', 'HERNANDEZ', 'RIHE781112', None, '1', None, 'evangel@hotmail.com', '55204033', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'CENTRO', 'CUAUHTÉMOC DF', 'DF', 'Mexico', '06000', '0', None, None, None, '30000019304', 'SI000002095', 'DEV000000318', '475600.00000', '475600.00000', '.00000', '.00000', '475600.00000', '-475600.00000', '-475600.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '30-Mar-13', '30-Mar-13', '30-Mar-13', '0', None, '30-Mar-13', '30-Mar-13', '30-Mar-13', '30-Mar-13', '30-Mar-13', None, None, None, None, None, '9-Sep-13', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC017', '0', 'CASA', 'ARBC017', 'ARB04CA0360', None, '04', None, None, '036', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535678', '1500', '0', '0', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00055504', 'TANIA LILIA HERNANDEZ MORENO', 'TANIA LILIA', 'HERNANDEZ', 'MORENO', 'HEMT880422N77', 'HEMT880422MDFRRN08', '1', None, 'tania_2204@outlook.com', '26165805', None, '5529508034', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'MORELOS', 'VENUSTIANO CARRANZA DF', 'DF', 'Mexico', '15270', '0', None, None, None, '30000020625', 'SI000003228', 'DEV000000493', '495677.67000', '495677.67000', '.00000', '.00000', '495677.67000', '-495677.67000', '-495677.67000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '4-Dec-13', '4-Dec-13', '4-Dec-13', '0', None, '4-Dec-13', '4-Dec-13', '4-Dec-13', '4-Dec-13', '4-Dec-13', None, None, None, None, None, '12-Dec-13', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC153', '0', 'CASA', 'ARBC153', 'ARB03CA0070', None, '03', None, None, '007', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549678', '1500', '0', '0', '30-Mar-13', '30-Mar-13', '1-Oct-12', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00057233', 'HECTOR NOLASCO LOPEZ', 'HECTOR', 'NOLASCO', 'LOPEZ', 'NOLH781127EM1', 'NOLH781127HMNLPC04', '1', None, 'hector.nolasco@hotmail.com', '58818143', None, '5549019320', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'U H FIDEL VELAZQUEZ', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54700', '0', None, None, None, '30000021334', 'SI000002073', 'DEV000000320', '475600.00000', '475600.00000', '.00000', '.00000', '475600.00000', '-475600.00000', '-475600.00000', '.00000', '.00000', '-3000.00000', '-3000.00000', '15-Jan-15', '15-Jan-15', '29-Mar-13', '29-Mar-13', '29-Mar-13', '0', None, '29-Mar-13', '29-Mar-13', '29-Mar-13', '29-Mar-13', '29-Mar-13', None, None, None, None, None, '17-Sep-13', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC039', '0', 'CASA', 'ARBC039', 'ARB04CA0130', None, '04', None, None, '013', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535678', '1500', '0', '0', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00057743', 'ANTONIO ROMERO ROSAS', 'ANTONIO', 'ROMERO', 'ROSAS', 'RORA6502283M3', 'RORA650228HGRMSN09', '1', None, None, '56600466', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SANTA FE', 'ALVARO OBREGÓN DF', 'DF', 'Mexico', '01210', '0', None, None, None, '30000021649', 'SI000003387', 'DEV000000649', '485677.67000', '485677.67000', '.00000', '.00000', '485677.67000', '-485677.67000', '-485677.67000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '30-Dec-13', '30-Dec-13', '30-Dec-13', '0', None, '30-Dec-13', '30-Dec-13', '30-Dec-13', '30-Dec-13', '30-Dec-13', None, None, None, None, None, '14-Apr-14', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC032', '0', 'CASA', 'ARBC032', 'ARB05CA0010', None, '05', None, None, '001', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549819', '1500', '0', '0', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00060559', 'JOSE LUIS BAUTISTA HERNANDEZ', 'JOSE LUIS', 'BAUTISTA', 'HERNANDEZ', 'BAHL790604H8A', 'BAHL790604HDFTRS02', '1', None, None, '58582245', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'EJ DE SAN AGUSTIN', 'NEZAHUALCÓYOTL MEX', 'MEX', 'Mexico', '57850', '0', None, None, None, '30000023322', 'SI000003648', 'DEV000000650', '499818.33000', '499818.33000', '.00000', '.00000', '499818.33000', '-499818.33000', '-499818.33000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '30-Jan-14', '30-Jan-14', '30-Jan-14', '0', None, '30-Jan-14', '30-Jan-14', '30-Jan-14', '30-Jan-14', '30-Jan-14', None, None, None, None, None, '14-Apr-14', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC125', '0', 'CASA', 'ARBC125', 'ARB05CA0320', None, '05', None, None, '032', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549819', '1500', '0', '0', '29-Nov-13', '29-Nov-13', '2-Jun-13', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00065580', 'ZINTIA HERNANDEZ IBAREZ', 'ZINTIA', 'HERNANDEZ', 'IBAREZ', 'HEIZ801121LD9', 'HEIZ801121MMCRBN09', '1', None, 'jclopezqi7@gmail.com', '16762602', None, '5516913864', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'INFONAVIT NORTE', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54720', '0', None, None, None, '30000026713', 'SI000004535', 'DEV000000757', '527818.33000', '527818.33000', '.00000', '.00000', '527818.33000', '-527818.33000', '-527818.33000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '2-May-14', '2-May-14', '2-May-14', '0', None, '2-May-14', '2-May-14', '2-May-14', '2-May-14', '2-May-14', None, None, None, None, None, '30-Jun-14', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC036', '0', 'CASA', 'ARBC036', 'ARB08CA0110', None, '08', None, None, '011', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564819', '1500', '0', '0', '31-Jan-14', '31-Jan-14', '4-Aug-13', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00066269', 'JUAN ARISTEO RODRIGUEZ GARCIA', 'JUAN ARISTEO', 'RODRIGUEZ', 'GARCIA', 'ROGJ630903976', 'ROGJ630903', '1', None, 'juan.rod@hotmail.com', '58783680', '5919171331', '5528978416', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SEÑOR DE LOS MILAGROS', 'MELCHOR OCAMPO MEX', 'MEX', 'Mexico', '54880', '0', None, None, None, '30000027315', 'SI000004537', 'DEV000000783', '553520.00000', '553520.00000', '.00000', '.00000', '553520.00000', '-553520.00000', '-553520.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '2-May-14', '2-May-14', '2-May-14', '0', None, '2-May-14', '2-May-14', '2-May-14', '2-May-14', '2-May-14', None, None, None, None, None, '18-Jul-14', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC141', '0', 'CASA', 'ARBC141', 'ARB02CA0140', None, '02', None, None, '014', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549678', '1500', '0', '0', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00071068', 'ROSITA MESINAS GARCIA', 'ROSITA', 'MESINAS', 'GARCIA', 'MEGR740115FLA', 'MEGR740115MMCSRS08', '1', None, 'rosymesinas@yahoo.com.mx', None, None, '5512933815', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN JOSE DEL JARAL', 'ATIZAPÁN MEX', 'MEX', 'Mexico', '52924', '0', None, None, None, '30000030632', 'SI000005421', 'DEV000000816', '549677.25000', '549677.25000', '.00000', '.00000', '549677.25000', '-549677.25000', '-549677.25000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '31-Jul-14', '31-Jul-14', '31-Jul-14', '0', None, '31-Jul-14', '31-Jul-14', '31-Jul-14', '31-Jul-14', '31-Jul-14', None, None, None, None, None, '22-Aug-14', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC107', '0', 'CASA', 'ARBC107', 'ARB05CA0270', None, '05', None, None, '027', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549819', '1500', '0', '0', '29-Nov-13', '29-Nov-13', '2-Jun-13', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00071100', 'EDMUNDO ESCOBAR MUNGUIA', 'EDMUNDO', 'ESCOBAR', 'MUNGUIA', 'EOME710903I1A', 'EOME710903HDFSND01', '1', None, 'escomu9311@prodigy.net', '32681862', None, '5532681862', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'ELECTRICISTAS', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02060', '0', None, None, None, '30000030657', 'SI000005389', 'DEV000000840', '515426.00000', '515426.00000', '.00000', '.00000', '515426.00000', '-515426.00000', '-515426.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '29-Jul-14', '29-Jul-14', '29-Jul-14', '0', None, '29-Jul-14', '29-Jul-14', '29-Jul-14', '29-Jul-14', '29-Jul-14', None, None, None, None, None, '5-Sep-14', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC122', '0', 'CASA', 'ARBC122', 'ARB05CA0250', None, '05', None, None, '025', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549819', '1500', '0', '0', '29-Nov-13', '29-Nov-13', '2-Jun-13', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00072875', 'MIGUEL ANGEL GONZALEZ LUCIO', 'MIGUEL ANGEL', 'GONZALEZ', 'LUCIO', 'NETP770608379', 'GOLM760325HDFNCG09', '1', None, 'mglez.lucio@gmail.com', '21478253', '63601179', '5522675464', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'UHAB  VALLEJO SCT', 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07700', '0', None, None, None, '30000031309', 'SI000005645', 'DEV000000931', '472267.93000', '472267.93000', '.00000', '.00000', '472267.93000', '-472267.93000', '-472267.93000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '2-Sep-14', '2-Sep-14', '2-Sep-14', '0', None, '2-Sep-14', '2-Sep-14', '2-Sep-14', '2-Sep-14', '2-Sep-14', None, None, None, None, None, '27-Oct-14', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC052', '0', 'CASA', 'ARBC052', 'ARB04CA0090', None, '04', None, None, '009', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '535678', '1500', '0', '0', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00072963', 'JOSE DE JESUS REYES GONZALEZ', 'JOSE DE JESUS', 'REYES', 'GONZALEZ', 'REGJ810721M94', 'REGJ810721HDFYNS05', '1', None, 'loboombo@hotmail.es', '13260123', None, '5524011659', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'AMPL GUADALUPE PROLETARIA', 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07670', '0', None, None, None, '30010165329', 'SI000006031', 'DEV000001104', '527500.00000', '527500.00000', '.00000', '.00000', '527500.00000', '-527500.00000', '-527500.00000', '52222.50000', '.00000', '.00000', '52222.50000', '15-Jan-15', '15-Jan-15', '29-Sep-14', '29-Sep-14', '29-Sep-14', '0', None, '29-Sep-14', '29-Sep-14', '29-Sep-14', '29-Sep-14', '29-Sep-14', None, None, None, None, None, '23-Jan-15', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC146', '0', 'CASA', 'ARBC146', 'ARB02CA0040', None, '02', None, None, '004', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549678', '1500', '0', '0', '15-Sep-12', '15-Sep-12', '19-Mar-12', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00075693', 'GABRIEL OSNAYA ITURRALDE', 'GABRIEL', 'OSNAYA', 'ITURRALDE', 'OAIG6702286R4', 'OAIG670228HDFSTB08', '1', None, 'azcapotzalco1967@hotmail.com', '52362948', '55127077', '5524179648', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'AMP SAN PEDROXALPA', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02719', '0', None, None, None, '30010167317', 'SI000006271', 'DEV000001215', '569677.25000', '569677.25000', '.00000', '.00000', '569677.25000', '-569677.25000', '-569677.25000', '.00000', '.00000', '63130.00000', '63130.00000', '15-Jan-15', '15-Jan-15', '9-Oct-14', '9-Oct-14', '9-Oct-14', '0', None, '9-Oct-14', '9-Oct-14', '9-Oct-14', '9-Oct-14', '9-Oct-14', None, '3-Dec-14', '3-Dec-14', None, '11-Dec-14', '14-Apr-15', None, None, 'CANCELADO POR FALTA DE RECURSOS'), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC088', '0', 'CASA', 'ARBC088', 'ARB06CA0320', None, '06', None, None, '032', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564819', '1500', '0', '0', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00076056', 'ANA LISSET GONZALEZ JIMENEZ', 'ANA LISSET', 'GONZALEZ', 'JIMENEZ', 'GOJA821202P53', 'GOJA821202MDFNMN04', '1', None, 'tessil26@yahoo.com.mx', '58892033', '10840900', '5540711286', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'INFONAVIT NORTE', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54720', '0', None, None, None, '30010168554', 'SI000006478', 'DEV000001103', '556000.00000', '556000.00000', '.00000', '.00000', '556000.00000', '-556000.00000', '-556000.00000', '55044.00000', '.00000', '.00000', '55044.00000', '15-Jan-15', '15-Jan-15', '27-Oct-14', '27-Oct-14', '27-Oct-14', '0', None, '27-Oct-14', '27-Oct-14', '27-Oct-14', '27-Oct-14', '27-Oct-14', None, None, None, None, None, '23-Jan-15', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC079', '0', 'CASA', 'ARBC079', 'ARB06CA0080', None, '06', None, None, '008', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564819', '1500', '0', '0', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00076600', 'ADRIANA FUENTES GOMEZ', 'ADRIANA', 'FUENTES', 'GOMEZ', 'FUGA870804J83', 'FUGA870804MMCNMD06', '1', None, 'adrianaf.ideasa@gmail.com', '16767645', None, '5522063456', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN MIGUEL CAÑADAS', 'TEPOTZOTLÁN MEX', 'MEX', 'Mexico', '54600', '0', None, None, None, '30010170014', 'SI000006561', 'DEV000001136', '483000.00000', '483000.00000', '.00000', '.00000', '483000.00000', '-483000.00000', '-483000.00000', '45160.50000', '.00000', '7563.87000', '52724.37000', '15-Jan-15', '15-Jan-15', '31-Oct-14', '31-Oct-14', '31-Oct-14', '0', None, '31-Oct-14', '31-Oct-14', '31-Oct-14', '31-Oct-14', '31-Oct-14', None, None, None, None, None, '12-Feb-15', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC107', '0', 'CASA', 'ARBC107', 'ARB05CA0270', None, '05', None, None, '027', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549819', '1500', '0', '0', '29-Nov-13', '29-Nov-13', '2-Jun-13', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00076604', 'BLANCA ESTELA BUCIO ROMERO', 'BLANCA ESTELA', 'BUCIO', 'ROMERO', 'BURB610717MZ2', 'BURB610717MVZCML08', '1', None, 'gaby291087@msn.com', '26050031', None, '5566541428', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN FRANCISCO CASCANTITLA', 'CUAUTITLÁN MEX', 'MEX', 'Mexico', '54801', '0', None, None, None, '30010169990', 'SI000006507', '0000046', '556000.00000', '556000.00000', '.00000', '.00000', '556000.00000', '-556000.00000', '-556000.00000', '.00000', '.00000', '-1492.00000', '-1492.00000', '15-Jan-15', '15-Jan-15', '29-Oct-14', '29-Oct-14', '29-Oct-14', '0', None, '29-Oct-14', '29-Oct-14', '29-Oct-14', '29-Oct-14', '29-Oct-14', None, None, None, None, None, '28-Jul-15', None, None, 'CANCELADO'), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC019', '0', 'CASA', 'ARBC019', 'ARB05CA0050', None, '05', None, None, '005', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '549819', '1500', '0', '0', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00077916', 'ANA MARIA DEL ROSARIO MORALES UBALDO', 'ANA MARIA DEL ROSARIO', 'MORALES', 'UBALDO', 'MOUA7509052Q1', 'MOUA750905MDFRBN06', '0', 'H', 'rosario1900@yahoo.com.mx', '56638600', '5539193820', None, '39927519213', '5-Sep-75', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '35', 'Suburbano', 'CORREGIDORA', '117', '201 B', 'SANTA ANITA', 'IZTACALCO DF', 'DF', 'MEXICO', '08300', '15', 'EMPLEADA', None, 'IFE', '70010172960', 'SI000010241', 'DEV000001212', '564818.33000', '564818.33000', '.00000', '.00000', '564818.33000', '-564818.33000', '-564818.33000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '13-Apr-15', '14-Apr-15', '14-Apr-15', '14-Apr-15', None, None, '14-Apr-15', '14-Apr-15', '14-Apr-15', '14-Apr-15', '14-Apr-15', None, '13-Apr-15', '13-Apr-15', None, '13-Apr-15', '13-Apr-15', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC073', '0', 'CASA', 'ARBC073', 'ARB06CA0140', None, '06', None, None, '014', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564819', '1500', '0', '0', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00078071', 'CARMEN ADRIANA PEREZ JACO', 'CARMEN ADRIANA', 'PEREZ', 'JACO', 'PEJC790416L97', 'PEJC790416MDFRCR08', '1', None, 'adryss000@outlook.es', '20868937', '46164640', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'TULTEPEC MEX', 'MEX', 'Mexico', '54960', '0', None, None, None, '30010173976', 'SI000010513', '0000042', '525000.00000', '525000.00000', '.00000', '.00000', '525000.00000', '-525000.00000', '-525000.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '30-Jan-15', '23-Dec-14', '23-Dec-14', '23-Dec-14', '0', None, '23-Dec-14', '23-Dec-14', '23-Dec-14', '23-Dec-14', '23-Dec-14', None, None, None, None, None, '24-Jul-15', None, None, 'CANCELADO'), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC093', '0', 'CASA', 'ARBC093', 'ARB06CA0270', None, '06', None, None, '027', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564819', '1500', '0', '0', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00078251', 'GUADALUPE RODRIGUEZ GUTIERREZ', 'GUADALUPE', 'RODRIGUEZ', 'GUTIERREZ', 'ROGG840304EU1', 'ROGG840304MDFDTD01', '1', None, 'guadalupe_rod_gut@hotmail.com', '53074808', '50015250', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, None, 'NAUCALPAN JUÁREZ MEX', 'MEX', 'Mexico', '53689', '0', None, None, None, '30010174057', 'SI000010244', 'DEV000001034', '564818.33000', '564818.33000', '.00000', '.00000', '564818.33000', '-564818.33000', '-564818.33000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '30-Jan-15', '2-Dec-14', '2-Dec-14', '2-Dec-14', '0', None, '2-Dec-14', '2-Dec-14', '2-Dec-14', '2-Dec-14', '2-Dec-14', None, None, None, None, None, '11-Dec-14', None, None, None), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC094', '0', 'CASA', 'ARBC094', 'ARB06CA0260', None, '06', None, None, '026', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '2', '1', '564819', '1500', '0', '0', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00079911', 'FRANCISCO ISAIAS SEGURA PEREZ', 'FRANCISCO ISAIAS', 'SEGURA', 'PEREZ', 'SEPF600706', None, '1', None, None, '60850464', '58120421', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'CUAJIMALPA', 'DF', 'DF', 'Mexico', '05000', '0', None, None, None, '30010179734', 'SI000010798', 'DEV000001199', '465500.00000', '465500.00000', '.00000', '.00000', '465500.00000', '-465500.00000', '-465500.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '22-Feb-15', '20-Jan-15', '20-Jan-15', '20-Jan-15', '0', None, '20-Jan-15', '20-Jan-15', '20-Jan-15', '20-Jan-15', '20-Jan-15', None, None, None, None, None, '1-Apr-15', None, None, 'CANCELACION POR FALTA DE RECURSOS'), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC066', '0', 'CASA', 'ARBC066', 'ARB06CA0130', None, '06', None, None, '013', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564819', '1500', '0', '0', '10-Jan-14', '10-Jan-14', '14-Jul-13', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00079933', 'EDGAR RODRIGUEZ REYES', 'EDGAR RODRIGUEZ', 'REYES', None, 'RORE730311FT0', 'RORE730311HDFDYD03', '1', None, None, None, None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', 'LOTTOS 12 MANZANA 19 LOTE 15 CSA 5', None, None, 'COL JARDINES DE LA CAÑADA', 'TULTITLAN', None, 'Mexico', None, '0', None, None, None, '30010179809', 'SI000010796', 'DEV000001263', '570000.00000', '570000.00000', '.00000', '.00000', '570000.00000', '-570000.00000', '-570000.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '28-Sep-15', '26-Jan-15', '26-Jan-15', '26-Jan-15', '0', None, '26-Jan-15', '26-Jan-15', '26-Jan-15', '26-Jan-15', '26-Jan-15', None, None, None, None, None, '11-Jun-15', None, None, 'CANCELADO'), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC100', '0', 'CASA', 'ARBC100', 'ARB05CA0240', None, '05', None, None, '024', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '2', '1', '552019.5', '1500', '0', '0', '29-Nov-13', '29-Nov-13', '2-Jun-13', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00081971', 'FERNANDO ROMERO GUERRERO', 'FERNANDO', 'ROMERO', 'GUERRERO', 'ROGF830904CA9', 'ROGF830904HGTMRR00', '0', 'H', 'fromero@4emexico.com', '58783318', '5542669301', '30678000', '92038306673', '4-Sep-83', 'CASADO', 'BIENES SEPARADOS', 'MEXICANA', 'GUANAJUATO', None, '1', 'Impresos', '12 DE DICIEMBRE', '62', None, 'LAS ANIMAS', 'TEPOTZOTLAN', 'MEXICO', 'MEXICO', '54616', '8', 'EMPLEADO', '2455085101088', 'IFE', '30020108897', '0002635', '0000027', '552019.50000', '552019.50000', '.00000', '.00000', '552019.50000', '-552019.50000', '-552019.50000', '.00000', '.00000', '1500.00000', '1500.00000', '28-Mar-15', '9-Apr-15', '15-Apr-15', '15-Apr-15', '15-Apr-15', '12', None, '15-Apr-15', '15-Apr-15', '15-Apr-15', '15-Apr-15', '15-Apr-15', None, None, None, None, None, '14-Jul-15', None, None, 'CANCELADO'), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC209', '0', 'CASA', 'ARBC209', 'ARB07CA0310', None, '07', None, None, '031', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 IZQ..', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564819', '1500', '0', '0', '24-Jan-14', '24-Jan-14', '28-Jul-13', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00082493', 'PATRICIA GUTIERREZ CORTES', 'PATRICIA', 'GUTIERREZ', 'CORTES', 'GUCP610505B48', 'GUCP610505MDFTRT07', '0', 'M', 'pgutierrezc@finanzas.df.gob.mx', '58175322', '5522980058', '57169150', None, '5-May-61', 'SOLTERO', None, 'MEXICANA', 'DISTRITO FEDERAL', None, '35', 'Suburbano', 'ALERCES 202', '3', '9', 'ARBOLEDAS SAN MIGUEL', 'CUAUTITLAN IZCALLI', 'MEXICO', 'MEXICO', '54715', '8', 'EMPLEADA', '0152017623034', 'IFE', '30020113731', '0002744', 'DEV000001262', '478750.00000', '478750.00000', '.00000', '.00000', '478750.00000', '-478750.00000', '-478750.00000', '.00000', '.00000', '.00000', '.00000', '19-Apr-15', '20-Apr-15', '29-Apr-15', '20-Apr-15', '21-Apr-15', '12', None, '29-Apr-15', '30-Apr-15', '30-Apr-15', '5-May-15', '5-May-15', None, None, None, None, None, '11-Jun-15', None, None, 'CANCELADA'), ('ARB', 'La Arboleda', 'Niños Héroes #1', None, 'Santa María Huecatitla', 'Cuautitlán', 'Estado de México', '54830', 'Mexico', '0181', 'ARBC216', '0', 'CASA', 'ARBC216', 'ARB07CA0240', None, '07', None, None, '024', None, '1', '0', 'ROBLE AP-01A2R2N1.5B5X12 DER.', 'UNIFAMILIAR, TERRENO 5X12, 2 RECAMARAS, 2 NIV, 1 BAÑO, 1 SANITARIO', None, None, '2', None, '1.5', None, None, None, None, None, None, None, None, '67.24', None, None, None, None, None, None, '5', '60', '0', None, None, None, None, None, '0', '1', '1', '564819', '1500', '0', '0', '24-Jan-14', '24-Jan-14', '28-Jul-13', 'LIBERADO', 'INACTIVO', 'CANCELADO', '016-CANCELADO', 'PV00082917', 'OSCAR TORICES REYES', 'OSCAR', 'TORICES', 'REYES', 'TORO920308FX9', 'TORO920308HMCRYS06', '0', 'H', None, '58708016', '5518265741', '58728261', '94109236698', '8-Mar-92', 'SOLTERO', None, 'MEXICANA', 'ESTADO DE MEXICO', None, '35', 'Suburbano', 'EJIDO DE SANTA BARBARA', '3', '14', 'LAZARO CARDENAS', 'CUAUTITLAN', 'MEXICO', 'MEXICO', '54870', '6', 'EMPLEADO', '0622121564649', 'IFE', '30020117195', '0002818', 'DEV000001261', '458362.50000', '458362.50000', '.00000', '.00000', '458362.50000', '-458362.50000', '-458362.50000', '.00000', '.00000', '8.00000', '8.00000', '10-May-15', '15-May-15', '12-May-15', '16-May-15', '18-May-15', '12', None, '19-May-15', '19-May-15', '19-May-15', '20-May-15', '20-May-15', None, None, None, None, None, '11-Jun-15', None, None, 'CANCELACION'), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P009', '1', 'DEPARTAMENTO', 'AS1D009', 'AS10AD00090', None, None, '0A', '0', '009', None, '1', '0', 'AS975. DEPTO TIPO 8C', 'SALA/COMEDOR, COCINA, 2 RECÁMARAS, BAÑO, PASILLO Y PATIO DE LAVADO', None, None, '2', None, '1', '0', '16.67', None, '4.71', None, None, None, None, '48.66', None, '0', '0', None, '0', '48.66', None, None, '0', None, None, None, None, None, '1', '0', '1', '0', '10000', '0', '0', '1-Mar-14', '1-Mar-14', '2-Sep-13', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P010', '1', 'DEPARTAMENTO', 'AS1D010', 'AS10AD00100', None, None, '0A', '0', '010', None, '1', '0', 'AS975. DEPTO TIPO 8D', 'SALA/COMEDOR, COCINA, 2 RECÁMARAS BAÑO PASILLO Y PATIO DE LAVADO', None, None, '2', None, '1', '0', '16.67', None, '4.71', None, None, None, None, '48.66', None, '0', '0', None, '0', '48.66', None, None, '0', None, None, None, None, None, '1', '0', '1', '0', '10000', '0', '0', '1-Mar-14', '1-Mar-14', '2-Sep-13', 'LIBERADO', 'INACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P041', '3', 'BODEGA', 'AS1B010', 'AS100BD0100', None, None, None, None, '010', None, '1', '0', 'AS.975. BODEGA TIPO 2', 'BODEGA DE 4 M2', None, None, None, None, None, None, None, None, None, None, None, None, None, '4', None, None, None, None, None, None, None, None, '0', None, None, None, None, None, '1', '0', '0', '1', '0', '0', '0', '1-Mar-14', '1-Mar-14', '2-Sep-13', 'LIBERADO', 'ACTIVO', 'DISPONIBLE', '000-DISPONIBLE', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None, None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P202', '1', 'DEPARTAMENTO', 'AS1D202', 'AS10CD55080', None, None, '0C', '5', '508', None, '1', '0', 'AS975.DEPTO TIPO 3', 'DEPTO, SALA/COMEDOR, COCINA, 1 RECÁMARA, 1 BAÑO, PASILLO, PATIO DE LAVADO', None, None, '1', None, '1', '0', '13.21', None, '6.64', None, None, None, None, '43.28', None, '0', '0', None, '0', '43.28', None, None, '69.1', None, None, None, None, None, '0', '1', '1', '1,050,000.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '011-LIBERADA', 'PV00083017', 'MOISES ALEJANDRO MUÑOZ JAUREGUI', 'MOISES ALEJANDRO', 'MUÑOZ', 'JAUREGUI', 'MUJM670104878', 'MUJM670104HNEXRS01', '0', 'H', 'MUNOZ_MOISES@HOTMAIL.COM', '5558895318', '5541676281', '5547602200', None, '4-Jan-67', 'CASADO', 'SOCIEDAD CONYUGAL', 'MEXICANA', 'PERU', None, '2', 'Volante', 'C CARMEN ROOS', 'LT 1', '11', 'CONJ HAB LAS CARMELITAS', 'CUAUTITLAN IZCALLI', 'MEX', 'MEXICO', '54710', '10', 'INDEPENDIENTE', '0731131359827', 'IFE', '30020118128', '0002916', None, '1000000.00000', '1130000.00000', '.00000', '.00000', '1130000.00000', '.00000', '.00000', '90400.00000', '.00000', '-334480.00000', '885920.00000', '16-May-15', '3-Jun-15', '30-May-15', '2-Jun-15', '2-Jun-15', '0', None, '2-Jun-15', '5-Jun-15', '5-Jun-15', '11-Jun-15', '11-Jun-15', None, '12-Jun-15', '12-Jun-15', None, '18-Jun-15', None, '29-Jun-15', None, None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P202', '2', 'ESTACIONAMIENTO', 'AS1E213', 'AS100EG1230', None, None, None, None, '123', None, '1', '0', 'EST DDEX', 'Cajón DISCAPACITADO, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '19', None, None, None, None, None, None, '3.8', None, '0', None, None, 'DISCAPACITADO', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '130,000.00 ', '0.00 ', '0.00 ', '0.00 ', '15-Dec-13', '15-Dec-13', '18-Jun-13', 'LIBERADO', 'INACTIVO', 'VENTA', '011-LIBERADA', 'PV00083017', 'MOISES ALEJANDRO MUÑOZ JAUREGUI', 'MOISES ALEJANDRO', 'MUÑOZ', 'JAUREGUI', 'MUJM670104878', 'MUJM670104HNEXRS01', '0', 'H', 'MUNOZ_MOISES@HOTMAIL.COM', '5558895318', '5541676281', '5547602200', None, '4-Jan-67', 'CASADO', 'SOCIEDAD CONYUGAL', 'MEXICANA', 'PERU', None, '2', 'Volante', 'C CARMEN ROOS', 'LT 1', '11', 'CONJ HAB LAS CARMELITAS', 'CUAUTITLAN IZCALLI', 'MEX', 'MEXICO', '54710', '10', 'INDEPENDIENTE', '0731131359827', 'IFE', '30020118128', '0002916', None, '130000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '16-May-15', '3-Jun-15', '30-May-15', '2-Jun-15', '2-Jun-15', '0', None, '2-Jun-15', '5-Jun-15', '5-Jun-15', '11-Jun-15', '11-Jun-15', None, '12-Jun-15', '12-Jun-15', None, '18-Jun-15', None, '29-Jun-15', None, None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P018', '1', 'DEPARTAMENTO', 'AS1D018', 'AS10AD11080', None, None, '0A', '1', '108', None, '1', '0', 'AS975.DEPTO TIPO 1', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '14.4', None, '4.52', None, None, None, None, '49.5', '2.05', '0', '0', None, '0', '49.5', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,142,833.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Sep-14', '20-Sep-14', '24-Mar-14', 'LIBERADO', 'INACTIVO', 'VENTA', '011-LIBERADA', 'PV00086840', 'MARIA DE LOS ANGELES GONZALEZ ORTIZ', 'MARIA DE LOS ANGELES', 'GONZALEZ', 'ORTIZ', 'GOOA66052487A', 'GOOA660524MDFNRN01', '0', 'M', 'BETOASABER007@HOTMAIL.COM', '5519291141', '5585689967', None, None, '24-May-66', 'SOLTERO', None, 'MEXICANA', 'MEXICO DISTRITO FEDERAL', None, '8', 'Publicidad en Pto de Vta', 'MARTIRES DE LA CONQUISTA', '124', 'H', 'ESCANDON', 'MIGUEL HIDALGO', 'MEXICO DISTRITO FEDERAL', 'MEXICO', '11800', '10', 'CONTADOR', 'G10177377', 'PASAPORTE', '30020138969', '0003354', None, '1112833.00000', '1197834.00000', '.00000', '.00000', '1197834.00000', '.00000', '.00000', '.00000', '54530.00000', '-1281683.00000', '-29319.00000', '5-Oct-15', '26-Oct-15', '17-Oct-15', '19-Oct-15', '22-Oct-15', '12', None, '26-Oct-15', '26-Oct-15', '26-Oct-15', '29-Oct-15', '29-Oct-15', '23-Oct-15', '1-Oct-15', '27-Oct-15', None, '31-Oct-15', None, '10-Nov-15', None, None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P018', '2', 'ESTACIONAMIENTO', 'AS1E011', 'AS100EA0570', None, None, None, None, '057', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '85,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '011-LIBERADA', 'PV00086840', 'MARIA DE LOS ANGELES GONZALEZ ORTIZ', 'MARIA DE LOS ANGELES', 'GONZALEZ', 'ORTIZ', 'GOOA66052487A', 'GOOA660524MDFNRN01', '0', 'M', 'BETOASABER007@HOTMAIL.COM', '5519291141', '5585689967', None, None, '24-May-66', 'SOLTERO', None, 'MEXICANA', 'MEXICO DISTRITO FEDERAL', None, '8', 'Publicidad en Pto de Vta', 'MARTIRES DE LA CONQUISTA', '124', 'H', 'ESCANDON', 'MIGUEL HIDALGO', 'MEXICO DISTRITO FEDERAL', 'MEXICO', '11800', '10', 'CONTADOR', 'G10177377', 'PASAPORTE', '30020138969', '0003354', None, '85000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '5-Oct-15', '26-Oct-15', '17-Oct-15', '19-Oct-15', '22-Oct-15', '12', None, '26-Oct-15', '26-Oct-15', '26-Oct-15', '29-Oct-15', '29-Oct-15', '23-Oct-15', '1-Oct-15', '27-Oct-15', None, '31-Oct-15', None, '10-Nov-15', None, None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P018', '3', 'BODEGA', 'AS1B011', 'AS100BD0110', None, None, None, None, '011', None, '1', '0', 'AS.975. BODEGA TIPO 2', 'BODEGA DE 4 M2', None, None, None, None, None, None, None, None, None, None, None, None, None, '4', None, None, None, None, None, None, None, None, '0', None, None, None, None, None, '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '1-Mar-14', '1-Mar-14', '2-Sep-13', 'LIBERADO', 'INACTIVO', 'VENTA', '011-LIBERADA', 'PV00086840', 'MARIA DE LOS ANGELES GONZALEZ ORTIZ', 'MARIA DE LOS ANGELES', 'GONZALEZ', 'ORTIZ', 'GOOA66052487A', 'GOOA660524MDFNRN01', '0', 'M', 'BETOASABER007@HOTMAIL.COM', '5519291141', '5585689967', None, None, '24-May-66', 'SOLTERO', None, 'MEXICANA', 'MEXICO DISTRITO FEDERAL', None, '8', 'Publicidad en Pto de Vta', 'MARTIRES DE LA CONQUISTA', '124', 'H', 'ESCANDON', 'MIGUEL HIDALGO', 'MEXICO DISTRITO FEDERAL', 'MEXICO', '11800', '10', 'CONTADOR', 'G10177377', 'PASAPORTE', '30020138969', '0003354', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '5-Oct-15', '26-Oct-15', '17-Oct-15', '19-Oct-15', '22-Oct-15', '12', None, '26-Oct-15', '26-Oct-15', '26-Oct-15', '29-Oct-15', '29-Oct-15', '23-Oct-15', '1-Oct-15', '27-Oct-15', None, '31-Oct-15', None, '10-Nov-15', None, None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P201', '1', 'DEPARTAMENTO', 'AS1D201', 'AS10CD55070', None, None, '0C', '5', '507', None, '1', '0', 'AS975.DEPTO TIPO 1', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '14.4', None, '4.52', None, None, None, None, '49.5', '2.05', '0', '0', None, '0', '49.5', None, None, '47.1', None, None, None, None, None, '0', '1', '1', '959,846.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00020828', 'CLAUDIA HAYDEE VILLA MARTINEZ', 'CLAUDIA HAYDEE', 'VILLA', 'MARTINEZ', 'VIMC720731HDA', None, '1', None, None, '35374587', None, '0445591953471', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'FRANCISCO VILLA', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02420', '0', None, None, None, '30000007036', 'SI000000937', None, '949173.20000', '1019174.20000', '.00000', '.00000', '1019174.20000', '.00000', '.00000', '61696.30000', '.00000', '-1019174.20000', '61696.30000', '1-Jan-00', '19-Jun-15', '30-Jun-12', '30-Jun-12', '30-Jun-12', '0', None, '30-Jun-12', '30-Jun-12', '30-Jun-12', '30-Jun-12', '30-Jun-12', None, '31-Jul-13', '31-Jul-13', None, '31-Jul-13', None, '28-Aug-13', '13-Sep-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P201', '2', 'ESTACIONAMIENTO', 'AS1E192', 'AS100EF1800', None, None, None, None, '180', None, '1', '0', 'EST CEEX', 'Cajón Chico, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '65,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00020828', 'CLAUDIA HAYDEE VILLA MARTINEZ', 'CLAUDIA HAYDEE', 'VILLA', 'MARTINEZ', 'VIMC720731HDA', None, '1', None, None, '35374587', None, '0445591953471', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'FRANCISCO VILLA', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02420', '0', None, None, None, '30000007036', 'SI000000936', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '30-Jun-12', '30-Jun-12', '30-Jun-12', '0', None, '30-Jun-12', '30-Jun-12', '30-Jun-12', '30-Jun-12', '30-Jun-12', None, '31-Jul-13', '31-Jul-13', None, '31-Jul-13', None, '28-Aug-13', '13-Sep-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P201', '2', 'ESTACIONAMIENTO', 'AS1E140', 'AS100ED1790', None, None, None, None, '179', None, '1', '0', 'EST CDEX', 'Cajón Chico, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00020828', 'CLAUDIA HAYDEE VILLA MARTINEZ', 'CLAUDIA HAYDEE', 'VILLA', 'MARTINEZ', 'VIMC720731HDA', None, '1', None, None, '35374587', None, '0445591953471', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'FRANCISCO VILLA', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02420', '0', None, None, None, '30000007036', 'SI000001921', None, '70000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '12-Mar-13', '12-Mar-13', '12-Mar-13', '0', None, '12-Mar-13', '12-Mar-13', '12-Mar-13', '12-Mar-13', '12-Mar-13', None, '31-Jul-13', '31-Jul-13', None, '31-Jul-13', None, '28-Aug-13', '13-Sep-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P200', '1', 'DEPARTAMENTO', 'AS1D200', 'AS10CD55060', None, None, '0C', '5', '506', None, '1', '0', 'AS975. DEPTO TIPO 6', 'DEPTO, SALA/COMEDOR, COCINA, 1 RECÁMARA, 1 BAÑO, PASILLO, PATIO DE LAVADO', None, None, '1', None, '1', '0', '17.48', None, '4.71', None, None, None, None, '47.75', None, '0', '0', None, '0', '47.75', None, None, '47.56', None, None, None, None, None, '0', '1', '1', '839,795.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00021123', 'DIDDIER SOLANO SANCHEZ', 'DIDDIER', 'SOLANO', 'SANCHEZ', 'SOSD810322BJ7', None, '1', None, 'diddiers@yahoo.com', '51485821', '37228585', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'CIRCUITO FUNDADORES', 'NAUCALPAN JUÁREZ MEX', 'MEX', 'Mexico', '53100', '0', None, None, None, '30000007242', 'SI000000964', None, '932243.00000', '1002244.00000', '.00000', '.00000', '1002244.00000', '.00000', '.00000', '74521.00000', '.00000', '-1002244.00000', '74521.00000', '15-Jan-15', '15-Jan-15', '25-Jul-12', '25-Jul-12', '25-Jul-12', '0', None, '25-Jul-12', '25-Jul-12', '25-Jul-12', '25-Jul-12', '25-Jul-12', None, '31-Jul-13', '31-Jul-13', None, '31-Jul-13', None, '5-Sep-13', '13-Sep-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P200', '2', 'ESTACIONAMIENTO', 'AS1E191', 'AS100EF1780', None, None, None, None, '178', None, '1', '0', 'EST CEEX', 'Cajón Chico, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '65,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00021123', 'DIDDIER SOLANO SANCHEZ', 'DIDDIER', 'SOLANO', 'SANCHEZ', 'SOSD810322BJ7', None, '1', None, 'diddiers@yahoo.com', '51485821', '37228585', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'CIRCUITO FUNDADORES', 'NAUCALPAN JUÁREZ MEX', 'MEX', 'Mexico', '53100', '0', None, None, None, '30000007242', 'SI000000963', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '25-Jul-12', '25-Jul-12', '25-Jul-12', '0', None, '25-Jul-12', '25-Jul-12', '25-Jul-12', '25-Jul-12', '25-Jul-12', None, '31-Jul-13', '31-Jul-13', None, '31-Jul-13', None, '5-Sep-13', '13-Sep-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P200', '2', 'ESTACIONAMIENTO', 'AS1E139', 'AS100ED1770', None, None, None, None, '177', None, '1', '0', 'EST CDEX', 'Cajón Chico, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00021123', 'DIDDIER SOLANO SANCHEZ', 'DIDDIER', 'SOLANO', 'SANCHEZ', 'SOSD810322BJ7', None, '1', None, 'diddiers@yahoo.com', '51485821', '37228585', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'CIRCUITO FUNDADORES', 'NAUCALPAN JUÁREZ MEX', 'MEX', 'Mexico', '53100', '0', None, None, None, '30000007242', 'SI000000962', None, '70000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '25-Jul-12', '25-Jul-12', '25-Jul-12', '0', None, '25-Jul-12', '25-Jul-12', '25-Jul-12', '25-Jul-12', '25-Jul-12', None, '31-Jul-13', '31-Jul-13', None, '31-Jul-13', None, '5-Sep-13', '13-Sep-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P187', '1', 'DEPARTAMENTO', 'AS1D187', 'AS10CD44010', None, None, '0C', '4', '401', None, '1', '0', 'AS975. DEPTO TIPO 5', 'DEPTO, SALA/COMEDOR, COCINA, 2 RECÁMARAS, 1 BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '16.57', None, '4.71', None, None, None, None, '48.64', None, '0', '0', None, '0', '48.64', None, None, '0', None, None, None, None, None, '0', '1', '1', '882,216.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00021147', 'JAIME ERNESTO MEDEL SANTOS', 'JAIME ERNESTO', 'MEDEL', 'SANTOS', 'MESJ791008LV1', None, '1', None, None, '0', '0', '5520705929', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'AMPLIACION DANIEL GARZA', 'MIGUEL HIDALGO DF', 'DF', 'Mexico', '11840', '0', None, None, None, '30000007267', 'SI000000956', None, '880189.00000', '945190.00000', '.00000', '.00000', '945190.00000', '.00000', '.00000', '66300.00000', '.00000', '-945189.97000', '66300.03000', '1-Jan-00', '19-Jun-15', '18-Jul-12', '18-Jul-12', '18-Jul-12', '0', None, '18-Jul-12', '18-Jul-12', '18-Jul-12', '18-Jul-12', '18-Jul-12', None, '31-Aug-13', '31-Aug-13', None, '31-Aug-13', None, '29-Oct-13', '1-Nov-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P187', '2', 'ESTACIONAMIENTO', 'AS1E194', 'AS100EF1940', None, None, None, None, '194', None, '1', '0', 'EST CEEX', 'Cajón Chico, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '65,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00021147', 'JAIME ERNESTO MEDEL SANTOS', 'JAIME ERNESTO', 'MEDEL', 'SANTOS', 'MESJ791008LV1', None, '1', None, None, '0', '0', '5520705929', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'AMPLIACION DANIEL GARZA', 'MIGUEL HIDALGO DF', 'DF', 'Mexico', '11840', '0', None, None, None, '30000007267', 'SI000002287', None, '65000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '17-May-13', '17-May-13', '17-May-13', '0', None, '17-May-13', '17-May-13', '17-May-13', '17-May-13', '17-May-13', None, '31-Aug-13', '31-Aug-13', None, '31-Aug-13', None, '29-Oct-13', '1-Nov-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P187', '2', 'ESTACIONAMIENTO', 'AS1E193', 'AS100EF1920', None, None, None, None, '192', None, '1', '0', 'EST CEEX', 'Cajón Chico, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '65,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00021147', 'JAIME ERNESTO MEDEL SANTOS', 'JAIME ERNESTO', 'MEDEL', 'SANTOS', 'MESJ791008LV1', None, '1', None, None, '0', '0', '5520705929', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'AMPLIACION DANIEL GARZA', 'MIGUEL HIDALGO DF', 'DF', 'Mexico', '11840', '0', None, None, None, '30000007267', 'SI000000955', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '18-Jul-12', '18-Jul-12', '18-Jul-12', '0', None, '18-Jul-12', '18-Jul-12', '18-Jul-12', '18-Jul-12', '18-Jul-12', None, '31-Aug-13', '31-Aug-13', None, '31-Aug-13', None, '29-Oct-13', '1-Nov-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P195', '1', 'DEPARTAMENTO', 'AS1D195', 'AS10CD55010', None, None, '0C', '5', '501', None, '1', '0', 'AS975. DEPTO TIPO 5', 'DEPTO, SALA/COMEDOR, COCINA, 2 RECÁMARAS, 1 BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '16.57', None, '4.71', None, None, None, None, '48.64', None, '0', '0', None, '0', '48.64', None, None, '49.4', None, None, None, None, None, '0', '1', '1', '950,527.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00021422', 'ALVARO GABINO SAUCEDO SANDOVAL', 'ALVARO GABINO', 'SAUCEDO', 'SANDOVAL', 'SASA821001VC9', None, '1', None, None, '58610908', None, '0445543473162', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BOSQUES DE MORELOS', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54760', '0', None, None, None, '30000007382', 'SI000000973', None, '940891.15000', '1043391.15000', '.00000', '.00000', '1043391.15000', '.00000', '.00000', '.00000', '.00000', '-1043391.20000', '-.05000', '1-Jan-00', '19-Jun-15', '31-Jul-12', '31-Jul-12', '31-Jul-12', '0', None, '31-Jul-12', '31-Jul-12', '31-Jul-12', '31-Jul-12', '31-Jul-12', None, '7-Oct-13', '7-Oct-13', None, '7-Oct-13', None, '28-Oct-13', '5-Nov-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P195', '2', 'ESTACIONAMIENTO', 'AS1E119', 'AS100ED0650', None, None, None, None, '065', None, '1', '0', 'EST CDEX', 'Cajón Chico, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00021422', 'ALVARO GABINO SAUCEDO SANDOVAL', 'ALVARO GABINO', 'SAUCEDO', 'SANDOVAL', 'SASA821001VC9', None, '1', None, None, '58610908', None, '0445543473162', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BOSQUES DE MORELOS', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54760', '0', None, None, None, '30000007382', 'SI000002283', None, '70000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '15-May-13', '15-May-13', '15-May-13', '0', None, '15-May-13', '15-May-13', '15-May-13', '15-May-13', '15-May-13', None, '7-Oct-13', '7-Oct-13', None, '7-Oct-13', None, '28-Oct-13', '5-Nov-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P195', '2', 'ESTACIONAMIENTO', 'AS1E171', 'AS100EF0640', None, None, None, None, '064', None, '1', '0', 'EST CEEX', 'Cajón Chico, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '65,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00021422', 'ALVARO GABINO SAUCEDO SANDOVAL', 'ALVARO GABINO', 'SAUCEDO', 'SANDOVAL', 'SASA821001VC9', None, '1', None, None, '58610908', None, '0445543473162', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BOSQUES DE MORELOS', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54760', '0', None, None, None, '30000007382', 'SI000000981', None, '32500.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '7-Aug-12', '7-Aug-12', '7-Aug-12', '0', None, '7-Aug-12', '7-Aug-12', '7-Aug-12', '7-Aug-12', '7-Aug-12', None, '7-Oct-13', '7-Oct-13', None, '7-Oct-13', None, '28-Oct-13', '5-Nov-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P198', '1', 'DEPARTAMENTO', 'AS1D198', 'AS10CD55040', None, None, '0C', '5', '504', None, '1', '0', 'AS975.DEPTO TIPO 2.1', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1ALCOBA, 2BAÑOS, PASILLO, PATIOLAVADO Y AZOTEA PRIVADA', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '49.07', '113.79', None, None, '49.07', None, None, None, None, None, '0', '1', '1', '1,255,076.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00021497', 'ADRIANA MORENO ZAMUDIO', 'ADRIANA', 'MORENO', 'ZAMUDIO', 'MOZA800807RR5', None, '1', None, None, '53185874', '52030444', '5517971872', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'HACIENDA DEL ROSARIO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02440', '0', None, None, None, '30000007416', 'SI000001176', None, '1199332.70000', '1279332.70000', '.00000', '.00000', '1279332.70000', '.00000', '.00000', '.00000', '.00000', '-1279332.70000', '.00000', '1-Jan-00', '19-Jun-15', '31-Oct-12', '31-Oct-12', '31-Oct-12', '0', None, '31-Oct-12', '31-Oct-12', '31-Oct-12', '31-Oct-12', '31-Oct-12', None, '25-Oct-13', '25-Oct-13', None, '25-Oct-13', None, '11-Dec-13', '13-Dec-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P198', '2', 'ESTACIONAMIENTO', 'AS1E048', 'AS100EA1870', None, None, None, None, '187', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '85,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00021497', 'ADRIANA MORENO ZAMUDIO', 'ADRIANA', 'MORENO', 'ZAMUDIO', 'MOZA800807RR5', None, '1', None, None, '53185874', '52030444', '5517971872', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'HACIENDA DEL ROSARIO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02440', '0', None, None, None, '30000007416', 'SI000001173', None, '80000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '31-Oct-12', '31-Oct-12', '31-Oct-12', '0', None, '31-Oct-12', '31-Oct-12', '31-Oct-12', '31-Oct-12', '31-Oct-12', None, '25-Oct-13', '25-Oct-13', None, '25-Oct-13', None, '11-Dec-13', '13-Dec-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P159', '1', 'DEPARTAMENTO', 'AS1D159', 'AS10CD00050', None, None, '0C', '0', '005', None, '1', '0', 'AS975.DEPTO TIPO 2B', 'DEPTO, SALA/COMEDOR, COCINA,2RECÁMARAS, 1ALCOBA,  2BAÑOS, PASILLO, PATIO LAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,186,129.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00022037', 'LIDIA LUCIA MORALES ZEPEDA', 'LIDIA LUCIA', 'MORALES', 'ZEPEDA', 'MOZL870518PK2', 'MOZL870518MDFRPD08', '1', None, None, '26221894', None, '22716168', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'FRACC. REAL DE TULTEPEC', 'TULTEPEC MEX', 'MEX', 'Mexico', '54987', '0', None, None, None, '30000007648', 'SI000001541', None, '1115000.64000', '1195000.64000', '.00000', '.00000', '1195000.64000', '.00000', '.00000', '.00000', '.00000', '-1197500.64000', '-2500.00000', '1-Jan-00', '19-Jun-15', '30-Jan-13', '30-Jan-13', '30-Jan-13', '0', None, '30-Jan-13', '30-Jan-13', '30-Jan-13', '30-Jan-13', '30-Jan-13', None, '13-Mar-14', '13-Mar-14', None, '25-Mar-14', None, '27-Mar-14', '12-Apr-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P159', '2', 'ESTACIONAMIENTO', 'AS1E014', 'AS100EA0630', None, None, None, None, '063', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '85,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00022037', 'LIDIA LUCIA MORALES ZEPEDA', 'LIDIA LUCIA', 'MORALES', 'ZEPEDA', 'MOZL870518PK2', 'MOZL870518MDFRPD08', '1', None, None, '26221894', None, '22716168', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'FRACC. REAL DE TULTEPEC', 'TULTEPEC MEX', 'MEX', 'Mexico', '54987', '0', None, None, None, '30000007648', 'SI000003272', None, '80000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '9-Dec-13', '9-Dec-13', '9-Dec-13', '0', None, '9-Dec-13', '9-Dec-13', '9-Dec-13', '9-Dec-13', '9-Dec-13', None, '13-Mar-14', '13-Mar-14', None, '25-Mar-14', None, '27-Mar-14', '12-Apr-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P166', '1', 'DEPARTAMENTO', 'AS1D166', 'AS10CD11040', None, None, '0C', '1', '104', None, '1', '0', 'AS975.DEPTO TIPO 2', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1ALCOBA, 2BAÑOS, PASILLO, PATIOLAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,130,971.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00024063', 'MARIA DE LOURDES MUÑOZ CARLIN', 'MARIA DE LOURDES', 'MUÑOZ', 'CARLIN', 'MUCL610110PE9', None, '1', None, None, '85793712', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SANTIAGO AHUIZOTLA', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02750', '0', None, None, None, '30000008596', 'SI000001164', None, '1083534.98000', '1148534.98000', '.00000', '.00000', '1148534.98000', '.00000', '.00000', '65012.09000', '.00000', '-1148534.98000', '65012.09000', '1-Jan-00', '19-Jun-15', '30-Oct-12', '30-Oct-12', '30-Oct-12', '0', None, '30-Oct-12', '30-Oct-12', '30-Oct-12', '30-Oct-12', '30-Oct-12', None, '31-Jul-13', '31-Jul-13', None, '31-Jul-13', None, '28-Aug-13', '5-Oct-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P166', '2', 'ESTACIONAMIENTO', 'AS1E142', 'AS100ED1930', None, None, None, None, '193', None, '1', '0', 'EST CDEX', 'Cajón Chico, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00024063', 'MARIA DE LOURDES MUÑOZ CARLIN', 'MARIA DE LOURDES', 'MUÑOZ', 'CARLIN', 'MUCL610110PE9', None, '1', None, None, '85793712', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SANTIAGO AHUIZOTLA', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02750', '0', None, None, None, '30000008596', 'SI000001217', None, '65000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '30-Nov-12', '30-Nov-12', '30-Nov-12', '0', None, '30-Nov-12', '30-Nov-12', '30-Nov-12', '30-Nov-12', '30-Nov-12', None, '28-Aug-13', '28-Aug-13', None, '28-Aug-13', None, '28-Aug-13', '5-Oct-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P175', '1', 'DEPARTAMENTO', 'AS1D175', 'AS10CD22050', None, None, '0C', '2', '205', None, '1', '0', 'AS975.DEPTO TIPO 2B', 'DEPTO, SALA/COMEDOR, COCINA,2RECÁMARAS, 1ALCOBA,  2BAÑOS, PASILLO, PATIO LAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,144,761.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00025697', 'DENNIS BENJAMIN HERNANDEZ GUTIERREZ', 'DENNIS BENJAMIN', 'HERNANDEZ', 'GUTIERREZ', 'HEGD800404PUA', None, '1', None, 'bvolcan@hotmail.com', '58801647', None, '5554656081', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN JUAN ATLAMICA', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54729', '0', None, None, None, '30000009370', 'SI000001154', None, '1096401.40000', '1166401.40000', '.00000', '.00000', '1166401.40000', '.00000', '.00000', '76748.10000', '.00000', '-1166401.40000', '76748.10000', '15-Jan-15', '15-Jan-15', '23-Oct-12', '23-Oct-12', '23-Oct-12', '0', None, '23-Oct-12', '23-Oct-12', '23-Oct-12', '23-Oct-12', '23-Oct-12', None, '31-Aug-13', '31-Aug-13', None, '31-Aug-13', None, '19-Sep-13', '28-Sep-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P175', '2', 'ESTACIONAMIENTO', 'AS1E141', 'AS100ED1910', None, None, None, None, '191', None, '1', '0', 'EST CDEX', 'Cajón Chico, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00025697', 'DENNIS BENJAMIN HERNANDEZ GUTIERREZ', 'DENNIS BENJAMIN', 'HERNANDEZ', 'GUTIERREZ', 'HEGD800404PUA', None, '1', None, 'bvolcan@hotmail.com', '58801647', None, '5554656081', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN JUAN ATLAMICA', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54729', '0', None, None, None, '30000009370', 'SI000001153', None, '70000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '23-Oct-12', '23-Oct-12', '23-Oct-12', '0', None, '23-Oct-12', '23-Oct-12', '23-Oct-12', '23-Oct-12', '23-Oct-12', None, '31-Aug-13', '31-Aug-13', None, '31-Aug-13', None, '19-Sep-13', '28-Sep-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P172', '1', 'DEPARTAMENTO', 'AS1D172', 'AS10CD22020', None, None, '0C', '2', '202', None, '1', '0', 'AS975.DEPTO TIPO 1B', 'DEPTO, SALA/COMEDOR, COCINA, 2 RECÁMARAS, 1 BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '14.4', None, '4.52', None, None, None, None, '49.5', '2.05', '0', '0', None, '0', '49.5', None, None, '0', None, None, None, None, None, '0', '1', '1', '916,917.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00025839', 'JESUS PEDROZA TORRES', 'JESUS', 'PEDROZA', 'TORRES', 'PETJ7006052JA', None, '1', None, None, '9138-5334', None, '04455-8541-8663', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'RICARDO FLORES MAGON', 'NAUCALPAN JUÁREZ MEX', 'NL', 'Mexico', '53820', '0', None, None, None, '30000009438', 'SI000001175', None, '959200.75000', '1029200.75000', '.00000', '.00000', '1029200.75000', '.00000', '.00000', '.00000', '.00000', '-1029200.75000', '.00000', '1-Jan-00', '19-Jun-15', '31-Oct-12', '31-Oct-12', '31-Oct-12', '0', None, '31-Oct-12', '31-Oct-12', '31-Oct-12', '31-Oct-12', '31-Oct-12', None, '31-Jul-13', '31-Jul-13', None, '31-Jul-13', None, '28-Aug-13', '2-Sep-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P172', '2', 'ESTACIONAMIENTO', 'AS1E143', 'AS100ED1950', None, None, None, None, '195', None, '1', '0', 'EST CDEX', 'Cajón Chico, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '85,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00025839', 'JESUS PEDROZA TORRES', 'JESUS', 'PEDROZA', 'TORRES', 'PETJ7006052JA', None, '1', None, None, '9138-5334', None, '04455-8541-8663', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'RICARDO FLORES MAGON', 'NAUCALPAN JUÁREZ MEX', 'NL', 'Mexico', '53820', '0', None, None, None, '30000009438', 'SI000001174', None, '70000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '31-Oct-12', '31-Oct-12', '31-Oct-12', '0', None, '31-Oct-12', '31-Oct-12', '31-Oct-12', '31-Oct-12', '31-Oct-12', None, '31-Jul-13', '31-Jul-13', None, '31-Jul-13', None, '28-Aug-13', '2-Sep-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P155', '1', 'DEPARTAMENTO', 'AS1D155', 'AS10CD00010', None, None, '0C', '0', '001', None, '1', '0', 'AS975. DEPTO TIPO 5', 'DEPTO, SALA/COMEDOR, COCINA, 2 RECÁMARAS, 1 BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '16.57', None, '4.71', None, None, None, None, '48.64', None, '0', '0', None, '0', '48.64', None, None, '0', None, None, None, None, None, '0', '1', '1', '845,758.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00026407', 'ROCIO MONROY GARCIA', 'ROCIO', 'MONROY', 'GARCIA', 'MOGR720121U41', None, '1', None, None, '41719942', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'CONJUNTO COACALCO', 'COACALCO MEX', 'MEX', 'Mexico', '55712', '0', None, None, None, '30000009651', 'SI000001540', None, '892805.60000', '892805.60000', '.00000', '.00000', '892805.60000', '.00000', '.00000', '.00000', '.00000', '-892805.60000', '.00000', '1-Jan-00', '19-Jun-15', '30-Jan-13', '30-Jan-13', '30-Jan-13', '0', None, '30-Jan-13', '30-Jan-13', '30-Jan-13', '30-Jan-13', '30-Jan-13', None, '26-Sep-13', '26-Sep-13', None, '26-Sep-13', None, '16-Oct-13', '25-Oct-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P174', '1', 'DEPARTAMENTO', 'AS1D174', 'AS10CD22040', None, None, '0C', '2', '204', None, '1', '0', 'AS975.DEPTO TIPO 2', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1ALCOBA, 2BAÑOS, PASILLO, PATIOLAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,144,761.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00026933', 'AMALIA GARCIA MORALES', 'AMALIA', 'GARCIA', 'MORALES', 'GAMA560212N44', None, '1', None, None, '53820052', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'REYNOSA TAMAULIPAS', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02200', '0', None, None, None, '30000009800', 'SI000001342', None, '1116401.40000', '1201401.40000', '.00000', '.00000', '1201401.40000', '.00000', '.00000', '94894.12000', '.00000', '-1201401.40000', '94894.12000', '15-Jan-15', '15-Jan-15', '28-Dec-12', '28-Dec-12', '28-Dec-12', '0', None, '28-Dec-12', '28-Dec-12', '28-Dec-12', '28-Dec-12', '28-Dec-12', None, '31-Aug-13', '31-Aug-13', None, '31-Aug-13', None, '4-Nov-13', '7-Nov-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P174', '2', 'ESTACIONAMIENTO', 'AS1E238', 'AS100EZ1520', None, None, None, None, '152', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '110,000.00 ', '0.00 ', '0.00 ', '0.00 ', '30-Apr-13', '30-Apr-13', '1-Nov-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00026933', 'AMALIA GARCIA MORALES', 'AMALIA', 'GARCIA', 'MORALES', 'GAMA560212N44', None, '1', None, None, '53820052', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'REYNOSA TAMAULIPAS', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02200', '0', None, None, None, '30000009800', 'SI000001341', None, '85000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '28-Dec-12', '28-Dec-12', '28-Dec-12', '0', None, '28-Dec-12', '28-Dec-12', '28-Dec-12', '28-Dec-12', '28-Dec-12', None, '31-Aug-13', '31-Aug-13', None, '31-Aug-13', None, '4-Nov-13', '7-Nov-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P090', '1', 'DEPARTAMENTO', 'AS1D090', 'AS10BD11060', None, None, '0B', '1', '106', None, '1', '0', 'AS975.DEPTO TIPO 2B', 'DEPTO, SALA/COMEDOR, COCINA,2RECÁMARAS, 1ALCOBA,  2BAÑOS, PASILLO, PATIO LAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,067,141.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Apr-14', '30-Apr-14', '1-Nov-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00027176', 'RAMON MARTINEZ PUGA', 'RAMON', 'MARTINEZ', 'PUGA', 'MAPR580614MF9', None, '1', None, 'repuga58@hotmail.com', '53182938', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'UH VILLAS AZC STO DOMINGO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02160', '0', None, None, None, '30000009867', 'SI000001207', None, '1019510.10000', '1194810.10000', '.00000', '.00000', '1194810.10000', '.00000', '.00000', '.00000', '.00000', '-1197014.10000', '-2204.00000', '15-Jan-15', '15-Jan-15', '28-Nov-12', '28-Nov-12', '28-Nov-12', '0', None, '28-Nov-12', '28-Nov-12', '28-Nov-12', '28-Nov-12', '28-Nov-12', None, '29-Nov-13', '29-Nov-13', None, '9-Dec-13', None, '23-Dec-13', '22-Feb-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P090', '2', 'ESTACIONAMIENTO', 'AS1E133', 'AS100ED1530', None, None, None, None, '153', None, '1', '0', 'EST CDEX', 'Cajón Chico, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '30-Nov-13', '30-Nov-13', '3-Jun-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00027176', 'RAMON MARTINEZ PUGA', 'RAMON', 'MARTINEZ', 'PUGA', 'MAPR580614MF9', None, '1', None, 'repuga58@hotmail.com', '53182938', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'UH VILLAS AZC STO DOMINGO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02160', '0', None, None, None, '30000009867', 'SI000001211', None, '70000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '29-Nov-12', '29-Nov-12', '29-Nov-12', '0', None, '29-Nov-12', '29-Nov-12', '29-Nov-12', '29-Nov-12', '29-Nov-12', None, '29-Nov-13', '29-Nov-13', None, '9-Dec-13', None, '23-Dec-13', '22-Feb-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P090', '2', 'ESTACIONAMIENTO', 'AS1E185', 'AS100EF1540', None, None, None, None, '154', None, '1', '0', 'EST CEEX', 'Cajón Chico, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '65,000.00 ', '0.00 ', '0.00 ', '0.00 ', '30-Nov-13', '30-Nov-13', '3-Jun-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00027176', 'RAMON MARTINEZ PUGA', 'RAMON', 'MARTINEZ', 'PUGA', 'MAPR580614MF9', None, '1', None, 'repuga58@hotmail.com', '53182938', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'UH VILLAS AZC STO DOMINGO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02160', '0', None, None, None, '30000009867', 'SI000001206', None, '65000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '28-Nov-12', '28-Nov-12', '28-Nov-12', '0', None, '28-Nov-12', '28-Nov-12', '28-Nov-12', '28-Nov-12', '28-Nov-12', None, '29-Nov-13', '29-Nov-13', None, '9-Dec-13', None, '23-Dec-13', '22-Feb-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P090', '3', 'BODEGA', 'AS1B042', 'AS100BD0420', None, None, None, None, '042', None, '1', '0', 'AS975. BODEGA TIPO 11', 'BODEGA DE 3.20 M2', None, None, None, None, None, None, None, None, None, None, None, None, None, '3.2', None, None, None, None, None, None, None, None, '0', None, None, None, None, None, '0', '1', '1', '21,320.00 ', '0.00 ', '0.00 ', '0.00 ', '1-Dec-13', '1-Dec-13', '4-Jun-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00027176', 'RAMON MARTINEZ PUGA', 'RAMON', 'MARTINEZ', 'PUGA', 'MAPR580614MF9', None, '1', None, 'repuga58@hotmail.com', '53182938', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'UH VILLAS AZC STO DOMINGO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02160', '0', None, None, None, '30000009867', 'SI000001912', None, '20800.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '7-Mar-13', '7-Mar-13', '7-Mar-13', '0', None, '7-Mar-13', '7-Mar-13', '7-Mar-13', '7-Mar-13', '7-Mar-13', None, '29-Nov-13', '29-Nov-13', None, '9-Dec-13', None, '23-Dec-13', '22-Feb-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P090', '3', 'BODEGA', 'AS1B041', 'AS100BD0410', None, None, None, None, '041', None, '1', '0', 'AS975. BODEGA TIPO 10', 'BODEGA DE 3 M2', None, None, None, None, None, None, None, None, None, None, None, None, None, '3', None, None, None, None, None, None, None, None, '0', None, None, None, None, None, '0', '1', '1', '19,988.00 ', '0.00 ', '0.00 ', '0.00 ', '1-Dec-13', '1-Dec-13', '4-Jun-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00027176', 'RAMON MARTINEZ PUGA', 'RAMON', 'MARTINEZ', 'PUGA', 'MAPR580614MF9', None, '1', None, 'repuga58@hotmail.com', '53182938', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'UH VILLAS AZC STO DOMINGO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02160', '0', None, None, None, '30000009867', 'SI000001911', None, '19500.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '7-Mar-13', '7-Mar-13', '7-Mar-13', '0', None, '7-Mar-13', '7-Mar-13', '7-Mar-13', '7-Mar-13', '7-Mar-13', None, '29-Nov-13', '29-Nov-13', None, '9-Dec-13', None, '23-Dec-13', '22-Feb-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P193', '1', 'DEPARTAMENTO', 'AS1D193', 'AS10CD44070', None, None, '0C', '4', '407', None, '1', '0', 'AS975.DEPTO TIPO 1', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '14.4', None, '4.52', None, None, None, None, '49.5', '2.05', '0', '0', None, '0', '49.5', None, None, '0', None, None, None, None, None, '0', '1', '1', '890,934.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00027250', 'PERLA FABIOLA LIMON ORTIZ', 'PERLA FABIOLA', 'LIMON', 'ORTIZ', 'LIOP6908279P5', None, '1', None, 'perlimon@gmail.com', '55347630', None, '52914331', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'U. CTM EL ROSARIO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02100', '0', None, None, None, '30000009883', 'SI000002460', None, '975501.11000', '1042126.11000', '.00000', '.00000', '1042126.11000', '.00000', '.00000', '.00000', '.00000', '-1042126.11000', '.00000', '15-Jan-15', '15-Jan-15', '30-Jun-13', '30-Jun-13', '30-Jun-13', '0', None, '30-Jun-13', '30-Jun-13', '30-Jun-13', '30-Jun-13', '30-Jun-13', None, '8-Oct-13', '8-Oct-13', None, '8-Oct-13', None, '23-Oct-13', '29-Oct-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P193', '2', 'ESTACIONAMIENTO', 'AS1E172', 'AS100EF0660', None, None, None, None, '066', None, '1', '0', 'EST CEEX', 'Cajón Chico, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '65,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00027250', 'PERLA FABIOLA LIMON ORTIZ', 'PERLA FABIOLA', 'LIMON', 'ORTIZ', 'LIOP6908279P5', None, '1', None, 'perlimon@gmail.com', '55347630', None, '52914331', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'U. CTM EL ROSARIO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02100', '0', None, None, None, '30000009883', 'SI000002457', None, '66625.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '30-Jun-13', '30-Jun-13', '30-Jun-13', '0', None, '30-Jun-13', '30-Jun-13', '30-Jun-13', '30-Jun-13', '30-Jun-13', None, '8-Oct-13', '8-Oct-13', None, '8-Oct-13', None, '23-Oct-13', '29-Oct-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P153', '1', 'DEPARTAMENTO', 'AS1D153', 'AS10BD55130', None, None, '0B', '5', '513', None, '1', '0', 'AS975.DEPTO TIPO 2', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1ALCOBA, 2BAÑOS, PASILLO, PATIOLAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '48.95', None, None, None, None, None, '0', '1', '1', '1,121,805.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Apr-14', '30-Apr-14', '1-Nov-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00027623', 'MARIO ENRIQUE FLORES MORA', 'MARIO ENRIQUE', 'FLORES', 'MORA', 'FOMM640708V67', None, '1', None, 'francisco.iniguez@quierocasaya.com.mx', '53 35 03 98', '55 91 99 66 41', '5523165479', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'TLACOQUEMECATL', 'BENITO JUÁREZ DF', 'DF', 'Mexico', '03200', '0', None, None, None, '30000009933', 'SI000001523', None, '1068058.20000', '1284208.20000', '.00000', '.00000', '1284208.20000', '.00000', '.00000', '85973.53000', '.00000', '-1284208.20000', '85973.53000', '15-Jan-15', '15-Jan-15', '29-Jan-13', '29-Jan-13', '29-Jan-13', '0', None, '29-Jan-13', '29-Jan-13', '29-Jan-13', '29-Jan-13', '29-Jan-13', None, '6-Dec-13', '6-Dec-13', None, '9-Dec-13', None, '18-Feb-14', '31-Mar-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P153', '2', 'ESTACIONAMIENTO', 'AS1E215', 'AS100EG1890', None, None, None, None, '189', None, '1', '0', 'EST DDEX', 'Cajón DISCAPACITADO, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '19', None, None, None, None, None, None, '3.8', None, '0', None, None, 'DISCAPACITADO', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '115,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00027623', 'MARIO ENRIQUE FLORES MORA', 'MARIO ENRIQUE', 'FLORES', 'MORA', 'FOMM640708V67', None, '1', None, 'francisco.iniguez@quierocasaya.com.mx', '53 35 03 98', '55 91 99 66 41', '5523165479', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'TLACOQUEMECATL', 'BENITO JUÁREZ DF', 'DF', 'Mexico', '03200', '0', None, None, None, '30000009933', 'SI000003046', None, '100575.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '14-Nov-13', '14-Nov-13', '14-Nov-13', '0', None, '14-Nov-13', '14-Nov-13', '14-Nov-13', '14-Nov-13', '14-Nov-13', None, '6-Dec-13', '6-Dec-13', None, '9-Dec-13', None, '18-Feb-14', '31-Mar-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P153', '2', 'ESTACIONAMIENTO', 'AS1E217', 'AS100EH1900', None, None, None, None, '190', None, '1', '0', 'EST DEEX', 'Cajón DISCAPACITADO, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '19', None, None, None, None, None, None, '3.8', None, '0', None, None, 'DISCAPACITADO', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '130,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00027623', 'MARIO ENRIQUE FLORES MORA', 'MARIO ENRIQUE', 'FLORES', 'MORA', 'FOMM640708V67', None, '1', None, 'francisco.iniguez@quierocasaya.com.mx', '53 35 03 98', '55 91 99 66 41', '5523165479', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'TLACOQUEMECATL', 'BENITO JUÁREZ DF', 'DF', 'Mexico', '03200', '0', None, None, None, '30000009933', 'SI000003045', None, '115575.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '14-Nov-13', '14-Nov-13', '14-Nov-13', '0', None, '14-Nov-13', '14-Nov-13', '14-Nov-13', '14-Nov-13', '14-Nov-13', None, '6-Dec-13', '6-Dec-13', None, '9-Dec-13', None, '18-Feb-14', '31-Mar-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P061', '1', 'DEPARTAMENTO', 'AS1D061', 'AS10AD55030', None, None, '0A', '5', '503', None, '1', '0', 'AS975.DEPTO TIPO 2', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1ALCOBA, 2BAÑOS, PASILLO, PATIOLAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '49.6', None, None, None, None, None, '0', '1', '1', '1,310,684.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Sep-14', '20-Sep-14', '24-Mar-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00027687', 'RICARDO CESAR GARCIA ALEGRIA', 'RICARDO CESAR', 'GARCIA', 'ALEGRIA', 'GAAR8402284S0', None, '1', None, None, '58739073', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BECERRA', 'ALVARO OBREGÓN DF', 'DF', 'Mexico', '01280', '0', None, None, None, '30000009941', 'SI000001219', None, '1109137.36000', '1244137.36000', '.00000', '.00000', '1244137.36000', '.00000', '.00000', '94276.68000', '.00000', '-1244137.36000', '94276.68000', '1-Jan-00', '19-Jun-15', '30-Nov-12', '30-Nov-12', '30-Nov-12', '0', None, '30-Nov-12', '30-Nov-12', '30-Nov-12', '30-Nov-12', '30-Nov-12', None, '5-Sep-14', '5-Sep-14', None, '9-Sep-14', None, '25-Sep-14', '17-Oct-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P061', '2', 'ESTACIONAMIENTO', 'AS1E181', 'AS100EF1350', None, None, None, None, '135', None, '1', '0', 'EST CEEX', 'Cajón Chico, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '65,000.00 ', '0.00 ', '0.00 ', '0.00 ', '1-Jun-14', '1-Jun-14', '3-Dec-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00027687', 'RICARDO CESAR GARCIA ALEGRIA', 'RICARDO CESAR', 'GARCIA', 'ALEGRIA', 'GAAR8402284S0', None, '1', None, None, '58739073', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BECERRA', 'ALVARO OBREGÓN DF', 'DF', 'Mexico', '01280', '0', None, None, None, '30000009941', 'SI000001283', None, '65000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '13-Dec-12', '13-Dec-12', '13-Dec-12', '0', None, '13-Dec-12', '13-Dec-12', '13-Dec-12', '13-Dec-12', '13-Dec-12', None, '5-Sep-14', '5-Sep-14', None, '9-Sep-14', None, '25-Sep-14', '17-Oct-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P061', '2', 'ESTACIONAMIENTO', 'AS1E129', 'AS100ED1340', None, None, None, None, '134', None, '1', '0', 'EST CDEX', 'Cajón Chico, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '1-Jun-14', '1-Jun-14', '3-Dec-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00027687', 'RICARDO CESAR GARCIA ALEGRIA', 'RICARDO CESAR', 'GARCIA', 'ALEGRIA', 'GAAR8402284S0', None, '1', None, None, '58739073', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BECERRA', 'ALVARO OBREGÓN DF', 'DF', 'Mexico', '01280', '0', None, None, None, '30000009941', 'SI000001282', None, '70000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '13-Dec-12', '13-Dec-12', '13-Dec-12', '0', None, '13-Dec-12', '13-Dec-12', '13-Dec-12', '13-Dec-12', '13-Dec-12', None, '5-Sep-14', '5-Sep-14', None, '9-Sep-14', None, '25-Sep-14', '17-Oct-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P138', '1', 'DEPARTAMENTO', 'AS1D138', 'AS10BD44120', None, None, '0B', '4', '412', None, '1', '0', 'AS975.DEPTO TIPO 1', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '14.4', None, '4.52', None, None, None, None, '49.5', '2.05', '0', '0', None, '0', '49.5', None, None, '0', None, None, None, None, None, '0', '1', '1', '958,984.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-14', '30-Jun-14', '1-Jan-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00028551', 'ALDO VEGA CASTRO', 'ALDO', 'VEGA', 'CASTRO', 'VECA8410081D2', 'VECA841008HMCGSL05', '1', None, None, '5539960788', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'ARBOLEDAS DE SAN MIGUEL', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54715', '0', None, None, None, '30000010295', 'SI000004171', None, '919488.13000', '984488.13000', '.00000', '.00000', '984488.13000', '.00000', '.00000', '113430.00000', '.00000', '-984488.13000', '113430.00000', '1-Jan-00', '19-Jun-15', '21-Mar-14', '21-Mar-14', '21-Mar-14', '0', None, '21-Mar-14', '21-Mar-14', '21-Mar-14', '21-Mar-14', '21-Mar-14', None, '9-May-14', '9-May-14', None, '29-May-14', None, '26-Jun-14', '5-Jul-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P138', '2', 'ESTACIONAMIENTO', 'AS1E206', 'AS100EF2220', None, None, None, None, '222', None, '1', '0', 'EST CEEX', 'Cajón Chico, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '65,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00028551', 'ALDO VEGA CASTRO', 'ALDO', 'VEGA', 'CASTRO', 'VECA8410081D2', 'VECA841008HMCGSL05', '1', None, None, '5539960788', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'ARBOLEDAS DE SAN MIGUEL', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54715', '0', None, None, None, '30000010295', 'SI000004170', None, '65000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '21-Mar-14', '21-Mar-14', '21-Mar-14', '0', None, '21-Mar-14', '21-Mar-14', '21-Mar-14', '21-Mar-14', '21-Mar-14', None, '9-May-14', '9-May-14', None, '29-May-14', None, '26-Jun-14', '5-Jul-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P145', '1', 'DEPARTAMENTO', 'AS1D145', 'AS10BD55050', None, None, '0B', '5', '505', None, '1', '0', 'AS975.DEPTO TIPO 2', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1ALCOBA, 2BAÑOS, PASILLO, PATIOLAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '49.73', None, None, None, None, None, '0', '1', '1', '1,121,805.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Apr-14', '30-Apr-14', '1-Nov-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00028972', 'RANULFO CARMONA RIOS', 'RANULFO', 'CARMONA', 'RIOS', 'CARR700527LA0', 'CARR700527HGRRSN09', '1', None, 'ranulfo.carmona@hotcimapasco.com.mx', '17422051', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BARR. DE SANTA CRUZ ACAYUCAN', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02770', '0', None, None, None, '30000010501', 'SI000001221', None, '1068058.20000', '1198058.20000', '.00000', '.00000', '1198058.20000', '.00000', '.00000', '69423.78000', '.00000', '-1199558.45000', '67923.53000', '15-Jan-15', '15-Jan-15', '30-Nov-12', '30-Nov-12', '30-Nov-12', '0', None, '30-Nov-12', '30-Nov-12', '30-Nov-12', '30-Nov-12', '30-Nov-12', None, '13-Mar-14', '13-Mar-14', None, '7-Apr-14', None, '29-Apr-14', '13-May-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P145', '2', 'ESTACIONAMIENTO', 'AS1E134', 'AS100ED1550', None, None, None, None, '155', None, '1', '0', 'EST CDEX', 'Cajón Chico, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00028972', 'RANULFO CARMONA RIOS', 'RANULFO', 'CARMONA', 'RIOS', 'CARR700527LA0', 'CARR700527HGRRSN09', '1', None, 'ranulfo.carmona@hotcimapasco.com.mx', '17422051', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BARR. DE SANTA CRUZ ACAYUCAN', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02770', '0', None, None, None, '30000010501', 'SI000001216', None, '70000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '30-Nov-12', '30-Nov-12', '30-Nov-12', '0', None, '30-Nov-12', '30-Nov-12', '30-Nov-12', '30-Nov-12', '30-Nov-12', None, '13-Mar-14', '13-Mar-14', None, '7-Apr-14', None, '29-Apr-14', '13-May-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P145', '2', 'ESTACIONAMIENTO', 'AS1E186', 'AS100EF1560', None, None, None, None, '156', None, '1', '0', 'EST CEEX', 'Cajón Chico, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '65,000.00 ', '0.00 ', '0.00 ', '0.00 ', '15-Nov-13', '15-Nov-13', '19-May-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00028972', 'RANULFO CARMONA RIOS', 'RANULFO', 'CARMONA', 'RIOS', 'CARR700527LA0', 'CARR700527HGRRSN09', '1', None, 'ranulfo.carmona@hotcimapasco.com.mx', '17422051', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BARR. DE SANTA CRUZ ACAYUCAN', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02770', '0', None, None, None, '30000010501', 'SI000001218', None, '60000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '30-Nov-12', '30-Nov-12', '30-Nov-12', '0', None, '30-Nov-12', '30-Nov-12', '30-Nov-12', '30-Nov-12', '30-Nov-12', None, '13-Mar-14', '13-Mar-14', None, '7-Apr-14', None, '29-Apr-14', '13-May-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P062', '1', 'DEPARTAMENTO', 'AS1D062', 'AS10AD55040', None, None, '0A', '5', '504', None, '1', '0', 'AS975.DEPTO TIPO 2B', 'DEPTO, SALA/COMEDOR, COCINA,2RECÁMARAS, 1ALCOBA,  2BAÑOS, PASILLO, PATIO LAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '48.95', None, None, None, None, None, '0', '1', '1', '1,310,684.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Sep-14', '20-Sep-14', '24-Mar-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00029093', 'VICTOR HUGO HERNANDEZ TRUJILLO', 'VICTOR HUGO', 'HERNANDEZ', 'TRUJILLO', 'HETV691231V42', 'HETV691231HGRRRC08', '1', None, None, '26280936', '53460000', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PUENTE DE VIGAS', 'AZCAPOTZALCO DF', 'MEX', 'Mexico', '54090', '0', None, None, None, '30000010576', 'SI000001220', None, '1109137.36000', '1264137.36000', '.00000', '.00000', '1264137.36000', '.00000', '.00000', '72093.93000', '.00000', '-1264137.39000', '72093.90000', '1-Jan-00', '19-Jun-15', '30-Nov-12', '30-Nov-12', '30-Nov-12', '0', None, '30-Nov-12', '30-Nov-12', '30-Nov-12', '30-Nov-12', '30-Nov-12', None, '5-Sep-14', '5-Sep-14', None, '18-Sep-14', None, '23-Sep-14', '11-Oct-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P062', '2', 'ESTACIONAMIENTO', 'AS1E031', 'AS100EA1260', None, None, None, None, '126', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '85,000.00 ', '0.00 ', '0.00 ', '0.00 ', '30-Jun-14', '30-Jun-14', '1-Jan-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00029093', 'VICTOR HUGO HERNANDEZ TRUJILLO', 'VICTOR HUGO', 'HERNANDEZ', 'TRUJILLO', 'HETV691231V42', 'HETV691231HGRRRC08', '1', None, None, '26280936', '53460000', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PUENTE DE VIGAS', 'AZCAPOTZALCO DF', 'MEX', 'Mexico', '54090', '0', None, None, None, '30000010576', 'SI000001339', None, '80000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '28-Dec-12', '28-Dec-12', '28-Dec-12', '0', None, '28-Dec-12', '28-Dec-12', '28-Dec-12', '28-Dec-12', '28-Dec-12', None, '5-Sep-14', '5-Sep-14', None, '18-Sep-14', None, '23-Sep-14', '11-Oct-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P062', '2', 'ESTACIONAMIENTO', 'AS1E083', 'AS100EC1270', None, None, None, None, '127', None, '1', '0', 'EST GEEX', 'Cajón Grande, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '30-Jun-14', '30-Jun-14', '1-Jan-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00029093', 'VICTOR HUGO HERNANDEZ TRUJILLO', 'VICTOR HUGO', 'HERNANDEZ', 'TRUJILLO', 'HETV691231V42', 'HETV691231HGRRRC08', '1', None, None, '26280936', '53460000', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PUENTE DE VIGAS', 'AZCAPOTZALCO DF', 'MEX', 'Mexico', '54090', '0', None, None, None, '30000010576', 'SI000001340', None, '75000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '28-Dec-12', '28-Dec-12', '28-Dec-12', '0', None, '28-Dec-12', '28-Dec-12', '28-Dec-12', '28-Dec-12', '28-Dec-12', None, '5-Sep-14', '5-Sep-14', None, '18-Sep-14', None, '23-Sep-14', '11-Oct-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P146', '1', 'DEPARTAMENTO', 'AS1D146', 'AS10BD55060', None, None, '0B', '5', '506', None, '1', '0', 'AS975.DEPTO TIPO 2B', 'DEPTO, SALA/COMEDOR, COCINA,2RECÁMARAS, 1ALCOBA,  2BAÑOS, PASILLO, PATIO LAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '49.07', None, None, None, None, None, '0', '1', '1', '1,121,805.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Apr-14', '30-Apr-14', '1-Nov-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00029097', 'JUAN GUADALUPE LECHUGA CARDENAS', 'JUAN GUADALUPE', 'LECHUGA', 'CARDENAS', 'LECJ670726S68', None, '1', None, None, '55657316', '52245000', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'U. TLALCALLI', 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54060', '0', None, None, None, '30000010584', 'SI000001222', None, '1068058.20000', '1213058.20000', '.00000', '.00000', '1213058.20000', '.00000', '.00000', '.00000', '.00000', '-1215262.20000', '-2204.00000', '1-Jan-00', '19-Jun-15', '30-Nov-12', '30-Nov-12', '30-Nov-12', '0', None, '30-Nov-12', '30-Nov-12', '30-Nov-12', '30-Nov-12', '30-Nov-12', None, '21-Nov-13', '21-Nov-13', None, '29-Nov-13', None, '17-Dec-13', '15-Feb-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P146', '2', 'ESTACIONAMIENTO', 'AS1E091', 'AS100EC1580', None, None, None, None, '158', None, '1', '0', 'EST GEEX', 'Cajón Grande, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '65,000.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Jun-14', '20-Jun-14', '22-Dec-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00029097', 'JUAN GUADALUPE LECHUGA CARDENAS', 'JUAN GUADALUPE', 'LECHUGA', 'CARDENAS', 'LECJ670726S68', None, '1', None, None, '55657316', '52245000', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'U. TLALCALLI', 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54060', '0', None, None, None, '30000010584', 'SI000003146', None, '65000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '2-Dec-13', '2-Dec-13', '2-Dec-13', '0', None, '2-Dec-13', '2-Dec-13', '2-Dec-13', '2-Dec-13', '2-Dec-13', None, '29-Nov-13', '29-Nov-13', None, '29-Nov-13', None, '17-Dec-13', '15-Feb-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P146', '2', 'ESTACIONAMIENTO', 'AS1E039', 'AS100EA1570', None, None, None, None, '157', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '30-Dec-13', '30-Dec-13', '3-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00029097', 'JUAN GUADALUPE LECHUGA CARDENAS', 'JUAN GUADALUPE', 'LECHUGA', 'CARDENAS', 'LECJ670726S68', None, '1', None, None, '55657316', '52245000', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'U. TLALCALLI', 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54060', '0', None, None, None, '30000010584', 'SI000001429', None, '80000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '9-Jan-13', '9-Jan-13', '9-Jan-13', '0', None, '9-Jan-13', '9-Jan-13', '9-Jan-13', '9-Jan-13', '9-Jan-13', None, '21-Nov-13', '21-Nov-13', None, '29-Nov-13', None, '17-Dec-13', '15-Feb-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P097', '1', 'DEPARTAMENTO', 'AS1D097', 'AS10BD11130', None, None, '0B', '1', '113', None, '1', '0', 'AS975.DEPTO TIPO 2', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1ALCOBA, 2BAÑOS, PASILLO, PATIOLAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,067,141.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Apr-14', '30-Apr-14', '1-Nov-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00030924', 'ELIZABETH LOPEZ SANCHEZ', 'ELIZABETH', 'LOPEZ', 'SANCHEZ', 'LOSE7902126Q1', None, '1', None, None, '55769602', '25813700', '5510106268', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'MONTEVIDEO 509 PISO 4 MZ .. LT', 'MIGUEL HIDALGO DF', 'DF', 'Mexico', '11230', '0', None, None, None, '30000011772', 'SI000001375', None, '1050095.40000', '1208970.40000', '.00000', '.00000', '1208970.40000', '.00000', '.00000', '.00000', '.00000', '-1211174.40000', '-2204.00000', '1-Jan-00', '19-Jun-15', '31-Dec-12', '31-Dec-12', '31-Dec-12', '0', None, '31-Dec-12', '31-Dec-12', '31-Dec-12', '31-Dec-12', '31-Dec-12', None, '28-Nov-13', '28-Nov-13', None, '9-Dec-13', None, '23-Dec-13', '22-Feb-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P097', '2', 'ESTACIONAMIENTO', 'AS1E028', 'AS100EA1090', None, None, None, None, '109', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '85,000.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Dec-13', '20-Dec-13', '23-Jun-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00030924', 'ELIZABETH LOPEZ SANCHEZ', 'ELIZABETH', 'LOPEZ', 'SANCHEZ', 'LOSE7902126Q1', None, '1', None, None, '55769602', '25813700', '5510106268', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'MONTEVIDEO 509 PISO 4 MZ .. LT', 'MIGUEL HIDALGO DF', 'DF', 'Mexico', '11230', '0', None, None, None, '30000011772', 'SI000002764', None, '82000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '19-Sep-13', '19-Sep-13', '19-Sep-13', '0', None, '19-Sep-13', '19-Sep-13', '19-Sep-13', '19-Sep-13', '19-Sep-13', None, '28-Nov-13', '28-Nov-13', None, '9-Dec-13', None, '23-Dec-13', '22-Feb-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P097', '2', 'ESTACIONAMIENTO', 'AS1E080', 'AS100EC1080', None, None, None, None, '108', None, '1', '0', 'EST GEEX', 'Cajón Grande, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Dec-13', '20-Dec-13', '23-Jun-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00030924', 'ELIZABETH LOPEZ SANCHEZ', 'ELIZABETH', 'LOPEZ', 'SANCHEZ', 'LOSE7902126Q1', None, '1', None, None, '55769602', '25813700', '5510106268', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'MONTEVIDEO 509 PISO 4 MZ .. LT', 'MIGUEL HIDALGO DF', 'DF', 'Mexico', '11230', '0', None, None, None, '30000011772', 'SI000002765', None, '76875.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '19-Sep-13', '19-Sep-13', '19-Sep-13', '0', None, '19-Sep-13', '19-Sep-13', '19-Sep-13', '19-Sep-13', '19-Sep-13', None, '28-Nov-13', '28-Nov-13', None, '9-Dec-13', None, '23-Dec-13', '22-Feb-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P183', '1', 'DEPARTAMENTO', 'AS1D183', 'AS10CD33050', None, None, '0C', '3', '305', None, '1', '0', 'AS975.DEPTO TIPO 2B', 'DEPTO, SALA/COMEDOR, COCINA,2RECÁMARAS, 1ALCOBA,  2BAÑOS, PASILLO, PATIO LAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,158,550.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00031072', 'ANA MARIA NAVA HINOJOSA', 'ANA MARIA', 'NAVA', 'HINOJOSA', 'NAHA7609012Z4', None, '1', None, None, '44441636', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'TIERRA NUEVA', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02130', '0', None, None, None, '30000011871', 'SI000001379', None, '1109267.81000', '1174267.81000', '.00000', '.00000', '1174267.81000', '.00000', '.00000', '72102.40000', '.00000', '-1174267.81000', '72102.40000', '1-Jan-00', '19-Jun-15', '31-Dec-12', '31-Dec-12', '31-Dec-12', '0', None, '31-Dec-12', '31-Dec-12', '31-Dec-12', '31-Dec-12', '31-Dec-12', None, '5-Feb-14', '5-Feb-14', None, '13-Feb-14', None, '24-Feb-14', '10-Mar-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P183', '2', 'ESTACIONAMIENTO', 'AS1E190', 'AS100EF1720', None, None, None, None, '172', None, '1', '0', 'EST CEEX', 'Cajón Chico, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '30-Apr-13', '30-Apr-13', '1-Nov-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00031072', 'ANA MARIA NAVA HINOJOSA', 'ANA MARIA', 'NAVA', 'HINOJOSA', 'NAHA7609012Z4', None, '1', None, None, '44441636', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'TIERRA NUEVA', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02130', '0', None, None, None, '30000011871', 'SI000001374', None, '65000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '31-Dec-12', '31-Dec-12', '31-Dec-12', '0', None, '31-Dec-12', '31-Dec-12', '31-Dec-12', '31-Dec-12', '31-Dec-12', None, '5-Feb-14', '5-Feb-14', None, '13-Feb-14', None, '24-Feb-14', '10-Mar-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P140', '1', 'DEPARTAMENTO', 'AS1D140', 'AS10BD44140', None, None, '0B', '4', '414', None, '1', '0', 'AS975.DEPTO TIPO 2B', 'DEPTO, SALA/COMEDOR, COCINA,2RECÁMARAS, 1ALCOBA,  2BAÑOS, PASILLO, PATIO LAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,108,139.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Apr-14', '30-Apr-14', '1-Nov-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00031076', 'HONGTIAN FENG', 'HONGTIAN', 'FENG', None, 'FEHN6310229G4', None, '1', None, None, '127488', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PASTEROS', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02150', '0', None, None, None, '30000011889', 'SI000001377', None, '1076722.83000', '1151722.83000', '.00000', '.00000', '1151722.83000', '.00000', '.00000', '69986.98000', '.00000', '-1154722.83000', '66986.98000', '1-Jan-00', '19-Jun-15', '31-Dec-12', '31-Dec-12', '31-Dec-12', '0', None, '31-Dec-12', '31-Dec-12', '31-Dec-12', '31-Dec-12', '31-Dec-12', None, '7-Feb-14', '7-Feb-14', None, '24-Feb-14', None, '20-Feb-14', '18-Mar-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P140', '2', 'ESTACIONAMIENTO', 'AS1E094', 'AS100EC1640', None, None, None, None, '164', None, '1', '0', 'EST GEEX', 'Cajón Grande, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '15-Dec-13', '15-Dec-13', '18-Jun-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00031076', 'HONGTIAN FENG', 'HONGTIAN', 'FENG', None, 'FEHN6310229G4', None, '1', None, None, '127488', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PASTEROS', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02150', '0', None, None, None, '30000011889', 'SI000001425', None, '75000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '4-Jan-13', '4-Jan-13', '4-Jan-13', '0', None, '4-Jan-13', '4-Jan-13', '4-Jan-13', '4-Jan-13', '4-Jan-13', None, '7-Feb-14', '7-Feb-14', None, '24-Feb-14', None, '20-Feb-14', '18-Mar-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P139', '1', 'DEPARTAMENTO', 'AS1D139', 'AS10BD44130', None, None, '0B', '4', '413', None, '1', '0', 'AS975.DEPTO TIPO 2', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1ALCOBA, 2BAÑOS, PASILLO, PATIOLAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,108,139.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Apr-14', '30-Apr-14', '1-Nov-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00031079', 'KA SHING HU', 'KA SHING', 'HU', None, 'HUK 861030I2A', None, '1', None, None, '55127488', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PASTEROS', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02150', '0', None, None, None, '30000011897', 'SI000001376', None, '1076722.83000', '1156722.83000', '.00000', '.00000', '1156722.83000', '.00000', '.00000', '.00000', '.00000', '-1156722.83000', '.00000', '1-Jan-00', '12-Mar-15', '31-Dec-12', '31-Dec-12', '31-Dec-12', '0', None, '31-Dec-12', '31-Dec-12', '31-Dec-12', '31-Dec-12', '31-Dec-12', None, '11-Nov-13', '11-Nov-13', None, '11-Nov-13', None, '14-Nov-13', '8-Mar-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P139', '2', 'ESTACIONAMIENTO', 'AS1E042', 'AS100EA1630', None, None, None, None, '163', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '85,000.00 ', '0.00 ', '0.00 ', '0.00 ', '15-Dec-13', '15-Dec-13', '18-Jun-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00031079', 'KA SHING HU', 'KA SHING', 'HU', None, 'HUK 861030I2A', None, '1', None, None, '55127488', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PASTEROS', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02150', '0', None, None, None, '30000011897', 'SI000001924', None, '80000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '12-Mar-15', '13-Mar-13', '13-Mar-13', '13-Mar-13', '0', None, '13-Mar-13', '13-Mar-13', '13-Mar-13', '13-Mar-13', '13-Mar-13', None, '11-Nov-13', '11-Nov-13', None, '11-Nov-13', None, '14-Nov-13', '8-Mar-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P066', '1', 'DEPARTAMENTO', 'AS1D066', 'AS10AD55080', None, None, '0A', '5', '508', None, '1', '0', 'AS975.DEPTO TIPO 1', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '14.4', None, '4.52', None, None, None, None, '49.5', '2.05', '0', '0', None, '0', '49.5', None, None, '48.45', None, None, None, None, None, '0', '1', '1', '1,166,888.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Sep-14', '20-Sep-14', '24-Mar-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00031725', 'ABEL GOMEZ RAMIREZ', 'ABEL', 'GOMEZ', 'RAMIREZ', 'GORA661114CU5', None, '1', None, None, '52368904', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'TIERRA NUEVA', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02130', '0', None, None, None, '30000012085', 'SI000001489', None, '1046700.23000', '1131700.23000', '.00000', '.00000', '1131700.23000', '.00000', '.00000', '.00000', '.00000', '-1131701.63000', '-1.40000', '1-Jan-00', '19-Jun-15', '22-Jan-13', '22-Jan-13', '22-Jan-13', '0', None, '22-Jan-13', '22-Jan-13', '22-Jan-13', '22-Jan-13', '22-Jan-13', None, '23-Sep-14', '23-Sep-14', None, '2-Oct-14', None, '17-Oct-14', '5-Nov-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P066', '2', 'ESTACIONAMIENTO', 'AS1E232', 'AS100EZ1190', None, None, None, None, '119', None, '1', '0', 'EST GUEX', 'Cajón Grande, Único, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Único', '0', '1', '1', '110,000.00 ', '0.00 ', '0.00 ', '0.00 ', '30-Jul-14', '30-Jul-14', '31-Jan-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00031725', 'ABEL GOMEZ RAMIREZ', 'ABEL', 'GOMEZ', 'RAMIREZ', 'GORA661114CU5', None, '1', None, None, '52368904', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'TIERRA NUEVA', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02130', '0', None, None, None, '30000012085', 'SI000001487', None, '85000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '22-Jan-13', '22-Jan-13', '22-Jan-13', '0', None, '22-Jan-13', '22-Jan-13', '22-Jan-13', '22-Jan-13', '22-Jan-13', None, '23-Sep-14', '23-Sep-14', None, '2-Oct-14', None, '17-Oct-14', '5-Nov-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P132', '1', 'DEPARTAMENTO', 'AS1D132', 'AS10BD44060', None, None, '0B', '4', '406', None, '1', '0', 'AS975.DEPTO TIPO 2B', 'DEPTO, SALA/COMEDOR, COCINA,2RECÁMARAS, 1ALCOBA,  2BAÑOS, PASILLO, PATIO LAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,108,139.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Apr-14', '30-Apr-14', '1-Nov-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00032436', 'FRANCISCO JACOME GALINDO', 'FRANCISCO', 'JACOME', 'GALINDO', 'JAGF650913ED9', 'JAGF650913HVZCLR08', '1', None, None, '63954170', '91387650', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'ANAHUAC', 'MIGUEL HIDALGO DF', 'DF', 'Mexico', '91697', '0', None, None, None, '30000012416', 'SI000004714', None, '1097166.78000', '1182166.78000', '.00000', '.00000', '1182166.78000', '.00000', '.00000', '121856.63000', '.00000', '-1182166.78000', '121856.63000', '1-Jan-00', '19-Jun-15', '29-May-14', '29-May-14', '29-May-14', '0', None, '29-May-14', '29-May-14', '29-May-14', '29-May-14', '29-May-14', None, '3-May-14', '3-May-14', None, '9-Jun-14', None, '17-Jun-14', '28-Jun-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P132', '2', 'ESTACIONAMIENTO', 'AS1E012', 'AS100EA0590', None, None, None, None, '059', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '85,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00032436', 'FRANCISCO JACOME GALINDO', 'FRANCISCO', 'JACOME', 'GALINDO', 'JAGF650913ED9', 'JAGF650913HVZCLR08', '1', None, None, '63954170', '91387650', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'ANAHUAC', 'MIGUEL HIDALGO DF', 'DF', 'Mexico', '91697', '0', None, None, None, '30000012416', 'SI000004713', None, '85000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '29-May-14', '29-May-14', '29-May-14', '0', None, '29-May-14', '29-May-14', '29-May-14', '29-May-14', '29-May-14', None, '3-May-14', '3-May-14', None, '9-Jun-14', None, '17-Jun-14', '28-Jun-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P026', '1', 'DEPARTAMENTO', 'AS1D026', 'AS10AD22040', None, None, '0A', '2', '204', None, '1', '0', 'AS975.DEPTO TIPO 2B', 'DEPTO, SALA/COMEDOR, COCINA,2RECÁMARAS, 1ALCOBA,  2BAÑOS, PASILLO, PATIO LAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,266,001.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Sep-14', '20-Sep-14', '24-Mar-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00032606', 'DELFINO RODRIGUEZ LAZARO', 'DELFINO', 'RODRIGUEZ', 'LAZARO', 'ROLD6406301S9', None, '1', None, 'delfino_rdz@hotmail.com', '53191905', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PASTEROS', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02150', '0', None, None, None, '30000012556', 'SI000001488', None, '1124249.36000', '1279249.36000', '.00000', '.00000', '1279249.36000', '.00000', '.00000', '73076.21000', '.00000', '-1046609.20000', '305716.37000', '15-Jan-15', '15-Jan-15', '22-Jan-13', '22-Jan-13', '22-Jan-13', '0', None, '22-Jan-13', '22-Jan-13', '22-Jan-13', '22-Jan-13', '22-Jan-13', None, '26-Sep-14', '26-Sep-14', None, '2-Oct-14', None, '17-Oct-14', '7-Nov-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P026', '2', 'ESTACIONAMIENTO', 'AS1E084', 'AS100EC1290', None, None, None, None, '129', None, '1', '0', 'EST GEEX', 'Cajón Grande, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '30-Jul-14', '30-Jul-14', '31-Jan-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00032606', 'DELFINO RODRIGUEZ LAZARO', 'DELFINO', 'RODRIGUEZ', 'LAZARO', 'ROLD6406301S9', None, '1', None, 'delfino_rdz@hotmail.com', '53191905', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PASTEROS', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02150', '0', None, None, None, '30000012556', 'SI000001486', None, '75000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '22-Jan-13', '22-Jan-13', '22-Jan-13', '0', None, '22-Jan-13', '22-Jan-13', '22-Jan-13', '22-Jan-13', '22-Jan-13', None, '26-Sep-14', '26-Sep-14', None, '2-Oct-14', None, '17-Oct-14', '7-Nov-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P034', '2', 'ESTACIONAMIENTO', 'AS1E032', 'AS100EA1280', None, None, None, None, '128', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '85,000.00 ', '0.00 ', '0.00 ', '0.00 ', '30-Jul-14', '30-Jul-14', '31-Jan-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00032606', 'DELFINO RODRIGUEZ LAZARO', 'DELFINO', 'RODRIGUEZ', 'LAZARO', 'ROLD6406301S9', None, '1', None, 'delfino_rdz@hotmail.com', '53191905', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PASTEROS', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02150', '0', None, None, None, '30000012556', 'SI000001484', None, '80000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '22-Jan-13', '22-Jan-13', '22-Jan-13', '0', None, '22-Jan-13', '22-Jan-13', '22-Jan-13', '22-Jan-13', '22-Jan-13', None, '26-Sep-14', '26-Sep-14', None, '2-Oct-14', None, '17-Oct-14', '7-Nov-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P034', '1', 'DEPARTAMENTO', 'AS1D034', 'AS10AD22120', None, None, '0A', '2', '212', None, '1', '0', 'AS975. DEPTO TIPO 9', 'DEPTO, S/C,COCINA, 2RECÁMARAS,1BAÑO,PASILLO,PATIO LAVADO,2BALCONES Y 1 TERRAZA', None, None, '2', None, '1', '2', '21.49', None, '4.71', None, None, None, None, '52.72', None, '19.1', '3.16', None, '0', '74.98', None, None, '22.34', None, None, None, None, None, '0', '1', '1', '1,336,224.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Sep-14', '20-Sep-14', '24-Mar-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00032606', 'DELFINO RODRIGUEZ LAZARO', 'DELFINO', 'RODRIGUEZ', 'LAZARO', 'ROLD6406301S9', None, '1', None, 'delfino_rdz@hotmail.com', '53191905', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PASTEROS', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02150', '0', None, None, None, '30000012564', 'SI000001578', None, '1186609.20000', '1186609.20000', '.00000', '.00000', '1186609.20000', '.00000', '.00000', '77129.60000', '.00000', '-140000.00000', '1123738.80000', '15-Jan-15', '15-Jan-15', '31-Jan-13', '31-Jan-13', '31-Jan-13', '0', None, '31-Jan-13', '31-Jan-13', '31-Jan-13', '31-Jan-13', '31-Jan-13', None, '11-May-15', '11-May-15', None, '19-May-15', None, '20-May-15', '28-May-15', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P169', '1', 'DEPARTAMENTO', 'AS1D169', 'AS10CD11070', None, None, '0C', '1', '107', None, '1', '0', 'AS975.DEPTO TIPO 1', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '14.4', None, '4.52', None, None, None, None, '49.5', '2.05', '0', '0', None, '0', '49.5', None, None, '0', None, None, None, None, None, '0', '1', '1', '856,478.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00032851', 'SONIA ALDACO DIAZ', 'SONIA', 'ALDACO', 'DIAZ', 'AADS7002214K1', 'AADS700221MDFLZN03', '1', None, None, '57579318', None, '5523004443', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'CONSTITUCION DE LA REPUBLICA', 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07469', '0', None, None, None, '30000012655', 'SI000001994', None, '931836.14000', '1013836.14000', '.00000', '.00000', '1013836.14000', '.00000', '.00000', '87378.17000', '.00000', '-1025789.69000', '75424.62000', '1-Jan-00', '19-Jun-15', '26-Mar-13', '26-Mar-13', '26-Mar-13', '0', None, '26-Mar-13', '26-Mar-13', '26-Mar-13', '26-Mar-13', '26-Mar-13', None, '27-Aug-13', '27-Aug-13', None, '27-Aug-13', None, '8-Oct-13', '15-Oct-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P169', '2', 'ESTACIONAMIENTO', 'AS1E145', 'AS100ED1990', None, None, None, None, '199', None, '1', '0', 'EST CDEX', 'Cajón Chico, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '85,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00032851', 'SONIA ALDACO DIAZ', 'SONIA', 'ALDACO', 'DIAZ', 'AADS7002214K1', 'AADS700221MDFLZN03', '1', None, None, '57579318', None, '5523004443', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'CONSTITUCION DE LA REPUBLICA', 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07469', '0', None, None, None, '30000012655', 'SI000002334', None, '82000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '31-May-13', '31-May-13', '31-May-13', '0', None, '31-May-13', '31-May-13', '31-May-13', '31-May-13', '31-May-13', None, '23-Apr-14', '23-Apr-14', None, '23-Apr-14', None, '23-Apr-14', '23-Apr-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P050', '1', 'DEPARTAMENTO', 'AS1D050', 'AS10AD44040', None, None, '0A', '4', '404', None, '1', '0', 'AS975.DEPTO TIPO 2B', 'DEPTO, SALA/COMEDOR, COCINA,2RECÁMARAS, 1ALCOBA,  2BAÑOS, PASILLO, PATIO LAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,295,789.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Sep-14', '20-Sep-14', '24-Mar-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00033769', 'GERARDO SARABIA LOPEZ', 'GERARDO', 'SARABIA', 'LOPEZ', 'VESG4703247Z6', '.', '1', None, None, '91937958', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LLANO DE LOS BAEZ', 'ECATEPEC MORELOS MEX', 'MEX', 'Mexico', '55055', '0', None, None, None, '30000013042', 'SI000001539', None, '1162325.54000', '1232325.54000', '.00000', '.00000', '1232325.54000', '.00000', '.00000', '81362.79000', '.00000', '-1232325.54000', '81362.79000', '1-Jan-00', '19-Jun-15', '30-Jan-13', '30-Jan-13', '30-Jan-13', '0', None, '30-Jan-13', '30-Jan-13', '30-Jan-13', '30-Jan-13', '30-Jan-13', None, '28-Aug-14', '28-Aug-14', None, '4-Sep-14', None, '11-Sep-14', '11-Oct-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P050', '2', 'ESTACIONAMIENTO', 'AS1E130', 'AS100ED1360', None, None, None, None, '136', None, '1', '0', 'EST CDEX', 'Cajón Chico, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '30-Jul-14', '30-Jul-14', '31-Jan-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00033769', 'GERARDO SARABIA LOPEZ', 'GERARDO', 'SARABIA', 'LOPEZ', 'VESG4703247Z6', '.', '1', None, None, '91937958', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LLANO DE LOS BAEZ', 'ECATEPEC MORELOS MEX', 'MEX', 'Mexico', '55055', '0', None, None, None, '30000013042', 'SI000001538', None, '70000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '30-Jan-13', '30-Jan-13', '30-Jan-13', '0', None, '30-Jan-13', '30-Jan-13', '30-Jan-13', '30-Jan-13', '30-Jan-13', None, '28-Aug-14', '28-Aug-14', None, '4-Sep-14', None, '11-Sep-14', '11-Oct-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P150', '1', 'DEPARTAMENTO', 'AS1D150', 'AS10BD55100', None, None, '0B', '5', '510', None, '1', '0', 'AS975.DEPTO TIPO 1', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '14.4', None, '4.52', None, None, None, None, '49.5', '2.05', '0', '0', None, '0', '49.5', None, None, '48.27', None, None, None, None, None, '0', '1', '1', '970,935.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Apr-14', '30-Apr-14', '1-Nov-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00033850', 'VERONICA RODRIGUEZ GODINEZ', 'VERONICA', 'RODRIGUEZ', 'GODINEZ', 'ROGV731021RNA', None, '1', None, None, '5558074950', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'UNIDAD HABITACIONAL EL ROSARIO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02100', '0', None, None, None, '30000013083', 'SI000001652', None, '962089.53000', '1097089.53000', '.00000', '.00000', '1097089.53000', '.00000', '.00000', '.00000', '.00000', '-1099293.53000', '-2204.00000', '1-Jan-00', '19-Jun-15', '13-Feb-13', '13-Feb-13', '13-Feb-13', '0', None, '13-Feb-13', '13-Feb-13', '13-Feb-13', '13-Feb-13', '13-Feb-13', None, '11-Nov-13', '11-Nov-13', None, '20-Nov-13', None, '9-Dec-13', '20-Feb-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P150', '2', 'ESTACIONAMIENTO', 'AS1E113', 'AS100ED0410', None, None, None, None, '041', None, '1', '0', 'EST CDEX', 'Cajón Chico, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00033850', 'VERONICA RODRIGUEZ GODINEZ', 'VERONICA', 'RODRIGUEZ', 'GODINEZ', 'ROGV731021RNA', None, '1', None, None, '5558074950', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'UNIDAD HABITACIONAL EL ROSARIO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02100', '0', None, None, None, '30000013083', 'SI000001650', None, '70000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '13-Feb-13', '13-Feb-13', '13-Feb-13', '0', None, '13-Feb-13', '13-Feb-13', '13-Feb-13', '13-Feb-13', '13-Feb-13', None, '11-Nov-13', '11-Nov-13', None, '20-Nov-13', None, '9-Dec-13', '20-Feb-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P150', '2', 'ESTACIONAMIENTO', 'AS1E165', 'AS100EF0400', None, None, None, None, '040', None, '1', '0', 'EST CEEX', 'Cajón Chico, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '65,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00033850', 'VERONICA RODRIGUEZ GODINEZ', 'VERONICA', 'RODRIGUEZ', 'GODINEZ', 'ROGV731021RNA', None, '1', None, None, '5558074950', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'UNIDAD HABITACIONAL EL ROSARIO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02100', '0', None, None, None, '30000013083', 'SI000001651', None, '65000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '13-Feb-13', '13-Feb-13', '13-Feb-13', '0', None, '13-Feb-13', '13-Feb-13', '13-Feb-13', '13-Feb-13', '13-Feb-13', None, '11-Nov-13', '11-Nov-13', None, '20-Nov-13', None, '9-Dec-13', '20-Feb-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P012', '1', 'DEPARTAMENTO', 'AS1D012', 'AS10AD11020', None, None, '0A', '1', '102', None, '1', '0', 'AS975. DEPTO TIPO 7', 'DEPTO, SALA/COMEDOR, COCINA, 2 RECÁMARAS, 1 BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '18.08', None, '4.71', None, None, None, None, '47.42', None, '0', '0', None, '0', '47.42', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,070,918.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Sep-14', '20-Sep-14', '24-Mar-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00034203', 'ERIKA MARTINEZ ANDRADE', 'ERIKA', 'MARTINEZ', 'ANDRADE', 'MAAES50711QB8', None, '1', None, None, '55 26 53 06 77', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PUE', None, 'PUE', 'Mexico', None, '0', None, None, None, '30000013158', 'SI000001577', None, '960614.93000', '1095614.93000', '.00000', '.00000', '1095614.93000', '.00000', '.00000', '.00000', '.00000', '-1095614.93000', '.00000', '1-Jan-00', '19-Jun-15', '31-Jan-13', '31-Jan-13', '31-Jan-13', '0', None, '31-Jan-13', '31-Jan-13', '31-Jan-13', '31-Jan-13', '31-Jan-13', None, '9-Sep-14', '9-Sep-14', None, '17-Sep-14', None, '25-Sep-14', '11-Oct-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P012', '2', 'ESTACIONAMIENTO', 'AS1E107', 'AS100ED0220', None, None, None, None, '022', None, '1', '0', 'EST CDEX', 'Cajón Chico, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00034203', 'ERIKA MARTINEZ ANDRADE', 'ERIKA', 'MARTINEZ', 'ANDRADE', 'MAAES50711QB8', None, '1', None, None, '55 26 53 06 77', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PUE', None, 'PUE', 'Mexico', None, '0', None, None, None, '30000013158', 'SI000001631', None, '70000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '6-Feb-13', '6-Feb-13', '6-Feb-13', '0', None, '6-Feb-13', '6-Feb-13', '6-Feb-13', '6-Feb-13', '6-Feb-13', None, '9-Sep-14', '9-Sep-14', None, '17-Sep-14', None, '25-Sep-14', '11-Oct-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P012', '2', 'ESTACIONAMIENTO', 'AS1E159', 'AS100EF0210', None, None, None, None, '021', None, '1', '0', 'EST CEEX', 'Cajón Chico, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '65,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00034203', 'ERIKA MARTINEZ ANDRADE', 'ERIKA', 'MARTINEZ', 'ANDRADE', 'MAAES50711QB8', None, '1', None, None, '55 26 53 06 77', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PUE', None, 'PUE', 'Mexico', None, '0', None, None, None, '30000013158', 'SI000001632', None, '65000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '6-Feb-13', '6-Feb-13', '6-Feb-13', '0', None, '6-Feb-13', '6-Feb-13', '6-Feb-13', '6-Feb-13', '6-Feb-13', None, '9-Sep-14', '9-Sep-14', None, '17-Sep-14', None, '25-Sep-14', '11-Oct-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P158', '1', 'DEPARTAMENTO', 'AS1D158', 'AS10CD00040', None, None, '0C', '0', '004', None, '1', '0', 'AS975.DEPTO TIPO 2', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1ALCOBA, 2BAÑOS, PASILLO, PATIOLAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,186,129.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00034920', 'BLANCA NIEVES MARTINEZ RODRIGUEZ', 'BLANCA NIEVES', 'MARTINEZ', 'RODRIGUEZ', 'MARB59090558A', None, '1', None, None, '5519163867', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN ESTEBAN', 'NAUCALPAN JUÁREZ MEX', 'DF', 'Mexico', '53550', '0', None, None, None, '30000013398', 'SI000001653', None, '1155000.64000', '1290000.64000', '.00000', '.00000', '1290000.64000', '.00000', '.00000', '.00000', '.00000', '-1297945.05000', '-7944.41000', '1-Jan-00', '19-Jun-15', '13-Feb-13', '13-Feb-13', '13-Feb-13', '0', None, '13-Feb-13', '13-Feb-13', '13-Feb-13', '13-Feb-13', '13-Feb-13', None, '31-Jul-13', '31-Jul-13', None, '31-Jul-13', None, '2-Oct-13', '15-Oct-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P158', '2', 'ESTACIONAMIENTO', 'AS1E121', 'AS100ED0790', None, None, None, None, '079', None, '1', '0', 'EST CDEX', 'Cajón Chico, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00034920', 'BLANCA NIEVES MARTINEZ RODRIGUEZ', 'BLANCA NIEVES', 'MARTINEZ', 'RODRIGUEZ', 'MARB59090558A', None, '1', None, None, '5519163867', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN ESTEBAN', 'NAUCALPAN JUÁREZ MEX', 'DF', 'Mexico', '53550', '0', None, None, None, '30000013398', 'SI000001838', None, '70000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '28-Feb-13', '28-Feb-13', '28-Feb-13', '0', None, '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', None, '31-Jul-13', '31-Jul-13', None, '31-Jul-13', None, '2-Oct-13', '15-Oct-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P158', '2', 'ESTACIONAMIENTO', 'AS1E173', 'AS100EF0780', None, None, None, None, '078', None, '1', '0', 'EST CEEX', 'Cajón Chico, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '65,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00034920', 'BLANCA NIEVES MARTINEZ RODRIGUEZ', 'BLANCA NIEVES', 'MARTINEZ', 'RODRIGUEZ', 'MARB59090558A', None, '1', None, None, '5519163867', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN ESTEBAN', 'NAUCALPAN JUÁREZ MEX', 'DF', 'Mexico', '53550', '0', None, None, None, '30000013398', 'SI000001842', None, '65000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '28-Feb-13', '28-Feb-13', '28-Feb-13', '0', None, '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', None, '31-Jul-13', '31-Jul-13', None, '31-Jul-13', None, '2-Oct-13', '15-Oct-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P126', '1', 'DEPARTAMENTO', 'AS1D126', 'AS10BD33140', None, None, '0B', '3', '314', None, '1', '0', 'AS975.DEPTO TIPO 2B', 'DEPTO, SALA/COMEDOR, COCINA,2RECÁMARAS, 1ALCOBA,  2BAÑOS, PASILLO, PATIO LAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,094,473.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Apr-14', '30-Apr-14', '1-Nov-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00035109', 'JUAN MOISES PAREDES LOPEZ', 'JUAN MOISES', 'PAREDES', 'LOPEZ', 'PALJ650127324', 'PALJ650127HDFRPN08', '1', None, None, '43560906', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PASTEROS', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02150', '0', None, None, None, '30000013497', 'SI000002081', None, '1096599.62000', '1096599.62000', '.00000', '.00000', '1096599.62000', '.00000', '.00000', '111448.27000', '.00000', '-1096599.62000', '111448.27000', '1-Jan-00', '19-Jun-15', '29-Mar-13', '29-Mar-13', '29-Mar-13', '0', None, '29-Mar-13', '29-Mar-13', '29-Mar-13', '29-Mar-13', '29-Mar-13', None, '2-Jun-14', '2-Jun-14', None, '5-Jun-14', None, '10-Jun-14', '23-Jun-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P004', '1', 'DEPARTAMENTO', 'AS1D004', 'AS10AD00040', None, None, '0A', '0', '004', None, '1', '0', 'AS975.DEPTO TIPO 2B', 'DEPTO, SALA/COMEDOR, COCINA,2RECÁMARAS, 1ALCOBA,  2BAÑOS, PASILLO, PATIO LAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,310,684.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Sep-14', '20-Sep-14', '24-Mar-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00035124', 'VERONICA RUEDA VALLADARES', 'VERONICA', 'RUEDA', 'VALLADARES', 'RUVV730629T3A', None, '1', None, None, '63550844', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'VIVEROS DE LA LOMA', 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54080', '0', None, None, None, '30000013513', 'SI000001759', None, '1175685.60000', '1260685.60000', '.00000', '.00000', '1260685.60000', '.00000', '.00000', '76419.56000', '.00000', '-1260685.60000', '76419.56000', '1-Jan-00', '19-Jun-15', '26-Feb-13', '26-Feb-13', '26-Feb-13', '0', None, '26-Feb-13', '26-Feb-13', '26-Feb-13', '26-Feb-13', '26-Feb-13', None, '13-Mar-15', '13-Mar-15', None, '19-Mar-15', None, '23-Mar-15', '16-Apr-15', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P004', '2', 'ESTACIONAMIENTO', 'AS1E233', 'AS100EZ1200', None, None, None, None, '120', None, '1', '0', 'EST GUEX', 'Cajón Grande, Único, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Único', '0', '1', '1', '110,000.00 ', '0.00 ', '0.00 ', '0.00 ', '31-Mar-15', '31-Mar-15', '2-Oct-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00035124', 'VERONICA RUEDA VALLADARES', 'VERONICA', 'RUEDA', 'VALLADARES', 'RUVV730629T3A', None, '1', None, None, '63550844', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'VIVEROS DE LA LOMA', 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54080', '0', None, None, None, '30000013513', 'SI000001768', None, '85000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '27-Feb-13', '27-Feb-13', '27-Feb-13', '0', None, '27-Feb-13', '27-Feb-13', '27-Feb-13', '27-Feb-13', '27-Feb-13', None, '13-Mar-15', '13-Mar-15', None, '19-Mar-15', None, '23-Mar-15', '16-Apr-15', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P082', '1', 'DEPARTAMENTO', 'AS1D082', 'AS10BD00120', None, None, '0B', '0', '012', None, '1', '0', 'AS975.DEPTO TIPO 1', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '14.4', None, '4.52', None, None, None, None, '49.5', '2.05', '0', '0', None, '0', '49.5', None, None, '0', None, None, None, None, None, '0', '1', '1', '970,935.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Apr-14', '30-Apr-14', '1-Nov-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00035239', 'LIDIA GARCIA SANCHEZ', 'LIDIA', 'GARCIA', 'SANCHEZ', 'GASL600214QS6', None, '1', None, None, '14857918', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LA LOMA', 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54060', '0', None, None, None, '30000013547', 'SI000001992', None, '981331.32000', '1116331.32000', '.00000', '.00000', '1116331.32000', '.00000', '.00000', '78699.49000', '.00000', '-1116331.32000', '78699.49000', '1-Jan-00', '19-Jun-15', '26-Mar-13', '26-Mar-13', '26-Mar-13', '0', None, '26-Mar-13', '26-Mar-13', '26-Mar-13', '26-Mar-13', '26-Mar-13', None, '20-Jan-14', '20-Jan-14', None, '6-Feb-14', None, '14-Feb-14', '20-Mar-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P082', '2', 'ESTACIONAMIENTO', 'AS1E183', 'AS100EF1470', None, None, None, None, '147', None, '1', '0', 'EST CEEX', 'Cajón Chico, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '65,000.00 ', '0.00 ', '0.00 ', '0.00 ', '30-Dec-13', '30-Dec-13', '3-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00035239', 'LIDIA GARCIA SANCHEZ', 'LIDIA', 'GARCIA', 'SANCHEZ', 'GASL600214QS6', None, '1', None, None, '14857918', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LA LOMA', 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54060', '0', None, None, None, '30000013547', 'SI000002037', None, '65000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '28-Mar-13', '28-Mar-13', '28-Mar-13', '0', None, '28-Mar-13', '28-Mar-13', '28-Mar-13', '28-Mar-13', '28-Mar-13', None, '20-Jan-14', '20-Jan-14', None, '6-Feb-14', None, '14-Feb-14', '20-Mar-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P082', '2', 'ESTACIONAMIENTO', 'AS1E131', 'AS100ED1460', None, None, None, None, '146', None, '1', '0', 'EST CDEX', 'Cajón Chico, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '30-Dec-13', '30-Dec-13', '3-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00035239', 'LIDIA GARCIA SANCHEZ', 'LIDIA', 'GARCIA', 'SANCHEZ', 'GASL600214QS6', None, '1', None, None, '14857918', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LA LOMA', 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54060', '0', None, None, None, '30000013547', 'SI000002036', None, '70000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '28-Mar-13', '28-Mar-13', '28-Mar-13', '0', None, '28-Mar-13', '28-Mar-13', '28-Mar-13', '28-Mar-13', '28-Mar-13', None, '20-Jan-14', '20-Jan-14', None, '6-Feb-14', None, '14-Feb-14', '20-Mar-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P096', '1', 'DEPARTAMENTO', 'AS1D096', 'AS10BD11120', None, None, '0B', '1', '112', None, '1', '0', 'AS975.DEPTO TIPO 1', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '14.4', None, '4.52', None, None, None, None, '49.5', '2.05', '0', '0', None, '0', '49.5', None, None, '0', None, None, None, None, None, '0', '1', '1', '923,129.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Apr-14', '30-Apr-14', '1-Nov-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00035689', 'TERESA MONTES DE OCA SANCHEZ', 'TERESA', 'MONTES DE OCA', 'SANCHEZ', 'MOST731003QL7', None, '1', None, 'tms_10@hotmail.com', None, None, '55666267', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'JARDINES DEL MOLINITO', 'NAUCALPAN JUÁREZ MEX', 'MEX', 'Mexico', '53530', '0', None, None, None, '30000013703', 'SI000001993', None, '936725.35000', '1021725.35000', '.00000', '.00000', '1021725.35000', '.00000', '.00000', '.00000', '.00000', '-1024225.35000', '-2500.00000', '15-Jan-15', '15-Jan-15', '26-Mar-13', '26-Mar-13', '26-Mar-13', '0', None, '26-Mar-13', '26-Mar-13', '26-Mar-13', '26-Mar-13', '26-Mar-13', None, '19-Mar-14', '19-Mar-14', None, '27-Mar-14', None, '8-Jul-14', '21-Jul-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P096', '2', 'ESTACIONAMIENTO', 'AS1E231', 'AS100EZ0390', None, None, None, None, '039', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '110,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00035689', 'TERESA MONTES DE OCA SANCHEZ', 'TERESA', 'MONTES DE OCA', 'SANCHEZ', 'MOST731003QL7', None, '1', None, 'tms_10@hotmail.com', None, None, '55666267', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'JARDINES DEL MOLINITO', 'NAUCALPAN JUÁREZ MEX', 'MEX', 'Mexico', '53530', '0', None, None, None, '30000013703', 'SI000001991', None, '85000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '26-Mar-13', '26-Mar-13', '26-Mar-13', '0', None, '26-Mar-13', '26-Mar-13', '26-Mar-13', '26-Mar-13', '26-Mar-13', None, '19-Mar-14', '19-Mar-14', None, '27-Mar-14', None, '8-Jul-14', '21-Jul-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P197', '1', 'DEPARTAMENTO', 'AS1D197', 'AS10CD55030', None, None, '0C', '5', '503', None, '1', '0', 'AS975.DEPTO TIPO 1', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '14.4', None, '4.52', None, None, None, None, '49.5', '2.05', '0', '0', None, '0', '49.5', None, None, '48.6', None, None, None, None, None, '0', '1', '1', '1,013,393.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00036011', 'CARLOS EMMANUEL SANCHEZ GARCIA', 'CARLOS EMMANUEL', 'SANCHEZ', 'GARCIA', 'SAGC761228DYV', None, '1', None, 'csanchez@cnsf.gob.mx', '5554357629', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'NARVARTE PONIENTE', 'BENITO JUÁREZ DF', 'DF', 'Mexico', '03020', '0', None, None, None, '30000013877', 'SI000001857', None, '1049219.06000', '1184219.06000', '.00000', '.00000', '1184219.06000', '.00000', '.00000', '89183.60000', '.00000', '-1184219.06000', '89183.60000', '15-Jan-15', '15-Jan-15', '28-Feb-13', '28-Feb-13', '28-Feb-13', '0', None, '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', None, '31-Aug-13', '31-Aug-13', None, '31-Aug-13', None, '16-Oct-13', '19-Oct-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P197', '2', 'ESTACIONAMIENTO', 'AS1E144', 'AS100ED1970', None, None, None, None, '197', None, '1', '0', 'EST CDEX', 'Cajón Chico, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '85,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00036011', 'CARLOS EMMANUEL SANCHEZ GARCIA', 'CARLOS EMMANUEL', 'SANCHEZ', 'GARCIA', 'SAGC761228DYV', None, '1', None, 'csanchez@cnsf.gob.mx', '5554357629', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'NARVARTE PONIENTE', 'BENITO JUÁREZ DF', 'DF', 'Mexico', '03020', '0', None, None, None, '30000013877', 'SI000001840', None, '70000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '28-Feb-13', '28-Feb-13', '28-Feb-13', '0', None, '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', None, '31-Aug-13', '31-Aug-13', None, '31-Aug-13', None, '16-Oct-13', '19-Oct-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P197', '2', 'ESTACIONAMIENTO', 'AS1E196', 'AS100EF1980', None, None, None, None, '198', None, '1', '0', 'EST CEEX', 'Cajón Chico, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00036011', 'CARLOS EMMANUEL SANCHEZ GARCIA', 'CARLOS EMMANUEL', 'SANCHEZ', 'GARCIA', 'SAGC761228DYV', None, '1', None, 'csanchez@cnsf.gob.mx', '5554357629', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'NARVARTE PONIENTE', 'BENITO JUÁREZ DF', 'DF', 'Mexico', '03020', '0', None, None, None, '30000013877', 'SI000001844', None, '65000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '28-Feb-13', '28-Feb-13', '28-Feb-13', '0', None, '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', None, '31-Aug-13', '31-Aug-13', None, '31-Aug-13', None, '16-Oct-13', '19-Oct-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P144', '1', 'DEPARTAMENTO', 'AS1D144', 'AS10BD55040', None, None, '0B', '5', '504', None, '1', '0', 'AS975.DEPTO TIPO 4', 'DEPTO, SALA/COMEDOR, COCINA, 2 RECÁMARAS, 1 BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '17.2', None, '4.67', None, None, None, None, '55.17', None, '0', '0', None, '0', '55.17', None, None, '63.33', None, None, None, None, None, '0', '1', '1', '1,029,538.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Apr-14', '30-Apr-14', '1-Nov-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00036250', 'EUGENIA LUCAS VALERIO', 'EUGENIA', 'LUCAS', 'VALERIO', 'LUVE640916666', None, '1', None, None, '53533258', None, '0445543837576', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SANTO DOMINGO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02160', '0', None, None, None, '30000013943', 'SI000001852', None, '1015697.49000', '1170697.49000', '.00000', '.00000', '1170697.49000', '.00000', '.00000', '86334.28000', '.00000', '-1170697.49000', '86334.28000', '1-Jan-00', '19-Jun-15', '28-Feb-13', '28-Feb-13', '28-Feb-13', '0', None, '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', None, '26-May-14', '26-May-14', None, '3-Jun-14', None, '22-Jul-14', '23-Sep-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P144', '2', 'ESTACIONAMIENTO', 'AS1E090', 'AS100EC1450', None, None, None, None, '145', None, '1', '0', 'EST GEEX', 'Cajón Grande, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '30-Dec-13', '30-Dec-13', '3-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00036250', 'EUGENIA LUCAS VALERIO', 'EUGENIA', 'LUCAS', 'VALERIO', 'LUVE640916666', None, '1', None, None, '53533258', None, '0445543837576', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SANTO DOMINGO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02160', '0', None, None, None, '30000013943', 'SI000001837', None, '75000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '28-Feb-13', '28-Feb-13', '28-Feb-13', '0', None, '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', None, '26-May-14', '26-May-14', None, '3-Jun-14', None, '22-Jul-14', '23-Sep-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P144', '2', 'ESTACIONAMIENTO', 'AS1E038', 'AS100EA1440', None, None, None, None, '144', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '85,000.00 ', '0.00 ', '0.00 ', '0.00 ', '30-Dec-13', '30-Dec-13', '3-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00036250', 'EUGENIA LUCAS VALERIO', 'EUGENIA', 'LUCAS', 'VALERIO', 'LUVE640916666', None, '1', None, None, '53533258', None, '0445543837576', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SANTO DOMINGO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02160', '0', None, None, None, '30000013943', 'SI000001836', None, '80000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '28-Feb-13', '28-Feb-13', '28-Feb-13', '0', None, '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', None, '26-May-14', '26-May-14', None, '3-Jun-14', None, '22-Jul-14', '23-Sep-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P013', '1', 'DEPARTAMENTO', 'AS1D013', 'AS10AD11030', None, None, '0A', '1', '103', None, '1', '0', 'AS975.DEPTO TIPO 2', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1ALCOBA, 2BAÑOS, PASILLO, PATIOLAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,251,107.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Sep-14', '20-Sep-14', '24-Mar-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00036267', 'DAVID VICENTE ORDOÑEZ SANTANA', 'DAVID VICENTE', 'ORDOÑEZ', 'SANTANA', 'OOSD830912772', None, '1', None, 'davidvic@hotmail.com', '55270430', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'HUICHAPAN', 'MIGUEL HIDALGO DF', 'DF', 'Mexico', '11290', '0', None, None, None, '30000013968', 'SI000001847', None, '1122245.34000', '1207245.34000', '.00000', '.00000', '1207245.34000', '.00000', '.00000', '78565.22000', '.00000', '-1207245.34000', '78565.22000', '15-Jan-15', '15-Jan-15', '28-Feb-13', '28-Feb-13', '28-Feb-13', '0', None, '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', None, '22-Sep-14', '22-Sep-14', None, '26-Sep-14', None, '2-Oct-14', '17-Oct-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P013', '2', 'ESTACIONAMIENTO', 'AS1E226', 'AS100EZ0070', None, None, None, None, '007', None, '1', '0', 'EST GUEX', 'Cajón Grande, Único, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Único', '0', '1', '1', '110,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00036267', 'DAVID VICENTE ORDOÑEZ SANTANA', 'DAVID VICENTE', 'ORDOÑEZ', 'SANTANA', 'OOSD830912772', None, '1', None, 'davidvic@hotmail.com', '55270430', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'HUICHAPAN', 'MIGUEL HIDALGO DF', 'DF', 'Mexico', '11290', '0', None, None, None, '30000013968', 'SI000001846', None, '85000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '28-Feb-13', '28-Feb-13', '28-Feb-13', '0', None, '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', None, '22-Sep-14', '22-Sep-14', None, '26-Sep-14', None, '2-Oct-14', '17-Oct-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P149', '1', 'DEPARTAMENTO', 'AS1D149', 'AS10BD55090', None, None, '0B', '5', '509', None, '1', '0', 'AS975.DEPTO TIPO 1B', 'DEPTO, SALA/COMEDOR, COCINA, 2 RECÁMARAS, 1 BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '14.4', None, '4.52', None, None, None, None, '49.5', '2.05', '0', '0', None, '0', '49.5', None, None, '48.23', None, None, None, None, None, '0', '1', '1', '970,935.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Apr-14', '30-Apr-14', '1-Nov-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00036268', 'LILIANA MATA GOMEZ', 'LILIANA', 'MATA', 'GOMEZ', 'MAGL700521JV3', None, '1', None, None, '5515023779', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'CTM CULHUACAN', 'COYOACÁN DF', 'DF', 'Mexico', '04489', '0', None, None, None, '30000013976', 'SI000001853', None, '962089.53000', '1032089.53000', '.00000', '.00000', '1032089.53000', '.00000', '.00000', '62535.82000', '.00000', '-1032089.53000', '62535.82000', '1-Jan-00', '19-Jun-15', '28-Feb-13', '28-Feb-13', '28-Feb-13', '0', None, '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', None, '6-Nov-14', '6-Nov-14', None, '11-Nov-14', None, '13-Nov-14', '9-Dec-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P149', '2', 'ESTACIONAMIENTO', 'AS1E126', 'AS100ED1050', None, None, None, None, '105', None, '1', '0', 'EST CDEX', 'Cajón Chico, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '30-Jan-14', '30-Jan-14', '3-Aug-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00036268', 'LILIANA MATA GOMEZ', 'LILIANA', 'MATA', 'GOMEZ', 'MAGL700521JV3', None, '1', None, None, '5515023779', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'CTM CULHUACAN', 'COYOACÁN DF', 'DF', 'Mexico', '04489', '0', None, None, None, '30000013976', 'SI000002297', None, '70000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '21-May-13', '21-May-13', '21-May-13', '0', None, '21-May-13', '21-May-13', '21-May-13', '21-May-13', '21-May-13', None, '6-Nov-14', '6-Nov-14', None, '11-Nov-14', None, '13-Nov-14', '9-Dec-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P196', '1', 'DEPARTAMENTO', 'AS1D196', 'AS10CD55020', None, None, '0C', '5', '502', None, '1', '0', 'AS975.DEPTO TIPO 1B', 'DEPTO, SALA/COMEDOR, COCINA, 2 RECÁMARAS, 1 BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '14.4', None, '4.52', None, None, None, None, '49.5', '2.05', '0', '0', None, '0', '49.5', None, None, '48.21', None, None, None, None, None, '0', '1', '1', '1,013,393.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00036767', 'FLOR MIREYA ANGUIANO VARGAS', 'FLOR MIREYA', 'ANGUIANO', 'VARGAS', 'AUVF470324LU0', None, '1', None, None, '37326551', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN BARTOLO ATEPEHUACAN', 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07730', '0', None, None, None, '30000014230', 'SI000002082', None, '1079711.25000', '1219711.25000', '.00000', '.00000', '1219711.25000', '.00000', '.00000', '.00000', '.00000', '-1203049.13000', '16662.12000', '1-Jan-00', '19-Jun-15', '29-Mar-13', '29-Mar-13', '29-Mar-13', '0', None, '29-Mar-13', '29-Mar-13', '29-Mar-13', '29-Mar-13', '29-Mar-13', None, '24-Oct-13', '24-Oct-13', None, '24-Oct-13', None, '16-Jan-14', '14-Mar-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P196', '2', 'ESTACIONAMIENTO', 'AS1E018', 'AS100EA0750', None, None, None, None, '075', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '85,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00036767', 'FLOR MIREYA ANGUIANO VARGAS', 'FLOR MIREYA', 'ANGUIANO', 'VARGAS', 'AUVF470324LU0', None, '1', None, None, '37326551', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN BARTOLO ATEPEHUACAN', 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07730', '0', None, None, None, '30000014230', 'SI000002074', None, '80000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '29-Mar-13', '29-Mar-13', '29-Mar-13', '0', None, '29-Mar-13', '29-Mar-13', '29-Mar-13', '29-Mar-13', '29-Mar-13', None, '24-Oct-13', '24-Oct-13', None, '24-Oct-13', None, '16-Jan-14', '14-Mar-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P196', '2', 'ESTACIONAMIENTO', 'AS1E070', 'AS100EC0740', None, None, None, None, '074', None, '1', '0', 'EST GEEX', 'Cajón Grande, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00036767', 'FLOR MIREYA ANGUIANO VARGAS', 'FLOR MIREYA', 'ANGUIANO', 'VARGAS', 'AUVF470324LU0', None, '1', None, None, '37326551', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN BARTOLO ATEPEHUACAN', 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07730', '0', None, None, None, '30000014230', 'SI000002076', None, '60000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '29-Mar-13', '29-Mar-13', '29-Mar-13', '0', None, '29-Mar-13', '29-Mar-13', '29-Mar-13', '29-Mar-13', '29-Mar-13', None, '24-Oct-13', '24-Oct-13', None, '24-Oct-13', None, '16-Jan-14', '14-Mar-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P058', '1', 'DEPARTAMENTO', 'AS1D058', 'AS10AD44120', None, None, '0A', '4', '412', None, '1', '0', 'AS975. DEPTO TIPO 9', 'DEPTO, S/C,COCINA, 2RECÁMARAS,1BAÑO,PASILLO,PATIO LAVADO,2BALCONES Y 1 TERRAZA', None, None, '2', None, '1', '2', '21.49', None, '4.71', None, None, None, None, '52.72', None, '19.1', '3.16', None, '0', '74.98', None, None, '22.34', None, None, None, None, None, '0', '1', '1', '1,398,824.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Sep-14', '20-Sep-14', '24-Mar-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00037097', 'NOEMI JUDITH VAZQUEZ OCAMPO', 'NOEMI JUDITH', 'VAZQUEZ', 'OCAMPO', 'VAON7306292G6', None, '1', None, None, '5518509309', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'ZONA ESCOLAR', 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07230', '0', None, None, None, '30000014321', 'SI000001665', None, '1226797.39000', '1404747.39000', '.00000', '.00000', '1404747.39000', '.00000', '.00000', '104277.77000', '.00000', '-1404747.39000', '104277.77000', '1-Jan-00', '19-Jun-15', '18-Feb-13', '18-Feb-13', '18-Feb-13', '0', None, '18-Feb-13', '18-Feb-13', '18-Feb-13', '18-Feb-13', '18-Feb-13', None, '29-Oct-14', '29-Oct-14', None, '7-Nov-14', None, '7-Nov-14', '2-Dec-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P058', '2', 'ESTACIONAMIENTO', 'AS1E219', 'AS100EI0020', None, None, None, None, '002', None, '1', '0', 'EST CUEX', 'Cajón Chico, Único, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Único', '0', '1', '1', '100,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00037097', 'NOEMI JUDITH VAZQUEZ OCAMPO', 'NOEMI JUDITH', 'VAZQUEZ', 'OCAMPO', 'VAON7306292G6', None, '1', None, None, '5518509309', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'ZONA ESCOLAR', 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07230', '0', None, None, None, '30000014321', 'SI000001679', None, '75000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '19-Feb-13', '19-Feb-13', '19-Feb-13', '0', None, '19-Feb-13', '19-Feb-13', '19-Feb-13', '19-Feb-13', '19-Feb-13', None, '29-Oct-14', '29-Oct-14', None, '7-Nov-14', None, '7-Nov-14', '2-Dec-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P058', '2', 'ESTACIONAMIENTO', 'AS1E218', 'AS100EI0010', None, None, None, None, '001', None, '1', '0', 'EST CUEX', 'Cajón Chico, Único, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Único', '0', '1', '1', '100,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00037097', 'NOEMI JUDITH VAZQUEZ OCAMPO', 'NOEMI JUDITH', 'VAZQUEZ', 'OCAMPO', 'VAON7306292G6', None, '1', None, None, '5518509309', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'ZONA ESCOLAR', 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07230', '0', None, None, None, '30000014321', 'SI000001664', None, '75000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '18-Feb-13', '18-Feb-13', '18-Feb-13', '0', None, '18-Feb-13', '18-Feb-13', '18-Feb-13', '18-Feb-13', '18-Feb-13', None, '29-Oct-14', '29-Oct-14', None, '7-Nov-14', None, '7-Nov-14', '2-Dec-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P058', '3', 'BODEGA', 'AS1B018', 'AS100BD0180', None, None, None, None, '018', None, '1', '0', 'AS975. BODEGA TIPO 6', 'BODEGA DE 4.30 M2', None, None, None, None, None, None, None, None, None, None, None, None, None, '4.3', None, None, None, None, None, None, None, None, '0', None, None, None, None, None, '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '1-Mar-14', '1-Mar-14', '2-Sep-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00037097', 'NOEMI JUDITH VAZQUEZ OCAMPO', 'NOEMI JUDITH', 'VAZQUEZ', 'OCAMPO', 'VAON7306292G6', None, '1', None, None, '5518509309', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'ZONA ESCOLAR', 'GUSTAVO A. MADERO DF', 'DF', 'Mexico', '07230', '0', None, None, None, '30000014321', 'SI000001990', None, '27950.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '26-Mar-13', '26-Mar-13', '26-Mar-13', '0', None, '26-Mar-13', '26-Mar-13', '26-Mar-13', '26-Mar-13', '26-Mar-13', None, '29-Oct-14', '29-Oct-14', None, '7-Nov-14', None, '7-Nov-14', '2-Dec-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P046', '1', 'DEPARTAMENTO', 'AS1D046', 'AS10AD33120', None, None, '0A', '3', '312', None, '1', '0', 'AS975. DEPTO TIPO 9', 'DEPTO, S/C,COCINA, 2RECÁMARAS,1BAÑO,PASILLO,PATIO LAVADO,2BALCONES Y 1 TERRAZA', None, None, '2', None, '1', '2', '21.49', None, '4.71', None, None, None, None, '52.72', None, '19.1', '3.16', None, '0', '74.98', None, None, '22.34', None, None, None, None, None, '0', '1', '1', '1,351,944.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Sep-14', '20-Sep-14', '24-Mar-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00037176', 'MARTHA ROCIO VARGAS SANCHEZ', 'MARTHA ROCIO', 'VARGAS', 'SANCHEZ', 'VASM601002DY1', 'VASM601002MDFRNR03', '1', None, None, '5529593772', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PASTEROS', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02150', '0', None, None, None, '30010105556', 'SI000001682', None, '1212696.27000', '1322396.27000', '.00000', '.00000', '1322396.27000', '.00000', '.00000', '127527.65000', '.00000', '-1322396.27000', '127527.65000', '1-Jan-00', '19-Jun-15', '19-Feb-13', '19-Feb-13', '19-Feb-13', '0', None, '19-Feb-13', '19-Feb-13', '19-Feb-13', '19-Feb-13', '19-Feb-13', None, '28-Nov-14', '28-Nov-14', None, '9-Dec-14', None, '3-Feb-15', '5-Feb-15', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P046', '2', 'ESTACIONAMIENTO', 'AS1E235', 'AS100EZ1220', None, None, None, None, '122', None, '1', '0', 'EST GUEX', 'Cajón Grande, Único, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Único', '0', '1', '1', '110,000.00 ', '0.00 ', '0.00 ', '0.00 ', '30-Jul-14', '30-Jul-14', '31-Jan-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00037176', 'MARTHA ROCIO VARGAS SANCHEZ', 'MARTHA ROCIO', 'VARGAS', 'SANCHEZ', 'VASM601002DY1', 'VASM601002MDFRNR03', '1', None, None, '5529593772', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PASTEROS', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02150', '0', None, None, None, '30010105556', 'SI000001681', None, '85000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '19-Feb-13', '19-Feb-13', '19-Feb-13', '0', None, '19-Feb-13', '19-Feb-13', '19-Feb-13', '19-Feb-13', '19-Feb-13', None, '28-Nov-14', '28-Nov-14', None, '9-Dec-14', None, '3-Feb-15', '5-Feb-15', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P046', '3', 'BODEGA', 'AS1B043', 'AS100BD0430', None, None, None, None, '043', None, '1', '0', 'AS975. BODEGA TIPO 12', 'BODEGA DE 3.40 M2', None, None, None, None, None, None, None, None, None, None, None, None, None, '3.4', None, None, None, None, None, None, None, None, '0', None, None, None, None, None, '0', '1', '1', '25,318.00 ', '0.00 ', '0.00 ', '0.00 ', '1-Dec-13', '1-Dec-13', '4-Jun-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00037176', 'MARTHA ROCIO VARGAS SANCHEZ', 'MARTHA ROCIO', 'VARGAS', 'SANCHEZ', 'VASM601002DY1', 'VASM601002MDFRNR03', '1', None, None, '5529593772', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PASTEROS', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02150', '0', None, None, None, '30010105556', 'SI000001678', None, '24700.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '19-Feb-13', '19-Feb-13', '19-Feb-13', '0', None, '19-Feb-13', '19-Feb-13', '19-Feb-13', '19-Feb-13', '19-Feb-13', None, '28-Nov-14', '28-Nov-14', None, '9-Dec-14', None, '3-Feb-15', '5-Feb-15', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P067', '1', 'DEPARTAMENTO', 'AS1D067', 'AS10AD55090', None, None, '0A', '5', '509', None, '1', '0', 'AS975.DEPTO TIPO 8B', 'DEPTO, SALA/COMEDOR, COCINA, 2 RECÁMARAS, 1BAÑO, PASILLO, PATIO LAVADO, 2 BALCON', None, None, '2', None, '1', '0', '16.67', None, '4.71', None, None, None, None, '48.66', None, '0', '0', None, '0', '48.66', None, None, '48.41', None, None, None, None, None, '0', '1', '1', '1,199,666.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Sep-14', '20-Sep-14', '24-Mar-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00037244', 'MIGUEL ANGEL GOMEZ AGUILAR', 'MIGUEL ANGEL', 'GOMEZ', 'AGUILAR', 'GOAM731130BX2', None, '1', None, None, '55630797', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'NONOALCO', 'BENITO JUÁREZ DF', 'DF', 'Mexico', '03700', '0', None, None, None, '30000014388', 'SI000001579', None, '1076102.84000', '1263607.84000', '.00000', '.00000', '1263607.84000', '.00000', '.00000', '75327.20000', '.00000', '-1288107.84000', '50827.20000', '1-Jan-00', '19-Jun-15', '31-Jan-13', '31-Jan-13', '31-Jan-13', '0', None, '31-Jan-13', '31-Jan-13', '31-Jan-13', '31-Jan-13', '31-Jan-13', None, '9-Sep-14', '9-Sep-14', None, '9-Sep-14', None, '3-Mar-15', '3-Mar-15', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P067', '2', 'ESTACIONAMIENTO', 'AS1E221', 'AS100EI0040', None, None, None, None, '004', None, '1', '0', 'EST CUEX', 'Cajón Chico, Único, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Único', '0', '1', '1', '100,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00037244', 'MIGUEL ANGEL GOMEZ AGUILAR', 'MIGUEL ANGEL', 'GOMEZ', 'AGUILAR', 'GOAM731130BX2', None, '1', None, None, '55630797', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'NONOALCO', 'BENITO JUÁREZ DF', 'DF', 'Mexico', '03700', '0', None, None, None, '30000014388', 'SI000001575', None, '75000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '31-Jan-13', '31-Jan-13', '31-Jan-13', '0', None, '31-Jan-13', '31-Jan-13', '31-Jan-13', '31-Jan-13', '31-Jan-13', None, '9-Sep-14', '9-Sep-14', None, '9-Sep-14', None, '3-Mar-15', '3-Mar-15', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P067', '2', 'ESTACIONAMIENTO', 'AS1E222', 'AS100EI0050', None, None, None, None, '005', None, '1', '0', 'EST CUEX', 'Cajón Chico, Único, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Único', '0', '1', '1', '100,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00037244', 'MIGUEL ANGEL GOMEZ AGUILAR', 'MIGUEL ANGEL', 'GOMEZ', 'AGUILAR', 'GOAM731130BX2', None, '1', None, None, '55630797', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'NONOALCO', 'BENITO JUÁREZ DF', 'DF', 'Mexico', '03700', '0', None, None, None, '30000014388', 'SI000001576', None, '75000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '31-Jan-13', '31-Jan-13', '31-Jan-13', '0', None, '31-Jan-13', '31-Jan-13', '31-Jan-13', '31-Jan-13', '31-Jan-13', None, '9-Sep-14', '9-Sep-14', None, '9-Sep-14', None, '3-Mar-15', '3-Mar-15', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P067', '3', 'BODEGA', 'AS1B039', 'AS100BD0390', None, None, None, None, '039', None, '1', '0', 'AS975. BODEGA TIPO 9', 'BODEGA DE 5.77 M2', None, None, None, None, None, None, None, None, None, None, None, None, None, '5.77', None, None, None, None, None, None, None, None, '0', None, None, None, None, None, '0', '1', '1', '38,443.00 ', '0.00 ', '0.00 ', '0.00 ', '1-Dec-13', '1-Dec-13', '4-Jun-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00037244', 'MIGUEL ANGEL GOMEZ AGUILAR', 'MIGUEL ANGEL', 'GOMEZ', 'AGUILAR', 'GOAM731130BX2', None, '1', None, None, '55630797', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'NONOALCO', 'BENITO JUÁREZ DF', 'DF', 'Mexico', '03700', '0', None, None, None, '30000014388', 'SI000001572', None, '37505.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '31-Jan-13', '31-Jan-13', '31-Jan-13', '0', None, '31-Jan-13', '31-Jan-13', '31-Jan-13', '31-Jan-13', '31-Jan-13', None, '9-Sep-14', '9-Sep-14', None, '9-Sep-14', None, '3-Mar-15', '3-Mar-15', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P089', '1', 'DEPARTAMENTO', 'AS1D089', 'AS10BD11050', None, None, '0B', '1', '105', None, '1', '0', 'AS975.DEPTO TIPO 2', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1ALCOBA, 2BAÑOS, PASILLO, PATIOLAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,067,141.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-14', '30-Jun-14', '1-Jan-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00037750', 'ISABEL CABRERA CRUZ', 'ISABEL', 'CABRERA', 'CRUZ', 'CACI6307025W6', None, '1', None, '15-ab-el@hotmail.com', '5527620960', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BOULEVARES DEL LAGO', 'VILLA DE ALLENDE MEX', 'MEX', 'Mexico', None, '0', None, None, None, '30000014495', 'SI000001960', None, '1071097.31000', '1156097.31000', '.00000', '.00000', '1156097.31000', '.00000', '.00000', '.00000', '.00000', '-1164569.31000', '-8472.00000', '15-Jan-15', '15-Jan-15', '20-Mar-13', '20-Mar-13', '20-Mar-13', '0', None, '20-Mar-13', '20-Mar-13', '20-Mar-13', '20-Mar-13', '20-Mar-13', None, '30-Jan-14', '30-Jan-14', None, '6-Feb-14', None, '17-Feb-14', '15-Mar-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P089', '2', 'ESTACIONAMIENTO', 'AS1E229', 'AS100EZ0370', None, None, None, None, '037', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '110,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00037750', 'ISABEL CABRERA CRUZ', 'ISABEL', 'CABRERA', 'CRUZ', 'CACI6307025W6', None, '1', None, '15-ab-el@hotmail.com', '5527620960', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BOULEVARES DEL LAGO', 'VILLA DE ALLENDE MEX', 'MEX', 'Mexico', None, '0', None, None, None, '30000014495', 'SI000001958', None, '85000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '20-Mar-13', '20-Mar-13', '20-Mar-13', '0', None, '20-Mar-13', '20-Mar-13', '20-Mar-13', '20-Mar-13', '20-Mar-13', None, '30-Jan-14', '30-Jan-14', None, '6-Feb-14', None, '17-Feb-14', '15-Mar-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P111', '1', 'DEPARTAMENTO', 'AS1D111', 'AS10BD22130', None, None, '0B', '2', '213', None, '1', '0', 'AS975.DEPTO TIPO 2', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1ALCOBA, 2BAÑOS, PASILLO, PATIOLAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,080,807.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Apr-14', '30-Apr-14', '1-Nov-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00037899', 'CARLOS JASSO JIMENEZ', 'CARLOS', 'JASSO', 'JIMENEZ', 'JAJC7606112B0', None, '1', None, None, '5529665277', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'MARGARITA MAZA DE JUAREZ', 'ATIZAPÁN ZARAGOZA MEX', 'MEX', 'Mexico', '52926', '0', None, None, None, '30000014529', 'SI000002080', None, '1083848.47000', '1238848.47000', '.00000', '.00000', '1238848.47000', '.00000', '.00000', '98521.93000', '.00000', '-1238848.47000', '98521.93000', '1-Jan-00', '19-Jun-15', '29-Mar-13', '29-Mar-13', '29-Mar-13', '0', None, '29-Mar-13', '29-Mar-13', '29-Mar-13', '29-Mar-13', '29-Mar-13', None, '27-Jan-14', '27-Jan-14', None, '13-Feb-14', None, '30-Apr-14', '16-May-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P111', '2', 'ESTACIONAMIENTO', 'AS1E093', 'AS100EC1620', None, None, None, None, '162', None, '1', '0', 'EST GEEX', 'Cajón Grande, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '30-Dec-13', '30-Dec-13', '3-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00037899', 'CARLOS JASSO JIMENEZ', 'CARLOS', 'JASSO', 'JIMENEZ', 'JAJC7606112B0', None, '1', None, None, '5529665277', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'MARGARITA MAZA DE JUAREZ', 'ATIZAPÁN ZARAGOZA MEX', 'MEX', 'Mexico', '52926', '0', None, None, None, '30000014529', 'SI000002077', None, '75000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '29-Mar-13', '29-Mar-13', '29-Mar-13', '0', None, '29-Mar-13', '29-Mar-13', '29-Mar-13', '29-Mar-13', '29-Mar-13', None, '27-Jan-14', '27-Jan-14', None, '13-Feb-14', None, '30-Apr-14', '16-May-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P111', '2', 'ESTACIONAMIENTO', 'AS1E041', 'AS100EA1610', None, None, None, None, '161', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '85,000.00 ', '0.00 ', '0.00 ', '0.00 ', '30-Dec-13', '30-Dec-13', '3-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00037899', 'CARLOS JASSO JIMENEZ', 'CARLOS', 'JASSO', 'JIMENEZ', 'JAJC7606112B0', None, '1', None, None, '5529665277', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'MARGARITA MAZA DE JUAREZ', 'ATIZAPÁN ZARAGOZA MEX', 'MEX', 'Mexico', '52926', '0', None, None, None, '30000014529', 'SI000002075', None, '80000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '29-Mar-13', '29-Mar-13', '29-Mar-13', '0', None, '29-Mar-13', '29-Mar-13', '29-Mar-13', '29-Mar-13', '29-Mar-13', None, '27-Jan-14', '27-Jan-14', None, '13-Feb-14', None, '30-Apr-14', '16-May-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P131', '1', 'DEPARTAMENTO', 'AS1D131', 'AS10BD44050', None, None, '0B', '4', '405', None, '1', '0', 'AS975.DEPTO TIPO 2', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1ALCOBA, 2BAÑOS, PASILLO, PATIOLAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,108,139.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Apr-14', '30-Apr-14', '1-Nov-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00037946', 'ETELBERTO VEGA PONTAZA', 'ETELBERTO', 'VEGA', 'PONTAZA', 'VEPE550520080', None, '1', None, None, '53528228', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN PEDRO XALPA', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02710', '0', None, None, None, '30000014560', 'SI000002039', None, '1109350.78000', '1244350.78000', '.00000', '.00000', '1244350.78000', '.00000', '.00000', '94294.81000', '.00000', '-1246850.78000', '91794.81000', '1-Jan-00', '19-Jun-15', '28-Mar-13', '28-Mar-13', '28-Mar-13', '0', None, '28-Mar-13', '28-Mar-13', '28-Mar-13', '28-Mar-13', '28-Mar-13', None, '18-Mar-14', '18-Mar-14', None, '19-Mar-14', None, '21-Mar-14', '1-Apr-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P131', '2', 'ESTACIONAMIENTO', 'AS1E200', 'AS100EF2060', None, None, None, None, '206', None, '1', '0', 'EST CEEX', 'Cajón Chico, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '65,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00037946', 'ETELBERTO VEGA PONTAZA', 'ETELBERTO', 'VEGA', 'PONTAZA', 'VEPE550520080', None, '1', None, None, '53528228', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN PEDRO XALPA', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02710', '0', None, None, None, '30000014560', 'SI000002079', None, '65000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '29-Mar-13', '29-Mar-13', '29-Mar-13', '0', None, '29-Mar-13', '29-Mar-13', '29-Mar-13', '29-Mar-13', '29-Mar-13', None, '7-May-14', '7-May-14', None, '7-May-14', None, '7-May-14', '7-May-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P131', '2', 'ESTACIONAMIENTO', 'AS1E148', 'AS100ED2050', None, None, None, None, '205', None, '1', '0', 'EST CDEX', 'Cajón Chico, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00037946', 'ETELBERTO VEGA PONTAZA', 'ETELBERTO', 'VEGA', 'PONTAZA', 'VEPE550520080', None, '1', None, None, '53528228', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN PEDRO XALPA', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02710', '0', None, None, None, '30000014560', 'SI000002078', None, '70000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '29-Mar-13', '29-Mar-13', '29-Mar-13', '0', None, '29-Mar-13', '29-Mar-13', '29-Mar-13', '29-Mar-13', '29-Mar-13', None, '7-May-14', '7-May-14', None, '7-May-14', None, '7-May-14', '7-May-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P022', '1', 'DEPARTAMENTO', 'AS1D022', 'AS10AD11120', None, None, '0A', '1', '112', None, '1', '0', 'AS975. DEPTO TIPO 9', 'DEPTO, S/C,COCINA, 2RECÁMARAS,1BAÑO,PASILLO,PATIO LAVADO,2BALCONES Y 1 TERRAZA', None, None, '2', None, '1', '2', '21.49', None, '4.71', None, None, None, None, '52.72', None, '19.1', '3.16', None, '0', '74.98', None, None, '22.34', None, None, None, None, None, '0', '1', '1', '1,320,503.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Sep-14', '20-Sep-14', '24-Mar-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00038217', 'JOSE LUIS LOPEZ HERNANDEZ', 'JOSE LUIS', 'LOPEZ', 'HERNANDEZ', 'LOHL470516IL4', 'LOHL470516', '1', None, 'jlopez@hotmail.com', '53591339', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN PEDRO XALPA', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02710', '0', None, None, None, '30000014685', 'SI000001848', None, '1184494.03000', '1259494.03000', '.00000', '.00000', '1259494.03000', '.00000', '.00000', '106604.00000', '.00000', '-1259495.00000', '106603.03000', '15-Jan-15', '15-Jan-15', '28-Feb-13', '28-Feb-13', '28-Feb-13', '0', None, '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', None, '10-Nov-14', '10-Nov-14', None, '11-Nov-14', None, '13-Nov-14', '9-Dec-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P022', '2', 'ESTACIONAMIENTO', 'AS1E224', 'AS100EI1180', None, None, None, None, '118', None, '1', '0', 'EST CUEX', 'Cajón Chico, Único, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Único', '0', '1', '1', '100,000.00 ', '0.00 ', '0.00 ', '0.00 ', '30-Jul-14', '30-Jul-14', '31-Jan-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00038217', 'JOSE LUIS LOPEZ HERNANDEZ', 'JOSE LUIS', 'LOPEZ', 'HERNANDEZ', 'LOHL470516IL4', 'LOHL470516', '1', None, 'jlopez@hotmail.com', '53591339', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN PEDRO XALPA', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02710', '0', None, None, None, '30000014685', 'SI000001943', None, '75000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '19-Mar-13', '19-Mar-13', '19-Mar-13', '0', None, '19-Mar-13', '19-Mar-13', '19-Mar-13', '19-Mar-13', '19-Mar-13', None, '10-Nov-14', '10-Nov-14', None, '11-Nov-14', None, '13-Nov-14', '9-Dec-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P117', '1', 'DEPARTAMENTO', 'AS1D117', 'AS10BD33050', None, None, '0B', '3', '305', None, '1', '0', 'AS975.DEPTO TIPO 2', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1ALCOBA, 2BAÑOS, PASILLO, PATIOLAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,094,473.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Apr-14', '30-Apr-14', '1-Nov-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00038237', 'MARISOL ELIZABETH FLORES GONZALEZ', 'MARISOL ELIZABETH', 'FLORES', 'GONZALEZ', 'FOGM840203EF9', None, '1', None, 'marisol@hotmail.com', '5513908316', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'NUEVO AXALCO', 'TLALPAN DF', 'DF', 'Mexico', '14400', '0', None, None, None, '30000014693', 'SI000002241', None, '1124014.61000', '1259014.61000', '.00000', '.00000', '1259014.61000', '.00000', '.00000', '91484.64000', '.00000', '-1259014.62000', '91484.63000', '15-Jan-15', '15-Jan-15', '30-Apr-13', '30-Apr-13', '30-Apr-13', '0', None, '30-Apr-13', '30-Apr-13', '30-Apr-13', '30-Apr-13', '30-Apr-13', None, '7-Feb-14', '7-Feb-14', None, '17-Feb-14', None, '26-Feb-14', '28-Mar-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P117', '2', 'ESTACIONAMIENTO', 'AS1E114', 'AS100ED0430', None, None, None, None, '043', None, '1', '0', 'EST CDEX', 'Cajón Chico, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00038237', 'MARISOL ELIZABETH FLORES GONZALEZ', 'MARISOL ELIZABETH', 'FLORES', 'GONZALEZ', 'FOGM840203EF9', None, '1', None, 'marisol@hotmail.com', '5513908316', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'NUEVO AXALCO', 'TLALPAN DF', 'DF', 'Mexico', '14400', '0', None, None, None, '30000014693', 'SI000002285', None, '70000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '17-May-13', '17-May-13', '17-May-13', '0', None, '17-May-13', '17-May-13', '17-May-13', '17-May-13', '17-May-13', None, '7-Feb-14', '7-Feb-14', None, '17-Feb-14', None, '26-Feb-14', '28-Mar-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P117', '2', 'ESTACIONAMIENTO', 'AS1E166', 'AS100EF0420', None, None, None, None, '042', None, '1', '0', 'EST CEEX', 'Cajón Chico, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '65,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00038237', 'MARISOL ELIZABETH FLORES GONZALEZ', 'MARISOL ELIZABETH', 'FLORES', 'GONZALEZ', 'FOGM840203EF9', None, '1', None, 'marisol@hotmail.com', '5513908316', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'NUEVO AXALCO', 'TLALPAN DF', 'DF', 'Mexico', '14400', '0', None, None, None, '30000014693', 'SI000002298', None, '65000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '21-May-13', '21-May-13', '21-May-13', '0', None, '21-May-13', '21-May-13', '21-May-13', '21-May-13', '21-May-13', None, '7-Feb-14', '7-Feb-14', None, '17-Feb-14', None, '26-Feb-14', '28-Mar-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P031', '1', 'DEPARTAMENTO', 'AS1D031', 'AS10AD22090', None, None, '0A', '2', '209', None, '1', '0', 'AS975.DEPTO TIPO 8B', 'DEPTO, SALA/COMEDOR, COCINA, 2 RECÁMARAS, 1BAÑO, PASILLO, PATIO LAVADO, 2 BALCON', None, None, '2', None, '1', '0', '16.67', None, '4.71', None, None, None, None, '48.66', None, '0', '0', None, '0', '48.66', None, None, '4.03', None, None, None, None, None, '0', '1', '1', '1,158,769.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Sep-14', '20-Sep-14', '24-Mar-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00038238', 'LUCIA MORALES ALMEIDA', 'LUCIA', 'MORALES', 'ALMEIDA', 'MOAL630307MV6', 'MOAL630307MTCRLC07', '1', None, None, '36692237', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'VISTA HERMOSA', 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54080', '0', None, None, None, '30000014701', 'SI000002096', None, '1070600.04000', '1202903.79000', '.00000', '.00000', '1202903.79000', '.00000', '.00000', '105778.44000', '.00000', '-1202903.79000', '105778.44000', '1-Jan-00', '19-Jun-15', '30-Mar-13', '30-Mar-13', '30-Mar-13', '0', None, '30-Mar-13', '30-Mar-13', '30-Mar-13', '30-Mar-13', '30-Mar-13', None, '16-Jun-15', '16-Jun-15', None, '18-Jun-15', None, '30-Jun-15', '8-Jul-15', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P031', '2', 'ESTACIONAMIENTO', 'AS1E225', 'AS100EZ0060', None, None, None, None, '006', None, '1', '0', 'EST GUEX', 'Cajón Grande, Único, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Único', '0', '1', '1', '110,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00038238', 'LUCIA MORALES ALMEIDA', 'LUCIA', 'MORALES', 'ALMEIDA', 'MOAL630307MV6', 'MOAL630307MTCRLC07', '1', None, None, '36692237', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'VISTA HERMOSA', 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54080', '0', None, None, None, '30000014701', 'SI000002198', None, '85000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '24-Apr-13', '24-Apr-13', '24-Apr-13', '0', None, '24-Apr-13', '24-Apr-13', '24-Apr-13', '24-Apr-13', '24-Apr-13', None, '16-Jun-15', '16-Jun-15', None, '18-Jun-15', None, '30-Jun-15', '8-Jul-15', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P031', '3', 'BODEGA', 'AS1B025', 'AS100BD0250', None, None, None, None, '025', None, '1', '0', 'AS975. BODEGA TIPO 7', 'BODEGA DE 7.10 M2', None, None, None, None, None, None, None, None, None, None, None, None, None, '7.1', None, None, None, None, None, None, None, None, '0', None, None, None, None, None, '0', '1', '1', '47,304.00 ', '0.00 ', '0.00 ', '0.00 ', '1-Mar-14', '1-Mar-14', '2-Sep-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00038238', 'LUCIA MORALES ALMEIDA', 'LUCIA', 'MORALES', 'ALMEIDA', 'MOAL630307MV6', 'MOAL630307MTCRLC07', '1', None, None, '36692237', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'VISTA HERMOSA', 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54080', '0', None, None, None, '30000014701', 'SI000005513', None, '47303.75000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '14-Aug-14', '14-Aug-14', '14-Aug-14', '0', None, '14-Aug-14', '14-Aug-14', '14-Aug-14', '14-Aug-14', '14-Aug-14', None, '16-Jun-15', '16-Jun-15', None, '18-Jun-15', None, '30-Jun-15', '8-Jul-15', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P163', '1', 'DEPARTAMENTO', 'AS1D163', 'AS10CD11010', None, None, '0C', '1', '101', None, '1', '0', 'AS975. DEPTO TIPO 5', 'DEPTO, SALA/COMEDOR, COCINA, 2 RECÁMARAS, 1 BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '16.57', None, '4.71', None, None, None, None, '48.64', None, '0', '0', None, '0', '48.64', None, None, '0', None, None, None, None, None, '0', '1', '1', '848,061.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00038803', 'MONTSERRAT CHAVEZ ORTEGA', 'MONTSERRAT', 'CHAVEZ', 'ORTEGA', 'CAOM920331IH8', None, '1', None, 'mon.ort31@gmail.com', '19412919', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'EL CONTADERO', 'CUAJIMALPA MORELOS DF', 'DF', 'Mexico', '05500', '0', None, None, None, '30000015013', 'SI000002005', None, '857067.42000', '992067.42000', '.00000', '.00000', '992067.42000', '.00000', '.00000', '72038.05000', '.00000', '-992067.56000', '72037.91000', '15-Jan-15', '15-Jan-15', '27-Mar-13', '27-Mar-13', '27-Mar-13', '0', None, '27-Mar-13', '27-Mar-13', '27-Mar-13', '27-Mar-13', '27-Mar-13', None, '23-Aug-13', '23-Aug-13', None, '23-Aug-13', None, '28-Aug-13', '18-Sep-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P163', '2', 'ESTACIONAMIENTO', 'AS1E122', 'AS100ED0810', None, None, None, None, '081', None, '1', '0', 'EST CDEX', 'Cajón Chico, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00038803', 'MONTSERRAT CHAVEZ ORTEGA', 'MONTSERRAT', 'CHAVEZ', 'ORTEGA', 'CAOM920331IH8', None, '1', None, 'mon.ort31@gmail.com', '19412919', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'EL CONTADERO', 'CUAJIMALPA MORELOS DF', 'DF', 'Mexico', '05500', '0', None, None, None, '30000015013', 'SI000002000', None, '70000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '27-Mar-13', '27-Mar-13', '27-Mar-13', '0', None, '27-Mar-13', '27-Mar-13', '27-Mar-13', '27-Mar-13', '27-Mar-13', None, '23-Aug-13', '23-Aug-13', None, '23-Aug-13', None, '28-Aug-13', '19-Sep-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P163', '2', 'ESTACIONAMIENTO', 'AS1E174', 'AS100EF0800', None, None, None, None, '080', None, '1', '0', 'EST CEEX', 'Cajón Chico, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '65,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00038803', 'MONTSERRAT CHAVEZ ORTEGA', 'MONTSERRAT', 'CHAVEZ', 'ORTEGA', 'CAOM920331IH8', None, '1', None, 'mon.ort31@gmail.com', '19412919', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'EL CONTADERO', 'CUAJIMALPA MORELOS DF', 'DF', 'Mexico', '05500', '0', None, None, None, '30000015013', 'SI000002001', None, '65000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '27-Mar-13', '27-Mar-13', '27-Mar-13', '0', None, '27-Mar-13', '27-Mar-13', '27-Mar-13', '27-Mar-13', '27-Mar-13', None, '23-Aug-13', '23-Aug-13', None, '23-Aug-13', None, '28-Aug-13', '19-Sep-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P118', '1', 'DEPARTAMENTO', 'AS1D118', 'AS10BD33060', None, None, '0B', '3', '306', None, '1', '0', 'AS975.DEPTO TIPO 2B', 'DEPTO, SALA/COMEDOR, COCINA,2RECÁMARAS, 1ALCOBA,  2BAÑOS, PASILLO, PATIO LAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,094,473.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Apr-14', '30-Apr-14', '1-Nov-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00040240', 'HUGO DANIEL ROSAS RAMOS', 'HUGO DANIEL', 'ROSAS', 'RAMOS', 'RORH770322P19', 'RORH770322HDFSMG00', '1', None, None, '5532284532', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN PEDRO XALPA', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02710', '0', None, None, None, '30000015633', 'SI000002308', None, '1152114.98000', '1290489.98000', '.00000', '.00000', '1290489.98000', '.00000', '.00000', '126671.04000', '.00000', '-1292739.98000', '124421.04000', '1-Jan-00', '19-Jun-15', '23-May-13', '23-May-13', '23-May-13', '0', None, '23-May-13', '23-May-13', '23-May-13', '23-May-13', '23-May-13', None, '28-Mar-14', '28-Mar-14', None, '7-Apr-14', None, '8-Apr-14', '16-Apr-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P118', '2', 'ESTACIONAMIENTO', 'AS1E147', 'AS100ED2030', None, None, None, None, '203', None, '1', '0', 'EST CDEX', 'Cajón Chico, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00040240', 'HUGO DANIEL ROSAS RAMOS', 'HUGO DANIEL', 'ROSAS', 'RAMOS', 'RORH770322P19', 'RORH770322HDFSMG00', '1', None, None, '5532284532', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN PEDRO XALPA', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02710', '0', None, None, None, '30000015633', 'SI000002335', None, '71750.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '31-May-13', '31-May-13', '31-May-13', '0', None, '31-May-13', '31-May-13', '31-May-13', '31-May-13', '31-May-13', None, '28-Mar-14', '28-Mar-14', None, '7-Apr-14', None, '8-Apr-14', '16-Apr-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P118', '2', 'ESTACIONAMIENTO', 'AS1E199', 'AS100EF2040', None, None, None, None, '204', None, '1', '0', 'EST CEEX', 'Cajón Chico, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '65,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00040240', 'HUGO DANIEL ROSAS RAMOS', 'HUGO DANIEL', 'ROSAS', 'RAMOS', 'RORH770322P19', 'RORH770322HDFSMG00', '1', None, None, '5532284532', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN PEDRO XALPA', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02710', '0', None, None, None, '30000015633', 'SI000002336', None, '66625.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '31-May-13', '31-May-13', '31-May-13', '0', None, '31-May-13', '31-May-13', '31-May-13', '31-May-13', '31-May-13', None, '28-Mar-14', '28-Mar-14', None, '7-Apr-14', None, '8-Apr-14', '16-Apr-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P070', '1', 'DEPARTAMENTO', 'AS1D070', 'AS10AD55120', None, None, '0A', '5', '512', None, '1', '0', 'AS975. DEPTO TIPO 9', 'DEPTO, S/C,COCINA, 2RECÁMARAS,1BAÑO,PASILLO,PATIO LAVADO,2BALCONES Y 1 TERRAZA', None, None, '2', None, '1', '2', '21.49', None, '4.71', None, None, None, None, '52.72', None, '19.1', '3.16', None, '0', '74.98', None, None, '80.04', None, None, None, None, None, '0', '1', '1', '1,414,544.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Sep-14', '20-Sep-14', '24-Mar-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00040993', 'RICARDO CESAR GUERRA MARTINEZ', 'RICARDO CESAR', 'GUERRA', 'MARTINEZ', 'GUMR750619GD8', 'GUMR350619', '1', None, None, '54002880', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LOMAS DE LOS ANGELES', 'ALVARO OBREGÓN DF', 'DF', 'Mexico', '01790', '0', None, None, None, '30000015872', 'SI000001849', None, '1216080.54000', '1296081.54000', '.00000', '.00000', '1296081.54000', '.00000', '.00000', '85125.63000', '.00000', '-1288581.55000', '92625.62000', '1-Jan-00', '19-Jun-15', '28-Feb-13', '28-Feb-13', '28-Feb-13', '0', None, '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', None, '3-Sep-14', '3-Sep-14', None, '10-Sep-14', None, '24-Sep-14', '14-Nov-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P070', '2', 'ESTACIONAMIENTO', 'AS1E003', 'AS100EA0140', None, None, None, None, '014', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '85,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00040993', 'RICARDO CESAR GUERRA MARTINEZ', 'RICARDO CESAR', 'GUERRA', 'MARTINEZ', 'GUMR750619GD8', 'GUMR350619', '1', None, None, '54002880', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LOMAS DE LOS ANGELES', 'ALVARO OBREGÓN DF', 'DF', 'Mexico', '01790', '0', None, None, None, '30000015872', 'SI000002493', None, '80000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '19-Jul-13', '19-Jul-13', '19-Jul-13', '0', None, '19-Jul-13', '19-Jul-13', '19-Jul-13', '19-Jul-13', '19-Jul-13', None, '3-Sep-14', '3-Sep-14', None, '10-Sep-14', None, '24-Sep-14', '14-Nov-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P070', '3', 'BODEGA', 'AS1B027', 'AS100BD0270', None, None, None, None, '027', None, '1', '0', 'AS975. BODEGA TIPO 6', 'BODEGA DE 4.30 M2', None, None, None, None, None, None, None, None, None, None, None, None, None, '4.3', None, None, None, None, None, None, None, None, '0', None, None, None, None, None, '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '1-Mar-14', '1-Mar-14', '2-Sep-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00040993', 'RICARDO CESAR GUERRA MARTINEZ', 'RICARDO CESAR', 'GUERRA', 'MARTINEZ', 'GUMR750619GD8', 'GUMR350619', '1', None, None, '54002880', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LOMAS DE LOS ANGELES', 'ALVARO OBREGÓN DF', 'DF', 'Mexico', '01790', '0', None, None, None, '30000015872', 'SI000006079', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '28-Feb-13', '28-Feb-13', '28-Feb-13', '0', None, '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', '28-Feb-13', None, '3-Sep-14', '3-Sep-14', None, '10-Sep-14', None, '24-Sep-14', '14-Nov-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P038', '1', 'DEPARTAMENTO', 'AS1D038', 'AS10AD33040', None, None, '0A', '3', '304', None, '1', '0', 'AS975.DEPTO TIPO 2B', 'DEPTO, SALA/COMEDOR, COCINA,2RECÁMARAS, 1ALCOBA,  2BAÑOS, PASILLO, PATIO LAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,312,055.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Sep-14', '20-Sep-14', '24-Mar-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00041013', 'JOSE LUIS CONTRERAS SANCHEZ', 'JOSE LUIS', 'CONTRERAS', 'SANCHEZ', 'COSL750328DNA', None, '1', None, None, '58574535', '50803700', '30453646', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'EL RECREO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02070', '0', None, None, None, '30000015880', 'SI000002217', None, '1242528.51000', '1412529.51000', '.00000', '.00000', '1412529.51000', '.00000', '.00000', '98521.93000', '.00000', '-1412528.51000', '98522.93000', '1-Jan-00', '19-Jun-15', '26-Apr-13', '26-Apr-13', '26-Apr-13', '0', None, '26-Apr-13', '26-Apr-13', '26-Apr-13', '26-Apr-13', '26-Apr-13', None, '31-Oct-14', '31-Oct-14', None, '11-Nov-14', None, '20-Nov-14', '16-Dec-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P038', '2', 'ESTACIONAMIENTO', 'AS1E237', 'AS100EZ1510', None, None, None, None, '151', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '110,000.00 ', '0.00 ', '0.00 ', '0.00 ', '30-Jul-14', '30-Jul-14', '31-Jan-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00041013', 'JOSE LUIS CONTRERAS SANCHEZ', 'JOSE LUIS', 'CONTRERAS', 'SANCHEZ', 'COSL750328DNA', None, '1', None, None, '58574535', '50803700', '30453646', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'EL RECREO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02070', '0', None, None, None, '30000015880', 'SI000002216', None, '85000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '26-Apr-13', '26-Apr-13', '26-Apr-13', '0', None, '26-Apr-13', '26-Apr-13', '26-Apr-13', '26-Apr-13', '26-Apr-13', None, '31-Oct-14', '31-Oct-14', None, '11-Nov-14', None, '20-Nov-14', '16-Dec-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P038', '2', 'ESTACIONAMIENTO', 'AS1E236', 'AS100EZ1500', None, None, None, None, '150', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '110,000.00 ', '0.00 ', '0.00 ', '0.00 ', '30-Jul-14', '30-Jul-14', '31-Jan-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00041013', 'JOSE LUIS CONTRERAS SANCHEZ', 'JOSE LUIS', 'CONTRERAS', 'SANCHEZ', 'COSL750328DNA', None, '1', None, None, '58574535', '50803700', '30453646', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'EL RECREO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02070', '0', None, None, None, '30000015880', 'SI000002215', None, '85000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '26-Apr-13', '26-Apr-13', '26-Apr-13', '0', None, '26-Apr-13', '26-Apr-13', '26-Apr-13', '26-Apr-13', '26-Apr-13', None, '31-Oct-14', '31-Oct-14', None, '11-Nov-14', None, '20-Nov-14', '16-Dec-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P038', '3', 'BODEGA', 'AS1B021', 'AS100BD0210', None, None, None, None, '021', None, '1', '0', 'AS975. BODEGA TIPO 6', 'BODEGA DE 4.30 M2', None, None, None, None, None, None, None, None, None, None, None, None, None, '4.3', None, None, None, None, None, None, None, None, '0', None, None, None, None, None, '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '1-Mar-14', '1-Mar-14', '2-Sep-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00041013', 'JOSE LUIS CONTRERAS SANCHEZ', 'JOSE LUIS', 'CONTRERAS', 'SANCHEZ', 'COSL750328DNA', None, '1', None, None, '58574535', '50803700', '30453646', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'EL RECREO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02070', '0', None, None, None, '30000015880', 'SI000010045', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '26-Apr-13', '26-Apr-13', '26-Apr-13', '0', None, '26-Apr-13', '26-Apr-13', '26-Apr-13', '26-Apr-13', '26-Apr-13', None, '31-Oct-14', '31-Oct-14', None, '11-Nov-14', None, '20-Nov-14', '16-Dec-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P088', '1', 'DEPARTAMENTO', 'AS1D088', 'AS10BD11040', None, None, '0B', '1', '104', None, '1', '0', 'AS975.DEPTO TIPO 4', 'DEPTO, SALA/COMEDOR, COCINA, 2 RECÁMARAS, 1 BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '17.2', None, '4.67', None, None, None, None, '55.17', None, '0', '0', None, '0', '55.17', None, None, '0', None, None, None, None, None, '0', '1', '1', '979,068.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Apr-14', '30-Apr-14', '1-Nov-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00041344', 'FELIPE RODOLFO BARRERA MENDOZA', 'FELIPE RODOLFO', 'BARRERA', 'MENDOZA', 'BAMF960205GZA', None, '1', None, None, '18234959', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LAS ALAMEDAS', 'ATIZAPÁN ZARAGOZA MEX', 'MEX', 'Mexico', '52970', '0', None, None, None, '30000016029', 'SI000002239', None, '1013643.01000', '1083643.01000', '.00000', '.00000', '1083643.01000', '.00000', '.00000', '.00000', '.00000', '-1085847.01000', '-2204.00000', '1-Jan-00', '19-Jun-15', '30-Apr-13', '30-Apr-13', '30-Apr-13', '0', None, '30-Apr-13', '30-Apr-13', '30-Apr-13', '30-Apr-13', '30-Apr-13', None, '7-Nov-13', '7-Nov-13', None, '20-Nov-13', None, '7-Jan-14', '14-Mar-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P088', '2', 'ESTACIONAMIENTO', 'AS1E112', 'AS100ED0360', None, None, None, None, '036', None, '1', '0', 'EST CDEX', 'Cajón Chico, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00041344', 'FELIPE RODOLFO BARRERA MENDOZA', 'FELIPE RODOLFO', 'BARRERA', 'MENDOZA', 'BAMF960205GZA', None, '1', None, None, '18234959', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LAS ALAMEDAS', 'ATIZAPÁN ZARAGOZA MEX', 'MEX', 'Mexico', '52970', '0', None, None, None, '30000016029', 'SI000002296', None, '70000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '21-May-13', '21-May-13', '21-May-13', '0', None, '21-May-13', '21-May-13', '21-May-13', '21-May-13', '21-May-13', None, '7-Nov-13', '7-Nov-13', None, '20-Nov-13', None, '7-Jan-14', '14-Mar-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P068', '1', 'DEPARTAMENTO', 'AS1D068', 'AS10AD55100', None, None, '0A', '5', '510', None, '1', '0', 'AS975.DEPTO TIPO 8', 'DEPTO, SALA/COMEDOR, COCINA, 2 RECÁMARAS, 1 BAÑO, PASILLO, PATIO LAVADO 2BALCON', None, None, '2', None, '1', '2', '16.67', None, '4.71', None, None, None, None, '48.66', None, '0', '2.44', None, '0', '51.1', None, None, '50.15', None, None, None, None, None, '0', '1', '1', '1,219,351.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Sep-14', '20-Sep-14', '24-Mar-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00041444', 'OSCAR ISRAEL NAVARRO GOVEA', 'OSCAR ISRAEL', 'NAVARRO', 'GOVEA', 'NAGO820515FF4', None, '1', None, None, '53942346', None, '5531967715', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LOS REYES IXTACALA', 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54090', '0', None, None, None, '30000016060', 'SI000002289', None, '1154736.96000', '1289737.96000', '.00000', '.00000', '1289737.96000', '.00000', '.00000', '112000.69000', '.00000', '-1289737.96000', '112000.69000', '1-Jan-00', '19-Jun-15', '17-May-13', '17-May-13', '17-May-13', '0', None, '17-May-13', '17-May-13', '17-May-13', '17-May-13', '17-May-13', None, '30-Sep-14', '30-Sep-14', None, '8-Oct-14', None, '20-Oct-14', '7-Nov-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P068', '2', 'ESTACIONAMIENTO', 'AS1E210', 'AS100EF2300', None, None, None, None, '230', None, '1', '0', 'EST CEEX', 'Cajón Chico, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '65,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00041444', 'OSCAR ISRAEL NAVARRO GOVEA', 'OSCAR ISRAEL', 'NAVARRO', 'GOVEA', 'NAGO820515FF4', None, '1', None, None, '53942346', None, '5531967715', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LOS REYES IXTACALA', 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54090', '0', None, None, None, '30000016060', 'SI000002288', None, '65000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '17-May-13', '17-May-13', '17-May-13', '0', None, '17-May-13', '17-May-13', '17-May-13', '17-May-13', '17-May-13', None, '30-Sep-14', '30-Sep-14', None, '8-Oct-14', None, '20-Oct-14', '7-Nov-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P068', '2', 'ESTACIONAMIENTO', 'AS1E158', 'AS100ED2290', None, None, None, None, '229', None, '1', '0', 'EST CDEX', 'Cajón Chico, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00041444', 'OSCAR ISRAEL NAVARRO GOVEA', 'OSCAR ISRAEL', 'NAVARRO', 'GOVEA', 'NAGO820515FF4', None, '1', None, None, '53942346', None, '5531967715', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LOS REYES IXTACALA', 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54090', '0', None, None, None, '30000016060', 'SI000002286', None, '70000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '17-May-13', '17-May-13', '17-May-13', '0', None, '17-May-13', '17-May-13', '17-May-13', '17-May-13', '17-May-13', None, '30-Sep-14', '30-Sep-14', None, '8-Oct-14', None, '20-Oct-14', '7-Nov-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P068', '3', 'BODEGA', 'AS1B029', 'AS100BD0290', None, None, None, None, '029', None, '1', '0', 'AS975. BODEGA TIPO 6', 'BODEGA DE 4.30 M2', None, None, None, None, None, None, None, None, None, None, None, None, None, '4.3', None, None, None, None, None, None, None, None, '0', None, None, None, None, None, '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '1-Mar-14', '1-Mar-14', '2-Sep-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00041444', 'OSCAR ISRAEL NAVARRO GOVEA', 'OSCAR ISRAEL', 'NAVARRO', 'GOVEA', 'NAGO820515FF4', None, '1', None, None, '53942346', None, '5531967715', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LOS REYES IXTACALA', 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54090', '0', None, None, None, '30000016060', 'SI000002284', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '17-May-13', '17-May-13', '17-May-13', '0', None, '17-May-13', '17-May-13', '17-May-13', '17-May-13', '17-May-13', None, '30-Sep-14', '30-Sep-14', None, '8-Oct-14', None, '20-Oct-14', '7-Nov-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P014', '1', 'DEPARTAMENTO', 'AS1D014', 'AS10AD11040', None, None, '0A', '1', '104', None, '1', '0', 'AS975.DEPTO TIPO 2B', 'DEPTO, SALA/COMEDOR, COCINA,2RECÁMARAS, 1ALCOBA,  2BAÑOS, PASILLO, PATIO LAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,282,266.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Sep-14', '20-Sep-14', '24-Mar-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00041522', 'EFREN ROLDAN JUAREZ', 'EFREN', 'ROLDAN', 'JUAREZ', 'ROJE8406189W4', None, '1', None, None, '59530967', '56631994', '5559530960', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'TEPEYAC INSURGENTES BAS', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '007020', '0', None, None, None, '30000016078', 'SI000002405', None, '1244676.70000', '1326677.70000', '.00000', '.00000', '1326677.70000', '.00000', '.00000', '118004.05000', '.00000', '-1326677.70000', '118004.05000', '1-Jan-00', '19-Jun-15', '13-Jun-13', '13-Jun-13', '13-Jun-13', '0', None, '13-Jun-13', '13-Jun-13', '13-Jun-13', '13-Jun-13', '13-Jun-13', None, '26-Nov-14', '26-Nov-14', None, '9-Dec-14', None, '11-Dec-14', '23-Dec-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P014', '2', 'ESTACIONAMIENTO', 'AS1E037', 'AS100EA1420', None, None, None, None, '142', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '85,000.00 ', '0.00 ', '0.00 ', '0.00 ', '30-May-14', '30-May-14', '1-Dec-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00041522', 'EFREN ROLDAN JUAREZ', 'EFREN', 'ROLDAN', 'JUAREZ', 'ROJE8406189W4', None, '1', None, None, '59530967', '56631994', '5559530960', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'TEPEYAC INSURGENTES BAS', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '007020', '0', None, None, None, '30000016078', 'SI000002416', None, '82000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '20-Jun-13', '20-Jun-13', '20-Jun-13', '0', None, '20-Jun-13', '20-Jun-13', '20-Jun-13', '20-Jun-13', '20-Jun-13', None, '26-Nov-14', '26-Nov-14', None, '9-Dec-14', None, '11-Dec-14', '23-Dec-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P014', '3', 'BODEGA', 'AS1B026', 'AS100BD0260', None, None, None, None, '026', None, '1', '0', 'AS975. BODEGA TIPO 6', 'BODEGA DE 4.30 M2', None, None, None, None, None, None, None, None, None, None, None, None, None, '4.3', None, None, None, None, None, None, None, None, '0', None, None, None, None, None, '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '1-Mar-14', '1-Mar-14', '2-Sep-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00041522', 'EFREN ROLDAN JUAREZ', 'EFREN', 'ROLDAN', 'JUAREZ', 'ROJE8406189W4', None, '1', None, None, '59530967', '56631994', '5559530960', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'TEPEYAC INSURGENTES BAS', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '007020', '0', None, None, None, '30000016078', 'SI000002404', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '13-Jun-13', '13-Jun-13', '13-Jun-13', '0', None, '13-Jun-13', '13-Jun-13', '13-Jun-13', '13-Jun-13', '13-Jun-13', None, '26-Nov-14', '26-Nov-14', None, '9-Dec-14', None, '11-Dec-14', '23-Dec-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P104', '1', 'DEPARTAMENTO', 'AS1D104', 'AS10BD22060', None, None, '0B', '2', '206', None, '1', '0', 'AS975.DEPTO TIPO 2B', 'DEPTO, SALA/COMEDOR, COCINA,2RECÁMARAS, 1ALCOBA,  2BAÑOS, PASILLO, PATIO LAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,080,807.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Apr-14', '30-Apr-14', '1-Nov-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00041558', 'KARINA LUCERO ALVAREZ HERNANDEZ', 'KARINA LUCERO', 'ALVAREZ', 'HERNANDEZ', 'AAHK811215G99', None, '1', None, 'luceroalvarezh@hotmail.com', '55618278', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SANTO DOMINGO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02160', '0', None, None, None, '30000016110', 'SI000002240', None, '1110944.68000', '1180944.68000', '.00000', '.00000', '1180944.68000', '.00000', '.00000', '126671.05000', '.00000', '-1180944.68000', '126671.05000', '15-Jan-15', '15-Jan-15', '30-Apr-13', '30-Apr-13', '30-Apr-13', '0', None, '30-Apr-13', '30-Apr-13', '30-Apr-13', '30-Apr-13', '30-Apr-13', None, '28-May-14', '28-May-14', None, '3-Jun-14', None, '11-Sep-14', '1-Oct-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P104', '2', 'ESTACIONAMIENTO', 'AS1E137', 'AS100ED1690', None, None, None, None, '169', None, '1', '0', 'EST CDEX', 'Cajón Chico, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '85,000.00 ', '0.00 ', '0.00 ', '0.00 ', '30-Jan-14', '30-Jan-14', '3-Aug-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00041558', 'KARINA LUCERO ALVAREZ HERNANDEZ', 'KARINA LUCERO', 'ALVAREZ', 'HERNANDEZ', 'AAHK811215G99', None, '1', None, 'luceroalvarezh@hotmail.com', '55618278', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SANTO DOMINGO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02160', '0', None, None, None, '30000016110', 'SI000002236', None, '70000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '30-Apr-13', '30-Apr-13', '30-Apr-13', '0', None, '30-Apr-13', '30-Apr-13', '30-Apr-13', '30-Apr-13', '30-Apr-13', None, '28-May-14', '28-May-14', None, '3-Jun-14', None, '11-Sep-14', '1-Oct-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P025', '1', 'DEPARTAMENTO', 'AS1D025', 'AS10AD22030', None, None, '0A', '2', '203', None, '1', '0', 'AS975.DEPTO TIPO 2', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1ALCOBA, 2BAÑOS, PASILLO, PATIOLAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,297,161.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Sep-14', '20-Sep-14', '24-Mar-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00042906', 'JIE TAO', 'JIE', 'TAO', None, 'TAJX821221LP3', None, '1', None, None, '55 10 88 18', None, '55 2332 3543', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'AZCAPOTZALCO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02000', '0', None, None, None, '30000016458', 'SI000002337', None, '1259134.21000', '1341135.21000', '.00000', '-20000.00000', '1321135.21000', '.00000', '.00000', '91484.64000', '.00000', '-1321135.22000', '91484.63000', '1-Jan-00', '19-Jun-15', '31-May-13', '31-May-13', '31-May-13', '0', None, '31-May-13', '31-May-13', '31-May-13', '31-May-13', '31-May-13', None, '2-Sep-14', '2-Sep-14', None, '9-Sep-14', None, '11-Sep-14', '11-Oct-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P025', '2', 'ESTACIONAMIENTO', 'AS1E034', 'AS100EA1320', None, None, None, None, '132', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '85,000.00 ', '0.00 ', '0.00 ', '0.00 ', '30-Aug-14', '30-Aug-14', '3-Mar-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00042906', 'JIE TAO', 'JIE', 'TAO', None, 'TAJX821221LP3', None, '1', None, None, '55 10 88 18', None, '55 2332 3543', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'AZCAPOTZALCO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02000', '0', None, None, None, '30000016458', 'SI000002332', None, '82000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '31-May-13', '31-May-13', '31-May-13', '0', None, '31-May-13', '31-May-13', '31-May-13', '31-May-13', '31-May-13', None, '2-Sep-14', '2-Sep-14', None, '9-Sep-14', None, '11-Sep-14', '11-Oct-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P025', '3', 'BODEGA', 'AS1B022', 'AS100BD0220', None, None, None, None, '022', None, '1', '0', 'AS975. BODEGA TIPO 6', 'BODEGA DE 4.30 M2', None, None, None, None, None, None, None, None, None, None, None, None, None, '4.3', None, None, None, None, None, None, None, None, '0', None, None, None, None, None, '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '1-Mar-14', '1-Mar-14', '2-Sep-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00042906', 'JIE TAO', 'JIE', 'TAO', None, 'TAJX821221LP3', None, '1', None, None, '55 10 88 18', None, '55 2332 3543', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'AZCAPOTZALCO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02000', '0', None, None, None, '30000016458', 'SI000002331', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '31-May-13', '31-May-13', '31-May-13', '0', None, '31-May-13', '31-May-13', '31-May-13', '31-May-13', '31-May-13', None, '2-Sep-14', '2-Sep-14', None, '9-Sep-14', None, '11-Sep-14', '11-Oct-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P037', '1', 'DEPARTAMENTO', 'AS1D037', 'AS10AD33030', None, None, '0A', '3', '303', None, '1', '0', 'AS975.DEPTO TIPO 2', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1ALCOBA, 2BAÑOS, PASILLO, PATIOLAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,312,055.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Sep-14', '20-Sep-14', '24-Mar-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00042908', 'JUNDONG MO', 'JUNDONG', 'MO', None, 'MOJN630319G6A', None, '1', None, None, '5347 6542', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BARRIO NEXTENGO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02000', '0', None, None, None, '30000016466', 'SI000002338', None, '1273591.72000', '1377117.72000', '.00000', '-20000.00000', '1357117.72000', '.00000', '.00000', '.00000', '.00000', '-1357117.60000', '.12000', '1-Jan-00', '19-Jun-15', '31-May-13', '31-May-13', '31-May-13', '0', None, '31-May-13', '31-May-13', '31-May-13', '31-May-13', '31-May-13', None, '2-Sep-14', '2-Sep-14', None, '5-Sep-14', None, '12-Sep-14', '17-Oct-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P037', '2', 'ESTACIONAMIENTO', 'AS1E086', 'AS100EC1330', None, None, None, None, '133', None, '1', '0', 'EST GEEX', 'Cajón Grande, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '30-Aug-14', '30-Aug-14', '3-Mar-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00042908', 'JUNDONG MO', 'JUNDONG', 'MO', None, 'MOJN630319G6A', None, '1', None, None, '5347 6542', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BARRIO NEXTENGO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02000', '0', None, None, None, '30000016466', 'SI000002333', None, '76875.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '31-May-13', '31-May-13', '31-May-13', '0', None, '31-May-13', '31-May-13', '31-May-13', '31-May-13', '31-May-13', None, '2-Sep-14', '2-Sep-14', None, '5-Sep-14', None, '12-Sep-14', '17-Oct-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P037', '3', 'BODEGA', 'AS1B020', 'AS100BD0200', None, None, None, None, '020', None, '1', '0', 'AS975. BODEGA TIPO 6', 'BODEGA DE 4.30 M2', None, None, None, None, None, None, None, None, None, None, None, None, None, '4.3', None, None, None, None, None, None, None, None, '0', None, None, None, None, None, '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '1-Mar-14', '1-Mar-14', '2-Sep-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00042908', 'JUNDONG MO', 'JUNDONG', 'MO', None, 'MOJN630319G6A', None, '1', None, None, '5347 6542', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BARRIO NEXTENGO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02000', '0', None, None, None, '30000016466', 'SI000002330', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '31-May-13', '31-May-13', '31-May-13', '0', None, '31-May-13', '31-May-13', '31-May-13', '31-May-13', '31-May-13', None, '2-Sep-14', '2-Sep-14', None, '5-Sep-14', None, '12-Sep-14', '17-Oct-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P037', '3', 'BODEGA', 'AS1B012', 'AS100BD0120', None, None, None, None, '012', None, '1', '0', 'AS.975. BODEGA TIPO 2', 'BODEGA DE 4 M2', None, None, None, None, None, None, None, None, None, None, None, None, None, '4', None, None, None, None, None, None, None, None, '0', None, None, None, None, None, '0', '1', '1', '26,650.00 ', '0.00 ', '0.00 ', '0.00 ', '1-Mar-14', '1-Mar-14', '2-Sep-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00042908', 'JUNDONG MO', 'JUNDONG', 'MO', None, 'MOJN630319G6A', None, '1', None, None, '5347 6542', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BARRIO NEXTENGO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02000', '0', None, None, None, '30000016466', 'SI000002609', None, '26650.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '20-Aug-13', '20-Aug-13', '20-Aug-13', '0', None, '20-Aug-13', '20-Aug-13', '20-Aug-13', '20-Aug-13', '20-Aug-13', None, '2-Sep-14', '2-Sep-14', None, '5-Sep-14', None, '12-Sep-14', '17-Oct-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P045', '1', 'DEPARTAMENTO', 'AS1D045', 'AS10AD33110', None, None, '0A', '3', '311', None, '1', '0', 'AS975.DEPTO TIPO 8B', 'DEPTO, SALA/COMEDOR, COCINA, 2 RECÁMARAS, 1BAÑO, PASILLO, PATIO LAVADO, 2 BALCON', None, None, '2', None, '1', '0', '16.67', None, '4.71', None, None, None, None, '48.66', None, '0', '0', None, '0', '48.66', None, None, '2.87', None, None, None, None, None, '0', '1', '1', '1,164,220.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Sep-14', '20-Sep-14', '24-Mar-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00043143', 'ESPERANZA CALIZ VELAZQUEZ', 'ESPERANZA', 'CALIZ', 'VELAZQUEZ', 'CAVE4708038A4', 'CAVE470803MMNLLS06', '1', None, 'esperanza.caliz@hotmail.com', '53947268', None, '2', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'U.HAB.LAS TRANCAS', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02450', '0', None, None, None, '30000016581', 'SI000002410', None, '1065000.00000', '1197633.13000', '.00000', '.00000', '1197633.13000', '.00000', '.00000', '80290.00000', '.00000', '-1197633.13000', '80290.00000', '15-Jan-15', '15-Jan-15', '18-Jun-13', '18-Jun-13', '18-Jun-13', '0', None, '18-Jun-13', '18-Jun-13', '18-Jun-13', '18-Jun-13', '18-Jun-13', None, '6-Aug-14', '6-Aug-14', None, '12-Aug-14', None, '15-Aug-14', '5-Dec-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P045', '2', 'ESTACIONAMIENTO', 'AS1E036', 'AS100EA1400', None, None, None, None, '140', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '85,000.00 ', '0.00 ', '0.00 ', '0.00 ', '30-Jul-14', '30-Jul-14', '31-Jan-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00043143', 'ESPERANZA CALIZ VELAZQUEZ', 'ESPERANZA', 'CALIZ', 'VELAZQUEZ', 'CAVE4708038A4', 'CAVE470803MMNLLS06', '1', None, 'esperanza.caliz@hotmail.com', '53947268', None, '2', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'U.HAB.LAS TRANCAS', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02450', '0', None, None, None, '30000016581', 'SI000002409', None, '82000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '18-Jun-13', '18-Jun-13', '18-Jun-13', '0', None, '18-Jun-13', '18-Jun-13', '18-Jun-13', '18-Jun-13', '18-Jun-13', None, '6-Aug-14', '6-Aug-14', None, '12-Aug-14', None, '15-Aug-14', '5-Dec-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P045', '3', 'BODEGA', 'AS1B001', 'AS100BD0010', None, None, None, None, '001', None, '1', '0', 'AS975. BODEGA TIPO 1', 'BODEGA DE 8.05 M2', None, None, None, None, None, None, None, None, None, None, None, None, None, '8.05', None, None, None, None, None, None, None, None, '0', None, None, None, None, None, '0', '1', '1', '53,634.00 ', '0.00 ', '0.00 ', '0.00 ', '1-Mar-14', '1-Mar-14', '2-Sep-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00043143', 'ESPERANZA CALIZ VELAZQUEZ', 'ESPERANZA', 'CALIZ', 'VELAZQUEZ', 'CAVE4708038A4', 'CAVE470803MMNLLS06', '1', None, 'esperanza.caliz@hotmail.com', '53947268', None, '2', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'U.HAB.LAS TRANCAS', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02450', '0', None, None, None, '30000016581', 'SI000005455', None, '50633.13000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '4-Aug-14', '4-Aug-14', '4-Aug-14', '0', None, '4-Aug-14', '4-Aug-14', '4-Aug-14', '4-Aug-14', '4-Aug-14', None, '6-Aug-14', '6-Aug-14', None, '12-Aug-14', None, '15-Aug-14', '5-Dec-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P185', '1', 'DEPARTAMENTO', 'AS1D185', 'AS10CD33070', None, None, '0C', '3', '307', None, '1', '0', 'AS975.DEPTO TIPO 1', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '14.4', None, '4.52', None, None, None, None, '49.5', '2.05', '0', '0', None, '0', '49.5', None, None, '0', None, None, None, None, None, '0', '1', '1', '879,449.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00043185', 'REYNA BAUTISTA GONZALEZ', 'REYNA', 'BAUTISTA', 'GONZALEZ', 'BAGR711107E90', 'BAGR711107MDFTNY05', '1', None, 'reynabg@prodigy.com.mx', None, None, '5', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'TLACUITLAPA', 'ALVARO OBREGÓN DF', 'DF', 'Mexico', '1650', '0', None, None, None, '30000016615', 'SI000002411', None, '955741.00000', '1114616.00000', '.00000', '.00000', '1114616.00000', '.00000', '.00000', '84320.85000', '.00000', '-1114616.00000', '84320.85000', '15-Jan-15', '15-Jan-15', '18-Jun-13', '18-Jun-13', '18-Jun-13', '0', None, '18-Jun-13', '18-Jun-13', '18-Jun-13', '18-Jun-13', '18-Jun-13', None, '31-Jul-13', '31-Jul-13', None, '31-Jul-13', None, '28-Aug-13', '7-Sep-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P185', '2', 'ESTACIONAMIENTO', 'AS1E098', 'AS100EC1840', None, None, None, None, '184', None, '1', '0', 'EST GEEX', 'Cajón Grande, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00043185', 'REYNA BAUTISTA GONZALEZ', 'REYNA', 'BAUTISTA', 'GONZALEZ', 'BAGR711107E90', 'BAGR711107MDFTNY05', '1', None, 'reynabg@prodigy.com.mx', None, None, '5', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'TLACUITLAPA', 'ALVARO OBREGÓN DF', 'DF', 'Mexico', '1650', '0', None, None, None, '30000016615', 'SI000002640', None, '76875.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '23-Aug-13', '23-Aug-13', '23-Aug-13', '0', None, '23-Aug-13', '23-Aug-13', '23-Aug-13', '23-Aug-13', '23-Aug-13', None, '28-Aug-13', '28-Aug-13', None, '28-Aug-13', None, '28-Aug-13', '7-Sep-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P185', '2', 'ESTACIONAMIENTO', 'AS1E046', 'AS100EA1830', None, None, None, None, '183', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '85,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00043185', 'REYNA BAUTISTA GONZALEZ', 'REYNA', 'BAUTISTA', 'GONZALEZ', 'BAGR711107E90', 'BAGR711107MDFTNY05', '1', None, 'reynabg@prodigy.com.mx', None, None, '5', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'TLACUITLAPA', 'ALVARO OBREGÓN DF', 'DF', 'Mexico', '1650', '0', None, None, None, '30000016615', 'SI000002561', None, '82000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '5-Aug-13', '5-Aug-13', '5-Aug-13', '0', None, '5-Aug-13', '5-Aug-13', '5-Aug-13', '5-Aug-13', '5-Aug-13', None, '28-Aug-13', '28-Aug-13', None, '28-Aug-13', None, '28-Aug-13', '7-Sep-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P084', '1', 'DEPARTAMENTO', 'AS1D084', 'AS10BD00140', None, None, '0B', '0', '014', None, '1', '0', 'AS975.DEPTO TIPO 2B', 'DEPTO, SALA/COMEDOR, COCINA,2RECÁMARAS, 1ALCOBA,  2BAÑOS, PASILLO, PATIO LAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,121,805.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Apr-14', '30-Apr-14', '1-Nov-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00043187', 'RICARDO MONROY SOSA', 'RICARDO', 'MONROY', 'SOSA', 'MOSR720214M36', 'MOSR720214HMCNSC04', '1', None, None, '5540273167', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'FRACC RINCONADA SAN FELIPE', 'COACALCO MEX', 'MEX', 'Mexico', '55719', '0', None, None, None, '30000016623', 'SI000002413', None, '1158908.35000', '1230658.35000', '.00000', '.00000', '1230658.35000', '.00000', '.00000', '105559.20000', '.00000', '-1235132.12000', '101085.43000', '1-Jan-00', '19-Jun-15', '19-Jun-13', '19-Jun-13', '19-Jun-13', '0', None, '19-Jun-13', '19-Jun-13', '19-Jun-13', '19-Jun-13', '19-Jun-13', None, '24-Oct-14', '24-Oct-14', None, '11-Nov-14', None, '21-Nov-14', '16-Dec-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P084', '2', 'ESTACIONAMIENTO', 'AS1E116', 'AS100ED0470', None, None, None, None, '047', None, '1', '0', 'EST CDEX', 'Cajón Chico, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00043187', 'RICARDO MONROY SOSA', 'RICARDO', 'MONROY', 'SOSA', 'MOSR720214M36', 'MOSR720214HMCNSC04', '1', None, None, '5540273167', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'FRACC RINCONADA SAN FELIPE', 'COACALCO MEX', 'MEX', 'Mexico', '55719', '0', None, None, None, '30000016623', 'SI000002412', None, '71750.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '19-Jun-13', '19-Jun-13', '19-Jun-13', '0', None, '19-Jun-13', '19-Jun-13', '19-Jun-13', '19-Jun-13', '19-Jun-13', None, '24-Oct-14', '24-Oct-14', None, '11-Nov-14', None, '21-Nov-14', '16-Dec-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P087', '1', 'DEPARTAMENTO', 'AS1D087', 'AS10BD11030', None, None, '0B', '1', '103', None, '1', '0', 'AS975.DEPTO TIPO 4', 'DEPTO, SALA/COMEDOR, COCINA, 2 RECÁMARAS, 1 BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '17.2', None, '4.67', None, None, None, None, '55.17', None, '0', '0', None, '0', '55.17', None, None, '0', None, None, None, None, None, '0', '1', '1', '979,068.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Apr-14', '30-Apr-14', '1-Nov-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00044136', 'GABRIELA VEGA SERRANO', 'GABRIELA', 'VEGA', 'SERRANO', 'GAVS4703247Z0', None, '1', None, None, None, None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'JARDINES DE SANTA MONICA', 'TLALNEPANTLA MEX', 'MEX', 'Mexico', None, '0', None, None, None, '30000016805', 'SI000002459', None, '1012984.09000', '1094984.09000', '.00000', '.00000', '1094984.09000', '.00000', '.00000', '.00000', '.00000', '-1094984.09000', '.00000', '1-Jan-00', '19-Jun-15', '30-Jun-13', '30-Jun-13', '30-Jun-13', '0', None, '30-Jun-13', '30-Jun-13', '30-Jun-13', '30-Jun-13', '30-Jun-13', None, '9-Dec-13', '9-Dec-13', None, '9-Dec-13', None, '5-Feb-14', '14-Mar-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P087', '2', 'ESTACIONAMIENTO', 'AS1E009', 'AS100EA0490', None, None, None, None, '049', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '85,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00044136', 'GABRIELA VEGA SERRANO', 'GABRIELA', 'VEGA', 'SERRANO', 'GAVS4703247Z0', None, '1', None, None, None, None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'JARDINES DE SANTA MONICA', 'TLALNEPANTLA MEX', 'MEX', 'Mexico', None, '0', None, None, None, '30000016805', 'SI000002456', None, '82000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '30-Jun-13', '30-Jun-13', '30-Jun-13', '0', None, '30-Jun-13', '30-Jun-13', '30-Jun-13', '30-Jun-13', '30-Jun-13', None, '9-Dec-13', '9-Dec-13', None, '9-Dec-13', None, '5-Feb-14', '14-Mar-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P102', '1', 'DEPARTAMENTO', 'AS1D102', 'AS10BD22040', None, None, '0B', '2', '204', None, '1', '0', 'AS975.DEPTO TIPO 4', 'DEPTO, SALA/COMEDOR, COCINA, 2 RECÁMARAS, 1 BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '17.2', None, '4.67', None, None, None, None, '55.17', None, '0', '0', None, '0', '55.17', None, None, '0', None, None, None, None, None, '0', '1', '1', '991,686.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Apr-14', '30-Apr-14', '1-Nov-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00046093', 'ANA VERONICA SIPAQUE ZUNUN', 'ANA VERONICA', 'SIPAQUE', 'ZUNUN', 'SIZA860301QN6', None, '1', None, None, '52554151', None, '5591862462', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'MODELO PENSIL', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '11490', '0', None, None, None, '30000017324', 'SI000002534', None, '1061866.47000', '1200241.47000', '.00000', '.00000', '1200241.47000', '.00000', '.00000', '110679.51000', '.00000', '-1200241.47000', '110679.51000', '1-Jan-00', '19-Jun-15', '31-Jul-13', '31-Jul-13', '31-Jul-13', '0', None, '31-Jul-13', '31-Jul-13', '31-Jul-13', '31-Jul-13', '31-Jul-13', None, '4-Mar-14', '4-Mar-14', None, '10-Mar-14', None, '12-Mar-14', '26-Apr-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P102', '2', 'ESTACIONAMIENTO', 'AS1E167', 'AS100EF0440', None, None, None, None, '044', None, '1', '0', 'EST CEEX', 'Cajón Chico, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '65,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00046093', 'ANA VERONICA SIPAQUE ZUNUN', 'ANA VERONICA', 'SIPAQUE', 'ZUNUN', 'SIZA860301QN6', None, '1', None, None, '52554151', None, '5591862462', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'MODELO PENSIL', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '11490', '0', None, None, None, '30000017324', 'SI000002533', None, '66625.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '31-Jul-13', '31-Jul-13', '31-Jul-13', '0', None, '31-Jul-13', '31-Jul-13', '31-Jul-13', '31-Jul-13', '31-Jul-13', None, '4-Mar-14', '4-Mar-14', None, '10-Mar-14', None, '12-Mar-14', '26-Apr-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P102', '2', 'ESTACIONAMIENTO', 'AS1E115', 'AS100ED0450', None, None, None, None, '045', None, '1', '0', 'EST CDEX', 'Cajón Chico, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00046093', 'ANA VERONICA SIPAQUE ZUNUN', 'ANA VERONICA', 'SIPAQUE', 'ZUNUN', 'SIZA860301QN6', None, '1', None, None, '52554151', None, '5591862462', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'MODELO PENSIL', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '11490', '0', None, None, None, '30000017324', 'SI000002531', None, '71750.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '31-Jul-13', '31-Jul-13', '31-Jul-13', '0', None, '31-Jul-13', '31-Jul-13', '31-Jul-13', '31-Jul-13', '31-Jul-13', None, '4-Mar-14', '4-Mar-14', None, '10-Mar-14', None, '12-Mar-14', '26-Apr-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P184', '1', 'DEPARTAMENTO', 'AS1D184', 'AS10CD33060', None, None, '0C', '3', '306', None, '1', '0', 'AS975. DEPTO TIPO 6', 'DEPTO, SALA/COMEDOR, COCINA, 1 RECÁMARA, 1 BAÑO, PASILLO, PATIO DE LAVADO', None, None, '1', None, '1', '0', '17.48', None, '4.71', None, None, None, None, '47.75', None, '0', '0', None, '0', '47.75', None, None, '0', None, None, None, None, None, '0', '1', '1', '760,832.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00046820', 'MARIO CAMARGO VILLALOBOS', 'MARIO', 'CAMARGO', 'VILLALOBOS', 'CAVM650610NR3', None, '1', None, None, '53193369', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PAJARITOS Y FRESNOS JARDINES D', 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54130', '0', None, None, None, '30000017514', 'SI000002643', None, '872025.00000', '954025.00000', '.00000', '.00000', '954025.00000', '.00000', '.00000', '.00000', '.00000', '-954025.00000', '.00000', '1-Jan-00', '19-Jun-15', '26-Aug-13', '26-Aug-13', '26-Aug-13', '0', None, '26-Aug-13', '26-Aug-13', '26-Aug-13', '26-Aug-13', '26-Aug-13', None, '5-Nov-13', '5-Nov-13', None, '5-Nov-13', None, '7-Nov-13', '12-Nov-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P184', '2', 'ESTACIONAMIENTO', 'AS1E017', 'AS100EA0730', None, None, None, None, '073', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '85,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00046820', 'MARIO CAMARGO VILLALOBOS', 'MARIO', 'CAMARGO', 'VILLALOBOS', 'CAVM650610NR3', None, '1', None, None, '53193369', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PAJARITOS Y FRESNOS JARDINES D', 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54130', '0', None, None, None, '30000017514', 'SI000002642', None, '82000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '26-Aug-13', '26-Aug-13', '26-Aug-13', '0', None, '26-Aug-13', '26-Aug-13', '26-Aug-13', '26-Aug-13', '26-Aug-13', None, '5-Nov-13', '5-Nov-13', None, '5-Nov-13', None, '7-Nov-13', '12-Nov-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P179', '1', 'DEPARTAMENTO', 'AS1D179', 'AS10CD33010', None, None, '0C', '3', '301', None, '1', '0', 'AS975. DEPTO TIPO 5', 'DEPTO, SALA/COMEDOR, COCINA, 2 RECÁMARAS, 1 BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '16.57', None, '4.71', None, None, None, None, '48.64', None, '0', '0', None, '0', '48.64', None, None, '0', None, None, None, None, None, '0', '1', '1', '870,831.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00046822', 'FRANCISCO JAVIER MARTINEZ LOPEZ', 'FRANCISCO JAVIER', 'MARTINEZ', 'LOPEZ', 'MALF570715S38', None, '1', None, None, None, None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'FRACCIONAMIENTO GRAN MORADA', 'TOLUCA MEX', 'MEX', 'Mexico', '50010', '0', None, None, None, '30000017522', 'SI000002657', None, '892208.40000', '974208.40000', '.00000', '.00000', '974208.40000', '.00000', '.00000', '.00000', '.00000', '-974208.40000', '.00000', '1-Jan-00', '19-Jun-15', '28-Aug-13', '28-Aug-13', '28-Aug-13', '0', None, '28-Aug-13', '28-Aug-13', '28-Aug-13', '28-Aug-13', '28-Aug-13', None, '28-Aug-13', '28-Aug-13', None, '28-Aug-13', None, '29-Aug-13', '7-Sep-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P179', '2', 'ESTACIONAMIENTO', 'AS1E019', 'AS100EA0830', None, None, None, None, '083', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '85,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00046822', 'FRANCISCO JAVIER MARTINEZ LOPEZ', 'FRANCISCO JAVIER', 'MARTINEZ', 'LOPEZ', 'MALF570715S38', None, '1', None, None, None, None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'FRACCIONAMIENTO GRAN MORADA', 'TOLUCA MEX', 'MEX', 'Mexico', '50010', '0', None, None, None, '30000017522', 'SI000002656', None, '82000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '28-Aug-13', '28-Aug-13', '28-Aug-13', '0', None, '28-Aug-13', '28-Aug-13', '28-Aug-13', '28-Aug-13', '28-Aug-13', None, '28-Aug-13', '28-Aug-13', None, '28-Aug-13', None, '29-Aug-13', '7-Sep-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P192', '1', 'DEPARTAMENTO', 'AS1D192', 'AS10CD44060', None, None, '0C', '4', '406', None, '1', '0', 'AS975. DEPTO TIPO 6', 'DEPTO, SALA/COMEDOR, COCINA, 1 RECÁMARA, 1 BAÑO, PASILLO, PATIO DE LAVADO', None, None, '1', None, '1', '0', '17.48', None, '4.71', None, None, None, None, '47.75', None, '0', '0', None, '0', '47.75', None, None, '0', None, None, None, None, None, '0', '1', '1', '772,112.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00046853', 'JOSE ALFREDO CARRILLO FRANCO', 'JOSE ALFREDO', 'CARRILLO', 'FRANCO', 'CAFA591028CZA', None, '1', None, None, '58316167', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PORFIRIO DIAZ', 'ATIZAPÁN MEX', 'MEX', 'Mexico', '52945', '0', None, None, None, '30000017530', 'SI000002682', None, '853398.35000', '1012273.35000', '.00000', '.00000', '1012273.35000', '.00000', '.00000', '.00000', '.00000', '-1012273.36000', '-.01000', '1-Jan-00', '19-Jun-15', '2-Sep-13', '2-Sep-13', '2-Sep-13', '0', None, '2-Sep-13', '2-Sep-13', '2-Sep-13', '2-Sep-13', '2-Sep-13', None, '10-Oct-13', '10-Oct-13', None, '10-Oct-13', None, '23-Oct-13', '29-Oct-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P192', '2', 'ESTACIONAMIENTO', 'AS1E068', 'AS100EC0700', None, None, None, None, '070', None, '1', '0', 'EST GEEX', 'Cajón Grande, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00046853', 'JOSE ALFREDO CARRILLO FRANCO', 'JOSE ALFREDO', 'CARRILLO', 'FRANCO', 'CAFA591028CZA', None, '1', None, None, '58316167', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PORFIRIO DIAZ', 'ATIZAPÁN MEX', 'MEX', 'Mexico', '52945', '0', None, None, None, '30000017530', 'SI000002797', None, '76875.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '1-Oct-13', '1-Oct-13', '1-Oct-13', '0', None, '1-Oct-13', '1-Oct-13', '1-Oct-13', '1-Oct-13', '1-Oct-13', None, '10-Oct-13', '10-Oct-13', None, '10-Oct-13', None, '23-Oct-13', '29-Oct-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P192', '2', 'ESTACIONAMIENTO', 'AS1E016', 'AS100EA0710', None, None, None, None, '071', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '85,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00046853', 'JOSE ALFREDO CARRILLO FRANCO', 'JOSE ALFREDO', 'CARRILLO', 'FRANCO', 'CAFA591028CZA', None, '1', None, None, '58316167', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PORFIRIO DIAZ', 'ATIZAPÁN MEX', 'MEX', 'Mexico', '52945', '0', None, None, None, '30000017530', 'SI000002796', None, '82000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '1-Oct-13', '1-Oct-13', '1-Oct-13', '0', None, '1-Oct-13', '1-Oct-13', '1-Oct-13', '1-Oct-13', '1-Oct-13', None, '10-Oct-13', '10-Oct-13', None, '10-Oct-13', None, '23-Oct-13', '29-Oct-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P161', '1', 'DEPARTAMENTO', 'AS1D161', 'AS10CD00070', None, None, '0C', '0', '007', None, '1', '0', 'AS975.DEPTO TIPO 1', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '14.4', None, '4.52', None, None, None, None, '49.5', '2.05', '0', '0', None, '0', '49.5', None, None, '0', None, None, None, None, None, '0', '1', '1', '854,157.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00047238', 'VICTOR LORENZO PERAL ALMENGOR', 'VICTOR LORENZO', 'PERAL', 'ALMENGOR', 'PEAV650913JF0', 'PEAV650913HDFRLC02', '1', None, None, '54358115', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'CD SATELITE', 'NAUCALPAN JUÁREZ MEX', 'MEX', 'Mexico', '53100', '0', None, None, None, '30000017670', 'SI000004916', None, '940000.00000', '1025000.00000', '.00000', '.00000', '1025000.00000', '.00000', '.00000', '112573.95000', '.00000', '-1035028.00000', '102545.95000', '1-Jan-00', '19-Jun-15', '20-Jun-14', '20-Jun-14', '20-Jun-14', '0', None, '20-Jun-14', '20-Jun-14', '20-Jun-14', '20-Jun-14', '20-Jun-14', None, '4-Jul-14', '4-Jul-14', None, '10-Jul-14', None, '15-Aug-14', '2-Sep-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P161', '2', 'ESTACIONAMIENTO', 'AS1E021', 'AS100EA0870', None, None, None, None, '087', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '85,000.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Jul-14', '20-Jul-14', '21-Jan-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00047238', 'VICTOR LORENZO PERAL ALMENGOR', 'VICTOR LORENZO', 'PERAL', 'ALMENGOR', 'PEAV650913JF0', 'PEAV650913HDFRLC02', '1', None, None, '54358115', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'CD SATELITE', 'NAUCALPAN JUÁREZ MEX', 'MEX', 'Mexico', '53100', '0', None, None, None, '30000017670', 'SI000004915', None, '85000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '20-Jun-14', '20-Jun-14', '20-Jun-14', '0', None, '20-Jun-14', '20-Jun-14', '20-Jun-14', '20-Jun-14', '20-Jun-14', None, '4-Jul-14', '4-Jul-14', None, '10-Jul-14', None, '15-Aug-14', '2-Sep-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P173', '1', 'DEPARTAMENTO', 'AS1D173', 'AS10CD22030', None, None, '0C', '2', '203', None, '1', '0', 'AS975.DEPTO TIPO 1', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '14.4', None, '4.52', None, None, None, None, '49.5', '2.05', '0', '0', None, '0', '49.5', None, None, '0', None, None, None, None, None, '0', '1', '1', '916,917.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00048594', 'SALVADOR GERARDO HERNANDEZ ALVAREZ', 'SALVADOR GERARDO', 'HERNANDEZ', 'ALVAREZ', 'HEAS610416712', 'HEAS610416HDFRLL02', '1', None, None, '56542813', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'U. INFONAVIT IZTACALCO', 'IZTACALCO DF', 'DF', 'Mexico', '08900', '0', None, None, None, '30000018082', 'SI000003622', None, '907837.89000', '972837.89000', '.00000', '.00000', '972837.89000', '.00000', '.00000', '110198.96000', '.00000', '-972837.93000', '110198.92000', '1-Jan-00', '19-Jun-15', '28-Jan-14', '28-Jan-14', '28-Jan-14', '0', None, '28-Jan-14', '28-Jan-14', '28-Jan-14', '28-Jan-14', '28-Jan-14', None, '6-Mar-14', '6-Mar-14', None, '14-Apr-14', None, '27-May-14', '5-Jun-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P173', '2', 'ESTACIONAMIENTO', 'AS1E175', 'AS100EF0900', None, None, None, None, '090', None, '1', '0', 'EST CEEX', 'Cajón Chico, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '65,000.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-14', '20-Feb-14', '24-Aug-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00048594', 'SALVADOR GERARDO HERNANDEZ ALVAREZ', 'SALVADOR GERARDO', 'HERNANDEZ', 'ALVAREZ', 'HEAS610416712', 'HEAS610416HDFRLL02', '1', None, None, '56542813', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'U. INFONAVIT IZTACALCO', 'IZTACALCO DF', 'DF', 'Mexico', '08900', '0', None, None, None, '30000018082', 'SI000003619', None, '65000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '28-Jan-14', '28-Jan-14', '28-Jan-14', '0', None, '28-Jan-14', '28-Jan-14', '28-Jan-14', '28-Jan-14', '28-Jan-14', None, '6-Mar-14', '6-Mar-14', None, '14-Apr-14', None, '27-May-14', '5-Jun-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P177', '1', 'DEPARTAMENTO', 'AS1D177', 'AS10CD22070', None, None, '0C', '2', '207', None, '1', '0', 'AS975.DEPTO TIPO 1', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '14.4', None, '4.52', None, None, None, None, '49.5', '2.05', '0', '0', None, '0', '49.5', None, None, '0', None, None, None, None, None, '0', '1', '1', '867,964.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00049020', 'MOISES  ALEJANDRO MUÑOZ JAUREGUI', 'MOISES  ALEJANDRO', 'MUÑOZ', 'JAUREGUI', 'MUJM670104878', None, '1', None, None, '58895318', '11012619', '5539726375', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'CONJ HAB LAS CARMELITAS', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54710', '0', None, None, None, '30000018215', 'SI000002831', None, '899369.42000', '971119.42000', '.00000', '.00000', '971119.42000', '.00000', '.00000', '.00000', '.00000', '-1762303.42000', '-791184.00000', '15-Jan-15', '15-Jan-15', '2-Oct-13', '2-Oct-13', '2-Oct-13', '0', None, '2-Oct-13', '2-Oct-13', '2-Oct-13', '2-Oct-13', '2-Oct-13', None, '11-Nov-13', '11-Nov-13', None, '11-Nov-13', None, '5-Dec-13', '6-Dec-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P177', '2', 'ESTACIONAMIENTO', 'AS1E120', 'AS100ED0670', None, None, None, None, '067', None, '1', '0', 'EST CDEX', 'Cajón Chico, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00049020', 'MOISES  ALEJANDRO MUÑOZ JAUREGUI', 'MOISES  ALEJANDRO', 'MUÑOZ', 'JAUREGUI', 'MUJM670104878', None, '1', None, None, '58895318', '11012619', '5539726375', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'CONJ HAB LAS CARMELITAS', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54710', '0', None, None, None, '30000018215', 'SI000002826', None, '71750.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '2-Oct-13', '2-Oct-13', '2-Oct-13', '0', None, '2-Oct-13', '2-Oct-13', '2-Oct-13', '2-Oct-13', '2-Oct-13', None, '11-Nov-13', '11-Nov-13', None, '11-Nov-13', None, '5-Dec-13', '6-Dec-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P063', '1', 'DEPARTAMENTO', 'AS1D063', 'AS10AD55050', None, None, '0A', '5', '505', None, '1', '0', 'AS975.DEPTO TIPO 1B', 'DEPTO, SALA/COMEDOR, COCINA, 2 RECÁMARAS, 1 BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '14.4', None, '4.52', None, None, None, None, '49.5', '2.05', '0', '0', None, '0', '49.5', None, None, '47.67', None, None, None, None, None, '0', '1', '1', '1,177,414.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Sep-14', '20-Sep-14', '24-Mar-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00050468', 'CLAUDIA GARCIA ARELLANO', 'CLAUDIA', 'GARCIA', 'ARELLANO', 'GAAC831222TQ1', None, '1', None, None, '58903998', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'FRACC FUENTES DEL VALLE', 'TULTITLÁN MEX', 'MEX', 'Mexico', '54910', '0', None, None, None, '30000018744', 'SI000002828', None, '1165756.26000', '1237507.26000', '.00000', '.00000', '1237507.26000', '.00000', '.00000', '92812.96000', '.00000', '-1237507.26000', '92812.96000', '1-Jan-00', '19-Jun-15', '2-Oct-13', '2-Oct-13', '2-Oct-13', '0', None, '2-Oct-13', '2-Oct-13', '2-Oct-13', '2-Oct-13', '2-Oct-13', None, '10-Oct-14', '10-Oct-14', None, '13-Oct-14', None, '21-Oct-14', '7-Nov-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P063', '2', 'ESTACIONAMIENTO', 'AS1E054', 'AS100EA2370', None, None, None, None, '237', None, '1', '0', 'EST CDEX', 'Cajón Chico, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00050468', 'CLAUDIA GARCIA ARELLANO', 'CLAUDIA', 'GARCIA', 'ARELLANO', 'GAAC831222TQ1', None, '1', None, None, '58903998', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'FRACC FUENTES DEL VALLE', 'TULTITLÁN MEX', 'MEX', 'Mexico', '54910', '0', None, None, None, '30000018744', 'SI000002827', None, '71750.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '2-Oct-13', '2-Oct-13', '2-Oct-13', '0', None, '2-Oct-13', '2-Oct-13', '2-Oct-13', '2-Oct-13', '2-Oct-13', None, '10-Oct-14', '10-Oct-14', None, '13-Oct-14', None, '21-Oct-14', '7-Nov-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P063', '3', 'BODEGA', 'AS1B036', 'AS100BD0360', None, None, None, None, '036', None, '1', '0', 'AS975. BODEGA TIPO 6', 'BODEGA DE 4.30 M2', None, None, None, None, None, None, None, None, None, None, None, None, None, '4.3', None, None, None, None, None, None, None, None, '0', None, None, None, None, None, '0', '1', '1', '1.00 ', '0.00 ', '0.00 ', '0.00 ', '1-Dec-13', '1-Dec-13', '4-Jun-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00050468', 'CLAUDIA GARCIA ARELLANO', 'CLAUDIA', 'GARCIA', 'ARELLANO', 'GAAC831222TQ1', None, '1', None, None, '58903998', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'FRACC FUENTES DEL VALLE', 'TULTITLÁN MEX', 'MEX', 'Mexico', '54910', '0', None, None, None, '30000018744', 'SI000002823', None, '1.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '2-Oct-13', '2-Oct-13', '2-Oct-13', '0', None, '2-Oct-13', '2-Oct-13', '2-Oct-13', '2-Oct-13', '2-Oct-13', None, '10-Oct-14', '10-Oct-14', None, '13-Oct-14', None, '21-Oct-14', '7-Nov-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P157', '1', 'DEPARTAMENTO', 'AS1D157', 'AS10CD00030', None, None, '0C', '0', '003', None, '1', '0', 'AS975.DEPTO TIPO 1', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '14.4', None, '4.52', None, None, None, None, '49.5', '2.05', '0', '0', None, '0', '49.5', None, None, '0', None, None, None, None, None, '0', '1', '1', '953,095.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00050756', 'ALICIA ESPINAL BALTAZAR', 'ALICIA', 'ESPINAL', 'BALTAZAR', 'EIBA8004025BA', 'EIBA800402MMCSLL08', '1', None, None, '58341776', '53224320 ext 22', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'FRACC LAS ESTEPAS', 'TULTITLÁN MEX', 'MEX', 'Mexico', '54930', '0', None, None, None, '30000018876', 'SI000002984', None, '933658.35000', '1008658.35000', '.00000', '.00000', '1008658.35000', '.00000', '.00000', '.00000', '.00000', '-1011323.67000', '-2665.32000', '1-Jan-00', '19-Jun-15', '5-Nov-13', '5-Nov-13', '5-Nov-13', '0', None, '5-Nov-13', '5-Nov-13', '5-Nov-13', '5-Nov-13', '5-Nov-13', None, '27-Nov-13', '27-Nov-13', None, '29-Nov-13', None, '23-Dec-13', '30-Dec-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P157', '2', 'ESTACIONAMIENTO', 'AS1E100', 'AS100EC1880', None, None, None, None, '188', None, '1', '0', 'EST GEEX', 'Cajón Grande, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00050756', 'ALICIA ESPINAL BALTAZAR', 'ALICIA', 'ESPINAL', 'BALTAZAR', 'EIBA8004025BA', 'EIBA800402MMCSLL08', '1', None, None, '58341776', '53224320 ext 22', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'FRACC LAS ESTEPAS', 'TULTITLÁN MEX', 'MEX', 'Mexico', '54930', '0', None, None, None, '30000018876', 'SI000002980', None, '75000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '5-Nov-13', '5-Nov-13', '5-Nov-13', '0', None, '5-Nov-13', '5-Nov-13', '5-Nov-13', '5-Nov-13', '5-Nov-13', None, '27-Nov-13', '27-Nov-13', None, '29-Nov-13', None, '23-Dec-13', '13-Dec-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P115', '1', 'DEPARTAMENTO', 'AS1D115', 'AS10BD33030', None, None, '0B', '3', '303', None, '1', '0', 'AS975.DEPTO TIPO 4', 'DEPTO, SALA/COMEDOR, COCINA, 2 RECÁMARAS, 1 BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '17.2', None, '4.67', None, None, None, None, '55.17', None, '0', '0', None, '0', '55.17', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,004,303.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Apr-14', '30-Apr-14', '1-Nov-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00050778', 'RICARDO MORA LEYVA', 'RICARDO', 'MORA', 'LEYVA', 'MOLR790403AL2', 'MOLR790403HDFRYC04', '1', None, None, '56080752', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'VALLE DE LUCES', 'IZTAPALAPA DF', 'DF', 'Mexico', '09800', '0', None, None, None, '30000018926', 'SI000002829', None, '1044359.02000', '1203234.02000', '.00000', '.00000', '1203234.02000', '.00000', '.00000', '110991.06000', '.00000', '-1205734.02000', '108491.06000', '1-Jan-00', '19-Jun-15', '2-Oct-13', '2-Oct-13', '2-Oct-13', '0', None, '2-Oct-13', '2-Oct-13', '2-Oct-13', '2-Oct-13', '2-Oct-13', None, '24-Apr-14', '24-Apr-14', None, '25-Apr-14', None, '25-Apr-14', '13-May-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P115', '2', 'ESTACIONAMIENTO', 'AS1E029', 'AS100EA1110', None, None, None, None, '111', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '85,000.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Jan-14', '20-Jan-14', '24-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00050778', 'RICARDO MORA LEYVA', 'RICARDO', 'MORA', 'LEYVA', 'MOLR790403AL2', 'MOLR790403HDFRYC04', '1', None, None, '56080752', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'VALLE DE LUCES', 'IZTAPALAPA DF', 'DF', 'Mexico', '09800', '0', None, None, None, '30000018926', 'SI000002824', None, '82000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '2-Oct-13', '2-Oct-13', '2-Oct-13', '0', None, '2-Oct-13', '2-Oct-13', '2-Oct-13', '2-Oct-13', '2-Oct-13', None, '24-Apr-14', '24-Apr-14', None, '25-Apr-14', None, '25-Apr-14', '13-May-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P115', '2', 'ESTACIONAMIENTO', 'AS1E081', 'AS100EC1100', None, None, None, None, '110', None, '1', '0', 'EST GEEX', 'Cajón Grande, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Jan-14', '20-Jan-14', '24-Jul-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00050778', 'RICARDO MORA LEYVA', 'RICARDO', 'MORA', 'LEYVA', 'MOLR790403AL2', 'MOLR790403HDFRYC04', '1', None, None, '56080752', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'VALLE DE LUCES', 'IZTAPALAPA DF', 'DF', 'Mexico', '09800', '0', None, None, None, '30000018926', 'SI000002825', None, '76875.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '2-Oct-13', '2-Oct-13', '2-Oct-13', '0', None, '2-Oct-13', '2-Oct-13', '2-Oct-13', '2-Oct-13', '2-Oct-13', None, '24-Apr-14', '24-Apr-14', None, '25-Apr-14', None, '25-Apr-14', '13-May-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P171', '1', 'DEPARTAMENTO', 'AS1D171', 'AS10CD22010', None, None, '0C', '2', '201', None, '1', '0', 'AS975. DEPTO TIPO 5', 'DEPTO, SALA/COMEDOR, COCINA, 2 RECÁMARAS, 1 BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '16.57', None, '4.71', None, None, None, None, '48.64', None, '0', '0', None, '0', '48.64', None, None, '0', None, None, None, None, None, '0', '1', '1', '859,446.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00051084', 'LEOPOLDO RODRIGUEZ RECIO', 'LEOPOLDO', 'RODRIGUEZ', 'RECIO', 'RORL5608185K4', None, '1', None, None, '58686607', '57548510', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'FRACC.  JARDINES DEL ALBA', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54750', '0', None, None, None, '30000019049', 'SI000002937', None, '880936.04000', '1040936.04000', '.00000', '.00000', '1040936.04000', '.00000', '.00000', '.00000', '.00000', '-1040936.04000', '.00000', '1-Jan-00', '19-Jun-15', '28-Oct-13', '28-Oct-13', '28-Oct-13', '0', None, '28-Oct-13', '28-Oct-13', '28-Oct-13', '28-Oct-13', '28-Oct-13', None, '3-Dec-13', '3-Dec-13', None, '9-Dec-13', None, '2-Jan-14', '12-Feb-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P171', '2', 'ESTACIONAMIENTO', 'AS1E097', 'AS100EC1820', None, None, None, None, '182', None, '1', '0', 'EST GEEX', 'Cajón Grande, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00051084', 'LEOPOLDO RODRIGUEZ RECIO', 'LEOPOLDO', 'RODRIGUEZ', 'RECIO', 'RORL5608185K4', None, '1', None, None, '58686607', '57548510', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'FRACC.  JARDINES DEL ALBA', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54750', '0', None, None, None, '30000019049', 'SI000002936', None, '75000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '28-Oct-13', '28-Oct-13', '28-Oct-13', '0', None, '28-Oct-13', '28-Oct-13', '28-Oct-13', '28-Oct-13', '28-Oct-13', None, '3-Dec-13', '3-Dec-13', None, '9-Dec-13', None, '2-Jan-14', '12-Feb-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P171', '2', 'ESTACIONAMIENTO', 'AS1E045', 'AS100EA1810', None, None, None, None, '181', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '85,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00051084', 'LEOPOLDO RODRIGUEZ RECIO', 'LEOPOLDO', 'RODRIGUEZ', 'RECIO', 'RORL5608185K4', None, '1', None, None, '58686607', '57548510', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'FRACC.  JARDINES DEL ALBA', 'CUAUTITLÁN IZCALLI MEX', 'MEX', 'Mexico', '54750', '0', None, None, None, '30000019049', 'SI000002935', None, '85000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '28-Oct-13', '28-Oct-13', '28-Oct-13', '0', None, '28-Oct-13', '28-Oct-13', '28-Oct-13', '28-Oct-13', '28-Oct-13', None, '3-Dec-13', '3-Dec-13', None, '9-Dec-13', None, '2-Jan-14', '12-Feb-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P165', '1', 'DEPARTAMENTO', 'AS1D165', 'AS10CD11030', None, None, '0C', '1', '103', None, '1', '0', 'AS975.DEPTO TIPO 1', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '14.4', None, '4.52', None, None, None, None, '49.5', '2.05', '0', '0', None, '0', '49.5', None, None, '0', None, None, None, None, None, '0', '1', '1', '904,857.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00052272', 'CLARA GABRIEL VILLAGOMEZ', 'CLARA', 'GABRIEL', 'VILLAGOMEZ', 'GAVC790809R67', 'GAVC790809MMCBLL02', '1', None, 'cgabriel@sueciacarsanangel.com', '35383414', '10857500', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BAJA CALIFORNIA DOCTORES', 'CUAUHTÉMOC DF', 'DF', 'Mexico', '06720', '0', None, None, None, '30000019395', 'SI000002957', None, '955897.74000', '1030897.76000', '.00000', '.00000', '1030897.76000', '.00000', '.00000', '.00000', '.00000', '-1030897.76000', '.00000', '15-Jan-15', '15-Jan-15', '4-Nov-13', '4-Nov-13', '4-Nov-13', '0', None, '4-Nov-13', '4-Nov-13', '4-Nov-13', '4-Nov-13', '4-Nov-13', None, '27-Nov-13', '27-Nov-13', None, '29-Nov-13', None, '18-Dec-13', '20-Dec-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P165', '2', 'ESTACIONAMIENTO', 'AS1E043', 'AS100EA1730', None, None, None, None, '173', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '85,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00052272', 'CLARA GABRIEL VILLAGOMEZ', 'CLARA', 'GABRIEL', 'VILLAGOMEZ', 'GAVC790809R67', 'GAVC790809MMCBLL02', '1', None, 'cgabriel@sueciacarsanangel.com', '35383414', '10857500', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'BAJA CALIFORNIA DOCTORES', 'CUAUHTÉMOC DF', 'DF', 'Mexico', '06720', '0', None, None, None, '30000019395', 'SI000002951', None, '75000.02000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '4-Nov-13', '4-Nov-13', '4-Nov-13', '0', None, '4-Nov-13', '4-Nov-13', '4-Nov-13', '4-Nov-13', '4-Nov-13', None, '27-Nov-13', '27-Nov-13', None, '29-Nov-13', None, '18-Dec-13', '20-Dec-13', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P108', '1', 'DEPARTAMENTO', 'AS1D108', 'AS10BD22100', None, None, '0B', '2', '210', None, '1', '0', 'AS975.DEPTO TIPO 1', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '14.4', None, '4.52', None, None, None, None, '49.5', '2.05', '0', '0', None, '0', '49.5', None, None, '0', None, None, None, None, None, '0', '1', '1', '935,080.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Apr-14', '30-Apr-14', '1-Nov-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00053540', 'CRISTIAM DENNYS ESPINOZA MALPARTIDA', 'CRISTIAM DENNYS', 'ESPINOZA', 'MALPARTIDA', 'EIMC770201ILA', 'EIMC770201HNESLR06', '1', None, None, '5554351894', '5553470628', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'NEXTENGO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02070', '0', None, None, None, '30000019825', 'SI000002982', None, '1005821.74000', '1090821.74000', '.00000', '.00000', '1090821.74000', '.00000', '.00000', '81811.57000', '.00000', '-1090822.21000', '81811.10000', '1-Jan-00', '19-Jun-15', '5-Nov-13', '5-Nov-13', '5-Nov-13', '0', None, '5-Nov-13', '5-Nov-13', '5-Nov-13', '5-Nov-13', '5-Nov-13', None, '12-May-14', '12-May-14', None, '12-May-14', None, '30-May-14', '5-Jun-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P108', '2', 'ESTACIONAMIENTO', 'AS1E027', 'AS100EA1070', None, None, None, None, '107', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '85,000.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Dec-13', '20-Dec-13', '23-Jun-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00053540', 'CRISTIAM DENNYS ESPINOZA MALPARTIDA', 'CRISTIAM DENNYS', 'ESPINOZA', 'MALPARTIDA', 'EIMC770201ILA', 'EIMC770201HNESLR06', '1', None, None, '5554351894', '5553470628', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'NEXTENGO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02070', '0', None, None, None, '30000019825', 'SI000002976', None, '85000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '5-Nov-13', '5-Nov-13', '5-Nov-13', '0', None, '5-Nov-13', '5-Nov-13', '5-Nov-13', '5-Nov-13', '5-Nov-13', None, '12-May-14', '12-May-14', None, '12-May-14', None, '30-May-14', '5-Jun-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P178', '1', 'DEPARTAMENTO', 'AS1D178', 'AS10CD22080', None, None, '0C', '2', '208', None, '1', '0', 'AS975.DEPTO TIPO 3', 'DEPTO, SALA/COMEDOR, COCINA, 1 RECÁMARA, 1 BAÑO, PASILLO, PATIO DE LAVADO', None, None, '1', None, '1', '0', '13.21', None, '6.64', None, None, None, None, '43.28', None, '0', '0', None, '0', '43.28', None, None, '0', None, None, None, None, None, '0', '1', '1', '749,353.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00054252', 'ROSA LAURA CRUZ SALINAS', 'ROSA LAURA', 'CRUZ', 'SALINAS', 'CUSR820503NEA', 'CUSR820503MMCRLS00', '1', None, 'rlcs_82@yahoo.com.mx', '5558898311', None, '5521413422', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'ESCANDON  2A SECC', 'MIGUEL HIDALGO DF', 'DF', 'Mexico', '11800', '0', None, None, None, '30000020062', 'SI000003150', None, '771932.81000', '846932.81000', '.00000', '.00000', '846932.81000', '.00000', '.00000', '90769.63000', '.00000', '-849432.81000', '88269.63000', '15-Jan-15', '15-Jan-15', '2-Dec-13', '2-Dec-13', '2-Dec-13', '0', None, '2-Dec-13', '2-Dec-13', '2-Dec-13', '2-Dec-13', '2-Dec-13', None, '17-Feb-14', '17-Feb-14', None, '21-Feb-14', None, '27-May-14', '5-Jun-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P178', '2', 'ESTACIONAMIENTO', 'AS1E065', 'AS100EC0600', None, None, None, None, '060', None, '1', '0', 'EST GEEX', 'Cajón Grande, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00054252', 'ROSA LAURA CRUZ SALINAS', 'ROSA LAURA', 'CRUZ', 'SALINAS', 'CUSR820503NEA', 'CUSR820503MMCRLS00', '1', None, 'rlcs_82@yahoo.com.mx', '5558898311', None, '5521413422', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'ESCANDON  2A SECC', 'MIGUEL HIDALGO DF', 'DF', 'Mexico', '11800', '0', None, None, None, '30000020062', 'SI000003143', None, '75000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '2-Dec-13', '2-Dec-13', '2-Dec-13', '0', None, '2-Dec-13', '2-Dec-13', '2-Dec-13', '2-Dec-13', '2-Dec-13', None, '17-Feb-14', '17-Feb-14', None, '21-Feb-14', None, '27-May-14', '5-Jun-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P103', '1', 'DEPARTAMENTO', 'AS1D103', 'AS10BD22050', None, None, '0B', '2', '205', None, '1', '0', 'AS975.DEPTO TIPO 2', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1ALCOBA, 2BAÑOS, PASILLO, PATIOLAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,080,807.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Apr-14', '30-Apr-14', '1-Nov-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00054835', 'JOSE LUIS HERNANDEZ SANTIAGO', 'JOSE LUIS', 'HERNANDEZ', 'SANTIAGO', 'HESL590706I51', 'HESL590706HDFRNS03', '1', None, 'joseluhesal@prodigy.net.mx', '65457696', '53593245', '5512955675', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'ANAHUAC', 'MIGUEL HIDALGO DF', 'DF', 'Mexico', '11320', '0', None, None, None, '30000020278', 'SI000003147', None, '1100105.48000', '1260105.48000', '.00000', '.00000', '1260105.48000', '.00000', '.00000', '110284.20000', '.00000', '-1260089.48000', '110300.20000', '15-Jan-15', '15-Jan-15', '2-Dec-13', '2-Dec-13', '2-Dec-13', '0', None, '2-Dec-13', '2-Dec-13', '2-Dec-13', '2-Dec-13', '2-Dec-13', None, '10-Jan-14', '10-Jan-14', None, '16-Jan-14', None, '18-Jul-14', '12-Aug-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P103', '2', 'ESTACIONAMIENTO', 'AS1E010', 'AS100EA0510', None, None, None, None, '051', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '85,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00054835', 'JOSE LUIS HERNANDEZ SANTIAGO', 'JOSE LUIS', 'HERNANDEZ', 'SANTIAGO', 'HESL590706I51', 'HESL590706HDFRNS03', '1', None, 'joseluhesal@prodigy.net.mx', '65457696', '53593245', '5512955675', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'ANAHUAC', 'MIGUEL HIDALGO DF', 'DF', 'Mexico', '11320', '0', None, None, None, '30000020278', 'SI000003140', None, '85000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '2-Dec-13', '2-Dec-13', '2-Dec-13', '0', None, '2-Dec-13', '2-Dec-13', '2-Dec-13', '2-Dec-13', '2-Dec-13', None, '10-Jan-14', '10-Jan-14', None, '16-Jan-14', None, '18-Jul-14', '12-Aug-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P103', '2', 'ESTACIONAMIENTO', 'AS1E062', 'AS100EC0500', None, None, None, None, '050', None, '1', '0', 'EST GEEX', 'Cajón Grande, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00054835', 'JOSE LUIS HERNANDEZ SANTIAGO', 'JOSE LUIS', 'HERNANDEZ', 'SANTIAGO', 'HESL590706I51', 'HESL590706HDFRNS03', '1', None, 'joseluhesal@prodigy.net.mx', '65457696', '53593245', '5512955675', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'ANAHUAC', 'MIGUEL HIDALGO DF', 'DF', 'Mexico', '11320', '0', None, None, None, '30000020278', 'SI000003142', None, '75000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '2-Dec-13', '2-Dec-13', '2-Dec-13', '0', None, '2-Dec-13', '2-Dec-13', '2-Dec-13', '2-Dec-13', '2-Dec-13', None, '10-Jan-14', '10-Jan-14', None, '16-Jan-14', None, '18-Jul-14', '12-Aug-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P156', '1', 'DEPARTAMENTO', 'AS1D156', 'AS10CD00020', None, None, '0C', '0', '002', None, '1', '0', 'AS975.DEPTO TIPO 1B', 'DEPTO, SALA/COMEDOR, COCINA, 2 RECÁMARAS, 1 BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '14.4', None, '4.52', None, None, None, None, '49.5', '2.05', '0', '0', None, '0', '49.5', None, None, '0', None, None, None, None, None, '0', '1', '1', '953,095.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00054846', 'BEATRIZ GUTIERREZ ZUÑIGA', 'BEATRIZ', 'GUTIERREZ', 'ZUÑIGA', 'GUZB651102AU5', 'GUZB651102MDFTXT01', '1', None, None, '3999290', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN  ALVARO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02090', '0', None, None, None, '30000020286', 'SI000003110', None, '993658.36000', '1068658.36000', '.00000', '.00000', '1068658.36000', '.00000', '.00000', '.00000', '.00000', '-1068658.36000', '.00000', '1-Jan-00', '19-Jun-15', '29-Nov-13', '29-Nov-13', '29-Nov-13', '0', None, '29-Nov-13', '29-Nov-13', '29-Nov-13', '29-Nov-13', '29-Nov-13', None, '6-Dec-13', '6-Dec-13', None, '9-Dec-13', None, '4-Feb-14', '6-Mar-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P156', '2', 'ESTACIONAMIENTO', 'AS1E099', 'AS100EC1860', None, None, None, None, '186', None, '1', '0', 'EST GEEX', 'Cajón Grande, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00054846', 'BEATRIZ GUTIERREZ ZUÑIGA', 'BEATRIZ', 'GUTIERREZ', 'ZUÑIGA', 'GUZB651102AU5', 'GUZB651102MDFTXT01', '1', None, None, '3999290', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN  ALVARO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02090', '0', None, None, None, '30000020286', 'SI000003109', None, '75000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '29-Nov-13', '29-Nov-13', '29-Nov-13', '0', None, '29-Nov-13', '29-Nov-13', '29-Nov-13', '29-Nov-13', '29-Nov-13', None, '6-Dec-13', '6-Dec-13', None, '9-Dec-13', None, '4-Feb-14', '6-Mar-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P041', '1', 'DEPARTAMENTO', 'AS1D041', 'AS10AD33070', None, None, '0A', '3', '307', None, '1', '0', 'AS975.DEPTO TIPO 1B', 'DEPTO, SALA/COMEDOR, COCINA, 2 RECÁMARAS, 1 BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '14.4', None, '4.52', None, None, None, None, '49.5', '2.05', '0', '0', None, '0', '49.5', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,149,189.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Sep-14', '20-Sep-14', '24-Mar-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00055705', 'YAZMIN VARA MEZA', 'YAZMIN', 'VARA', 'MEZA', 'VAMY8009032P7', 'VAMY800903MDFRZZ00', '1', None, 'tsyazvm@hotmail.com', '25659858', None, '5525659858', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LA CONCHITA', 'ALVARO OBREGÓN DF', 'DF', 'Mexico', '01130', '0', None, None, None, '30010164223', 'SI000006015', None, '1154188.67000', '1219188.67000', '.00000', '.00000', '1219188.67000', '.00000', '.00000', '115822.92000', '.00000', '-1219189.67000', '115821.92000', '15-Jan-15', '15-Jan-15', '26-Sep-14', '26-Sep-14', '26-Sep-14', '0', None, '26-Sep-14', '26-Sep-14', '26-Sep-14', '26-Sep-14', '26-Sep-14', None, '18-Nov-14', '18-Nov-14', None, '27-Nov-14', None, '17-Feb-15', '3-Mar-15', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P041', '2', 'ESTACIONAMIENTO', 'AS1E184', 'AS100EF1490', None, None, None, None, '149', None, '1', '0', 'EST CEEX', 'Cajón Chico, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '65,000.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Oct-14', '20-Oct-14', '23-Apr-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00055705', 'YAZMIN VARA MEZA', 'YAZMIN', 'VARA', 'MEZA', 'VAMY8009032P7', 'VAMY800903MDFRZZ00', '1', None, 'tsyazvm@hotmail.com', '25659858', None, '5525659858', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LA CONCHITA', 'ALVARO OBREGÓN DF', 'DF', 'Mexico', '01130', '0', None, None, None, '30010164223', 'SI000006014', None, '65000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '26-Sep-14', '26-Sep-14', '26-Sep-14', '0', None, '26-Sep-14', '26-Sep-14', '26-Sep-14', '26-Sep-14', '26-Sep-14', None, '18-Nov-14', '18-Nov-14', None, '27-Nov-14', None, '17-Feb-15', '24-Feb-15', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P080', '1', 'DEPARTAMENTO', 'AS1D080', 'AS10BD00100', None, None, '0B', '0', '010', None, '1', '0', 'AS975.DEPTO TIPO 1', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '14.4', None, '4.52', None, None, None, None, '49.5', '2.05', '0', '0', None, '0', '49.5', None, None, '0', None, None, None, None, None, '0', '1', '1', '970,935.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-14', '30-Jun-14', '1-Jan-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00056039', 'MIGUEL MENDOZA BELLO', 'MIGUEL', 'MENDOZA', 'BELLO', 'MEBM6707058A1', 'MEBM670705HDFNLG09', '0', 'H', None, '55417733', None, '5541773350', None, '1-Jan-00', None, None, None, None, None, '2', 'Volante', 'ANGEL DANIEL', '120', None, 'FRACC CLAUSTROS DE SAN MIGUEL', 'CUAUTITLAN IZCALLI', 'MEX', 'MEXICO', '54715', '0', None, None, '0', '30010184080', '0002265', None, '970935.00000', '1045935.00000', '.00000', '.00000', '1045935.00000', '.00000', '.00000', '83674.80000', '.00000', '-1045935.00000', '83674.80000', '1-Jan-00', '19-Jun-15', '26-Feb-15', '26-Feb-15', '24-Feb-15', '12', None, '27-Feb-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', None, '12-Mar-15', '12-Mar-15', None, '19-Mar-15', None, '10-Apr-15', '28-Apr-15', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P080', '2', 'ESTACIONAMIENTO', 'AS1E076', 'AS100EC0960', None, None, None, None, '096', None, '1', '0', 'EST GEEX', 'Cajón Grande, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '1-Mar-14', '1-Mar-14', '2-Sep-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00056039', 'MIGUEL MENDOZA BELLO', 'MIGUEL', 'MENDOZA', 'BELLO', 'MEBM6707058A1', 'MEBM670705HDFNLG09', '0', 'H', None, '55417733', None, '5541773350', None, '1-Jan-00', None, None, None, None, None, '2', 'Volante', 'ANGEL DANIEL', '120', None, 'FRACC CLAUSTROS DE SAN MIGUEL', 'CUAUTITLAN IZCALLI', 'MEX', 'MEXICO', '54715', '0', None, None, '0', '30010184080', '0002265', None, '75000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '26-Feb-15', '26-Feb-15', '24-Feb-15', '12', None, '27-Feb-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', '5-Mar-15', None, '12-Mar-15', '12-Mar-15', None, '19-Mar-15', None, '10-Apr-15', '28-Apr-15', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P180', '1', 'DEPARTAMENTO', 'AS1D180', 'AS10CD33020', None, None, '0C', '3', '302', None, '1', '0', 'AS975.DEPTO TIPO 1B', 'DEPTO, SALA/COMEDOR, COCINA, 2 RECÁMARAS, 1 BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '14.4', None, '4.52', None, None, None, None, '49.5', '2.05', '0', '0', None, '0', '49.5', None, None, '0', None, None, None, None, None, '0', '1', '1', '928,976.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00056365', 'LUIS MIGUEL CRUZ RODRIGUEZ', 'LUIS MIGUEL', 'CRUZ', 'RODRIGUEZ', 'CURL800215PT5', 'CURL800215HDFRDS09', '1', None, 'lmcruzr@gmail.com', '567456800', None, '5538993188', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PORTALES', 'BENITO JUÁREZ DF', 'DF', 'Mexico', '03300', '0', None, None, None, '30000020914', 'SI000003347', None, '919778.05000', '1139778.05000', '.00000', '.00000', '1139778.05000', '.00000', '.00000', '91200.00000', '.00000', '-1139778.05000', '91200.00000', '15-Jan-15', '15-Jan-15', '23-Dec-13', '23-Dec-13', '23-Dec-13', '0', None, '23-Dec-13', '23-Dec-13', '23-Dec-13', '23-Dec-13', '23-Dec-13', None, '6-Feb-14', '6-Feb-14', None, '13-Feb-14', None, '28-Feb-14', '10-Mar-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P180', '2', 'ESTACIONAMIENTO', 'AS1E212', 'AS100EG0770', None, None, None, None, '077', None, '1', '0', 'EST DDEX', 'Cajón DISCAPACITADO, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '19', None, None, None, None, None, None, '3.8', None, '0', None, None, 'DISCAPACITADO', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '115,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00056365', 'LUIS MIGUEL CRUZ RODRIGUEZ', 'LUIS MIGUEL', 'CRUZ', 'RODRIGUEZ', 'CURL800215PT5', 'CURL800215HDFRDS09', '1', None, 'lmcruzr@gmail.com', '567456800', None, '5538993188', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PORTALES', 'BENITO JUÁREZ DF', 'DF', 'Mexico', '03300', '0', None, None, None, '30000020914', 'SI000003365', None, '115000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '26-Dec-13', '26-Dec-13', '26-Dec-13', '0', None, '26-Dec-13', '26-Dec-13', '26-Dec-13', '26-Dec-13', '26-Dec-13', None, '6-Feb-14', '6-Feb-14', None, '13-Feb-14', None, '28-Feb-14', '10-Mar-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P180', '2', 'ESTACIONAMIENTO', 'AS1E001', 'AS100E50760', None, None, None, None, '076', None, '1', '0', 'EST DEEX', 'Cajón DISCAPACITADO, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '19', None, None, None, None, None, None, '3.8', None, '0', None, None, 'DISCAPACITADO', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '105,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00056365', 'LUIS MIGUEL CRUZ RODRIGUEZ', 'LUIS MIGUEL', 'CRUZ', 'RODRIGUEZ', 'CURL800215PT5', 'CURL800215HDFRDS09', '1', None, 'lmcruzr@gmail.com', '567456800', None, '5538993188', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PORTALES', 'BENITO JUÁREZ DF', 'DF', 'Mexico', '03300', '0', None, None, None, '30000020914', 'SI000003346', None, '105000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '23-Dec-13', '23-Dec-13', '23-Dec-13', '0', None, '23-Dec-13', '23-Dec-13', '23-Dec-13', '23-Dec-13', '23-Dec-13', None, '6-Feb-14', '6-Feb-14', None, '13-Feb-14', None, '28-Feb-14', '10-Mar-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P091', '1', 'DEPARTAMENTO', 'AS1D091', 'AS10BD11070', None, None, '0B', '1', '107', None, '1', '0', 'AS975.DEPTO TIPO 1B', 'DEPTO, SALA/COMEDOR, COCINA, 2 RECÁMARAS, 1 BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '14.4', None, '4.52', None, None, None, None, '49.5', '2.05', '0', '0', None, '0', '49.5', None, None, '0', None, None, None, None, None, '0', '1', '1', '923,129.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Apr-14', '30-Apr-14', '1-Nov-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00056387', 'ANTONIO VALENCIA ROMERO', 'ANTONIO', 'VALENCIA', 'ROMERO', 'VARA6301275U1', 'VARA630127HMCLMN05', '1', None, None, '50777806', '51338900 ext 66', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN JUAN BOSCO', 'ATIZAPÁN ZARAGOZA MEX', 'MEX', 'Mexico', '52946', '0', None, None, None, '30000020922', 'SI000003185', None, '933988.54000', '998988.54000', '.00000', '.00000', '998988.54000', '.00000', '.00000', '101185.06000', '.00000', '-998988.86000', '101184.74000', '1-Jan-00', '19-Jun-15', '3-Dec-13', '3-Dec-13', '3-Dec-13', '0', None, '3-Dec-13', '3-Dec-13', '3-Dec-13', '3-Dec-13', '3-Dec-13', None, '28-Jan-14', '28-Jan-14', None, '6-Feb-14', None, '14-Apr-14', '26-Apr-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P091', '2', 'ESTACIONAMIENTO', 'AS1E201', 'AS100EF2120', None, None, None, None, '212', None, '1', '0', 'EST CEEX', 'Cajón Chico, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '65,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00056387', 'ANTONIO VALENCIA ROMERO', 'ANTONIO', 'VALENCIA', 'ROMERO', 'VARA6301275U1', 'VARA630127HMCLMN05', '1', None, None, '50777806', '51338900 ext 66', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN JUAN BOSCO', 'ATIZAPÁN ZARAGOZA MEX', 'MEX', 'Mexico', '52946', '0', None, None, None, '30000020922', 'SI000003183', None, '65000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '3-Dec-13', '3-Dec-13', '3-Dec-13', '0', None, '3-Dec-13', '3-Dec-13', '3-Dec-13', '3-Dec-13', '3-Dec-13', None, '28-Jan-14', '28-Jan-14', None, '6-Feb-14', None, '14-Apr-14', '26-Apr-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P160', '1', 'DEPARTAMENTO', 'AS1D160', 'AS10CD00060', None, None, '0C', '0', '006', None, '1', '0', 'AS975. DEPTO TIPO 6', 'DEPTO, SALA/COMEDOR, COCINA, 1 RECÁMARA, 1 BAÑO, PASILLO, PATIO DE LAVADO', None, None, '1', None, '1', '0', '17.48', None, '4.71', None, None, None, None, '47.75', None, '0', '0', None, '0', '47.75', None, None, '0', None, None, None, None, None, '0', '1', '1', '735,988.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00056419', 'PAOLA ESTHER PEREZ ORTIZ', 'PAOLA ESTHER', 'PEREZ', 'ORTIZ', 'PEOP890607V32', 'PEOP890607MDFRRL04', '1', None, None, '5527560042', '52271435', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'EL RECREO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02070', '0', None, None, None, '30000020930', 'SI000003148', None, '733700.82000', '893700.82000', '.00000', '.00000', '893700.82000', '.00000', '.00000', '74861.71000', '.00000', '-896200.82000', '72361.71000', '1-Jan-00', '19-Jun-15', '2-Dec-13', '2-Dec-13', '2-Dec-13', '0', None, '2-Dec-13', '2-Dec-13', '2-Dec-13', '2-Dec-13', '2-Dec-13', None, '18-Dec-13', '18-Dec-13', None, '16-Jan-14', None, '16-Jan-14', '25-Jan-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P160', '2', 'ESTACIONAMIENTO', 'AS1E067', 'AS100EC0680', None, None, None, None, '068', None, '1', '0', 'EST GEEX', 'Cajón Grande, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00056419', 'PAOLA ESTHER PEREZ ORTIZ', 'PAOLA ESTHER', 'PEREZ', 'ORTIZ', 'PEOP890607V32', 'PEOP890607MDFRRL04', '1', None, None, '5527560042', '52271435', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'EL RECREO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02070', '0', None, None, None, '30000020930', 'SI000003145', None, '75000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '2-Dec-13', '2-Dec-13', '2-Dec-13', '0', None, '2-Dec-13', '2-Dec-13', '2-Dec-13', '2-Dec-13', '2-Dec-13', None, '18-Dec-13', '18-Dec-13', None, '16-Jan-14', None, '16-Jan-14', '25-Jan-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P160', '2', 'ESTACIONAMIENTO', 'AS1E015', 'AS100EA0690', None, None, None, None, '069', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '85,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00056419', 'PAOLA ESTHER PEREZ ORTIZ', 'PAOLA ESTHER', 'PEREZ', 'ORTIZ', 'PEOP890607V32', 'PEOP890607MDFRRL04', '1', None, None, '5527560042', '52271435', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'EL RECREO', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02070', '0', None, None, None, '30000020930', 'SI000003141', None, '85000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '2-Dec-13', '2-Dec-13', '2-Dec-13', '0', None, '2-Dec-13', '2-Dec-13', '2-Dec-13', '2-Dec-13', '2-Dec-13', None, '18-Dec-13', '18-Dec-13', None, '16-Jan-14', None, '16-Jan-14', '25-Jan-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P098', '1', 'DEPARTAMENTO', 'AS1D098', 'AS10BD11140', None, None, '0B', '1', '114', None, '1', '0', 'AS975.DEPTO TIPO 2B', 'DEPTO, SALA/COMEDOR, COCINA,2RECÁMARAS, 1ALCOBA,  2BAÑOS, PASILLO, PATIO LAVADO', None, None, '2', None, '2', '0', '18.12', None, '4.6', None, None, None, None, '64.72', None, '0', '0', None, '0', '64.72', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,067,141.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Apr-14', '30-Apr-14', '1-Nov-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00056597', 'JOSEFINA FLORES LOPEZ', 'JOSEFINA', 'FLORES', 'LOPEZ', 'FOLJ650204R19', None, '1', None, None, '53191023', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'U.H XOCHINAHUAC', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02125', '0', None, None, None, '30000021029', 'SI000001580', None, '1050095.40000', '1205095.40000', '.00000', '.00000', '1205095.40000', '.00000', '.00000', '11684.00000', '.00000', '-1207299.40000', '9480.00000', '1-Jan-00', '19-Jun-15', '31-Jan-13', '31-Jan-13', '31-Jan-13', '0', None, '31-Jan-13', '31-Jan-13', '31-Jan-13', '31-Jan-13', '31-Jan-13', None, '5-Dec-13', '5-Dec-13', None, '9-Dec-13', None, '23-Dec-13', '8-Mar-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P098', '2', 'ESTACIONAMIENTO', 'AS1E050', 'AS100EA2090', None, None, None, None, '209', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '85,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00056597', 'JOSEFINA FLORES LOPEZ', 'JOSEFINA', 'FLORES', 'LOPEZ', 'FOLJ650204R19', None, '1', None, None, '53191023', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'U.H XOCHINAHUAC', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02125', '0', None, None, None, '30000021029', 'SI000001573', None, '80000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '31-Jan-13', '31-Jan-13', '31-Jan-13', '0', None, '31-Jan-13', '31-Jan-13', '31-Jan-13', '31-Jan-13', '31-Jan-13', None, '5-Dec-13', '5-Dec-13', None, '9-Dec-13', None, '23-Dec-13', '8-Mar-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P098', '2', 'ESTACIONAMIENTO', 'AS1E102', 'AS100EC2100', None, None, None, None, '210', None, '1', '0', 'EST GEEX', 'Cajón Grande, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00056597', 'JOSEFINA FLORES LOPEZ', 'JOSEFINA', 'FLORES', 'LOPEZ', 'FOLJ650204R19', None, '1', None, None, '53191023', None, None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'U.H XOCHINAHUAC', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02125', '0', None, None, None, '30000021029', 'SI000001574', None, '75000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '31-Jan-13', '31-Jan-13', '31-Jan-13', '0', None, '31-Jan-13', '31-Jan-13', '31-Jan-13', '31-Jan-13', '31-Jan-13', None, '5-Dec-13', '5-Dec-13', None, '9-Dec-13', None, '23-Dec-13', '8-Mar-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P081', '1', 'DEPARTAMENTO', 'AS1D081', 'AS10BD00110', None, None, '0B', '0', '011', None, '1', '0', 'AS975.DEPTO TIPO 1B', 'DEPTO, SALA/COMEDOR, COCINA, 2 RECÁMARAS, 1 BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '14.4', None, '4.52', None, None, None, None, '49.5', '2.05', '0', '0', None, '0', '49.5', None, None, '0', None, None, None, None, None, '0', '1', '1', '970,935.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-14', '30-Jun-14', '1-Jan-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00056654', 'HECTOR JAVIER CISNEROS GUERRERO', 'HECTOR JAVIER', 'CISNEROS', 'GUERRERO', 'CIGH580719AD2', 'CIGH580719HDFSRC05', '1', None, None, '18097658', '53945781', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LOS REYES IXTACALA', 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54090', '0', None, None, None, '30000021045', 'SI000003652', None, '961321.33000', '1121321.33000', '.00000', '.00000', '1121321.33000', '.00000', '.00000', '91500.00000', '.00000', '-1121321.33000', '91500.00000', '1-Jan-00', '19-Jun-15', '30-Jan-14', '30-Jan-14', '30-Jan-14', '0', None, '30-Jan-14', '30-Jan-14', '30-Jan-14', '30-Jan-14', '30-Jan-14', None, '30-Jun-14', '30-Jun-14', None, '2-Jul-14', None, '28-Jul-14', '31-Jul-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P081', '2', 'ESTACIONAMIENTO', 'AS1E025', 'AS100EA0990', None, None, None, None, '099', None, '1', '0', 'EST GDEX', 'Cajón Grande, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '85,000.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-14', '20-Feb-14', '24-Aug-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00056654', 'HECTOR JAVIER CISNEROS GUERRERO', 'HECTOR JAVIER', 'CISNEROS', 'GUERRERO', 'CIGH580719AD2', 'CIGH580719HDFSRC05', '1', None, None, '18097658', '53945781', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LOS REYES IXTACALA', 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54090', '0', None, None, None, '30000021045', 'SI000003649', None, '85000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '30-Jan-14', '30-Jan-14', '30-Jan-14', '0', None, '30-Jan-14', '30-Jan-14', '30-Jan-14', '30-Jan-14', '30-Jan-14', None, '30-Jun-14', '30-Jun-14', None, '2-Jul-14', None, '28-Jul-14', '31-Jul-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P081', '2', 'ESTACIONAMIENTO', 'AS1E077', 'AS100EC0980', None, None, None, None, '098', None, '1', '0', 'EST GEEX', 'Cajón Grande, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '20-Feb-14', '20-Feb-14', '24-Aug-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00056654', 'HECTOR JAVIER CISNEROS GUERRERO', 'HECTOR JAVIER', 'CISNEROS', 'GUERRERO', 'CIGH580719AD2', 'CIGH580719HDFSRC05', '1', None, None, '18097658', '53945781', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'LOS REYES IXTACALA', 'TLALNEPANTLA MEX', 'MEX', 'Mexico', '54090', '0', None, None, None, '30000021045', 'SI000004669', None, '75000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '22-May-14', '22-May-14', '22-May-14', '0', None, '22-May-14', '22-May-14', '22-May-14', '22-May-14', '22-May-14', None, '30-Jun-14', '30-Jun-14', None, '2-Jul-14', None, '28-Jul-14', '31-Jul-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P129', '1', 'DEPARTAMENTO', 'AS1D129', 'AS10BD44030', None, None, '0B', '4', '403', None, '1', '0', 'AS975.DEPTO TIPO 4', 'DEPTO, SALA/COMEDOR, COCINA, 2 RECÁMARAS, 1 BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '17.2', None, '4.67', None, None, None, None, '55.17', None, '0', '0', None, '0', '55.17', None, None, '0', None, None, None, None, None, '0', '1', '1', '1,016,921.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Apr-14', '30-Apr-14', '1-Nov-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00056899', 'JUAN AGUSTIN VAZQUEZ LUNA', 'JUAN AGUSTIN', 'VAZQUEZ', 'LUNA', 'VALJ840828CW1', 'VALJ840828HMNZNN00', '1', None, 'agustinvazquez_28@hotmail.com', '5564224243', None, '5554182226', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PASTEROS', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02150', '0', None, None, None, '30000021151', 'SI000003317', None, '1036851.57000', '1111851.57000', '.00000', '.00000', '1111851.57000', '.00000', '.00000', '92232.92000', '.00000', '-1111851.57000', '92232.92000', '15-Jan-15', '15-Jan-15', '19-Dec-13', '19-Dec-13', '19-Dec-13', '0', None, '19-Dec-13', '19-Dec-13', '19-Dec-13', '19-Dec-13', '19-Dec-13', None, '26-Feb-14', '26-Feb-14', None, '10-Mar-14', None, '14-Mar-14', '1-Apr-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P129', '2', 'ESTACIONAMIENTO', 'AS1E152', 'AS100ED2170', None, None, None, None, '217', None, '1', '0', 'EST CDEX', 'Cajón Chico, Adelante doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '9.24', None, None, None, None, None, None, '2.2', None, '0', None, None, 'Chico', 'Abajo sin eleva autos', 'Adelante doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00056899', 'JUAN AGUSTIN VAZQUEZ LUNA', 'JUAN AGUSTIN', 'VAZQUEZ', 'LUNA', 'VALJ840828CW1', 'VALJ840828HMNZNN00', '1', None, 'agustinvazquez_28@hotmail.com', '5564224243', None, '5554182226', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'PASTEROS', 'AZCAPOTZALCO DF', 'DF', 'Mexico', '02150', '0', None, None, None, '30000021151', 'SI000003316', None, '75000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '19-Dec-13', '19-Dec-13', '19-Dec-13', '0', None, '19-Dec-13', '19-Dec-13', '19-Dec-13', '19-Dec-13', '19-Dec-13', None, '26-Feb-14', '26-Feb-14', None, '10-Mar-14', None, '14-Mar-14', '1-Apr-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P186', '1', 'DEPARTAMENTO', 'AS1D186', 'AS10CD33080', None, None, '0C', '3', '308', None, '1', '0', 'AS975.DEPTO TIPO 3', 'DEPTO, SALA/COMEDOR, COCINA, 1 RECÁMARA, 1 BAÑO, PASILLO, PATIO DE LAVADO', None, None, '1', None, '1', '0', '13.21', None, '6.64', None, None, None, None, '43.28', None, '0', '0', None, '0', '43.28', None, None, '0', None, None, None, None, None, '0', '1', '1', '760,629.00 ', '10,000.00 ', '0.00 ', '0.00 ', '30-Jun-13', '30-Jun-13', '1-Jan-13', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00057044', 'SAMANTHA MONROY GARCIA', 'SAMANTHA', 'MONROY', 'GARCIA', 'SOPS850725CE6', 'MOGS850122MDFNRM02', '1', None, None, '5554706633', '11036000 ext 22', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN ISIDRO', 'VALLE DE CHALCO MEX', 'MEX', 'Mexico', '56617', '0', None, None, None, '30000021193', 'SI000003318', None, '803097.61000', '878097.61000', '.00000', '.00000', '878097.61000', '.00000', '.00000', '90769.63000', '.00000', '-882327.08000', '86540.16000', '1-Jan-00', '19-Jun-15', '19-Dec-13', '19-Dec-13', '19-Dec-13', '0', None, '19-Dec-13', '19-Dec-13', '19-Dec-13', '19-Dec-13', '19-Dec-13', None, '6-Feb-14', '6-Feb-14', None, '11-Feb-14', None, '16-Apr-14', '30-Apr-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P186', '2', 'ESTACIONAMIENTO', 'AS1E071', 'AS100EC0820', None, None, None, None, '082', None, '1', '0', 'EST GEEX', 'Cajón Grande, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00057044', 'SAMANTHA MONROY GARCIA', 'SAMANTHA', 'MONROY', 'GARCIA', 'SOPS850725CE6', 'MOGS850122MDFNRM02', '1', None, None, '5554706633', '11036000 ext 22', None, None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'SAN ISIDRO', 'VALLE DE CHALCO MEX', 'MEX', 'Mexico', '56617', '0', None, None, None, '30000021193', 'SI000003315', None, '75000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '1-Jan-00', '19-Jun-15', '19-Dec-13', '19-Dec-13', '19-Dec-13', '0', None, '19-Dec-13', '19-Dec-13', '19-Dec-13', '19-Dec-13', '19-Dec-13', None, '6-Feb-14', '6-Feb-14', None, '11-Feb-14', None, '16-Apr-14', '12-Apr-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P064', '1', 'DEPARTAMENTO', 'AS1D064', 'AS10AD55060', None, None, '0A', '5', '506', None, '1', '0', 'AS975.DEPTO TIPO 1', 'DEPTO, SALA/COMEDOR, COCINA, 2RECÁMARAS, 1BAÑO, PASILLO, PATIO DE LAVADO', None, None, '2', None, '1', '0', '14.4', None, '4.52', None, None, None, None, '49.5', '2.05', '0', '0', None, '0', '49.5', None, None, '48.39', None, None, None, None, None, '0', '1', '1', '1,177,414.00 ', '10,000.00 ', '0.00 ', '0.00 ', '20-Sep-14', '20-Sep-14', '24-Mar-14', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00057323', 'ISRAEL BENITEZ HERNANDEZ', 'ISRAEL', 'BENITEZ', 'HERNANDEZ', 'BEHI801201KYA', 'BEHI801201HDFNRS06', '1', None, 'israelbh80@icloud.com', '58905044', None, '5531848801', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'VILLAS DE SAN JOSE', 'TULTITLÁN MEX', 'MEX', 'Mexico', '54901', '0', None, None, None, '30010105689', 'SI000003439', None, '1135756.26000', '1295757.26000', '.00000', '.00000', '1295757.26000', '.00000', '.00000', '97181.71000', '.00000', '-1295757.26000', '97181.71000', '15-Jan-15', '15-Jan-15', '6-Jan-14', '6-Jan-14', '6-Jan-14', '0', None, '6-Jan-14', '6-Jan-14', '6-Jan-14', '6-Jan-14', '6-Jan-14', None, '3-Oct-14', '3-Oct-14', None, '3-Oct-14', None, '9-Oct-14', '25-Oct-14', None), ('AS1', 'Pasteros', 'Aquiles Serdán # 975', None, 'Pasteros', 'Azcapotzalco', 'Distrito Federal', '02150', 'Mexico', '0131', 'AS1P064', '2', 'ESTACIONAMIENTO', 'AS1E059', 'AS100EC0250', None, None, None, None, '025', None, '1', '0', 'EST GEEX', 'Cajón Grande, Atrás doble, Abajo sin eleva autos.', None, None, None, None, None, None, None, None, None, None, None, None, None, '12', None, None, None, None, None, None, '2.4', None, '0', None, None, 'Grande', 'Abajo sin eleva autos', 'Atrás doble', '0', '1', '1', '75,000.00 ', '0.00 ', '0.00 ', '0.00 ', '2-Feb-13', '2-Feb-13', '6-Aug-12', 'LIBERADO', 'INACTIVO', 'VENTA', '012-ENTREGADA', 'PV00057323', 'ISRAEL BENITEZ HERNANDEZ', 'ISRAEL', 'BENITEZ', 'HERNANDEZ', 'BEHI801201KYA', 'BEHI801201HDFNRS06', '1', None, 'israelbh80@icloud.com', '58905044', None, '5531848801', None, '1-Jan-00', None, None, None, None, None, '1', 'Impresos', None, None, None, 'VILLAS DE SAN JOSE', 'TULTITLÁN MEX', 'MEX', 'Mexico', '54901', '0', None, None, None, '30010105689', 'SI000003437', None, '75000.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '.00000', '15-Jan-15', '15-Jan-15', '6-Jan-14', '6-Jan-14', '6-Jan-14', '0', None, '6-Jan-14', '6-Jan-14', '6-Jan-14', '6-Jan-14', '6-Jan-14', None, '3-Oct-14', '3-Oct-14', None, '3-Oct-14', None, '9-Oct-14', '25-Oct-14', None)])
class Test_df_distance_cluster(unittest.TestCase):
	maxDiff = None
	@staticmethod
	def test_levenshtein_filter():
		actual_df =dc.levenshtein_filter(source_df,'STATE')
		expected_df = op.create.df([('STATE_FROM', StringType(), True),('STATE***LEVENSHTEIN_DISTANCE', IntegerType(), True),('STATE_TO', StringType(), True)], [('estadodemexico', 11, 'distritofederal'), ('distritofederal', 11, 'estadodemexico')])
		assert (expected_df.collect() == actual_df.collect())
	@staticmethod
	def test_levenshtein_matrix():
		actual_df =dc.levenshtein_matrix(source_df,'STATE')
		expected_df = op.create.df([('STATE_LEVENSHTEIN_1', StringType(), True),('STATE_LEVENSHTEIN_2', StringType(), True),('STATE***LEVENSHTEIN_DISTANCE', IntegerType(), True)], [('estadodemexico', 'estadodemexico', 0), ('estadodemexico', 'distritofederal', 11), ('distritofederal', 'estadodemexico', 11), ('distritofederal', 'distritofederal', 0)])
		assert (expected_df.collect() == actual_df.collect())
